/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/types","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/electron-main/state","vs/base/common/map","vs/base/common/process","vs/base/common/labels","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/objects","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/update/common/update","vs/base/common/functional","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/severity","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/parts/sandbox/electron-main/electronTypes","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/codicons","vs/base/common/themables","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/utilityProcess/electron-main/utilityProcess","string_decoder","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","https","vscode-policy-watcher","zlib","vs/code/electron-main/main"],te=function(x){for(var e=[],I=0,R=x.length;I<R;I++)e[I]=ee[x[I]];return e};define(ee[122],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function I(P,d){const h=Math.pow(10,d);return Math.round(P*h)/h}class R{constructor(d,h,S,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,h))|0,this.b=Math.min(255,Math.max(0,S))|0,this.a=I(Math.max(Math.min(1,v),0),3)}static equals(d,h){return d.r===h.r&&d.g===h.g&&d.b===h.b&&d.a===h.a}}e.RGBA=R;class n{constructor(d,h,S,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=I(Math.max(Math.min(1,h),0),3),this.l=I(Math.max(Math.min(1,S),0),3),this.a=I(Math.max(Math.min(1,v),0),3)}static equals(d,h){return d.h===h.h&&d.s===h.s&&d.l===h.l&&d.a===h.a}static fromRGBA(d){const h=d.r/255,S=d.g/255,v=d.b/255,b=d.a,g=Math.max(h,S,v),p=Math.min(h,S,v);let w=0,a=0;const u=(p+g)/2,m=g-p;if(m>0){switch(a=Math.min(u<=.5?m/(2*u):m/(2-2*u),1),g){case h:w=(S-v)/m+(S<v?6:0);break;case S:w=(v-h)/m+2;break;case v:w=(h-S)/m+4;break}w*=60,w=Math.round(w)}return new n(w,a,u,b)}static i(d,h,S){return S<0&&(S+=1),S>1&&(S-=1),S<1/6?d+(h-d)*6*S:S<1/2?h:S<2/3?d+(h-d)*(2/3-S)*6:d}static toRGBA(d){const h=d.h/360,{s:S,l:v,a:b}=d;let g,p,w;if(S===0)g=p=w=v;else{const a=v<.5?v*(1+S):v+S-v*S,u=2*v-a;g=n.i(u,a,h+1/3),p=n.i(u,a,h),w=n.i(u,a,h-1/3)}return new R(Math.round(g*255),Math.round(p*255),Math.round(w*255),b)}}e.HSLA=n;class C{constructor(d,h,S,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=I(Math.max(Math.min(1,h),0),3),this.v=I(Math.max(Math.min(1,S),0),3),this.a=I(Math.max(Math.min(1,v),0),3)}static equals(d,h){return d.h===h.h&&d.s===h.s&&d.v===h.v&&d.a===h.a}static fromRGBA(d){const h=d.r/255,S=d.g/255,v=d.b/255,b=Math.max(h,S,v),g=Math.min(h,S,v),p=b-g,w=b===0?0:p/b;let a;return p===0?a=0:b===h?a=((S-v)/p%6+6)%6:b===S?a=(v-h)/p+2:a=(h-S)/p+4,new C(Math.round(a*60),w,b,d.a)}static toRGBA(d){const{h,s:S,v,a:b}=d,g=v*S,p=g*(1-Math.abs(h/60%2-1)),w=v-g;let[a,u,m]=[0,0,0];return h<60?(a=g,u=p):h<120?(a=p,u=g):h<180?(u=g,m=p):h<240?(u=p,m=g):h<300?(a=p,m=g):h<=360&&(a=g,m=p),a=Math.round((a+w)*255),u=Math.round((u+w)*255),m=Math.round((m+w)*255),new R(a,u,m,b)}}e.HSVA=C;class D{static fromHex(d){return D.Format.CSS.parseHex(d)||D.red}static equals(d,h){return!d&&!h?!0:!d||!h?!1:d.equals(h)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:C.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof R)this.rgba=d;else if(d instanceof n)this.i=d,this.rgba=n.toRGBA(d);else if(d instanceof C)this.j=d,this.rgba=C.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&R.equals(this.rgba,d.rgba)&&n.equals(this.hsla,d.hsla)&&C.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=D.k(this.rgba.r),h=D.k(this.rgba.g),S=D.k(this.rgba.b),v=.2126*d+.7152*h+.0722*S;return I(v,4)}static k(d){const h=d/255;return h<=.03928?h/12.92:Math.pow((h+.055)/1.055,2.4)}getContrastRatio(d){const h=this.getRelativeLuminance(),S=d.getRelativeLuminance();return h>S?(h+.05)/(S+.05):(S+.05)/(h+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const h=this.getRelativeLuminance(),S=d.getRelativeLuminance();return h>S}isDarkerThan(d){const h=this.getRelativeLuminance(),S=d.getRelativeLuminance();return h<S}lighten(d){return new D(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new D(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:h,g:S,b:v,a:b}=this.rgba;return new D(new R(h,S,v,b*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const h=d.rgba,S=this.rgba.a,v=h.a,b=S+v*(1-S);if(b<1e-6)return D.transparent;const g=this.rgba.r*S/b+h.r*v*(1-S)/b,p=this.rgba.g*S/b+h.g*v*(1-S)/b,w=this.rgba.b*S/b+h.b*v*(1-S)/b;return new D(new R(g,p,w,b))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:h,g:S,b:v,a:b}=this.rgba;return new D(new R(d.rgba.r-b*(d.rgba.r-h),d.rgba.g-b*(d.rgba.g-S),d.rgba.b-b*(d.rgba.b-v),1))}flatten(...d){const h=d.reduceRight((S,v)=>D.o(v,S));return D.o(this,h)}static o(d,h){const S=1-d.rgba.a;return new D(new R(S*h.rgba.r+d.rgba.a*d.rgba.r,S*h.rgba.g+d.rgba.a*d.rgba.g,S*h.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(d,h,S){if(d.isLighterThan(h))return d;S=S||.5;const v=d.getRelativeLuminance(),b=h.getRelativeLuminance();return S=S*(b-v)/b,d.lighten(S)}static getDarkerColor(d,h,S){if(d.isDarkerThan(h))return d;S=S||.5;const v=d.getRelativeLuminance(),b=h.getRelativeLuminance();return S=S*(v-b)/v,d.darken(S)}}e.Color=D,D.white=new D(new R(255,255,255,1)),D.black=new D(new R(0,0,0,1)),D.red=new D(new R(255,0,0,1)),D.blue=new D(new R(0,0,255,1)),D.green=new D(new R(0,255,0,1)),D.cyan=new D(new R(0,255,255,1)),D.lightgrey=new D(new R(211,211,211,1)),D.transparent=new D(new R(0,0,0,0)),function(P){let d;(function(h){let S;(function(v){function b(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}v.formatRGB=b;function g(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}v.formatRGBA=g;function p(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}v.formatHSL=p;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}v.formatHSLA=w;function a(t){const c=t.toString(16);return c.length!==2?"0"+c:c}function u(t){return`#${a(t.rgba.r)}${a(t.rgba.g)}${a(t.rgba.b)}`}v.formatHex=u;function m(t,c=!1){return c&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${a(t.rgba.r)}${a(t.rgba.g)}${a(t.rgba.b)}${a(Math.round(t.rgba.a*255))}`}v.formatHexA=m;function k(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}v.format=k;function E(t){const c=t.length;if(c===0||t.charCodeAt(0)!==35)return null;if(c===7){const i=16*L(t.charCodeAt(1))+L(t.charCodeAt(2)),r=16*L(t.charCodeAt(3))+L(t.charCodeAt(4)),s=16*L(t.charCodeAt(5))+L(t.charCodeAt(6));return new P(new R(i,r,s,1))}if(c===9){const i=16*L(t.charCodeAt(1))+L(t.charCodeAt(2)),r=16*L(t.charCodeAt(3))+L(t.charCodeAt(4)),s=16*L(t.charCodeAt(5))+L(t.charCodeAt(6)),l=16*L(t.charCodeAt(7))+L(t.charCodeAt(8));return new P(new R(i,r,s,l/255))}if(c===4){const i=L(t.charCodeAt(1)),r=L(t.charCodeAt(2)),s=L(t.charCodeAt(3));return new P(new R(16*i+i,16*r+r,16*s+s))}if(c===5){const i=L(t.charCodeAt(1)),r=L(t.charCodeAt(2)),s=L(t.charCodeAt(3)),l=L(t.charCodeAt(4));return new P(new R(16*i+i,16*r+r,16*s+s,(16*l+l)/255))}return null}v.parseHex=E;function L(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(S=h.CSS||(h.CSS={}))})(d=P.Format||(P.Format={}))}(D=e.Color||(e.Color={}))}),define(ee[54],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(D){return(P,d,h)=>{let S=null,v=null;if(typeof h.value=="function"?(S="value",v=h.value):typeof h.get=="function"&&(S="get",v=h.get),!v)throw new Error("not supported");h[S]=D(v,d)}}function R(D,P,d){let h=null,S=null;if(typeof d.value=="function"?(h="value",S=d.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(h="get",S=d.get),!S)throw new Error("not supported");const v=`$memoize$${P}`;d[h]=function(...b){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,b)}),this[v]}}e.memoize=R;function n(D,P,d){return I((h,S)=>{const v=`$debounce$${S}`,b=`$debounce$result$${S}`;return function(...g){this[b]||(this[b]=d?d():void 0),clearTimeout(this[v]),P&&(this[b]=P(this[b],...g),g=[this[b]]),this[v]=setTimeout(()=>{h.apply(this,g),this[b]=d?d():void 0},D)}})}e.debounce=n;function C(D,P,d){return I((h,S)=>{const v=`$throttle$timer$${S}`,b=`$throttle$result$${S}`,g=`$throttle$lastRun$${S}`,p=`$throttle$pending$${S}`;return function(...w){if(this[b]||(this[b]=d?d():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),P&&(this[b]=P(this[b],...w)),this[p])return;const a=this[g]+D;a<=Date.now()?(this[g]=Date.now(),h.apply(this,[this[b]]),this[b]=d?d():void 0):(this[p]=!0,this[v]=setTimeout(()=>{this[p]=!1,this[g]=Date.now(),h.apply(this,[this[b]]),this[b]=d?d():void 0},a-Date.now()))}})}e.throttle=C}),define(ee[13],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.b=[],this.a=function(c){setTimeout(()=>{throw c.stack?E.isErrorNoTelemetry(c)?new E(c.message+`

`+c.stack):new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.b.push(c),()=>{this.d(c)}}c(c){this.b.forEach(i=>{i(c)})}d(c){this.b.splice(this.b.indexOf(c),1)}setUnexpectedErrorHandler(c){this.a=c}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(c){this.a(c),this.c(c)}onUnexpectedExternalError(c){this.a(c)}}e.ErrorHandler=I,e.errorHandler=new I;function R(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=R;function n(t){if(!t||typeof t!="object")return!1;const c=t;return c.code==="EPIPE"&&c.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=n;function C(t){h(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=C;function D(t){h(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=D;function P(t){if(t instanceof Error){const{name:c,message:i}=t,r=t.stacktrace||t.stack;return{$isError:!0,name:c,message:i,stack:r,noTelemetry:E.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=P;const d="Canceled";function h(t){return t instanceof S?!0:t instanceof Error&&t.name===d&&t.message===d}e.isCancellationError=h;class S extends Error{constructor(){super(d),this.name=this.message}}e.CancellationError=S;function v(){const t=new Error(d);return t.name=t.message,t}e.canceled=v;function b(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=b;function g(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=g;function p(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function w(t){const c=new Error(`${t} has been disposed`);return c.name="DISPOSED",c}e.disposed=w;function a(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=a;class u extends Error{constructor(c){super("NotImplemented"),c&&(this.message=c)}}e.NotImplementedError=u;class m extends Error{constructor(c){super("NotSupported"),c&&(this.message=c)}}e.NotSupportedError=m;class k extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=k;class E extends Error{constructor(c){super(c),this.name="CodeExpectedError"}static fromError(c){if(c instanceof E)return c;const i=new E;return i.message=c.message,i.stack=c.stack,i}static isErrorNoTelemetry(c){return c.name==="CodeExpectedError"}}e.ErrorNoTelemetry=E;class L extends Error{constructor(c){super(c||"An unexpected bug occurred."),Object.setPrototypeOf(this,L.prototype);debugger}}e.BugIndicatingError=L}),define(ee[25],te([0,1,13]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function R(N,$=0){return N[N.length-(1+$)]}e.tail=R;function n(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=n;function C(N,$,J=(oe,le)=>oe===le){if(N===$)return!0;if(!N||!$||N.length!==$.length)return!1;for(let oe=0,le=N.length;oe<le;oe++)if(!J(N[oe],$[oe]))return!1;return!0}e.equals=C;function D(N,$){const J=N.length-1;$<J&&(N[$]=N[J]),N.pop()}e.removeFastWithoutKeepingOrder=D;function P(N,$,J){return d(N.length,oe=>J(N[oe],$))}e.binarySearch=P;function d(N,$){let J=0,oe=N-1;for(;J<=oe;){const le=(J+oe)/2|0,be=$(le);if(be<0)J=le+1;else if(be>0)oe=le-1;else return le}return-(J+1)}e.binarySearch2=d;function h(N,$){let J=0,oe=N.length;if(oe===0)return 0;for(;J<oe;){const le=Math.floor((J+oe)/2);$(N[le])?oe=le:J=le+1}return J}e.findFirstInSorted=h;function S(N,$,J){if(N=N|0,N>=$.length)throw new TypeError("invalid index");const oe=$[Math.floor($.length*Math.random())],le=[],be=[],Le=[];for(const Te of $){const Ae=J(Te,oe);Ae<0?le.push(Te):Ae>0?be.push(Te):Le.push(Te)}return N<le.length?S(N,le,J):N<le.length+Le.length?Le[0]:S(N-(le.length+Le.length),be,J)}e.quickSelect=S;function v(N,$){const J=[];let oe;for(const le of N.slice(0).sort($))!oe||$(oe[0],le)!==0?(oe=[le],J.push(oe)):oe.push(le);return J}e.groupBy=v;function b(N,$,J){const oe=[];function le(Te,Ae,pe){if(Ae===0&&pe.length===0)return;const ve=oe[oe.length-1];ve&&ve.start+ve.deleteCount===Te?(ve.deleteCount+=Ae,ve.toInsert.push(...pe)):oe.push({start:Te,deleteCount:Ae,toInsert:pe})}let be=0,Le=0;for(;;){if(be===N.length){le(be,0,$.slice(Le));break}if(Le===$.length){le(be,N.length-be,[]);break}const Te=N[be],Ae=$[Le],pe=J(Te,Ae);pe===0?(be+=1,Le+=1):pe<0?(le(be,1,[]),be+=1):pe>0&&(le(be,0,[Ae]),Le+=1)}return oe}e.sortedDiff=b;function g(N,$,J){const oe=b(N,$,J),le=[],be=[];for(const Le of oe)le.push(...N.slice(Le.start,Le.start+Le.deleteCount)),be.push(...Le.toInsert);return{removed:le,added:be}}e.delta=g;function p(N,$,J){if(J===0)return[];const oe=N.slice(0,J).sort($);return a(N,$,oe,J,N.length),oe}e.top=p;function w(N,$,J,oe,le){return J===0?Promise.resolve([]):new Promise((be,Le)=>{(async()=>{const Te=N.length,Ae=N.slice(0,J).sort($);for(let pe=J,ve=Math.min(J+oe,Te);pe<Te;pe=ve,ve=Math.min(ve+oe,Te)){if(pe>J&&await new Promise(Ce=>setTimeout(Ce)),le&&le.isCancellationRequested)throw new I.CancellationError;a(N,$,Ae,pe,ve)}return Ae})().then(be,Le)})}e.topAsync=w;function a(N,$,J,oe,le){for(const be=J.length;oe<le;oe++){const Le=N[oe];if($(Le,J[be-1])<0){J.pop();const Te=h(J,Ae=>$(Le,Ae)<0);J.splice(Te,0,Le)}}}function u(N){return N.filter($=>!!$)}e.coalesce=u;function m(N){let $=0;for(let J=0;J<N.length;J++)N[J]&&(N[$]=N[J],$+=1);N.length=$}e.coalesceInPlace=m;function k(N,$,J){N.splice(J,0,N.splice($,1)[0])}e.move=k;function E(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=E;function L(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=L;function t(N,$=J=>J){const J=new Set;return N.filter(oe=>{const le=$(oe);return J.has(le)?!1:(J.add(le),!0)})}e.distinct=t;function c(N){const $=new Set;return J=>{const oe=N(J);return $.has(oe)?!1:($.add(oe),!0)}}e.uniqueFilter=c;function i(N,$){const J=r(N,$);if(J!==-1)return N[J]}e.findLast=i;function r(N,$){for(let J=N.length-1;J>=0;J--){const oe=N[J];if($(oe))return J}return-1}e.lastIndex=r;function s(N,$){return N.length>0?N[0]:$}e.firstOrDefault=s;function l(N,$){return N.length>0?N[N.length-1]:$}e.lastOrDefault=l;function o(N,$,J=(oe,le)=>oe===le){let oe=0;for(let le=0,be=Math.min(N.length,$.length);le<be&&J(N[le],$[le]);le++)oe++;return oe}e.commonPrefixLength=o;function f(N){return[].concat(...N)}e.flatten=f;function y(N,$){let J=typeof $=="number"?N:0;typeof $=="number"?J=N:(J=0,$=N);const oe=[];if(J<=$)for(let le=J;le<$;le++)oe.push(le);else for(let le=J;le>$;le--)oe.push(le);return oe}e.range=y;function M(N,$,J){return N.reduce((oe,le)=>(oe[$(le)]=J?J(le):le,oe),Object.create(null))}e.index=M;function O(N,$){return N.push($),()=>j(N,$)}e.insert=O;function j(N,$){const J=N.indexOf($);if(J>-1)return N.splice(J,1),$}e.remove=j;function G(N,$,J){const oe=N.slice(0,$),le=N.slice($);return oe.concat(J,le)}e.arrayInsert=G;function H(N,$){let J;if(typeof $=="number"){let oe=$;J=()=>{const le=Math.sin(oe++)*179426549;return le-Math.floor(le)}}else J=Math.random;for(let oe=N.length-1;oe>0;oe-=1){const le=Math.floor(J()*(oe+1)),be=N[oe];N[oe]=N[le],N[le]=be}}e.shuffle=H;function K(N,$){const J=N.indexOf($);J>-1&&(N.splice(J,1),N.unshift($))}e.pushToStart=K;function ne(N,$){const J=N.indexOf($);J>-1&&(N.splice(J,1),N.push($))}e.pushToEnd=ne;function re(N,$){for(const J of $)N.push(J)}e.pushMany=re;function ae(N,$){return Array.isArray(N)?N.map($):$(N)}e.mapArrayOrNot=ae;function fe(N){return Array.isArray(N)?N:[N]}e.asArray=fe;function ge(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=ge;function V(N,$){for(const J of N){const oe=$(J);if(oe!==void 0)return oe}}e.mapFind=V;function F(N,$,J){const oe=z(N,$),le=N.length,be=J.length;N.length=le+be;for(let Le=le-1;Le>=oe;Le--)N[Le+be]=N[Le];for(let Le=0;Le<be;Le++)N[Le+oe]=J[Le]}e.insertInto=F;function W(N,$,J,oe){const le=z(N,$),be=N.splice(le,J);return F(N,le,oe),be}e.splice=W;function z(N,$){return $<0?Math.max($+N.length,0):Math.min($,N.length)}var X;(function(N){function $(le){return le<0}N.isLessThan=$;function J(le){return le>0}N.isGreaterThan=J;function oe(le){return le===0}N.isNeitherLessOrGreaterThan=oe,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(X=e.CompareResult||(e.CompareResult={}));function ie(N,$){return(J,oe)=>$(N(J),N(oe))}e.compareBy=ie;function se(...N){return($,J)=>{for(const oe of N){const le=oe($,J);if(!X.isNeitherLessOrGreaterThan(le))return le}return X.neitherLessOrGreaterThan}}e.tieBreakComparators=se;const Q=(N,$)=>N-$;e.numberComparator=Q;function A(N,$){if(N.length===0)return;let J=N[0];for(let oe=1;oe<N.length;oe++){const le=N[oe];$(le,J)>0&&(J=le)}return J}e.findMaxBy=A;function T(N,$){if(N.length===0)return;let J=N[0];for(let oe=1;oe<N.length;oe++){const le=N[oe];$(le,J)>=0&&(J=le)}return J}e.findLastMaxBy=T;function U(N,$){return A(N,(J,oe)=>-$(J,oe))}e.findMinBy=U;class B{constructor($){this.f=$,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile($){let J=this.c;for(;J<this.f.length&&$(this.f[J]);)J++;const oe=J===this.c?null:this.f.slice(this.c,J);return this.c=J,oe}takeFromEndWhile($){let J=this.d;for(;J>=0&&$(this.f[J]);)J--;const oe=J===this.d?null:this.f.slice(J+1,this.d+1);return this.d=J,oe}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const $=this.f[this.c];return this.c++,$}removeLast(){const $=this.f[this.d];return this.d--,$}takeCount($){const J=this.f.slice(this.c,this.c+$);return this.c+=$,J}}e.ArrayQueue=B;class q{constructor($){this.iterate=$}forEach($){this.iterate(J=>($(J),!0))}toArray(){const $=[];return this.iterate(J=>($.push(J),!0)),$}filter($){return new q(J=>this.iterate(oe=>$(oe)?J(oe):!0))}map($){return new q(J=>this.iterate(oe=>J($(oe))))}some($){let J=!1;return this.iterate(oe=>(J=$(oe),!J)),J}findFirst($){let J;return this.iterate(oe=>$(oe)?(J=oe,!1):!0),J}findLast($){let J;return this.iterate(oe=>($(oe)&&(J=oe),!0)),J}findLastMaxBy($){let J,oe=!0;return this.iterate(le=>((oe||X.isGreaterThan($(le,J)))&&(oe=!1,J=le),!0)),J}}e.CallbackIterable=q,q.empty=new q(N=>{})}),define(ee[123],te([0,1,13]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function R(d,h){if(!d)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}e.ok=R;function n(d,h="Unreachable"){throw new Error(h)}e.assertNever=n;function C(d){if(!d)throw new I.BugIndicatingError("Assertion Failed")}e.assert=C;function D(d){if(!d()){debugger;d(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function P(d,h){let S=0;for(;S<d.length-1;){const v=d[S],b=d[S+1];if(!h(v,b))return!1;S++}return!0}e.checkAdjacentItems=P}),define(ee[49],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function I(R){const n=this;let C=!1,D;return function(){return C||(C=!0,D=R.apply(n,arguments)),D}}e.once=I}),define(ee[69],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(R){function n(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}R.is=n;const C=Object.freeze([]);function D(){return C}R.empty=D;function*P(E){yield E}R.single=P;function d(E){return n(E)?E:P(E)}R.wrap=d;function h(E){return E||C}R.from=h;function S(E){return!E||E[Symbol.iterator]().next().done===!0}R.isEmpty=S;function v(E){return E[Symbol.iterator]().next().value}R.first=v;function b(E,L){for(const t of E)if(L(t))return!0;return!1}R.some=b;function g(E,L){for(const t of E)if(L(t))return t}R.find=g;function*p(E,L){for(const t of E)L(t)&&(yield t)}R.filter=p;function*w(E,L){let t=0;for(const c of E)yield L(c,t++)}R.map=w;function*a(...E){for(const L of E)for(const t of L)yield t}R.concat=a;function u(E,L,t){let c=t;for(const i of E)c=L(c,i);return c}R.reduce=u;function*m(E,L,t=E.length){for(L<0&&(L+=E.length),t<0?t+=E.length:t>E.length&&(t=E.length);L<t;L++)yield E[L]}R.slice=m;function k(E,L=Number.POSITIVE_INFINITY){const t=[];if(L===0)return[t,E];const c=E[Symbol.iterator]();for(let i=0;i<L;i++){const r=c.next();if(r.done)return[t,R.empty()];t.push(r.value)}return[t,{[Symbol.iterator](){return c}}]}R.consume=k})(I=e.Iterable||(e.Iterable={}))}),define(ee[43],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var n;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(n=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function D(t,c=!1){let i=0;const r=t.length;let s="",l=0,o=16,f=0;function y(ne){let re=0,ae=0;for(;re<ne;){const fe=t.charCodeAt(i);if(fe>=48&&fe<=57)ae=ae*16+fe-48;else if(fe>=65&&fe<=70)ae=ae*16+fe-65+10;else if(fe>=97&&fe<=102)ae=ae*16+fe-97+10;else break;i++,re++}return re<ne&&(ae=-1),ae}function M(ne){i=ne,s="",l=0,o=16,f=0}function O(){const ne=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&h(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&h(t.charCodeAt(i)))for(i++;i<t.length&&h(t.charCodeAt(i));)i++;else return f=3,t.substring(ne,i);let re=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&h(t.charCodeAt(i))){for(i++;i<t.length&&h(t.charCodeAt(i));)i++;re=i}else f=3;return t.substring(ne,re)}function j(){let ne="",re=i;for(;;){if(i>=r){ne+=t.substring(re,i),f=2;break}const ae=t.charCodeAt(i);if(ae===34){ne+=t.substring(re,i),i++;break}if(ae===92){if(ne+=t.substring(re,i),i++,i>=r){f=2;break}switch(t.charCodeAt(i++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const ge=y(4);ge>=0?ne+=String.fromCharCode(ge):f=4;break}default:f=5}re=i;continue}if(ae>=0&&ae<=31)if(d(ae)){ne+=t.substring(re,i),f=2;break}else f=6;i++}return ne}function G(){if(s="",f=0,l=i,i>=r)return l=r,o=17;let ne=t.charCodeAt(i);if(P(ne)){do i++,s+=String.fromCharCode(ne),ne=t.charCodeAt(i);while(P(ne));return o=15}if(d(ne))return i++,s+=String.fromCharCode(ne),ne===13&&t.charCodeAt(i)===10&&(i++,s+=`
`),o=14;switch(ne){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,s=j(),o=10;case 47:{const re=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!d(t.charCodeAt(i));)i++;return s=t.substring(re,i),o=12}if(t.charCodeAt(i+1)===42){i+=2;const ae=r-1;let fe=!1;for(;i<ae;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,fe=!0;break}i++}return fe||(i++,f=1),s=t.substring(re,i),o=13}return s+=String.fromCharCode(ne),i++,o=16}case 45:if(s+=String.fromCharCode(ne),i++,i===r||!h(t.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=O(),o=11;default:for(;i<r&&H(ne);)i++,ne=t.charCodeAt(i);if(l!==i){switch(s=t.substring(l,i),s){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return s+=String.fromCharCode(ne),i++,o=16}}function H(ne){if(P(ne)||d(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let ne;do ne=G();while(ne>=12&&ne<=15);return ne}return{setPosition:M,getPosition:()=>i,scan:c?K:G,getToken:()=>o,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>f}}e.createScanner=D;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function h(t){return t>=48&&t<=57}var S;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(S||(S={}));function v(t,c){const i=[],r=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function f(y,M,O,j){l.value=y,l.offset=M,l.length=O,l.type=j,l.colonOffset=void 0,s=l}try{k(t,{onObjectBegin:(y,M)=>{if(c<=y)throw r;s=void 0,o=c>y,i.push("")},onObjectProperty:(y,M,O)=>{if(c<M||(f(y,M,O,"property"),i[i.length-1]=y,c<=M+O))throw r},onObjectEnd:(y,M)=>{if(c<=y)throw r;s=void 0,i.pop()},onArrayBegin:(y,M)=>{if(c<=y)throw r;s=void 0,i.push(0)},onArrayEnd:(y,M)=>{if(c<=y)throw r;s=void 0,i.pop()},onLiteralValue:(y,M,O)=>{if(c<M||(f(y,M,O,L(y)),c<=M+O))throw r},onSeparator:(y,M,O)=>{if(c<=M)throw r;if(y===":"&&s&&s.type==="property")s.colonOffset=M,o=!1,s=void 0;else if(y===","){const j=i[i.length-1];typeof j=="number"?i[i.length-1]=j+1:(o=!0,i[i.length-1]=""),s=void 0}}})}catch(y){if(y!==r)throw y}return{path:i,previousNode:s,isAtPropertyKey:o,matches:y=>{let M=0;for(let O=0;M<y.length&&O<i.length;O++)if(y[M]===i[O]||y[M]==="*")M++;else if(y[M]!=="**")return!1;return M===y.length}}}e.getLocation=v;function b(t,c=[],i=C.DEFAULT){let r=null,s=[];const l=[];function o(y){Array.isArray(s)?s.push(y):r!==null&&(s[r]=y)}return k(t,{onObjectBegin:()=>{const y={};o(y),l.push(s),s=y,r=null},onObjectProperty:y=>{r=y},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const y=[];o(y),l.push(s),s=y,r=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:o,onError:(y,M,O)=>{c.push({error:y,offset:M,length:O})}},i),s[0]}e.parse=b;function g(t,c=[],i=C.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){r.type==="property"&&(r.length=y-r.offset,r=r.parent)}function l(y){return r.children.push(y),y}k(t,{onObjectBegin:y=>{r=l({type:"object",offset:y,length:-1,parent:r,children:[]})},onObjectProperty:(y,M,O)=>{r=l({type:"property",offset:M,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:y,offset:M,length:O,parent:r})},onObjectEnd:(y,M)=>{r.length=y+M-r.offset,r=r.parent,s(y+M)},onArrayBegin:(y,M)=>{r=l({type:"array",offset:y,length:-1,parent:r,children:[]})},onArrayEnd:(y,M)=>{r.length=y+M-r.offset,r=r.parent,s(y+M)},onLiteralValue:(y,M,O)=>{l({type:L(y),offset:M,length:O,parent:r,value:y}),s(M+O)},onSeparator:(y,M,O)=>{r.type==="property"&&(y===":"?r.colonOffset=M:y===","&&s(M))},onError:(y,M,O)=>{c.push({error:y,offset:M,length:O})}},i);const f=r.children[0];return f&&delete f.parent,f}e.parseTree=g;function p(t,c){if(!t)return;let i=t;for(const r of c)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===r){i=l.children[1],s=!0;break}if(!s)return}else{const s=r;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=p;function w(t){if(!t.parent||!t.parent.children)return[];const c=w(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;c.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&c.push(i)}return c}e.getNodePath=w;function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const c=Object.create(null);for(const i of t.children){const r=i.children[1];r&&(c[i.children[0].value]=a(r))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=a;function u(t,c,i=!1){return c>=t.offset&&c<t.offset+t.length||i&&c===t.offset+t.length}e.contains=u;function m(t,c,i=!1){if(u(t,c,i)){const r=t.children;if(Array.isArray(r))for(let s=0;s<r.length&&r[s].offset<=c;s++){const l=m(r[s],c,i);if(l)return l}return t}}e.findNodeAtOffset=m;function k(t,c,i=C.DEFAULT){const r=D(t,!1);function s(ie){return ie?()=>ie(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(ie){return ie?se=>ie(se,r.getTokenOffset(),r.getTokenLength()):()=>!0}const o=s(c.onObjectBegin),f=l(c.onObjectProperty),y=s(c.onObjectEnd),M=s(c.onArrayBegin),O=s(c.onArrayEnd),j=l(c.onLiteralValue),G=l(c.onSeparator),H=s(c.onComment),K=l(c.onError),ne=i&&i.disallowComments,re=i&&i.allowTrailingComma;function ae(){for(;;){const ie=r.scan();switch(r.getTokenError()){case 4:fe(14);break;case 5:fe(15);break;case 3:fe(13);break;case 1:ne||fe(11);break;case 2:fe(12);break;case 6:fe(16);break}switch(ie){case 12:case 13:ne?fe(10):H();break;case 16:fe(1);break;case 15:case 14:break;default:return ie}}}function fe(ie,se=[],Q=[]){if(K(ie),se.length+Q.length>0){let A=r.getToken();for(;A!==17;){if(se.indexOf(A)!==-1){ae();break}else if(Q.indexOf(A)!==-1)break;A=ae()}}}function ge(ie){const se=r.getTokenValue();return ie?j(se):f(se),ae(),!0}function V(){switch(r.getToken()){case 11:{let ie=0;try{ie=JSON.parse(r.getTokenValue()),typeof ie!="number"&&(fe(2),ie=0)}catch{fe(2)}j(ie);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return ae(),!0}function F(){return r.getToken()!==10?(fe(3,[],[2,5]),!1):(ge(!1),r.getToken()===6?(G(":"),ae(),X()||fe(4,[],[2,5])):fe(5,[],[2,5]),!0)}function W(){o(),ae();let ie=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(ie||fe(4,[],[]),G(","),ae(),r.getToken()===2&&re)break}else ie&&fe(6,[],[]);F()||fe(4,[],[2,5]),ie=!0}return y(),r.getToken()!==2?fe(7,[2],[]):ae(),!0}function z(){M(),ae();let ie=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(ie||fe(4,[],[]),G(","),ae(),r.getToken()===4&&re)break}else ie&&fe(6,[],[]);X()||fe(4,[],[4,5]),ie=!0}return O(),r.getToken()!==4?fe(8,[4],[]):ae(),!0}function X(){switch(r.getToken()){case 3:return z();case 1:return W();case 10:return ge(!0);default:return V()}}return ae(),r.getToken()===17?i.allowEmptyContent?!0:(fe(4,[],[]),!1):X()?(r.getToken()!==17&&fe(9,[],[]),!0):(fe(4,[],[]),!1)}e.visit=k;function E(t,c){const i=D(t),r=[];let s,l=0,o;do switch(o=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:l!==o&&r.push(t.substring(l,o)),c!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,c)),l=i.getPosition();break}while(s!==17);return r.join("")}e.stripComments=E;function L(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=L}),define(ee[124],te([0,1,43]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function R(h,S,v){let b,g,p,w,a;if(S){for(w=S.offset,a=w+S.length,p=w;p>0&&!d(h,p-1);)p--;let o=a;for(;o<h.length&&!d(h,o);)o++;g=h.substring(p,o),b=D(g,v)}else g=h,b=0,p=0,w=0,a=h.length;const u=P(v,h);let m=!1,k=0,E;v.insertSpaces?E=C(" ",v.tabSize||4):E="	";const L=(0,I.createScanner)(g,!1);let t=!1;function c(){return u+C(E,b+k)}function i(){let o=L.scan();for(m=!1;o===15||o===14;)m=m||o===14,o=L.scan();return t=o===16||L.getTokenError()!==0,o}const r=[];function s(o,f,y){!t&&f<a&&y>w&&h.substring(f,y)!==o&&r.push({offset:f,length:y-f,content:o})}let l=i();if(l!==17){const o=L.getTokenOffset()+p,f=C(E,b);s(f,p,o)}for(;l!==17;){let o=L.getTokenOffset()+L.getTokenLength()+p,f=i(),y="";for(;!m&&(f===12||f===13);){const O=L.getTokenOffset()+p;s(" ",o,O),o=L.getTokenOffset()+L.getTokenLength()+p,y=f===12?c():"",f=i()}if(f===2)l!==1&&(k--,y=c());else if(f===4)l!==3&&(k--,y=c());else{switch(l){case 3:case 1:k++,y=c();break;case 5:case 12:y=c();break;case 13:m?y=c():y=" ";break;case 6:y=" ";break;case 10:if(f===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?y=" ":f!==5&&f!==17&&(t=!0);break;case 16:t=!0;break}m&&(f===12||f===13)&&(y=c())}const M=L.getTokenOffset()+p;s(y,o,M),l=f}return r}e.format=R;function n(h,S){const v=JSON.stringify(h,void 0,S.insertSpaces?S.tabSize||4:"	");return S.eol!==void 0?v.replace(/\r\n|\r|\n/g,S.eol):v}e.toFormattedString=n;function C(h,S){let v="";for(let b=0;b<S;b++)v+=h;return v}function D(h,S){let v=0,b=0;const g=S.tabSize||4;for(;v<h.length;){const p=h.charAt(v);if(p===" ")b++;else if(p==="	")b+=g;else break;v++}return Math.floor(b/g)}function P(h,S){for(let v=0;v<S.length;v++){const b=S.charAt(v);if(b==="\r")return v+1<S.length&&S.charAt(v+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return h&&h.eol||`
`}e.getEOL=P;function d(h,S){return`\r
`.indexOf(h.charAt(S))!==-1}e.isEOL=d}),define(ee[125],te([0,1,43,124]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function n(h,S,v){return C(h,S,void 0,v)}e.removeProperty=n;function C(h,S,v,b,g){const p=S.slice(),w=[],a=(0,I.parseTree)(h,w);let u,m;for(;p.length>0&&(m=p.pop(),u=(0,I.findNodeAtLocation)(a,p),u===void 0&&v!==void 0);)typeof m=="string"?v={[m]:v}:v=[v];if(u)if(u.type==="object"&&typeof m=="string"&&Array.isArray(u.children)){const k=(0,I.findNodeAtLocation)(u,[m]);if(k!==void 0)if(v===void 0){if(!k.parent)throw new Error("Malformed AST");const E=u.children.indexOf(k.parent);let L,t=k.parent.offset+k.parent.length;if(E>0){const c=u.children[E-1];L=c.offset+c.length}else L=u.offset+1,u.children.length>1&&(t=u.children[1].offset);return D(h,{offset:L,length:t-L,content:""},b)}else return D(h,{offset:k.offset,length:k.length,content:JSON.stringify(v)},b);else{if(v===void 0)return[];const E=`${JSON.stringify(m)}: ${JSON.stringify(v)}`,L=g?g(u.children.map(c=>c.children[0].value)):u.children.length;let t;if(L>0){const c=u.children[L-1];t={offset:c.offset+c.length,length:0,content:","+E}}else u.children.length===0?t={offset:u.offset+1,length:0,content:E}:t={offset:u.offset+1,length:0,content:E+","};return D(h,t,b)}}else if(u.type==="array"&&typeof m=="number"&&Array.isArray(u.children))if(v!==void 0){const k=`${JSON.stringify(v)}`;let E;if(u.children.length===0||m===0)E={offset:u.offset+1,length:0,content:u.children.length===0?k:k+","};else{const L=m===-1||m>u.children.length?u.children.length:m,t=u.children[L-1];E={offset:t.offset+t.length,length:0,content:","+k}}return D(h,E,b)}else{const k=m,E=u.children[k];let L;if(u.children.length===1)L={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===k){const t=u.children[k-1],c=t.offset+t.length,i=u.offset+u.length;L={offset:c,length:i-2-c,content:""}}else L={offset:E.offset,length:u.children[k+1].offset-E.offset,content:""};return D(h,L,b)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${u.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return D(h,{offset:a?a.offset:0,length:a?a.length:0,content:JSON.stringify(v)},b)}}e.setProperty=C;function D(h,S,v){let b=P(h,S),g=S.offset,p=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;g>0&&!(0,R.isEOL)(b,g-1);)g--;for(;p<b.length&&!(0,R.isEOL)(b,p);)p++}const w=(0,R.format)(b,{offset:g,length:p-g},v);for(let u=w.length-1;u>=0;u--){const m=w[u];b=P(b,m),g=Math.min(g,m.offset),p=Math.max(p,m.offset+m.length),p+=m.content.length-m.length}const a=h.length-(b.length-p)-g;return[{offset:g,length:a,content:b.substring(g,p)}]}e.withFormatting=D;function P(h,S){return h.substring(0,S.offset)+S.content+h.substring(S.offset+S.length)}e.applyEdit=P;function d(h,S){const v=S.slice(0).sort((g,p)=>{const w=g.offset-p.offset;return w===0?g.length-p.length:w});let b=h.length;for(let g=v.length-1;g>=0;g--){const p=v[g];if(p.offset+p.length<=b)h=P(h,p);else throw new Error("Overlapping edit");b=p.offset}return h}e.applyEdits=d}),define(ee[126],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=I}),define(ee[2],te([0,1,49,69]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const n=!1;let C=null;function D(l){C=l}if(e.setDisposableTracker=D,n){const l="__is_disposable_tracked__";D(new class{trackDisposable(o){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[l]||console.log(f)},3e3)}setParent(o,f){if(o&&o!==m.None)try{o[l]=!0}catch{}}markAsDisposed(o){if(o&&o!==m.None)try{o[l]=!0}catch{}}markAsSingleton(o){}})}function P(l){return C?.trackDisposable(l),l}function d(l){C?.markAsDisposed(l)}function h(l,o){C?.setParent(l,o)}function S(l,o){if(!!C)for(const f of l)C.setParent(f,o)}function v(l){return C?.markAsSingleton(l),l}e.markAsSingleton=v;function b(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=b;function g(l){if(R.Iterable.is(l)){const o=[];for(const f of l)if(f)try{f.dispose()}catch(y){o.push(y)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=g;function p(l){for(const o of l)b(o)&&o.dispose();return[]}e.disposeIfDisposable=p;function w(...l){const o=a(()=>g(l));return S(l,o),o}e.combinedDisposable=w;function a(l){const o=P({dispose:(0,I.once)(()=>{d(o),l()})});return o}e.toDisposable=a;class u{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(d(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{g(this.c)}finally{this.c.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return h(o,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(o),o}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this.q=new u,P(this),h(this.q,this)}dispose(){d(this),this.q.dispose()}B(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(o)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class k{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(o){this.b||o===this.a||(this.a?.dispose(),o&&h(o,this),this.a=o)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const o=this.a;return this.a=void 0,o&&h(o,null),o}}e.MutableDisposable=k;class E{constructor(o){this.b=o,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=E;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(o){let f=o;return this.unset=()=>f=void 0,this.isset=()=>f!==void 0,this.dispose=()=>{f&&(f(),f=void 0,d(this))},this}}e.SafeDisposable=L;class t{constructor(){this.a=new Map}acquire(o,...f){let y=this.a.get(o);y||(y={counter:0,object:this.b(o,...f)},this.a.set(o,y));const{object:M}=y,O=(0,I.once)(()=>{--y.counter===0&&(this.c(o,y.object),this.a.delete(o))});return y.counter++,{object:M,dispose:O}}}e.ReferenceCollection=t;class c{constructor(o){this.a=o}async acquire(o,...f){const y=this.a.acquire(o,...f);try{return{object:await y.object,dispose:()=>y.dispose()}}catch(M){throw y.dispose(),M}}}e.AsyncReferenceCollection=c;class i{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=i;function r(l){const o=new u;try{l(o)}finally{o.dispose()}}e.disposeOnReturn=r;class s{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(o){return this.a.has(o)}get(o){return this.a.get(o)}set(o,f,y=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),y||this.a.get(o)?.dispose(),this.a.set(o,f)}deleteAndDispose(o){this.a.get(o)?.dispose(),this.a.delete(o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(ee[98],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{constructor(C){this.element=C,this.next=I.Undefined,this.prev=I.Undefined}}I.Undefined=new I(void 0);class R{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let C=this.a;for(;C!==I.Undefined;){const D=C.next;C.prev=I.Undefined,C.next=I.Undefined,C=D}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(C){return this.d(C,!1)}push(C){return this.d(C,!0)}d(C,D){const P=new I(C);if(this.a===I.Undefined)this.a=P,this.b=P;else if(D){const h=this.b;this.b=P,P.prev=h,h.next=P}else{const h=this.a;this.a=P,P.next=h,h.prev=P}this.c+=1;let d=!1;return()=>{d||(d=!0,this.e(P))}}shift(){if(this.a!==I.Undefined){const C=this.a.element;return this.e(this.a),C}}pop(){if(this.b!==I.Undefined){const C=this.b.element;return this.e(this.b),C}}e(C){if(C.prev!==I.Undefined&&C.next!==I.Undefined){const D=C.prev;D.next=C.next,C.next.prev=D}else C.prev===I.Undefined&&C.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):C.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):C.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let C=this.a;for(;C!==I.Undefined;)yield C.element,C=C.next}}e.LinkedList=R}),define(ee[35],te([0,1]),function(x,e){"use strict";var I,R,n;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function C(p,w,a){let u=p.get(w);return u===void 0&&(u=a,p.set(w,u)),u}e.getOrSet=C;function D(p){const w=[];return p.forEach((a,u)=>{w.push(`${u} => ${a}`)}),`Map(${p.size}) {${w.join(", ")}}`}e.mapToString=D;function P(p){const w=[];return p.forEach(a=>{w.push(a)}),`Set(${p.size}) {${w.join(", ")}}`}e.setToString=P;class d{constructor(w,a){this.uri=w,this.value=a}}class h{constructor(w,a){this[I]="ResourceMap",w instanceof h?(this.b=new Map(w.b),this.c=a??h.a):(this.b=new Map,this.c=w??h.a)}set(w,a){return this.b.set(this.c(w),new d(w,a)),this}get(w){return this.b.get(this.c(w))?.value}has(w){return this.b.has(this.c(w))}get size(){return this.b.size}clear(){this.b.clear()}delete(w){return this.b.delete(this.c(w))}forEach(w,a){typeof a<"u"&&(w=w.bind(a));for(const[u,m]of this.b)w(m.value,m.uri,this)}*values(){for(const w of this.b.values())yield w.value}*keys(){for(const w of this.b.values())yield w.uri}*entries(){for(const w of this.b.values())yield[w.uri,w.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,w]of this.b)yield[w.uri,w.value]}}e.ResourceMap=h,h.a=p=>p.toString();class S{constructor(w,a){this[R]="ResourceSet",!w||typeof w=="function"?this.a=new h(w):(this.a=new h(a),w.forEach(this.add,this))}get size(){return this.a.size}add(w){return this.a.set(w,w),this}clear(){this.a.clear()}delete(w){return this.a.delete(w)}forEach(w,a){this.a.forEach((u,m)=>w.call(a,m,m,this))}has(w){return this.a.has(w)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=S;var v;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class b{constructor(){this[n]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(w){return this.a.has(w)}get(w,a=0){const u=this.a.get(w);if(!!u)return a!==0&&this.j(u,a),u.value}set(w,a,u=0){let m=this.a.get(w);if(m)m.value=a,u!==0&&this.j(m,u);else{switch(m={key:w,value:a,next:void 0,previous:void 0},u){case 0:this.h(m);break;case 1:this.g(m);break;case 2:this.h(m);break;default:this.h(m);break}this.a.set(w,m),this.d++}return this}delete(w){return!!this.remove(w)}remove(w){const a=this.a.get(w);if(!!a)return this.a.delete(w),this.i(a),this.d--,a.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const w=this.b;return this.a.delete(w.key),this.i(w),this.d--,w.value}forEach(w,a){const u=this.e;let m=this.b;for(;m;){if(a?w.bind(a)(m.value,m.key,this):w(m.value,m.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const w=this,a=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(w.e!==a)throw new Error("LinkedMap got modified during iteration.");if(u){const k={value:u.key,done:!1};return u=u.next,k}else return{value:void 0,done:!0}}};return m}values(){const w=this,a=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(w.e!==a)throw new Error("LinkedMap got modified during iteration.");if(u){const k={value:u.value,done:!1};return u=u.next,k}else return{value:void 0,done:!0}}};return m}entries(){const w=this,a=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(w.e!==a)throw new Error("LinkedMap got modified during iteration.");if(u){const k={value:[u.key,u.value],done:!1};return u=u.next,k}else return{value:void 0,done:!0}}};return m}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(w){if(w>=this.size)return;if(w===0){this.clear();return}let a=this.b,u=this.size;for(;a&&u>w;)this.a.delete(a.key),a=a.next,u--;this.b=a,this.d=u,a&&(a.previous=void 0),this.e++}g(w){if(!this.b&&!this.c)this.c=w;else if(this.b)w.next=this.b,this.b.previous=w;else throw new Error("Invalid list");this.b=w,this.e++}h(w){if(!this.b&&!this.c)this.b=w;else if(this.c)w.previous=this.c,this.c.next=w;else throw new Error("Invalid list");this.c=w,this.e++}i(w){if(w===this.b&&w===this.c)this.b=void 0,this.c=void 0;else if(w===this.b){if(!w.next)throw new Error("Invalid list");w.next.previous=void 0,this.b=w.next}else if(w===this.c){if(!w.previous)throw new Error("Invalid list");w.previous.next=void 0,this.c=w.previous}else{const a=w.next,u=w.previous;if(!a||!u)throw new Error("Invalid list");a.previous=u,u.next=a}w.next=void 0,w.previous=void 0,this.e++}j(w,a){if(!this.b||!this.c)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(w===this.b)return;const u=w.next,m=w.previous;w===this.c?(m.next=void 0,this.c=m):(u.previous=m,m.next=u),w.previous=void 0,w.next=this.b,this.b.previous=w,this.b=w,this.e++}else if(a===2){if(w===this.c)return;const u=w.next,m=w.previous;w===this.b?(u.previous=void 0,this.b=u):(u.previous=m,m.next=u),w.next=void 0,w.previous=this.c,this.c.next=w,this.c=w,this.e++}}}toJSON(){const w=[];return this.forEach((a,u)=>{w.push([u,a])}),w}fromJSON(w){this.clear();for(const[a,u]of w)this.set(a,u)}}e.LinkedMap=b;class g extends b{constructor(w,a=1){super(),this.k=w,this.l=Math.min(Math.max(0,a),1)}get limit(){return this.k}set limit(w){this.k=w,this.m()}get ratio(){return this.l}set ratio(w){this.l=Math.min(Math.max(0,w),1),this.m()}get(w,a=2){return super.get(w,a)}peek(w){return super.get(w,0)}set(w,a){return super.set(w,a,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=g}),define(ee[79],te([0,1,35]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new I.LRUCache(1e4);function n(h){return d(h,"NFC",R)}e.normalizeNFC=n;const C=new I.LRUCache(1e4);function D(h){return d(h,"NFD",C)}e.normalizeNFD=D;const P=/[^\u0000-\u0080]/;function d(h,S,v){if(!h)return h;const b=v.get(h);if(b)return b;let g;return P.test(h)?g=h.normalize(S):g=h,v.set(h,g),g}e.removeAccents=function(){const h=/[\u0300-\u036f]/g;return function(S){return D(S).replace(h,"")}}()}),define(ee[127],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function I(P,d,h){return Math.min(Math.max(P,d),h)}e.clamp=I;function R(P,d){return(d+P%d)%d}e.rot=R;class n{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=n;class C{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=C;class D{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const h=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=h,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=D}),function(){function x(n){const C=[];typeof n=="number"&&C.push("code/timeOrigin",n);function D(d){C.push(d,Date.now())}function P(){const d=[];for(let h=0;h<C.length;h+=2)d.push({name:C[h],startTime:C[h+1]});return d}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(n){performance.mark(n)},getMarks(){let n=performance.timeOrigin;typeof n!="number"&&(n=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(n)}];for(const D of performance.getEntriesByType("mark"))C.push({name:D.name,startTime:Math.round(n+D.startTime)});return C}};if(typeof process=="object"){const n=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(n)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function I(n){return n.MonacoPerformanceMarks||(n.MonacoPerformanceMarks=e()),n.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=I(R))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var R in I)(typeof exports=="object"?exports:x)[R]=I[R]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function I(R){if(e[R])return e[R].exports;var n=e[R]={i:R,l:!1,exports:{}};return x[R].call(n.exports,n,n.exports,I),n.l=!0,n.exports}return I.m=x,I.c=e,I.d=function(R,n,C){I.o(R,n)||Object.defineProperty(R,n,{enumerable:!0,get:C})},I.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},I.t=function(R,n){if(1&n&&(R=I(R)),8&n||4&n&&typeof R=="object"&&R&&R.__esModule)return R;var C=Object.create(null);if(I.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:R}),2&n&&typeof R!="string")for(var D in R)I.d(C,D,function(P){return R[P]}.bind(null,D));return C},I.n=function(R){var n=R&&R.__esModule?function(){return R.default}:function(){return R};return I.d(n,"a",n),n},I.o=function(R,n){return Object.prototype.hasOwnProperty.call(R,n)},I.p="",I(I.s=0)}([function(x,e,I){(function(R){var n;e=x.exports=Q,n=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],d=e.src=[],h=0,S=h++;d[S]="0|[1-9]\\d*";var v=h++;d[v]="[0-9]+";var b=h++;d[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=h++;d[g]="("+d[S]+")\\.("+d[S]+")\\.("+d[S]+")";var p=h++;d[p]="("+d[v]+")\\.("+d[v]+")\\.("+d[v]+")";var w=h++;d[w]="(?:"+d[S]+"|"+d[b]+")";var a=h++;d[a]="(?:"+d[v]+"|"+d[b]+")";var u=h++;d[u]="(?:-("+d[w]+"(?:\\."+d[w]+")*))";var m=h++;d[m]="(?:-?("+d[a]+"(?:\\."+d[a]+")*))";var k=h++;d[k]="[0-9A-Za-z-]+";var E=h++;d[E]="(?:\\+("+d[k]+"(?:\\."+d[k]+")*))";var L=h++,t="v?"+d[g]+d[u]+"?"+d[E]+"?";d[L]="^"+t+"$";var c="[v=\\s]*"+d[p]+d[m]+"?"+d[E]+"?",i=h++;d[i]="^"+c+"$";var r=h++;d[r]="((?:<|>)?=?)";var s=h++;d[s]=d[v]+"|x|X|\\*";var l=h++;d[l]=d[S]+"|x|X|\\*";var o=h++;d[o]="[v=\\s]*("+d[l]+")(?:\\.("+d[l]+")(?:\\.("+d[l]+")(?:"+d[u]+")?"+d[E]+"?)?)?";var f=h++;d[f]="[v=\\s]*("+d[s]+")(?:\\.("+d[s]+")(?:\\.("+d[s]+")(?:"+d[m]+")?"+d[E]+"?)?)?";var y=h++;d[y]="^"+d[r]+"\\s*"+d[o]+"$";var M=h++;d[M]="^"+d[r]+"\\s*"+d[f]+"$";var O=h++;d[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=h++;d[j]="(?:~>?)";var G=h++;d[G]="(\\s*)"+d[j]+"\\s+",P[G]=new RegExp(d[G],"g");var H=h++;d[H]="^"+d[j]+d[o]+"$";var K=h++;d[K]="^"+d[j]+d[f]+"$";var ne=h++;d[ne]="(?:\\^)";var re=h++;d[re]="(\\s*)"+d[ne]+"\\s+",P[re]=new RegExp(d[re],"g");var ae=h++;d[ae]="^"+d[ne]+d[o]+"$";var fe=h++;d[fe]="^"+d[ne]+d[f]+"$";var ge=h++;d[ge]="^"+d[r]+"\\s*("+c+")$|^$";var V=h++;d[V]="^"+d[r]+"\\s*("+t+")$|^$";var F=h++;d[F]="(\\s*)"+d[r]+"\\s*("+c+"|"+d[o]+")",P[F]=new RegExp(d[F],"g");var W=h++;d[W]="^\\s*("+d[o]+")\\s+-\\s+("+d[o]+")\\s*$";var z=h++;d[z]="^\\s*("+d[f]+")\\s+-\\s+("+d[f]+")\\s*$";var X=h++;d[X]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)n(ie,d[ie]),P[ie]||(P[ie]=new RegExp(d[ie]));function se(Z,ue){if(Z instanceof Q)return Z;if(typeof Z!="string"||Z.length>C||!(ue?P[i]:P[L]).test(Z))return null;try{return new Q(Z,ue)}catch{return null}}function Q(Z,ue){if(Z instanceof Q){if(Z.loose===ue)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof Q))return new Q(Z,ue);n("SemVer",Z,ue),this.loose=ue;var de=Z.trim().match(ue?P[i]:P[L]);if(!de)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Re=+Pe;if(Re>=0&&Re<D)return Re}return Pe}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=se,e.valid=function(Z,ue){var de=se(Z,ue);return de?de.version:null},e.clean=function(Z,ue){var de=se(Z.trim().replace(/^[=v]+/,""),ue);return de?de.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(Z){return n("SemVer.compare",this.version,this.loose,Z),Z instanceof Q||(Z=new Q(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},Q.prototype.compareMain=function(Z){return Z instanceof Q||(Z=new Q(Z,this.loose)),T(this.major,Z.major)||T(this.minor,Z.minor)||T(this.patch,Z.patch)},Q.prototype.comparePre=function(Z){if(Z instanceof Q||(Z=new Q(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var ue=0;do{var de=this.prerelease[ue],Pe=Z.prerelease[ue];if(n("prerelease compare",ue,de,Pe),de===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(de===void 0)return-1;if(de!==Pe)return T(de,Pe)}while(++ue)},Q.prototype.inc=function(Z,ue){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,ue,de,Pe){typeof de=="string"&&(Pe=de,de=void 0);try{return new Q(Z,de).inc(ue,Pe).version}catch{return null}},e.diff=function(Z,ue){if(N(Z,ue))return null;var de=se(Z),Pe=se(ue);if(de.prerelease.length||Pe.prerelease.length){for(var Re in de)if((Re==="major"||Re==="minor"||Re==="patch")&&de[Re]!==Pe[Re])return"pre"+Re;return"prerelease"}for(var Re in de)if((Re==="major"||Re==="minor"||Re==="patch")&&de[Re]!==Pe[Re])return Re},e.compareIdentifiers=T;var A=/^[0-9]+$/;function T(Z,ue){var de=A.test(Z),Pe=A.test(ue);return de&&Pe&&(Z=+Z,ue=+ue),de&&!Pe?-1:Pe&&!de?1:Z<ue?-1:Z>ue?1:0}function U(Z,ue,de){return new Q(Z,de).compare(new Q(ue,de))}function B(Z,ue,de){return U(Z,ue,de)>0}function q(Z,ue,de){return U(Z,ue,de)<0}function N(Z,ue,de){return U(Z,ue,de)===0}function $(Z,ue,de){return U(Z,ue,de)!==0}function J(Z,ue,de){return U(Z,ue,de)>=0}function oe(Z,ue,de){return U(Z,ue,de)<=0}function le(Z,ue,de,Pe){var Re;switch(ue){case"===":typeof Z=="object"&&(Z=Z.version),typeof de=="object"&&(de=de.version),Re=Z===de;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof de=="object"&&(de=de.version),Re=Z!==de;break;case"":case"=":case"==":Re=N(Z,de,Pe);break;case"!=":Re=$(Z,de,Pe);break;case">":Re=B(Z,de,Pe);break;case">=":Re=J(Z,de,Pe);break;case"<":Re=q(Z,de,Pe);break;case"<=":Re=oe(Z,de,Pe);break;default:throw new TypeError("Invalid operator: "+ue)}return Re}function be(Z,ue){if(Z instanceof be){if(Z.loose===ue)return Z;Z=Z.value}if(!(this instanceof be))return new be(Z,ue);n("comparator",Z,ue),this.loose=ue,this.parse(Z),this.semver===Le?this.value="":this.value=this.operator+this.semver.version,n("comp",this)}e.rcompareIdentifiers=function(Z,ue){return T(ue,Z)},e.major=function(Z,ue){return new Q(Z,ue).major},e.minor=function(Z,ue){return new Q(Z,ue).minor},e.patch=function(Z,ue){return new Q(Z,ue).patch},e.compare=U,e.compareLoose=function(Z,ue){return U(Z,ue,!0)},e.rcompare=function(Z,ue,de){return U(ue,Z,de)},e.sort=function(Z,ue){return Z.sort(function(de,Pe){return e.compare(de,Pe,ue)})},e.rsort=function(Z,ue){return Z.sort(function(de,Pe){return e.rcompare(de,Pe,ue)})},e.gt=B,e.lt=q,e.eq=N,e.neq=$,e.gte=J,e.lte=oe,e.cmp=le,e.Comparator=be;var Le={};function Te(Z,ue){if(Z instanceof Te)return Z.loose===ue?Z:new Te(Z.raw,ue);if(Z instanceof be)return new Te(Z.value,ue);if(!(this instanceof Te))return new Te(Z,ue);if(this.loose=ue,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Ae(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function pe(Z,ue,de,Pe,Re,We,Fe,He,Ue,qe,Ke,Be,xe){return((ue=Ae(de)?"":Ae(Pe)?">="+de+".0.0":Ae(Re)?">="+de+"."+Pe+".0":">="+ue)+" "+(He=Ae(Ue)?"":Ae(qe)?"<"+(+Ue+1)+".0.0":Ae(Ke)?"<"+Ue+"."+(+qe+1)+".0":Be?"<="+Ue+"."+qe+"."+Ke+"-"+Be:"<="+He)).trim()}function ve(Z,ue){for(var de=0;de<Z.length;de++)if(!Z[de].test(ue))return!1;if(ue.prerelease.length){for(de=0;de<Z.length;de++)if(n(Z[de].semver),Z[de].semver!==Le&&Z[de].semver.prerelease.length>0){var Pe=Z[de].semver;if(Pe.major===ue.major&&Pe.minor===ue.minor&&Pe.patch===ue.patch)return!0}return!1}return!0}function Ce(Z,ue,de){try{ue=new Te(ue,de)}catch{return!1}return ue.test(Z)}function Me(Z,ue,de,Pe){var Re,We,Fe,He,Ue;switch(Z=new Q(Z,Pe),ue=new Te(ue,Pe),de){case">":Re=B,We=oe,Fe=q,He=">",Ue=">=";break;case"<":Re=q,We=J,Fe=B,He="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(Z,ue,Pe))return!1;for(var qe=0;qe<ue.set.length;++qe){var Ke=ue.set[qe],Be=null,xe=null;if(Ke.forEach(function(Y){Y.semver===Le&&(Y=new be(">=0.0.0")),Be=Be||Y,xe=xe||Y,Re(Y.semver,Be.semver,Pe)?Be=Y:Fe(Y.semver,xe.semver,Pe)&&(xe=Y)}),Be.operator===He||Be.operator===Ue||(!xe.operator||xe.operator===He)&&We(Z,xe.semver)||xe.operator===Ue&&Fe(Z,xe.semver))return!1}return!0}be.prototype.parse=function(Z){var ue=this.loose?P[ge]:P[V],de=Z.match(ue);if(!de)throw new TypeError("Invalid comparator: "+Z);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new Q(de[2],this.loose):this.semver=Le},be.prototype.toString=function(){return this.value},be.prototype.test=function(Z){return n("Comparator.test",Z,this.loose),this.semver===Le||(typeof Z=="string"&&(Z=new Q(Z,this.loose)),le(Z,this.operator,this.semver,this.loose))},be.prototype.intersects=function(Z,ue){if(!(Z instanceof be))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Te(Z.value,ue),Ce(this.value,de,ue);if(Z.operator==="")return de=new Te(this.value,ue),Ce(Z.semver,de,ue);var Pe=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),We=this.semver.version===Z.semver.version,Fe=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),He=le(this.semver,"<",Z.semver,ue)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),Ue=le(this.semver,">",Z.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return Pe||Re||We&&Fe||He||Ue},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(Z){var ue=this.loose;Z=Z.trim(),n("range",Z,ue);var de=ue?P[z]:P[W];Z=Z.replace(de,pe),n("hyphen replace",Z),Z=Z.replace(P[F],"$1$2$3"),n("comparator trim",Z,P[F]),Z=(Z=(Z=Z.replace(P[G],"$1~")).replace(P[re],"$1^")).split(/\s+/).join(" ");var Pe=ue?P[ge]:P[V],Re=Z.split(" ").map(function(We){return function(Fe,He){return n("comp",Fe),Fe=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(Ke){return function(Be,xe){n("caret",Be,xe);var Y=xe?P[fe]:P[ae];return Be.replace(Y,function(ce,he,me,ye,Oe){var $e;return n("caret",Be,ce,he,me,ye,Oe),Ae(he)?$e="":Ae(me)?$e=">="+he+".0.0 <"+(+he+1)+".0.0":Ae(ye)?$e=he==="0"?">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":">="+he+"."+me+".0 <"+(+he+1)+".0.0":Oe?(n("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),$e=he==="0"?me==="0"?">="+he+"."+me+"."+ye+Oe+" <"+he+"."+me+"."+(+ye+1):">="+he+"."+me+"."+ye+Oe+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+ye+Oe+" <"+(+he+1)+".0.0"):(n("no pr"),$e=he==="0"?me==="0"?">="+he+"."+me+"."+ye+" <"+he+"."+me+"."+(+ye+1):">="+he+"."+me+"."+ye+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+ye+" <"+(+he+1)+".0.0"),n("caret return",$e),$e})}(Ke,qe)}).join(" ")}(Fe,He),n("caret",Fe),Fe=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(Ke){return function(Be,xe){var Y=xe?P[K]:P[H];return Be.replace(Y,function(ce,he,me,ye,Oe){var $e;return n("tilde",Be,ce,he,me,ye,Oe),Ae(he)?$e="":Ae(me)?$e=">="+he+".0.0 <"+(+he+1)+".0.0":Ae(ye)?$e=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":Oe?(n("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),$e=">="+he+"."+me+"."+ye+Oe+" <"+he+"."+(+me+1)+".0"):$e=">="+he+"."+me+"."+ye+" <"+he+"."+(+me+1)+".0",n("tilde return",$e),$e})}(Ke,qe)}).join(" ")}(Fe,He),n("tildes",Fe),Fe=function(Ue,qe){return n("replaceXRanges",Ue,qe),Ue.split(/\s+/).map(function(Ke){return function(Be,xe){Be=Be.trim();var Y=xe?P[M]:P[y];return Be.replace(Y,function(ce,he,me,ye,Oe,$e){n("xRange",Be,ce,he,me,ye,Oe,$e);var tt=Ae(me),Qe=tt||Ae(ye),Ge=Qe||Ae(Oe);return he==="="&&Ge&&(he=""),tt?ce=he===">"||he==="<"?"<0.0.0":"*":he&&Ge?(Qe&&(ye=0),Ge&&(Oe=0),he===">"?(he=">=",Qe?(me=+me+1,ye=0,Oe=0):Ge&&(ye=+ye+1,Oe=0)):he==="<="&&(he="<",Qe?me=+me+1:ye=+ye+1),ce=he+me+"."+ye+"."+Oe):Qe?ce=">="+me+".0.0 <"+(+me+1)+".0.0":Ge&&(ce=">="+me+"."+ye+".0 <"+me+"."+(+ye+1)+".0"),n("xRange return",ce),ce})}(Ke,qe)}).join(" ")}(Fe,He),n("xrange",Fe),Fe=function(Ue,qe){return n("replaceStars",Ue,qe),Ue.trim().replace(P[X],"")}(Fe,He),n("stars",Fe),Fe}(We,ue)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(We){return!!We.match(Pe)})),Re=Re.map(function(We){return new be(We,ue)})},Te.prototype.intersects=function(Z,ue){if(!(Z instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Pe){return Z.set.some(function(Re){return Re.every(function(We){return Pe.intersects(We,ue)})})})})},e.toComparators=function(Z,ue){return new Te(Z,ue).set.map(function(de){return de.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new Q(Z,this.loose));for(var ue=0;ue<this.set.length;ue++)if(ve(this.set[ue],Z))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(Z,ue,de){var Pe=null,Re=null;try{var We=new Te(ue,de)}catch{return null}return Z.forEach(function(Fe){We.test(Fe)&&(Pe&&Re.compare(Fe)!==-1||(Re=new Q(Pe=Fe,de)))}),Pe},e.minSatisfying=function(Z,ue,de){var Pe=null,Re=null;try{var We=new Te(ue,de)}catch{return null}return Z.forEach(function(Fe){We.test(Fe)&&(Pe&&Re.compare(Fe)!==1||(Re=new Q(Pe=Fe,de)))}),Pe},e.validRange=function(Z,ue){try{return new Te(Z,ue).range||"*"}catch{return null}},e.ltr=function(Z,ue,de){return Me(Z,ue,"<",de)},e.gtr=function(Z,ue,de){return Me(Z,ue,">",de)},e.outside=Me,e.prerelease=function(Z,ue){var de=se(Z,ue);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(Z,ue,de){return Z=new Te(Z,de),ue=new Te(ue,de),Z.intersects(ue)},e.coerce=function(Z){if(Z instanceof Q)return Z;if(typeof Z!="string")return null;var ue=Z.match(P[O]);return ue==null?null:se((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,I(1))},function(x,e){var I,R,n=x.exports={};function C(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function P(a){if(I===setTimeout)return setTimeout(a,0);if((I===C||!I)&&setTimeout)return I=setTimeout,setTimeout(a,0);try{return I(a,0)}catch{try{return I.call(null,a,0)}catch{return I.call(this,a,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:C}catch{I=C}try{R=typeof clearTimeout=="function"?clearTimeout:D}catch{R=D}})();var d,h=[],S=!1,v=-1;function b(){S&&d&&(S=!1,d.length?h=d.concat(h):v=-1,h.length&&g())}function g(){if(!S){var a=P(b);S=!0;for(var u=h.length;u;){for(d=h,h=[];++v<u;)d&&d[v].run();v=-1,u=h.length}d=null,S=!1,function(m){if(R===clearTimeout)return clearTimeout(m);if((R===D||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(m);try{R(m)}catch{try{return R.call(null,m)}catch{return R.call(this,m)}}}(a)}}function p(a,u){this.fun=a,this.array=u}function w(){}n.nextTick=function(a){var u=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)u[m-1]=arguments[m];h.push(new p(a,u)),h.length!==1||S||P(g)},p.prototype.run=function(){this.fun.apply(null,this.array)},n.title="browser",n.browser=!0,n.env={},n.argv=[],n.version="",n.versions={},n.on=w,n.addListener=w,n.once=w,n.off=w,n.removeListener=w,n.removeAllListeners=w,n.emit=w,n.prependListener=w,n.prependOnceListener=w,n.listeners=function(a){return[]},n.binding=function(a){throw new Error("process.binding is not supported")},n.cwd=function(){return"/"},n.chdir=function(a){throw new Error("process.chdir is not supported")},n.umask=function(){return 0}}])}),define(ee[128],te([0,1]),function(x,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class R{constructor(P,d,h){this.level=P,this.key=d,this.value=h,this.forward=[]}}const n=void 0;class C{constructor(P,d=2**16){this.comparator=P,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(d)|0),this.e=new R(this.c,n,n)}get size(){return this.f}clear(){this.e=new R(this.c,n,n)}has(P){return Boolean(C.g(this,P,this.comparator))}get(P){return C.g(this,P,this.comparator)?.value}set(P,d){return C.h(this,P,d,this.comparator)&&(this.f+=1),this}delete(P){const d=C.k(this,P,this.comparator);return d&&(this.f-=1),d}forEach(P,d){let h=this.e.forward[0];for(;h;)P.call(d,h.value,h.key,this),h=h.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",d=this.e.forward[0];for(;d;)P+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return P}static g(P,d,h){let S=P.e;for(let v=P.d-1;v>=0;v--)for(;S.forward[v]&&h(S.forward[v].key,d)<0;)S=S.forward[v];if(S=S.forward[0],S&&h(S.key,d)===0)return S}static h(P,d,h,S){const v=[];let b=P.e;for(let g=P.d-1;g>=0;g--){for(;b.forward[g]&&S(b.forward[g].key,d)<0;)b=b.forward[g];v[g]=b}if(b=b.forward[0],b&&S(b.key,d)===0)return b.value=h,!1;{const g=C.j(P);if(g>P.d){for(let p=P.d;p<g;p++)v[p]=P.e;P.d=g}b=new R(g,d,h);for(let p=0;p<g;p++)b.forward[p]=v[p].forward[p],v[p].forward[p]=b;return!0}}static j(P,d=.5){let h=1;for(;Math.random()<d&&h<P.c;)h+=1;return h}static k(P,d,h){const S=[];let v=P.e;for(let b=P.d-1;b>=0;b--){for(;v.forward[b]&&h(v.forward[b].key,d)<0;)v=v.forward[b];S[b]=v}if(v=v.forward[0],!v||h(v.key,d)!==0)return!1;for(let b=0;b<P.d&&S[b].forward[b]===v;b++)S[b].forward[b]=v.forward[b];for(;P.d>0&&P.e.forward[P.d-1]===n;)P.d-=1;return!0}}e.SkipList=C}),define(ee[59],te([0,1,13,2]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function n(E){const L=E;return L?typeof L.read=="function":!1}e.isReadable=n;function C(E){const L=E;return L?[L.on,L.pause,L.resume,L.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=C;function D(E){const L=E;return L?C(L.stream)&&Array.isArray(L.buffer)&&typeof L.ended=="boolean":!1}e.isReadableBufferedStream=D;function P(E,L){return new d(E,L)}e.newWriteableStream=P;class d{constructor(L,t){this.e=L,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(L){if(!this.a.destroyed){if(this.a.flowing)this.g(L);else if(this.b.data.push(L),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(L){this.a.destroyed||(this.a.flowing?this.h(L):this.b.error.push(L))}end(L){this.a.destroyed||(typeof L<"u"&&this.write(L),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(L){this.c.data.slice(0).forEach(t=>t(L))}h(L){this.c.error.length===0?(0,I.onUnexpectedError)(L):this.c.error.slice(0).forEach(t=>t(L))}i(){this.c.end.slice(0).forEach(L=>L())}on(L,t){if(!this.a.destroyed)switch(L){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(L,t){if(this.a.destroyed)return;let c;switch(L){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const i=c.indexOf(t);i>=0&&c.splice(i,1)}}j(){if(this.b.data.length>0){const L=this.e(this.b.data);this.g(L),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const L of this.b.error)this.h(L);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function h(E,L){const t=[];let c;for(;(c=E.read())!==null;)t.push(c);return L(t)}e.consumeReadable=h;function S(E,L,t){const c=[];let i;for(;(i=E.read())!==null&&c.length<t;)c.push(i);return i===null&&c.length>0?L(c):{read:()=>{if(c.length>0)return c.shift();if(typeof i<"u"){const r=i;return i=void 0,r}return E.read()}}}e.peekReadable=S;function v(E,L){return new Promise((t,c)=>{const i=[];b(E,{onData:r=>{L&&i.push(r)},onError:r=>{L?c(r):t(void 0)},onEnd:()=>{t(L?L(i):void 0)}})})}e.consumeStream=v;function b(E,L){let t=!1;return E.on("error",c=>{t||L.onError(c)}),E.on("end",()=>{t||L.onEnd()}),E.on("data",c=>{t||L.onData(c)}),(0,R.toDisposable)(()=>t=!0)}e.listenStream=b;function g(E,L){return new Promise((t,c)=>{const i=new R.DisposableStore,r=[],s=f=>{if(r.push(f),r.length>L)return i.dispose(),E.pause(),t({stream:E,buffer:r,ended:!1})},l=f=>c(f),o=()=>t({stream:E,buffer:r,ended:!0});i.add((0,R.toDisposable)(()=>E.removeListener("error",l))),E.on("error",l),i.add((0,R.toDisposable)(()=>E.removeListener("end",o))),E.on("end",o),i.add((0,R.toDisposable)(()=>E.removeListener("data",s))),E.on("data",s)})}e.peekStream=g;function p(E,L){const t=P(L);return t.end(E),t}e.toStream=p;function w(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=w;function a(E){let L=!1;return{read:()=>L?null:(L=!0,E)}}e.toReadable=a;function u(E,L,t){const c=P(t);return b(E,{onData:i=>c.write(L.data(i)),onError:i=>c.error(L.error?L.error(i):i),onEnd:()=>c.end()}),c}e.transform=u;function m(E,L,t){let c=!1;return{read:()=>{const i=L.read();return c?i:(c=!0,i!==null?t([E,i]):E)}}}e.prefixedReadable=m;function k(E,L,t){let c=!1;const i=P(t);return b(L,{onData:r=>c?i.write(r):(c=!0,i.write(t([E,r]))),onError:r=>i.error(r),onEnd:()=>{c||(c=!0,i.write(E)),i.end()}}),i}e.prefixedStream=k}),define(ee[17],te([0,1,59]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer<"u";let n,C;class D{static alloc(f){return R?new D(Buffer.allocUnsafe(f)):new D(new Uint8Array(f))}static wrap(f){return R&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new D(f)}static fromString(f,y){return!(y?.dontUseNodeBuffer||!1)&&R?new D(Buffer.from(f)):(n||(n=new TextEncoder),new D(n.encode(f)))}static fromByteArray(f){const y=D.alloc(f.length);for(let M=0,O=f.length;M<O;M++)y.buffer[M]=f[M];return y}static concat(f,y){if(typeof y>"u"){y=0;for(let j=0,G=f.length;j<G;j++)y+=f[j].byteLength}const M=D.alloc(y);let O=0;for(let j=0,G=f.length;j<G;j++){const H=f[j];M.set(H,O),O+=H.byteLength}return M}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=D.alloc(this.byteLength);return f.set(this),f}toString(){return R?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(f,y){return new D(this.buffer.subarray(f,y))}set(f,y){if(f instanceof D)this.buffer.set(f.buffer,y);else if(f instanceof Uint8Array)this.buffer.set(f,y);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),y);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),y);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return h(this.buffer,f)}writeUInt32BE(f,y){S(this.buffer,f,y)}readUInt32LE(f){return v(this.buffer,f)}writeUInt32LE(f,y){b(this.buffer,f,y)}readUInt8(f){return g(this.buffer,f)}writeUInt8(f,y){p(this.buffer,f,y)}}e.VSBuffer=D;function P(o,f){return o[f+0]<<0>>>0|o[f+1]<<8>>>0}e.readUInt16LE=P;function d(o,f,y){o[y+0]=f&255,f=f>>>8,o[y+1]=f&255}e.writeUInt16LE=d;function h(o,f){return o[f]*2**24+o[f+1]*2**16+o[f+2]*2**8+o[f+3]}e.readUInt32BE=h;function S(o,f,y){o[y+3]=f,f=f>>>8,o[y+2]=f,f=f>>>8,o[y+1]=f,f=f>>>8,o[y]=f}e.writeUInt32BE=S;function v(o,f){return o[f+0]<<0>>>0|o[f+1]<<8>>>0|o[f+2]<<16>>>0|o[f+3]<<24>>>0}e.readUInt32LE=v;function b(o,f,y){o[y+0]=f&255,f=f>>>8,o[y+1]=f&255,f=f>>>8,o[y+2]=f&255,f=f>>>8,o[y+3]=f&255}e.writeUInt32LE=b;function g(o,f){return o[f]}e.readUInt8=g;function p(o,f,y){o[y]=f}e.writeUInt8=p;function w(o){return I.consumeReadable(o,f=>D.concat(f))}e.readableToBuffer=w;function a(o){return I.toReadable(o)}e.bufferToReadable=a;function u(o){return I.consumeStream(o,f=>D.concat(f))}e.streamToBuffer=u;async function m(o){return o.ended?D.concat(o.buffer):D.concat([...o.buffer,await u(o.stream)])}e.bufferedStreamToBuffer=m;function k(o){return I.toStream(o,f=>D.concat(f))}e.bufferToStream=k;function E(o){return I.transform(o,{data:f=>typeof f=="string"?D.fromString(f):D.wrap(f)},f=>D.concat(f))}e.streamToBufferReadableStream=E;function L(o){return I.newWriteableStream(f=>D.concat(f),o)}e.newWriteableBufferStream=L;function t(o,f){return I.prefixedReadable(o,f,y=>D.concat(y))}e.prefixedBufferReadable=t;function c(o,f){return I.prefixedStream(o,f,y=>D.concat(y))}e.prefixedBufferStream=c;function i(o){let f=0,y=0,M=0;const O=new Uint8Array(Math.floor(o.length/4*3)),j=H=>{switch(y){case 3:O[M++]=f|H,y=0;break;case 2:O[M++]=f|H>>>2,f=H<<6,y=3;break;case 1:O[M++]=f|H>>>4,f=H<<4,y=2;break;default:f=H<<2,y=1}};for(let H=0;H<o.length;H++){const K=o.charCodeAt(H);if(K>=65&&K<=90)j(K-65);else if(K>=97&&K<=122)j(K-97+26);else if(K>=48&&K<=57)j(K-48+52);else if(K===43||K===45)j(62);else if(K===47||K===95)j(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${o[H]}`)}}const G=M;for(;y>0;)j(0);return D.wrap(O).slice(0,G)}e.decodeBase64=i;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:o},f=!0,y=!1){const M=y?s:r;let O="";const j=o.byteLength%3;let G=0;for(;G<o.byteLength-j;G+=3){const H=o[G+0],K=o[G+1],ne=o[G+2];O+=M[H>>>2],O+=M[(H<<4|K>>>4)&63],O+=M[(K<<2|ne>>>6)&63],O+=M[ne&63]}if(j===1){const H=o[G+0];O+=M[H>>>2],O+=M[H<<4&63],f&&(O+="==")}else if(j===2){const H=o[G+0],K=o[G+1];O+=M[H>>>2],O+=M[(H<<4|K>>>4)&63],O+=M[K<<2&63],f&&(O+="=")}return O}e.encodeBase64=l}),define(ee[129],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ee[10],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function I(c){return typeof c=="string"}e.isString=I;function R(c){return Array.isArray(c)&&c.every(i=>I(i))}e.isStringArray=R;function n(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=n;function C(c){const i=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof i}e.isTypedArray=C;function D(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=D;function P(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=P;function d(c){return c===!0||c===!1}e.isBoolean=d;function h(c){return typeof c>"u"}e.isUndefined=h;function S(c){return!v(c)}e.isDefined=S;function v(c){return h(c)||c===null}e.isUndefinedOrNull=v;function b(c,i){if(!c)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=b;function g(c){if(v(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=g;function p(...c){const i=[];for(let r=0;r<c.length;r++){const s=c[r];if(v(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);i.push(s)}return i}e.assertAllDefined=p;const w=Object.prototype.hasOwnProperty;function a(c){if(!n(c))return!1;for(const i in c)if(w.call(c,i))return!1;return!0}e.isEmptyObject=a;function u(c){return typeof c=="function"}e.isFunction=u;function m(...c){return c.length>0&&c.every(u)}e.areFunctions=m;function k(c,i){const r=Math.min(c.length,i.length);for(let s=0;s<r;s++)E(c[s],i[s])}e.validateConstraints=k;function E(c,i){if(I(i)){if(typeof c!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(c instanceof i)return}catch{}if(!v(c)&&c.constructor===i||i.length===1&&i.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=E;function L(c){return c===null?void 0:c}e.withNullAsUndefined=L;function t(c){return typeof c>"u"?null:c}e.withUndefinedAsNull=t}),define(ee[130],te([0,1,10]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const R=Object.create(null);function n(P,d){if((0,I.isString)(d)){const h=R[d];if(h===void 0)throw new Error(`${P} references an unknown codicon: ${d}`);d=h}return R[P]=d,{id:P}}function C(){return R}e.getCodiconFontCharacters=C;function D(){return Object.values(e.Codicon)}e.getAllCodicons=D,e.Codicon={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package_:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(ee[44],te([0,1,10]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const m=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([k,E])=>{m[k]=E&&typeof E=="object"?R(E):E}),m}e.deepClone=R;function n(u){if(!u||typeof u!="object")return u;const m=[u];for(;m.length>0;){const k=m.shift();Object.freeze(k);for(const E in k)if(C.call(k,E)){const L=k[E];typeof L=="object"&&!Object.isFrozen(L)&&!(0,I.isTypedArray)(L)&&m.push(L)}}return u}e.deepFreeze=n;const C=Object.prototype.hasOwnProperty;function D(u,m){return P(u,m,new Set)}e.cloneAndChange=D;function P(u,m,k){if((0,I.isUndefinedOrNull)(u))return u;const E=m(u);if(typeof E<"u")return E;if(Array.isArray(u)){const L=[];for(const t of u)L.push(P(t,m,k));return L}if((0,I.isObject)(u)){if(k.has(u))throw new Error("Cannot clone recursive data-structure");k.add(u);const L={};for(const t in u)C.call(u,t)&&(L[t]=P(u[t],m,k));return k.delete(u),L}return u}function d(u,m,k=!0){return(0,I.isObject)(u)?((0,I.isObject)(m)&&Object.keys(m).forEach(E=>{E in u?k&&((0,I.isObject)(u[E])&&(0,I.isObject)(m[E])?d(u[E],m[E],k):u[E]=m[E]):u[E]=m[E]}),u):m}e.mixin=d;function h(u,m){if(u===m)return!0;if(u==null||m===null||m===void 0||typeof u!=typeof m||typeof u!="object"||Array.isArray(u)!==Array.isArray(m))return!1;let k,E;if(Array.isArray(u)){if(u.length!==m.length)return!1;for(k=0;k<u.length;k++)if(!h(u[k],m[k]))return!1}else{const L=[];for(E in u)L.push(E);L.sort();const t=[];for(E in m)t.push(E);if(t.sort(),!h(L,t))return!1;for(k=0;k<L.length;k++)if(!h(u[L[k]],m[L[k]]))return!1}return!0}e.equals=h;function S(u){const m=new Set;return JSON.stringify(u,(k,E)=>{if((0,I.isObject)(E)||Array.isArray(E)){if(m.has(E))return"[Circular]";m.add(E)}return E})}e.safeStringify=S;function v(u,m){const k=Object.create(null);return!u||!m||Object.keys(m).forEach(L=>{const t=u[L],c=m[L];h(t,c)||(k[L]=c)}),k}e.distinct=v;function b(u,m){const k=m.toLowerCase(),E=Object.keys(u).find(L=>L.toLowerCase()===k);return E?u[E]:u[m]}e.getCaseInsensitive=b;function g(u,m){const k=Object.create(null);for(const[E,L]of Object.entries(u))m(E,L)&&(k[E]=L);return k}e.filter=g;function p(u){let m=[],k=Object.getPrototypeOf(u);for(;Object.prototype!==k;)m=m.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return m}e.getAllPropertyNames=p;function w(u){const m=[];for(const k of p(u))typeof u[k]=="function"&&m.push(k);return m}e.getAllMethodNames=w;function a(u,m){const k=L=>function(){const t=Array.prototype.slice.call(arguments,0);return m(L,t)},E={};for(const L of u)E[L]=k(L);return E}e.createProxyObject=a}),define(ee[131],te([0,1,130]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var R;(function(D){function P(d){return d&&typeof d=="object"&&typeof d.id=="string"}D.isThemeColor=P})(R=e.ThemeColor||(e.ThemeColor={}));function n(D){return{id:D}}e.themeColorFromId=n;var C;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function d(m){const k=P.exec(m.id);if(!k)return d(I.Codicon.error);const[,E,L]=k,t=["codicon","codicon-"+E];return L&&t.push("codicon-modifier-"+L.substring(1)),t}D.asClassNameArray=d;function h(m){return d(m).join(" ")}D.asClassName=h;function S(m){return"."+d(m).join(".")}D.asCSSSelector=S;function v(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||R.isThemeColor(m.color))}D.isThemeIcon=v;const b=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function g(m){const k=b.exec(m);if(!k)return;const[,E]=k;return{id:E}}D.fromString=g;function p(m){return{id:m}}D.fromId=p;function w(m,k){let E=m.id;const L=E.lastIndexOf("~");return L!==-1&&(E=E.substring(0,L)),k&&(E=`${E}~${k}`),{id:E}}D.modify=w;function a(m){const k=m.id.lastIndexOf("~");if(k!==-1)return m.id.substring(k+1)}D.getModifier=a;function u(m,k){return m.id===k.id&&m.color?.id===k.color?.id}D.isEqual=u})(C=e.ThemeIcon||(e.ThemeIcon={}))}),define(ee[31],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(n){return I.test(n)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(P){for(let d=0;d<P.length;d++)P[d]=Math.floor(Math.random()*256);return P};const C=new Uint8Array(16),D=[];for(let P=0;P<256;P++)D.push(P.toString(16).padStart(2,"0"));return function(){n(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let d=0,h="";return h+=D[C[d++]],h+=D[C[d++]],h+=D[C[d++]],h+=D[C[d++]],h+="-",h+=D[C[d++]],h+=D[C[d++]],h+="-",h+=D[C[d++]],h+=D[C[d++]],h+="-",h+=D[C[d++]],h+=D[C[d++]],h+="-",h+=D[C[d++]],h+=D[C[d++]],h+=D[C[d++]],h+=D[C[d++]],h+=D[C[d++]],h+=D[C[d++]],h}}()}),define(ee[132],te([0,1,80,41,49]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function C(D,P){if(await new Promise((S,v)=>{const b=R.createReadStream(D),g=I.createHash("sha1");b.pipe(g);const p=(0,n.once)((w,a)=>{b.removeAllListeners(),g.removeAllListeners(),w?v(w):S(a)});b.once("error",p),b.once("end",p),g.once("error",p),g.once("data",w=>p(void 0,w.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=C}),define(ee[133],te([0,1,26]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function n(D){const P=D.replace(/\-/g,":").toLowerCase();return!R.has(P)}function C(){const D=(0,I.networkInterfaces)();for(const P in D){const d=D[P];if(d){for(const{mac:h}of d)if(n(h))return h}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(ee[99],te([0,1,81]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function R(P,d,h,S=1){let v=!1;return new Promise(b=>{const g=setTimeout(()=>{if(!v)return v=!0,b(0)},h);n(P,d,S,p=>{if(!v)return v=!0,clearTimeout(g),b(p)})})}e.findFreePort=R;function n(P,d,h,S){if(d===0)return S(0);const v=new I.Socket;v.once("connect",()=>(D(v),n(P+h,d-1,h,S))),v.once("data",()=>{}),v.once("error",b=>(D(v),b.code!=="ECONNREFUSED"?n(P+h,d-1,h,S):S(P))),v.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(P,d,h,S="127.0.0.1"){let v=!1,b,g=1;const p=I.createServer({pauseOnConnect:!0});function w(a,u){v||(v=!0,p.removeAllListeners(),p.close(),b&&clearTimeout(b),u(a))}return new Promise(a=>{b=setTimeout(()=>{w(0,a)},h),p.on("listening",()=>{w(P,a)}),p.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&g<d?(P++,g++,p.listen(P,S)):w(0,a)}),p.on("close",()=>{w(0,a)}),p.listen(P,S)})}e.findFreePortFaster=C;function D(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(d){console.error(d)}}}),define(ee[134],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[135],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class I{constructor(n,C){this.a=n,this.onMessage=C}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=I}),define(ee[42],te([0,1,14,13]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class n{constructor(){this.a=new WeakMap}on(D,P){const d=(h,...S)=>{this.b(D,h)&&P(h,...S)};return this.a.set(P,d),I.ipcMain.on(D,d),this}once(D,P){return I.ipcMain.once(D,(d,...h)=>{this.b(D,d)&&P(d,...h)}),this}handle(D,P){return I.ipcMain.handle(D,(d,...h)=>this.b(D,d)?P(d,...h):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return I.ipcMain.removeHandler(D),this}removeListener(D,P){const d=this.a.get(P);return d&&(I.ipcMain.removeListener(D,d),this.a.delete(P)),this}b(D,P){if(!D||!D.startsWith("vscode:"))return(0,R.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const d=P.senderFrame,h=d.url;if(!h)return!0;let S="unknown";try{S=new URL(h).host}catch{return(0,R.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${h}'.`),!1}return S!=="vscode-app"?((0,R.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${S}'.`),!1):d.parent!==null?((0,R.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${S}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new n}),define(ee[136],te([0,1,14,42,10,134]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){R.validatedIpcMain.on(C.CONTEXT_MENU_CHANNEL,(d,h,S,v,b)=>{const g=P(d,v,S);g.popup({window:(0,n.withNullAsUndefined)(I.BrowserWindow.fromWebContents(d.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{g&&d.sender.send(C.CONTEXT_MENU_CLOSE_CHANNEL,h)}})})}e.registerContextMenuListener=D;function P(d,h,S){const v=new I.Menu;return S.forEach(b=>{let g;b.type==="separator"?g=new I.MenuItem({type:b.type}):Array.isArray(b.submenu)?g=new I.MenuItem({submenu:P(d,h,b.submenu),label:b.label}):g=new I.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(p,w,a)=>d.sender.send(h,b.id,a)}),v.append(g)}),v}}),define(ee[100],te([0,1,14]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.canUseUtilityProcess=e.UtilityProcess=void 0,e.UtilityProcess=I.utilityProcess,e.canUseUtilityProcess=typeof e.UtilityProcess<"u"}),define(ee[137],te([12,11]),function(x,e){return x.create("vs/base/common/date",e)}),define(ee[138],te([0,1,137]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,n=R*60,C=n*24,D=C*7,P=C*30,d=C*365;function h(v,b,g,p){typeof v!="number"&&(v=v.getTime());const w=Math.round((new Date().getTime()-v)/1e3);if(w<-30)return(0,I.localize)(0,null,h(new Date().getTime()+w*1e3,!1));if(!p&&w<30)return(0,I.localize)(1,null);let a;return w<R?(a=w,b?a===1?g?(0,I.localize)(2,null,a):(0,I.localize)(3,null,a):g?(0,I.localize)(4,null,a):(0,I.localize)(5,null,a):a===1?g?(0,I.localize)(6,null,a):(0,I.localize)(7,null,a):g?(0,I.localize)(8,null,a):(0,I.localize)(9,null,a)):w<n?(a=Math.floor(w/R),b?a===1?g?(0,I.localize)(10,null,a):(0,I.localize)(11,null,a):g?(0,I.localize)(12,null,a):(0,I.localize)(13,null,a):a===1?g?(0,I.localize)(14,null,a):(0,I.localize)(15,null,a):g?(0,I.localize)(16,null,a):(0,I.localize)(17,null,a)):w<C?(a=Math.floor(w/n),b?a===1?g?(0,I.localize)(18,null,a):(0,I.localize)(19,null,a):g?(0,I.localize)(20,null,a):(0,I.localize)(21,null,a):a===1?g?(0,I.localize)(22,null,a):(0,I.localize)(23,null,a):g?(0,I.localize)(24,null,a):(0,I.localize)(25,null,a)):w<D?(a=Math.floor(w/C),b?a===1?(0,I.localize)(26,null,a):(0,I.localize)(27,null,a):a===1?(0,I.localize)(28,null,a):(0,I.localize)(29,null,a)):w<P?(a=Math.floor(w/D),b?a===1?g?(0,I.localize)(30,null,a):(0,I.localize)(31,null,a):g?(0,I.localize)(32,null,a):(0,I.localize)(33,null,a):a===1?g?(0,I.localize)(34,null,a):(0,I.localize)(35,null,a):g?(0,I.localize)(36,null,a):(0,I.localize)(37,null,a)):w<d?(a=Math.floor(w/P),b?a===1?g?(0,I.localize)(38,null,a):(0,I.localize)(39,null,a):g?(0,I.localize)(40,null,a):(0,I.localize)(41,null,a):a===1?g?(0,I.localize)(42,null,a):(0,I.localize)(43,null,a):g?(0,I.localize)(44,null,a):(0,I.localize)(45,null,a)):(a=Math.floor(w/d),b?a===1?g?(0,I.localize)(46,null,a):(0,I.localize)(47,null,a):g?(0,I.localize)(48,null,a):(0,I.localize)(49,null,a):a===1?g?(0,I.localize)(50,null,a):(0,I.localize)(51,null,a):g?(0,I.localize)(52,null,a):(0,I.localize)(53,null,a))}e.fromNow=h;function S(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=S}),define(ee[139],te([12,11]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(ee[45],te([0,1,25,10,139]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function C(v,b){return b&&(v.stack||v.stacktrace)?n.localize(0,null,P(v),D(v.stack)||D(v.stacktrace)):P(v)}function D(v){return Array.isArray(v)?v.join(`
`):v}function P(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?n.localize(1,null,v.message):v.message||n.localize(2,null)}function d(v=null,b=!1){if(!v)return n.localize(3,null);if(Array.isArray(v)){const g=I.coalesce(v),p=d(g[0],b);return g.length>1?n.localize(4,null,p,g.length):p}if(R.isString(v))return v;if(v.detail){const g=v.detail;if(g.error)return C(g.error,b);if(g.exception)return C(g.exception,b)}return v.stack?C(v,b):v.message?v.message:n.localize(5,null)}e.toErrorMessage=d;function h(v){const b=v;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=h;function S(v,b){let g;return typeof v=="string"?g=new Error(v):g=v,g.actions=b,g}e.createErrorWithActions=S}),define(ee[140],te([12,11]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(ee[141],te([0,1,140]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function R(n){switch(n){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.getParseErrorMessage=R}),define(ee[142],te([12,11]),function(x,e){return x.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,142]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let R=!1,n=!1,C=!1,D=!1,P=!1,d=!1,h=!1,S=!1,v=!1,b=!1,g,p=e.LANGUAGE_DEFAULT,w,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const m=typeof u?.versions?.electron=="string",k=m&&u?.type==="renderer";if(typeof navigator=="object"&&!k)a=navigator.userAgent,R=a.indexOf("Windows")>=0,n=a.indexOf("Macintosh")>=0,S=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=a.indexOf("Linux")>=0,b=a?.indexOf("Mobi")>=0,d=!0,g=I.getConfiguredDefaultLocale(I.localize(0,null))||e.LANGUAGE_DEFAULT,p=g;else if(typeof u=="object"){R=u.platform==="win32",n=u.platform==="darwin",C=u.platform==="linux",D=C&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,h=m,v=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT;const o=u.env.VSCODE_NLS_CONFIG;if(o)try{const f=JSON.parse(o),y=f.availableLanguages["*"];g=f.locale,p=y||e.LANGUAGE_DEFAULT,w=f._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var E;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function L(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=L;let t=0;n?t=1:R?t=3:C&&(t=2),e.isWindows=R,e.isMacintosh=n,e.isLinux=C,e.isLinuxSnap=D,e.isNative=P,e.isElectron=h,e.isWeb=d,e.isWebWorker=d&&typeof e.globals.importScripts=="function",e.isIOS=S,e.isMobile=b,e.isCI=v,e.platform=t,e.userAgent=a,e.language=p;var c;(function(o){function f(){return e.language}o.value=f;function y(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=y;function M(){return e.language==="en"}o.isDefault=M})(c=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=w,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let M=0,O=o.length;M<O;M++){const j=o[M];if(j.id===y.data.vscodeScheduleAsyncWork){o.splice(M,1),j.callback();return}}});let f=0;return y=>{const M=++f;o.push({id:M,callback:y}),e.globals.postMessage({vscodeScheduleAsyncWork:M},"*")}}return o=>setTimeout(o)})();var i;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=n||S?2:R?1:3;let r=!0,s=!1;function l(){if(!s){s=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,r=new Uint16Array(o.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[36],te([0,1,4]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let R;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.process<"u"){const n=I.globals.vscode.process;R={get platform(){return n.platform},get arch(){return n.arch},get env(){return n.env},cwd(){return n.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.arch=R.arch}),define(ee[9],te([0,1,36]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,n=97,C=90,D=122,P=46,d=47,h=92,S=58,v=63;class b extends Error{constructor(c,i,r){let s;typeof i=="string"&&i.indexOf("not ")===0?(s="must not be",i=i.replace(/^not /,"")):s="must be";const l=c.indexOf(".")!==-1?"property":"argument";let o=`The "${c}" ${l} ${s} of type ${i}`;o+=`. Received type ${typeof r}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function g(t,c){if(t===null||typeof t!="object")throw new b(c,"Object",t)}function p(t,c){if(typeof t!="string")throw new b(c,"string",t)}const w=I.platform==="win32";function a(t){return t===d||t===h}function u(t){return t===d}function m(t){return t>=R&&t<=C||t>=n&&t<=D}function k(t,c,i,r){let s="",l=0,o=-1,f=0,y=0;for(let M=0;M<=t.length;++M){if(M<t.length)y=t.charCodeAt(M);else{if(r(y))break;y=d}if(r(y)){if(!(o===M-1||f===1))if(f===2){if(s.length<2||l!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const O=s.lastIndexOf(i);O===-1?(s="",l=0):(s=s.slice(0,O),l=s.length-1-s.lastIndexOf(i)),o=M,f=0;continue}else if(s.length!==0){s="",l=0,o=M,f=0;continue}}c&&(s+=s.length>0?`${i}..`:"..",l=2)}else s.length>0?s+=`${i}${t.slice(o+1,M)}`:s=t.slice(o+1,M),l=M-o-1;o=M,f=0}else y===P&&f!==-1?++f:f=-1}return s}function E(t,c){g(c,"pathObject");const i=c.dir||c.root,r=c.base||`${c.name||""}${c.ext||""}`;return i?i===c.root?`${i}${r}`:`${i}${t}${r}`:r}e.win32={resolve(...t){let c="",i="",r=!1;for(let s=t.length-1;s>=-1;s--){let l;if(s>=0){if(l=t[s],p(l,"path"),l.length===0)continue}else c.length===0?l=I.cwd():(l=I.env[`=${c}`]||I.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==c.toLowerCase()&&l.charCodeAt(2)===h)&&(l=`${c}\\`));const o=l.length;let f=0,y="",M=!1;const O=l.charCodeAt(0);if(o===1)a(O)&&(f=1,M=!0);else if(a(O))if(M=!0,a(l.charCodeAt(1))){let j=2,G=j;for(;j<o&&!a(l.charCodeAt(j));)j++;if(j<o&&j!==G){const H=l.slice(G,j);for(G=j;j<o&&a(l.charCodeAt(j));)j++;if(j<o&&j!==G){for(G=j;j<o&&!a(l.charCodeAt(j));)j++;(j===o||j!==G)&&(y=`\\\\${H}\\${l.slice(G,j)}`,f=j)}}}else f=1;else m(O)&&l.charCodeAt(1)===S&&(y=l.slice(0,2),f=2,o>2&&a(l.charCodeAt(2))&&(M=!0,f=3));if(y.length>0)if(c.length>0){if(y.toLowerCase()!==c.toLowerCase())continue}else c=y;if(r){if(c.length>0)break}else if(i=`${l.slice(f)}\\${i}`,r=M,M&&c.length>0)break}return i=k(i,!r,"\\",a),r?`${c}\\${i}`:`${c}${i}`||"."},normalize(t){p(t,"path");const c=t.length;if(c===0)return".";let i=0,r,s=!1;const l=t.charCodeAt(0);if(c===1)return u(l)?"\\":t;if(a(l))if(s=!0,a(t.charCodeAt(1))){let f=2,y=f;for(;f<c&&!a(t.charCodeAt(f));)f++;if(f<c&&f!==y){const M=t.slice(y,f);for(y=f;f<c&&a(t.charCodeAt(f));)f++;if(f<c&&f!==y){for(y=f;f<c&&!a(t.charCodeAt(f));)f++;if(f===c)return`\\\\${M}\\${t.slice(y)}\\`;f!==y&&(r=`\\\\${M}\\${t.slice(y,f)}`,i=f)}}}else i=1;else m(l)&&t.charCodeAt(1)===S&&(r=t.slice(0,2),i=2,c>2&&a(t.charCodeAt(2))&&(s=!0,i=3));let o=i<c?k(t.slice(i),!s,"\\",a):"";return o.length===0&&!s&&(o="."),o.length>0&&a(t.charCodeAt(c-1))&&(o+="\\"),r===void 0?s?`\\${o}`:o:s?`${r}\\${o}`:`${r}${o}`},isAbsolute(t){p(t,"path");const c=t.length;if(c===0)return!1;const i=t.charCodeAt(0);return a(i)||c>2&&m(i)&&t.charCodeAt(1)===S&&a(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,i;for(let l=0;l<t.length;++l){const o=t[l];p(o,"path"),o.length>0&&(c===void 0?c=i=o:c+=`\\${o}`)}if(c===void 0)return".";let r=!0,s=0;if(typeof i=="string"&&a(i.charCodeAt(0))){++s;const l=i.length;l>1&&a(i.charCodeAt(1))&&(++s,l>2&&(a(i.charCodeAt(2))?++s:r=!1))}if(r){for(;s<c.length&&a(c.charCodeAt(s));)s++;s>=2&&(c=`\\${c.slice(s)}`)}return e.win32.normalize(c)},relative(t,c){if(p(t,"from"),p(c,"to"),t===c)return"";const i=e.win32.resolve(t),r=e.win32.resolve(c);if(i===r||(t=i.toLowerCase(),c=r.toLowerCase(),t===c))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===h;)s++;let l=t.length;for(;l-1>s&&t.charCodeAt(l-1)===h;)l--;const o=l-s;let f=0;for(;f<c.length&&c.charCodeAt(f)===h;)f++;let y=c.length;for(;y-1>f&&c.charCodeAt(y-1)===h;)y--;const M=y-f,O=o<M?o:M;let j=-1,G=0;for(;G<O;G++){const K=t.charCodeAt(s+G);if(K!==c.charCodeAt(f+G))break;K===h&&(j=G)}if(G!==O){if(j===-1)return r}else{if(M>O){if(c.charCodeAt(f+G)===h)return r.slice(f+G+1);if(G===2)return r.slice(f+G)}o>O&&(t.charCodeAt(s+G)===h?j=G:G===2&&(j=3)),j===-1&&(j=0)}let H="";for(G=s+j+1;G<=l;++G)(G===l||t.charCodeAt(G)===h)&&(H+=H.length===0?"..":"\\..");return f+=j,H.length>0?`${H}${r.slice(f,y)}`:(r.charCodeAt(f)===h&&++f,r.slice(f,y))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.win32.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===h){if(c.charCodeAt(1)===h){const i=c.charCodeAt(2);if(i!==v&&i!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(m(c.charCodeAt(0))&&c.charCodeAt(1)===S&&c.charCodeAt(2)===h)return`\\\\?\\${c}`;return t},dirname(t){p(t,"path");const c=t.length;if(c===0)return".";let i=-1,r=0;const s=t.charCodeAt(0);if(c===1)return a(s)?t:".";if(a(s)){if(i=r=1,a(t.charCodeAt(1))){let f=2,y=f;for(;f<c&&!a(t.charCodeAt(f));)f++;if(f<c&&f!==y){for(y=f;f<c&&a(t.charCodeAt(f));)f++;if(f<c&&f!==y){for(y=f;f<c&&!a(t.charCodeAt(f));)f++;if(f===c)return t;f!==y&&(i=r=f+1)}}}}else m(s)&&t.charCodeAt(1)===S&&(i=c>2&&a(t.charCodeAt(2))?3:2,r=i);let l=-1,o=!0;for(let f=c-1;f>=r;--f)if(a(t.charCodeAt(f))){if(!o){l=f;break}}else o=!1;if(l===-1){if(i===-1)return".";l=i}return t.slice(0,l)},basename(t,c){c!==void 0&&p(c,"ext"),p(t,"path");let i=0,r=-1,s=!0,l;if(t.length>=2&&m(t.charCodeAt(0))&&t.charCodeAt(1)===S&&(i=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let o=c.length-1,f=-1;for(l=t.length-1;l>=i;--l){const y=t.charCodeAt(l);if(a(y)){if(!s){i=l+1;break}}else f===-1&&(s=!1,f=l+1),o>=0&&(y===c.charCodeAt(o)?--o===-1&&(r=l):(o=-1,r=f))}return i===r?r=f:r===-1&&(r=t.length),t.slice(i,r)}for(l=t.length-1;l>=i;--l)if(a(t.charCodeAt(l))){if(!s){i=l+1;break}}else r===-1&&(s=!1,r=l+1);return r===-1?"":t.slice(i,r)},extname(t){p(t,"path");let c=0,i=-1,r=0,s=-1,l=!0,o=0;t.length>=2&&t.charCodeAt(1)===S&&m(t.charCodeAt(0))&&(c=r=2);for(let f=t.length-1;f>=c;--f){const y=t.charCodeAt(f);if(a(y)){if(!l){r=f+1;break}continue}s===-1&&(l=!1,s=f+1),y===P?i===-1?i=f:o!==1&&(o=1):i!==-1&&(o=-1)}return i===-1||s===-1||o===0||o===1&&i===s-1&&i===r+1?"":t.slice(i,s)},format:E.bind(null,"\\"),parse(t){p(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const i=t.length;let r=0,s=t.charCodeAt(0);if(i===1)return a(s)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(a(s)){if(r=1,a(t.charCodeAt(1))){let j=2,G=j;for(;j<i&&!a(t.charCodeAt(j));)j++;if(j<i&&j!==G){for(G=j;j<i&&a(t.charCodeAt(j));)j++;if(j<i&&j!==G){for(G=j;j<i&&!a(t.charCodeAt(j));)j++;j===i?r=j:j!==G&&(r=j+1)}}}}else if(m(s)&&t.charCodeAt(1)===S){if(i<=2)return c.root=c.dir=t,c;if(r=2,a(t.charCodeAt(2))){if(i===3)return c.root=c.dir=t,c;r=3}}r>0&&(c.root=t.slice(0,r));let l=-1,o=r,f=-1,y=!0,M=t.length-1,O=0;for(;M>=r;--M){if(s=t.charCodeAt(M),a(s)){if(!y){o=M+1;break}continue}f===-1&&(y=!1,f=M+1),s===P?l===-1?l=M:O!==1&&(O=1):l!==-1&&(O=-1)}return f!==-1&&(l===-1||O===0||O===1&&l===f-1&&l===o+1?c.base=c.name=t.slice(o,f):(c.name=t.slice(o,l),c.base=t.slice(o,f),c.ext=t.slice(l,f))),o>0&&o!==r?c.dir=t.slice(0,o-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const L=(()=>{if(w){const t=/\\/g;return()=>{const c=I.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>I.cwd()})();e.posix={resolve(...t){let c="",i=!1;for(let r=t.length-1;r>=-1&&!i;r--){const s=r>=0?t[r]:L();p(s,"path"),s.length!==0&&(c=`${s}/${c}`,i=s.charCodeAt(0)===d)}return c=k(c,!i,"/",u),i?`/${c}`:c.length>0?c:"."},normalize(t){if(p(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===d,i=t.charCodeAt(t.length-1)===d;return t=k(t,!c,"/",u),t.length===0?c?"/":i?"./":".":(i&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return p(t,"path"),t.length>0&&t.charCodeAt(0)===d},join(...t){if(t.length===0)return".";let c;for(let i=0;i<t.length;++i){const r=t[i];p(r,"path"),r.length>0&&(c===void 0?c=r:c+=`/${r}`)}return c===void 0?".":e.posix.normalize(c)},relative(t,c){if(p(t,"from"),p(c,"to"),t===c||(t=e.posix.resolve(t),c=e.posix.resolve(c),t===c))return"";const i=1,r=t.length,s=r-i,l=1,o=c.length-l,f=s<o?s:o;let y=-1,M=0;for(;M<f;M++){const j=t.charCodeAt(i+M);if(j!==c.charCodeAt(l+M))break;j===d&&(y=M)}if(M===f)if(o>f){if(c.charCodeAt(l+M)===d)return c.slice(l+M+1);if(M===0)return c.slice(l+M)}else s>f&&(t.charCodeAt(i+M)===d?y=M:M===0&&(y=0));let O="";for(M=i+y+1;M<=r;++M)(M===r||t.charCodeAt(M)===d)&&(O+=O.length===0?"..":"/..");return`${O}${c.slice(l+y)}`},toNamespacedPath(t){return t},dirname(t){if(p(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===d;let i=-1,r=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===d){if(!r){i=s;break}}else r=!1;return i===-1?c?"/":".":c&&i===1?"//":t.slice(0,i)},basename(t,c){c!==void 0&&p(c,"ext"),p(t,"path");let i=0,r=-1,s=!0,l;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let o=c.length-1,f=-1;for(l=t.length-1;l>=0;--l){const y=t.charCodeAt(l);if(y===d){if(!s){i=l+1;break}}else f===-1&&(s=!1,f=l+1),o>=0&&(y===c.charCodeAt(o)?--o===-1&&(r=l):(o=-1,r=f))}return i===r?r=f:r===-1&&(r=t.length),t.slice(i,r)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===d){if(!s){i=l+1;break}}else r===-1&&(s=!1,r=l+1);return r===-1?"":t.slice(i,r)},extname(t){p(t,"path");let c=-1,i=0,r=-1,s=!0,l=0;for(let o=t.length-1;o>=0;--o){const f=t.charCodeAt(o);if(f===d){if(!s){i=o+1;break}continue}r===-1&&(s=!1,r=o+1),f===P?c===-1?c=o:l!==1&&(l=1):c!==-1&&(l=-1)}return c===-1||r===-1||l===0||l===1&&c===r-1&&c===i+1?"":t.slice(c,r)},format:E.bind(null,"/"),parse(t){p(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const i=t.charCodeAt(0)===d;let r;i?(c.root="/",r=1):r=0;let s=-1,l=0,o=-1,f=!0,y=t.length-1,M=0;for(;y>=r;--y){const O=t.charCodeAt(y);if(O===d){if(!f){l=y+1;break}continue}o===-1&&(f=!1,o=y+1),O===P?s===-1?s=y:M!==1&&(M=1):s!==-1&&(M=-1)}if(o!==-1){const O=l===0&&i?1:l;s===-1||M===0||M===1&&s===o-1&&s===l+1?c.base=c.name=t.slice(O,o):(c.name=t.slice(O,s),c.base=t.slice(O,o),c.ext=t.slice(s,o))}return l>0?c.dir=t.slice(0,l-1):i&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w?e.win32.normalize:e.posix.normalize,e.isAbsolute=w?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w?e.win32.join:e.posix.join,e.resolve=w?e.win32.resolve:e.posix.resolve,e.relative=w?e.win32.relative:e.posix.relative,e.dirname=w?e.win32.dirname:e.posix.dirname,e.basename=w?e.win32.basename:e.posix.basename,e.extname=w?e.win32.extname:e.posix.extname,e.format=w?e.win32.format:e.posix.format,e.parse=w?e.win32.parse:e.posix.parse,e.toNamespacedPath=w?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w?e.win32.sep:e.posix.sep,e.delimiter=w?e.win32.delimiter:e.posix.delimiter}),define(ee[82],te([0,1,4]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var n;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(P,...d){const h=d.reduce((b,g)=>(b[g]=!0,b),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(b=>!h[b]).forEach(b=>{for(let g=0;g<S.length;g++)if(b.search(S[g])!==-1){delete P[b];break}})}e.sanitizeProcessEnvironment=C;function D(P){!P||(delete P.DEBUG,I.isMacintosh&&delete P.DYLD_LIBRARY_PATH,I.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(ee[70],te([0,1,4]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=I.globals.performance&&typeof I.globals.performance.now=="function";class n{static create(D=!0){return new n(D)}constructor(D){this.a=R&&D,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?I.globals.performance.now():Date.now()}}e.StopWatch=n}),define(ee[3],te([0,1,13,49,2,98,70]),function(x,e,I,R,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,d=!1;var h;(function(l){l.None=()=>n.Disposable.None;function o(U){if(d){const{onDidAddListener:B}=U,q=p.create();let N=0;U.onDidAddListener=()=>{++N===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),q.print()),B?.()}}}function f(U,B){return re(U,()=>{},0,void 0,void 0,B)}l.defer=f;function y(U){return(B,q=null,N)=>{let $=!1,J;return J=U(oe=>{if(!$)return J?J.dispose():$=!0,B.call(q,oe)},null,N),$&&J.dispose(),J}}l.once=y;function M(U,B,q){return ne((N,$=null,J)=>U(oe=>N.call($,B(oe)),null,J),q)}l.map=M;function O(U,B,q){return ne((N,$=null,J)=>U(oe=>{B(oe),N.call($,oe)},null,J),q)}l.forEach=O;function j(U,B,q){return ne((N,$=null,J)=>U(oe=>B(oe)&&N.call($,oe),null,J),q)}l.filter=j;function G(U){return U}l.signal=G;function H(...U){return(B,q=null,N)=>(0,n.combinedDisposable)(...U.map($=>$(J=>B.call(q,J),null,N)))}l.any=H;function K(U,B,q,N){let $=q;return M(U,J=>($=B($,J),$),N)}l.reduce=K;function ne(U,B){let q;const N={onWillAddFirstListener(){q=U($.fire,$)},onDidRemoveLastListener(){q?.dispose()}};B||o(N);const $=new a(N);return B?.add($),$.event}function re(U,B,q=100,N=!1,$,J){let oe,le,be,Le=0;const Te={leakWarningThreshold:$,onWillAddFirstListener(){oe=U(pe=>{Le++,le=B(le,pe),N&&!be&&(Ae.fire(le),le=void 0);const ve=()=>{const Ce=le;le=void 0,be=void 0,(!N||Le>1)&&Ae.fire(Ce),Le=0};typeof q=="number"?(clearTimeout(be),be=setTimeout(ve,q)):be===void 0&&(be=0,queueMicrotask(ve))})},onDidRemoveLastListener(){oe.dispose()}};J||o(Te);const Ae=new a(Te);return J?.add(Ae),Ae.event}l.debounce=re;function ae(U,B=0,q){return l.debounce(U,(N,$)=>N?(N.push($),N):[$],B,void 0,void 0,q)}l.accumulate=ae;function fe(U,B=(N,$)=>N===$,q){let N=!0,$;return j(U,J=>{const oe=N||!B(J,$);return N=!1,$=J,oe},q)}l.latch=fe;function ge(U,B,q){return[l.filter(U,B,q),l.filter(U,N=>!B(N),q)]}l.split=ge;function V(U,B=!1,q=[]){let N=q.slice(),$=U(le=>{N?N.push(le):oe.fire(le)});const J=()=>{N?.forEach(le=>oe.fire(le)),N=null},oe=new a({onWillAddFirstListener(){$||($=U(le=>oe.fire(le)))},onDidAddFirstListener(){N&&(B?setTimeout(J):J())},onDidRemoveLastListener(){$&&$.dispose(),$=null}});return oe.event}l.buffer=V;class F{constructor(B){this.event=B,this.c=new n.DisposableStore}map(B){return new F(M(this.event,B,this.c))}forEach(B){return new F(O(this.event,B,this.c))}filter(B){return new F(j(this.event,B,this.c))}reduce(B,q){return new F(K(this.event,B,q,this.c))}latch(){return new F(fe(this.event,void 0,this.c))}debounce(B,q=100,N=!1,$){return new F(re(this.event,B,q,N,$,this.c))}on(B,q,N){return this.event(B,q,N)}once(B,q,N){return y(this.event)(B,q,N)}dispose(){this.c.dispose()}}function W(U){return new F(U)}l.chain=W;function z(U,B,q=N=>N){const N=(...le)=>oe.fire(q(...le)),$=()=>U.on(B,N),J=()=>U.removeListener(B,N),oe=new a({onWillAddFirstListener:$,onDidRemoveLastListener:J});return oe.event}l.fromNodeEventEmitter=z;function X(U,B,q=N=>N){const N=(...le)=>oe.fire(q(...le)),$=()=>U.addEventListener(B,N),J=()=>U.removeEventListener(B,N),oe=new a({onWillAddFirstListener:$,onDidRemoveLastListener:J});return oe.event}l.fromDOMEventEmitter=X;function ie(U){return new Promise(B=>y(U)(B))}l.toPromise=ie;function se(U,B){return B(void 0),U(q=>B(q))}l.runAndSubscribe=se;function Q(U,B){let q=null;function N(J){q?.dispose(),q=new n.DisposableStore,B(J,q)}N(void 0);const $=U(J=>N(J));return(0,n.toDisposable)(()=>{$.dispose(),q?.dispose()})}l.runAndSubscribeWithStore=Q;class A{constructor(B,q){this.obs=B,this.c=0,this.d=!1;const N={onWillAddFirstListener:()=>{B.addObserver(this)},onDidRemoveLastListener:()=>{B.removeObserver(this)}};q||o(N),this.emitter=new a(N),q&&q.add(this.emitter)}beginUpdate(B){this.c++}handleChange(B,q){this.d=!0}endUpdate(B){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function T(U,B){return new A(U,B).emitter.event}l.fromObservable=T})(h=e.Event||(e.Event={}));class S{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${S.c++}`,S.all.add(this)}start(o){this.d=new D.StopWatch(!0),this.listenerCount=o}stop(){if(this.d){const o=this.d.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=S,S.all=new Set,S.c=0;let v=-1;function b(l){const o=v;return v=l,{dispose(){v=o}}}e.setGlobalLeakWarningThreshold=b;class g{constructor(o,f=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=f,this.d=0}dispose(){this.c?.clear()}check(o,f){const y=this.threshold;if(y<=0||f<y)return;this.c||(this.c=new Map);const M=this.c.get(o.value)||0;if(this.c.set(o.value,M+1),this.d-=1,this.d<=0){this.d=y*.5;let O,j=0;for(const[G,H]of this.c)(!O||j<H)&&(O=G,j=H);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${j}):`),console.warn(O)}return()=>{const O=this.c.get(o.value)||0;this.c.set(o.value,O-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w{constructor(o,f,y){this.callback=o,this.callbackThis=f,this.stack=y,this.subscription=new n.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class a{constructor(o){this.j=!1,this.d=o,this.f=v>0||this.d?.leakWarningThreshold?new g(this.d?.leakWarningThreshold??v):void 0,this.g=this.d?._profName?new S(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const o=Array.from(this.q);queueMicrotask(()=>{for(const f of o)f.subscription.isset()&&(f.subscription.unset(),f.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(o,f,y)=>{if(this.q||(this.q=new C.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.Disposable.None;const M=this.q.isEmpty();M&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,j;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(j=p.create(),O=this.f.check(j,this.q.size+1)),P&&(j=j??p.create());const G=new w(o,f,j),H=this.q.push(G);M&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,o,f);const K=G.subscription.set(()=>{O?.(),this.j||(H(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return y instanceof n.DisposableStore?y.add(K):Array.isArray(y)&&y.push(K),K}),this.l}fire(o){if(this.q){this.m||(this.m=new m);for(const f of this.q)this.m.push(this,f,o);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=a;class u{constructor(){this.c=new C.LinkedList}get size(){return this.c.size}push(o,f,y){this.c.push(new k(o,f,y))}clear(o){const f=new C.LinkedList;for(const y of this.c)y.emitter!==o&&f.push(y);this.c=f}deliver(){for(;this.c.size>0;){const o=this.c.shift();try{o.listener.invoke(o.event)}catch(f){(0,I.onUnexpectedError)(f)}}}}e.EventDeliveryQueue=u;class m extends u{clear(o){this.c.clear()}}class k{constructor(o,f,y){this.emitter=o,this.listener=f,this.event=y}}class E extends a{async fireAsync(o,f,y){if(!!this.q){this.c||(this.c=new C.LinkedList);for(const M of this.q)this.c.push([M,o]);for(;this.c.size>0&&!f.isCancellationRequested;){const[M,O]=this.c.shift(),j=[],G={...O,token:f,waitUntil:H=>{if(Object.isFrozen(j))throw new Error("waitUntil can NOT be called asynchronous");y&&(H=y(H,M.callback)),j.push(H)}};try{M.invoke(G)}catch(H){(0,I.onUnexpectedError)(H);continue}Object.freeze(j),await Promise.allSettled(j).then(H=>{for(const K of H)K.status==="rejected"&&(0,I.onUnexpectedError)(K.reason)})}}}}e.AsyncEmitter=E;class L extends a{constructor(o){super(o),this.h=0,this.s=new C.LinkedList,this.t=o?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const o=Array.from(this.s);this.s.clear(),super.fire(this.t(o))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(o){this.q&&(this.h!==0?this.s.push(o):super.fire(o))}}e.PauseableEmitter=L;class t extends L{constructor(o){super(o),this.c=o.delay??100}fire(o){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(o)}}e.DebounceEmitter=t;class c extends a{constructor(o){super(o),this.c=[],this.h=o?.merge}fire(o){!this.hasListeners()||(this.c.push(o),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(f=>super.fire(f)),this.c=[]}))}}e.MicrotaskEmitter=c;class i{constructor(){this.d=!1,this.f=[],this.c=new a({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(o){const f={event:o,listener:null};this.f.push(f),this.d&&this.j(f);const y=()=>{this.d&&this.k(f);const M=this.f.indexOf(f);this.f.splice(M,1)};return(0,n.toDisposable)((0,R.once)(y))}g(){this.d=!0,this.f.forEach(o=>this.j(o))}h(){this.d=!1,this.f.forEach(o=>this.k(o))}j(o){o.listener=o.event(f=>this.c.fire(f))}k(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class r{constructor(){this.c=[]}wrapEvent(o){return(f,y,M)=>o(O=>{const j=this.c[this.c.length-1];j?j.push(()=>f.call(y,O)):f.call(y,O)},void 0,M)}bufferEvents(o){const f=[];this.c.push(f);const y=o();return this.c.pop(),f.forEach(M=>M()),y}}e.EventBufferer=r;class s{constructor(){this.c=!1,this.d=h.None,this.f=n.Disposable.None,this.g=new a({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(o){this.d=o,this.c&&(this.f.dispose(),this.f=o(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(ee[22],te([0,1,3]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(P,d){const h=setTimeout(P.bind(d),0);return{dispose(){clearTimeout(h)}}});var n;(function(P){function d(h){return h===P.None||h===P.Cancelled||h instanceof C?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}P.isCancellationToken=d,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(n=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new I.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(d){this.a=void 0,this.b=void 0,this.b=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new C),this.a}cancel(){this.a?this.a instanceof C&&this.a.cancel():this.a=n.Cancelled}dispose(d=!1){d&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof C&&this.a.dispose():this.a=n.None}}e.CancellationTokenSource=D}),define(ee[143],te([0,1,22]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class R{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new I.CancellationTokenSource,d=this.b(P.token);return this.a={promise:d,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=R;class n{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const d=JSON.stringify(P);return this.b!==d&&(this.b=d,this.a=this.c(P)),this.a}}e.LRUCachedFunction=n;class C{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const d=this.b(P);return this.a.set(P,d),d}}e.CachedFunction=C}),define(ee[27],te([0,1,143,126]),function(x,e,I,R){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=C;const D=/{(\d+)}/g;function P(Y,...ce){return ce.length===0?Y:Y.replace(D,function(he,me){const ye=parseInt(me,10);return isNaN(ye)||ye<0||ye>=ce.length?he:ce[ye]})}e.format=P;const d=/{([^}]+)}/g;function h(Y,ce){return Y.replace(d,(he,me)=>ce[me]??he)}e.format2=h;function S(Y){return Y.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=S;function v(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=v;function b(Y,ce){let he=0;const me=ce.charCodeAt(0);for(let ye=Y.length-1;ye>=0;ye--)Y.charCodeAt(ye)===me&&he++;return he}e.count=b;function g(Y,ce,he="\u2026"){return Y.length<=ce?Y:`${Y.substr(0,ce)}${he}`}e.truncate=g;function p(Y,ce=" "){const he=w(Y,ce);return a(he,ce)}e.trim=p;function w(Y,ce){if(!Y||!ce)return Y;const he=ce.length;if(he===0||Y.length===0)return Y;let me=0;for(;Y.indexOf(ce,me)===me;)me=me+he;return Y.substring(me)}e.ltrim=w;function a(Y,ce){if(!Y||!ce)return Y;const he=ce.length,me=Y.length;if(he===0||me===0)return Y;let ye=me,Oe=-1;for(;Oe=Y.lastIndexOf(ce,ye-1),!(Oe===-1||Oe+he!==ye);){if(Oe===0)return"";ye=Oe}return Y.substring(0,ye)}e.rtrim=a;function u(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function m(Y){return Y.replace(/\*/g,"")}e.stripWildcards=m;function k(Y,ce,he={}){if(!Y)throw new Error("Cannot create regex from empty string");ce||(Y=v(Y)),he.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let me="";return he.global&&(me+="g"),he.matchCase||(me+="i"),he.multiline&&(me+="m"),he.unicode&&(me+="u"),new RegExp(Y,me)}e.createRegExp=k;function E(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function L(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=L;function t(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=t;function c(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=c;function i(Y){for(let ce=0,he=Y.length;ce<he;ce++){const me=Y.charCodeAt(ce);if(me!==32&&me!==9)return ce}return-1}e.firstNonWhitespaceIndex=i;function r(Y,ce=0,he=Y.length){for(let me=ce;me<he;me++){const ye=Y.charCodeAt(me);if(ye!==32&&ye!==9)return Y.substring(ce,me)}return Y.substring(ce,he)}e.getLeadingWhitespace=r;function s(Y,ce=Y.length-1){for(let he=ce;he>=0;he--){const me=Y.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.lastNonWhitespaceIndex=s;function l(Y,ce,he){const me=[];let ye=0;for(const Oe of Y.matchAll(ce)){if(me.push(Y.slice(ye,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");ye=Oe.index+Oe[0].length,me.push(he(Oe[0],...Oe.slice(1),Oe.index,Y,Oe.groups))}return me.push(Y.slice(ye)),Promise.all(me).then(Oe=>Oe.join(""))}e.replaceAsync=l;function o(Y,ce){return Y<ce?-1:Y>ce?1:0}e.compare=o;function f(Y,ce,he=0,me=Y.length,ye=0,Oe=ce.length){for(;he<me&&ye<Oe;he++,ye++){const Qe=Y.charCodeAt(he),Ge=ce.charCodeAt(ye);if(Qe<Ge)return-1;if(Qe>Ge)return 1}const $e=me-he,tt=Oe-ye;return $e<tt?-1:$e>tt?1:0}e.compareSubstring=f;function y(Y,ce){return M(Y,ce,0,Y.length,0,ce.length)}e.compareIgnoreCase=y;function M(Y,ce,he=0,me=Y.length,ye=0,Oe=ce.length){for(;he<me&&ye<Oe;he++,ye++){let Qe=Y.charCodeAt(he),Ge=ce.charCodeAt(ye);if(Qe===Ge)continue;if(Qe>=128||Ge>=128)return f(Y.toLowerCase(),ce.toLowerCase(),he,me,ye,Oe);j(Qe)&&(Qe-=32),j(Ge)&&(Ge-=32);const et=Qe-Ge;if(et!==0)return et}const $e=me-he,tt=Oe-ye;return $e<tt?-1:$e>tt?1:0}e.compareSubstringIgnoreCase=M;function O(Y){return Y>=48&&Y<=57}e.isAsciiDigit=O;function j(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=j;function G(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=G;function H(Y,ce){return Y.length===ce.length&&M(Y,ce)===0}e.equalsIgnoreCase=H;function K(Y,ce){const he=ce.length;return ce.length>Y.length?!1:M(Y,ce,0,he)===0}e.startsWithIgnoreCase=K;function ne(Y,ce){const he=Math.min(Y.length,ce.length);let me;for(me=0;me<he;me++)if(Y.charCodeAt(me)!==ce.charCodeAt(me))return me;return he}e.commonPrefixLength=ne;function re(Y,ce){const he=Math.min(Y.length,ce.length);let me;const ye=Y.length-1,Oe=ce.length-1;for(me=0;me<he;me++)if(Y.charCodeAt(ye-me)!==ce.charCodeAt(Oe-me))return me;return he}e.commonSuffixLength=re;function ae(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=ae;function fe(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=fe;function ge(Y,ce){return(Y-55296<<10)+(ce-56320)+65536}e.computeCodePoint=ge;function V(Y,ce,he){const me=Y.charCodeAt(he);if(ae(me)&&he+1<ce){const ye=Y.charCodeAt(he+1);if(fe(ye))return ge(me,ye)}return me}e.getNextCodePoint=V;function F(Y,ce){const he=Y.charCodeAt(ce-1);if(fe(he)&&ce>1){const me=Y.charCodeAt(ce-2);if(ae(me))return ge(me,he)}return he}class W{get offset(){return this.e}constructor(ce,he=0){this.c=ce,this.d=ce.length,this.e=he}setOffset(ce){this.e=ce}prevCodePoint(){const ce=F(this.c,this.e);return this.e-=ce>=65536?2:1,ce}nextCodePoint(){const ce=V(this.c,this.d,this.e);return this.e+=ce>=65536?2:1,ce}eol(){return this.e>=this.d}}e.CodePointIterator=W;class z{get offset(){return this.c.offset}constructor(ce,he=0){this.c=new W(ce,he)}nextGraphemeLength(){const ce=We.getInstance(),he=this.c,me=he.offset;let ye=ce.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Oe=he.offset,$e=ce.getGraphemeBreakType(he.nextCodePoint());if(Pe(ye,$e)){he.setOffset(Oe);break}ye=$e}return he.offset-me}prevGraphemeLength(){const ce=We.getInstance(),he=this.c,me=he.offset;let ye=ce.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Oe=he.offset,$e=ce.getGraphemeBreakType(he.prevCodePoint());if(Pe($e,ye)){he.setOffset(Oe);break}ye=$e}return me-he.offset}eol(){return this.c.eol()}}e.GraphemeIterator=z;function X(Y,ce){return new z(Y,ce).nextGraphemeLength()}e.nextCharLength=X;function ie(Y,ce){return new z(Y,ce).prevGraphemeLength()}e.prevCharLength=ie;function se(Y,ce){ce>0&&fe(Y.charCodeAt(ce))&&ce--;const he=ce+X(Y,ce);return[he-ie(Y,he),he]}e.getCharContainingOffset=se;function Q(Y){const ce=new z(Y);let he=0;for(;!ce.eol();)he++,ce.nextGraphemeLength();return he}e.charCount=Q;let A;function T(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(Y){return A||(A=T()),A.test(Y)}e.containsRTL=U;const B=/^[\t\n\r\x20-\x7E]*$/;function q(Y){return B.test(Y)}e.isBasicASCII=q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function N(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=N;function $(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=$;function J(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}e.isEmojiImprecise=J;function oe(Y,ce){if(Y.length<ce)return Y;const he=/\b/g;let me=0;for(;he.test(Y)&&!(Y.length-he.lastIndex<ce);)me=he.lastIndex,he.lastIndex+=1;return Y.substring(me).replace(/^\s/,"")}e.lcut=oe;const le=/\x1B\x5B[12]?K/g,be=/\x1b\[\d+m/g,Le=/\x1b\[0?m/g;function Te(Y){return Y&&(Y=Y.replace(le,""),Y=Y.replace(be,""),Y=Y.replace(Le,"")),Y}e.removeAnsiEscapeCodes=Te,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ae(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ae;function pe(Y){return Ae(Y)?Y.substr(1):Y}e.stripUTF8BOM=pe;function ve(Y,ce){if(!Y||!ce||Y.length<ce.length)return!1;const he=ce.length,me=Y.toLowerCase();let ye=0,Oe=-1;for(;ye<he;){const $e=me.indexOf(ce[ye],Oe+1);if($e<0)return!1;Oe=$e,ye++}return!0}e.fuzzyContains=ve;function Ce(Y,ce=!1){return Y?(ce&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=Ce;function Me(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Me;function Z(Y,ce=1){if(ce===0)return"";let he=-1;do he=Y.indexOf(`
`,he+1),ce--;while(ce>0&&he>=0);return he===-1?Y:(Y[he-1]==="\r"&&he--,Y.substr(0,he))}e.getNLines=Z;function ue(Y){return Y=Y%(2*26),Y<26?String.fromCharCode(97+Y):String.fromCharCode(65+Y-26)}e.singleLetterHash=ue;function de(Y){return We.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=de;function Pe(Y,ce){return Y===0?ce!==5&&ce!==7:Y===2&&ce===3?!1:Y===4||Y===2||Y===3||ce===4||ce===2||ce===3?!0:!(Y===8&&(ce===8||ce===9||ce===11||ce===12)||(Y===11||Y===9)&&(ce===9||ce===10)||(Y===12||Y===10)&&ce===10||ce===5||ce===13||ce===7||Y===1||Y===13&&ce===14||Y===6&&ce===6)}var Re;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{static getInstance(){return We.c||(We.c=new We),We.c}constructor(){this.d=Fe()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const he=this.d,me=he.length/3;let ye=1;for(;ye<=me;)if(ce<he[3*ye])ye=2*ye;else if(ce>he[3*ye+1])ye=2*ye+1;else return he[3*ye+2];return 0}}We.c=null;function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Y,ce){if(Y===0)return 0;const he=Ue(Y,ce);if(he!==void 0)return he;const me=new W(ce,Y);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=He;function Ue(Y,ce){const he=new W(ce,Y);let me=he.prevCodePoint();for(;qe(me)||me===65039||me===8419;){if(he.offset===0)return;me=he.prevCodePoint()}if(!J(me))return;let ye=he.offset;return ye>0&&he.prevCodePoint()===8205&&(ye=he.offset),ye}function qe(Y){return 127995<=Y&&Y<=127999}var Ke;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Ke||(Ke={})),e.noBreakWhitespace="\xA0";class Be{static getInstance(ce){return Be.d.get(Array.from(ce))}static getLocales(){return Be.e.value}constructor(ce){this.f=ce}isAmbiguous(ce){return this.f.has(ce)}getPrimaryConfusable(ce){return this.f.get(ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=Be,n=Be,Be.c=new R.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.d=new I.LRUCachedFunction(Y=>{function ce(Ge){const et=new Map;for(let it=0;it<Ge.length;it+=2)et.set(Ge[it],Ge[it+1]);return et}function he(Ge,et){const it=new Map(Ge);for(const[ot,ut]of et)it.set(ot,ut);return it}function me(Ge,et){if(!Ge)return et;const it=new Map;for(const[ot,ut]of Ge)et.has(ot)&&it.set(ot,ut);return it}const ye=n.c.value;let Oe=Y.filter(Ge=>!Ge.startsWith("_")&&Ge in ye);Oe.length===0&&(Oe=["_default"]);let $e;for(const Ge of Oe){const et=ce(ye[Ge]);$e=me($e,et)}const tt=ce(ye._common),Qe=he(tt,$e);return new Be(Qe)}),Be.e=new R.Lazy(()=>Object.keys(Be.c.value).filter(Y=>!Y.startsWith("_")));class xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(xe.c())),this.d}static isInvisibleCharacter(ce){return xe.e().has(ce)}static get codePoints(){return xe.e()}}e.InvisibleCharacters=xe,xe.d=void 0}),define(ee[32],te([0,1,9,4,27,10]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(s){return s===47||s===92}e.isPathSeparator=D;function P(s){return s.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=P;function d(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=d;function h(s,l=I.posix.sep){if(!s)return"";const o=s.length,f=s.charCodeAt(0);if(D(f)){if(D(s.charCodeAt(1))&&!D(s.charCodeAt(2))){let M=3;const O=M;for(;M<o&&!D(s.charCodeAt(M));M++);if(O!==M&&!D(s.charCodeAt(M+1))){for(M+=1;M<o;M++)if(D(s.charCodeAt(M)))return s.slice(0,M+1).replace(/[\\/]/g,l)}}return l}else if(u(f)&&s.charCodeAt(1)===58)return D(s.charCodeAt(2))?s.slice(0,2)+l:s.slice(0,2);let y=s.indexOf("://");if(y!==-1){for(y+=3;y<o;y++)if(D(s.charCodeAt(y)))return s.slice(0,y+1)}return""}e.getRoot=h;function S(s){if(!R.isWindows||!s||s.length<5)return!1;let l=s.charCodeAt(0);if(l!==92||(l=s.charCodeAt(1),l!==92))return!1;let o=2;const f=o;for(;o<s.length&&(l=s.charCodeAt(o),l!==92);o++);return!(f===o||(l=s.charCodeAt(o+1),isNaN(l)||l===92))}e.isUNC=S;const v=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(s,l=R.isWindows){const o=l?v:b;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||l&&g.test(s)||s==="."||s===".."||l&&s[s.length-1]==="."||l&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=p;function w(s,l,o){const f=s===l;return!o||f?f:!s||!l?!1:(0,n.equalsIgnoreCase)(s,l)}e.isEqual=w;function a(s,l,o,f=I.sep){if(s===l)return!0;if(!s||!l||l.length>s.length)return!1;if(o){if(!(0,n.startsWithIgnoreCase)(s,l))return!1;if(l.length===s.length)return!0;let M=l.length;return l.charAt(l.length-1)===f&&M--,s.charAt(M)===f}return l.charAt(l.length-1)!==f&&(l+=f),s.indexOf(l)===0}e.isEqualOrParent=a;function u(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=u;function m(s,l){return R.isWindows&&s.endsWith(":")&&(s+=I.sep),(0,I.isAbsolute)(s)||(s=(0,I.join)(l,s)),s=(0,I.normalize)(s),R.isWindows?(s=(0,n.rtrim)(s,I.sep),s.endsWith(":")&&(s+=I.sep)):(s=(0,n.rtrim)(s,I.sep),s||(s=I.sep)),s}e.sanitizeFilePath=m;function k(s){const l=(0,I.normalize)(s);return R.isWindows?s.length>3?!1:E(l)&&(s.length===2||l.charCodeAt(2)===92):l===I.posix.sep}e.isRootOrDriveLetter=k;function E(s,l=R.isWindows){return l?u(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function L(s){return E(s)?s[0]:void 0}e.getDriveLetter=L;function t(s,l,o){return l.length>s.length?-1:s===l?0:(o&&(s=s.toLowerCase(),l=l.toLowerCase()),s.indexOf(l))}e.indexOfPath=t;function c(s){const l=s.split(":");let o,f,y;for(const M of l){const O=Number(M);(0,C.isNumber)(O)?f===void 0?f=O:y===void 0&&(y=O):o=o?[o,M].join(":"):M}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:f!==void 0?f:void 0,column:y!==void 0?y:f!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(s,l,o=8){let f="";for(let M=0;M<o;M++)f+=i.charAt(Math.floor(Math.random()*i.length));let y;return l?y=`${l}-${f}`:y=f,s?(0,I.join)(s,y):y}e.randomPath=r}),define(ee[71],te([0,1,27]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(u){return n(u,0)}e.hash=R;function n(u,m){switch(typeof u){case"object":return u===null?C(349,m):Array.isArray(u)?d(u,m):h(u,m);case"string":return P(u,m);case"boolean":return D(u,m);case"number":return C(u,m);case"undefined":return C(937,m);default:return C(617,m)}}e.doHash=n;function C(u,m){return(m<<5)-m+u|0}e.numberHash=C;function D(u,m){return C(u?433:863,m)}function P(u,m){m=C(149417,m);for(let k=0,E=u.length;k<E;k++)m=C(u.charCodeAt(k),m);return m}e.stringHash=P;function d(u,m){return m=C(104579,m),u.reduce((k,E)=>n(E,k),m)}function h(u,m){return m=C(181387,m),Object.keys(u).sort().reduce((k,E)=>(k=P(E,k),n(u[E],k)),m)}class S{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=n(m,this.g),this.g}}e.Hasher=S;var v;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function b(u,m,k=32){const E=k-m,L=~((1<<E)-1);return(u<<m|(L&u)>>>E)>>>0}function g(u,m=0,k=u.byteLength,E=0){for(let L=0;L<k;L++)u[m+L]=E}function p(u,m,k="0"){for(;u.length<m;)u=k+u;return u}function w(u,m=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(k=>k.toString(16).padStart(2,"0")).join(""):p((u>>>0).toString(16),m/4)}e.toHexString=w;class a{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const k=m.length;if(k===0)return;const E=this.p;let L=this.r,t=this.u,c,i;for(t!==0?(c=t,i=-1,t=0):(c=m.charCodeAt(0),i=0);;){let r=c;if(I.isHighSurrogate(c))if(i+1<k){const s=m.charCodeAt(i+1);I.isLowSurrogate(s)?(i++,r=I.computeCodePoint(c,s)):r=65533}else{t=c;break}else I.isLowSurrogate(c)&&(r=65533);if(L=this.w(E,L,r),i++,i<k)c=m.charCodeAt(i);else break}this.r=L,this.u=t}w(m,k,E){return E<128?m[k++]=E:E<2048?(m[k++]=192|(E&1984)>>>6,m[k++]=128|(E&63)>>>0):E<65536?(m[k++]=224|(E&61440)>>>12,m[k++]=128|(E&4032)>>>6,m[k++]=128|(E&63)>>>0):(m[k++]=240|(E&1835008)>>>18,m[k++]=128|(E&258048)>>>12,m[k++]=128|(E&4032)>>>6,m[k++]=128|(E&63)>>>0),k>=64&&(this.y(),k-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),k}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=a.g,k=this.q;for(let o=0;o<64;o+=4)m.setUint32(o,k.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)m.setUint32(o,b(m.getUint32(o-12,!1)^m.getUint32(o-32,!1)^m.getUint32(o-56,!1)^m.getUint32(o-64,!1),1),!1);let E=this.h,L=this.l,t=this.m,c=this.n,i=this.o,r,s,l;for(let o=0;o<80;o++)o<20?(r=L&t|~L&c,s=1518500249):o<40?(r=L^t^c,s=1859775393):o<60?(r=L&t|L&c|t&c,s=2400959708):(r=L^t^c,s=3395469782),l=b(E,5)+r+i+s+m.getUint32(o*4,!1)&4294967295,i=c,c=t,t=b(L,30),L=E,E=l;this.h=this.h+E&4294967295,this.l=this.l+L&4294967295,this.m=this.m+t&4294967295,this.n=this.n+c&4294967295,this.o=this.o+i&4294967295}}e.StringSHA1=a,a.g=new DataView(new ArrayBuffer(320))}),define(ee[83],te([0,1,27]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(n){n[n.Ignore=0]="Ignore",n[n.Info=1]="Info",n[n.Warning=2]="Warning",n[n.Error=3]="Error"})(R||(R={})),function(n){const C="error",D="warning",P="warn",d="info",h="ignore";function S(b){return b?I.equalsIgnoreCase(C,b)?n.Error:I.equalsIgnoreCase(D,b)||I.equalsIgnoreCase(P,b)?n.Warning:I.equalsIgnoreCase(d,b)?n.Info:n.Ignore:n.Ignore}n.fromValue=S;function v(b){switch(b){case n.Error:return C;case n.Warning:return D;case n.Info:return d;default:return h}}n.toString=v}(R||(R={})),e.default=R}),define(ee[60],te([0,1,25,27]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class n{constructor(){this.b="",this.c=0}reset(g){return this.b=g,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(g){const p=g.charCodeAt(0),w=this.b.charCodeAt(this.c);return p-w}value(){return this.b[this.c]}}e.StringIterator=n;class C{constructor(g=!0){this.e=g}reset(g){return this.b=g,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let g=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(g)this.c++;else break;else g=!1;return this}cmp(g){return this.e?(0,R.compareSubstring)(g,this.b,0,g.length,this.c,this.d):(0,R.compareSubstringIgnoreCase)(g,this.b,0,g.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=C;class D{constructor(g=!0,p=!0){this.f=g,this.g=p}reset(g){this.d=0,this.e=0,this.b=g,this.c=g.length;for(let p=g.length-1;p>=0;p--,this.c--){const w=this.b.charCodeAt(p);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let g=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(g)this.d++;else break;else g=!1}return this}cmp(g){return this.g?(0,R.compareSubstring)(g,this.b,0,g.length,this.d,this.e):(0,R.compareSubstringIgnoreCase)(g,this.b,0,g.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=D;var P;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(P||(P={}));class d{constructor(g,p){this.f=g,this.g=p,this.d=[],this.e=0}reset(g){return this.c=g,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(g)),this.b.reset(g.path),this.b.value()&&this.d.push(3)),this.g(g)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(g){if(this.d[this.e]===1)return(0,R.compareIgnoreCase)(g,this.c.scheme);if(this.d[this.e]===2)return(0,R.compareIgnoreCase)(g,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(g);if(this.d[this.e]===4)return(0,R.compare)(g,this.c.query);if(this.d[this.e]===5)return(0,R.compare)(g,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=d;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const g=this.right;return this.right=g.left,g.left=this,this.updateHeight(),g.updateHeight(),g}rotateRight(){const g=this.left;return this.left=g.right,g.right=this,this.updateHeight(),g.updateHeight(),g}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(S||(S={}));class v{static forUris(g=()=>!1,p=()=>!1){return new v(new d(g,p))}static forPaths(g=!1){return new v(new D(void 0,!g))}static forStrings(){return new v(new n)}static forConfigKeys(){return new v(new C)}constructor(g){this.b=g}clear(){this.c=void 0}fill(g,p){if(p){const w=p.slice(0);(0,I.shuffle)(w);for(const a of w)this.set(a,g)}else{const w=g.slice(0);(0,I.shuffle)(w);for(const a of w)this.set(a[0],a[1])}}set(g,p){const w=this.b.reset(g);let a;this.c||(this.c=new h,this.c.segment=w.value());const u=[];for(a=this.c;;){const k=w.cmp(a.segment);if(k>0)a.left||(a.left=new h,a.left.segment=w.value()),u.push([-1,a]),a=a.left;else if(k<0)a.right||(a.right=new h,a.right.segment=w.value()),u.push([1,a]),a=a.right;else if(w.hasNext())w.next(),a.mid||(a.mid=new h,a.mid.segment=w.value()),u.push([0,a]),a=a.mid;else break}const m=a.value;a.value=p,a.key=g;for(let k=u.length-1;k>=0;k--){const E=u[k][1];E.updateHeight();const L=E.balanceFactor();if(L<-1||L>1){const t=u[k][0],c=u[k+1][0];if(t===1&&c===1)u[k][1]=E.rotateLeft();else if(t===-1&&c===-1)u[k][1]=E.rotateRight();else if(t===1&&c===-1)E.right=u[k+1][1]=u[k+1][1].rotateRight(),u[k][1]=E.rotateLeft();else if(t===-1&&c===1)E.left=u[k+1][1]=u[k+1][1].rotateLeft(),u[k][1]=E.rotateRight();else throw new Error;if(k>0)switch(u[k-1][0]){case-1:u[k-1][1].left=u[k][1];break;case 1:u[k-1][1].right=u[k][1];break;case 0:u[k-1][1].mid=u[k][1];break}else this.c=u[0][1]}}return m}get(g){return this.d(g)?.value}d(g){const p=this.b.reset(g);let w=this.c;for(;w;){const a=p.cmp(w.segment);if(a>0)w=w.left;else if(a<0)w=w.right;else if(p.hasNext())p.next(),w=w.mid;else break}return w}has(g){const p=this.d(g);return!(p?.value===void 0&&p?.mid===void 0)}delete(g){return this.e(g,!1)}deleteSuperstr(g){return this.e(g,!0)}e(g,p){const w=this.b.reset(g),a=[];let u=this.c;for(;u;){const m=w.cmp(u.segment);if(m>0)a.push([-1,u]),u=u.left;else if(m<0)a.push([1,u]),u=u.right;else if(w.hasNext())w.next(),a.push([0,u]),u=u.mid;else break}if(!!u){if(p?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const m=this.f(u.right);if(m.key){const{key:k,value:E,segment:L}=m;this.e(m.key,!1),u.key=k,u.value=E,u.segment=L}}else{const m=u.left??u.right;if(a.length>0){const[k,E]=a[a.length-1];switch(k){case-1:E.left=m;break;case 0:E.mid=m;break;case 1:E.right=m;break}}else this.c=m}for(let m=a.length-1;m>=0;m--){const k=a[m][1];k.updateHeight();const E=k.balanceFactor();if(E>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),a[m][1]=k.rotateLeft()):E<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),a[m][1]=k.rotateRight()),m>0)switch(a[m-1][0]){case-1:a[m-1][1].left=a[m][1];break;case 1:a[m-1][1].right=a[m][1];break;case 0:a[m-1][1].mid=a[m][1];break}else this.c=a[0][1]}}}f(g){for(;g.left;)g=g.left;return g}findSubstr(g){const p=this.b.reset(g);let w=this.c,a;for(;w;){const u=p.cmp(w.segment);if(u>0)w=w.left;else if(u<0)w=w.right;else if(p.hasNext())p.next(),a=w.value||a,w=w.mid;else break}return w&&w.value||a}findSuperstr(g){return this.g(g,!1)}g(g,p){const w=this.b.reset(g);let a=this.c;for(;a;){const u=w.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(w.hasNext())w.next(),a=a.mid;else return a.mid?this.h(a.mid):p?a.value:void 0}}hasElementOrSubtree(g){return this.g(g,!0)!==void 0}forEach(g){for(const[p,w]of this)g(w,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(g){const p=[];return this.j(g,p),p[Symbol.iterator]()}j(g,p){!g||(g.left&&this.j(g.left,p),g.value&&p.push([g.key,g.value]),g.mid&&this.j(g.mid,p),g.right&&this.j(g.right,p))}_isBalanced(){const g=p=>{if(!p)return!0;const w=p.balanceFactor();return w<-1||w>1?!1:g(p.left)&&g(p.right)};return g(this.c)}}e.TernarySearchTree=v}),define(ee[7],te([0,1,9,4]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const n=/^\w[\w\d+.-]*$/,C=/^\//,D=/^\/\//;function P(i,r){if(!i.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!n.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!C.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(i,r){return!i&&!r?"file":i}function h(i,r){switch(i){case"https":case"http":case"file":r?r[0]!==v&&(r=v+r):r=v;break}return r}const S="",v="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(r){return r instanceof g?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,s,l,o,f,y=!1){typeof r=="object"?(this.scheme=r.scheme||S,this.authority=r.authority||S,this.path=r.path||S,this.query=r.query||S,this.fragment=r.fragment||S):(this.scheme=d(r,y),this.authority=s||S,this.path=h(this.scheme,l||S),this.query=o||S,this.fragment=f||S,P(this,y))}get fsPath(){return k(this,!1)}with(r){if(!r)return this;let{scheme:s,authority:l,path:o,query:f,fragment:y}=r;return s===void 0?s=this.scheme:s===null&&(s=S),l===void 0?l=this.authority:l===null&&(l=S),o===void 0?o=this.path:o===null&&(o=S),f===void 0?f=this.query:f===null&&(f=S),y===void 0?y=this.fragment:y===null&&(y=S),s===this.scheme&&l===this.authority&&o===this.path&&f===this.query&&y===this.fragment?this:new w(s,l,o,f,y)}static parse(r,s=!1){const l=b.exec(r);return l?new w(l[2]||S,c(l[4]||S),c(l[5]||S),c(l[7]||S),c(l[9]||S),s):new w(S,S,S,S,S)}static file(r){let s=S;if(R.isWindows&&(r=r.replace(/\\/g,v)),r[0]===v&&r[1]===v){const l=r.indexOf(v,2);l===-1?(s=r.substring(2),r=v):(s=r.substring(2,l),r=r.substring(l)||v)}return new w("file",s,r,S,S)}static from(r){const s=new w(r.scheme,r.authority,r.path,r.query,r.fragment);return P(s,!0),s}static joinPath(r,...s){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return R.isWindows&&r.scheme==="file"?l=g.file(I.win32.join(k(r,!0),...s)).path:l=I.posix.join(r.path,...s),r.with({path:l})}toString(r=!1){return E(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof g)return r;{const s=new w(r);return s._formatted=r.external,s._fsPath=r._sep===p?r.fsPath:null,s}}else return r}}e.URI=g;const p=R.isWindows?1:void 0;class w extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=k(this,!1)),this._fsPath}toString(r=!1){return r?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=p),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const a={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,r,s){let l,o=-1;for(let f=0;f<i.length;f++){const y=i.charCodeAt(f);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||r&&y===47||s&&y===91||s&&y===93||s&&y===58)o!==-1&&(l+=encodeURIComponent(i.substring(o,f)),o=-1),l!==void 0&&(l+=i.charAt(f));else{l===void 0&&(l=i.substr(0,f));const M=a[y];M!==void 0?(o!==-1&&(l+=encodeURIComponent(i.substring(o,f)),o=-1),l+=M):o===-1&&(o=f)}}return o!==-1&&(l+=encodeURIComponent(i.substring(o))),l!==void 0?l:i}function m(i){let r;for(let s=0;s<i.length;s++){const l=i.charCodeAt(s);l===35||l===63?(r===void 0&&(r=i.substr(0,s)),r+=a[l]):r!==void 0&&(r+=i[s])}return r!==void 0?r:i}function k(i,r){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?r?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,R.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=k;function E(i,r){const s=r?m:u;let l="",{scheme:o,authority:f,path:y,query:M,fragment:O}=i;if(o&&(l+=o,l+=":"),(f||o==="file")&&(l+=v,l+=v),f){let j=f.indexOf("@");if(j!==-1){const G=f.substr(0,j);f=f.substr(j+1),j=G.lastIndexOf(":"),j===-1?l+=s(G,!1,!1):(l+=s(G.substr(0,j),!1,!1),l+=":",l+=s(G.substr(j+1),!1,!0)),l+="@"}f=f.toLowerCase(),j=f.lastIndexOf(":"),j===-1?l+=s(f,!1,!0):(l+=s(f.substr(0,j),!1,!0),l+=f.substr(j))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const j=y.charCodeAt(1);j>=65&&j<=90&&(y=`/${String.fromCharCode(j+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const j=y.charCodeAt(0);j>=65&&j<=90&&(y=`${String.fromCharCode(j+32)}:${y.substr(2)}`)}l+=s(y,!0,!1)}return M&&(l+="?",l+=s(M,!1,!1)),O&&(l+="#",l+=r?O:u(O,!1,!1)),l}function L(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+L(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(i){return i.match(t)?i.replace(t,r=>L(r)):i}}),define(ee[144],te([0,1,7]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(h){const S=h;return S&&typeof S.type=="string"&&typeof S.severity=="string"}e.isRemoteConsoleLog=R;function n(h){const S=[];let v;try{const b=JSON.parse(h.arguments),g=b[b.length-1];g&&g.__$stack&&(b.pop(),v=g.__$stack),S.push(...b)}catch{S.push("Unable to log remote console arguments",h.arguments)}return{args:S,stack:v}}e.parse=n;function C(h){if(typeof h!="string")return C(n(h).stack);const S=h;if(S){const v=D(S),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(b&&b.length===4)return{uri:I.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=C;function D(h){if(!h)return h;const S=h.indexOf(`
`);return S===-1?h:h.substring(0,S)}function P(h,S){const{args:v,stack:b}=n(h),g=typeof v[0]=="string"&&v.length===1;let p=D(b);p&&(p=`(${p.trim()})`);let w=[];if(typeof v[0]=="string"?p&&g?w=[`%c[${S}] %c${v[0]} %c${p}`,d("blue"),d(""),d("grey")]:w=[`%c[${S}] %c${v[0]}`,d("blue"),d(""),...v.slice(1)]:w=[`%c[${S}]%`,d("blue"),...v],p&&!g&&w.push(p),typeof console[h.severity]!="function")throw new Error("Unknown console method");console[h.severity].apply(console,w)}e.log=P;function d(h){return`color: ${h}`}}),define(ee[72],te([0,1,17,27,7]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function C(h){return JSON.stringify(h,P)}e.stringify=C;function D(h){let S=JSON.parse(h);return S=d(S),S}e.parse=D;function P(h,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:(0,R.regExpFlags)(S)}:S}function d(h,S=0){if(!h||S>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return n.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 16:return new Date(h.source)}if(h instanceof I.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let v=0;v<h.length;++v)h[v]=d(h[v],S+1);else for(const v in h)Object.hasOwnProperty.call(h,v)&&(h[v]=d(h[v],S+1))}return h}e.revive=d}),define(ee[15],te([0,1,13,4,7]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var C;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebook="vscode-notebook",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractive="vscode-interactive",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm"})(C=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(S){this.d=S}setDelegate(S){this.e=S}setServerRootPath(S){this.f=`${S}/${C.vscodeRemoteResource}`}set(S,v,b){this.a[S]=v,this.b[S]=b}setConnectionToken(S,v){this.c[S]=v}getPreferredWebSchema(){return this.d}rewrite(S){if(this.e)try{return this.e(S)}catch(a){return I.onUnexpectedError(a),S}const v=S.authority;let b=this.a[v];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const g=this.b[v],p=this.c[v];let w=`path=${encodeURIComponent(S.path)}`;return typeof p=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),n.URI.from({scheme:R.isWeb?this.d:C.vscodeRemoteResource,authority:`${b}:${g}`,path:this.f,query:w})}}e.RemoteAuthorities=new D,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(S){const v=this.b(S,x);return this.uriToBrowserUri(v)}uriToBrowserUri(S){return S.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(S):S.scheme===C.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${C.vscodeFileResource}://${P.a}`)?S.with({scheme:C.vscodeFileResource,authority:S.authority||P.a,query:null,fragment:null}):S}asFileUri(S){const v=this.b(S,x);return this.uriToFileUri(v)}uriToFileUri(S){return S.scheme===C.vscodeFileResource?S.with({scheme:C.file,authority:S.authority!==P.a?S.authority:null,query:null,fragment:null}):S}b(S,v){return n.URI.isUri(S)?S:n.URI.parse(v.toUrl(S))}}P.a="vscode-app",e.FileAccess=new P;var d;(function(h){const S=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(S.get("3"));const v="vscode-coi";function b(p){let w;typeof p=="string"?w=new URL(p).searchParams:p instanceof URL?w=p.searchParams:n.URI.isUri(p)&&(w=new URL(p.toString(!0)).searchParams);const a=w?.get(v);if(!!a)return S.get(a)}h.getHeadersFromQuery=b;function g(p,w,a){if(!globalThis.crossOriginIsolated)return;const u=w&&a?"3":a?"2":"1";p instanceof URLSearchParams?p.set(v,u):p[v]=u}h.addSearchParam=g})(d=e.COI||(e.COI={}))}),define(ee[20],te([0,1,32,15,9,4,27,7]),function(x,e,I,R,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(g){return(0,P.uriToFsPath)(g,!0)}e.originalFSPath=d;class h{constructor(p){this.a=p}compare(p,w,a=!1){return p===w?0:(0,D.compare)(this.getComparisonKey(p,a),this.getComparisonKey(w,a))}isEqual(p,w,a=!1){return p===w?!0:!p||!w?!1:this.getComparisonKey(p,a)===this.getComparisonKey(w,a)}getComparisonKey(p,w=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,w,a=!1){if(p.scheme===w.scheme){if(p.scheme===R.Schemas.file)return I.isEqualOrParent(d(p),d(w),this.a(p))&&p.query===w.query&&(a||p.fragment===w.fragment);if((0,e.isEqualAuthority)(p.authority,w.authority))return I.isEqualOrParent(p.path,w.path,this.a(p),"/")&&p.query===w.query&&(a||p.fragment===w.fragment)}return!1}joinPath(p,...w){return P.URI.joinPath(p,...w)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return n.posix.basename(p.path)}extname(p){return n.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let w;return p.scheme===R.Schemas.file?w=P.URI.file(n.dirname(d(p))).path:(w=n.posix.dirname(p.path),p.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),w="/")),p.with({path:w})}normalizePath(p){if(!p.path.length)return p;let w;return p.scheme===R.Schemas.file?w=P.URI.file(n.normalize(d(p))).path:w=n.posix.normalize(p.path),p.with({path:w})}relativePath(p,w){if(p.scheme!==w.scheme||!(0,e.isEqualAuthority)(p.authority,w.authority))return;if(p.scheme===R.Schemas.file){const m=n.relative(d(p),d(w));return C.isWindows?I.toSlashes(m):m}let a=p.path||"/";const u=w.path||"/";if(this.a(p)){let m=0;for(const k=Math.min(a.length,u.length);m<k&&!(a.charCodeAt(m)!==u.charCodeAt(m)&&a.charAt(m).toLowerCase()!==u.charAt(m).toLowerCase());m++);a=u.substr(0,m)+a.substr(m)}return n.posix.relative(a,u)}resolvePath(p,w){if(p.scheme===R.Schemas.file){const a=P.URI.file(n.resolve(d(p),w));return p.with({authority:a.authority,path:a.path})}return w=I.toPosixPath(w),p.with({path:n.posix.resolve(p.path,w)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,w){return p===w||p!==void 0&&w!==void 0&&(0,D.equalsIgnoreCase)(p,w)}hasTrailingPathSeparator(p,w=n.sep){if(p.scheme===R.Schemas.file){const a=d(p);return a.length>I.getRoot(a).length&&a[a.length-1]===w}else{const a=p.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,w=n.sep){return(0,e.hasTrailingPathSeparator)(p,w)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,w=n.sep){let a=!1;if(p.scheme===R.Schemas.file){const u=d(p);a=u!==void 0&&u.length===I.getRoot(u).length&&u[u.length-1]===w}else{w="/";const u=p.path;a=u.length===1&&u.charCodeAt(u.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(p,w)?p.with({path:p.path+"/"}):p}}e.ExtUri=h,e.extUri=new h(()=>!1),e.extUriBiasedIgnorePathCase=new h(g=>g.scheme===R.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new h(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function S(g,p){const w=[];for(let a=0;a<g.length;a++){const u=p(g[a]);g.some((m,k)=>k===a?!1:(0,e.isEqualOrParent)(u,p(m)))||w.push(g[a])}return w}e.distinctParents=S;var v;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function p(w){const a=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(k=>{const[E,L]=k.split(":");E&&L&&a.set(E,L)});const m=w.path.substring(0,w.path.indexOf(";"));return m&&a.set(g.META_DATA_MIME,m),a}g.parseMetaData=p})(v=e.DataUri||(e.DataUri={}));function b(g,p,w){if(p){let a=g.path;return a&&a[0]!==n.posix.sep&&(a=n.posix.sep+a),g.with({scheme:w,authority:p,path:a})}return g.with({scheme:w})}e.toLocalResource=b}),define(ee[8],te([0,1,22,13,3,2,20,4,129]),function(x,e,I,R,n,C,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(Q){return!!Q&&typeof Q.then=="function"}e.isThenable=h;function S(Q){const A=new I.CancellationTokenSource,T=Q(A.token),U=new Promise((B,q)=>{const N=A.token.onCancellationRequested(()=>{N.dispose(),A.dispose(),q(new R.CancellationError)});Promise.resolve(T).then($=>{N.dispose(),A.dispose(),B($)},$=>{N.dispose(),A.dispose(),q($)})});return new class{cancel(){A.cancel()}then(B,q){return U.then(B,q)}catch(B){return this.then(void 0,B)}finally(B){return U.finally(B)}}}e.createCancelablePromise=S;function v(Q,A,T){return new Promise((U,B)=>{const q=A.onCancellationRequested(()=>{q.dispose(),U(T)});Q.then(U,B).finally(()=>q.dispose())})}e.raceCancellation=v;function b(Q,A){return new Promise((T,U)=>{const B=A.onCancellationRequested(()=>{B.dispose(),U(new R.CancellationError)});Q.then(T,U).finally(()=>B.dispose())})}e.raceCancellationError=b;async function g(Q){let A=-1;const T=Q.map((B,q)=>B.then(N=>(A=q,N))),U=await Promise.race(T);return Q.forEach((B,q)=>{q!==A&&B.cancel()}),U}e.raceCancellablePromises=g;function p(Q,A,T){let U;const B=setTimeout(()=>{U?.(void 0),T?.()},A);return Promise.race([Q.finally(()=>clearTimeout(B)),new Promise(q=>U=q)])}e.raceTimeout=p;function w(Q){return new Promise((A,T)=>{const U=Q();h(U)?U.then(A,T):A(U)})}e.asPromise=w;class a{constructor(){this.a=null,this.b=null,this.d=null}queue(A){if(this.a){if(this.d=A,!this.b){const T=()=>{this.b=null;const U=this.queue(this.d);return this.d=null,U};this.b=new Promise(U=>{this.a.then(T,T).then(U)})}return new Promise((T,U)=>{this.b.then(T,U)})}return this.a=A(),new Promise((T,U)=>{this.a.then(B=>{this.a=null,T(B)},B=>{this.a=null,U(B)})})}}e.Throttler=a;class u{constructor(){this.a=Promise.resolve(null)}queue(A){return this.a=this.a.then(()=>A(),()=>A())}}e.Sequencer=u;class m{constructor(){this.a=new Map}queue(A,T){const B=(this.a.get(A)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.a.get(A)===B&&this.a.delete(A)});return this.a.set(A,B),B}}e.SequencerByKey=m;const k=(Q,A)=>{let T=!0;const U=setTimeout(()=>{T=!1,A()},Q);return{isTriggered:()=>T,dispose:()=>{clearTimeout(U),T=!1}}},E=Q=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,Q())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};class L{constructor(A){this.defaultDelay=A,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(A,T=this.defaultDelay){this.g=A,this.h(),this.b||(this.b=new Promise((B,q)=>{this.d=B,this.f=q}).then(()=>{if(this.b=null,this.d=null,this.g){const B=this.g;return this.g=null,B()}}));const U=()=>{this.a=null,this.d?.(null)};return this.a=T===d.MicrotaskDelay?E(U):k(T,U),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=L;class t{constructor(A){this.a=new L(A),this.b=new a}trigger(A,T){return this.a.trigger(()=>this.b.queue(A),T)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class c{constructor(){this.a=!1,this.b=new Promise((A,T)=>{this.d=A})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=c;class i extends c{constructor(A){super(),this.f=setTimeout(()=>this.open(),A)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function r(Q,A){return A?new Promise((T,U)=>{const B=setTimeout(()=>{q.dispose(),T()},Q),q=A.onCancellationRequested(()=>{clearTimeout(B),q.dispose(),U(new R.CancellationError)})}):S(T=>r(Q,T))}e.timeout=r;function s(Q,A=0){const T=setTimeout(Q,A);return(0,C.toDisposable)(()=>clearTimeout(T))}e.disposableTimeout=s;function l(Q){const A=[];let T=0;const U=Q.length;function B(){return T<U?Q[T++]():null}function q(N){N!=null&&A.push(N);const $=B();return $?$.then(q):Promise.resolve(A)}return Promise.resolve(null).then(q)}e.sequence=l;function o(Q,A=U=>!!U,T=null){let U=0;const B=Q.length,q=()=>{if(U>=B)return Promise.resolve(T);const N=Q[U++];return Promise.resolve(N()).then(J=>A(J)?Promise.resolve(J):q())};return q()}e.first=o;function f(Q,A=U=>!!U,T=null){if(Q.length===0)return Promise.resolve(T);let U=Q.length;const B=()=>{U=-1;for(const q of Q)q.cancel?.()};return new Promise((q,N)=>{for(const $ of Q)$.then(J=>{--U>=0&&A(J)?(B(),q(J)):U===0&&q(T)}).catch(J=>{--U>=0&&(B(),N(J))})})}e.firstParallel=f;class y{constructor(A){this.a=0,this.d=A,this.f=[],this.b=0,this.g=new n.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(A){return this.a++,new Promise((T,U)=>{this.f.push({factory:A,c:T,e:U}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const A=this.f.shift();this.b++;const T=A.factory();T.then(A.c,A.e),T.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=y;class M extends y{constructor(){super(1)}}e.Queue=M;class O{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const A=new F;return this.b.add(A),A.p}d(){for(const[,A]of this.a)if(A.size>0)return!1;return!0}queueFor(A,T=D.extUri){const U=T.getComparisonKey(A);let B=this.a.get(U);return B||(B=new M,n.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(U),this.f()}),this.a.set(U,B)),B}f(){!this.d()||this.g()}g(){for(const A of this.b)A.complete();this.b.clear()}dispose(){for(const[,A]of this.a)A.dispose();this.a.clear(),this.g()}}e.ResourceQueue=O;class j{constructor(A,T){this.a=-1,typeof A=="function"&&typeof T=="number"&&this.setIfNotSet(A,T)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(A,T){this.cancel(),this.a=setTimeout(()=>{this.a=-1,A()},T)}setIfNotSet(A,T){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,A()},T))}}e.TimeoutTimer=j;class G{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(A,T){this.cancel(),this.a=setInterval(()=>{A()},T)}}e.IntervalTimer=G;class H{constructor(A,T){this.b=-1,this.a=A,this.d=T,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(A=this.d){this.cancel(),this.b=setTimeout(this.f,A)}get delay(){return this.d}set delay(A){this.d=A}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=H;class K{constructor(A,T){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.a=A,this.b=T,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(A=this.b){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(A/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=K;class ne extends H{constructor(A,T){super(A,T),this.j=[]}work(A){this.j.push(A),this.isScheduled()||this.schedule()}h(){const A=this.j;this.j=[],this.a?.(A)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=ne;class re extends C.Disposable{constructor(A,T){super(),this.g=A,this.h=T,this.a=[],this.b=this.B(new C.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(A){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+A.length>this.g.maxBufferedWork)return!1}else if(this.pending+A.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const T of A)this.a.push(T);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new H(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Q=>{(0,P.setTimeout0)(()=>{if(A)return;const T=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,T-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(Q,A)=>{const T=requestIdleCallback(Q,typeof A=="number"?{timeout:A}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(T))}}}}();class ae{constructor(A){this.d=!1,this.a=()=>{try{this.f=A()}catch(T){this.g=T}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=ae;async function fe(Q,A,T){let U;for(let B=0;B<T;B++)try{return await Q()}catch(q){U=q,await r(A)}throw U}e.retry=fe;class ge{hasPending(A){return this.a?typeof A=="number"?this.a.taskId===A:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(A,T,U){return this.a={taskId:A,cancel:()=>U?.(),promise:T},T.then(()=>this.d(A),()=>this.d(A)),T}d(A){this.a&&A===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const A=this.b;this.b=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this.b)this.b.run=A;else{let T,U;const B=new Promise((q,N)=>{T=q,U=N});this.b={run:A,promise:B,promiseResolve:T,promiseReject:U}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=ge;class V{constructor(A,T=()=>Date.now()){this.d=A,this.f=T,this.a=0,this.b=0}increment(){const A=this.f();return A-this.a>this.d&&(this.a=A,this.b=0),this.b++,this.b}}e.IntervalCounter=V;class F{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((A,T)=>{this.a=A,this.b=T})}complete(A){return new Promise(T=>{this.a(A),this.f=!0,T()})}error(A){return new Promise(T=>{this.b(A),this.d=!0,T()})}cancel(){new Promise(A=>{this.b(new R.CancellationError),this.d=!0,A()})}}e.DeferredPromise=F;var W;(function(Q){async function A(U){let B;const q=await Promise.all(U.map(N=>N.then($=>$,$=>{B||(B=$)})));if(typeof B<"u")throw B;return q}Q.settled=A;function T(U){return new Promise(async(B,q)=>{try{await U(B,q)}catch(N){q(N)}})}Q.withAsyncBody=T})(W=e.Promises||(e.Promises={}));var z;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(z||(z={}));class X{static fromArray(A){return new X(T=>{T.emitMany(A)})}static fromPromise(A){return new X(async T=>{T.emitMany(await A)})}static fromPromises(A){return new X(async T=>{await Promise.all(A.map(async U=>T.emitOne(await U)))})}static merge(A){return new X(async T=>{await Promise.all(A.map(async U=>{for await(const B of U)T.emitOne(B)}))})}constructor(A){this.a=0,this.b=[],this.d=null,this.f=new n.Emitter,queueMicrotask(async()=>{const T={emitOne:U=>this.g(U),emitMany:U=>this.h(U),reject:U=>this.k(U)};try{await Promise.resolve(A(T)),this.j()}catch(U){this.k(U)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(A<this.b.length)return{done:!1,value:this.b[A++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(A,T){return new X(async U=>{for await(const B of A)U.emitOne(T(B))})}map(A){return X.map(this,A)}static filter(A,T){return new X(async U=>{for await(const B of A)T(B)&&U.emitOne(B)})}filter(A){return X.filter(this,A)}static coalesce(A){return X.filter(A,T=>!!T)}coalesce(){return X.coalesce(this)}static async toPromise(A){const T=[];for await(const U of A)T.push(U);return T}toPromise(){return X.toPromise(this)}g(A){this.a===0&&(this.b.push(A),this.f.fire())}h(A){this.a===0&&(this.b=this.b.concat(A),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(A){this.a===0&&(this.a=2,this.d=A,this.f.fire())}}e.AsyncIterableObject=X,X.EMPTY=X.fromArray([]);class ie extends X{constructor(A,T){super(T),this.l=A}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ie;function se(Q){const A=new I.CancellationTokenSource,T=Q(A.token);return new ie(A,async U=>{const B=A.token.onCancellationRequested(()=>{B.dispose(),A.dispose(),U.reject(new R.CancellationError)});try{for await(const q of T){if(A.token.isCancellationRequested)return;U.emitOne(q)}B.dispose(),A.dispose()}catch(q){B.dispose(),A.dispose(),U.reject(q)}})}e.createCancelableAsyncIterable=se}),define(ee[101],te([0,1,25,8,32,35,9,4,27]),function(x,e,I,R,n,C,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function h(){return Object.create(null)}e.getEmptyExpression=h,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const S="[/\\\\]",v="[^/\\\\]",b=/\//g;function g(V,F){switch(V){case 0:return"";case 1:return`${v}*?`;default:return`(?:${S}|${v}+${S}${F?`|${S}${v}+`:""})*?`}}function p(V,F){if(!V)return[];const W=[];let z=!1,X=!1,ie="";for(const se of V){switch(se){case F:if(!z&&!X){W.push(ie),ie="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":X=!0;break;case"]":X=!1;break}ie+=se}return ie&&W.push(ie),W}e.splitGlobAware=p;function w(V){if(!V)return"";let F="";const W=p(V,e.GLOB_SPLIT);if(W.every(z=>z===e.GLOBSTAR))F=".*";else{let z=!1;W.forEach((X,ie)=>{if(X===e.GLOBSTAR){if(z)return;F+=g(2,ie===W.length-1)}else{let se=!1,Q="",A=!1,T="";for(const U of X){if(U!=="}"&&se){Q+=U;continue}if(A&&(U!=="]"||!T)){let B;U==="-"?B=U:(U==="^"||U==="!")&&!T?B="^":U===e.GLOB_SPLIT?B="":B=(0,d.escapeRegExpCharacters)(U),T+=B;continue}switch(U){case"{":se=!0;continue;case"[":A=!0;continue;case"}":{F+=`(?:${p(Q,",").map(N=>w(N)).join("|")})`,se=!1,Q="";break}case"]":{F+="["+T+"]",A=!1,T="";break}case"?":F+=v;continue;case"*":F+=g(1);continue;default:F+=(0,d.escapeRegExpCharacters)(U)}}ie<W.length-1&&(W[ie+1]!==e.GLOBSTAR||ie+2<W.length)&&(F+=S)}z=X===e.GLOBSTAR})}return F}const a=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,L=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new C.LRUCache(1e4),c=function(){return!1},i=function(){return null};function r(V,F){if(!V)return i;let W;typeof V!="string"?W=V.pattern:W=V,W=W.trim();const z=`${W}_${!!F.trimForExclusions}`;let X=t.get(z);if(X)return s(X,V);let ie;return a.test(W)?X=o(W.substr(4),W):(ie=u.exec(l(W,F)))?X=f(ie[1],W):(F.trimForExclusions?k:m).test(W)?X=y(W,F):(ie=E.exec(l(W,F)))?X=M(ie[1].substr(1),W,!0):(ie=L.exec(l(W,F)))?X=M(ie[1],W,!1):X=O(W),t.set(z,X),s(X,V)}function s(V,F){if(typeof F=="string")return V;const W=function(z,X){return(0,n.isEqualOrParent)(z,F.base,!P.isLinux)?V((0,d.ltrim)(z.substr(F.base.length),D.sep),X):null};return W.allBasenames=V.allBasenames,W.allPaths=V.allPaths,W.basenames=V.basenames,W.patterns=V.patterns,W}function l(V,F){return F.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function o(V,F){return function(W,z){return typeof W=="string"&&W.endsWith(V)?F:null}}function f(V,F){const W=`/${V}`,z=`\\${V}`,X=function(se,Q){return typeof se!="string"?null:Q?Q===V?F:null:se===V||se.endsWith(W)||se.endsWith(z)?F:null},ie=[V];return X.basenames=ie,X.patterns=[F],X.allBasenames=ie,X}function y(V,F){const W=fe(V.slice(1,-1).split(",").map(Q=>r(Q,F)).filter(Q=>Q!==i),V),z=W.length;if(!z)return i;if(z===1)return W[0];const X=function(Q,A){for(let T=0,U=W.length;T<U;T++)if(W[T](Q,A))return V;return null},ie=W.find(Q=>!!Q.allBasenames);ie&&(X.allBasenames=ie.allBasenames);const se=W.reduce((Q,A)=>A.allPaths?Q.concat(A.allPaths):Q,[]);return se.length&&(X.allPaths=se),X}function M(V,F,W){const z=D.sep===D.posix.sep,X=z?V:V.replace(b,D.sep),ie=D.sep+X,se=D.posix.sep+V;let Q;return W?Q=function(A,T){return typeof A=="string"&&(A===X||A.endsWith(ie)||!z&&(A===V||A.endsWith(se)))?F:null}:Q=function(A,T){return typeof A=="string"&&(A===X||!z&&A===V)?F:null},Q.allPaths=[(W?"*/":"./")+V],Q}function O(V){try{const F=new RegExp(`^${w(V)}$`);return function(W){return F.lastIndex=0,typeof W=="string"&&F.test(W)?V:null}}catch{return i}}function j(V,F,W){return!V||typeof F!="string"?!1:G(V)(F,void 0,W)}e.match=j;function G(V,F={}){if(!V)return c;if(typeof V=="string"||H(V)){const W=r(V,F);if(W===i)return c;const z=function(X,ie){return!!W(X,ie)};return W.allBasenames&&(z.allBasenames=W.allBasenames),W.allPaths&&(z.allPaths=W.allPaths),z}return re(V,F)}e.parse=G;function H(V){const F=V;return F?typeof F.base=="string"&&typeof F.pattern=="string":!1}e.isRelativePattern=H;function K(V){return V.allBasenames||[]}e.getBasenameTerms=K;function ne(V){return V.allPaths||[]}e.getPathTerms=ne;function re(V,F){const W=fe(Object.getOwnPropertyNames(V).map(Q=>ae(Q,V[Q],F)).filter(Q=>Q!==i)),z=W.length;if(!z)return i;if(!W.some(Q=>!!Q.requiresSiblings)){if(z===1)return W[0];const Q=function(U,B){let q;for(let N=0,$=W.length;N<$;N++){const J=W[N](U,B);if(typeof J=="string")return J;(0,R.isThenable)(J)&&(q||(q=[]),q.push(J))}return q?(async()=>{for(const N of q){const $=await N;if(typeof $=="string")return $}return null})():null},A=W.find(U=>!!U.allBasenames);A&&(Q.allBasenames=A.allBasenames);const T=W.reduce((U,B)=>B.allPaths?U.concat(B.allPaths):U,[]);return T.length&&(Q.allPaths=T),Q}const X=function(Q,A,T){let U,B;for(let q=0,N=W.length;q<N;q++){const $=W[q];$.requiresSiblings&&T&&(A||(A=(0,D.basename)(Q)),U||(U=A.substr(0,A.length-(0,D.extname)(Q).length)));const J=$(Q,A,U,T);if(typeof J=="string")return J;(0,R.isThenable)(J)&&(B||(B=[]),B.push(J))}return B?(async()=>{for(const q of B){const N=await q;if(typeof N=="string")return N}return null})():null},ie=W.find(Q=>!!Q.allBasenames);ie&&(X.allBasenames=ie.allBasenames);const se=W.reduce((Q,A)=>A.allPaths?Q.concat(A.allPaths):Q,[]);return se.length&&(X.allPaths=se),X}function ae(V,F,W){if(F===!1)return i;const z=r(V,W);if(z===i)return i;if(typeof F=="boolean")return z;if(F){const X=F.when;if(typeof X=="string"){const ie=(se,Q,A,T)=>{if(!T||!z(se,Q))return null;const U=X.replace("$(basename)",()=>A),B=T(U);return(0,R.isThenable)(B)?B.then(q=>q?V:null):B?V:null};return ie.requiresSiblings=!0,ie}}return z}function fe(V,F){const W=V.filter(Q=>!!Q.basenames);if(W.length<2)return V;const z=W.reduce((Q,A)=>{const T=A.basenames;return T?Q.concat(T):Q},[]);let X;if(F){X=[];for(let Q=0,A=z.length;Q<A;Q++)X.push(F)}else X=W.reduce((Q,A)=>{const T=A.patterns;return T?Q.concat(T):Q},[]);const ie=function(Q,A){if(typeof Q!="string")return null;if(!A){let U;for(U=Q.length;U>0;U--){const B=Q.charCodeAt(U-1);if(B===47||B===92)break}A=Q.substr(U)}const T=z.indexOf(A);return T!==-1?X[T]:null};ie.basenames=z,ie.patterns=X,ie.allBasenames=z;const se=V.filter(Q=>!Q.basenames);return se.push(ie),se}function ge(V,F){return(0,I.equals)(V,F,(W,z)=>typeof W=="string"&&typeof z=="string"?W===z:typeof W!="string"&&typeof z!="string"?W.base===z.base&&W.pattern===z.pattern:!1)}e.patternsEquals=ge}),define(ee[37],te([0,1,25,32,9,4,20,27]),function(x,e,I,R,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function d(i,r){const{os:s,tildify:l,relative:o}=r;if(o){const M=h(i,o,s);if(typeof M=="string")return M}let f=i.fsPath;if(s===1&&!C.isWindows?f=f.replace(/\//g,"\\"):s!==1&&C.isWindows&&(f=f.replace(/\\/g,"/")),s!==1&&l?.userHome){const M=l.userHome.fsPath;let O;i.scheme!==l.userHome.scheme&&i.path.startsWith(n.posix.sep)?O=l.userHome.with({path:i.path}).fsPath:O=i.fsPath,f=b(O,M,s)}return(s===1?n.win32:n.posix).normalize(S(f,s===1))}e.getPathLabel=d;function h(i,r,s){const l=s===1?n.win32:n.posix,o=s===3?D.extUri:D.extUriIgnorePathCase,f=r.getWorkspace(),y=(0,I.firstOrDefault)(f.folders);if(!y)return;i.scheme!==y.uri.scheme&&i.path.startsWith(n.posix.sep)&&(i=y.uri.with({path:i.path}));const M=r.getWorkspaceFolder(i);if(!M)return;let O;if(o.isEqual(M.uri,i)?O="":O=o.relativePath(M.uri,i)??"",O&&(O=l.normalize(O)),f.folders.length>1&&!r.noPrefix){const j=M.name?M.name:o.basenameOrAuthority(M.uri);O=O?`${j} \u2022 ${O}`:j}return O}function S(i,r=C.isWindows){return(0,R.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=S;let v=Object.create(null);function b(i,r,s=C.OS){if(s===1||!i||!r)return i;let l=v.original===r?v.normalized:void 0;l||(l=r,C.isWindows&&(l=(0,R.toSlashes)(l)),l=`${(0,P.rtrim)(l,n.posix.sep)}${n.posix.sep}`,v={original:r,normalized:l});let o=i;return C.isWindows&&(o=(0,R.toSlashes)(o)),(s===3?o.startsWith(l):(0,P.startsWithIgnoreCase)(o,l))?`~/${o.substr(l.length)}`:i}e.tildify=b;function g(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=g;const p="\u2026",w="\\\\",a="~";function u(i,r=n.sep){const s=new Array(i.length);let l=!1;for(let o=0;o<i.length;o++){const f=i[o];if(f===""){s[o]=`.${r}`;continue}if(!f){s[o]=f;continue}l=!0;let y="",M=f;M.indexOf(w)===0?(y=M.substr(0,M.indexOf(w)+w.length),M=M.substr(M.indexOf(w)+w.length)):M.indexOf(r)===0?(y=M.substr(0,M.indexOf(r)+r.length),M=M.substr(M.indexOf(r)+r.length)):M.indexOf(a)===0&&(y=M.substr(0,M.indexOf(a)+a.length),M=M.substr(M.indexOf(a)+a.length));const O=M.split(r);for(let j=1;l&&j<=O.length;j++)for(let G=O.length-j;l&&G>=0;G--){l=!1;let H=O.slice(G,G+j).join(r);for(let K=0;!l&&K<i.length;K++)if(K!==o&&i[K]&&i[K].indexOf(H)>-1){const ne=G+j===O.length,re=G>0&&i[K].indexOf(r)>-1?r+H:H,ae=i[K].endsWith(re);l=!ne||ae}if(!l){let K="";(O[0].endsWith(":")||y!=="")&&(G===1&&(G=0,j++,H=O[0]+r+H),G>0&&(K=O[0]+r),K=y+K),G>0&&(K=K+p+r),K=K+H,G+j<O.length&&(K=K+r+p),s[o]=K}}l&&(s[o]=f)}return s}e.shorten=u;var m;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function k(i,r=Object.create(null)){const s=[];let l=!1,o="";for(const f of i)if(f==="$"||l&&f==="{")o&&s.push({value:o,type:m.TEXT}),o="",l=!0;else if(f==="}"&&l){const y=r[o];if(typeof y=="string")y.length&&s.push({value:y,type:m.VARIABLE});else if(y){const M=s[s.length-1];(!M||M.type!==m.SEPARATOR)&&s.push({value:y.label,type:m.SEPARATOR})}o="",l=!1}else o+=f;return o&&!l&&s.push({value:o,type:m.TEXT}),s.filter((f,y)=>{if(f.type===m.SEPARATOR){const M=s[y-1],O=s[y+1];return[M,O].every(j=>j&&(j.type===m.VARIABLE||j.type===m.TEXT)&&j.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=k;function E(i,r){return C.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function L(i,r){return C.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,s=>s==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=L;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function c(i){const r=i.indexOf("/")!==-1?n.posix:n.win32,s=r.basename(i),l=r.dirname(i);return s.length?{name:s,parentPath:l}:{name:l,parentPath:""}}e.splitName=c}),define(ee[145],te([0,1,17,7]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(v){return v.toJSON()}class C{constructor(b){this.a=b}transformIncoming(b){const g=this.a.transformIncoming(b);return g===b?b:n(R.URI.from(g))}transformOutgoing(b){const g=this.a.transformOutgoing(b);return g===b?b:n(R.URI.from(g))}transformOutgoingURI(b){const g=this.a.transformOutgoing(b);return g===b?b:R.URI.from(g)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function D(v,b,g){if(!v||g>200)return null;if(typeof v=="object"){if(v instanceof R.URI)return b.transformOutgoing(v);for(const p in v)if(Object.hasOwnProperty.call(v,p)){const w=D(v[p],b,g+1);w!==null&&(v[p]=w)}}return null}function P(v,b){const g=D(v,b,0);return g===null?v:g}e.transformOutgoingURIs=P;function d(v,b,g,p){if(!v||p>200)return null;if(typeof v=="object"){if(v.$mid===1)return g?R.URI.revive(b.transformIncoming(v)):b.transformIncoming(v);if(v instanceof I.VSBuffer)return null;for(const w in v)if(Object.hasOwnProperty.call(v,w)){const a=d(v[w],b,g,p+1);a!==null&&(v[w]=a)}}return null}function h(v,b){const g=d(v,b,!1,0);return g===null?v:g}e.transformIncomingURIs=h;function S(v,b){const g=d(v,b,!0,0);return g===null?v:g}e.transformAndReviveIncomingURIs=S}),define(ee[84],te([0,1,26,13,60,31,133]),function(x,e,I,R,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(S){return this.a||(this.a=n.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(S)}value(){if(this.b===void 0){let S=0,v=0;const b=(0,I.networkInterfaces)();for(const g in b){const p=b[g];if(p)for(const{mac:w,internal:a}of p)a||(v+=1,this.c(w.toUpperCase())&&(S+=1))}this.b=v>0?S/v:0}return this.b}};let P;async function d(){return P||(P=(async()=>await h()||C.generateUuid())()),P}e.getMachineId=d;async function h(){try{const S=await new Promise((b,g)=>{x(["crypto"],b,g)}),v=(0,D.getMac)();return S.createHash("sha256").update(v,"utf8").digest("hex")}catch(S){R.onUnexpectedError(S);return}}}),define(ee[23],te([0,1,41,26,146,8,32,79,9,4,20,7]),function(x,e,I,R,n,C,D,P,d,h,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function g(re,ae=b.UNLINK){if((0,D.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");return ae===b.UNLINK?w(re):p(re)}async function p(re){try{const ae=(0,D.randomPath)((0,R.tmpdir)());try{await I.promises.rename(re,ae)}catch(fe){return fe.code==="ENOENT"?void 0:w(re)}w(ae).catch(fe=>{})}catch(ae){if(ae.code!=="ENOENT")throw ae}}async function w(re){return(0,n.promisify)(I.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function a(re){if((0,D.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=a;async function u(re,ae){return E(await(ae?m(re):(0,n.promisify)(I.readdir)(re)))}async function m(re){try{return await(0,n.promisify)(I.readdir)(re,{withFileTypes:!0})}catch(ge){console.warn("[node.js fs] readdir with filetypes failed with error: ",ge)}const ae=[],fe=await u(re);for(const ge of fe){let V=!1,F=!1,W=!1;try{const z=await e.Promises.lstat((0,d.join)(re,ge));V=z.isFile(),F=z.isDirectory(),W=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}ae.push({name:ge,isFile:()=>V,isDirectory:()=>F,isSymbolicLink:()=>W})}return ae}function k(re){return E(I.readdirSync(re))}e.readdirSync=k;function E(re){return re.map(ae=>typeof ae=="string"?h.isMacintosh?(0,P.normalizeNFC)(ae):ae:(ae.name=h.isMacintosh?(0,P.normalizeNFC)(ae.name):ae.name,ae))}async function L(re){const ae=await u(re),fe=[];for(const ge of ae)await c.existsDirectory((0,d.join)(re,ge))&&fe.push(ge);return fe}function t(re,ae=1e3){return new Promise(fe=>{let ge=!1;const V=setInterval(()=>{ge||(ge=!0,I.access(re,F=>{ge=!1,F&&(clearInterval(V),fe(void 0))}))},ae)})}e.whenDeleted=t;var c;(function(re){async function ae(V){let F;try{if(F=await e.Promises.lstat(V),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(h.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw z}throw W}}re.stat=ae;async function fe(V){try{const{stat:F,symbolicLink:W}=await re.stat(V);return F.isFile()&&W?.dangling!==!0}catch{}return!1}re.existsFile=fe;async function ge(V){try{const{stat:F,symbolicLink:W}=await re.stat(V);return F.isDirectory()&&W?.dangling!==!0}catch{}return!1}re.existsDirectory=ge})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new C.ResourceQueue;function r(re,ae,fe){return i.queueFor(v.URI.file(re),S.extUriBiasedIgnorePathCase).queue(()=>{const ge=y(fe);return new Promise((V,F)=>o(re,ae,ge,W=>W?F(W):V()))})}let s=!0;function l(re){s=re}e.configureFlushOnWrite=l;function o(re,ae,fe,ge){if(!s)return I.writeFile(re,ae,{mode:fe.mode,flag:fe.flag},ge);I.open(re,fe.flag,fe.mode,(V,F)=>{if(V)return ge(V);I.writeFile(F,ae,W=>{if(W)return I.close(F,()=>ge(W));I.fdatasync(F,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),l(!1)),I.close(F,X=>ge(X))))})})}function f(re,ae,fe){const ge=y(fe);if(!s)return I.writeFileSync(re,ae,{mode:ge.mode,flag:ge.flag});const V=I.openSync(re,ge.flag,ge.mode);try{I.writeFileSync(V,ae);try{I.fdatasyncSync(V)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),l(!1)}}finally{I.closeSync(V)}}e.writeFileSync=f;function y(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function M(re,ae){if(re!==ae)try{await e.Promises.rename(re,ae)}catch(fe){if(re.toLowerCase()!==ae.toLowerCase()&&fe.code==="EXDEV"||re.endsWith("."))await O(re,ae,{preserveSymlinks:!1}),await g(re,b.MOVE);else throw fe}}async function O(re,ae,fe){return G(re,ae,{root:{source:re,target:ae},options:fe,handledSourcePaths:new Set})}const j=511;async function G(re,ae,fe){if(fe.handledSourcePaths.has(re))return;fe.handledSourcePaths.add(re);const{stat:ge,symbolicLink:V}=await c.stat(re);if(V){if(fe.options.preserveSymlinks)try{return await ne(re,ae,fe)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(V.dangling)return}return ge.isDirectory()?H(re,ae,ge.mode&j,fe):K(re,ae,ge.mode&j)}async function H(re,ae,fe,ge){await e.Promises.mkdir(ae,{recursive:!0,mode:fe});const V=await u(re);for(const F of V)await G((0,d.join)(re,F),(0,d.join)(ae,F),ge)}async function K(re,ae,fe){await e.Promises.copyFile(re,ae),await e.Promises.chmod(ae,fe)}async function ne(re,ae,fe){let ge=await e.Promises.readlink(re);(0,D.isEqualOrParent)(ge,fe.root.source,!h.isLinux)&&(ge=(0,d.join)(fe.root.target,ge.substr(fe.root.source.length+1))),await e.Promises.symlink(ge,ae)}e.Promises=new class{get access(){return(0,n.promisify)(I.access)}get stat(){return(0,n.promisify)(I.stat)}get lstat(){return(0,n.promisify)(I.lstat)}get utimes(){return(0,n.promisify)(I.utimes)}get read(){return(re,ae,fe,ge,V)=>new Promise((F,W)=>{I.read(re,ae,fe,ge,V,(z,X,ie)=>z?W(z):F({bytesRead:X,buffer:ie}))})}get readFile(){return(0,n.promisify)(I.readFile)}get write(){return(re,ae,fe,ge,V)=>new Promise((F,W)=>{I.write(re,ae,fe,ge,V,(z,X,ie)=>z?W(z):F({bytesWritten:X,buffer:ie}))})}get appendFile(){return(0,n.promisify)(I.appendFile)}get fdatasync(){return(0,n.promisify)(I.fdatasync)}get truncate(){return(0,n.promisify)(I.truncate)}get rename(){return(0,n.promisify)(I.rename)}get copyFile(){return(0,n.promisify)(I.copyFile)}get open(){return(0,n.promisify)(I.open)}get close(){return(0,n.promisify)(I.close)}get symlink(){return(0,n.promisify)(I.symlink)}get readlink(){return(0,n.promisify)(I.readlink)}get chmod(){return(0,n.promisify)(I.chmod)}get mkdir(){return(0,n.promisify)(I.mkdir)}get unlink(){return(0,n.promisify)(I.unlink)}get rmdir(){return(0,n.promisify)(I.rmdir)}get realpath(){return(0,n.promisify)(I.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return L}get writeFile(){return r}get rm(){return g}get move(){return M}get copy(){return O}}}),define(ee[102],te([0,1,41,9,4,27,23]),function(x,e,I,R,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(b){if(n.isLinux)return b;const g=(0,R.dirname)(b);if(b===g)return b;const p=((0,R.basename)(b)||b).toLowerCase();try{const a=(0,D.readdirSync)(g).filter(u=>u.toLowerCase()===p);if(a.length===1){const u=P(g);if(u)return(0,R.join)(u,a[0])}else if(a.length>1){const u=a.indexOf(p);if(u>=0){const m=P(g);if(m)return(0,R.join)(m,a[u])}}}catch{}return null}e.realcaseSync=P;async function d(b){if(n.isLinux)return b;const g=(0,R.dirname)(b);if(b===g)return b;const p=((0,R.basename)(b)||b).toLowerCase();try{const a=(await D.Promises.readdir(g)).filter(u=>u.toLowerCase()===p);if(a.length===1){const u=await d(g);if(u)return(0,R.join)(u,a[0])}else if(a.length>1){const u=a.indexOf(p);if(u>=0){const m=await d(g);if(m)return(0,R.join)(m,a[u])}}}catch{}return null}e.realcase=d;async function h(b){try{return await D.Promises.realpath(b)}catch{const p=v(b);return await D.Promises.access(p,I.constants.R_OK),p}}e.realpath=h;function S(b){try{return I.realpathSync(b)}catch{const p=v(b);return I.accessSync(p,I.constants.R_OK),p}}e.realpathSync=S;function v(b){return(0,C.rtrim)((0,R.normalize)(b),R.sep)}}),define(ee[147],te([0,1,26,9,23]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,D=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var d;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(d||(d={}));let h;switch(process.arch){case"ia32":case"x32":h=1;break;case"arm":case"arm64":h=2;break;default:h=0;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=1:S=0;class v{constructor(L,t,c){this.exePath=L,this.displayName=t,this.a=c}async exists(){return this.a===void 0&&(this.a=await n.SymlinkSupport.existsFile(this.exePath)),this.a}}function b({useAlternateBitness:E=!1}={}){return E?h===0?process.env["ProgramFiles(x86)"]||null:S===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:E=!1,findPreview:L=!1}={}){const t=b({useAlternateBitness:E});if(!t)return null;const c=R.join(t,"PowerShell");if(!await n.SymlinkSupport.existsDirectory(c))return null;let i=-1,r=null;for(const o of await n.Promises.readdir(c)){let f=-1;if(L){const M=o.indexOf("-");if(M<0)continue;const O=o.substring(0,M);if(!C.test(O)||o.substring(M+1)!=="preview")continue;f=parseInt(O,10)}else{if(!C.test(o))continue;f=parseInt(o,10)}if(f<=i)continue;const y=R.join(c,o,"pwsh.exe");!await n.SymlinkSupport.existsFile(y)||(r=y,i=f)}if(!r)return null;const s=t.includes("x86")?" (x86)":"",l=L?" Preview":"";return new v(r,`PowerShell${l}${s}`,!0)}async function p({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const L=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await n.SymlinkSupport.existsDirectory(L))return null;const{pwshMsixDirRegex:t,pwshMsixName:c}=E?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await n.Promises.readdir(L))if(t.test(i)){const r=R.join(L,i,"pwsh.exe");return new v(r,c)}return null}function w(){const E=R.join(I.homedir(),".dotnet","tools","pwsh.exe");return new v(E,".NET Core PowerShell Global Tool")}function a(){const E=R.join(process.env.windir,h===1&&S!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(E,"Windows PowerShell",!0)}async function*u(){let E=await g();E&&(yield E),E=await g({useAlternateBitness:!0}),E&&(yield E),E=await p(),E&&(yield E),E=w(),E&&(yield E),E=await g({findPreview:!0}),E&&(yield E),E=await p({findPreview:!0}),E&&(yield E),E=await g({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=a(),E&&(yield E)}async function*m(){for await(const E of u())await E.exists()&&(yield E)}e.enumeratePowerShellInstallations=m;async function k(){for await(const E of m())return E;return null}e.getFirstAvailablePowerShellInstallation=k}),define(ee[85],te([0,1,9,4,36,82,10,23]),function(x,e,I,R,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function d(v=n.env){return v.comspec||"cmd.exe"}e.getWindowsShell=d;function h(v){let b=[],g=!1;const p=function(w){if(g){b.push(w);return}(!v.send(w,u=>{if(u&&console.error(u),g=!1,b.length>0){const m=b.slice(0);b=[],m.forEach(k=>p(k))}})||R.isWindows)&&(g=!0)};return{send:p}}e.createQueuedSender=h;var S;(function(v){async function b(g,p,w){if(I.isAbsolute(g))return g;if(p===void 0&&(p=n.cwd()),I.dirname(g)!=="."||(w===void 0&&D.isString(n.env.PATH)&&(w=n.env.PATH.split(I.delimiter)),w===void 0||w.length===0))return I.join(p,g);async function u(m){if(await P.Promises.exists(m)){let k;try{k=await P.Promises.stat(m)}catch(E){E.message.startsWith("EACCES")&&(k=await P.Promises.lstat(m))}return k?!k.isDirectory():!1}return!1}for(const m of w){let k;if(I.isAbsolute(m)?k=I.join(m,g):k=I.join(p,m,g),await u(k))return k;let E=k+".com";if(await u(E)||(E=k+".exe",await u(E)))return E}return I.join(p,g)}v.findExecutable=b})(S=e.win32||(e.win32={}))}),define(ee[103],te([0,1,46,15]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function n(D){return new Promise((P,d)=>{let h;const S=new Map;function v(g,p,w,a,u){const m=S.get(p);if(g===D||m){const k={name:b(w),cmd:w,pid:g,ppid:p,load:a,mem:u};S.set(g,k),g===D&&(h=k),m&&(m.children||(m.children=[]),m.children.push(k),m.children.length>1&&(m.children=m.children.sort((E,L)=>E.pid-L.pid)))}}function b(g){const p=/--vscode-window-kind=shared-process/,w=/--vscode-window-kind=issue-reporter/,a=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,m=/--utility-sub-type=node.mojom.NodeService/,k=/--crashes-directory/,E=/\\pipe\\winpty-control/,L=/conhost\.exe/,t=/--type=([a-zA-Z-]+)/;if(k.exec(g))return"electron-crash-reporter";if(E.exec(g))return"winpty-process";if(L.exec(g))return"console-window-host (Windows internal process)";let c=t.exec(g);if(c&&c.length===2){if(c[1]==="renderer")return p.exec(g)?"shared-process":w.exec(g)?"issue-reporter":a.exec(g)?"process-explorer":"window";if(c[1]==="utility"){if(u.exec(g))return"utility-network-service";if(m.exec(g))return"extension-host"}else if(c[1]==="extensionHost")return"extension-host";return c[1]}const i=/[a-zA-Z-]+\.js/g;let r="";do c=i.exec(g),c&&(r+=c+" ");while(c);return r&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${r}`:g}if(process.platform==="win32"){const g=p=>p.indexOf("\\\\?\\")===0||p.indexOf("\\??\\")===0?p.substr(4):p.indexOf('"\\\\?\\')===0||p.indexOf('"\\??\\')===0?'"'+p.substr(5):p;new Promise((p,w)=>{x(["windows-process-tree"],p,w)}).then(p=>{p.getProcessList(D,w=>{if(!w){d(new Error(`Root process ${D} not found`));return}p.getProcessCpuUsage(w,a=>{const u=new Map;a.forEach(m=>{const k=g(m.commandLine||"");u.set(m.pid,{name:b(k),cmd:k,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),h=u.get(D),h?(u.forEach(m=>{const k=u.get(m.ppid);k&&(k.children||(k.children=[]),k.children.push(m))}),u.forEach(m=>{m.children&&(m.children=m.children.sort((k,E)=>k.pid-E.pid))}),P(h)):d(new Error(`Root process ${D} not found`))})},p.ProcessDataFlag.CommandLine|p.ProcessDataFlag.Memory)})}else{let g=function(){let p=[h];const w=[];for(;p.length;){const u=p.shift();u&&(w.push(u.pid),u.children&&(p=p.concat(u.children)))}let a=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);a+=" "+w.join(" "),(0,I.exec)(a,{},(u,m,k)=>{if(u||k)d(u||new Error(k.toString()));else{const E=m.toString().split(`
`);for(let L=0;L<w.length;L++){const t=S.get(w[L]);t.load=parseFloat(E[L])}if(!h){d(new Error(`Root process ${D} not found`));return}P(h)}})};(0,I.exec)("which ps",{},(p,w,a)=>{if(p||a)if(process.platform!=="linux")d(p||new Error(a.toString()));else{const u=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(u,{},(m,k,E)=>{m||E?d(m||new Error(E.toString())):(C(k,v),g())})}else{const u=w.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${u} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(k,E,L)=>{k||L&&!L.includes("screen size is bogus")?d(k||new Error(L.toString())):(C(E,v),process.platform==="linux"?g():h?P(h):d(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=n;function C(D,P){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,h=D.toString().split(`
`);for(const S of h){const v=d.exec(S.trim());v&&v.length===6&&P(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(ee[148],te([0,1,26,4,147,85]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function D(v,b){return v===1?R.isWindows?S():C.getWindowsShell(b):d(v,b)}e.getSystemShell=D;let P=null;function d(v,b){if(R.isLinux&&v===2||R.isMacintosh&&v===3)return"/bin/bash";if(!P){let g;if(R.isWindows)g="/bin/bash";else{if(g=b.SHELL,!g)try{g=(0,I.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}P=g}return P}let h=null;async function S(){return h||(h=(await(0,n.getFirstAvailablePowerShellInstallation)()).exePath),h}});var we=this&&this.__decorate||function(x,e,I,R){var n=arguments.length,C=n<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,I):R,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(x,e,I,R);else for(var P=x.length-1;P>=0;P--)(D=x[P])&&(C=(n<3?D(C):n>3?D(e,I,C):D(e,I))||C);return n>3&&C&&Object.defineProperty(e,I,C),C};define(ee[47],te([0,1,25,8,17,22,54,13,3,2,72,27,10]),function(x,e,I,R,n,C,D,P,d,h,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var g;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(g||(g={}));function p(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(w||(w={}));function a(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(u||(u={}));function m(F){let W=0;for(let z=0;;z+=7){const X=F.read(1);if(W|=(X.buffer[0]&127)<<z,!(X.buffer[0]&128))return W}}const k=i(0);function E(F,W){if(W===0){F.write(k);return}let z=0;for(let ie=W;ie!==0;ie=ie>>>7)z++;const X=n.VSBuffer.alloc(z);for(let ie=0;W!==0;ie++)X.buffer[ie]=W&127,W=W>>>7,W>0&&(X.buffer[ie]|=128);F.write(X)}class L{constructor(W){this.b=W,this.a=0}read(W){const z=this.b.slice(this.a,this.a+W);return this.a+=z.byteLength,z}}e.BufferReader=L;class t{constructor(){this.a=[]}get buffer(){return n.VSBuffer.concat(this.a)}write(W){this.a.push(W)}}e.BufferWriter=t;var c;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object",F[F.Int=6]="Int"})(c||(c={}));function i(F){const W=n.VSBuffer.alloc(1);return W.writeUInt8(F,0),W}const r={Undefined:i(c.Undefined),String:i(c.String),Buffer:i(c.Buffer),VSBuffer:i(c.VSBuffer),Array:i(c.Array),Object:i(c.Object),Uint:i(c.Int)},s=typeof Buffer<"u";function l(F,W){if(typeof W>"u")F.write(r.Undefined);else if(typeof W=="string"){const z=n.VSBuffer.fromString(W);F.write(r.String),E(F,z.byteLength),F.write(z)}else if(s&&Buffer.isBuffer(W)){const z=n.VSBuffer.wrap(W);F.write(r.Buffer),E(F,z.byteLength),F.write(z)}else if(W instanceof n.VSBuffer)F.write(r.VSBuffer),E(F,W.byteLength),F.write(W);else if(Array.isArray(W)){F.write(r.Array),E(F,W.length);for(const z of W)l(F,z)}else if(typeof W=="number"&&(W|0)===W)F.write(r.Uint),E(F,W);else{const z=n.VSBuffer.fromString(JSON.stringify(W));F.write(r.Object),E(F,z.byteLength),F.write(z)}}e.serialize=l;function o(F){switch(F.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return F.read(m(F)).toString();case c.Buffer:return F.read(m(F)).buffer;case c.VSBuffer:return F.read(m(F));case c.Array:{const z=m(F),X=[];for(let ie=0;ie<z;ie++)X.push(o(F));return X}case c.Object:return JSON.parse(F.read(m(F)).toString());case c.Int:return m(F)}}e.deserialize=o;class f{constructor(W,z,X=null,ie=1e3){this.h=W,this.j=z,this.k=X,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:200})}registerChannel(W,z){this.b.set(W,z),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const z=this.o([W.type]);this.k?.logOutgoing(z,0,1,a(W.type));return}case 201:case 202:case 204:case 203:{const z=this.o([W.type,W.id],W.data);this.k?.logOutgoing(z,W.id,1,a(W.type),W.data);return}}}o(W,z=void 0){const X=new t;return l(X,W),l(X,z),this.p(X.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const z=new L(W),X=o(z),ie=o(z),se=X[0];switch(se){case 100:return this.k?.logIncoming(W.byteLength,X[1],1,`${p(se)}: ${X[2]}.${X[3]}`,ie),this.s({type:se,id:X[1],channelName:X[2],name:X[3],arg:ie});case 102:return this.k?.logIncoming(W.byteLength,X[1],1,`${p(se)}: ${X[2]}.${X[3]}`,ie),this.t({type:se,id:X[1],channelName:X[2],name:X[3],arg:ie});case 101:return this.k?.logIncoming(W.byteLength,X[1],1,`${p(se)}`),this.u({type:se,id:X[1]});case 103:return this.k?.logIncoming(W.byteLength,X[1],1,`${p(se)}`),this.u({type:se,id:X[1]})}}s(W){const z=this.b.get(W.channelName);if(!z){this.v(W);return}const X=new C.CancellationTokenSource;let ie;try{ie=z.call(this.j,W.name,W.arg,X.token)}catch(A){ie=Promise.reject(A)}const se=W.id;ie.then(A=>{this.m({id:se,data:A,type:201}),this.d.delete(W.id)},A=>{A instanceof Error?this.m({id:se,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.m({id:se,data:A,type:203}),this.d.delete(W.id)});const Q=(0,h.toDisposable)(()=>X.cancel());this.d.set(W.id,Q)}t(W){const z=this.b.get(W.channelName);if(!z){this.v(W);return}const X=W.id,se=z.listen(this.j,W.name,W.arg)(Q=>this.m({id:X,data:Q,type:204}));this.d.set(W.id,se)}u(W){const z=this.d.get(W.id);z&&(z.dispose(),this.d.delete(W.id))}v(W){let z=this.g.get(W.channelName);z||(z=[],this.g.set(W.channelName,z));const X=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:W,timeoutTimer:X})}w(W){const z=this.g.get(W);if(z){for(const X of z)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,h.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=f;var y;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(W,z=null){this.l=W,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=z}getChannel(W){const z=this;return{call(X,ie,se){return z.a?Promise.reject(new P.CancellationError):z.m(W,X,ie,se)},listen(X,ie){return z.a?d.Event.None:z.o(W,X,ie)}}}m(W,z,X,ie=C.CancellationToken.None){const se=this.g++,A={id:se,type:100,channelName:W,name:z,arg:X};if(ie.isCancellationRequested)return Promise.reject(new P.CancellationError);let T;return new Promise((B,q)=>{if(ie.isCancellationRequested)return q(new P.CancellationError);const N=()=>{const le=be=>{switch(be.type){case 201:this.f.delete(se),B(be.data);break;case 202:{this.f.delete(se);const Le=new Error(be.data.message);Le.stack=Array.isArray(be.data.stack)?be.data.stack.join(`
`):be.data.stack,Le.name=be.data.name,q(Le);break}case 203:this.f.delete(se),q(be.data);break}};this.f.set(se,le),this.p(A)};let $=null;this.b===u.Idle?N():($=(0,R.createCancelablePromise)(le=>this.u()),$.then(()=>{$=null,N()}));const J=()=>{$?($.cancel(),$=null):this.p({id:se,type:101}),q(new P.CancellationError)},oe=ie.onCancellationRequested(J);T=(0,h.combinedDisposable)((0,h.toDisposable)(J),oe),this.d.add(T)}).finally(()=>{this.d.delete(T)})}o(W,z,X){const ie=this.g++,Q={id:ie,type:102,channelName:W,name:z,arg:X};let A=null;const T=new d.Emitter({onWillAddFirstListener:()=>{A=(0,R.createCancelablePromise)(B=>this.u()),A.then(()=>{A=null,this.d.add(T),this.p(Q)})},onDidRemoveLastListener:()=>{A?(A.cancel(),A=null):(this.d.delete(T),this.p({id:ie,type:103}))}}),U=B=>T.fire(B.data);return this.f.set(ie,U),T.event}p(W){switch(W.type){case 100:case 102:{const z=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(z,W.id,0,`${p(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const z=this.q([W.type,W.id]);this.j?.logOutgoing(z,W.id,0,p(W.type));return}}}q(W,z=void 0){const X=new t;return l(X,W),l(X,z),this.r(X.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const z=new L(W),X=o(z),ie=o(z),se=X[0];switch(se){case 200:return this.j?.logIncoming(W.byteLength,0,0,a(se)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,X[1],0,a(se),ie),this.t({type:X[0],id:X[1],data:ie})}}t(W){if(W.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,h.dispose)(this.d.values()),this.d.clear()}}we([D.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class O{get connections(){const W=[];return this.f.forEach(z=>W.push(z)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new d.Emitter,this.onDidAddConnection=this.g.event,this.h=new d.Emitter,this.onDidRemoveConnection=this.h.event,W(({protocol:z,onDidClientDisconnect:X})=>{d.Event.once(z.onMessage)(se=>{const Q=new L(se),A=o(Q),T=new f(z,A),U=new M(z);this.a.forEach((q,N)=>T.registerChannel(N,q));const B={channelServer:T,channelClient:U,ctx:A};this.f.add(B),this.g.fire(B),X(()=>{T.dispose(),U.dispose(),this.f.delete(B),this.h.fire(B)})})})}getChannel(W,z){const X=this;return{call(ie,se,Q){let A;if((0,b.isFunction)(z)){const U=(0,I.getRandomElement)(X.connections.filter(z));A=U?Promise.resolve(U):d.Event.toPromise(d.Event.filter(X.onDidAddConnection,z))}else A=z.routeCall(X,ie,se);const T=A.then(U=>U.channelClient.getChannel(W));return G(T).call(ie,se,Q)},listen(ie,se){if((0,b.isFunction)(z))return X.j(W,z,ie,se);const Q=z.routeEvent(X,ie,se).then(A=>A.channelClient.getChannel(W));return G(Q).listen(ie,se)}}}j(W,z,X,ie){const se=this;let Q=new h.DisposableStore;const A=new d.Emitter({onWillAddFirstListener:()=>{Q=new h.DisposableStore;const T=new d.EventMultiplexer,U=new Map,B=N=>{const J=N.channelClient.getChannel(W).listen(X,ie),oe=T.add(J);U.set(N,oe)},q=N=>{const $=U.get(N);!$||($.dispose(),U.delete(N))};se.connections.filter(z).forEach(B),d.Event.filter(se.onDidAddConnection,z)(B,void 0,Q),se.onDidRemoveConnection(q,void 0,Q),T.event(A.fire,A,Q),Q.add(T)},onDidRemoveLastListener:()=>{Q.dispose()}});return A.event}registerChannel(W,z){this.a.set(W,z),this.f.forEach(X=>{X.channelServer.registerChannel(W,z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=O;class j{constructor(W,z,X=null){const ie=new t;l(ie,z),W.send(ie.buffer),this.a=new M(W,X),this.d=new f(W,z,X)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,z){this.d.registerChannel(W,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=j;function G(F){return{call(W,z,X){return F.then(ie=>ie.call(W,z,X))},listen(W,z){const X=new d.Relay;return F.then(ie=>X.input=ie.listen(W,z)),X.event}}}e.getDelayedChannel=G;function H(F){let W=!1;return{call(z,X,ie){return W?F.call(z,X,ie):(0,R.timeout)(0).then(()=>W=!0).then(()=>F.call(z,X,ie))},listen(z,X){if(W)return F.listen(z,X);const ie=new d.Relay;return(0,R.timeout)(0).then(()=>W=!0).then(()=>ie.input=F.listen(z,X)),ie.event}}}e.getNextTickChannel=H;class K{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const z of W.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await d.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.StaticRouter=K;var ne;(function(F){function W(se,Q){const A=se,T=Q&&Q.disableMarshalling,U=new Map;for(const B in A)X(B)&&U.set(B,d.Event.buffer(A[B],!0));return new class{listen(B,q,N){const $=U.get(q);if($)return $;if(ie(q)){const J=A[q];if(typeof J=="function")return J.call(A,N)}throw new Error(`Event not found: ${q}`)}call(B,q,N){const $=A[q];if(typeof $=="function"){if(!T&&Array.isArray(N))for(let J=0;J<N.length;J++)N[J]=(0,S.revive)(N[J]);return $.apply(A,N)}throw new Error(`Method not found: ${q}`)}}}F.fromService=W;function z(se,Q){const A=Q&&Q.disableMarshalling;return new Proxy({},{get(T,U){if(typeof U=="string")return Q?.properties?.has(U)?Q.properties.get(U):ie(U)?function(B){return se.listen(U,B)}:X(U)?se.listen(U):async function(...B){let q;Q&&!(0,b.isUndefinedOrNull)(Q.context)?q=[Q.context,...B]:q=B;const N=await se.call(U,q);return A?N:(0,S.revive)(N)};throw new Error(`Property not found: ${String(U)}`)}})}F.toService=z;function X(se){return se[0]==="o"&&se[1]==="n"&&v.isUpperAsciiLetter(se.charCodeAt(2))}function ie(se){return/^onDynamic/.test(se)&&v.isUpperAsciiLetter(se.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ae(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const W=F.toString();if(W!=="[object Object]")return W}return F}function fe(F){return Array.isArray(F)?F.map(ae):ae(F)}function ge(F,W,z,X,ie,se,Q){Q=fe(Q);const A=re[ie],T=A[X%A.length];let U=[`%c[${F}]%c[${String(W).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${T}`];/\($/.test(se)?(U=U.concat(Q),U.push(")")):U.push(Q),console.log.apply(console,U)}class V{constructor(W,z){this.d=W,this.f=z,this.a=0,this.b=0}logOutgoing(W,z,X,ie,se){this.b+=W,ge(this.d,this.b,W,z,X,ie,se)}logIncoming(W,z,X,ie,se){this.a+=W,ge(this.f,this.a,W,z,X,ie,se)}}e.IPCLogger=V}),define(ee[149],te([0,1,17,3,47]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class C{constructor(d){this.a=d,this.onMessage=R.Event.fromDOMEventEmitter(this.a,"message",h=>I.VSBuffer.wrap(h.data)),d.start()}send(d){this.a.postMessage(d.buffer)}disconnect(){this.a.close()}}e.Protocol=C;class D extends n.IPCClient{constructor(d,h){const S=new C(d);super(S,h),this.b=S}dispose(){this.b.disconnect()}}e.Client=D}),define(ee[104],te([0,1,8,17,3,2,47]),function(x,e,I,R,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(M){M.Created="created",M.Read="read",M.Write="write",M.Open="open",M.Error="error",M.Close="close",M.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",M.NodeEndReceived="nodeEndReceived",M.NodeEndSent="nodeEndSent",M.NodeDrainBegin="nodeDrainBegin",M.NodeDrainEnd="nodeDrainEnd",M.zlibInflateError="zlibInflateError",M.zlibInflateData="zlibInflateData",M.zlibInflateInitialWrite="zlibInflateInitialWrite",M.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",M.zlibInflateWrite="zlibInflateWrite",M.zlibInflateFlushFired="zlibInflateFlushFired",M.zlibDeflateError="zlibDeflateError",M.zlibDeflateData="zlibDeflateData",M.zlibDeflateWrite="zlibDeflateWrite",M.zlibDeflateFlushFired="zlibDeflateFlushFired",M.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",M.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",M.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",M.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",M.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",M.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",M.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",M.ProtocolHeaderRead="protocolHeaderRead",M.ProtocolMessageRead="protocolMessageRead",M.ProtocolHeaderWrite="protocolHeaderWrite",M.ProtocolMessageWrite="protocolMessageWrite",M.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var d;(function(M){M.enableDiagnostics=!1,M.records=[];const O=new WeakMap;let j=0;function G(K,ne){if(!O.has(K)){const re=String(++j);O.set(K,re)}return O.get(K)}function H(K,ne,re,ae){if(!M.enableDiagnostics)return;const fe=G(K,ne);if(ae instanceof R.VSBuffer||ae instanceof Uint8Array||ae instanceof ArrayBuffer||ArrayBuffer.isView(ae)){const ge=R.VSBuffer.alloc(ae.byteLength);ge.set(ae),M.records.push({timestamp:Date.now(),id:fe,label:ne,type:re,buff:ge})}else M.records.push({timestamp:Date.now(),id:fe,label:ne,type:re,data:ae})}M.traceSocketEvent=H})(d=e.SocketDiagnostics||(e.SocketDiagnostics={}));var h;(function(M){M[M.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",M[M.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h=e.SocketCloseEventType||(e.SocketCloseEventType={}));let S=null;function v(){return S||(S=R.VSBuffer.alloc(0)),S}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(O){this.a.push(O),this.b+=O.byteLength}read(O){return this.c(O,!0)}peek(O){return this.c(O,!1)}c(O,j){if(O===0)return v();if(O>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===O){const ne=this.a[0];return j&&(this.a.shift(),this.b-=O),ne}if(this.a[0].byteLength>O){const ne=this.a[0].slice(0,O);return j&&(this.a[0]=this.a[0].slice(O),this.b-=O),ne}const G=R.VSBuffer.alloc(O);let H=0,K=0;for(;O>0;){const ne=this.a[K];if(ne.byteLength>O){const re=ne.slice(0,O);G.set(re,H),H+=O,j&&(this.a[K]=ne.slice(O),this.b-=O),O-=O}else G.set(ne,H),H+=ne.byteLength,j?(this.a.shift(),this.b-=ne.byteLength):K++,O-=ne.byteLength}return G}}e.ChunkStream=b;var g;(function(M){M[M.None=0]="None",M[M.Regular=1]="Regular",M[M.Control=2]="Control",M[M.Ack=3]="Ack",M[M.Disconnect=5]="Disconnect",M[M.ReplayRequest=6]="ReplayRequest",M[M.Pause=7]="Pause",M[M.Resume=8]="Resume",M[M.KeepAlive=9]="KeepAlive",M[M.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",M[M.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(g||(g={}));function p(M){switch(M){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var w;(function(M){M[M.HeaderLength=13]="HeaderLength",M[M.AcknowledgeTime=2e3]="AcknowledgeTime",M[M.TimeoutTime=2e4]="TimeoutTime",M[M.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",M[M.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",M[M.KeepAliveSendTime=5e3]="KeepAliveSendTime",M[M.LatencySampleTime=6e4]="LatencySampleTime",M[M.LatencySampleCount=5]="LatencySampleCount",M[M.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",M[M.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class a{constructor(O,j,G,H){this.type=O,this.id=j,this.ack=G,this.data=H,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends C.Disposable{constructor(O){super(),this.f=this.B(new n.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=O,this.b=!1,this.c=new b,this.B(this.a.onData(j=>this.acceptChunk(j))),this.lastReadTime=Date.now()}acceptChunk(O){if(!(!O||O.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(O);this.c.byteLength>=this.g.readLen;){const j=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=j.readUInt32BE(9),this.g.messageType=j.readUInt8(0),this.g.id=j.readUInt32BE(1),this.g.ack=j.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const G=this.g.messageType,H=this.g.id,K=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",j),this.f.fire(new a(G,H,K,j)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class m{constructor(O){this.k=null,this.a=!1,this.b=!1,this.c=O,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(O){if(this.a)return;O.writtenTime=Date.now(),this.lastWriteTime=Date.now();const j=R.VSBuffer.alloc(13);j.writeUInt8(O.type,0),j.writeUInt32BE(O.id,1),j.writeUInt32BE(O.ack,5),j.writeUInt32BE(O.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:p(O.type),id:O.id,ack:O.ack,messageSize:O.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",O.data),this.j(j,O.data)}g(O,j){const G=this.f===0;return this.d.push(O,j),this.f+=O.byteLength+j.byteLength,G}h(){const O=R.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,O}j(O,j){this.g(O,j)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const O=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:O.byteLength}),this.c.write(O)}}class k extends C.Disposable{constructor(O){super(),this.f=new n.Emitter,this.onMessage=this.f.event,this.g=new n.Emitter,this.onDidDispose=this.g.event,this.a=O,this.b=this.B(new m(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(j=>{j.type===1&&this.f.fire(j.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(O){this.b.write(new a(1,0,0,O))}}e.Protocol=k;class E extends D.IPCClient{static fromSocket(O,j){return new E(new k(O),j)}get onDidDispose(){return this.b.onDidDispose}constructor(O,j,G=null){super(O,j,G),this.b=O}dispose(){super.dispose();const O=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),O.end()}}e.Client=E;class L{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new n.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(O){this.b?this.d.length>0?this.d.push(O):this.a.fire(O):this.d.push(O)}flushBuffer(){this.d=[]}}e.BufferedEmitter=L;class t{constructor(O){this.data=O,this.next=null}}class c{constructor(){this.a=null,this.b=null}length(){let O=0,j=this.a;for(;j;)j=j.next,O++;return O}peek(){return this.a?this.a.data:null}toArray(){const O=[];let j=0,G=this.a;for(;G;)O[j++]=G.data,G=G.next;return O}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(O){const j=new t(O);if(!this.a){this.a=j,this.b=j;return}this.b.next=j,this.b=j}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const O=Date.now();for(let j=0;j<i.a;j++)this.c[j]=O-1e3*j;setInterval(()=>{for(let j=i.a;j>=1;j--)this.c[j]=this.c[j-1];this.c[0]=Date.now()},1e3)}d(){const O=Date.now(),j=(1+i.a)*1e3;let G=0;for(let H=0;H<i.a;H++)O-this.c[H]<=j&&G++;return 1-G/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var r;(function(M){M[M.Good=0]="Good",M[M.Poor=1]="Poor"})(r=e.ConnectionHealth||(e.ConnectionHealth={}));function s(M){switch(M){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=s;class l{constructor(O){this.connectionHealth=O}}e.ConnectionHealthChangedEvent=l;class o{constructor(O,j){this.roundTripTime=O,this.recentHighRoundTripCount=j}}e.HighRoundTripTimeEvent=o;class f{get unacknowledgedCount(){return this.c-this.d}constructor(O){this.x=new L,this.onControlMessage=this.x.event,this.y=new L,this.onMessage=this.y.event,this.z=new L,this.onDidDispose=this.z.event,this.A=new L,this.onSocketClose=this.A.event,this.B=new L,this.onSocketTimeout=this.B.event,this.C=new L,this.onHighRoundTripTime=this.C.event,this.D=new L,this.onDidChangeConnectionHealth=this.D.event,this.u=O.loadEstimator??i.getInstance(),this.v=O.measureRoundTripTime??!1,this.w=O.sendKeepAlive??!0,this.a=!1,this.b=new c,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new C.DisposableStore,this.o=O.socket,this.p=this.t.add(new m(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(j=>this.E(j))),this.t.add(this.o.onClose(j=>this.A.fire(j))),this.r=this.t.add(new y),this.t.add(this.r.onSendLatencyRequest(j=>this.J(j))),this.t.add(this.r.onHighRoundTripTime(j=>this.C.fire(j))),this.t.add(this.r.onDidChangeConnectionHealth(j=>this.D.fire(j))),this.v&&this.r.start(),O.initialChunk&&this.q.acceptChunk(O.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const O=new a(5,0,0,v());this.p.write(O),this.p.flush()}sendPause(){const O=new a(7,0,0,v());this.p.write(O)}sendResume(){const O=new a(8,0,0,v());this.p.write(O)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(O,j){this.a=!0,this.t.dispose(),this.t=new C.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=O,this.p=this.t.add(new m(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(G=>this.E(G))),this.t.add(this.o.onClose(G=>this.A.fire(G))),this.r=this.t.add(new y),this.t.add(this.r.onSendLatencyRequest(G=>this.J(G))),this.t.add(this.r.onHighRoundTripTime(G=>this.C.fire(G))),this.t.add(this.r.onDidChangeConnectionHealth(G=>this.D.fire(G))),this.q.acceptChunk(j)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const O=new a(3,0,this.h,v());this.p.write(O);const j=this.b.toArray();for(let G=0,H=j.length;G<H;G++)this.p.write(j[G]);this.G()}acceptDisconnect(){this.z.fire()}E(O){if(O.ack>this.d){this.d=O.ack;do{const j=this.b.peek();if(j&&j.id<=O.ack)this.b.pop();else break}while(!0)}switch(O.type){case 0:break;case 1:{if(O.id>this.g)if(O.id!==this.g+1){const j=Date.now();j-this.m>1e4&&(this.m=j,this.p.write(new a(6,0,0,v())))}else this.g=O.id,this.j=Date.now(),this.F(),this.y.fire(O.data);break}case 2:{this.x.fire(O.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const j=this.b.toArray();for(let G=0,H=j.length;G<H;G++)this.p.write(j[G]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(O.data);break}case 11:{this.r.handleResponse(O.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(O){const j=++this.c;this.h=this.g;const G=new a(1,j,this.h,O);this.b.push(G),this.a||(this.p.write(G),this.G())}sendControl(O){const j=new a(2,0,0,O);this.p.write(j)}F(){if(this.g<=this.h||this.k)return;const O=Date.now()-this.j;if(O>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-O+5)}G(){if(this.c<=this.d||this.f||this.a)return;const O=this.b.peek(),j=Date.now()-O.writtenTime,G=Date.now()-this.q.lastReadTime,H=Date.now()-this.n;if(j>=2e4&&G>=2e4&&H>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:j,timeSinceLastReceivedSomeData:G});return}const K=Math.max(2e4-j,2e4-G,2e4-H,500);this.f=setTimeout(()=>{this.f=null,this.G()},K)}H(){if(this.g<=this.h)return;this.h=this.g;const O=new a(3,0,this.h,v());this.p.write(O)}I(){this.h=this.g;const O=new a(9,0,this.h,v());this.p.write(O)}J(O){this.h=this.g;const j=new a(10,0,this.h,O);this.p.write(j)}K(O){this.h=this.g;const j=new a(11,0,this.h,O);this.p.write(j)}}e.PersistentProtocol=f;class y extends C.Disposable{constructor(){super(),this.a=this.B(new n.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new n.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new n.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new I.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},O=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const O=++this.h,j=R.VSBuffer.alloc(4);j.writeUInt32BE(O,0),this.a.fire(j)},6e4)}handleResponse(O){if(O.byteLength!==4)return;const j=O.readUInt32BE(0);if(this.g<=0||j!==this.h)return;const G=Date.now()-this.g,H=this.k++;this.j[H%this.j.length]=G;const K=this.l,ne=this.j.filter(re=>re>=1e3).length;this.l=ne>=3?1:0,G>1e3&&this.b.fire(new o(G,ne)),K!==this.l&&this.c.fire(this.l)}}}),define(ee[150],te([0,1,42,17,3,2,47,135]),function(x,e,I,R,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function d(S,v){const b=n.Event.fromNodeEventEmitter(I.validatedIpcMain,v,(p,w)=>({event:p,message:w})),g=n.Event.filter(b,({event:p})=>p.sender.id===S);return n.Event.map(g,({message:p})=>p&&R.VSBuffer.wrap(p))}class h extends D.IPCServer{static d(){const v=n.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:hello",({sender:b})=>b);return n.Event.map(v,b=>{const g=b.id;h.b.get(g)?.dispose();const w=new n.Emitter;h.b.set(g,(0,C.toDisposable)(()=>w.fire()));const a=d(g,"vscode:message"),u=n.Event.any(n.Event.signal(d(g,"vscode:disconnect")),w.event);return{protocol:new P.Protocol(b,a),onDidClientDisconnect:u}})}constructor(){super(h.d())}}e.Server=h,h.b=new Map}),define(ee[105],te([0,1,42,3,31,149]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends C.Client{constructor(h,S){super({addEventListener:(v,b)=>h.addListener(v,b),removeEventListener:(v,b)=>h.removeListener(v,b),postMessage:v=>h.postMessage(v),start:()=>h.start(),close:()=>h.close()},S)}}e.Client=D;async function P(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const h=(0,n.generateUuid)();d.webContents.send("vscode:createMessageChannel",h);const S=R.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:createMessageChannelResult",(b,g)=>({nonce:g,port:b.ports[0]})),{port:v}=await R.Event.toPromise(R.Event.once(R.Event.filter(S,b=>b.nonce===h)));return v}e.connect=P}),define(ee[151],te([0,1,46,8,17,22,144,13,3,2,44,85,82,47]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends g.ChannelServer{constructor(u){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",m=>n.VSBuffer.wrap(Buffer.from(m,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=p;class w{constructor(u,m){this.i=u,this.j=m,this.c=new Set,this.g=new Map,this.h=new d.Emitter,this.onDidProcessExit=this.h.event;const k=m&&m.timeout?m.timeout:6e4;this.b=new R.Delayer(k),this.d=null,this.f=null}getChannel(u){const m=this;return{call(k,E,L){return m.k(u,k,E,L)},listen(k,E){return m.l(u,k,E)}}}k(u,m,k,E=C.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const L=this.n(u),t=(0,R.createCancelablePromise)(r=>L.call(m,k,r)),c=E.onCancellationRequested(()=>t.cancel()),i=(0,h.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{c.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,m,k){if(!this.b)return d.Event.None;this.b.cancel();let E;const L=new d.Emitter({onWillAddFirstListener:()=>{E=this.n(u).listen(m,k)(L.fire,L),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return L.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,S.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,b.removeDangerousEnvVariables)(m.env),this.d=(0,I.fork)(this.i,u,m);const k=new d.Emitter;d.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,D.isRemoteConsoleLog)(s)){(0,D.log)(s,`IPC Library: ${this.j.serverName}`);return}k.fire(n.VSBuffer.wrap(Buffer.from(s,"base64")))});const L=this.j.useQueue?(0,v.createQueuedSender)(this.d):this.d,t=s=>this.d&&this.d.connected&&L.send(s.buffer.toString("base64")),c=k.event,i={send:t,onMessage:c};this.f=new g.ChannelClient(i);const r=()=>this.o();process.once("exit",r),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,l)=>{process.removeListener("exit",r),this.c.forEach(o=>(0,h.dispose)(o)),this.c.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:l})})}return this.f}n(u){let m=this.g.get(u);return m||(m=this.m.getChannel(u),this.g.set(u,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=w}),define(ee[86],te([0,1,17,13,3,2,9,4,31,47,104]),function(x,e,I,R,n,C,D,P,d,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function v(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class b{traceSocketEvent(o,f){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,f)}constructor(o,f=""){this.f=!0,this.debugLabel=f,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=y=>{if(this.traceSocketEvent("error",{code:y?.code,message:y?.message}),y){if(y.code==="EPIPE")return;(0,R.onUnexpectedError)(y)}},this.socket.on("error",this.a),this.b=y=>{this.traceSocketEvent("close",{hadError:y}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(o){const f=y=>{this.traceSocketEvent("read",y),o(I.VSBuffer.wrap(y))};return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(o){const f=y=>{o({type:0,hadError:y,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(o){const f=()=>{o()};return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(o){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,R.onUnexpectedError)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,R.onUnexpectedError)(f)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,f)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const y=()=>{this.socket.off("close",y),this.socket.off("end",y),this.socket.off("error",y),this.socket.off("timeout",y),this.socket.off("drain",y),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",y),this.socket.on("end",y),this.socket.on("error",y),this.socket.on("timeout",y),this.socket.on("drain",y)})}}e.NodeSocket=b;var g;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var p;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(p||(p={}));class w extends C.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(o,f){this.socket.traceSocketEvent(o,f)}constructor(o,f,y,M){super(),this.f=this.B(new n.Emitter),this.g=this.B(new n.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:f,inflateBytesLength:y?.byteLength||0,recordInflateBytes:M}),this.a=this.B(new a(this,f,y,M,this.f,(O,j)=>this.k(O,j))),this.B(this.a.onError(O=>{console.error(O),(0,R.onUnexpectedError)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new S.ChunkStream,this.B(this.socket.onData(O=>this.l(O))),this.B(this.socket.onClose(O=>this.g.fire(O)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this.f.event(o)}onClose(o){return this.g.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this.a.writeMessage(o)}k(o,f){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let y=2;o.byteLength<126?y+=0:o.byteLength<2**16?y+=2:y+=8;const M=I.VSBuffer.alloc(y);if(f?M.writeUInt8(194,0):M.writeUInt8(130,0),o.byteLength<126)M.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){M.writeUInt8(126,1);let O=1;M.writeUInt8(o.byteLength>>>8&255,++O),M.writeUInt8(o.byteLength>>>0&255,++O)}else{M.writeUInt8(127,1);let O=1;M.writeUInt8(0,++O),M.writeUInt8(0,++O),M.writeUInt8(0,++O),M.writeUInt8(0,++O),M.writeUInt8(o.byteLength>>>24&255,++O),M.writeUInt8(o.byteLength>>>16&255,++O),M.writeUInt8(o.byteLength>>>8&255,++O),M.writeUInt8(o.byteLength>>>0&255,++O)}this.socket.write(I.VSBuffer.concat([M,o]))}end(){this.h=!0,this.socket.end()}l(o){if(o.byteLength!==0){for(this.b.acceptChunk(o);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const f=this.b.peek(this.j.readLen),y=f.readUInt8(0),M=(y&128)>>>7,O=(y&64)>>>6,j=f.readUInt8(1),G=(j&128)>>>7,H=j&127;this.j.state=2,this.j.readLen=2+(G?4:0)+(H===126?2:0)+(H===127?8:0),this.j.fin=M,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(O)),this.j.firstFrameOfMessage=Boolean(M),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const f=this.b.read(this.j.readLen),y=f.readUInt8(1),M=(y&128)>>>7;let O=y&127,j=1;O===126?O=f.readUInt8(++j)*2**8+f.readUInt8(++j):O===127&&(O=f.readUInt8(++j)*0+f.readUInt8(++j)*0+f.readUInt8(++j)*0+f.readUInt8(++j)*0+f.readUInt8(++j)*2**24+f.readUInt8(++j)*2**16+f.readUInt8(++j)*2**8+f.readUInt8(++j));let G=0;M&&(G=f.readUInt8(++j)*2**24+f.readUInt8(++j)*2**16+f.readUInt8(++j)*2**8+f.readUInt8(++j)),this.j.state=3,this.j.readLen=O,this.j.mask=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const f=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",f),k(f,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",f),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(f,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await n.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class a extends C.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.VSBuffer.alloc(0)}constructor(o,f,y,M,O,j){super(),this.k=o,this.l=O,this.m=j,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new n.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,f?(this.b=this.B(new u(this.k,M,y,{windowBits:15})),this.f=this.B(new m(this.k,{windowBits:15})),this.B(this.b.onError(G=>this.a.fire(G))),this.B(this.f.onError(G=>this.a.fire(G)))):(this.b=null,this.f=null)}writeMessage(o){this.g.push(o),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const o=this.g.shift();if(this.f){const f=await this.r(this.f,o);this.m(f,!0)}else this.m(o,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(o,f){return new Promise((y,M)=>{o.write(f),o.flush(O=>y(O))})}acceptFrame(o,f,y){this.h.push({data:o,isCompressed:f,isLastFrameOfMessage:y}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const o=this.h.shift();if(this.b&&o.isCompressed){const f=await this.u(this.b,o.data,o.isLastFrameOfMessage);this.l.fire(f)}else this.l.fire(o.data)}this.s=!1}}u(o,f,y){return new Promise((M,O)=>{o.write(f),y&&o.write(I.VSBuffer.fromByteArray([0,0,255,255])),o.flush(j=>M(j))})}}class u extends C.Disposable{get recordedInflateBytes(){return this.j?I.VSBuffer.concat(this.f):I.VSBuffer.alloc(0)}constructor(o,f,y,M){super(),this.h=o,this.j=f,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=v().zlib.createInflateRaw(M),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(I.VSBuffer.wrap(O))}),y&&(this.h.traceSocketEvent("zlibInflateInitialWrite",y.buffer),this.b.write(y.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(o){this.j&&this.f.push(o.clone()),this.h.traceSocketEvent("zlibInflateWrite",o),this.b.write(o.buffer)}flush(o){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const f=I.VSBuffer.concat(this.g);this.g.length=0,o(f)})}}class m extends C.Disposable{constructor(o,f){super(),this.g=o,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.f=[],this.b=v().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",y=>{this.g.traceSocketEvent("zlibDeflateError",{message:y?.message,code:y?.code}),this.a.fire(y)}),this.b.on("data",y=>{this.g.traceSocketEvent("zlibDeflateData",y),this.f.push(I.VSBuffer.wrap(y))})}write(o){this.g.traceSocketEvent("zlibDeflateWrite",o.buffer),this.b.write(o.buffer)}flush(o){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let f=I.VSBuffer.concat(this.f);this.f.length=0,f=f.slice(0,f.byteLength-4),o(f)})}}function k(l,o){if(o===0)return;const f=l.byteLength>>>2;for(let H=0;H<f;H++){const K=l.readUInt32BE(H*4);l.writeUInt32BE(K^o,H*4)}const y=f*4,M=l.byteLength-y,O=o>>>24&255,j=o>>>16&255,G=o>>>8&255;M>=1&&l.writeUInt8(l.readUInt8(y)^O,y),M>=2&&l.writeUInt8(l.readUInt8(y+1)^j,y+1),M>=3&&l.writeUInt8(l.readUInt8(y+2)^G,y+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const E={[2]:107,[1]:103};function L(){const l=(0,d.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):o=(0,D.join)(v().os.tmpdir(),`vscode-ipc-${l}.sock`),c(o),o}e.createRandomIPCHandle=L;function t(l,o,f){const y=v().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${y}-${f}-${o}-sock`;let M;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?M=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${y.substr(0,8)}-${f}-${o}.sock`):M=(0,D.join)(l,`${f}-${o}.sock`),c(M),M}e.createStaticIPCHandle=t;function c(l){const o=E[P.platform];typeof o=="number"&&l.length>=o&&console.warn(`WARNING: IPC handle "${l}" is longer than ${o} chars, try a shorter --user-data-dir`)}class i extends h.IPCServer{static b(o){const f=n.Event.fromNodeEventEmitter(o,"connection");return n.Event.map(f,y=>({protocol:new S.Protocol(new b(y,"ipc-server-connection")),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(y,"close"))}))}constructor(o){super(i.b(o)),this.d=o}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function r(l){return new Promise((o,f)=>{const y=v().net.createServer();y.on("error",f),y.listen(l,()=>{y.removeListener("error",f),o(new i(y))})})}e.serve=r;function s(l,o){return new Promise((f,y)=>{const M=v().net.createConnection(l,()=>{M.removeListener("error",y),f(S.Client.fromSocket(new b(M,`ipc-client${o}`),o))});M.once("error",y)})}e.connect=s}),define(ee[106],te([0,1,8,3,2,10]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D=e.StorageHint||(e.StorageHint={}));function P(v){const b=v;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var d;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(d=e.StorageState||(e.StorageState={}));class h extends n.Disposable{constructor(b,g=Object.create(null)){super(),this.m=b,this.n=g,this.b=this.B(new R.Emitter),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=new I.ThrottledDelayer(h.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(b=>this.r(b)))}r(b){b.changed?.forEach((g,p)=>this.s(p,g)),b.deleted?.forEach(g=>this.s(g,void 0))}s(b,g){if(this.c===d.Closed)return;let p=!1;(0,C.isUndefinedOrNull)(g)?p=this.f.delete(b):this.f.get(b)!==g&&(this.f.set(b,g),p=!0),p&&this.b.fire(b)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.n.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(b,g){const p=this.f.get(b);return(0,C.isUndefinedOrNull)(p)?g:p}getBoolean(b,g){const p=this.get(b);return(0,C.isUndefinedOrNull)(p)?g:p==="true"}getNumber(b,g){const p=this.get(b);return(0,C.isUndefinedOrNull)(p)?g:parseInt(p,10)}async set(b,g){if(this.c===d.Closed)return;if((0,C.isUndefinedOrNull)(g))return this.delete(b);const p=String(g);if(this.f.get(b)!==p)return this.f.set(b,p),this.j.set(b,p),this.h.delete(b),this.b.fire(b),this.w()}async delete(b){if(!(this.c===d.Closed||!this.f.delete(b)))return this.h.has(b)||this.h.add(b),this.j.delete(b),this.b.fire(b),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=d.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const b={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(b).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(b){if(!!this.u)return this.w(b)}async w(b){return this.g.trigger(()=>this.v(),b)}async whenFlushed(){if(!!this.u)return new Promise(b=>this.l.push(b))}isInMemory(){return this.n.hint===D.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=h,h.a=100;class S{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(b){b.insert?.forEach((g,p)=>this.a.set(p,g)),b.delete?.forEach(g=>this.a.delete(g))}async close(){}}e.InMemoryStorageDatabase=S}),define(ee[152],te([0,1,8,3,35,9,23]),function(x,e,I,R,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{get onDidChangeItemsExternal(){return R.Event.None}constructor(S,v=Object.create(null)){this.g=S,this.h=v,this.c=(0,C.basename)(this.g),this.d=new d(this.h.logging),this.f=this.n(this.g)}async getItems(){const S=await this.f,v=new Map;return(await this.s(S,"SELECT * FROM ItemTable")).forEach(g=>v.set(g.key,g.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${v.size} rows`),v}async updateItems(S){const v=await this.f;return this.j(v,S)}j(S,v){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${v.insert?(0,n.mapToString)(v.insert):"0"}), delete(${v.delete?(0,n.setToString)(v.delete):"0"})`),this.t(S,()=>{const b=v.insert,g=v.delete;if(b&&b.size>0){const p=[];p.push([]);let w=0;b.forEach((a,u)=>{let m=p[w];m.length>P.b&&(w++,m=[],p.push(m)),m.push(u,a)}),p.forEach(a=>{this.u(S,`INSERT INTO ItemTable VALUES ${new Array(a.length/2).fill("(?,?)").join(",")}`,u=>u.run(a),()=>{const u=[];let m=0;return b.forEach((k,E)=>{u.push(E),m+=k.length}),`Keys: ${u.join(", ")} Length: ${m}`})})}if(g&&g.size){const p=[];p.push([]);let w=0;g.forEach(a=>{let u=p[w];u.length>P.b&&(w++,u=[],p.push(u)),u.push(a)}),p.forEach(a=>{this.u(S,`DELETE FROM ItemTable WHERE key IN (${new Array(a.length).fill("?").join(",")})`,u=>u.run(a),()=>{const u=[];return g.forEach(m=>{u.push(m)}),`Keys: ${u.join(", ")}`})})}})}async close(S){this.d.trace(`[storage ${this.c}] close()`);const v=await this.f;return this.k(v,S)}k(S,v){return new Promise((b,g)=>{S.db.close(p=>(p&&this.o(S,`[storage ${this.c}] close(): ${p}`),this.g===P.IN_MEMORY_PATH?b():!S.isErroneous&&!S.isInMemory?this.l().then(b,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),b())):typeof v=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const a=()=>this.k(w,void 0);return this.j(w,{insert:v()}).then(()=>a(),u=>(a(),Promise.reject(u)))})).then(b,g):g(p||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const S=this.m(this.g);return D.Promises.copy(this.g,S,{preserveSymlinks:!1})}m(S){return`${S}.backup`}async checkIntegrity(S){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${S})`);const v=await this.f,b=await this.r(v,S?"PRAGMA integrity_check":"PRAGMA quick_check"),g=S?b.integrity_check:b.quick_check;return v.isErroneous?`${g} (last error: ${v.lastError})`:v.isInMemory?`${g} (in-memory!)`:g}async n(S,v=!0){this.d.trace(`[storage ${this.c}] open(${S}, retryOnBusy: ${v})`);try{return await this.p(S)}catch(b){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&v)return await(0,I.timeout)(P.a),this.n(S,!1);try{await D.Promises.unlink(S);try{await D.Promises.rename(this.m(S),S)}catch{}return await this.p(S)}catch(g){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${g}`),this.p(P.IN_MEMORY_PATH)}}}o(S,v){S.isErroneous=!0,S.lastError=v,this.d.error(v)}p(S){return new Promise((v,b)=>{new Promise((g,p)=>{x(["@vscode/sqlite3"],g,p)}).then(g=>{const p={db:new(this.d.isTracing?g.verbose().Database:g.Database)(S,w=>w?p.db&&w.code!=="SQLITE_CANTOPEN"?p.db.close(()=>b(w)):b(w):this.q(p,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v(p),a=>p.db.close(()=>b(a)))),isInMemory:S===P.IN_MEMORY_PATH};p.db.on("error",w=>this.o(p,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&p.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},b)})}q(S,v){return new Promise((b,g)=>{S.db.exec(v,p=>p?(this.o(S,`[storage ${this.c}] exec(): ${p}`),g(p)):b())})}r(S,v){return new Promise((b,g)=>{S.db.get(v,(p,w)=>p?(this.o(S,`[storage ${this.c}] get(): ${p}`),g(p)):b(w))})}s(S,v){return new Promise((b,g)=>{S.db.all(v,(p,w)=>p?(this.o(S,`[storage ${this.c}] all(): ${p}`),g(p)):b(w))})}t(S,v){return new Promise((b,g)=>{S.db.serialize(()=>{S.db.run("BEGIN TRANSACTION"),v(),S.db.run("END TRANSACTION",p=>p?(this.o(S,`[storage ${this.c}] transaction(): ${p}`),g(p)):b())})})}u(S,v,b,g){const p=S.db.prepare(v),w=a=>{this.o(S,`[storage ${this.c}] prepare(): ${a} (${v}). Details: ${g()}`)};p.on("error",w),b(p),p.finalize(a=>{a&&w(a),p.removeListener("error",w)})}}e.SQLiteStorageDatabase=P,P.IN_MEMORY_PATH=":memory:",P.a=2e3,P.b=256;class d{constructor(S){S&&typeof S.logTrace=="function"&&process.env[d.VSCODE_TRACE_STORAGE]&&(this.a=S.logTrace),S&&typeof S.logError=="function"&&(this.b=S.logError)}get isTracing(){return!!this.a}trace(S){this.a?.(S)}error(S){this.b?.(S)}}d.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[153],te([12,11]),function(x,e){return x.create("vs/code/electron-main/app",e)}),define(ee[154],te([12,11]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[155],te([12,11]),function(x,e){return x.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[156],te([12,11]),function(x,e){return x.create("vs/platform/environment/node/argv",e)}),define(ee[157],te([12,11]),function(x,e){return x.create("vs/platform/environment/node/argvHelper",e)}),define(ee[158],te([12,11]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[159],te([12,11]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[160],te([12,11]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[161],te([12,11]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[162],te([12,11]),function(x,e){return x.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[163],te([12,11]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(ee[164],te([12,11]),function(x,e){return x.create("vs/platform/files/common/files",e)}),define(ee[165],te([12,11]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(ee[166],te([12,11]),function(x,e){return x.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[167],te([12,11]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[168],te([12,11]),function(x,e){return x.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[169],te([12,11]),function(x,e){return x.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[170],te([12,11]),function(x,e){return x.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[171],te([12,11]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(ee[172],te([12,11]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(ee[173],te([12,11]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[174],te([12,11]),function(x,e){return x.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[175],te([12,11]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[176],te([12,11]),function(x,e){return x.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[177],te([12,11]),function(x,e){return x.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[178],te([12,11]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(ee[179],te([12,11]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[180],te([12,11]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[181],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function I(n){return n&&n.hasOwnProperty("folderUri")}e.isFolderBackupInfo=I;function R(n){return n&&n.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=R}),define(ee[182],te([0,1,7]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function R(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=R;function n(D){let P=[];try{Array.isArray(D.workspaces)&&(P=D.workspaces.map(d=>({workspace:{id:d.id,configPath:I.URI.parse(d.configURIPath)},remoteAuthority:d.remoteAuthority})))}catch{}return P}e.deserializeWorkspaceInfos=n;function C(D){let P=[];try{Array.isArray(D.folders)&&(P=D.folders.map(d=>({folderUri:I.URI.parse(d.folderUri),remoteAuthority:d.remoteAuthority})))}catch{}return P}e.deserializeFolderInfos=C}),define(ee[183],te([0,1,3,2]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class n{constructor(){this.a=new I.Emitter,this.b=new I.Emitter,this.c=new I.Emitter,this.d=new I.Emitter}call(P,d,h){switch(d){case"close":return Promise.resolve(this.a.fire({sessionId:h[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:h[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:h[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:h[0],port:h[1],subId:h[2]}))}throw new Error("Method not implemented.")}listen(P,d,h){switch(d){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=n,n.ChannelName="extensionhostdebugservice";class C extends R.Disposable{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,d,h){this.b.call("attach",[P,d,h])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,d){this.b.call("terminate",[P,d])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,d){return this.b.call("openExtensionDevelopmentHostWindow",[P,d])}}e.ExtensionHostDebugChannelClient=C}),define(ee[184],te([0,1,138,54,15,9,36,20,7]),function(x,e,I,R,n,C,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class h{get appRoot(){return(0,C.dirname)(n.FileAccess.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return d.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.b.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const p=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",p)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return d.URI.file((0,C.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(d.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=D.env.VSCODE_PORTABLE;return p?d.URI.file((0,C.join)(p,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,C.resolve)(p):(0,C.normalize)((0,C.join)(n.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?d.URI.file((0,C.resolve)(p)):d.URI.file((0,C.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,C.resolve)(p);const w=D.env.VSCODE_EXTENSIONS;if(w)return w;const a=D.env.VSCODE_PORTABLE;return a?(0,C.join)(a,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(w=>/^[^:/?#]+?:\/\//.test(w)?d.URI.parse(w):d.URI.file((0,C.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?d.URI.parse(p):d.URI.file((0,C.normalize)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(p))}get extensionLogLevel(){const p=[];for(const w of this.args.log||[]){const a=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(w);a&&a[1]&&a[2]&&p.push([a[1],a[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return d.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=D.env.VSCODE_PORTABLE;return p?d.URI.file((0,C.join)(p,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this.a}constructor(p,w,a){this.a=p,this.b=w,this.c=a,this.editSessionId=this.args.editSessionId}}we([R.memoize],h.prototype,"appRoot",null),we([R.memoize],h.prototype,"userHome",null),we([R.memoize],h.prototype,"userDataPath",null),we([R.memoize],h.prototype,"appSettingsHome",null),we([R.memoize],h.prototype,"tmpDir",null),we([R.memoize],h.prototype,"cacheHome",null),we([R.memoize],h.prototype,"stateResource",null),we([R.memoize],h.prototype,"userRoamingDataHome",null),we([R.memoize],h.prototype,"userDataSyncHome",null),we([R.memoize],h.prototype,"userDataSyncLogResource",null),we([R.memoize],h.prototype,"editSessionsLogResource",null),we([R.memoize],h.prototype,"sync",null),we([R.memoize],h.prototype,"machineSettingsResource",null),we([R.memoize],h.prototype,"workspaceStorageHome",null),we([R.memoize],h.prototype,"localHistoryHome",null),we([R.memoize],h.prototype,"keyboardLayoutResource",null),we([R.memoize],h.prototype,"argvResource",null),we([R.memoize],h.prototype,"isExtensionDevelopment",null),we([R.memoize],h.prototype,"untitledWorkspacesHome",null),we([R.memoize],h.prototype,"installSourcePath",null),we([R.memoize],h.prototype,"builtinExtensionsPath",null),we([R.memoize],h.prototype,"extensionsPath",null),we([R.memoize],h.prototype,"extensionDevelopmentLocationURI",null),we([R.memoize],h.prototype,"extensionDevelopmentKind",null),we([R.memoize],h.prototype,"extensionTestsLocationURI",null),we([R.memoize],h.prototype,"debugExtensionHost",null),we([R.memoize],h.prototype,"logLevel",null),we([R.memoize],h.prototype,"extensionLogLevel",null),we([R.memoize],h.prototype,"serviceMachineIdResource",null),we([R.memoize],h.prototype,"telemetryLogResource",null),we([R.memoize],h.prototype,"disableWorkspaceTrust",null),we([R.memoize],h.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=h;function S(g,p){return b(g["inspect-extensions"],g["inspect-brk-extensions"],5870,p,g.debugId,g.extensionEnvironment)}e.parseExtensionHostPort=S;function v(g,p){return b(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,p,g.extensionEnvironment)}e.parsePtyHostPort=v;function b(g,p,w,a,u,m){const E=Number(p||g)||(a?null:w),L=E?Boolean(!!p):!1;let t;if(m)try{t=JSON.parse(m)}catch{}return{port:E,break:L,debugId:u,env:t}}}),define(ee[107],te([0,1,286,4,156]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,n.localize)(0,null),e:(0,n.localize)(1,null),t:(0,n.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,n.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,n.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,n.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,n.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,n.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,n.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,n.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,n.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,n.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,n.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,n.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,n.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,n.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,n.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,n.localize)(17,null)},category:{type:"string",cat:"e",description:(0,n.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,n.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,n.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,n.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,n.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,n.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,n.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,n.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,n.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,n.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,n.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,n.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,n.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,n.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,n.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,n.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,n.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,n.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(w,a,u=D){const m=w.find(l=>l.length>0&&l[0]!=="-"),k={},E=["_"],L=[],t={};let c;for(const l in a){const o=a[l];o.type==="subcommand"?l===m&&(c=o):(o.alias&&(k[l]=o.alias),o.type==="string"||o.type==="string[]"?(E.push(l),o.deprecates&&E.push(...o.deprecates)):o.type==="boolean"&&(L.push(l),o.deprecates&&L.push(...o.deprecates)),o.global&&(t[l]=o))}if(c&&m){const l=t;for(const M in c.options)l[M]=c.options[M];const o=w.filter(M=>M!==m),f=u.getSubcommandReporter?u.getSubcommandReporter(m):void 0,y=P(o,l,f);return{[m]:y,_:[]}}const i=I(w,{string:E,boolean:L,alias:k}),r={},s=i;r._=i._.map(l=>String(l)).filter(l=>l.length>0),delete s._;for(const l in a){const o=a[l];if(o.type==="subcommand")continue;o.alias&&delete s[o.alias];let f=s[l];if(o.deprecates)for(const y of o.deprecates)s.hasOwnProperty(y)&&(f||(f=s[y],f&&u.onDeprecatedOption(y,o.deprecationMessage||(0,n.localize)(36,null,l))),delete s[y]);if(typeof f<"u"){if(o.type==="string[]"){if(Array.isArray(f)||(f=[f]),!o.allowEmptyValue){const y=f.filter(M=>M.length>0);y.length!==f.length&&(u.onEmptyValue(l),f=y.length>0?y:void 0)}}else o.type==="string"&&(Array.isArray(f)?(f=f.pop(),u.onMultipleValues(l,f)):!f&&!o.allowEmptyValue&&(u.onEmptyValue(l),f=void 0));r[l]=f,o.deprecationMessage&&u.onDeprecatedOption(l,o.deprecationMessage)}delete s[l]}for(const l in s)u.onUnknownOption(l);return r}e.parseArgs=P;function d(w,a){let u="";return a.args&&(Array.isArray(a.args)?u=` <${a.args.join("> <")}>`:u=` <${a.args}>`),a.alias?`-${a.alias} --${w}${u}`:`--${w}${u}`}function h(w,a){const u=[];for(const m in w){const k=w[m],E=d(m,k);u.push([E,k.description])}return S(u,a)}e.formatOptions=h;function S(w,a){const m=w.reduce((L,t)=>Math.max(L,t[0].length),12)+2+1;if(a-m<25)return w.reduce((L,t)=>L.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const k=a-m-1,E=[];for(const L of w){const t=L[0],c=b(L[1],k),i=v(m-t.length-2);E.push("  "+t+i+c[0]);for(let r=1;r<c.length;r++)E.push(v(m)+c[r])}return E}function v(w){return" ".repeat(w)}function b(w,a){const u=[];for(;w.length;){const m=w.length<a?w.length:w.lastIndexOf(" ",a),k=w.slice(0,m).trim();w=w.slice(m),u.push(k)}return u}function g(w,a,u,m,k){const E=process.stdout.isTTY&&process.stdout.columns||80,L=k?.noInputFiles!==!0?`[${(0,n.localize)(37,null)}...]`:"",t=[`${w} ${u}`];t.push(""),t.push(`${(0,n.localize)(38,null)}: ${a} [${(0,n.localize)(39,null)}]${L}`),t.push(""),k?.noPipe!==!0&&(R.isWindows?t.push((0,n.localize)(40,null,a)):t.push((0,n.localize)(41,null,a)),t.push(""));const c={},i=[];for(const r in m){const s=m[r];if(s.type==="subcommand")s.description&&i.push({command:r,description:s.description});else if(s.description&&s.cat){let l=c[s.cat];l||(c[s.cat]=l={}),l[r]=s}}for(const r in c){const s=r,l=c[s];l&&(t.push(C[s]),t.push(...h(l,E)),t.push(""))}return i.length&&(t.push((0,n.localize)(42,null)),t.push(...S(i.map(r=>[r.command,r.description]),E)),t.push("")),t.join(`
`)}e.buildHelpMessage=g;function p(w,a){return`${w||(0,n.localize)(43,null)}
${a||(0,n.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=p}),define(ee[185],te([0,1,81,183,107]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class C extends R.ExtensionHostDebugBroadcastChannel{constructor(P){super(),this.f=P}call(P,d,h){return d==="openExtensionDevelopmentHostWindow"?this.g(h[0],h[1]):super.call(P,d,h)}async g(P,d){const h=(0,n.parseArgs)(P,n.OPTIONS);h.debugRenderer=d;const S=h.extensionDevelopmentPath;if(!S)return{success:!1};const[v]=await this.f.openExtensionDevelopmentHostWindow(S,{context:5,cli:h,forceProfile:h.profile,forceTempProfile:h["profile-temp"]});if(!d)return{success:!0};const b=v.win;if(!b)return{success:!0};const g=b.webContents.debugger;let p=g.isAttached()?1/0:0;const w=(0,I.createServer)(a=>{p++===0&&g.attach();let u=!1;const m=L=>{u||a.write(JSON.stringify(L)+"\0")},k=(L,t,c,i)=>m({method:t,params:c,sessionId:i});b.on("close",()=>{g.removeListener("message",k),a.end(),u=!0}),g.addListener("message",k);let E=Buffer.alloc(0);a.on("data",L=>{E=Buffer.concat([E,L]);for(let t=E.indexOf(0);t!==-1;t=E.indexOf(0)){let c;try{const i=E.slice(0,t).toString("utf8");E=E.slice(t+1),c=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}g.sendCommand(c.method,c.params,c.sessionId).then(i=>m({id:c.id,sessionId:c.sessionId,result:i})).catch(i=>m({id:c.id,sessionId:c.sessionId,error:{code:0,message:i.message}}))}}),a.on("error",L=>{console.error("error on cdp pipe:",L)}),a.on("close",()=>{u=!0,--p===0&&g.detach()})});return await new Promise(a=>w.listen(0,a)),b.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=C}),define(ee[61],te([0,1,287,157,107]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const C=2048;function D(b,g){const p=(E,L)=>{console.warn((0,R.localize)(0,null,E,L))},w=E=>{console.warn((0,R.localize)(1,null,E))},a=(E,L)=>{console.warn((0,R.localize)(2,null,E,L))},u=E=>({onUnknownOption:L=>{E!=="tunnel"&&console.warn((0,R.localize)(3,null,L,E))},onMultipleValues:p,onEmptyValue:w,onDeprecatedOption:a,getSubcommandReporter:E!=="tunnel"?u:void 0}),m={onUnknownOption:E=>{console.warn((0,R.localize)(4,null,E))},onMultipleValues:p,onEmptyValue:w,onDeprecatedOption:a,getSubcommandReporter:u},k=(0,n.parseArgs)(b,n.OPTIONS,g?m:void 0);return k.goto&&k._.forEach(E=>I(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,R.localize)(5,null))),k["max-memory"]&&I(parseInt(k["max-memory"])>=C,`The max-memory argument cannot be specified lower than ${C} MB.`),k}function P(b){const g=b.findIndex(p=>!/^-/.test(p));if(g>-1)return[...b.slice(0,g),...b.slice(g+1)]}function d(b){let[,...g]=b;process.env.VSCODE_DEV&&(g=P(g)||[]);const p=!v(process.env);return D(g,p)}e.parseMainProcessArgv=d;function h(b){let[,,...g]=b;return process.env.VSCODE_DEV&&(g=P(g)||[]),D(g,!0)}e.parseCLIProcessArgv=h;function S(b,...g){const p=b.indexOf("--");return p===-1?b.push(...g):b.splice(p,0,...g),b}e.addArg=S;function v(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=v}),function(){"use strict";function x(e,I,R){function n(D,P){const d=C(D,P),h=[d];return e.isAbsolute(d)||h.unshift(R),e.resolve(...h)}function C(D,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let h=process.env.VSCODE_APPDATA;if(h)return e.join(h,P);const S=D["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(h=process.env.APPDATA,!h){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");h=e.join(v,"AppData","Roaming")}break;case"darwin":h=e.join(I.homedir(),"Library","Application Support");break;case"linux":h=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(h,P)}return{getUserDataPath:n}}if(typeof define=="function")define(ee[186],te([187,26,36]),function(e,I,R){return x(e,I,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=x(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[188],te([0,1,26,184,186]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends R.AbstractNativeEnvironmentService{constructor(P,d){super(P,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,n.getUserDataPath)(P,d.nameShort)},d)}}e.NativeEnvironmentService=C}),define(ee[189],te([0,1,41,26,32]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function C(D){const P=(0,n.randomPath)((0,R.tmpdir)());try{return(0,I.writeFileSync)(P,""),D&&console.log(`Marker file for --wait created: ${P}`),P}catch(d){D&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.createWaitMarkerFileSync=C}),define(ee[190],te([0,1,10,159]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function n(D,P,d){try{C(D,P,d)}catch(h){console.error(h?.message??h)}return D}e.localizeManifest=n;function C(D,P,d){const h=(S,v,b)=>{const g=S[v];if((0,I.isString)(g)){const p=g,w=p.length;if(w>1&&p[0]==="%"&&p[w-1]==="%"){const a=p.substr(1,w-2);let u=P[a];u===void 0&&d&&(u=d[a]);const m=typeof u=="string"?u:u?.message,k=d?.[a],E=typeof k=="string"?k:k?.message;if(!m){E||console.warn(`[${D.name}]: ${(0,R.localize)(0,null,a)}`);return}if(b&&(v==="title"||v==="category")&&E&&E!==m){const L={value:m,original:E};S[v]=L}else S[v]=m}}else if((0,I.isObject)(g))for(const p in g)g.hasOwnProperty(p)&&(p==="commands"?h(g,p,!0):h(g,p,b));else if(Array.isArray(g))for(let p=0;p<g.length;p++)h(g,p,b)};for(const S in D)D.hasOwnProperty(S)&&h(D,S)}}),define(ee[191],te([0,1,13]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class R{constructor(){this.a=new Map}register(C,D){this.a.set(C,D)}updateManifest(C){if(!(typeof C.main>"u"&&typeof C.browser>"u")&&(C.activationEvents===void 0&&Object.assign(C,{activationEvents:[]}),!(!Array.isArray(C.activationEvents)||!C.contributes)))for(const D in C.contributes){const P=this.a.get(D);if(!P)continue;const d=C.contributes[D],h=Array.isArray(d)?d:[d];try{P(h,C.activationEvents)}catch(S){(0,I.onUnexpectedError)(S)}}}}e.ImplicitActivationEventsImpl=R,e.ImplicitActivationEvents=new R}),define(ee[192],te([0,1,20,83,161,193]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function d(u){return u=u.trim(),u==="*"||D.test(u)}e.isValidVersionStr=d;function h(u){if(!d(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=u.match(D);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=h;function S(u){if(!u)return null;const m=u.majorBase,k=u.majorMustEqual,E=u.minorBase;let L=u.minorMustEqual;const t=u.patchBase;let c=u.patchMustEqual;u.hasCaret&&(m===0||(L=!1),c=!1);let i=0;if(u.preRelease){const r=P.exec(u.preRelease);if(r){const[,s,l,o]=r;i=Date.UTC(Number(s),Number(l)-1,Number(o))}}return{majorBase:m,majorMustEqual:k,minorBase:E,minorMustEqual:L,patchBase:t,patchMustEqual:c,isMinimum:u.hasGreaterEquals,notBefore:i}}e.normalizeVersion=S;function v(u,m,k){let E;typeof u=="string"?E=S(h(u)):E=u;let L;m instanceof Date?L=m.getTime():typeof m=="string"&&(L=new Date(m).getTime());let t;if(typeof k=="string"?t=S(h(k)):t=k,!E||!t)return!1;const c=E.majorBase,i=E.minorBase,r=E.patchBase;let s=t.majorBase,l=t.minorBase,o=t.patchBase;const f=t.notBefore;let y=t.majorMustEqual,M=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?c>s?!0:c<s?!1:i>l?!0:i<l||L&&L<f?!1:r>=o:(c===1&&s===0&&(!y||!M||!O)&&(s=1,l=0,o=0,y=!0,M=!1,O=!1),c<s?!1:c>s?!y:i<l?!1:i>l?!M:r<o?!1:r>o?!O:!(L&&L<f))}e.isValidVersion=v;function b(u,m,k,E,L){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([R.default.Error,n.localize(0,null)]),t;if(typeof E.name!="string")return t.push([R.default.Error,n.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([R.default.Error,n.localize(2,null,"version")]),t;if(!E.engines)return t.push([R.default.Error,n.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([R.default.Error,n.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!a(E.extensionDependencies))return t.push([R.default.Error,n.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!a(E.activationEvents))return t.push([R.default.Error,n.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([R.default.Error,n.localize(7,null,"activationEvents","main")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([R.default.Warning,n.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([R.default.Error,n.localize(9,null,"main")]),t;{const r=(0,I.joinPath)(k,E.main);(0,I.isEqualOrParent)(r,k)||t.push([R.default.Warning,n.localize(10,null,r.path,k.path)])}if(typeof E.activationEvents>"u")return t.push([R.default.Error,n.localize(11,null,"activationEvents","main")]),t}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([R.default.Error,n.localize(12,null,"browser")]),t;{const r=(0,I.joinPath)(k,E.browser);(0,I.isEqualOrParent)(r,k)||t.push([R.default.Warning,n.localize(13,null,r.path,k.path)])}if(typeof E.activationEvents>"u")return t.push([R.default.Error,n.localize(14,null,"activationEvents","browser")]),t}if(!C.valid(E.version))return t.push([R.default.Error,n.localize(15,null)]),t;const c=[];if(!g(u,m,E,L,c))for(const r of c)t.push([R.default.Error,r]);return t}e.validateExtensionManifest=b;function g(u,m,k,E,L){return E||typeof k.main>"u"&&typeof k.browser>"u"?!0:w(u,m,k.engines.vscode,L)}e.isValidExtensionVersion=g;function p(u,m,k){return u==="*"||w(m,k,u)}e.isEngineValid=p;function w(u,m,k,E=[]){const L=S(h(k));if(!L)return E.push(n.localize(16,null,k)),!1;if(L.majorBase===0){if(!L.majorMustEqual||!L.minorMustEqual)return E.push(n.localize(17,null,k)),!1}else if(!L.majorMustEqual)return E.push(n.localize(18,null,k)),!1;return v(u,m,L)?!0:(E.push(n.localize(19,null,u,k)),!1)}function a(u){if(!Array.isArray(u))return!1;for(let m=0,k=u.length;m<k;m++)if(typeof u[m]!="string")return!1;return!0}}),define(ee[194],te([0,1,17,31]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function n(C,D,P){let d=P&&P.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const S=(await D.readFile(C.serviceMachineIdResource)).value.toString();d=(0,R.isUUID)(S)?S:null}catch{d=null}if(!d){d=(0,R.generateUuid)();try{await D.writeFile(C.serviceMachineIdResource,I.VSBuffer.fromString(d))}catch{}}return P?.store("storage.serviceMachineId",d,-1,1),d}e.getServiceMachineId=n}),define(ee[73],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(n,C=[],D=!1){this.ctor=n,this.staticArguments=C,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=I}),define(ee[195],te([0,1,73]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var n;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(n=e.InstantiationType||(e.InstantiationType={}));function C(P,d,h){d instanceof I.SyncDescriptor||(d=new I.SyncDescriptor(d,[],Boolean(h))),R.push([P,d])}e.registerSingleton=C;function D(){return R}e.getSingletonServiceDescriptors=D}),define(ee[196],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(C,D){this.key=C,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class R{constructor(C){this.b=C,this.a=new Map}roots(){const C=[];for(const D of this.a.values())D.outgoing.size===0&&C.push(D);return C}insertEdge(C,D){const P=this.lookupOrInsertNode(C),d=this.lookupOrInsertNode(D);P.outgoing.set(d.key,d),d.incoming.set(P.key,P)}removeNode(C){const D=this.b(C);this.a.delete(D);for(const P of this.a.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(C){const D=this.b(C);let P=this.a.get(D);return P||(P=new I(D,C),this.a.set(D,P)),P}lookup(C){return this.a.get(this.b(C))}isEmpty(){return this.a.size===0}toString(){const C=[];for(const[D,P]of this.a)C.push(`${D}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return C.join(`
`)}findCycleSlow(){for(const[C,D]of this.a){const P=new Set([C]),d=this.c(D,P);if(d)return d}}c(C,D){for(const[P,d]of C.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const h=this.c(d,D);if(h)return h;D.delete(P)}}}e.Graph=R}),define(ee[6],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function P(d){return d[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=P})(I=e._util||(e._util={})),e.IInstantiationService=n("instantiationService");function R(D,P,d){P[I.DI_TARGET]===P?P[I.DI_DEPENDENCIES].push({id:D,index:d}):(P[I.DI_DEPENDENCIES]=[{id:D,index:d}],P[I.DI_TARGET]=P)}function n(D){if(I.serviceIds.has(D))return I.serviceIds.get(D);const P=function(d,h,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(P,d,S)};return P.toString=()=>D,I.serviceIds.set(D,P),P}e.createDecorator=n;function C(D){return D}e.refineServiceDecorator=C}),define(ee[62],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,I.createDecorator)("backupMainService")}),define(ee[18],te([0,1,10,7,6]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,n.createDecorator)("configurationService");function C(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof R.URI)}e.isConfigurationOverrides=C;function D(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=D;var P;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function d(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=d;function h(a,u){const m=Object.create(null);for(const k in a)S(m,k,a[k],u);return m}e.toValuesTree=h;function S(a,u,m,k){const E=u.split("."),L=E.pop();let t=a;for(let c=0;c<E.length;c++){const i=E[c];let r=t[i];switch(typeof r){case"undefined":r=t[i]=Object.create(null);break;case"object":break;default:k(`Ignoring ${u} as ${E.slice(0,c+1).join(".")} is ${JSON.stringify(r)}`);return}t=r}if(typeof t=="object"&&t!==null)try{t[L]=m}catch{k(`Ignoring ${u} as ${E.join(".")} is ${JSON.stringify(t)}`)}else k(`Ignoring ${u} as ${E.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=S;function v(a,u){const m=u.split(".");b(a,m)}e.removeFromValueTree=v;function b(a,u){const m=u.shift();if(u.length===0){delete a[m];return}if(Object.keys(a).indexOf(m)!==-1){const k=a[m];typeof k=="object"&&!Array.isArray(k)&&(b(k,u),Object.keys(k).length===0&&delete a[m])}}function g(a,u,m){function k(t,c){let i=t;for(const r of c){if(typeof i!="object"||i===null)return;i=i[r]}return i}const E=u.split("."),L=k(a,E);return typeof L>"u"?m:L}e.getConfigurationValue=g;function p(a,u,m){Object.keys(u).forEach(k=>{k!=="__proto__"&&(k in a?I.isObject(a[k])&&I.isObject(u[k])?p(a[k],u[k],m):m&&(a[k]=u[k]):a[k]=u[k])})}e.merge=p;function w(a){return a.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(ee[74],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,I.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,I.createDecorator)("credentialsMainService");class R{constructor(){this.a={}}async getPassword(C,D){return this.a[C]?.[D]??null}async setPassword(C,D,P){this.a[C]=this.a[C]??{},this.a[C][D]=P}async deletePassword(C,D){return this.a[C]?.[D]?(delete this.a[C][D],Object.keys(this.a[C]).length===0&&delete this.a[C],!0):!1}async findPassword(C){return JSON.stringify(this.a[C])??null}async findCredentials(C){const D=[];for(const P of Object.keys(this.a[C]||{}))D.push({account:P,password:this.a[C][P]});return D}async clear(){this.a={}}}e.InMemoryCredentialsProvider=R}),define(ee[87],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,I.createDecorator)(e.ID);function R(C){return!!C.hostName&&!!C.errorMessage}e.isRemoteDiagnosticError=R;class n{async getPerformanceInfo(D,P){return{}}async getSystemInfo(D,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,P){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=n}),define(ee[108],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,I.createDecorator)("encryptionMainService")}),define(ee[33],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[28],te([0,1,54,9,86,33,188,6]),function(x,e,I,R,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,P.refineServiceDecorator)(C.IEnvironmentService);class d extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,R.join)(this.userDataPath,"clp")}get backupHome(){return(0,R.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,n.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,R.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}we([I.memoize],d.prototype,"cachedLanguagesPath",null),we([I.memoize],d.prototype,"backupHome",null),we([I.memoize],d.prototype,"mainIPCHandle",null),we([I.memoize],d.prototype,"mainLockfile",null),we([I.memoize],d.prototype,"disableUpdates",null),we([I.memoize],d.prototype,"disableKeytar",null),we([I.memoize],d.prototype,"crossOriginIsolated",null),we([I.memoize],d.prototype,"codeCachePath",null),we([I.memoize],d.prototype,"useCodeCache",null),e.EnvironmentMainService=d}),define(ee[197],te([0,1,158,6]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough";function n(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function C(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function D(u,m){switch(u){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function P(u,m){return m==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function d(u,m,k){return P(m,k)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===k?!0:h(k).includes(u)}e.isTargetPlatformCompatible=d;function h(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=h;function S(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=S;var v;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var b;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var g;(function(u){u.Install="install",u.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var p;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var w;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(w=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class a extends Error{constructor(m,k){super(m),this.code=k,this.name=k}}e.ExtensionManagementError=a,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,I.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ee[198],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,I.createDecorator)("extensionUrlTrustService")}),define(ee[199],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,I.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[109],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,I.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,I.createDecorator)("externalTerminal")}),define(ee[200],te([0,1,46,15,9,4,82,23,85,162,109]),function(x,e,I,R,n,C,D,P,d,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const v=h.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:g.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class g extends b{openTerminal(E,L){return this.spawnTerminal(I,E,d.getWindowsShell(),L)}spawnTerminal(E,L,t,c){const i=L.windowsExec||g.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const r=n.basename(i,".exe").toLowerCase();if(r==="cmder")return E.spawn(i,c?[c]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return i.indexOf(" ")>=0&&s.push('""'),s.push(i),r==="wt"&&s.push("-d ."),new Promise((l,o)=>{const f=a(process),y=E.spawn(t,s,{cwd:c,env:f});y.on("error",o),y.on("exit",()=>l())})}runInTerminal(E,L,t,c,i){const r="windowsExec"in i&&i.windowsExec?i.windowsExec:g.getDefaultTerminalWindows();return new Promise((s,l)=>{const o=`"${L} - ${v}"`,f=`""${t.join('" "')}" & pause"`,y=Object.assign({},a(process),c);Object.keys(y).filter(H=>y[H]===null).forEach(H=>delete y[H]);const M={cwd:L,env:y,windowsVerbatimArguments:!0};let O,j;n.basename(r,".exe")==="wt"?(O=r,j=["-d",".",g.b,"/c",f]):(O=g.b,j=["/c","start",o,"/wait",r,"/c",f]),I.spawn(O,j,M).on("error",H=>{l(u(H))}),s(void 0)})}static getDefaultTerminalWindows(){if(!g.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");g.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return g.d}}e.WindowsExternalTerminalService=g,g.b="cmd.exe";class p extends b{openTerminal(E,L){return this.spawnTerminal(I,E,L)}runInTerminal(E,L,t,c,i){const r=i.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((s,l)=>{if(r===S.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const o=r===S.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",y=[R.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`).fsPath,"-t",E||v,"-w",L];for(const j of t)y.push("-a"),y.push(j);if(c){const j=Object.assign({},a(process),c);for(const G in j){const H=j[G];H===null?(y.push("-u"),y.push(G)):(y.push("-e"),y.push(`${G}=${H}`))}}let M="";const O=I.spawn(p.b,y);O.on("error",j=>{l(u(j))}),O.stderr.on("data",j=>{M+=j.toString()}),O.on("exit",j=>{if(j===0)s(void 0);else if(M){const G=M.split(`
`,1);l(new Error(G[0]))}else l(new Error(h.localize(1,null,o,j)))})}else l(new Error(h.localize(2,null,r)))})}spawnTerminal(E,L,t){const c=L.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((i,r)=>{const s=["-a",c];t&&s.push(t);const l=a(process),o=E.spawn("/usr/bin/open",s,{cwd:t,env:l});o.on("error",r),o.on("exit",()=>i())})}}e.MacExternalTerminalService=p,p.b="/usr/bin/osascript";class w extends b{openTerminal(E,L){return this.spawnTerminal(I,E,L)}runInTerminal(E,L,t,c,i){const r=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((s,l)=>{const o=[];r.then(f=>{f.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const y=`${m(t)}; echo; read -p "${w.b}" -n1;`;o.push(`''${y}''`);const M=Object.assign({},a(process),c);Object.keys(M).filter(H=>M[H]===null).forEach(H=>delete M[H]);const O={cwd:L,env:M};let j="";const G=I.spawn(f,o,O);G.on("error",H=>{l(u(H))}),G.stderr.on("data",H=>{j+=H.toString()}),G.on("exit",H=>{if(H===0)s(void 0);else if(j){const K=j.split(`
`,1);l(new Error(K[0]))}else l(new Error(h.localize(4,null,f,H)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!C.isLinux)w.d=Promise.resolve("xterm");else{const E=await P.Promises.exists("/etc/debian_version");w.d=new Promise(L=>{E?L("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?L("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?L("konsole"):process.env.COLORTERM?L(process.env.COLORTERM):process.env.TERM?L(process.env.TERM):L("xterm")})}return w.d}spawnTerminal(E,L,t){const c=L.linuxExec?Promise.resolve(L.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,r)=>{c.then(s=>{const l=a(process),o=E.spawn(s,[],{cwd:t,env:l});o.on("error",r),o.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=w,w.b=h.localize(3,null);function a(k){const E={...k.env};return(0,D.sanitizeProcessEnvironment)(E),E}function u(k){return"errno"in k&&k.errno==="ENOENT"&&"path"in k&&typeof k.path=="string"?new Error(h.localize(5,null,k.path)):k}function m(k){let E="";for(const L of k)L.indexOf(" ")>=0?E+='"'+L+'"':E+=L,E+=" ";return E}}),define(ee[16],te([0,1,60,9,27,10,7,164,6,4]),function(x,e,I,R,n,C,D,P,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,d.createDecorator)("fileService");function S(F){return F.create===!0}e.isFileOpenForWriteOptions=S;var v;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(v=e.FileType||(e.FileType={}));var b;(function(F){F[F.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var g;(function(F){F[F.None=0]="None",F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock",F[F.FileAtomicRead=16384]="FileAtomicRead",F[F.FileClone=32768]="FileClone"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=p;function w(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=w;function a(F){return!!(F.capabilities&32768)}e.hasFileCloneCapability=a;function u(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function m(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=m;function k(F){return p(F)?!!(F.capabilities&16384):!1}e.hasFileAtomicReadCapability=k;var E;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class L extends Error{constructor(W,z){super(W),this.code=z}}e.FileSystemProviderError=L;function t(F,W){const z=new L(F.toString(),W);return i(z,W),z}e.createFileSystemProviderError=t;function c(F){return F||t((0,P.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=c;function i(F,W){return F.name=W?`${W} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=i;function r(F){if(!F)return E.Unknown;if(F instanceof L)return F.code;const W=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!W)return E.Unknown;switch(W[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=r;function s(F){if(F instanceof O)return F.fileOperationResult;switch(r(F)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var l;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY",F[F.WRITE=4]="WRITE"})(l=e.FileOperation||(e.FileOperation={}));class o{constructor(W,z,X){this.resource=W,this.operation=z,this.target=X}isOperation(W){return this.operation===W}}e.FileOperationEvent=o;var f;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(f=e.FileChangeType||(e.FileChangeType={}));class y{constructor(W,z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const X=new Map;for(const ie of W){const se=X.get(ie.type);switch(se?se.push([ie.resource,ie]):X.set(ie.type,[[ie.resource,ie]]),ie.type){case 1:this.rawAdded.push(ie.resource);break;case 0:this.rawUpdated.push(ie.resource);break;case 2:this.rawDeleted.push(ie.resource);break}}for(const[ie,se]of X)switch(ie){case 1:this.a=I.TernarySearchTree.forUris(()=>z),this.a.fill(se);break;case 0:this.b=I.TernarySearchTree.forUris(()=>z),this.b.fill(se);break;case 2:this.c=I.TernarySearchTree.forUris(()=>z),this.c.fill(se);break}}contains(W,...z){return this.d(W,{includeChildren:!1},...z)}affects(W,...z){return this.d(W,{includeChildren:!0},...z)}d(W,z,...X){if(!W)return!1;const ie=X.length>0;return!!((!ie||X.includes(1))&&(this.a?.get(W)||z.includeChildren&&this.a?.findSuperstr(W))||(!ie||X.includes(0))&&(this.b?.get(W)||z.includeChildren&&this.b?.findSuperstr(W))||(!ie||X.includes(2))&&(this.c?.findSubstr(W)||z.includeChildren&&this.c?.findSuperstr(W)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=y;function M(F,W,z){return!F||!W||F===W||W.length>F.length?!1:(W.charAt(W.length-1)!==R.sep&&(W+=R.sep),z?(0,n.startsWithIgnoreCase)(F,W):F.indexOf(W)===0)}e.isParent=M;class O extends Error{constructor(W,z,X){super(W),this.fileOperationResult=z,this.options=X}}e.FileOperationError=O;class j extends O{constructor(W,z,X,ie){super(W,z,ie),this.fileOperationResult=z,this.size=X}}e.TooLargeFileOperationError=j;class G extends O{constructor(W,z,X){super(W,2,X),this.stat=z}}e.NotModifiedSinceFileOperationError=G;var H;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(H=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var K;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(K=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ne(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=ne;async function re(F,W){if(!W.hasProvider(D.URI.from({scheme:F.scheme})))return new Promise(z=>{const X=W.onDidChangeFileSystemProviderRegistrations(ie=>{ie.scheme===F.scheme&&ie.added&&(X.dispose(),z())})})}e.whenProviderRegistered=re,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ae{static formatSize(W){return(0,C.isNumber)(W)||(W=0),W<ae.KB?(0,P.localize)(1,null,W.toFixed(0)):W<ae.MB?(0,P.localize)(2,null,(W/ae.KB).toFixed(2)):W<ae.GB?(0,P.localize)(3,null,(W/ae.MB).toFixed(2)):W<ae.TB?(0,P.localize)(4,null,(W/ae.GB).toFixed(2)):(0,P.localize)(5,null,(W/ae.TB).toFixed(2))}}e.ByteSize=ae,ae.KB=1024,ae.MB=ae.KB*ae.KB,ae.GB=ae.MB*ae.KB,ae.TB=ae.GB*ae.KB;var fe;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(fe=e.Arch||(e.Arch={}));function ge(F){return{maxFileSize:F===0?300*ae.MB:16*ae.GB,maxHeapSize:F===0?700*ae.MB:2*700*ae.MB}}e.getPlatformFileLimits=ge;function V(F){return h.isWeb?F?10*ae.MB:50*ae.MB:F?100*ae.MB:1024*ae.MB}e.getLargeFileConfirmationLimit=V}),define(ee[201],te([0,1,17,45,13,3,2,59,7,31,16]),function(x,e,I,R,n,C,D,P,d,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class v extends D.Disposable{constructor(g,p){super(),this.a=g,this.b=p,this.onDidChangeCapabilities=C.Event.None,this.f=this.B(new C.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new C.Emitter),this.onDidWatchError=this.g.event,this.h=(0,h.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,p){const{buffer:w}=await this.a.call("readFile",[g,p]);return w}readFileStream(g,p,w){const a=(0,P.newWriteableStream)(m=>I.VSBuffer.concat(m.map(k=>I.VSBuffer.wrap(k))).buffer),u=this.a.listen("readFileStream",[g,p])(m=>{if(m instanceof I.VSBuffer)a.write(m.buffer);else{if(m==="end")a.end();else{let k;if(m instanceof Error)k=m;else{const E=m;k=(0,S.createFileSystemProviderError)(E.message??(0,R.toErrorMessage)(E),E.code??S.FileSystemProviderErrorCode.Unknown)}a.error(k),a.end()}u.dispose()}});return w.onCancellationRequested(()=>{a.error((0,n.canceled)()),a.end(),u.dispose()}),a}writeFile(g,p,w){return this.a.call("writeFile",[g,I.VSBuffer.wrap(p),w])}open(g,p){return this.a.call("open",[g,p])}close(g){return this.a.call("close",[g])}async read(g,p,w,a,u){const[m,k]=await this.a.call("read",[g,p,u]);return w.set(m.buffer.slice(0,k),a),k}write(g,p,w,a,u){return this.a.call("write",[g,p,I.VSBuffer.wrap(w),a,u])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,p){return this.a.call("delete",[g,p])}rename(g,p,w){return this.a.call("rename",[g,p,w])}copy(g,p,w){return this.a.call("copy",[g,p,w])}cloneFile(g,p){return this.a.call("cloneFile",[g,p])}i(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const p=g;this.f.fire(p.map(w=>({resource:d.URI.revive(w.resource),type:w.type})))}else{const p=g;this.g.fire(p)}}))}watch(g,p){const w=(0,h.generateUuid)();return this.a.call("watch",[this.h,w,g,p]),(0,D.toDisposable)(()=>this.a.call("unwatch",[this.h,w]))}}e.DiskFileSystemProviderClient=v}),define(ee[110],te([0,1,17,13,165,16]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(S,v,b,g,p,w){let a;try{await P(S,v,b,g,p,w)}catch(u){a=u}finally{a&&p.errorTransformer&&(a=p.errorTransformer(a)),typeof a<"u"&&b.error(a),b.end()}}e.readFileIntoStream=D;async function P(S,v,b,g,p,w){d(w);const a=await S.open(v,{create:!1});try{d(w);let u=0,m=0,k=p&&typeof p.length=="number"?p.length:void 0,E=I.VSBuffer.alloc(Math.min(p.bufferSize,typeof k=="number"?k:p.bufferSize)),L=p&&typeof p.position=="number"?p.position:0,t=0;do m=await S.read(a,L,E.buffer,t,E.byteLength-t),L+=m,t+=m,u+=m,typeof k=="number"&&(k-=m),t===E.byteLength&&(await b.write(g(E)),E=I.VSBuffer.alloc(Math.min(p.bufferSize,typeof k=="number"?k:p.bufferSize)),t=0);while(m>0&&(typeof k!="number"||k>0)&&d(w)&&h(u,p));if(t>0){let c=t;typeof k=="number"&&(c=Math.min(t,k)),b.write(g(E.slice(0,c)))}}catch(u){throw(0,C.ensureFileSystemProviderError)(u)}finally{await S.close(a)}}function d(S){if(S.isCancellationRequested)throw(0,R.canceled)();return!0}function h(S,v){if(v?.limits){if(typeof v.limits.memory=="number"&&S>v.limits.memory)throw(0,C.createFileSystemProviderError)((0,n.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&S>v.limits.size)throw(0,C.createFileSystemProviderError)((0,n.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[75],te([0,1,101,2,9,4,7,16]),function(x,e,I,R,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function d(u){return u.recursive===!0}e.isRecursiveWatchRequest=d;class h extends R.Disposable{constructor(m,k,E,L){super(),this.h=m,this.i=k,this.j=E,this.k=L,this.c=this.B(new R.MutableDisposable),this.f=void 0,this.g=0}m(){const m=new R.DisposableStore;this.c.value=m,this.b=this.l(m),this.b.setVerboseLogging(this.j),m.add(this.b.onDidChangeFile(k=>this.h(k))),m.add(this.b.onDidLogMessage(k=>this.i(k))),m.add(this.b.onDidError(k=>this.n(k)))}n(m){this.k.restartOnError?this.g<h.a&&this.f?(this.r(`restarting watcher after error: ${m}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${m}`):this.r(m)}p(m){this.g++,this.m(),this.watch(m)}async watch(m){this.f=m,await this.b?.watch(m)}async setVerboseLogging(m){this.j=m,await this.b?.setVerboseLogging(m)}r(m){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${m}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=h,h.a=5;class S extends h{constructor(m,k,E){super(m,k,E,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=S;class v extends h{constructor(m,k,E){super(m,k,E,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=v;function b(u){return u.map(m=>({type:m.type,resource:D.URI.file(m.path)}))}e.toFileChanges=b;function g(u){const m=new a;for(const k of u)m.processEvent(k);return m.coalesce()}e.coalesceEvents=g;function p(u,m){return typeof m=="string"&&!m.startsWith(I.GLOBSTAR)&&!(0,n.isAbsolute)(m)?{base:u,pattern:m}:m}e.normalizeWatcherPattern=p;function w(u,m){const k=[];for(const E of m)k.push((0,I.parse)(p(u,E)));return k}e.parseWatcherPatterns=w;class a{constructor(){this.a=new Set,this.b=new Map}c(m){return C.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const k=this.b.get(this.c(m));let E=!1;if(k){const L=k.type,t=m.type;k.path!==m.path&&(m.type===2||m.type===1)?E=!0:L===1&&t===2?(this.b.delete(this.c(m)),this.a.delete(k)):L===2&&t===1?k.type=0:L===1&&t===0||(k.type=t)}else E=!0;E&&(this.a.add(m),this.b.set(this.c(m),m))}coalesce(){const m=[],k=[];return Array.from(this.a).filter(E=>E.type!==2?(m.push(E),!1):!0).sort((E,L)=>E.path.length-L.path.length).filter(E=>k.some(L=>(0,P.isParent)(E.path,L,!C.isLinux))?!1:(k.push(E.path),!0)).concat(m)}}}),define(ee[202],te([0,1,41,8,22,32,2,79,9,4,102,23,75]),function(x,e,I,R,n,C,D,P,d,h,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class g extends D.Disposable{constructor(a,u,m,k){super(),this.j=a,this.k=u,this.l=m,this.m=k,this.c=this.B(new R.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.k(E))),this.f=this.B(new R.RunOnceWorker(E=>this.u(E),g.b)),this.g=(0,b.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,b.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new n.CancellationTokenSource,this.ready=this.n()}async n(){try{const a=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const u=await v.Promises.stat(a);this.B(await this.s(a,u.isDirectory()))}catch(a){a.code!=="ENOENT"?this.w(a):this.z(a)}}async r(a){let u=a.path;try{u=await v.Promises.realpath(a.path),a.path===u&&(u=await(0,S.realcase)(a.path)??a.path),a.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${a.path}, real: ${u})`)}catch{}return u}async s(a,u){if(h.isMacintosh&&(0,C.isEqualOrParent)(a,"/Volumes/",!0))return this.w(`Refusing to watch ${a} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const m=new n.CancellationTokenSource(this.i.token),k=new D.DisposableStore;try{const E=(0,d.basename)(a),L=(0,I.watch)(a);k.add((0,D.toDisposable)(()=>{L.removeAllListeners(),L.close()})),this.z(`Started watching: '${a}'`);const t=new Set;if(u)try{for(const i of await v.Promises.readdir(a))t.add(i)}catch(i){this.w(i)}const c=new Map;k.add((0,D.toDisposable)(()=>{for(const[,i]of c)i.dispose();c.clear()})),L.on("error",(i,r)=>{this.w(`Failed to watch ${a} for changes using fs.watch() (${i}, ${r})`),this.dispose()}),L.on("change",(i,r)=>{if(m.token.isCancellationRequested)return;this.z(`[raw] ["${i}"] ${r}`);let s="";if(r&&(s=r.toString(),h.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||i!=="change"&&i!=="rename"))if(u)if(i==="rename"){c.get(s)?.dispose();const l=setTimeout(async()=>{if(c.delete(s),s===E&&!await v.Promises.exists(a)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.v((0,d.join)(a,s));if(m.token.isCancellationRequested)return;let f;o?t.has(s)?f=0:(f=1,t.add(s)):(t.delete(s),f=2),this.t({path:(0,d.join)(this.j.path,s),type:f})},g.a);c.set(s,(0,D.toDisposable)(()=>clearTimeout(l)))}else{let l;t.has(s)?l=0:(l=1,t.add(s)),this.t({path:(0,d.join)(this.j.path,s),type:l})}else if(i==="rename"||s!==E){const l=setTimeout(async()=>{const o=await v.Promises.exists(a);m.token.isCancellationRequested||(o?(this.t({path:this.j.path,type:0},!0),k.add(await this.s(a,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},g.a);k.clear(),k.add((0,D.toDisposable)(()=>clearTimeout(l)))}else this.t({path:this.j.path,type:0},!0)})}catch(E){await v.Promises.exists(a)&&!m.token.isCancellationRequested&&this.w(`Failed to watch ${a} for changes using fs.watch() (${E.toString()})`)}return(0,D.toDisposable)(()=>{m.dispose(!0),k.dispose()})}t(a,u=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`),!u&&this.g.some(m=>m(a.path))?this.m&&this.z(` >> ignored (excluded) ${a.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(m=>m(a.path))?this.m&&this.z(` >> ignored (not included) ${a.path}`):this.f.work(a))}u(a){const u=(0,b.coalesceEvents)(a);if(u.length>0){if(this.m)for(const k of u)this.z(`>> normalized ${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.path}`);this.c.work(u)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(a){if(h.isLinux)return v.Promises.exists(a);try{const u=(0,d.basename)(a);return(await v.Promises.readdir((0,d.dirname)(a))).some(k=>k===u)}catch(u){return this.z(u),!1}}setVerboseLogging(a){this.m=a}w(a){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${a}`})}y(a){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${a}`})}z(a){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${a}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=g,g.a=100,g.b=75;async function p(w,a,u,m,k=512){const E=await v.Promises.open(w,"r"),L=Buffer.allocUnsafe(k),t=new n.CancellationTokenSource(m);let c,i=!1;const r={path:w,excludes:[],recursive:!1},s=new g(r,l=>{(async()=>{for(const{type:o}of l)if(o===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:f}=await v.Promises.read(E,L,0,k,null);if(!f||t.token.isCancellationRequested)break;a(L.slice(0,f))}}catch(f){c=new Error(f),t.dispose(!0)}finally{i=!1}}})()});return await s.ready,u(),new Promise((l,o)=>{t.token.onCancellationRequested(async()=>{s.dispose();try{await v.Promises.close(E)}catch(f){c=new Error(f)}c?o(c):l()})})}e.watchFileContents=p}),define(ee[203],te([0,1,3,101,2,4,202]),function(x,e,I,R,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends n.Disposable{constructor(){super(...arguments),this.a=this.B(new I.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new I.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(h){const S=this.i(h),v=S.filter(g=>{const p=this.c.get(g.path);return p?!(0,R.patternsEquals)(p.request.excludes,g.excludes)||!(0,R.patternsEquals)(p.request.includes,g.includes):!0}),b=Array.from(this.c.values()).filter(({request:g})=>!S.find(p=>p.path===g.path&&(0,R.patternsEquals)(p.excludes,g.excludes)&&(0,R.patternsEquals)(p.includes,g.includes))).map(({request:g})=>g.path);v.length&&this.j(`Request to start watching: ${v.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),b.length&&this.j(`Request to stop watching: ${b.join(",")}`);for(const g of b)this.h(g);for(const g of v)this.g(g)}g(h){const S=new D.NodeJSFileWatcherLibrary(h,b=>this.a.fire(b),b=>this.b.fire(b),this.f),v={request:h,instance:S};this.c.set(h.path,v)}async stop(){for(const[h]of this.c)this.h(h);this.c.clear()}h(h){const S=this.c.get(h);S&&(this.c.delete(h),S.instance.dispose())}i(h){const S=new Map;for(const v of h){const b=C.isLinux?v.path:v.path.toLowerCase();S.set(b,v)}return Array.from(S.values())}async setVerboseLogging(h){this.f=h;for(const[,S]of this.c)S.instance.setVerboseLogging(h)}j(h){this.f&&this.b.fire({type:"trace",message:this.k(h)})}k(h,S){return S?`[File Watcher (node.js)] ${h} (path: ${S.request.path})`:`[File Watcher (node.js)] ${h}`}}e.NodeJSWatcher=P}),define(ee[204],te([0,1,75,203]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class n extends I.AbstractNonRecursiveWatcherClient{constructor(D,P,d){super(D,P,d),this.m()}l(){return new R.NodeJSWatcher}}e.NodeJSWatcherClient=n}),define(ee[205],te([0,1,15,47,151,75]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends C.AbstractUniversalWatcherClient{constructor(d,h,S){super(d,h,S),this.m()}l(d){const h=d.add(new n.Client(I.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(h.onDidProcessExit(({code:S,signal:v})=>this.n(`terminated by itself with code ${S}, signal: ${v}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(h.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(ee[88],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...n){this.a=new Map;for(const[C,D]of n)this.set(C,D)}set(n,C){const D=this.a.get(n);return this.a.set(n,C),D}has(n){return this.a.has(n)}get(n){return this.a.get(n)}}e.ServiceCollection=I}),define(ee[206],te([0,1,8,13,2,73,196,6,88,98]),function(x,e,I,R,n,C,D,P,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const S=!1;class v extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class b{constructor(a=new d.ServiceCollection,u=!1,m,k=S){this.f=a,this.g=u,this.h=m,this.i=k,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=k?m?._globalGraph??new D.Graph(E=>E):void 0}createChild(a){return new b(a,this.g,this,this.i)}invokeFunction(a,...u){const m=p.traceInvocation(this.i,a);let k=!1;try{return a({get:L=>{if(k)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(L,m);if(!t)throw new Error(`[invokeFunction] unknown service '${L}'`);return t}},...u)}finally{k=!0,m.stop()}}createInstance(a,...u){let m,k;return a instanceof C.SyncDescriptor?(m=p.traceCreation(this.i,a.ctor),k=this.j(a.ctor,a.staticArguments.concat(u),m)):(m=p.traceCreation(this.i,a),k=this.j(a,u,m)),m.stop(),k}j(a,u=[],m){const k=P._util.getServiceDependencies(a).sort((t,c)=>t.index-c.index),E=[];for(const t of k){const c=this.m(t.id,m);c||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(c)}const L=k.length>0?k[0].index:u.length;if(u.length!==L){console.trace(`[createInstance] First service dependency of ${a.name} at position ${L+1} conflicts with ${u.length} static arguments`);const t=L-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,L)}return Reflect.construct(a,u.concat(E))}k(a,u){if(this.f.get(a)instanceof C.SyncDescriptor)this.f.set(a,u);else if(this.h)this.h.k(a,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const u=this.f.get(a);return!u&&this.h?this.h.l(a):u}m(a,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const m=this.l(a);return m instanceof C.SyncDescriptor?this.q(a,m,u.branch(a,!0)):(u.branch(a,!1),m)}q(a,u,m){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,u,m)}finally{this.o.delete(a)}}r(a,u,m){const k=new D.Graph(t=>t.id.toString());let E=0;const L=[{id:a,desc:u,_trace:m}];for(;L.length;){const t=L.pop();if(k.lookupOrInsertNode(t),E++>1e3)throw new v(k);for(const c of P._util.getServiceDependencies(t.desc.ctor)){const i=this.l(c.id);if(i||this.u(`[createInstance] ${a} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(c.id)),i instanceof C.SyncDescriptor){const r={id:c.id,desc:i,_trace:t._trace.branch(c.id,!0)};k.insertEdge(t,r),L.push(r)}}}for(;;){const t=k.roots();if(t.length===0){if(!k.isEmpty())throw new v(k);break}for(const{data:c}of t){if(this.l(c.id)instanceof C.SyncDescriptor){const r=this.s(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.k(c.id,r)}k.removeNode(c)}}return this.l(a)}s(a,u,m=[],k,E){if(this.f.get(a)instanceof C.SyncDescriptor)return this.t(a,u,m,k,E);if(this.h)return this.h.s(a,u,m,k,E);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(a,u,m=[],k,E){if(k){const L=new b(void 0,this.g,this,this.i);L.c=String(a);const t=new Map,c=new I.IdleValue(()=>{const i=L.j(u,m,E);for(const[r,s]of t){const l=i[r];if(typeof l=="function")for(const o of s)l.apply(i,o)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,r){if(!c.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let o=t.get(r);return o||(o=new h.LinkedList,t.set(r,o)),(y,M,O)=>{const j=o.push([y,M,O]);return(0,n.toDisposable)(j)}}if(r in i)return i[r];const s=c.value;let l=s[r];return typeof l!="function"||(l=l.bind(s),i[r]=l),l},set(i,r,s){return c.value[r]=s,!0},getPrototypeOf(i){return u.prototype}})}else return this.j(u,m,E)}u(a,u){if(u&&console.warn(a),this.g)throw new Error(a)}}e.InstantiationService=b;var g;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(g||(g={}));class p{static traceInvocation(a,u){return a?new p(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(a,u){return a?new p(1,u.name):p.c}constructor(a,u){this.type=a,this.name=u,this.g=Date.now(),this.h=[]}branch(a,u){const m=new p(3,a.toString());return this.h.push([a,u,m]),m}stop(){const a=Date.now()-this.g;p.f+=a;let u=!1;function m(E,L){const t=[],c=new Array(E+1).join("	");for(const[i,r,s]of L.h)if(r&&s){u=!0,t.push(`${c}CREATES -> ${i}`);const l=m(E+1,s);l&&t.push(l)}else t.push(`${c}uses -> ${i}`);return t.join(`
`)}const k=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(a>2||u)&&p.all.add(k.join(`
`))}}e.Trace=p,p.all=new Set,p.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p.f=0}),define(ee[5],te([0,1,45,3,2,35,4,10,7,6]),function(x,e,I,R,n,C,D,P,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.setLogLevel=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,h.createDecorator)("logService"),e.ILoggerService=(0,h.createDecorator)("loggerService");function S(){return new Date().toISOString()}function v(f){return(0,P.isNumber)(f)}e.isLogLevel=v;var b;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function g(f,y,M){switch(y){case b.Trace:f.trace(M);break;case b.Debug:f.debug(M);break;case b.Info:f.info(M);break;case b.Warning:f.warn(M);break;case b.Error:f.error(M);break;case b.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=g;function p(f){let y="";for(let M=0;M<f.length;M++){let O=f[M];if(typeof O=="object")try{O=JSON.stringify(O)}catch{}y+=(M>0?" ":"")+O}return y}e.format=p;class w extends n.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new R.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==b.Off&&this.b<=y}}e.AbstractLogger=w;class a extends w{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...M){this.f(b.Trace)&&this.g(b.Trace,p([y,...M]))}debug(y,...M){this.f(b.Debug)&&this.g(b.Debug,p([y,...M]))}info(y,...M){this.f(b.Info)&&this.g(b.Info,p([y,...M]))}warn(y,...M){this.f(b.Warning)&&this.g(b.Warning,p([y,...M]))}error(y,...M){if(this.f(b.Error))if(y instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=y.stack,this.g(b.Error,p(O))}else this.g(b.Error,p([y,...M]))}flush(){}}e.AbstractMessageLogger=a;class u extends w{constructor(y=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(y),this.g=!D.isWindows}trace(y,...M){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,y,...M):console.log(`[main ${S()}]`,y,...M))}debug(y,...M){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,y,...M):console.log(`[main ${S()}]`,y,...M))}info(y,...M){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,y,...M):console.log(`[main ${S()}]`,y,...M))}warn(y,...M){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,y,...M):console.warn(`[main ${S()}]`,y,...M))}error(y,...M){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,y,...M):console.error(`[main ${S()}]`,y,...M))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class m extends w{constructor(y=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(y)}trace(y,...M){this.f(b.Trace)&&console.log("%cTRACE","color: #888",y,...M)}debug(y,...M){this.f(b.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",y,...M)}info(y,...M){this.f(b.Info)&&console.log("%c INFO","color: #33f",y,...M)}warn(y,...M){this.f(b.Warning)&&console.log("%c WARN","color: #993",y,...M)}error(y,...M){this.f(b.Error)&&console.log("%c  ERR","color: #f33",y,...M)}dispose(){}flush(){}}e.ConsoleLogger=m;class k extends w{constructor(y,M=e.DEFAULT_LOG_LEVEL){super(),this.g=y,this.setLevel(M)}trace(y,...M){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(y),...M])}debug(y,...M){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(y),...M])}info(y,...M){this.f(b.Info)&&this.g.log(b.Info,[this.h(y),...M])}warn(y,...M){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(y),...M])}error(y,...M){this.f(b.Error)&&this.g.log(b.Error,[this.h(y),...M])}h(y){return typeof y=="string"?y:(0,I.toErrorMessage)(y,this.f(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=k;class E extends w{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const M of this.g)M.setLevel(y);super.setLevel(y)}trace(y,...M){for(const O of this.g)O.trace(y,...M)}debug(y,...M){for(const O of this.g)O.debug(y,...M)}info(y,...M){for(const O of this.g)O.info(y,...M)}warn(y,...M){for(const O of this.g)O.warn(y,...M)}error(y,...M){for(const O of this.g)O.error(y,...M)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose()}}e.MultiplexLogger=E;class L extends n.Disposable{constructor(y,M){if(super(),this.j=y,this.b=new C.ResourceMap,this.c=new C.ResourceMap,this.f=this.B(new R.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new R.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new R.Emitter),this.onDidChangeVisibility=this.h.event,M)for(const O of M)this.c.set(O.resource,O)}getLogger(y){return this.b.get(y)}createLogger(y,M){let O=this.b.get(y);const j=M?.logLevel==="always"?b.Trace:M?.logLevel;return O||(O=this.k(y,j??this.getLogLevel(y)??this.j,M),this.b.set(y,O)),this.registerLogger({resource:y,id:M?.id??y.toString(),logLevel:j,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId}),O}setLogLevel(y,M){if(d.URI.isUri(y)){const O=y,j=M,G=this.c.get(O);G&&j!==G.logLevel&&(G.logLevel=j===this.j?void 0:j,this.b.get(O)?.setLevel(j),this.c.set(G.resource,G),this.g.fire([O,j]))}else{this.j=y;for(const[O,j]of this.b.entries())this.c.get(O)?.logLevel===void 0&&j.setLevel(this.j);this.g.fire(this.j)}}setVisibility(y,M){const O=this.c.get(y);O&&M!==!O.hidden&&(O.hidden=!M,this.c.set(O.resource,O),this.h.fire([y,M]))}getLogLevel(y){let M;return y&&(M=this.c.get(y)?.logLevel),M??this.j}registerLogger(y){const M=this.c.get(y.resource);M?M.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.c.set(y.resource,y),this.f.fire({added:[y],removed:[]}))}deregisterLogger(y){const M=this.c.get(y);if(M){this.c.delete(y);const O=this.b.get(y);O&&(this.b.delete(y),O.dispose()),this.f.fire({added:[],removed:[M]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(y){return this.c.get(y)}dispose(){this.b.forEach(y=>y.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=L;class t{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(y){}getLevel(){return b.Info}trace(y,...M){}debug(y,...M){}info(y,...M){}warn(y,...M){}error(y,...M){}critical(y,...M){}dispose(){}flush(){}}e.NullLogger=t;class c extends t{}e.NullLogService=c;class i extends L{constructor(){super(b.Info)}k(y,M,O){return new t}}e.NullLoggerService=i;function r(f){if(f.verbose)return b.Trace;if(typeof f.logLevel=="string"){const y=l(f.logLevel.toLowerCase());if(y!==void 0)return y}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function s(f){switch(f){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=s;function l(f){switch(f){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=l;function o(f,y){v(y)?f.setLogLevel(y):f.setLogLevel(y[0],y[1])}e.setLogLevel=o});var _=this&&this.__param||function(x,e){return function(I,R){e(I,R,x)}};define(ee[207],te([0,1,74,3,2,5,4,8]),function(x,e,I,R,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let d=class dt extends n.Disposable{constructor(S){super(),this.g=S,this.c=this.B(new R.Emitter),this.onDidChangePassword=this.c.event}async getPassword(S,v){this.g.trace("Getting password from keytar:",S,v);let b;try{b=await this.h()}catch{return null}const g=await(0,P.retry)(()=>b.getPassword(S,v),50,3);if(!g)return this.g.trace("Did not get a password from keytar for account:",v),g;let p,w;try{const a=JSON.parse(g);p=a.content,w=a.hasNextChunk}catch{}if(!p||!w)return this.g.trace("Got password from keytar for account:",v),g;try{let a=1;for(;w;){const u=await(0,P.retry)(()=>b.getPassword(S,`${v}-${a}`),50,3),m=JSON.parse(u);p+=m.content,w=m.hasNextChunk,a++}return this.g.trace(`Got ${a}-chunked password from keytar for account:`,v),p}catch(a){return this.g.error(a),g}}async setPassword(S,v,b){this.g.trace("Setting password using keytar:",S,v);let g;try{g=await this.h()}catch(p){throw this.i?.(p),p}if(D.isWindows&&b.length>dt.a){let p=0,w=0,a=!0;for(;a;){const u=b.substring(p,p+dt.b);p+=dt.b,a=b.length-p>0;const m={content:u,hasNextChunk:a};await(0,P.retry)(()=>g.setPassword(S,w?`${v}-${w}`:v,JSON.stringify(m)),50,3),w++}this.g.trace(`Got${w?` ${w}-chunked`:""} password from keytar for account:`,v)}else await(0,P.retry)(()=>g.setPassword(S,v,b),50,3),this.g.trace("Got password from keytar for account:",v);this.c.fire({service:S,account:v})}async deletePassword(S,v){this.g.trace("Deleting password using keytar:",S,v);let b;try{b=await this.h()}catch(u){throw this.i?.(u),u}const g=await b.getPassword(S,v);if(!g)return this.g.trace("Did not get a password to delete from keytar for account:",v),!1;let p,w;try{const u=JSON.parse(g);p=u.content,w=u.hasNextChunk}catch{}let a=0;if(p&&w)try{for(a++;w;){const u=`${v}-${a}`,m=await b.getPassword(S,u);await b.deletePassword(S,u),w=JSON.parse(m).hasNextChunk,a++}}catch(u){this.g.error(u)}return await b.deletePassword(S,v)?(this.c.fire({service:S,account:v}),this.g.trace(`Deleted${a?` ${a}-chunked`:""} password from keytar for account:`,v),!0):(this.g.trace(`Keytar failed to delete${a?` ${a}-chunked`:""} password for account:`,v),!1)}async findPassword(S){let v;try{v=await this.h()}catch{return null}return await v.findPassword(S)}async findCredentials(S){let v;try{v=await this.h()}catch{return[]}return await v.findCredentials(S)}clear(){return this.f instanceof I.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};d.a=2500,d.b=d.a-100,d=we([_(0,C.ILogService)],d),e.BaseCredentialsMainService=d}),define(ee[208],te([0,1,5]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let R=class{constructor(C,D){this.a=C,this.b=D}c(){return new Promise((C,D)=>x(["vscode-encrypt"],C,D))}async encrypt(C){let D;try{D=await this.c()}catch{return C}try{return D.encrypt(this.a,C)}catch(P){return this.b.error(P),C}}async decrypt(C){let D;try{D=await this.c()}catch{return C}try{return D.decrypt(this.a,C)}catch(P){return this.b.error(P),C}}};R=we([_(1,I.ILogService)],R),e.EncryptionMainService=R}),define(ee[209],te([0,1,25,8,13,3,2,9,75,5]),function(x,e,I,R,n,C,D,P,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class S extends D.Disposable{constructor(b,g){super(),this.a=b,this.b=g,this.c=this.B(new C.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new C.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new R.ThrottledDelayer(0)),this.s=[],this.t=this.B(new R.ThrottledDelayer(0))}watch(b,g){return g.recursive||this.b?.watcher?.forceUniversal?this.l(b,g):this.u(b,g)}l(b,g){const p={path:this.C(b),excludes:g.excludes,includes:g.includes,recursive:g.recursive},w=(0,I.insert)(this.j,p);return this.m(),(0,D.toDisposable)(()=>{w(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(b=>(0,n.onUnexpectedError)(b))}n(){this.h||(this.h=this.B(this.p(g=>this.c.fire((0,d.toFileChanges)(g)),g=>this.z(g),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const g of this.j)(0,d.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const g of this.j)(0,d.isRecursiveWatchRequest)(g)&&b.includes(g.path)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(b,g){const p={path:this.C(b),excludes:g.excludes,includes:g.includes,recursive:!1},w=(0,I.insert)(this.s,p);return this.v(),(0,D.toDisposable)(()=>{w(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(b=>(0,n.onUnexpectedError)(b))}w(){return this.r||(this.r=this.B(this.y(b=>this.c.fire((0,d.toFileChanges)(b)),b=>this.z(b),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)}))),this.r.watch(this.s)}z(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}C(b){return(0,P.normalize)(b.fsPath)}}e.AbstractDiskFileSystemProvider=S}),define(ee[210],te([0,1,25,8,17,22,3,71,69,2,60,15,63,20,59,163,16,110,5,13]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let E=class extends h.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new D.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new D.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new D.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new R.ResourceQueue)}registerProvider(t,c){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${t}`);const i=new h.DisposableStore;return this.h.set(t,c),this.c.fire({added:!0,scheme:t,provider:c}),i.add(c.onDidChangeFile(r=>this.R.fire(new a.FileChangesEvent(r,!this.O(c))))),typeof c.onDidWatchError=="function"&&i.add(c.onDidWatchError(r=>this.S.fire(new Error(r)))),i.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:t}))),(0,h.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:c}),this.h.delete(t),(0,h.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const c=[];this.f.fire({scheme:t,join(i){c.push(i)}}),!this.h.has(t)&&await R.Promises.settled(c)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,c){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&c)}listCapabilities(){return d.Iterable.map(this.h,([t,c])=>({scheme:t,capabilities:c.capabilities}))}async j(t){if(!(0,g.isAbsolutePath)(t))throw new a.FileOperationError((0,w.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const c=this.h.get(t.scheme);if(!c){const i=new k.ErrorNoTelemetry;throw i.message=(0,w.localize)(1,null,t.toString()),i}return c}async k(t){const c=await this.j(t);if((0,a.hasOpenReadWriteCloseCapability)(c)||(0,a.hasReadWriteCapability)(c)||(0,a.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const c=await this.j(t);if((0,a.hasOpenReadWriteCloseCapability)(c)||(0,a.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,c){try{return await this.n(t,c)}catch(i){throw(0,a.toFileSystemProviderErrorCode)(i)===a.FileSystemProviderErrorCode.FileNotFound?new a.FileOperationError((0,w.localize)(2,null,this.nb(t)),1):(0,a.ensureFileSystemProviderError)(i)}}async n(t,c){const i=await this.j(t),r=this.O(i),s=c?.resolveTo,l=c?.resolveSingleChildDescendants,o=c?.resolveMetadata,f=await i.stat(t);let y;return this.p(i,t,f,void 0,!!o,(M,O)=>(y||(y=S.TernarySearchTree.forUris(()=>!r),y.set(t,!0),s&&y.fill(!0,s)),y.get(M.resource)||y.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&l?O===1:!1))}async p(t,c,i,r,s,l){const{providerExtUri:o}=this.N(t),f={resource:c,name:o.basename(c),isFile:(i.type&a.FileType.File)!==0,isDirectory:(i.type&a.FileType.Directory)!==0,isSymbolicLink:(i.type&a.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&a.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,a.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(f.isDirectory&&l(f,r)){try{const y=await t.readdir(c),M=await R.Promises.settled(y.map(async([O,j])=>{try{const G=o.joinPath(c,O),H=s?await t.stat(G):{type:j};return await this.p(t,G,H,y.length,s,l)}catch(G){return this.b.trace(G),null}}));f.children=(0,I.coalesce)(M)}catch(y){this.b.trace(y),f.children=[]}return f}return f}async resolveAll(t){return R.Promises.settled(t.map(async c=>{try{return{stat:await this.n(c.resource,c.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const c=await this.j(t),i=await c.stat(t);return this.p(c,t,i,void 0,!0,()=>!1)}async exists(t){const c=await this.j(t);try{return!!await c.stat(t)}catch{return!1}}async canCreateFile(t,c){try{await this.r(t,c)}catch(i){return i}return!0}async r(t,c){if(!c?.overwrite&&await this.exists(t))throw new a.FileOperationError((0,w.localize)(3,null,this.nb(t)),3,c)}async createFile(t,c=n.VSBuffer.fromString(""),i){await this.r(t,i);const r=await this.writeFile(t,c);return this.m.fire(new a.FileOperationEvent(t,0,r)),r}async writeFile(t,c,i){const r=this.lb(await this.l(t),t),{providerExtUri:s}=this.N(r);try{await this.s(r,t,i)||await this.P(r,s.dirname(t));let o;if((0,a.hasReadWriteCapability)(r)&&!(c instanceof n.VSBuffer))if((0,p.isReadableStream)(c)){const f=await(0,p.peekStream)(c,3);f.ended?o=n.VSBuffer.concat(f.buffer):o=f}else o=(0,p.peekReadable)(c,f=>n.VSBuffer.concat(f),3);else o=c;!(0,a.hasOpenReadWriteCloseCapability)(r)||(0,a.hasReadWriteCapability)(r)&&o instanceof n.VSBuffer?await this.cb(r,t,i,o):await this.Y(r,t,i,o instanceof n.VSBuffer?(0,n.bufferToReadable)(o):o),this.m.fire(new a.FileOperationEvent(t,4))}catch(l){throw new a.FileOperationError((0,w.localize)(4,null,this.nb(t),(0,a.ensureFileSystemProviderError)(l).toString()),(0,a.toFileOperationResult)(l),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,c,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.nb(c)));let s;try{s=await t.stat(c)}catch{return}if((s.type&a.FileType.Directory)!==0)throw new a.FileOperationError((0,w.localize)(6,null,this.nb(c)),0,i);if(this.mb(c,s),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==a.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&i.mtime<s.mtime&&i.etag!==(0,a.etag)({mtime:i.mtime,size:s.size}))throw new a.FileOperationError((0,w.localize)(7,null),3,i);return s}async readFile(t,c,i){const r=await this.k(t);return c?.atomic?this.t(r,t,c,i):this.u(r,t,c,i)}async t(t,c,i,r){return new Promise((s,l)=>{this.X.queueFor(c,this.N(t).providerExtUri).queue(async()=>{try{const o=await this.u(t,c,i,r);s(o)}catch(o){l(o)}})})}async u(t,c,i,r){const s=await this.v(t,c,{...i,preferUnbuffered:!0},r);return{...s,value:await(0,n.streamToBuffer)(s.value)}}async readFileStream(t,c,i){const r=await this.k(t);return this.v(r,t,c,i)}async v(t,c,i,r){const s=new C.CancellationTokenSource(r),l=this.F(c,i).then(f=>f,f=>{throw s.cancel(),f});let o;try{return typeof i?.etag=="string"&&i.etag!==a.ETAG_DISABLED&&await l,i?.atomic&&(0,a.hasFileAtomicReadCapability)(t)||!((0,a.hasOpenReadWriteCloseCapability)(t)||(0,a.hasFileReadStreamCapability)(t))||(0,a.hasReadWriteCapability)(t)&&i?.preferUnbuffered?o=this.D(t,c,i):(0,a.hasFileReadStreamCapability)(t)?o=this.z(t,c,s.token,i):o=this.C(t,c,s.token,i),{...await l,value:o}}catch(f){throw o&&await(0,p.consumeStream)(o),this.w(f,c,i)}}w(t,c,i){const r=(0,w.localize)(8,null,this.nb(c),(0,a.ensureFileSystemProviderError)(t).toString());return t instanceof a.NotModifiedSinceFileOperationError?new a.NotModifiedSinceFileOperationError(r,t.stat,i):t instanceof a.TooLargeFileOperationError?new a.TooLargeFileOperationError(r,t.fileOperationResult,t.size,t.options):new a.FileOperationError(r,(0,a.toFileOperationResult)(t),i)}z(t,c,i,r=Object.create(null)){const s=t.readFileStream(c,r,i);return(0,p.transform)(s,{data:l=>l instanceof n.VSBuffer?l:n.VSBuffer.wrap(l),error:l=>this.w(l,c,r)},l=>n.VSBuffer.concat(l))}C(t,c,i,r=Object.create(null)){const s=(0,n.newWriteableBufferStream)();return(0,u.readFileIntoStream)(t,c,s,l=>l,{...r,bufferSize:this.a,errorTransformer:l=>this.w(l,c,r)},i),s}D(t,c,i){const r=(0,p.newWriteableStream)(s=>n.VSBuffer.concat(s));return(async()=>{try{let s;i?.atomic&&(0,a.hasFileAtomicReadCapability)(t)?s=await t.readFile(c,{atomic:!0}):s=await t.readFile(c),typeof i?.position=="number"&&(s=s.slice(i.position)),typeof i?.length=="number"&&(s=s.slice(0,i.length)),this.G(c,s.byteLength,i),r.end(n.VSBuffer.wrap(s))}catch(s){r.error(s),r.end()}})(),r}async F(t,c){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new a.FileOperationError((0,w.localize)(9,null,this.nb(t)),0,c);if(typeof c?.etag=="string"&&c.etag!==a.ETAG_DISABLED&&c.etag===i.etag)throw new a.NotModifiedSinceFileOperationError((0,w.localize)(10,null),i,c);return this.G(t,i.size,c),i}G(t,c,i){if(i?.limits){let r;if(typeof i.limits.memory=="number"&&c>i.limits.memory&&(r=9),typeof i.limits.size=="number"&&c>i.limits.size&&(r=7),typeof r=="number")throw new a.TooLargeFileOperationError((0,w.localize)(11,null,this.nb(t)),r,c,i)}}async canMove(t,c,i){return this.H(t,c,"move",i)}async canCopy(t,c,i){return this.H(t,c,"copy",i)}async H(t,c,i,r){if(t.toString()!==c.toString())try{const s=i==="move"?this.lb(await this.l(t),t):await this.k(t),l=this.lb(await this.l(c),c);await this.M(s,t,l,c,i,r)}catch(s){return s}return!0}async move(t,c,i){const r=this.lb(await this.l(t),t),s=this.lb(await this.l(c),c),l=await this.I(r,t,s,c,"move",!!i),o=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(t,l==="move"?2:3,o)),o}async copy(t,c,i){const r=await this.k(t),s=this.lb(await this.l(c),c),l=await this.I(r,t,s,c,"copy",!!i),o=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(t,l==="copy"?3:2,o)),o}async I(t,c,i,r,s,l){if(c.toString()===r.toString())return s;const{exists:o,isSameResourceWithDifferentPathCase:f}=await this.M(t,c,i,r,s,l);if(o&&!f&&l&&await this.del(r,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(r)),s==="copy"){if(t===i&&(0,a.hasFileFolderCopyCapability)(t))await t.copy(c,r,{overwrite:l});else{const y=await this.resolve(c);y.isDirectory?await this.L(t,y,i,r):await this.J(t,c,i,r)}return s}else return t===i?(await t.rename(c,r,{overwrite:l}),s):(await this.I(t,c,i,r,"copy",l),await this.del(c,{recursive:!0}),"copy")}async J(t,c,i,r){if((0,a.hasOpenReadWriteCloseCapability)(t)&&(0,a.hasOpenReadWriteCloseCapability)(i))return this.eb(t,c,i,r);if((0,a.hasOpenReadWriteCloseCapability)(t)&&(0,a.hasReadWriteCapability)(i))return this.kb(t,c,i,r);if((0,a.hasReadWriteCapability)(t)&&(0,a.hasOpenReadWriteCloseCapability)(i))return this.ib(t,c,i,r);if((0,a.hasReadWriteCapability)(t)&&(0,a.hasReadWriteCapability)(i))return this.gb(t,c,i,r)}async L(t,c,i,r){await i.mkdir(r),Array.isArray(c.children)&&await R.Promises.settled(c.children.map(async s=>{const l=this.N(i).providerExtUri.joinPath(r,s.name);return s.isDirectory?this.L(t,await this.resolve(s.resource),i,l):this.J(t,s.resource,i,l)}))}async M(t,c,i,r,s,l){let o=!1;if(t===i){const{providerExtUri:y,isPathCaseSensitive:M}=this.N(t);if(M||(o=y.isEqual(c,r)),o&&s==="copy")throw new Error((0,w.localize)(12,null,this.nb(c),this.nb(r)));if(!o&&y.isEqualOrParent(r,c))throw new Error((0,w.localize)(13,null,this.nb(c),this.nb(r)))}const f=await this.exists(r);if(f&&!o){if(!l)throw new a.FileOperationError((0,w.localize)(14,null,this.nb(c),this.nb(r)),4);if(t===i){const{providerExtUri:y}=this.N(t);if(y.isEqualOrParent(c,r))throw new Error((0,w.localize)(15,null,this.nb(c),this.nb(r)))}}return{exists:f,isSameResourceWithDifferentPathCase:o}}N(t){const c=this.O(t);return{providerExtUri:c?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:c}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const c=this.lb(await this.j(t),t);await this.P(c,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(t,0,i)),i}async P(t,c){const i=[],{providerExtUri:r}=this.N(t);for(;!r.isEqual(c,r.dirname(c));)try{if(((await t.stat(c)).type&a.FileType.Directory)===0)throw new Error((0,w.localize)(16,null,this.nb(c)));break}catch(s){if((0,a.toFileSystemProviderErrorCode)(s)!==a.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(r.basename(c)),c=r.dirname(c)}for(let s=i.length-1;s>=0;s--){c=r.joinPath(c,i[s]);try{await t.mkdir(c)}catch(l){if((0,a.toFileSystemProviderErrorCode)(l)!==a.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(t,c){try{await this.Q(t,c)}catch(i){return i}return!0}async Q(t,c){const i=this.lb(await this.j(t),t);if(!!c?.useTrash&&!(i.capabilities&4096))throw new Error((0,w.localize)(17,null,this.nb(t)));let s;try{s=await i.stat(t)}catch{}if(s)this.mb(t,s);else throw new a.FileOperationError((0,w.localize)(18,null,this.nb(t)),1);if(!!!c?.recursive){const o=await this.resolve(t);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,w.localize)(19,null,this.nb(t)))}return i}async del(t,c){const i=await this.Q(t,c),r=!!c?.useTrash,s=!!c?.recursive;await i.delete(t,{recursive:s,useTrash:r}),this.m.fire(new a.FileOperationEvent(t,1))}async cloneFile(t,c){const i=await this.j(t),r=this.lb(await this.l(c),c);if(i===r&&this.N(i).providerExtUri.isEqual(t,c))return;if(i===r&&(0,a.hasFileCloneCapability)(i))return i.cloneFile(t,c);await this.P(r,this.N(r).providerExtUri.dirname(c));const s=this.X.queueFor(t,this.N(i).providerExtUri);return i===r&&(0,a.hasFileFolderCopyCapability)(i)?s.queue(()=>i.copy(t,c,{overwrite:!0})):s.queue(()=>this.J(i,t,r,c))}watch(t,c={recursive:!1,excludes:[]}){const i=new h.DisposableStore;let r=!1,s=()=>{r=!0};return i.add((0,h.toDisposable)(()=>s())),(async()=>{try{const l=await this.W(t,c);r?(0,h.dispose)(l):s=()=>(0,h.dispose)(l)}catch(l){this.b.error(l)}})(),i}async W(t,c){const i=await this.j(t),r=(0,P.hash)([this.N(i).providerExtUri.getComparisonKey(t),c]);let s=this.U.get(r);return s||(s={count:0,disposable:i.watch(t,c)},this.U.set(r,s)),s.count+=1,(0,h.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,h.dispose)(s.disposable),this.U.delete(r)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,h.dispose)(t.disposable);this.U.clear()}async Y(t,c,i,r){return this.X.queueFor(c,this.N(t).providerExtUri).queue(async()=>{const s=await t.open(c,{create:!0,unlock:i?.unlock??!1});try{(0,p.isReadableStream)(r)||(0,p.isReadableBufferedStream)(r)?await this.Z(t,s,r):await this.ab(t,s,r)}catch(l){throw(0,a.ensureFileSystemProviderError)(l)}finally{await t.close(s)}})}async Z(t,c,i){let r=0,s;if((0,p.isReadableBufferedStream)(i)){if(i.buffer.length>0){const l=n.VSBuffer.concat(i.buffer);await this.bb(t,c,l,l.byteLength,r,0),r+=l.byteLength}if(i.ended)return;s=i.stream}else s=i;return new Promise((l,o)=>{(0,p.listenStream)(s,{onData:async f=>{s.pause();try{await this.bb(t,c,f,f.byteLength,r,0)}catch(y){return o(y)}r+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>o(f),onEnd:()=>l()})})}async ab(t,c,i){let r=0,s;for(;(s=i.read())!==null;)await this.bb(t,c,s,s.byteLength,r,0),r+=s.byteLength}async bb(t,c,i,r,s,l){let o=0;for(;o<r;)o+=await t.write(c,s+o,i.buffer,l+o,r-o)}async cb(t,c,i,r){return this.X.queueFor(c,this.N(t).providerExtUri).queue(()=>this.db(t,c,i,r))}async db(t,c,i,r){let s;r instanceof n.VSBuffer?s=r:(0,p.isReadableStream)(r)?s=await(0,n.streamToBuffer)(r):(0,p.isReadableBufferedStream)(r)?s=await(0,n.bufferedStreamToBuffer)(r):s=(0,n.readableToBuffer)(r),await t.writeFile(c,s.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,c,i,r){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.fb(t,c,i,r))}async fb(t,c,i,r){let s,l;try{s=await t.open(c,{create:!1}),l=await i.open(r,{create:!0,unlock:!1});const o=n.VSBuffer.alloc(this.a);let f=0,y=0,M=0;do M=await t.read(s,f,o.buffer,y,o.byteLength-y),await this.bb(i,l,o,M,f,y),f+=M,y+=M,y===o.byteLength&&(y=0);while(M>0)}catch(o){throw(0,a.ensureFileSystemProviderError)(o)}finally{await R.Promises.settled([typeof s=="number"?t.close(s):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async gb(t,c,i,r){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.hb(t,c,i,r))}async hb(t,c,i,r){return i.writeFile(r,await t.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async ib(t,c,i,r){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.jb(t,c,i,r))}async jb(t,c,i,r){const s=await i.open(r,{create:!0,unlock:!1});try{const l=await t.readFile(c);await this.bb(i,s,n.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw(0,a.ensureFileSystemProviderError)(l)}finally{await i.close(s)}}async kb(t,c,i,r){const s=await(0,n.streamToBuffer)(this.C(t,c,C.CancellationToken.None));await this.cb(i,r,void 0,s)}lb(t,c){if(t.capabilities&2048)throw new a.FileOperationError((0,w.localize)(20,null,this.nb(c)),6);return t}mb(t,c){if((c.permissions??0)&a.FilePermission.Readonly)throw new a.FileOperationError((0,w.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===v.Schemas.file?t.fsPath:t.toString(!0)}};E=we([_(0,m.ILogService)],E),e.FileService=E}),define(ee[89],te([0,1,41,288,8,35,17,3,32,2,9,4,20,59,23,167,16,110,209,45,205,204]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u,m,k,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(I)}catch(c){console.error(`Error enabling graceful-fs: ${(0,k.toErrorMessage)(c)}`)}})();class t extends m.AbstractDiskFileSystemProvider{constructor(i,r){super(i,r),this.onDidChangeCapabilities=P.Event.None,this.H=new C.ResourceMap(s=>b.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,v.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:r,symbolicLink:s}=await p.SymlinkSupport.stat(this.C(i));return{type:this.G(r,s),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.Y(r)}}async readdir(i){try{const r=await p.Promises.readdir(this.C(i),{withFileTypes:!0}),s=[];return await Promise.all(r.map(async l=>{try{let o;l.isSymbolicLink()?o=(await this.stat((0,b.joinPath)(i,l.name))).type:o=this.G(l),s.push([l.name,o])}catch(o){this.a.trace(o)}})),s}catch(r){throw this.Y(r)}}G(i,r){let s;return r?.dangling?s=a.FileType.Unknown:i.isFile()?s=a.FileType.File:i.isDirectory()?s=a.FileType.Directory:s=a.FileType.Unknown,r&&(s|=a.FileType.SymbolicLink),s}async I(i){const r=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let s;for(;s=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await s.wait();const l=new n.Barrier;return this.H.set(i,l),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,h.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.H.get(i)===l&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),l.open()})}async readFile(i,r){let s;try{r?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),s=await this.I(i));const l=this.C(i);return await p.Promises.readFile(l)}catch(l){throw this.Y(l)}finally{s?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,r,s){const l=(0,g.newWriteableStream)(o=>D.VSBuffer.concat(o.map(f=>D.VSBuffer.wrap(f))).buffer);return(0,u.readFileIntoStream)(this,i,l,o=>o.buffer,{...r,bufferSize:256*1024},s),l}async writeFile(i,r,s){let l;try{const o=this.C(i);if(!s.create||!s.overwrite){if(await p.Promises.exists(o)){if(!s.overwrite)throw(0,a.createFileSystemProviderError)((0,w.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,a.createFileSystemProviderError)((0,w.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(l,0,r,0,r.byteLength)}catch(o){throw await this.Z(i,o)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(i){t.O=i}async open(i,r){const s=this.C(i);let l;(0,a.isFileOpenForWriteOptions)(r)&&(l=await this.I(i));let o;try{if((0,a.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:y}=await p.SymlinkSupport.stat(s);y.mode&128||await p.Promises.chmod(s,y.mode|128)}catch(y){this.a.trace(y)}let f;if((0,a.isFileOpenForWriteOptions)(r)){if(v.isWindows)try{await p.Promises.truncate(s,0),f="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}f||(f="w")}else f="r";o=await p.Promises.open(s,f)}catch(f){throw l?.dispose(),(0,a.isFileOpenForWriteOptions)(r)?await this.Z(i,f):this.Y(f)}if(this.L.set(o,0),(0,a.isFileOpenForWriteOptions)(r)&&this.N.set(o,i),l){const f=this.M.get(o);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${s})`),this.M.set(o,l),f&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${s})`),f.dispose())}return o}async close(i){const r=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await p.Promises.fdatasync(i)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await p.Promises.close(i)}catch(s){throw this.Y(s)}finally{r&&(this.M.get(i)===r&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),r.dispose())}}async read(i,r,s,l,o){const f=this.P(i,r);let y=null;try{y=(await p.Promises.read(i,s,l,o,f)).bytesRead}catch(M){throw this.Y(M)}finally{this.Q(i,f,y)}return y}P(i,r){return r===this.L.get(i)?null:r}Q(i,r,s){const l=this.L.get(i);typeof l=="number"&&(typeof r=="number"||(typeof s=="number"?this.L.set(i,l+s):this.L.delete(i)))}async write(i,r,s,l,o){return(0,n.retry)(()=>this.R(i,r,s,l,o),100,3)}async R(i,r,s,l,o){const f=this.P(i,r);let y=null;try{y=(await p.Promises.write(i,s,l,o,f)).bytesWritten}catch(M){throw await this.Z(this.N.get(i),M)}finally{this.Q(i,f,y)}return y}async mkdir(i){try{await p.Promises.mkdir(this.C(i))}catch(r){throw this.Y(r)}}async delete(i,r){try{const s=this.C(i);r.recursive?await p.Promises.rm(s,p.RimRafMode.MOVE):await p.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(i,r,s){const l=this.C(i),o=this.C(r);if(l!==o)try{await this.S(i,r,"move",s.overwrite),await p.Promises.move(l,o)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,w.localize)(2,null,(0,S.basename)(l),(0,S.basename)((0,S.dirname)(o)),f.toString()))),this.Y(f)}}async copy(i,r,s){const l=this.C(i),o=this.C(r);if(l!==o)try{await this.S(i,r,"copy",s.overwrite),await p.Promises.copy(l,o,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,w.localize)(3,null,(0,S.basename)(l),(0,S.basename)((0,S.dirname)(o)),f.toString()))),this.Y(f)}}async S(i,r,s,l){const o=this.C(i),f=this.C(r);let y=!1;if(!!(this.capabilities&1024)||(y=(0,d.isEqual)(o,f,!0)),y&&s==="copy")throw(0,a.createFileSystemProviderError)((0,w.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!y&&await p.Promises.exists(f)){if(!l)throw(0,a.createFileSystemProviderError)((0,w.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(i,r){return this.U(i,r,!1)}async U(i,r,s){const l=this.C(i),o=this.C(r),f=!!(this.capabilities&1024);if((0,d.isEqual)(l,o,!f))return;const y=new h.DisposableStore;try{const[M,O]=await Promise.all([this.I(i),this.I(r)]);y.add(M),y.add(O),s&&await p.Promises.mkdir((0,S.dirname)(o),{recursive:!0}),await p.Promises.copyFile(l,o)}catch(M){if(M.code==="ENOENT"&&!s)return this.U(i,r,!0);throw this.Y(M)}finally{y.dispose()}}p(i,r,s){return new E.UniversalWatcherClient(l=>i(l),l=>r(l),s)}y(i,r,s){return new L.NodeJSWatcherClient(l=>i(l),l=>r(l),s)}Y(i){if(i instanceof a.FileSystemProviderError)return i;let r;switch(i.code){case"ENOENT":r=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=a.FileSystemProviderErrorCode.NoPermissions;break;default:r=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(i,r)}async Z(i,r){let s=this.Y(r);if(i&&s.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await p.SymlinkSupport.stat(this.C(i));l.mode&128||(s=(0,a.createFileSystemProviderError)(r,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return s}}e.DiskFileSystemProvider=t,t.D=!1,t.O=!0}),define(ee[211],te([0,1,3,89,2,17,59,22]),function(x,e,I,R,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class d extends n.Disposable{constructor(v,b){super(),this.a=v,this.b=b,this.w=new Map,this.y=new Map}call(v,b,g){const p=this.c(v);switch(b){case"stat":return this.g(p,g[0]);case"readdir":return this.h(p,g[0]);case"open":return this.l(p,g[0],g[1]);case"close":return this.m(g[0]);case"read":return this.n(g[0],g[1],g[2]);case"readFile":return this.i(p,g[0],g[1]);case"write":return this.p(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.k(p,g[0],g[1],g[2]);case"rename":return this.t(p,g[0],g[1],g[2]);case"copy":return this.u(p,g[0],g[1],g[2]);case"cloneFile":return this.v(p,g[0],g[1]);case"mkdir":return this.r(p,g[0]);case"delete":return this.s(p,g[0],g[1]);case"watch":return this.C(p,g[0],g[1],g[2],g[3]);case"unwatch":return this.D(g[0],g[1])}throw new Error(`IPC Command ${b} not found`)}listen(v,b,g){const p=this.c(v);switch(b){case"fileChange":return this.z(p,g[0]);case"readFileStream":return this.j(p,g[0],g[1])}throw new Error(`Unknown event ${b}`)}g(v,b){const g=this.f(v,b,!0);return this.a.stat(g)}h(v,b){const g=this.f(v,b);return this.a.readdir(g)}async i(v,b,g){const p=this.f(v,b,!0),w=await this.a.readFile(p,g);return C.VSBuffer.wrap(w)}j(v,b,g){const p=this.f(v,b,!0),w=new P.CancellationTokenSource,a=new I.Emitter({onDidRemoveLastListener:()=>{w.cancel()}}),u=this.a.readFileStream(p,g,w.token);return(0,D.listenStream)(u,{onData:m=>a.fire(C.VSBuffer.wrap(m)),onError:m=>a.fire(m),onEnd:()=>{a.fire("end"),a.dispose(),w.dispose()}}),a.event}k(v,b,g,p){const w=this.f(v,b);return this.a.writeFile(w,g.buffer,p)}l(v,b,g){const p=this.f(v,b,!0);return this.a.open(p,g)}m(v){return this.a.close(v)}async n(v,b,g){const p=C.VSBuffer.alloc(g),w=0,a=await this.a.read(v,b,p.buffer,w,g);return[p,a]}p(v,b,g,p,w){return this.a.write(v,b,g.buffer,p,w)}r(v,b){const g=this.f(v,b);return this.a.mkdir(g)}s(v,b,g){const p=this.f(v,b);return this.a.delete(p,g)}t(v,b,g,p){const w=this.f(v,b),a=this.f(v,g);return this.a.rename(w,a,p)}u(v,b,g,p){const w=this.f(v,b),a=this.f(v,g);return this.a.copy(w,a,p)}v(v,b,g){const p=this.f(v,b),w=this.f(v,g);return this.a.cloneFile(p,w)}z(v,b){const g=new I.Emitter({onWillAddFirstListener:()=>{this.w.set(b,this.F(v,g))},onDidRemoveLastListener:()=>{(0,n.dispose)(this.w.get(b)),this.w.delete(b)}});return g.event}async C(v,b,g,p,w){const a=this.w.get(b);if(a){const u=this.f(v,p),m=a.watch(g,u,w);this.y.set(b+g,m)}}async D(v,b){const g=v+b,p=this.y.get(g);p&&((0,n.dispose)(p),this.y.delete(g))}dispose(){super.dispose();for(const[,v]of this.y)v.dispose();this.y.clear();for(const[,v]of this.w)v.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=d;class h extends n.Disposable{constructor(v,b,g,p){super(),this.c=v,this.f=g,this.g=p,this.a=new Map,this.b=this.B(new R.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(b)}h(v){const b=this.B(new I.Emitter);this.B(b.event(g=>{v.fire(g.map(p=>({resource:this.c.transformOutgoingURI(p.resource),type:p.type})))})),this.B(this.b.onDidChangeFile(g=>b.fire(g))),this.B(this.b.onDidWatchError(g=>v.fire(g)))}i(v){}j(v){}watch(v,b,g){const p=this.j(this.g);return Array.isArray(p)&&(g.excludes=[...g.excludes,...p]),this.a.set(v,this.b.watch(b,g)),(0,n.toDisposable)(()=>{(0,n.dispose)(this.a.get(v)),this.a.delete(v)})}dispose(){super.dispose();for(const[,v]of this.a)v.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=h}),define(ee[212],te([0,1,14,166,4,7,16,9,211,145]),function(x,e,I,R,n,C,D,P,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class S extends d.AbstractDiskFileSystemProviderChannel{constructor(g,p,w){super(g,p),this.G=w}c(g){return h.DefaultURITransformer}f(g,p){return C.URI.revive(p)}async s(g,p,w){if(!w.useTrash)return super.s(g,p,w);const a=this.f(g,p),u=(0,P.normalize)(a.fsPath);try{await I.shell.trashItem(u)}catch{throw(0,D.createFileSystemProviderError)(n.isWindows?(0,R.localize)(0,null,(0,P.basename)(u)):(0,R.localize)(1,null,(0,P.basename)(u)),D.FileSystemProviderErrorCode.Unknown)}}F(g,p){return new v(g,p,this.b,this.G)}}e.DiskFileSystemProviderChannel=S;class v extends d.AbstractSessionFileWatcher{watch(g,p,w){if(w.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(g,p,w)}}}),define(ee[213],te([0,1,5]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class R extends I.AbstractMessageLogger{constructor(C=I.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(C),this.B(this.onDidChangeLogLevel(D=>{this.l?.setLevel(D)}))}set logger(C){this.l=C;for(const{level:D,message:P}of this.k)(0,I.log)(C,D,P);this.k=[]}g(C,D){this.l?(0,I.log)(this.l,C,D):this.getLevel()<=C&&this.k.push({level:C,message:D})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogger=R}),define(ee[214],te([0,1,2,5]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class n extends I.Disposable{constructor(D,P=[]){super(),this.a=new R.MultiplexLogger([D,...P]),this.B(D.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...P){this.a.trace(D,...P)}debug(D,...P){this.a.debug(D,...P)}info(D,...P){this.a.info(D,...P)}warn(D,...P){this.a.warn(D,...P)}error(D,...P){this.a.error(D,...P)}flush(){this.a.flush()}}e.LogService=n}),define(ee[215],te([0,1,35,7,5]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class C{constructor(P){this.b=P,this.a=new I.ResourceMap}listen(P,d,h){switch(d){case"onDidChangeLoggers":return h?this.b.getOnDidChangeLoggersEvent(h):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return h?this.b.getOnDidChangeLogLevelEvent(h):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return h?this.b.getOnDidChangeVisibilityEvent(h):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${d}`)}async call(P,d,h){switch(d){case"createLogger":this.c(R.URI.revive(h[0]),h[1],h[2]);return;case"log":return this.e(R.URI.revive(h[0]),h[1]);case"consoleLog":return this.d(h[0],h[1]);case"setLogLevel":return this.b.setLogLevel(R.URI.revive(h[0]),h[1]);case"setVisibility":return this.b.setVisibility(R.URI.revive(h[0]),h[1]);case"registerLogger":return this.b.registerLogger({...h[0],resource:R.URI.revive(h[0].resource)},h[1]);case"deregisterLogger":return this.b.deregisterLogger(R.URI.revive(h[0]))}throw new Error(`Call not found: ${d}`)}c(P,d,h){this.a.set(P,this.b.createLogger(P,d,h))}d(P,d){let h=console.log;switch(P){case n.LogLevel.Error:h=console.error;break;case n.LogLevel.Warning:h=console.warn;break;case n.LogLevel.Info:h=console.info;break}h.call(console,...d)}e(P,d){const h=this.a.get(P);if(!h)throw new Error("Create the logger before logging");for(const[S,v]of d)(0,n.log)(h,S,v)}}e.LoggerChannel=C}),define(ee[216],te([0,1,16,5]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var n;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(n||(n={}));async function C(h,S,v,b,g){try{const p=await new Promise((a,u)=>{x(["spdlog"],a,u)});p.setFlushOn(n.Trace);const w=await p.createAsyncRotatingLogger(h,S,v,b);return g?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(p){console.error(p)}return null}function D(h,S,v){switch(S){case R.LogLevel.Trace:h.trace(v);break;case R.LogLevel.Debug:h.debug(v);break;case R.LogLevel.Info:h.info(v);break;case R.LogLevel.Warning:h.warn(v);break;case R.LogLevel.Error:h.error(v);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${S}`)}}function P(h,S){switch(S){case R.LogLevel.Trace:h.setLevel(n.Trace);break;case R.LogLevel.Debug:h.setLevel(n.Debug);break;case R.LogLevel.Info:h.setLevel(n.Info);break;case R.LogLevel.Warning:h.setLevel(n.Warning);break;case R.LogLevel.Error:h.setLevel(n.Error);break;case R.LogLevel.Off:h.setLevel(n.Off);break;default:throw new Error(`Invalid log level ${S}`)}}class d extends R.AbstractMessageLogger{constructor(S,v,b,g,p){super(),this.k=[],this.setLevel(p),this.l=this.n(S,v,b,g),this.B(this.onDidChangeLogLevel(w=>{this.m&&P(this.m,w)}))}async n(S,v,b,g){const p=b?6:1,w=30/p*I.ByteSize.MB,a=await C(S,v,w,p,g);if(a){this.m=a,P(this.m,this.getLevel());for(const{level:u,message:m}of this.k)D(this.m,u,m);this.k=[]}}g(S,v){this.m?D(this.m,S,v):this.getLevel()<=S&&this.k.push({level:S,message:v})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=d}),define(ee[217],te([0,1,31,5,216]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class C extends R.AbstractLoggerService{k(P,d,h){return new n.SpdLogLogger((0,I.generateUuid)(),P.fsPath,!h?.donotRotate,!!h?.donotUseFormatters,d)}}e.LoggerService=C}),define(ee[64],te([0,1,35,3,6,5,217]),function(x,e,I,R,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,n.refineServiceDecorator)(C.ILoggerService);class P extends D.LoggerService{constructor(){super(...arguments),this.m=new I.ResourceMap}createLogger(h,S,v){v!==void 0&&this.m.set(h,v);try{return super.createLogger(h,S)}catch(b){throw this.m.delete(h),b}}registerLogger(h,S){S!==void 0&&this.m.set(h.resource,S),super.registerLogger(h)}deregisterLogger(h){this.m.delete(h),super.deregisterLogger(h)}getRegisteredLoggers(h){const S=[];for(const v of super.getRegisteredLoggers())h===this.m.get(v.resource)&&S.push(v);return S}getOnDidChangeLogLevelEvent(h){return R.Event.filter(this.onDidChangeLogLevel,S=>(0,C.isLogLevel)(S)||this.n(S[0],h))}getOnDidChangeVisibilityEvent(h){return R.Event.filter(this.onDidChangeVisibility,([S])=>this.n(S,h))}getOnDidChangeLoggersEvent(h){return R.Event.filter(R.Event.map(this.onDidChangeLoggers,S=>({added:[...S.added].filter(b=>this.n(b.resource,h)),removed:[...S.removed].filter(b=>this.n(b.resource,h))})),S=>S.added.length>0||S.removed.length>0)}deregisterLoggers(h){for(const[S,v]of this.m)v===h&&this.deregisterLogger(S)}n(h,S){const v=this.m.get(h);return v===void 0||v===S}dispose(){super.dispose(),this.m.clear()}}e.LoggerMainService=P}),define(ee[218],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function I(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=I;function R(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=R;function n(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=n;function C(D){return!I(D)&&!R(D)&&!n(D)}e.isMenubarMenuItemAction=C}),define(ee[38],te([0,1,3,69,2,6]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,C.createDecorator)("policy");class D extends n.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(h){const S=Object.keys(this.f).length;return this.f={...h,...this.f},S!==Object.keys(this.f).length&&await this.i(h),R.Iterable.reduce(this.g.entries(),(v,[b,g])=>({...v,[b]:g}),{})}getPolicyValue(h){return this.g.get(h)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(h,[S,v])=>({...h,[S]:{definition:v,value:this.g.get(S)}}),{})}}e.AbstractPolicyService=D;class P{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ee[219],te([0,1,8,3,69,10,16,5,38]),function(x,e,I,R,n,C,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function h(v,b){const g=[];for(const p of new Set(n.Iterable.concat(v.keys(),b.keys())))v.get(p)!==b.get(p)&&g.push(p);return g}let S=class extends d.AbstractPolicyService{constructor(b,g,p){super(),this.j=b,this.k=g,this.l=p,this.c=this.B(new I.ThrottledDelayer(500));const w=R.Event.filter(g.onDidFilesChange,a=>a.affects(b));this.B(g.watch(b)),this.B(w(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const b=new Map;try{const g=await this.k.readFile(this.j),p=JSON.parse(g.value.toString());if(!(0,C.isObject)(p))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(p))this.f[w]&&b.set(w,p[w])}catch(g){g.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",g)}return b}async p(){const b=await this.n(),g=h(this.g,b);this.g=b,g.length>0&&this.h.fire(g)}};S=we([_(1,D.IFileService),_(2,P.ILogService)],S),e.FilePolicyService=S}),define(ee[220],te([0,1,3,2,38]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class C{constructor(d){this.b=d,this.a=new R.DisposableStore}listen(d,h){switch(h){case"onDidChange":return I.Event.map(this.b.onDidChange,S=>S.reduce((v,b)=>({...v,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${h}`)}call(d,h,S){switch(h){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(S)}throw new Error(`Call not found: ${h}`)}dispose(){this.a.dispose()}}e.PolicyChannel=C;class D extends n.AbstractPolicyService{constructor(d,h){super(),this.a=h;for(const S in d){const{definition:v,value:b}=d[S];this.f[S]=v,b!==void 0&&this.g.set(S,b)}this.a.listen("onDidChange")(S=>{for(const v in S){const b=S[v];b===null?this.g.delete(v):this.g.set(v,b)}this.h.fire(Object.keys(S))})}async i(d){const h=await this.a.call("updatePolicyDefinitions",d);for(const S in h)this.g.set(S,h[S])}}e.PolicyChannelClient=D}),define(ee[65],te([0,1,4,36]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let n;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.context<"u"){const C=I.globals.vscode.context.configuration();if(C)n=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(n=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(n,{nameShort:`${n.nameShort} Dev`,nameLong:`${n.nameLong} Dev`,dataFolderName:`${n.dataFolderName}-dev`,serverDataFolderName:n.serverDataFolderName?`${n.serverDataFolderName}-dev`:void 0}),!n.version){const C=globalThis._VSCODE_PACKAGE_JSON;Object.assign(n,{version:C.version})}}else n={},Object.keys(n).length===0&&Object.assign(n,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=n}),define(ee[19],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[221],te([0,1,80,5,19]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let C=class{constructor(P,d){this.b=P,this.c=d,this.a=new Map}async isExtensionUrlTrusted(P,d){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const h=/^(.*)#([^#]+)$/.exec(d);if(!h)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",d),!1;const[,S,v]=h;let b=this.a.get(P);if(!b){if(b=this.b.trustedExtensionUrlPublicKeys[P],!b||b.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.a.set(P,[...b])}const g=Buffer.from(decodeURIComponent(v),"base64");if(g.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",d),!1;const p=g.slice(0,6),w=g.readUIntBE(0,6),a=Date.now()-w;if(a<0||a>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",d),!1;const u=g.slice(6),m=I.createVerify("SHA256");m.write(p),m.write(Buffer.from(S)),m.end();for(let k=0;k<b.length;k++){let E=b[k];if(E!==null){if(typeof E=="string")try{E=I.createPublicKey({key:Buffer.from(E,"base64"),format:"der",type:"spki"}),b[k]=E}catch(L){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${k+1} for ${P}:`,L),b[k]=null;continue}if(m.verify(E,u))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",d),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",d),!1}};C=we([_(0,n.IProductService),_(1,R.ILogService)],C),e.ExtensionUrlTrustService=C}),define(ee[222],te([0,1,8,5]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let n=class{constructor(D,P,d){this.a=D,this.b=P,this.c=d}async inspect(D){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,I.timeout)(D);const d=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),d.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};n=we([_(2,R.ILogService)],n),e.WindowProfiler=n}),define(ee[66],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,I.createDecorator)("protocolMainService")}),define(ee[50],te([0,1,123,10]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class n{constructor(){this.a=new Map}add(D,P){I.ok(R.isString(D)),I.ok(R.isObject(P)),I.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,P)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.Registry=new n}),define(ee[223],te([0,1,3,50]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function n(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class C{constructor(){this.b=new I.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,h){this.a[n(d)]=h,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const D=new C;R.Registry.add(e.Extensions.JSONContribution,D)}),define(ee[67],te([0,1,25,3,10,154,18,223,50]),function(x,e,I,R,n,C,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(L){L.Multiline="multilineText",L.Singleline="singlelineText"})(h=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(L){L[L.APPLICATION=1]="APPLICATION",L[L.MACHINE=2]="MACHINE",L[L.WINDOW=3]="WINDOW",L[L.RESOURCE=4]="RESOURCE",L[L.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",L[L.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const v=d.Registry.as(P.Extensions.JSONContribution);class b{constructor(){this.h=new Set,this.i=new R.Emitter,this.onDidSchemaChange=this.i.event,this.j=new R.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const i=new Set;this.n(t,c,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const c=new Set;this.o(t,c),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:t,remove:c}){const i=new Set;this.o(c,i),this.n(t,!1,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const c=new Set;this.k(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(t,c){const i=[];for(const{overrides:r,source:s}of t)for(const l in r)if(c.add(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const o=this.a.get(l),f=o?.valuesSources??new Map;if(s)for(const j of Object.keys(r[l]))f.set(j,s);const y={...o?.value||{},...r[l]};this.a.set(l,{source:s,value:y,valuesSources:f});const M=(0,D.getLanguageTagSettingPlainKey)(l),O={type:"object",default:y,description:C.localize(1,null,M),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:y,source:n.isString(s)?void 0:s,defaultValueSource:s};i.push(...w(l)),this.d[l]=O,this.b.properties[l]=O}else{this.a.set(l,{value:r[l],source:s});const o=this.d[l];o&&(this.w(l,o),this.r(l,o))}this.m(i)}deregisterDefaultConfigurations(t){const c=new Set;this.l(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(t,c){for(const{overrides:i,source:r}of t)for(const s in i){const l=this.a.get(s),o=n.isString(r)?r:r?.id,f=n.isString(l?.source)?l?.source:l?.source?.id;if(o===f)if(c.add(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const y=this.d[s];y&&(this.w(s,y),this.r(s,y))}}this.u()}deltaConfiguration(t){let c=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),c=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),c=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const c of t)this.h.add(c);this.u()}n(t,c,i){t.forEach(r=>{this.p(r,c,r.extensionInfo,r.restrictedProperties,void 0,i),this.c.push(r),this.q(r)})}o(t,c){const i=r=>{if(r.properties)for(const s in r.properties){c.add(s);const l=this.d[s];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[s],this.s(s,r.properties[s])}r.allOf?.forEach(s=>i(s))};for(const r of t){i(r);const s=this.c.indexOf(r);s!==-1&&this.c.splice(s,1)}}p(t,c=!0,i,r,s=3,l){s=n.isUndefinedOrNull(t.scope)?s:t.scope;const o=t.properties;if(o)for(const y in o){const M=o[y];if(c&&k(y,M)){delete o[y];continue}if(M.source=i,M.defaultDefaultValue=o[y].default,this.w(y,M),e.OVERRIDE_PROPERTY_REGEX.test(y)?M.scope=void 0:(M.scope=n.isUndefinedOrNull(M.scope)?s:M.scope,M.restricted=n.isUndefinedOrNull(M.restricted)?!!r?.includes(y):M.restricted),o[y].hasOwnProperty("included")&&!o[y].included){this.f[y]=o[y],delete o[y];continue}else this.d[y]=o[y],o[y].policy?.name&&this.e.set(o[y].policy.name,y);!o[y].deprecationMessage&&o[y].markdownDeprecationMessage&&(o[y].deprecationMessage=o[y].markdownDeprecationMessage),l.add(y)}const f=t.allOf;if(f)for(const y of f)this.p(y,c,i,r,s,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const c=i=>{const r=i.properties;if(r)for(const l in r)this.r(l,r[l]);i.allOf?.forEach(c)};c(t)}r(t,c){switch(e.allSettings.properties[t]=c,c.scope){case 1:e.applicationSettings.properties[t]=c;break;case 2:e.machineSettings.properties[t]=c;break;case 6:e.machineOverridableSettings.properties[t]=c;break;case 3:e.windowSettings.properties[t]=c;break;case 4:e.resourceSettings.properties[t]=c;break;case 5:e.resourceSettings.properties[t]=c,this.g.properties[t]=c;break}}s(t,c){switch(delete e.allSettings.properties[t],c.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const c=`[${t}]`,i={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(c,i),e.allSettings.properties[c]=i,e.applicationSettings.properties[c]=i,e.machineSettings.properties[c]=i,e.machineOverridableSettings.properties[c]=i,e.windowSettings.properties[c]=i,e.resourceSettings.properties[c]=i}}v(){const t={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,c){const i=this.a.get(t);let r=i?.value,s=i?.source;n.isUndefined(r)&&(r=c.defaultDefaultValue,s=void 0),n.isUndefined(r)&&(r=u(c.type)),c.default=r,c.defaultValueSource=s}}const g="\\[([^\\]]+)\\]",p=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(L){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(L)){let c=p.exec(L);for(;c?.length;){const i=c[1].trim();i&&t.push(i),c=p.exec(L)}}return(0,I.distinct)(t)}e.overrideIdentifiersFromKey=w;function a(L){return L.reduce((t,c)=>`${t}[${c}]`,"")}e.keyFromOverrideIdentifiers=a;function u(L){switch(Array.isArray(L)?L[0]:L){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const m=new b;d.Registry.add(e.Extensions.Configuration,m);function k(L,t){return L.trim()?e.OVERRIDE_PROPERTY_REGEX.test(L)?C.localize(7,null,L):m.getConfigurationProperties()[L]!==void 0?C.localize(8,null,L):t.policy?.name&&m.getPolicyConfigurations().get(t.policy?.name)!==void 0?C.localize(9,null,L,t.policy?.name,m.getPolicyConfigurations().get(t.policy?.name)):null:C.localize(6,null)}e.validateProperty=k;function E(){const L=[],t=m.getConfigurationProperties();for(const c of Object.keys(t))L.push([c,t[c].scope]);return L.push(["launch",4]),L.push(["task",4]),L}e.getScopes=E}),define(ee[111],te([0,1,25,3,43,2,35,44,10,7,18,67,50]),function(x,e,I,R,n,C,D,P,d,h,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function g(c){return Object.isFrozen(c)?c:P.deepFreeze(c)}class p{constructor(i={},r=[],s=[],l){this.b=i,this.c=r,this.d=s,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(r=>{if(r instanceof p)return r;const s=new w("");return s.parseRaw(r),s.configurationModel});this.f=i.reduce((r,s)=>s===r?s:r.merge(s),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,S.getConfigurationValue)(this.contents,i):this.contents}inspect(i,r){const s=this.rawConfiguration.getValue(i),l=r?this.rawConfiguration.getOverrideValue(i,r):void 0,o=r?this.rawConfiguration.override(r).getValue(i):s;return{value:s,override:l,merged:o}}getOverrideValue(i,r){const s=this.i(r);return s?i?(0,S.getConfigurationValue)(s,i):s:void 0}getKeysForOverrideIdentifier(i){const r=[];for(const s of this.overrides)s.identifiers.includes(i)&&r.push(...s.keys);return I.distinct(r)}getAllOverrideIdentifiers(){const i=[];for(const r of this.overrides)i.push(...r.identifiers);return I.distinct(i)}override(i){let r=this.a.get(i);return r||(r=this.g(i),this.a.set(i,r)),r}merge(...i){const r=P.deepClone(this.contents),s=P.deepClone(this.overrides),l=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const f of i)if(o.push(...f.raw?.length?f.raw:[f]),!f.isEmpty()){this.h(r,f.contents);for(const y of f.overrides){const[M]=s.filter(O=>I.equals(O.identifiers,y.identifiers));M?(this.h(M.contents,y.contents),M.keys.push(...y.keys),M.keys=I.distinct(M.keys)):s.push(P.deepClone(y))}for(const y of f.keys)l.indexOf(y)===-1&&l.push(y)}return new p(r,l,s,o.every(f=>f instanceof p)?void 0:o)}g(i){const r=this.i(i);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const s={};for(const l of I.distinct([...Object.keys(this.contents),...Object.keys(r)])){let o=this.contents[l];const f=r[l];f&&(typeof o=="object"&&typeof f=="object"?(o=P.deepClone(o),this.h(o,f)):o=f),s[l]=o}return new p(s,this.keys,this.overrides)}h(i,r){for(const s of Object.keys(r)){if(s in i&&d.isObject(i[s])&&d.isObject(r[s])){this.h(i[s],r[s]);continue}i[s]=P.deepClone(r[s])}}i(i){let r=null,s=null;const l=o=>{o&&(s?this.h(s,o):s=P.deepClone(o))};for(const o of this.overrides)I.equals(o.identifiers,[i])?r=o.contents:o.identifiers.includes(i)&&l(o.contents);return l(r),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,r){this.j(i,r,!0)}setValue(i,r){this.j(i,r,!1)}removeValue(i){const r=this.keys.indexOf(i);r!==-1&&(this.keys.splice(r,1),(0,S.removeFromValueTree)(this.contents,i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(s=>I.equals(s.identifiers,(0,v.overrideIdentifiersFromKey)(i))),1))}j(i,r,s){(0,S.addToValueTree)(this.contents,i,r,l=>console.error(l)),s=s||this.keys.indexOf(i)===-1,s&&this.keys.push(i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,v.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,S.toValuesTree)(this.contents[i],l=>console.error(l))})}}e.ConfigurationModel=p;class w{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,r){if(!d.isUndefinedOrNull(i)){const s=this.g(i);this.parseRaw(s,r)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,r){this.a=i;const{contents:s,keys:l,overrides:o,restricted:f,hasExcludedProperties:y}=this.h(i,r);this.b=new p(s,l,o,y?[i]:void 0),this.c=f||[]}g(i){let r={},s=null,l=[];const o=[],f=[];function y(O){Array.isArray(l)?l.push(O):s!==null&&(l[s]=O)}const M={onObjectBegin:()=>{const O={};y(O),o.push(l),l=O,s=null},onObjectProperty:O=>{s=O},onObjectEnd:()=>{l=o.pop()},onArrayBegin:()=>{const O=[];y(O),o.push(l),l=O,s=null},onArrayEnd:()=>{l=o.pop()},onLiteralValue:y,onError:(O,j,G)=>{f.push({error:O,offset:j,length:G})}};if(i)try{n.visit(i,M),r=l[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return r}h(i,r){const s=b.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),l=this.i(i,s,!0,r);i=l.raw;const o=(0,S.toValuesTree)(i,M=>console.error(`Conflict in settings file ${this.f}: ${M}`)),f=Object.keys(i),y=this.j(i,M=>console.error(`Conflict in settings file ${this.f}: ${M}`));return{contents:o,keys:f,overrides:y,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(i,r,s,l){let o=!1;if(!l?.scopes&&!l?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:o};const f={},y=[];for(const M in i)if(v.OVERRIDE_PROPERTY_REGEX.test(M)&&s){const O=this.i(i[M],r,!1,l);f[M]=O.raw,o=o||O.hasExcludedProperties,y.push(...O.restricted)}else{const O=r[M],j=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&y.push(M),(j===void 0||l.scopes===void 0||l.scopes.includes(j))&&!(l.skipRestricted&&O?.restricted)?f[M]=i[M]:o=!0}return{raw:f,restricted:y,hasExcludedProperties:o}}j(i,r){const s=[];for(const l of Object.keys(i))if(v.OVERRIDE_PROPERTY_REGEX.test(l)){const o={};for(const f in i[l])o[f]=i[l][f];s.push({identifiers:(0,v.overrideIdentifiersFromKey)(l),keys:Object.keys(o),contents:(0,S.toValuesTree)(o,r)})}return s}}e.ConfigurationModelParser=w;class a extends C.Disposable{constructor(i,r,s,l){super(),this.f=i,this.g=r,this.h=l,this.c=this.B(new R.Emitter),this.onDidChange=this.c.event,this.a=new w(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(R.Event.any(R.Event.filter(this.h.onDidFilesChange,o=>o.contains(this.f)),R.Event.filter(this.h.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&s.isEqual(o.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=a;class u{constructor(i,r,s,l,o,f,y,M,O,j,G,H,K){this.a=i,this.b=r,this.c=s,this.overrideIdentifiers=l,this.d=o,this.f=f,this.g=y,this.h=M,this.i=O,this.j=j,this.k=G,this.l=H,this.m=K}get value(){return g(this.c)}n(i,r,s){const l=i.inspect(r,s);return{get value(){return g(l.value)},get override(){return g(l.override)},get merged(){return g(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class m{constructor(i,r,s,l,o=new p,f=new p,y=new D.ResourceMap,M=new p,O=new D.ResourceMap){this.c=i,this.d=r,this.f=s,this.g=l,this.h=o,this.i=f,this.j=y,this.l=M,this.m=O,this.a=null,this.b=new D.ResourceMap,this.n=null}getValue(i,r,s){return this.q(i,r,s).getValue(i)}updateValue(i,r,s={}){let l;s.resource?(l=this.m.get(s.resource),l||(l=new p,this.m.set(s.resource,l))):l=this.l,r===void 0?l.removeValue(i):l.setValue(i,r),s.resource||(this.a=null)}inspect(i,r,s){const l=this.q(i,r,s),o=this.u(r.resource,s),f=r.resource?this.m.get(r.resource)||this.l:this.l,y=new Set;for(const M of l.overrides)for(const O of M.identifiers)l.getOverrideValue(i,O)!==void 0&&y.add(O);return new u(i,r,l.getValue(i),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,o||void 0,f)}keys(i){const r=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:r?r.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,r){this.j.set(i,r),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,r){const s=[];if(!r){const{added:l,updated:o,removed:f}=L(this.c,i);r=[...l,...o,...f]}for(const l of r)for(const o of(0,v.overrideIdentifiersFromKey)(l)){const f=this.c.getKeysForOverrideIdentifier(o),y=i.getKeysForOverrideIdentifier(o),M=[...y.filter(O=>f.indexOf(O)===-1),...f.filter(O=>y.indexOf(O)===-1),...f.filter(O=>!P.equals(this.c.override(o).getValue(O),i.override(o).getValue(O)))];s.push([o,M])}return this.updateDefaultConfiguration(i),{keys:r,overrides:s}}compareAndUpdatePolicyConfiguration(i){const{added:r,updated:s,removed:l}=L(this.d,i),o=[...r,...s,...l];return o.length&&this.updatePolicyConfiguration(i),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:r,updated:s,removed:l,overrides:o}=L(this.applicationConfiguration,i),f=[...r,...s,...l];return f.length&&this.updateApplicationConfiguration(i),{keys:f,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:r,updated:s,removed:l,overrides:o}=L(this.localUserConfiguration,i),f=[...r,...s,...l];return f.length&&this.updateLocalUserConfiguration(i),{keys:f,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:r,updated:s,removed:l,overrides:o}=L(this.remoteUserConfiguration,i),f=[...r,...s,...l];return f.length&&this.updateRemoteUserConfiguration(i),{keys:f,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:r,updated:s,removed:l,overrides:o}=L(this.workspaceConfiguration,i),f=[...r,...s,...l];return f.length&&this.updateWorkspaceConfiguration(i),{keys:f,overrides:o}}compareAndUpdateFolderConfiguration(i,r){const s=this.p.get(i),{added:l,updated:o,removed:f,overrides:y}=L(s,r),M=[...l,...o,...f];return(M.length||!s)&&this.updateFolderConfiguration(i,r),{keys:M,overrides:y}}compareAndDeleteFolderConfiguration(i){const r=this.p.get(i);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:s,updated:l,removed:o,overrides:f}=L(r,void 0);return{keys:[...s,...l,...o],overrides:f}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,r,s){let l=this.r(r,s);return r.overrideIdentifier&&(l=l.override(r.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(l=l.merge(this.d)),l}r({resource:i},r){let s=this.s();if(r&&i){const l=r.getFolder(i);l&&(s=this.t(l.uri)||s);const o=this.m.get(i);o&&(s=s.merge(o))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let r=this.b.get(i);if(!r){const s=this.s(),l=this.j.get(i);l?(r=s.merge(l),this.b.set(i,r)):r=s}return r}u(i,r){if(r&&i){const s=r.getFolder(i);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,r)=>{const{contents:s,overrides:l,keys:o}=this.j.get(r);return i.push([r,{contents:s,overrides:l,keys:o}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(r=>i.add(r)),this.userConfiguration.keys.forEach(r=>i.add(r)),this.i.keys.forEach(r=>i.add(r)),this.j.forEach(r=>r.keys.forEach(s=>i.add(s))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this.userConfiguration.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this.i.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this.j.forEach(r=>r.getAllOverrideIdentifiers().forEach(s=>i.add(s))),[...i.values()]}w(i){const r=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>r.add(s)),this.i.getKeysForOverrideIdentifier(i).forEach(s=>r.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(i).forEach(l=>r.add(l))),[...r.values()]}static parse(i){const r=this.x(i.defaults),s=this.x(i.policy),l=this.x(i.application),o=this.x(i.user),f=this.x(i.workspace),y=i.folders.reduce((M,O)=>(M.set(h.URI.revive(O[0]),this.x(O[1])),M),new D.ResourceMap);return new m(r,s,l,o,new p,f,y,new p,new D.ResourceMap)}static x(i){return new p(i.contents,i.keys,i.overrides)}}e.Configuration=m;function k(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,r=new Map;for(const l of c)l.keys.forEach(o=>i.add(o)),l.overrides.forEach(([o,f])=>{const y=(0,D.getOrSet)(r,o,new Set);f.forEach(M=>y.add(M))});const s=[];return r.forEach((l,o)=>s.push([o,[...l.values()]])),{keys:[...i.values()],overrides:s}}e.mergeChanges=k;class E{constructor(i,r,s,l){this.change=i,this.f=r,this.g=s,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of i.keys)this.affectedKeys.add(o);for(const[,o]of i.overrides)for(const f of o)this.affectedKeys.add(f);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=m.parse(this.f.data)),this.i}affectsConfiguration(i,r){const s=this.a+i,l=this.d.indexOf(s);if(l<0)return!1;const o=l+s.length;if(o>=this.d.length)return!1;const f=this.d.charCodeAt(o);if(f!==this.b&&f!==this.c)return!1;if(r){const y=this.previousConfiguration?this.previousConfiguration.getValue(i,r,this.f?.workspace):void 0,M=this.g.getValue(i,r,this.h);return!P.equals(y,M)}return!0}}e.ConfigurationChangeEvent=E;function L(c,i){const{added:r,removed:s,updated:l}=t(i?.rawConfiguration,c?.rawConfiguration),o=[],f=c?.getAllOverrideIdentifiers()||[],y=i?.getAllOverrideIdentifiers()||[];if(i){const M=y.filter(O=>!f.includes(O));for(const O of M)o.push([O,i.getKeysForOverrideIdentifier(O)])}if(c){const M=f.filter(O=>!y.includes(O));for(const O of M)o.push([O,c.getKeysForOverrideIdentifier(O)])}if(i&&c){for(const M of f)if(y.includes(M)){const O=t({contents:c.getOverrideValue(void 0,M)||{},keys:c.getKeysForOverrideIdentifier(M)},{contents:i.getOverrideValue(void 0,M)||{},keys:i.getKeysForOverrideIdentifier(M)});o.push([M,[...O.added,...O.removed,...O.updated]])}}return{added:r,removed:s,updated:l,overrides:o}}function t(c,i){const r=c?i?c.keys.filter(o=>i.keys.indexOf(o)===-1):[...c.keys]:[],s=i?c?i.keys.filter(o=>c.keys.indexOf(o)===-1):[...i.keys]:[],l=[];if(c&&i){for(const o of i.keys)if(c.keys.indexOf(o)!==-1){const f=(0,S.getConfigurationValue)(i.contents,o),y=(0,S.getConfigurationValue)(c.contents,o);P.equals(f,y)||l.push(o)}}return{added:r,removed:s,updated:l}}}),define(ee[224],te([0,1,25,3,2,44,10,111,67,5,38,50]),function(x,e,I,R,n,C,D,P,d,h,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class b extends n.Disposable{constructor(){super(...arguments),this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:a,defaultsOverrides:u})=>this.c(Array.from(a),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(a,u){this.h(a,v.Registry.as(d.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:a})}f(){return{}}g(){this.b=new P.ConfigurationModel;const a=v.Registry.as(d.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(a),a)}h(a,u){const m=this.f();for(const k of a){const E=m[k],L=u[k];E!==void 0?this.b.addValue(k,E):L?this.b.addValue(k,L.default):this.b.removeValue(k)}}}e.DefaultConfiguration=b;class g{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let p=class extends n.Disposable{get configurationModel(){return this.b}constructor(a,u,m){super(),this.c=a,this.f=u,this.g=m,this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(a=>this.i(a))),this.B(this.c.onDidChangeConfiguration(async({properties:a})=>this.j(await this.h(a),!0))),this.b}async h(a){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",a);const u={},m=[],k=v.Registry.as(d.Extensions.Configuration).getConfigurationProperties();for(const E of a){const L=k[E];if(!L){m.push(E);continue}if(L.policy){if(L.type!=="string"&&L.type!=="number"){this.g.warn(`Policy ${L.policy.name} has unsupported type ${L.type}`);continue}m.push(E),u[L.policy.name]={type:L.type}}}return(0,D.isEmptyObject)(u)||await this.f.updatePolicyDefinitions(u),m}i(a){this.g.trace("PolicyConfiguration#onDidChangePolicies",a);const u=v.Registry.as(d.Extensions.Configuration).getPolicyConfigurations(),m=(0,I.coalesce)(a.map(k=>u.get(k)));this.j(m,!0)}j(a,u){this.g.trace("PolicyConfiguration#update",a);const m=v.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),k=[],E=this.b.isEmpty();for(const L of a){const t=m[L]?.policy?.name;if(t){const c=this.f.getPolicyValue(t);(E?c!==void 0:!(0,C.equals)(this.b.getValue(L),c))&&k.push([L,c])}else this.b.getValue(L)!==void 0&&k.push([L,void 0])}if(k.length){this.g.trace("PolicyConfiguration#changed",k);const L=this.b;this.b=new P.ConfigurationModel;for(const t of L.keys)this.b.setValue(t,L.getValue(t));for(const[t,c]of k)c===void 0?this.b.removeValue(t):this.b.setValue(t,c);u&&this.a.fire(this.b)}}};p=we([_(1,S.IPolicyService),_(2,h.ILogService)],p),e.PolicyConfiguration=p}),define(ee[225],te([0,1,8,3,2,20,18,111,224,38]),function(x,e,I,R,n,C,D,P,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class S extends n.Disposable{constructor(b,g,p,w){super(),this.i=b,this.h=this.B(new R.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new d.DefaultConfiguration),this.c=p instanceof h.NullPolicyService?new d.NullPolicyConfiguration:this.B(new d.PolicyConfiguration(this.b,p,w)),this.f=this.B(new P.UserSettings(this.i,void 0,C.extUriBiasedIgnorePathCase,g)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new I.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:a,properties:u})=>this.k(a,u))),this.B(this.c.onDidChangeConfiguration(a=>this.l(a))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,g,p]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(b,g,new P.ConfigurationModel,p)}getConfigurationData(){return this.a.toData()}getValue(b,g){const p=typeof b=="string"?b:void 0,w=(0,D.isConfigurationOverrides)(b)?b:(0,D.isConfigurationOverrides)(g)?g:{};return this.a.getValue(p,w,void 0)}updateValue(b,g,p,w){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.j(b)}j(b){const g=this.a.toData(),p=this.a.compareAndUpdateLocalUserConfiguration(b);this.m(p,g,2)}k(b,g){const p=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(b,g);this.m(w,p,7)}l(b){const g=this.a.toData(),p=this.a.compareAndUpdatePolicyConfiguration(b);this.m(p,g,7)}m(b,g,p){const w=new P.ConfigurationChangeEvent(b,{data:g},this.a);w.source=p,w.sourceConfig=this.n(p),this.h.fire(w)}n(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=S}),define(ee[226],te([0,1,13,6]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var n;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends I.ErrorNoTelemetry{static isNotAvailable(d){return d instanceof C&&d._code===n.NotAvailable}static isTemporarilyNotAvailable(d){return d instanceof C&&d._code===n.TemporarilyNotAvailable}static isNoResolverFound(d){return d instanceof C&&d._code===n.NoResolverFound}static isHandled(d){return d instanceof C&&d.isHandled}constructor(d,h=n.Unknown,S){super(d),this._message=d,this._code=h,this._detail=S,this.isHandled=h===n.NotAvailable&&S===!0,Object.setPrototypeOf(this,C.prototype)}}e.RemoteAuthorityResolverError=C;function D(P){const d=P.indexOf("+");return d===-1?P:P.substring(0,d)}e.getRemoteAuthorityPrefix=D}),define(ee[55],te([0,1,15]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(h){return h.scheme===I.Schemas.vscodeRemote?h.authority:void 0}e.getRemoteAuthority=R;function n(h){if(!h)return;const S=h.indexOf("+");return S<0?h:h.substr(0,S)}e.getRemoteName=n;function C(h){return`/${h.quality??"oss"}-${h.commit??"dev"}`}e.getRemoteServerRootPath=C;function D(h){const{host:S,port:v}=d(h);if(typeof v>"u")throw new Error("Remote authority doesn't contain a port!");return{host:S,port:v}}e.parseAuthorityWithPort=D;function P(h,S){let{host:v,port:b}=d(h);return typeof b>"u"&&(b=S),{host:v,port:b}}e.parseAuthorityWithOptionalPort=P;function d(h){const S=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const v=h.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const b=h.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:h,port:void 0}}}),define(ee[90],te([0,1,27,6,55]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=C;function D(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var d;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(d=e.TargetPlatform||(e.TargetPlatform={}));class h{constructor(w){this.value=w,this.c=w.toLowerCase()}static equals(w,a){if(typeof w>"u"||w===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof w=="string"||typeof a=="string"){const u=typeof w=="string"?w:w.value,m=typeof a=="string"?a:a.value;return I.equalsIgnoreCase(u,m)}return w.c===a.c}static toKey(w){return typeof w=="string"?w.toLowerCase():w.c}}e.ExtensionIdentifier=h;function S(p){return v(p)}e.isApplicationScopedExtension=S;function v(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function b(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=b;function g(p,w){if(w){const a=`onResolveRemoteAuthority:${(0,n.getRemoteName)(w)}`;return p.activationEvents?.indexOf(a)!==-1}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[227],te([0,1,8,17,22,13,3,2,63,70,31,104,226,55]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var w;(function(T){T[T.Management=1]="Management",T[T.ExtensionHost=2]="ExtensionHost",T[T.Tunnel=3]="Tunnel"})(w=e.ConnectionType||(e.ConnectionType={}));function a(T){switch(T){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(T){const U=new n.CancellationTokenSource;return setTimeout(()=>U.cancel(),T),U.token}function m(T,U){if(T.isCancellationRequested||U.isCancellationRequested)return n.CancellationToken.Cancelled;const B=new n.CancellationTokenSource;return T.onCancellationRequested(()=>B.cancel()),U.onCancellationRequested(()=>B.cancel()),B.token}class k{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((B,q)=>{this.f=B,this.g=q}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function E(T,U){const B=new k(U);return B.registerDisposable(T.onControlMessage(q=>{const N=JSON.parse(q.toString()),$=z(N);$?B.reject($):B.resolve(N)})),B.promise}function L(T,U,B,q,N,$,J,oe,le){const be=new k(le),Le=h.StopWatch.create(!1);return T.info(`Creating a socket (${oe})...`),d.mark(`code/willCreateSocket/${J}`),U.connect(B,q,N,$,oe,(Te,Ae)=>{be.didTimeout?(d.mark(`code/didCreateSocketError/${J}`),T.info(`Creating a socket (${oe}) finished after ${Le.elapsed()} ms, but this is too late and has timed out already.`),Te&&T.error(Te),Ae?.dispose()):Te||!Ae?(d.mark(`code/didCreateSocketError/${J}`),T.info(`Creating a socket (${oe}) returned an error after ${Le.elapsed()} ms.`),be.reject(Te)):(d.mark(`code/didCreateSocketOK/${J}`),T.info(`Creating a socket (${oe}) was successful after ${Le.elapsed()} ms.`),be.resolve(Ae))}),be.promise}function t(T,U){const B=new k(U);return T.then(q=>{B.didTimeout||B.resolve(q)},q=>{B.didTimeout||B.reject(q)}),B.promise}async function c(T,U,B,q){const N=Q(T,U);T.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let $;try{$=await L(T.logService,T.socketFactory,T.host,T.port,(0,g.getRemoteServerRootPath)(T),`reconnectionToken=${T.reconnectionToken}&reconnection=${T.reconnectionProtocol?"true":"false"}`,a(U),`renderer-${a(U)}-${T.reconnectionToken}`,q)}catch(Le){throw T.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),T.logService.error(Le),Le}T.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let J,oe;T.reconnectionProtocol?(T.reconnectionProtocol.beginAcceptReconnection($,null),J=T.reconnectionProtocol,oe=!1):(J=new v.PersistentProtocol({socket:$,measureRoundTripTime:!0}),oe=!0),T.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const le=await t(T.signService.createNewMessage((0,S.generateUuid)()),q),be={type:"auth",auth:T.connectionToken||"00000000000000000000",data:le.data};J.sendControl(R.VSBuffer.fromString(JSON.stringify(be)));try{const Le=await E(J,m(q,u(1e4)));if(Le.type!=="sign"||typeof Le.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}if(T.logService.trace(`${N} 4/6. received SignRequest control message.`),!await t(T.signService.validate(le,Le.signedData),q)){const ve=new Error("Refused to connect to unsupported server");throw ve.code="VSCODE_CONNECTION_ERROR",ve}const Ae=await t(T.signService.sign(Le.data),q),pe={type:"connectionType",commit:T.commit,signedData:Ae,desiredConnectionType:U};return B&&(pe.args=B),T.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(R.VSBuffer.fromString(JSON.stringify(pe))),{protocol:J,ownsProtocol:oe}}catch(Le){throw Le&&Le.code==="ETIMEDOUT"&&(T.logService.error(`${N} the handshake timed out. Error:`),T.logService.error(Le)),Le&&Le.code==="VSCODE_CONNECTION_ERROR"&&(T.logService.error(`${N} received error control message when negotiating connection. Error:`),T.logService.error(Le)),oe&&W(J),Le}}async function i(T,U,B,q){const N=Date.now(),$=Q(T,U),{protocol:J,ownsProtocol:oe}=await c(T,U,B,q),le=new k(q);return le.registerDisposable(J.onControlMessage(be=>{const Le=JSON.parse(be.toString()),Te=z(Le);Te?(T.logService.error(`${$} received error control message when negotiating connection. Error:`),T.logService.error(Te),oe&&W(J),le.reject(Te)):(T.reconnectionProtocol?.endAcceptReconnection(),T.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${A(N)}!`),le.resolve({protocol:J,firstMessage:Le}))})),le.promise}async function r(T,U){const{protocol:B}=await i(T,1,void 0,U);return{protocol:B}}async function s(T,U,B){const{protocol:q,firstMessage:N}=await i(T,2,U,B),$=N&&N.debugPort;return{protocol:q,debugPort:$}}async function l(T,U,B){const q=Date.now(),N=Q(T,3),{protocol:$}=await c(T,3,U,B);return T.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${A(q)}!`),$}async function o(T,U,B){const{host:q,port:N,connectionToken:$}=await T.addressProvider.getAddress();return{commit:T.commit,quality:T.quality,host:q,port:N,connectionToken:$,reconnectionToken:U,reconnectionProtocol:B,socketFactory:T.socketFactory,signService:T.signService,logService:T.logService}}async function f(T,U,B){return M(T,async q=>{const{protocol:N}=await r(q,n.CancellationToken.None);return new V(T,U,B,q.reconnectionToken,N)})}e.connectRemoteAgentManagement=f;async function y(T,U){return M(T,async B=>{const{protocol:q,debugPort:N}=await s(B,U,n.CancellationToken.None);return new F(T,U,B.reconnectionToken,q,N)})}e.connectRemoteAgentExtensionHost=y;async function M(T,U){for(let q=1;;q++)try{const N=(0,S.generateUuid)(),$=await o(T,N,null);return await U($)}catch(N){if(q<5)T.logService.error(`[remote-connection][attempt ${q}] An error occurred in initial connection! Will retry... Error:`),T.logService.error(N);else throw T.logService.error(`[remote-connection][attempt ${q}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),T.logService.error(N),ge.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(N)),N}}async function O(T,U,B){const q=await o(T,(0,S.generateUuid)(),null);return await l(q,{host:U,port:B},n.CancellationToken.None)}e.connectRemoteAgentTunnel=O;function j(T){return(0,I.createCancelablePromise)(U=>new Promise((B,q)=>{const N=setTimeout(B,T*1e3);U.onCancellationRequested(()=>{clearTimeout(N),B()})}))}var G;(function(T){T[T.ConnectionLost=0]="ConnectionLost",T[T.ReconnectionWait=1]="ReconnectionWait",T[T.ReconnectionRunning=2]="ReconnectionRunning",T[T.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",T[T.ConnectionGain=4]="ConnectionGain",T[T.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(G=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class H{constructor(U,B){this.reconnectionToken=U,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=H;class K{constructor(U,B,q,N){this.reconnectionToken=U,this.millisSinceLastIncomingData=B,this.durationSeconds=q,this.c=N,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=K;class ne{constructor(U,B,q){this.reconnectionToken=U,this.millisSinceLastIncomingData=B,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=ne;class re{constructor(U,B,q){this.reconnectionToken=U,this.millisSinceLastIncomingData=B,this.attempt=q,this.type=4}}e.ConnectionGainEvent=re;class ae{constructor(U,B){this.reconnectionToken=U,this.connectionHealth=B,this.type=5}}e.ConnectionHealthChangedEvent=ae;class fe{constructor(U,B,q,N){this.reconnectionToken=U,this.millisSinceLastIncomingData=B,this.attempt=q,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=fe;class ge extends P.Disposable{static triggerPermanentFailure(U,B,q){this._permanentFailure=!0,this.f=U,this.g=B,this.h=q,this.i.forEach(N=>N.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(U=>U.r())}static debugPauseSocketWriting(){this.i.forEach(U=>U.v())}get k(){return this.c||ge._permanentFailure}constructor(U,B,q,N,$){super(),this.m=U,this.n=B,this.reconnectionToken=q,this.protocol=N,this.p=$,this.j=this.B(new D.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new re(this.reconnectionToken,0,0)),this.B(N.onSocketClose(J=>{const oe=se(this.m,this.reconnectionToken,!0);J?J.type===0?(this.n.logService.info(`${oe} received socket close event (hadError: ${J.hadError}).`),J.error&&this.n.logService.error(J.error)):(this.n.logService.info(`${oe} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.n.logService.error(J.event)):this.n.logService.info(`${oe} received socket close event.`),this.r()})),this.B(N.onSocketTimeout(J=>{const oe=se(this.m,this.reconnectionToken,!0);this.n.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.r()})),this.B(N.onHighRoundTripTime(J=>{const oe=ie(this.m,this.reconnectionToken);this.n.logService.info(`${oe} high roundtrip time: ${J.roundTripTime}ms (${J.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(N.onDidChangeConnectionHealth(J=>{this.j.fire(new ae(this.reconnectionToken,J))})),ge.i.push(this),this.B((0,P.toDisposable)(()=>{const J=ge.i.indexOf(this);J>=0&&ge.i.splice(J,1)})),this.k&&this.u(ge.f,ge.g,ge.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const U=se(this.m,this.reconnectionToken,!0);this.n.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const N=q<B.length?B[q]:B[B.length-1];try{if(N>0){const J=j(N);this.j.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,J)),this.n.logService.info(`${U} waiting for ${N} seconds before reconnecting...`);try{await J}catch{}}if(this.k){this.n.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this.n.logService.info(`${U} resolving connection...`);const $=await o(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${U} connecting to ${$.host}:${$.port}...`),await this.w($,u(p)),this.n.logService.info(`${U} reconnected!`),this.j.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch($){if($.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error($),this.t(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this.n.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error($),this.t(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable($)){this.n.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace($);continue}if(($.code==="ETIMEDOUT"||$.code==="ENETUNREACH"||$.code==="ECONNREFUSED"||$.code==="ECONNRESET")&&$.syscall==="connect"){this.n.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace($);continue}if((0,C.isCancellationError)($)){this.n.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace($);continue}if($ instanceof b.RemoteAuthorityResolverError){this.n.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error($),this.t(this.protocol.getMillisSinceLastIncomingData(),q+1,b.RemoteAuthorityResolverError.isHandled($));break}this.n.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error($),this.t(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!this.k)}t(U,B,q){this.p?ge.triggerPermanentFailure(U,B,q):this.u(U,B,q)}u(U,B,q){this.j.fire(new fe(this.reconnectionToken,U,B,q)),W(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ge,ge._permanentFailure=!1,ge.f=0,ge.g=0,ge.h=!1,ge.i=[];class V extends ge{constructor(U,B,q,N,$){super(1,U,N,$,!0),this.client=this.B(new v.Client($,{remoteAuthority:B,clientId:q},U.ipcLogger))}async w(U,B){await r(U,B)}}e.ManagementPersistentConnection=V;class F extends ge{constructor(U,B,q,N,$){super(2,U,q,N,!1),this.y=B,this.debugPort=$}async w(U,B){await s(U,this.y,B)}}e.ExtensionHostPersistentConnection=F;function W(T){try{T.acceptDisconnect();const U=T.getSocket();T.dispose(),U.dispose()}catch(U){(0,C.onUnexpectedError)(U)}}function z(T){if(T&&T.type==="error"){const U=new Error(`Connection error: ${T.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function X(T,U){for(;T.length<U;)T+=" ";return T}function ie(T,U){return`[remote-connection][${X(a(T),13)}][${U.substr(0,5)}\u2026]`}function se(T,U,B){return`${ie(T,U)}[${B?"reconnect":"initial"}]`}function Q(T,U){return`${se(U,T.reconnectionToken,!!T.reconnectionProtocol)}[${T.host}:${T.port}]`}function A(T){return`${Date.now()-T} ms`}}),define(ee[228],te([0,1,81,86]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(n,C,D,P,d,h){const S=b=>h(b,void 0),v=I.createConnection({host:n,port:C},()=>{v.removeListener("error",S);const b=Buffer.alloc(16);for(let a=0;a<16;a++)b[a]=Math.round(Math.random()*256);const g=b.toString("base64"),p=[`GET ws://${/:/.test(n)?`[${n}]`:n}:${C}${D}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];v.write(p.join(`\r
`)+`\r
\r
`);const w=a=>{a.toString().indexOf(`\r
\r
`)>=0&&(v.off("data",w),h(void 0,new R.NodeSocket(v,d)))};v.on("data",w)});v.setNoDelay(!0),v.once("error",S)}}}),define(ee[229],te([0,1,26,46,41,187]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let D;async function P(g=!1){return(D===void 0||g)&&(D=d()),D}e.hasWSLFeatureInstalled=P;async function d(){const g=h();if(g===void 0)return!1;if(g>=22e3){const p=v();if(p)return new Promise(w=>{R.execFile(p,["--status"],a=>w(!a))})}else{const p=b();if(p)try{if((await n.promises.stat(p)).isFile())return!0}catch{}}return!1}function h(){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());if(g)return parseInt(g[3])}function S(g){const p=process.env.SystemRoot;if(p){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return C.join(p,w?"Sysnative":"System32",g)}}function v(){return S("wsl.exe")}function b(){return S("lxss\\LxssManager.dll")}}),define(ee[56],te([0,1,17,171,67,6,50]),function(x,e,I,R,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function P(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}e.isSuccess=P;function d(w){return w.res.statusCode===204}async function h(w){return d(w)?null:(await(0,I.streamToBuffer)(w.stream)).toString()}e.asText=h;async function S(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);return h(w)}e.asTextOrError=S;async function v(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);if(d(w))return null;const u=(await(0,I.streamToBuffer)(w.stream)).toString();try{return JSON.parse(u)}catch(m){throw m.message+=`:
`+u,m}}e.asJson=v;function b(w){p(w)}e.updateProxyConfigurationsScope=b;let g;function p(w){const a=D.Registry.as(n.Extensions.Configuration),u=g;g={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},a.updateConfigurations({add:[g],remove:u?[u]:[]})}p(2)}),define(ee[230],te([0,1,17,22]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class n{constructor(P){this.a=P}listen(P,d){throw new Error("Invalid listen")}call(P,d,h,S=R.CancellationToken.None){switch(d){case"request":return this.a.request(h[0],S).then(async({res:v,stream:b})=>{const g=await(0,I.streamToBuffer)(b);return[{statusCode:v.statusCode,headers:v.headers},g]});case"resolveProxy":return this.a.resolveProxy(h[0])}throw new Error("Invalid call")}}e.RequestChannel=n;class C{constructor(P){this.a=P}async request(P,d){const[h,S]=await this.a.call("request",[P],d);return{res:h,stream:(0,I.bufferToStream)(S)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=C}),define(ee[231],te([0,1,232,10]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function n(D,P){return D.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:D.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function C(D,P,d={}){const h=(0,I.parse)(D),S=d.proxyUrl||n(h,P);if(!S)return null;const v=(0,I.parse)(S);if(!/^https?:$/.test(v.protocol||""))return null;const b={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,R.isBoolean)(d.strictSSL)?d.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((g,p)=>{x(["http-proxy-agent"],g,p)}))(b):new(await new Promise((g,p)=>{x(["https-proxy-agent"],g,p)}))(b)}e.getProxyAgent=C}),define(ee[112],te([0,1,46,9,172,22,45,13,4,31,148,61,8,127]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let p;async function w(u,m,k,E){return k["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.isLaunchedFromCli)(E)&&!k["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.isLaunchedFromCli)(E)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=b.Promises.withAsyncBody(async(L,t)=>{const c=new C.CancellationTokenSource;let i=1e4;const r=u.getValue("application.shellEnvironmentResolutionTimeout");typeof r=="number"&&(i=(0,g.clamp)(r,1,120)*1e3);const s=setTimeout(()=>{c.dispose(!0),t(new Error((0,n.localize)(0,null)))},i);try{L(await a(m,c.token))}catch(l){!(0,P.isCancellationError)(l)&&!c.token.isCancellationRequested?t(new Error((0,n.localize)(1,null,(0,D.toErrorMessage)(l)))):L({})}finally{clearTimeout(s),c.dispose()}})),p)}e.getResolvedShellEnv=w;async function a(u,m){const k=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",k);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",E);const L=(0,h.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(L+"({.*})"+L),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",c);const i=await(0,S.getSystemShell)(d.OS,c);return u.trace("getUnixShellEnvironment#shell",i),new Promise((r,s)=>{if(m.isCancellationRequested)return s(new P.CancellationError);const l=(0,R.basename)(i);let o,f;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(o=`& '${process.execPath}' ${y} -p '''${L}'' + JSON.stringify(process.env) + ''${L}'''`,f=["-Login","-Command"]):(o=`'${process.execPath}' ${y} -p '"${L}" + JSON.stringify(process.env) + "${L}"'`,l==="tcsh"||l==="csh"?f=["-ic"]:f=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),o);const M=(0,I.spawn)(i,[...f,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});m.onCancellationRequested(()=>(M.kill(),s(new P.CancellationError))),M.on("error",G=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(G)),s(G)});const O=[];M.stdout.on("data",G=>O.push(G));const j=[];M.stderr.on("data",G=>j.push(G)),M.on("close",(G,H)=>{const K=Buffer.concat(O).toString("utf8");u.trace("getUnixShellEnvironment#raw",K);const ne=Buffer.concat(j).toString("utf8");if(ne.trim()&&u.trace("getUnixShellEnvironment#stderr",ne),G||H)return s(new Error((0,n.localize)(2,null,G,H)));const re=t.exec(K),ae=re?re[1]:"{}";try{const fe=JSON.parse(ae);k?fe.ELECTRON_RUN_AS_NODE=k:delete fe.ELECTRON_RUN_AS_NODE,E?fe.ELECTRON_NO_ATTACH_CONSOLE=E:delete fe.ELECTRON_NO_ATTACH_CONSOLE,delete fe.VSCODE_RESOLVING_ENVIRONMENT,delete fe.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",fe),r(fe)}catch(fe){u.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(fe)),s(fe)}})})}}),define(ee[91],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,I.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[233],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class I{constructor(){this.b=new Map}c(){return new Promise((n,C)=>x(["vsda"],n,C))}async createNewMessage(n){try{const C=await this.c(),D=new C.validator;if(D){const P=String(I.a++);return this.b.set(P,D),{id:P,data:D.createNewMessage(n)}}}catch{}return{id:"",data:n}}async validate(n,C){if(!n.id)return!0;const D=this.b.get(n.id);if(!D)return!1;this.b.delete(n.id);try{return D.validate(C)==="ok"}catch{return!1}}async sign(n){try{const C=await this.c(),D=new C.signer;if(D)return D.sign(n)}catch{}return n}}e.SignService=I,I.a=1}),define(ee[34],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,I.createDecorator)("stateMainService")}),define(ee[21],te([0,1,14,42,8,3,2,4,36,10,6,5,34,28]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,S.createDecorator)("lifecycleMainService");var p;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(p=e.ShutdownReason||(e.ShutdownReason={}));var w;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})(w=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let a=class ft extends D.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(m,k,E){super(),this.v=m,this.w=k,this.y=E,this.c=this.B(new C.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new C.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new C.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new C.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(ft.b),this.j&&this.w.removeItem(ft.b)}C(){const m=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.isMacintosh&&this.n===0&&this.D(1))};I.app.addListener("before-quit",m);const k=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!P.isMacintosh)&&I.app.quit()};I.app.addListener("window-all-closed",k),I.app.once("will-quit",E=>{this.L("Lifecycle#app.on(will-quit)"),E.preventDefault(),this.D(1).finally(()=>{this.H(!1),I.app.removeListener("before-quit",m),I.app.removeListener("window-all-closed",k),I.app.quit()})})}D(m){if(this.s)return this.s;this.L("Lifecycle#onWillShutdown.fire()");const k=[];return this.f.fire({reason:m,join(E){k.push(E)}}),this.s=(async()=>{try{await n.Promises.settled(k)}catch(E){this.v.error(E)}try{await this.w.close()}catch(E){this.v.error(E)}})(),this.s}set phase(m){if(m<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===m)return;this.L(`lifecycle (main): phase changed (value: ${m})`),this.k=m;const k=this.u.get(this.k);k&&(k.open(),this.u.delete(this.k))}async when(m){if(m<=this.k)return;let k=this.u.get(m);k||(k=new n.Barrier,this.u.set(m,k)),await k.wait()}registerWindow(m){const k=new D.DisposableStore;this.n++,k.add(m.onWillLoad(L=>this.g.fire({window:m,workspace:L.workspace,reason:L.reason})));const E=(0,h.assertIsDefined)(m.win);E.on("close",L=>{const t=m.id;if(this.l.has(t)){this.l.delete(t);return}this.L(`Lifecycle#window.on('close') - window ID ${m.id}`),L.preventDefault(),this.unload(m,1).then(c=>{if(c){this.l.delete(t);return}this.l.add(t),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this.h.fire(m),m.close()})}),E.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${m.id}`),this.n--,k.dispose(),this.n===0&&(!P.isMacintosh||this.i)&&this.D(1)})}async reload(m,k){await this.unload(m,3)||m.reload(k)}unload(m,k){const E=this.t.get(m.id);if(E)return E;const L=this.F(m,k).finally(()=>{this.t.delete(m.id)});return this.t.set(m.id,L),L}async F(m,k){if(!m.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${m.id}`);const E=this.i?2:k,L=await this.I(m,E);return L?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${m.id})`),this.G(L)):(await this.J(m,E),!1)}G(m){return m?(this.H(!0),this.i=!1,!0):!1}H(m){this.r&&(this.r(m),this.r=void 0,this.p=void 0)}I(m,k){return new Promise(E=>{const L=this.m++,t=`vscode:ok${L}`,c=`vscode:cancel${L}`;R.validatedIpcMain.once(t,()=>{E(!1)}),R.validatedIpcMain.once(c,()=>{E(!0)}),m.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:c,reason:k})})}J(m,k){return new Promise(E=>{const t=`vscode:reply${this.m++}`;R.validatedIpcMain.once(t,()=>E()),m.send("vscode:onWillUnload",{replyChannel:t,reason:k})})}quit(m){return this.L(`Lifecycle#quit() - begin (willRestart: ${m})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(m&&this.w.setItem(ft.b,!0),this.p=new Promise(k=>{this.r=k,this.L("Lifecycle#quit() - calling app.quit()"),I.app.quit()}),this.p)}L(m){this.y.args["enable-smoke-test-driver"]?this.v.info(m):this.v.trace(m)}async relaunch(m){this.L("Lifecycle#relaunch()");const k=process.argv.slice(1);if(m?.addArgs&&k.push(...m.addArgs),m?.removeArgs)for(const t of m.removeArgs){const c=k.indexOf(t);c>=0&&k.splice(c,1)}const E=()=>{try{if(P.isWindows){const t=(0,d.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.v.error(t)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),I.app.relaunch({args:k})};I.app.once("quit",E),await this.quit(!0)&&I.app.removeListener("quit",E)}async kill(m){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const k of I.BrowserWindow.getAllWindows())if(k&&!k.isDestroyed()){let E;k.webContents&&!k.webContents.isDestroyed()?E=new Promise(L=>k.once("closed",L)):E=Promise.resolve(),k.destroy(),await E}})()]),I.app.exit(m)}};a.b="lifecycle.quitAndRestart",a=we([_(0,v.ILogService),_(1,b.IStateMainService),_(2,g.IEnvironmentMainService)],a),e.LifecycleMainService=a}),define(ee[234],te([0,1,4,3,2,6,21]),function(x,e,I,R,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,C.createDecorator)("keyboardLayoutMainService");let P=class extends n.Disposable{constructor(S){super(),this.a=this.B(new R.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,S.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const S=await new Promise((v,b)=>{x(["native-keymap"],v,b)});this.c=d(S),I.isCI||S.onDidChangeKeyboardLayout(()=>{this.c=d(S),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};P=we([_(0,D.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function d(h){const S=h.getKeyMap(),v=h.getCurrentKeyboardLayout();return{keyboardMapping:S,keyboardLayoutInfo:v}}}),define(ee[235],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,I.createDecorator)("stateService")}),define(ee[236],te([0,1,8,17,10,33,16,5]),function(x,e,I,R,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class d{constructor(v,b,g){this.f=v,this.g=b,this.h=g,this.a=Object.create(null),this.b="",this.c=new I.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.g.error(v)}}getItem(v,b){const g=this.a[v];return(0,n.isUndefinedOrNull)(g)?b:g}setItem(v,b){this.setItems([{key:v,data:b}])}setItems(v){let b=!1;for(const{key:g,data:p}of v)this.a[g]!==p&&((0,n.isUndefinedOrNull)(p)?(0,n.isUndefined)(this.a[g])||(this.a[g]=void 0,b=!0):(this.a[g]=p,b=!0));b&&this.j()}removeItem(v){(0,n.isUndefined)(this.a[v])||(this.a[v]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.h.writeFile(this.f,R.VSBuffer.fromString(v)),this.b=v}catch(b){this.g.error(b)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=d;let h=class{constructor(v,b,g){this.a=new d(v.stateResource,b,g)}async init(){await this.a.init()}getItem(v,b){return this.a.getItem(v,b)}};h=we([_(0,C.IEnvironmentService),_(1,P.ILogService),_(2,D.IFileService)],h),e.StateService=h}),define(ee[237],te([0,1,236]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class R extends I.StateService{setItem(C,D){this.a.setItem(C,D)}setItems(C){this.a.setItems(C)}removeItem(C){this.a.removeItem(C)}close(){return this.a.close()}}e.StateMainService=R}),define(ee[92],te([0,1,4,36,7,31]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(h){if(I.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}async function P(h,S,v,b,g,p,w,a,u,m){const k=Object.create(null);k["common.machineId"]=w,k.sessionID=(0,C.generateUuid)()+Date.now(),k.commitHash=g,k.version=p,k["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),k["common.platform"]=(0,I.PlatformToString)(I.platform),k["common.nodePlatform"]=R.platform,k["common.nodeArch"]=b,k["common.product"]=m||"desktop",a&&(k["common.msftInternal"]=a);let E=0;const L=Date.now();Object.defineProperties(k,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-L,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),I.isLinuxSnap&&(k["common.snap"]="true");const t=D(v);t&&(k["common.platformDetail"]=t);try{const c=await h.readFile(n.URI.file(u));k["common.source"]=c.value.toString().slice(0,30)}catch{}return k}e.resolveCommonProperties=P;function d(h){const S=R.env.USERDNSDOMAIN;if(!S)return!1;const v=S.toLowerCase();return h.some(b=>v===b)}e.verifyMicrosoftInternalDomain=d}),define(ee[24],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var n;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(n=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[238],te([0,1,26,8,43,15,9,4,7,84,23,103,87,16,19,24]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const a=new Map;async function u(t,c){const i=`${t}::${c.join(":")}`,r=a.get(i);if(r)return r;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,o=new Map,f=2e4;function y(O,j,G,H){const K=j.substring(O.length+1);return R.Promises.withAsyncBody(async ne=>{let re;try{re=await S.Promises.readdir(j,{withFileTypes:!0})}catch{ne();return}if(H.count>=f){H.count+=re.length,H.maxReached=!0,ne();return}let ae=re.length;if(ae===0){ne();return}let fe=re;H.count+re.length>f&&(H.maxReached=!0,ae=f-H.count,fe=re.slice(0,ae)),H.count+=re.length;for(const ge of fe)if(ge.isDirectory()){if(G.includes(ge.name)||await y(O,(0,D.join)(j,ge.name),G,H),--ae===0){ne();return}}else{const V=ge.name.lastIndexOf(".");if(V>=0){const F=ge.name.substring(V+1);F&&l.set(F,(l.get(F)??0)+1)}for(const F of s)F.relativePathPattern?.test(K)!==!1&&F.filePattern.test(ge.name)&&o.set(F.tag,(o.get(F.tag)??0)+1);if(--ae===0){ne();return}}})}const M=R.Promises.withAsyncBody(async O=>{const j={count:0,maxReached:!1};await y(t,t,c,j);const G=await E(t);O({configFiles:m(o),fileTypes:m(l),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:G})});return a.set(i,M),M}e.collectWorkspaceStats=u;function m(t){return Array.from(t.entries(),([c,i])=>({name:c,count:i})).sort((c,i)=>i.count-c.count)}function k(){const t={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(h.virtualMachineHint.value()*100)}%`},c=I.cpus();return c&&c.length>0&&(t.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),t}e.getMachineInfo=k;async function E(t){try{const c=new Map,i=(0,D.join)(t,".vscode","launch.json"),r=await S.Promises.readFile(i),s=[],l=(0,n.parse)(r.toString(),s);if(s.length)return console.log(`Unable to parse ${i}`),[];if((0,n.getNodeType)(l)==="object"&&l.configurations)for(const o of l.configurations){const f=o.type;f&&(c.has(f)?c.set(f,c.get(f)+1):c.set(f,1))}return m(c)}catch{return[]}}e.collectLaunchConfigs=E;let L=class{constructor(c,i){this.c=c,this.d=i}f(c){const i=[];return i.push(`OS Version:       ${c.os}`),i.push(`CPUs:             ${c.cpus}`),i.push(`Memory (System):  ${c.memory}`),i.push(`VM:               ${c.vmHint}`),i.join(`
`)}g(c){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const r=I.cpus();return r&&r.length>0&&i.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),i.push(`Memory (System):  ${(I.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||i.push(`Load (avg):       ${I.loadavg().map(s=>Math.round(s)).join(", ")}`),i.push(`VM:               ${Math.round(h.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${c.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(c,i){return Promise.all([(0,v.listProcesses)(c.mainPID),this.k(c)]).then(async r=>{let[s,l]=r,o=this.m(c,s);return i.forEach(f=>{if((0,b.isRemoteDiagnosticError)(f))o+=`
${f.errorMessage}`,l+=`
${f.errorMessage}`;else if(o+=`

Remote: ${f.hostName}`,f.processes&&(o+=`
${this.m(c,f.processes)}`),f.workspaceMetadata){l+=`
|  Remote: ${f.hostName}`;for(const y of Object.keys(f.workspaceMetadata)){const M=f.workspaceMetadata[y];let O=`${M.fileCount} files`;M.maxFilesReached&&(O=`more than ${O}`),l+=`|    Folder (${y}): ${O}`,l+=this.h(M)}}}),{processInfo:o,workspaceInfo:l}})}async getSystemInfo(c,i){const{memory:r,vmHint:s,os:l,cpus:o}=k(),f={os:l,memory:r,cpus:o,vmHint:s,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:i};return P.isWindows||(f.load=`${I.loadavg().map(y=>Math.round(y)).join(", ")}`),P.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(c,i){const r=[];return(0,v.listProcesses)(c.mainPID).then(async s=>(r.push(""),r.push(this.g(c)),r.push(""),r.push(this.m(c,s)),c.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(c))),i.forEach(l=>{if((0,b.isRemoteDiagnosticError)(l))r.push(`
${l.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${l.hostName}`),r.push(this.f(l.machineInfo)),l.processes&&r.push(this.m(c,l.processes)),l.workspaceMetadata)for(const o of Object.keys(l.workspaceMetadata)){const f=l.workspaceMetadata[o];let y=`${f.fileCount} files`;f.maxFilesReached&&(y=`more than ${y}`),r.push(`Folder (${o}): ${y}`),r.push(this.h(f))}}),r.push(""),r.push(""),r.join(`
`)))}h(c){const i=[];let s=0;const l=(M,O)=>{const j=` ${M}(${O})`;s+j.length>60?(i.push(o),o="|                 ",s=o.length):s+=j.length,o+=j};let o="|      File types:";const f=10,y=c.fileTypes.length>f?f:c.fileTypes.length;for(let M=0;M<y;M++){const O=c.fileTypes[M];l(O.name,O.count)}if(i.push(o),c.configFiles.length>=0&&(o="|      Conf files:",s=0,c.configFiles.forEach(M=>{l(M.name,M.count)}),i.push(o)),c.launchConfigFiles.length>0){let M="|      Launch Configs:";c.launchConfigFiles.forEach(O=>{M+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),i.push(M)}return i.join(`
`)}j(c){const i=Math.max(...Object.keys(c).map(r=>r.length));return Object.keys(c).map(r=>`${r}:  ${" ".repeat(i-r.length)}  ${c[r]}`).join(`
                  `)}k(c){const i=[],r=[];return c.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(i.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const o=d.URI.revive(l);if(o.scheme===C.Schemas.file){const f=o.fsPath;r.push(u(f,["node_modules",".git"]).then(y=>{let M=`${y.fileCount} files`;y.maxFilesReached&&(M=`more than ${M}`),i.push(`|    Folder (${(0,D.basename)(f)}): ${M}`),i.push(this.h(y))}).catch(y=>{i.push(`|      Error: Unable to collect workspace stats for folder ${f} (${y.toString()})`)}))}else i.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(s=>i.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(c,i){const r=new Map;c.windows.forEach(l=>r.set(l.pid,l.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),i&&this.n(c.mainPID,r,s,i,0),s.join(`
`)}n(c,i,r,s,l){const o=l===0;let f;o?f=s.pid===c?`${this.d.applicationName} main`:"remote agent":(f=`${"  ".repeat(l)} ${s.name}`,s.name==="window"&&(f=`${f} (${i.get(s.pid)})`));const y=process.platform==="win32"?s.mem:I.totalmem()*(s.mem/100);r.push(`${s.load.toFixed(0).padStart(5," ")}	${(y/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(s.children)&&s.children.forEach(M=>this.n(c,i,r,M,l+1))}async getWorkspaceFileExtensions(c){const i=new Set;for(const{uri:r}of c.folders){const s=d.URI.revive(r);if(s.scheme!==C.Schemas.file)continue;const l=s.fsPath;try{(await u(l,["node_modules",".git"])).fileTypes.forEach(f=>i.add(f.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(c){for(const{uri:i}of c.folders){const r=d.URI.revive(i);if(r.scheme!==C.Schemas.file)continue;const s=r.fsPath;try{const l=await u(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),l.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:o.name,count:o.count})}),l.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:o.name,count:o.count})}),l.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};L=we([_(0,w.ITelemetryService),_(1,p.IProductService)],L),e.DiagnosticsService=L}),define(ee[239],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class I{constructor(C){this.b=C}listen(C,D){throw new Error(`Event not found: ${D}`)}call(C,D,{eventName:P,data:d}){return this.b.forEach(h=>h.log(P,d)),Promise.resolve(null)}}e.TelemetryAppenderChannel=I;class R{constructor(C){this.b=C}log(C,D){return this.b.call("log",{eventName:C,data:D}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=R}),define(ee[51],te([0,1,44,10,3,18,55,92,24]),function(x,e,I,R,n,C,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class h{constructor(o){this.value=o}}e.TelemetryTrustedValue=h;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,f){return Promise.resolve(void 0)}publicLog2(o,f){return this.publicLog(o,f)}publicLogError(o,f){return Promise.resolve(void 0)}publicLogError2(o,f){return this.publicLogError(o,f)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class v{async publicLog(o,f,y){}async publicLogError(o,f,y){}}e.NullEndpointTelemetryService=v,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(l,o){return n.Event.debounce(o.onDidChangeConfiguration,(y,M)=>{const O=y?new Set([...y.affectedKeys,...M.affectedKeys]):M.affectedKeys;return{...M,affectedKeys:O}},1e3,!0)(y=>{y.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(y.source),configurationKeys:E(y.affectedKeys)})})}e.configurationTelemetry=b;function g(l,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!l.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=g;function p(l,o){return!(o.isBuilt||o.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}e.isLoggingOnly=p;function w(l){const o=l.getValue(d.TELEMETRY_SETTING_ID),f=l.getValue(d.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(l.getValue(d.TELEMETRY_OLD_SETTING_ID)===!1||f===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function a(l){const o={},f={},y={};k(l,y);for(let M in y){M=M.length>150?M.substr(M.length-149):M;const O=y[M];typeof O=="number"?f[M]=O:typeof O=="boolean"?f[M]=O?1:0:typeof O=="string"?(O.length>8192&&console.warn(`Telemetry property: ${M} has been trimmed to 8192, the original length is ${O.length}`),o[M]=O.substring(0,8191)):typeof O<"u"&&O!==null&&(o[M]=O)}return{properties:o,measurements:f}}e.validateTelemetryData=a;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function m(l){if(!l)return"none";const o=(0,D.getRemoteName)(l);return u.has(o)?o:"other"}e.cleanRemoteAuthority=m;function k(l,o,f=0,y){if(!!l)for(const M of Object.getOwnPropertyNames(l)){const O=l[M],j=y?y+M:M;Array.isArray(O)?o[j]=(0,I.safeStringify)(O):O instanceof Date?o[j]=O.toISOString():(0,R.isObject)(O)?f<2?k(O,o,f+1,j+"."):o[j]=(0,I.safeStringify)(O):o[j]=O}}function E(l){if(!l)return[];const o=[];return L(o,"",l),o}function L(l,o,f){f&&typeof f=="object"&&!Array.isArray(f)?Object.keys(f).forEach(y=>L(l,o?`${o}.${y}`:y,f[y])):l.push(o)}function t(l,o){const f=l.msftInternalDomains||[],y=o.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(f)||y}e.isInternalTelemetry=t;function c(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.getPiiPathsFromEnvironment=c;function i(l,o){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let f=l;const y=[];for(const G of o)for(;;){const H=G.exec(l);if(!H)break;y.push([H.index,G.lastIndex])}const M=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,O=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let j=0;for(f="";;){const G=O.exec(l);if(!G)break;const H=y.some(([K,ne])=>G.index<ne&&K<O.lastIndex);!M.test(G[0])&&!H&&(f+=l.substring(j,G.index)+"<REDACTED: user-file-path>",j=O.lastIndex)}return j<l.length&&(f+=l.substr(j)),f}function r(l){if(!l)return l;const o=l.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const y of f)if(y.regex.test(o))return`<REDACTED: ${y.label}>`;return l}function s(l,o){return(0,I.cloneAndChange)(l,f=>{if(f instanceof h)return f.value;if(typeof f=="string"){let y=f.replaceAll("%20"," ");y=i(y,o);for(const M of o)y=y.replace(M,"");return y=r(y),y}})}e.cleanData=s}),define(ee[113],te([0,1,27,197,90,4,7,13,36,51]),function(x,e,I,R,n,C,D,P,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function S(i,r){return i.uuid&&r.uuid?i.uuid===r.uuid:i.id===r.id?!0:(0,I.compareIgnoreCase)(i.id,r.id)===0}e.areSameExtensions=S;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(r){const s=r.manifest?r.manifest.version:r.version,l=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new b(r.identifier,s,l)}static parse(r){const s=v.exec(r);return s&&s[1]&&s[2]?new b({id:s[1]},s[2],s[4]||void 0):null}constructor(r,s,l="undefined"){this.version=s,this.targetPlatform=l,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof b?S(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=b;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(i){const r=g.exec(i);return r&&r[1]?[a(r[1]),r[2]]:[a(i),void 0]}e.getIdAndVersion=p;function w(i,r){return`${i}.${r}`}e.getExtensionId=w;function a(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=a;function u(i,r){return a(w(i,r))}e.getGalleryExtensionId=u;function m(i,r){const s=[],l=o=>{for(const f of s)if(f.some(y=>S(r(y),r(o))))return f;return null};for(const o of i){const f=l(o);f?f.push(o):s.push([o])}return s}e.groupByExtension=m;function k(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=k;function E(i){return{id:new h.TelemetryTrustedValue(i.identifier.id),name:new h.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function L(i,r){const s=[],l=r.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const o=l.shift();if(o&&s.every(f=>!S(f.identifier,{id:o}))){const f=i.filter(y=>S(y.identifier,{id:o}));f.length===1&&(s.push(f[0]),l.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=L;async function t(i,r){if(!C.isLinux)return!1;let s;try{s=(await i.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await i.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){r.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(o))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function c(i,r){const s=await t(i,r),l=(0,R.getTargetPlatform)(s?"alpine":C.platform,d.arch);return r.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=c}),define(ee[240],te([0,1,194,51]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function n(C,D,P,d,h,S,v){const b={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${D.nameShort})`};if((0,R.supportsTelemetry)(D,P)&&(0,R.getTelemetryLevel)(d)===3){const g=await(0,I.getServiceMachineId)(P,h,S),{machineId:p}=await v.getTelemetryInfo();b["X-Market-User-Id"]=g,b["VSCode-SessionId"]=p||g}return b}e.resolveMarketplaceHeaders=n}),define(ee[241],te([0,1,13,44,51]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const C="https://mobile.events.data.microsoft.com/OneCollector/1.0",D="https://mobile.events.data.microsoft.com/ping";async function P(h,S,v){const b=await new Promise((u,m)=>{x(["@microsoft/1ds-core-js"],u,m)}),g=await new Promise((u,m)=>{x(["@microsoft/1ds-post-js"],u,m)}),p=new b.AppInsightsCore,w=new g.PostChannel,a={instrumentationKey:h,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(v){a.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:v};a.extensionConfig[w.identifier]=u}return p.initialize(a,[]),p.addTelemetryInitializer(u=>{S&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),p}class d{constructor(S,v,b,g,p){this.e=S,this.f=v,this.g=b,this.h=p,this.c=C,this.d=D,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(S){if(!!this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(v=>{S(v)},v=>{(0,I.onUnexpectedError)(v),console.error(v)})}}log(S,v){if(!this.a)return;v=(0,R.mixin)(v,this.g),v=(0,n.validateTelemetryData)(v);const b=this.f+"/"+S;try{this.i(g=>{g.pluginVersionString=v?.properties.version??"Unknown",g.track({name:b,baseData:{name:b,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.i(v=>{v.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=d}),define(ee[114],te([0,1,2,44,4,27,173,18,67,65,19,50,24,51]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(u,m,k){this.k=m,this.l=k,this.d={},this.i=new I.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,C.escapeRegExpCharacters)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,C.escapeRegExpCharacters)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(b.TELEMETRY_SETTING_ID)||E.affectsConfiguration(b.TELEMETRY_OLD_SETTING_ID)||E.affectsConfiguration(b.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(u,m){this.d[u]=m}m(){let u=(0,g.getTelemetryLevel)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const k=m.usage?3:m.error?2:0;u=Math.min(u,k)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,m=u.sessionID,k=u["common.machineId"],E=u["common.firstSessionDate"],L=u["common.msftInternal"];return{sessionId:m,machineId:k,firstSessionDate:E,msftInternal:L}}dispose(){this.i.dispose()}n(u,m,k){return this.g<m?Promise.resolve(void 0):this.c.then(E=>{k=(0,R.mixin)(k,this.d),k=(0,g.cleanData)(k,this.j),k=(0,R.mixin)(k,E),this.b.forEach(L=>L.log(u,k))},E=>{console.error(E)})}publicLog(u,m){return this.n(u,3,m)}publicLog2(u,m){return this.publicLog(u,m)}publicLogError(u,m){return this.h?this.n(u,2,m):Promise.resolve(void 0)}publicLogError2(u,m){return this.publicLogError(u,m)}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=we([_(1,P.IConfigurationService),_(2,S.IProductService)],p),e.TelemetryService=p;function w(){const a=(0,D.localize)(0,null,h.default.nameLong),u=h.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",h.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=n.isWeb?"":(0,D.localize)(3,null),k=(0,D.localize)(4,null),E=(0,D.localize)(5,null),L=(0,D.localize)(6,null),t=(0,D.localize)(7,null),c=`
|       | ${k} | ${E} | ${L} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,D.localize)(8,null);return`
${a} ${u} ${m}

&nbsp;

${t}
${c}

&nbsp;

${i}
`}v.Registry.as(d.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(d.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:h.default.privacyStatementUrl?(0,D.localize)(16,null,h.default.nameLong,h.default.privacyStatementUrl):(0,D.localize)(15,null,h.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[242],te([0,1,289,241]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class n extends R.AbstractOneDataSystemAppender{constructor(D,P,d,h){const S={sendPOST:(v,b)=>{const g={method:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data)}};try{const p=I.request(v.urlString,g,w=>{w.on("data",function(a){b(w.statusCode??200,w.headers,a.toString())}),w.on("error",function(a){b(0,{})})});p.write(v.data),p.end()}catch{b(0,{})}}};super(D,P,d,h,S)}}e.OneDataSystemAppender=n}),define(ee[243],te([0,1,4,84,24]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function C(D){let P=D.getItem(n.machineIdKey);return(typeof P!="string"||I.isMacintosh&&P==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(P=await(0,R.getMachineId)()),P}e.resolveMachineId=C}),define(ee[115],te([0,1,24,243]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function n(C){const D=await(0,R.resolveMachineId)(C);return C.setItem(I.machineIdKey,D),D}e.resolveMachineId=n}),define(ee[68],te([0,1,14,3,2,4,18,6,34]),function(x,e,I,R,n,C,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const h="#FFFFFF",S="#1E1E1E",v="#000000",b="#FFFFFF",g="theme",p="themeBackground",w="windowSplash";e.IThemeMainService=(0,P.createDecorator)("themeMainService");let a=class extends n.Disposable{constructor(m,k){super(),this.b=m,this.c=k,this.a=this.B(new R.Emitter),this.onDidChangeColorScheme=this.a.event,I.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(C.isWindows){if(I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(C.isMacintosh){if(I.nativeTheme.shouldUseInvertedColorScheme||I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(C.isLinux&&I.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const m=this.getColorScheme();if(m.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return m.dark?v:b;let k=this.b.getItem(p,null);if(!k)switch(this.b.getItem(g,"vs-dark").split(" ")[0]){case"vs":k=h;break;case"hc-black":k=v;break;case"hc-light":k=b;break;default:k=S}return C.isMacintosh&&k.toUpperCase()===S&&(k="#171717"),k}saveWindowSplash(m,k){this.b.setItems([{key:g,data:k.baseTheme},{key:p,data:k.colorInfo.background},{key:w,data:k}]),typeof m=="number"&&this.f(m,k)}f(m,k){for(const E of I.BrowserWindow.getAllWindows())if(E.id===m){E.setBackgroundColor(k.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};a=we([_(0,d.IStateMainService),_(1,D.IConfigurationService)],a),e.ThemeMainService=a}),define(ee[116],te([0,1,3,18,6,5]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,n.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,n.createDecorator)("sharedTunnelsService");var D;(function(w){w.Http="http",w.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var d;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(d=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function h(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(!!a)return{address:a[1],port:+a[2]}}e.extractLocalHostUriMetaDataForPortMapping=h,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(w){return e.LOCALHOST_ADDRESSES.indexOf(w)>=0}e.isLocalhost=S,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(w){return e.ALL_INTERFACES_ADDRESSES.indexOf(w)>=0}e.isAllInterfaces=v;function b(w,a,u,m){if(u===1)return!1;if(u===2&&v(a)){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(k?.length===4&&parseInt(k[1])>=18)return!1}return w<1024}e.isPortPrivileged=b;class g{constructor(a,u,m){this.remoteAddress=a,this.localAddress=u,this.b=m,this.a=new I.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=g;let p=class{constructor(a,u){this.i=a,this.j=u,this.a=new I.Emitter,this.onTunnelOpened=this.a.event,this.b=new I.Emitter,this.onTunnelClosed=this.b.event,this.c=new I.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const a=this.j.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(a){return this.e=a,a?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this.f=a.elevation,this.g=a.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const a=[],u=Array.from(this.d.values());for(const m of u){const k=Array.from(m.values());for(const E of k){const L=await E.value;L&&a.push(L)}}return a}async dispose(){for(const a of this.d.values()){for(const{value:u}of a.values())await u.then(m=>m?.dispose());a.clear()}this.d.clear()}setEnvironmentTunnel(a,u,m,k,E){this.o(a,u,Promise.resolve({tunnelRemoteHost:a,tunnelRemotePort:u,localAddress:m,privacy:k,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(a,u){(v(a)||S(a))&&(a=e.LOCALHOST_ADDRESSES[0]);const m=this.q(a,u);if(m)return++m.refcount,m.value}openTunnel(a,u,m,k,E,L=!1,t,c){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${m} on local port ${E}.`),!a)return;if(u||(u="localhost"),k||(k=this.k),this.e&&this.h.has(m)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(a,u,m,k,E,L,t,c);return i?i.then(r=>{if(!r){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,m);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(r);return(r.tunnelRemoteHost!==u||r.tunnelRemotePort!==m)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const u=this.d.get(a.tunnelRemoteHost);if(u){const m=u.get(a.tunnelRemotePort);m&&(m.refcount--,await this.n(a.tunnelRemoteHost,a.tunnelRemotePort,m))}}}}async n(a,u,m){if(m.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${u}.`);const k=m.value.then(async E=>{E&&(await E.dispose(!0),this.b.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this.d.has(a)&&this.d.get(a).delete(u),k}}async closeTunnel(a,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${u} `);const m=this.d.get(a);if(m&&m.has(u)){const k=m.get(u);k.refcount=0,await this.n(a,u,k)}}o(a,u,m){this.d.has(a)||this.d.set(a,new Map),this.d.get(a).set(u,{refcount:1,value:m})}async p(a,u){const m=this.d.get(a);m&&(await m.get(u)||m.delete(u),m.size===0&&this.d.delete(a))}q(a,u){const m=[a];S(a)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):v(a)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const k=m.map(E=>this.d.get(E));for(const E of k){const L=E?.get(u);if(L)return L}}canTunnel(a){return!!h(a)}s(a,u,m,k,E,L,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${m} on local port ${k}.`);const c=m;this.h.add(c);const i=k===void 0?m:k,r={elevationRequired:E?this.isPortPrivileged(i):!1},s={remoteAddress:{host:u,port:m},localAddressPort:k,privacy:L,public:L?L!==P.Private:void 0,protocol:t},l=a.forwardPort(s,r);return l?(this.o(u,m,l),l.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(c)})):this.h.delete(c),l}};p=we([_(0,C.ILogService),_(1,R.IConfigurationService)],p),e.AbstractTunnelService=p}),define(ee[244],te([0,1,81,26,99,228,8,2,18,5,19,227,116,91,4]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function w(E,L,t,c,i){let r;for(let s=3;s&&(r?.dispose(),r=await new a(E,L,t,c,i).waitForReady(),!(i&&n.BROWSER_RESTRICTED_PORTS[i]||!n.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));s--);return r}class a extends P.Disposable{constructor(L,t,c,i,r){super(),this.j=t,this.k=r,this.privacy=b.TunnelPrivacyId.Private,this.i=new Map,this.a=L,this.b=I.createServer(),this.c=new D.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const L=this.k??this.tunnelRemotePort,t=(0,b.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let c=await(0,n.findFreePortFaster)(L,2,1e3,t),i=null;return this.b.listen(c,this.j),await this.c.wait(),i=this.b.address(),i||(c=0,this.b.listen(c,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(L){L.pause();const t=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,v.connectRemoteAgentTunnel)(this.a,t,this.tunnelRemotePort),i=c.getSocket().socket,r=c.readEntireBuffer();c.dispose(),r.byteLength>0&&L.write(r.buffer),L.on("end",()=>{L.localAddress&&this.i.delete(L.localAddress),i.end()}),L.on("close",()=>i.end()),L.on("error",()=>{L.localAddress&&this.i.delete(L.localAddress),i.destroy()}),i.on("end",()=>L.end()),i.on("close",()=>L.end()),i.on("error",()=>{L.destroy()}),L.pipe(i),i.pipe(L),L.localAddress&&this.i.set(L.localAddress,()=>{L.end(),i.end()})}}let u=class extends b.AbstractTunnelService{constructor(L,t,c,i,r){super(t,r),this.t=L,this.u=c,this.v=i}isPortPrivileged(L){return(0,b.isPortPrivileged)(L,this.k,p.OS,R.release())}r(L,t,c,i,r,s,l,o){const f=this.q(t,c);if(f)return++f.refcount,f.value;if(this.e)return this.s(this.e,t,c,r,s,l,o);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${c} on local port ${r}.`);const y={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:L,signService:this.u,logService:this.i,ipcLogger:null},M=w(y,i,t,c,r);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,c,M),M}}};u=we([_(1,h.ILogService),_(2,g.ISignService),_(3,S.IProductService),_(4,d.IConfigurationService)],u),e.BaseTunnelService=u;let m=class extends u{constructor(L,t,c,i){super(C.nodeSocketFactory,L,t,c,i)}};m=we([_(0,h.ILogService),_(1,g.ISignService),_(2,S.IProductService),_(3,d.IConfigurationService)],m),e.TunnelService=m;let k=class extends P.Disposable{constructor(L,t,c,i){super(),this.b=L,this.c=t,this.f=c,this.g=i,this.a=new Map}async openTunnel(L,t,c,i,r,s,l,o,f){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${i} on local port ${s}.`),!this.a.has(L)){const y=new m(this.b,this.f,this.c,this.g);this.B(y),this.a.set(L,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(L))})}return this.a.get(L).openTunnel(t,c,i,r,s,l,o,f)}};k=we([_(0,h.ILogService),_(1,S.IProductService),_(2,g.ISignService),_(3,d.IConfigurationService)],k),e.SharedTunnelsService=k}),define(ee[48],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var R;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(R=e.StateType||(e.StateType={}));var n;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(n=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(C,D)=>({type:"idle",updateType:C,error:D}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.IUpdateService=(0,I.createDecorator)("updateService")}),define(ee[245],te([0,1,4,174,67,50]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),C.Registry.as(n.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:I.isWindows&&!I.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[246],te([0,1,3,48]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class n{constructor(P){this.a=P}listen(P,d){switch(d){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${d}`)}call(P,d,h){switch(d){case"checkForUpdates":return this.a.checkForUpdates(h);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(h)}throw new Error(`Call not found: ${d}`)}}e.UpdateChannel=n;class C{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new I.Emitter,this.onStateChange=this.a.event,this.b=R.State.Uninitialized,this.c.listen("onStateChange")(d=>this.state=d),this.c.call("_getInitialState").then(d=>this.state=d)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=C}),define(ee[93],te([0,1,8,22,3,18,28,21,5,19,56,48]),function(x,e,I,R,n,C,D,P,d,h,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(p,w,a){return`${a.updateUrl}/api/update/${p}/${w}/${a.commit}`}e.createUpdateURL=b;let g=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,a,u,m,k,E){this.f=w,this.g=a,this.h=u,this.i=m,this.j=k,this.k=E,this.b=v.State.Uninitialized,this.c=new n.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),a=this.l(w);if(!a){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.r(a),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(v.State.Idle(this.p())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.m(30*1e3).then(void 0,u=>this.j.error(u))}l(w){return w==="none"?void 0:this.k.quality}m(w=60*60*1e3){return(0,I.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.m(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.s(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.n(this.state)}async n(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.o()}async o(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.q())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},R.CancellationToken.None)).res.statusCode===204}catch(a){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(a);return}}async _applySpecificUpdate(w){}p(){return 1}q(){}};g=we([_(0,P.ILifecycleMainService),_(1,C.IConfigurationService),_(2,D.IEnvironmentMainService),_(3,S.IRequestService),_(4,d.ILogService),_(5,h.IProductService)],g),e.AbstractUpdateService=g}),define(ee[247],te([0,1,14,54,3,2,18,28,21,5,19,56,24,48,93]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends p.AbstractUpdateService{get u(){return n.Event.fromNodeEventEmitter(I.autoUpdater,"error",(u,m)=>m)}get v(){return n.Event.fromNodeEventEmitter(I.autoUpdater,"update-not-available")}get w(){return n.Event.fromNodeEventEmitter(I.autoUpdater,"update-available",(u,m,k)=>({url:m,version:k,productVersion:k}))}get x(){return n.Event.fromNodeEventEmitter(I.autoUpdater,"update-downloaded",(u,m,k,E)=>({releaseNotes:m,version:k,productVersion:k,date:E}))}constructor(u,m,k,E,L,t,c){super(u,m,E,L,t,c),this.y=k,this.t=new C.DisposableStore}async initialize(){await super.initialize(),this.u(this.z,this,this.t),this.w(this.C,this,this.t),this.x(this.D,this,this.t),this.v(this.E,this,this.t)}z(u){this.j.error("UpdateService error:",u);const k=(this.state.type==="checking for updates"?this.state.explicit:!0)?u:void 0;this.d(g.State.Idle(1,k))}r(u){let m;this.k.darwinUniversalAssetId?m=this.k.darwinUniversalAssetId:m=process.arch==="x64"?"darwin":"darwin-arm64";const k=(0,p.createUpdateURL)(m,u,this.k);try{I.autoUpdater.setFeedURL({url:k})}catch(E){this.j.error("Failed to set update feed URL",E);return}return k}s(u){this.d(g.State.CheckingForUpdates(u)),I.autoUpdater.checkForUpdates()}C(u){this.state.type==="checking for updates"&&this.d(g.State.Downloading(u))}D(u){this.state.type==="downloading"&&(this.y.publicLog2("update:downloaded",{version:u.version}),this.d(g.State.Ready(u)))}E(){this.state.type==="checking for updates"&&(this.y.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(g.State.Idle(1)))}q(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),I.autoUpdater.quitAndInstall()}dispose(){this.t.dispose()}};we([R.memoize],w.prototype,"u",null),we([R.memoize],w.prototype,"v",null),we([R.memoize],w.prototype,"w",null),we([R.memoize],w.prototype,"x",null),w=we([_(0,d.ILifecycleMainService),_(1,D.IConfigurationService),_(2,b.ITelemetryService),_(3,P.IEnvironmentMainService),_(4,v.IRequestService),_(5,h.ILogService),_(6,S.IProductService)],w),e.DarwinUpdateService=w}),define(ee[248],te([0,1,46,41,8,3,9,28,21,5,24,48]),function(x,e,I,R,n,C,D,P,d,h,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,a,u){if(this.f=w,this.g=u,this.a=v.State.Uninitialized,this.b=new C.Emitter,this.onStateChange=this.b.event,a.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(v.State.Idle(this.k())),this.h(30*1e3).then(void 0,m=>this.g.error(m))}h(w=60*60*1e3){return(0,n.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};b=we([_(0,d.ILifecycleMainService),_(1,P.IEnvironmentMainService),_(2,h.ILogService)],b);let g=class extends b{constructor(w,a,u,m,k,E){super(u,m,k),this.o=w,this.p=a,this.q=E;const L=(0,R.watch)(D.dirname(this.o)),t=C.Event.fromNodeEventEmitter(L,"change",(s,l)=>l),c=C.Event.filter(t,s=>s==="current"),r=C.Event.debounce(c,(s,l)=>l,2e3)(()=>this.checkForUpdates(!1));u.onWillShutdown(()=>{r.dispose(),L.close()})}m(){this.d(v.State.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(v.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.State.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.State.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,I.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise((u,m)=>(0,R.realpath)(`${D.dirname(this.o)}/current`,(k,E)=>k?m(k):u(E))),a=D.basename(w);return this.p!==a}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};g=we([_(2,d.ILifecycleMainService),_(3,P.IEnvironmentMainService),_(4,h.ILogService),_(5,S.ITelemetryService)],g),e.SnapUpdateService=g}),define(ee[39],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(ee[249],te([0,1,39,195,16,20,128,3,2]),function(x,e,I,R,n,C,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class h{constructor(b){this.uri=b,this.time=h._clock++}touch(){return this.time=h._clock++,this}}h._clock=0;let S=class{constructor(b){this.g=b,this.c=new d.DisposableStore,this.f=2**16;const g=new Map,p=w=>{let a=g.get(w.scheme);return a===void 0&&(a=b.hasProvider(w)&&!this.g.hasCapability(w,1024),g.set(w.scheme,a)),a};this.c.add(P.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(w=>{g.delete(w.scheme)})),this.extUri=new C.ExtUri(p),this.d=new D.SkipList((w,a)=>this.extUri.compare(w,a,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,C.normalizePath)(b));const g=this.d.get(b);return g?g.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new h(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((p,w)=>p[1].touch<w[1].touch?1:p[1].touch>w[1].touch?-1:0);h._clock=0,this.d.clear();const g=this.f*.5;for(let p=0;p<g;p++)this.d.set(b[p][0],b[p][1].touch())}};S=we([_(0,n.IFileService)],S),e.UriIdentityService=S,(0,R.registerSingleton)(I.IUriIdentityService,S,1)}),define(ee[117],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,I.createDecorator)("urlService")}),define(ee[250],te([0,1,7]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class R{constructor(P){this.a=P}listen(P,d){throw new Error(`Event not found: ${d}`)}call(P,d,h){switch(d){case"handleURL":return this.a.handleURL(I.URI.revive(h[0]),h[1])}throw new Error(`Call not found: ${d}`)}}e.URLHandlerChannel=R;class n{constructor(P){this.a=P}handleURL(P,d){return this.a.call("handleURL",[P.toJSON(),d])}}e.URLHandlerChannelClient=n;class C{constructor(P,d){this.a=P,this.b=d}async routeCall(P,d,h,S){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(Array.isArray(h)&&h.length>0){const v=I.URI.revive(h[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",v.toString(!0)),v.query){const b=/\bwindowId=(\d+)/.exec(v.query);if(b){const g=b[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${g}"`,v.toString(!0));const p=new RegExp(`window:${g}`),w=P.connections.find(a=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",a.ctx),p.test(a.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",v.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",v.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",v.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,d,h,S)}routeEvent(P,d){throw new Error(`Event not found: ${d}`)}}e.URLHandlerRouter=C}),define(ee[251],te([0,1,8,2,7,19]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends R.Disposable{constructor(){super(...arguments),this.a=new Set}open(h,S){const v=[...this.a.values()];return(0,I.first)(v.map(b=>()=>b.handleURL(h,S)),void 0,!1).then(b=>b||!1)}registerHandler(h){return this.a.add(h),(0,R.toDisposable)(()=>this.a.delete(h))}}e.AbstractURLService=D;let P=class extends D{constructor(h){super(),this.b=h}create(h){let{authority:S,path:v,query:b,fragment:g}=h||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return S&&v&&v.indexOf("/")!==0&&(v=`/${v}`),n.URI.from({scheme:this.b.urlProtocol,authority:S,path:v,query:b,fragment:g})}};P=we([_(0,C.IProductService)],P),e.NativeURLService=P}),define(ee[252],te([0,1,14,8,3,2,4,7]),function(x,e,I,R,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class d{constructor(S,v,b,g,p,w){if(this.f=v,this.g=w,this.a=[],this.b=0,this.c=C.Disposable.None,this.d=new C.DisposableStore,S&&(w.trace("ElectronURLListener initialUrisToHandle:",S.map(m=>m.originalUrl)),this.a=S),D.isWindows){const m=g.isBuilt?[]:[`"${g.appRoot}"`];m.push("--open-url","--"),I.app.setAsDefaultProtocolClient(p.urlProtocol,process.execPath,m)}const a=n.Event.map(n.Event.fromNodeEventEmitter(I.app,"open-url",(m,k)=>({event:m,url:k})),({event:m,url:k})=>(m.preventDefault(),k));this.d.add(a(m=>{const k=this.h(m);!k||this.f.open(k,{originalUrl:m})})),b.getWindows().filter(m=>m.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),n.Event.once(b.onDidSignalReadyWindow)(this.i,this,this.d))}h(S){try{return P.URI.parse(S)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const S=[];for(const v of this.a)await this.f.open(v.uri,{originalUrl:v.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",v.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",v.originalUrl),S.push(v));S.length!==0&&(this.a=S,this.c=(0,R.disposableTimeout)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=d}),define(ee[253],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,I.createDecorator)("webviewManagerService")}),define(ee[254],te([0,1,14,2,15,7]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends R.Disposable{constructor(){super();const d=this.b.bind(this);I.protocol.registerFileProtocol(n.Schemas.vscodeWebview,d)}b(d,h){try{const S=C.URI.parse(d.url),v=D.a.get(S.path);if(typeof v=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${v}`,g=n.FileAccess.asFileUri(b);return h({path:decodeURIComponent(g.fsPath),headers:{...n.COI.getHeadersFromQuery(d.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return h({error:-10})}catch{}return h({error:-2})}}e.WebviewProtocolProvider=D,D.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(ee[76],te([0,1,4]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(S){return!!S.workspaceUri}e.isWorkspaceToOpen=R;function n(S){return!!S.folderUri}e.isFolderToOpen=n;function C(S){return!!S.fileUri}e.isFileToOpen=C;function D(S){const v=P(S),b=S.getValue("window.menuBarVisibility");return b==="default"||v==="native"&&b==="compact"||I.isMacintosh&&I.isNative?"classic":b}e.getMenuBarVisibility=D;function P(S){if(I.isWeb)return"custom";const v=S.getValue("window");if(v){if(I.isMacintosh&&v.nativeTabs===!0||I.isMacintosh&&v.nativeFullScreen===!1)return"native";const p=v.titleBarStyle;if(p==="native"||p==="custom")return p}return I.isLinux?"native":"custom"}e.getTitleBarStyle=P;function d(S){if(!I.isWindows||I.isWeb||P(S)==="native")return!1;const v=S.getValue("window.experimental.windowControlsOverlay.enabled");return typeof v=="boolean"?v:!0}e.useWindowControlsOverlay=d;function h(S=0){return Math.pow(1.2,S)}e.zoomLevelToZoomFactor=h}),define(ee[118],te([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var I;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(I=e.LoadReason||(e.LoadReason={}));var R;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(R=e.UnloadReason||(e.UnloadReason={}));const n=function(P=1){return{width:1024,height:768,mode:P}};e.defaultWindowState=n;var C;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(C=e.WindowMode||(e.WindowMode={}));var D;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(ee[30],te([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,I.createDecorator)("windowsMainService");var R;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(R=e.OpenContext||(e.OpenContext={}))}),define(ee[255],te([0,1,14,22,3,71,2,31,74,108,5,19,30]),function(x,e,I,R,n,C,D,P,d,h,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var g;(function(w){w[w.Initial=1]="Initial",w[w.StoredCredentialsUsed=2]="StoredCredentialsUsed",w[w.LoginDialogShown=3]="LoginDialogShown"})(g||(g={}));let p=class extends D.Disposable{constructor(a,u,m,k,E){super(),this.g=a,this.h=u,this.i=m,this.j=k,this.k=E,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=g.Initial,this.f=void 0,this.l()}l(){const a=n.Event.fromNodeEventEmitter(I.app,"login",(u,m,k,E,L)=>({event:u,webContents:m,req:k,authInfo:E,callback:L}));this.B(a(this.m,this))}async m({event:a,authInfo:u,req:m,callback:k}){if(!u.isProxy)return;if(!this.b&&this.c===g.LoginDialogShown&&m.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}a.preventDefault();let E;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),E=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(u);try{E=await this.b}finally{this.b=void 0}}k(E?.username,E?.password)}async n(a){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const u=await this.p(a);if(u)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),u;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(a){this.g.trace("auth#doResolveProxyCredentials - enter",a);const u=String((0,C.hash)({scheme:a.scheme,host:a.host,port:a.port}));let m,k;try{const c=await this.i.getPassword(this.a,u);if(c){const i=JSON.parse(await this.j.decrypt(c));m=i.username,k=i.password}}catch(c){this.g.error(c)}if(this.c!==g.StoredCredentialsUsed&&typeof m=="string"&&typeof k=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=g.StoredCredentialsUsed,{username:m,password:k};const E=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!E){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${E.id} to handle proxy login`);const L={authInfo:a,username:this.f?.username??m,password:this.f?.password??k,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};E.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,L),this.c=g.LoginDialogShown;const t=await new Promise(c=>{const i=async(r,s,l)=>{if(s===L.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${E.id}`),E.win?.webContents.off("ipc-message",i),l){const o={username:l.username,password:l.password};try{if(l.remember){const f=await this.j.encrypt(JSON.stringify(o));await this.i.setPassword(this.a,u,f)}else await this.i.deletePassword(this.a,u)}catch(f){this.g.error(f)}c({username:o.username,password:o.password})}else c(void 0)};E.win?.webContents.on("ipc-message",i)});return this.f=t,t}};p=we([_(0,S.ILogService),_(1,b.IWindowsMainService),_(2,d.ICredentialsMainService),_(3,h.IEncryptionMainService),_(4,v.IProductService)],p),e.ProxyAuthHandler=p}),define(ee[256],te([0,1,74,5,33,19,30,207]),function(x,e,I,R,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let d=class extends P.BaseCredentialsMainService{constructor(S,v,b,g){super(S),this.j=v,this.k=b,this.l=g,this.i=p=>{this.l.sendToFocused("vscode:showCredentialsError",p.message??p)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new I.InMemoryCredentialsProvider,this.f;const S=await new Promise((v,b)=>{x(["keytar"],v,b)});return await S.findCredentials("test-keytar-loads"),this.f=S,this.f}};d=we([_(0,R.ILogService),_(1,n.INativeEnvironmentService),_(2,C.IProductService),_(3,D.IWindowsMainService)],d),e.CredentialsNativeMainService=d}),define(ee[257],te([0,1,14,25,4,7,23,18,61,6,5,117,30]),function(x,e,I,R,n,C,D,P,d,h,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,h.createDecorator)(e.ID);let g=class{constructor(w,a,u,m){this.a=w,this.b=a,this.c=u,this.d=m}async start(w,a){this.a.trace("Received data from other instance: ",w,a),n.isMacintosh&&I.app.focus({steal:!0});const u=this.e(w);if(u.length){let m=Promise.resolve();if(this.b.getWindowCount()===0){const k=(0,R.firstOrDefault)(await this.b.openEmptyWindow({context:4}));k&&(m=k.ready())}m.then(()=>{for(const{uri:k,originalUrl:E}of u)this.c.open(k,{originalUrl:E})})}else return this.f(w,a)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,R.coalesce)(w._urls.map(a=>{try{return{uri:C.URI.parse(a),originalUrl:a}}catch{return null}})):[]}async f(w,a){const u=(0,d.isLaunchedFromCli)(a)?0:4;let m=[];const k=w.wait&&w.waitMarkerFilePath?C.URI.file(w.waitMarkerFilePath):void 0,E=w.remote||void 0,L={context:u,cli:w,userEnv:a,waitMarkerFileURI:k,remoteAuthority:E,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,L);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||L.forceProfile||L.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!n.isMacintosh}if(t)m=await this.b.open({...L,forceNewWindow:!0,forceEmpty:!0});else{const c=this.b.getLastActiveWindow();c?(this.b.openExistingWindow(c,L),m=[c]):m=await this.b.open({...L,forceEmpty:!0})}}else m=await this.b.open({...L,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(k&&m.length===1&&m[0])return Promise.race([m[0].whenClosedOrLoaded,(0,D.whenDeleted)(k.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};g=we([_(0,S.ILogService),_(1,b.IWindowsMainService),_(2,v.IURLService),_(3,P.IConfigurationService)],g),e.LaunchMainService=g}),define(ee[258],te([0,1,14,2,3,5,259,8,15,100,30,83,24]),function(x,e,I,R,n,C,D,P,d,h,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcess=void 0;let g=class It extends R.Disposable{constructor(w,a,u){super(),this.n=w,this.p=a,this.r=u,this.b=String(++It.a),this.c=this.B(new n.Emitter),this.onStdout=this.c.event,this.f=this.B(new n.Emitter),this.onStderr=this.f.event,this.g=this.B(new n.Emitter),this.onMessage=this.g.event,this.h=this.B(new n.Emitter),this.onExit=this.h.event,this.i=this.B(new n.Emitter),this.onCrash=this.i.event,this.j=void 0,this.k=void 0,this.l=void 0,this.m=!1}s(w,a){let u;switch(this.l?.correlationId?u=`[UtilityProcess id: ${this.l?.correlationId}, type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${w}`:u=`[UtilityProcess type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${w}`,a){case v.default.Error:this.n.error(u);break;case v.default.Warning:this.n.warn(u);break;case v.default.Info:this.n.info(u);break}}t(w){if(!h.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess API from Electron!");if(this.j){this.s("Cannot start utility process because it is already running...",v.default.Error);return}const a=this.p.getWindowById(w.responseWindowId)?.win;if(!a||a.isDestroyed()||a.webContents.isDestroyed()){this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",v.default.Error);return}return a}start(w){const a=this.t(w);if(!a)return;this.l=w;const u=`${this.l.type}-${this.b}`,m=d.FileAccess.asFileUri("bootstrap-fork.js").fsPath,k=[...this.l.args??[],`--type=${this.l.type}`],E=this.l.execArgv,L=this.l.allowLoadingUnsignedLibraries,t="pipe";let c=this.l.env;if(c){c={...c};for(const i of Object.keys(c))c[i]=String(c[i])}this.s("creating new...",v.default.Info),this.j=h.UtilityProcess.fork(m,k,{serviceName:u,env:c,execArgv:E,allowLoadingUnsignedLibraries:L,stdio:t}),this.u(this.j,this.l,u),this.v(this.j,this.l,a)}u(w,a,u){if(w.stdout){const m=new D.StringDecoder("utf-8");this.B(n.Event.fromNodeEventEmitter(w.stdout,"data")(k=>this.c.fire(typeof k=="string"?k:m.write(k))))}if(w.stderr){const m=new D.StringDecoder("utf-8");this.B(n.Event.fromNodeEventEmitter(w.stderr,"data")(k=>this.f.fire(typeof k=="string"?k:m.write(k))))}this.B(n.Event.fromNodeEventEmitter(w,"message")(m=>this.g.fire(m))),this.B(n.Event.fromNodeEventEmitter(w,"spawn")(()=>{this.k=w.pid,this.s("successfully created",v.default.Info)})),this.B(n.Event.fromNodeEventEmitter(w,"exit")(m=>{this.s(`received exit event with code ${m}`,v.default.Info),this.m=!0,this.h.fire({pid:this.k,code:m,signal:"unknown"})})),this.B(n.Event.fromNodeEventEmitter(I.app,"child-process-gone",(m,k)=>({event:m,details:k}))(({details:m})=>{m.type==="Utility"&&m.name===u&&(this.s(`crashed with code ${m.exitCode} and reason '${m.reason}'`,v.default.Error),this.r.publicLog2("utilityprocesscrash",{type:a.type,reason:m.reason,code:m.exitCode}),this.i.fire({pid:this.k,code:m.exitCode,reason:m.reason}))}))}v(w,a,u){const{port1:m,port2:k}=new I.MessageChannelMain;w.postMessage("null",[k]),u.webContents.postMessage(a.responseChannel,a.responseNonce,[m])}enableInspectPort(){if(typeof this.k!="number")return!1;this.s("enabling inspect port",v.default.Info);const w=process;return typeof w._debugProcess=="function"?(w._debugProcess(this.k),!0):!1}kill(){if(!this.j){this.s("no running process to kill",v.default.Warning);return}this.s("attempting to kill the process...",v.default.Info),this.j.kill()?this.s("successfully killed the process",v.default.Info):this.s("unable to kill the process",v.default.Warning)}async waitForExit(w){if(!this.j){this.s("no running process to wait for exit",v.default.Warning);return}this.m||(this.s("waiting to exit...",v.default.Info),await Promise.race([n.Event.toPromise(this.onExit),(0,P.timeout)(w)]),this.m||(this.s("did not exit within ${maxWaitTimeMs}ms, will kill it now...",v.default.Info),this.kill()))}};g.a=0,g=we([_(0,C.ILogService),_(1,S.IWindowsMainService),_(2,b.ITelemetryService)],g),e.UtilityProcess=g}),define(ee[260],te([0,1,13,2,3,5,21,70,46,259,8,15,44,4,36,100,258,30,24]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let k=class Pt{constructor(t,c,i,r){this.d=t,this.f=i,this.g=r,this.c=!1,this.b=new Map,c.onWillShutdown(s=>{this.c=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}h(t){const c=this.b.get(t);if(!c)throw new Error("Unknown extension host!");return c}onDynamicStdout(t){return this.h(t).onStdout}onDynamicStderr(t){return this.h(t).onStderr}onDynamicMessage(t){return this.h(t).onMessage}onDynamicError(t){const c=this.h(t);return c instanceof a.UtilityProcess?n.Event.None:c.onError}onDynamicExit(t){return this.h(t).onExit}async canUseUtilityProcess(){return w.canUseUtilityProcess}async createExtensionHost(t){if(this.c)throw(0,I.canceled)();const c=String(++Pt.a);let i;if(t){if(!w.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess!");i=new a.UtilityProcess(this.d,this.f,this.g)}else i=new E(c,this.d);return this.b.set(c,i),i.onExit(({pid:r,code:s,signal:l})=>{this.d.info(`Extension host with pid ${r} exited with code: ${s}, signal: ${l}.`),setTimeout(()=>{i.dispose(),this.b.delete(c)})}),{id:c}}async start(t,c){if(this.c)throw(0,I.canceled)();return this.h(t).start({...c,type:"extensionHost",args:["--skipWorkspaceStorageLock"],execArgv:c.execArgv??[],allowLoadingUnsignedLibraries:!0,correlationId:t})}async enableInspectPort(t){if(this.c)throw(0,I.canceled)();const c=this.b.get(t);return c?c.enableInspectPort():!1}async kill(t){if(this.c)throw(0,I.canceled)();const c=this.b.get(t);!c||c.kill()}async _killAllNow(){for(const[,t]of this.b)t.kill()}async _waitForAllExit(t){const c=[];for(const[,i]of this.b)c.push(i.waitForExit(t));return S.Promises.settled(c).then(()=>{})}};k.a=0,k=we([_(0,C.ILogService),_(1,D.ILifecycleMainService),_(2,u.IWindowsMainService),_(3,m.ITelemetryService)],k),e.ExtensionHostStarter=k;let E=class extends R.Disposable{constructor(t,c){super(),this.id=t,this.c=c,this._onStdout=this.B(new n.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new n.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new n.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new n.Emitter),this.onError=this._onError.event,this._onExit=this.B(new n.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(t){g.isCI&&this.c.info("Calling fork to start extension host...");const c=P.StopWatch.create(!1);this.a=(0,d.fork)(v.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,b.mixin)({cwd:(0,p.cwd)()},t));const i=c.elapsed(),r=this.a.pid;this.c.info(`Starting extension host with pid ${r} (fork() took ${i} ms).`);const s=new h.StringDecoder("utf-8");this.a.stdout?.on("data",o=>{const f=typeof o=="string"?o:s.write(o);this._onStdout.fire(f)});const l=new h.StringDecoder("utf-8");this.a.stderr?.on("data",o=>{const f=typeof o=="string"?o:l.write(o);this._onStderr.fire(f)}),this.a.on("message",o=>{this._onMessage.fire(o)}),this.a.on("error",o=>{this._onError.fire({error:(0,I.transformErrorForSerialization)(o)})}),this.a.on("exit",(o,f)=>{this.b=!0,this._onExit.fire({pid:r,code:o,signal:f})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):g.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(t){if(!this.a)return;const c=this.a.pid;this.c.info(`Waiting for extension host with pid ${c} to exit.`),await Promise.race([n.Event.toPromise(this.onExit),(0,S.timeout)(t)]),this.b||(this.c.info(`Extension host with pid ${c} did not exit within ${t}ms.`),this.a.kill())}};E=we([_(1,C.ILogService)],E)}),define(ee[261],te([0,1,14,3,2,254,30]),function(x,e,I,R,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends n.Disposable{constructor(h){super(),this.b=h,this.a=this.B(new R.Emitter),this.onFoundInFrame=this.a.event,this.B(new C.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(h,S){let v;if(typeof h.windowId=="number"){const{windowId:b}=h,g=this.b.getWindowById(b);if(!g?.win)throw new Error(`Invalid windowId: ${b}`);v=g.win.webContents}else{const{webContentsId:b}=h;if(v=I.webContents.fromId(b),!v)throw new Error(`Invalid webContentsId: ${b}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(S)}async findInFrame(h,S,v,b){const p=this.c(h,S);if(typeof p.findInFrame=="function"){p.findInFrame(v,{findNext:b.findNext,forward:b.forward});const w=(a,u)=>{u.finalUpdate&&(this.a.fire(u),p.removeListener("found-in-frame",w))};p.on("found-in-frame",w)}}async stopFindInFrame(h,S,v){const g=this.c(h,S);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}c(h,S){const v=this.b.getWindowById(h.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${h}`);const b=v.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===S);if(!b)throw new Error(`Unknown frame: ${S}`);return b}};P=we([_(0,D.IWindowsMainService)],P),e.WebviewMainService=P}),define(ee[262],te([0,1,8,3,2]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class C extends n.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:d,getActiveWindowId:h}){super(),this.a=this.B(new n.DisposableStore),R.Event.latch(R.Event.any(P,d))(this.f,this,this.a),this.b=(0,I.createCancelablePromise)(()=>h()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=C}),define(ee[29],te([0,1,178,9,60,20,7,6,15]),function(x,e,I,R,n,C,D,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function h(i){const r=i;return typeof r?.id=="string"&&D.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=h;function S(i){return typeof i?.id=="string"&&!h(i)&&!b(i)}e.isEmptyWorkspaceIdentifier=S,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function v(i,r){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.basename)(i)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const s=i;return s.configuration?{id:s.id,configPath:s.configuration}:s.folders.length===1?{id:s.id,uri:s.folders[0].uri}:{id:s.id}}e.toWorkspaceIdentifier=v;function b(i){const r=i;return typeof r?.id=="string"&&D.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=b;function g(i){const r=i;if(r?.uri)return{id:r.id,uri:D.URI.revive(r.uri)};const s=i;if(s?.configPath)return{id:s.id,configPath:D.URI.revive(s.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=g;var p;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function w(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=w;function a(i){const r=i;return!!(r&&typeof r=="object"&&D.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=a;class u{constructor(r,s,l,o,f){this.h=r,this.j=l,this.k=o,this.l=f,this.c=n.TernarySearchTree.forUris(this.l,()=>!0),this.folders=s}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=n.TernarySearchTree.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class m{constructor(r,s){this.raw=s,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,C.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function k(i){return new m({uri:i,index:0,name:(0,C.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=k,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(i,r){return C.extUriBiasedIgnorePathCase.isEqualOrParent(i,r.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function L(i){let r;return D.URI.isUri(i)?r=i:r=i.configuration,r?.scheme===d.Schemas.tmp}e.isTemporaryWorkspace=L;function t(i,r){return!E(i,r)&&!L(i)}e.isSavedWorkspace=t;function c(i){return(typeof i=="string"?(0,R.extname)(i):(0,C.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=c}),define(ee[57],te([0,1,14,8,71,37,2,79,4,10,23,155,6,5,29]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,b.createDecorator)("dialogMainService");let w=class{constructor(u){this.d=u,this.a=new Map,this.b=new Map,this.c=new R.Queue}pickFileFolder(u,m){return this.e({...u,pickFolders:!0,pickFiles:!0,title:(0,v.localize)(0,null)},m)}pickFolder(u,m){return this.e({...u,pickFolders:!0,title:(0,v.localize)(1,null)},m)}pickFile(u,m){return this.e({...u,pickFiles:!0,title:(0,v.localize)(2,null)},m)}pickWorkspace(u,m){const k=(0,v.localize)(3,null),E=(0,C.mnemonicButtonLabel)((0,v.localize)(4,null)),L=p.WORKSPACE_FILTER;return this.e({...u,pickFiles:!0,title:k,filters:L,buttonLabel:E},m)}async e(u,m){const k={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters,defaultPath:u.defaultPath};(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(k.properties=void 0,u.pickFiles&&u.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),d.isMacintosh&&k.properties.push("treatPackageAsDirectory");const E=await this.showOpenDialog(k,(0,h.withNullAsUndefined)(m||I.BrowserWindow.getFocusedWindow()));if(E&&E.filePaths&&E.filePaths.length>0)return E.filePaths}f(u){if(u){let m=this.b.get(u.id);return m||(m=new R.Queue,this.b.set(u.id,m)),m}else return this.c}showMessageBox(u,m){return this.f(m).queue(async()=>m?I.dialog.showMessageBox(m,u):I.dialog.showMessageBox(u))}async showSaveDialog(u,m){const k=this.i(u,m);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.f(m).queue(async()=>{let E;return m?E=await I.dialog.showSaveDialog(m,u):E=await I.dialog.showSaveDialog(u),E.filePath=this.g(E.filePath),E})}finally{(0,D.dispose)(k)}}g(u){return u&&d.isMacintosh&&(u=(0,P.normalizeNFC)(u)),u}h(u){return u.map(m=>this.g(m))}async showOpenDialog(u,m){u.defaultPath&&(await S.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const k=this.i(u,m);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.f(m).queue(async()=>{let E;return m?E=await I.dialog.showOpenDialog(m,u):E=await I.dialog.showOpenDialog(u),E.filePaths=this.h(E.filePaths),E})}finally{(0,D.dispose)(k)}}i(u,m){if(!m)return D.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",u);let k=this.a.get(m.id);k||(k=new Set,this.a.set(m.id,k));const E=(0,n.hash)(u);if(!k.has(E))return this.d.trace("[DialogMainService]: new file dialog lock created",u),k.add(E),(0,D.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",u),k?.delete(E),k?.size===0&&this.a.delete(m.id)})}};w=we([_(0,g.ILogService)],w),e.DialogMainService=w}),define(ee[263],te([0,1,3,2,72,29]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends R.Disposable{constructor(d,h){super(),this.f=d,this.g=h,this.b=this.B(new I.Emitter),this.c=new Map,this.h(h.applicationStorage,this.b)}h(d,h){this.B(I.Event.debounce(d.onDidChangeStorage,(S,v)=>(S?S.push(v):S=[v],S),D.a)(S=>{S.length&&h.fire(this.i(S,d))}))}i(d,h){const S=new Map,v=new Set;return d.forEach(b=>{const g=h.get(b.key);typeof g=="string"?S.set(b.key,g):v.add(b.key)}),{changed:Array.from(S.entries()),deleted:Array.from(v.values())}}listen(d,h,S){switch(h){case"onDidChangeStorage":{const v=S.profile?(0,n.revive)(S.profile):void 0;if(!v)return this.b.event;let b=this.c.get(v.id);return b||(b=this.B(new I.Emitter),this.h(this.g.profileStorage(v),b),this.c.set(v.id,b)),b.event}}throw new Error(`Event not found: ${h}`)}async call(d,h,S){const v=S.profile?(0,n.revive)(S.profile):void 0,b=(0,C.reviveIdentifier)(S.workspace),g=await this.j(v,b);switch(h){case"getItems":return Array.from(g.items.entries());case"updateItems":{const p=S;if(p.insert)for(const[w,a]of p.insert)g.set(w,a);p.delete?.forEach(w=>g.delete(w));break}case"isUsed":{const p=S.payload;if(typeof p=="string")return this.g.isUsed(p)}default:throw new Error(`Call not found: ${h}`)}}async j(d,h){let S;h?S=this.g.workspaceStorage(h):d?S=this.g.profileStorage(d):S=this.g.applicationStorage;try{await S.init()}catch(v){this.f.error(`StorageIPC#init: Unable to init ${h?"workspace":d?"profile":"application"} storage due to ${v}`)}return S}}e.StorageDatabaseChannel=D,D.a=100}),define(ee[40],te([0,1,71,3,2,20,7,175,33,16,6,5,29,35,39,8,31,27,10]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function k(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&D.URI.isUri(r.location)&&D.URI.isUri(r.globalStorageHome)&&D.URI.isUri(r.settingsResource)&&D.URI.isUri(r.keybindingsResource)&&D.URI.isUri(r.tasksResource)&&D.URI.isUri(r.snippetsHome)&&D.URI.isUri(r.extensionsResource))}e.isUserDataProfile=k,e.IUserDataProfilesService=(0,S.createDecorator)("IUserDataProfilesService");function E(i,r){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:D.URI.revive(i.location).with({scheme:r}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:r}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:r}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:r}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:r}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:r}),extensionsResource:D.URI.revive(i.extensionsResource)?.with({scheme:r}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=E;function L(i,r,s,l){return{id:i,name:r,location:s,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,C.joinPath)(s,"globalStorage"),settingsResource:(0,C.joinPath)(s,"settings.json"),keybindingsResource:(0,C.joinPath)(s,"keybindings.json"),tasksResource:(0,C.joinPath)(s,"tasks.json"),snippetsHome:(0,C.joinPath)(s,"snippets"),extensionsResource:(0,C.joinPath)(s,"extensions.json"),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=L;let t=class extends n.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(r,s,l,o){super(),this.m=r,this.n=s,this.r=l,this.s=o,this.f=!0,this.g=this.B(new R.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new R.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new R.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new R.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new g.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,C.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(r){this.f!==r&&(this.t=void 0,this.f=r)}isEnabled(){return this.f}get u(){if(!this.t){const r=[];if(this.f)for(const f of this.G()){if(!f.name||!(0,m.isString)(f.name)||!f.location){this.s.warn("Skipping the invalid stored profile",f.location||f.name);continue}r.push(L((0,C.basename)(f.location),f.name,f.location,{shortName:f.shortName,useDefaultFlags:f.useDefaultFlags}))}const s=new g.ResourceMap,l=new Map,o=L((0,I.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(r.unshift({...o,extensionsResource:this.L()??o.extensionsResource,isDefault:!0}),r.length){const f=this.I();if(f.workspaces)for(const[y,M]of Object.entries(f.workspaces)){const O=D.URI.parse(y),j=D.URI.parse(M),G=r.find(H=>this.r.extUri.isEqual(H.location,j));G&&s.set(O,G)}if(f.emptyWindows)for(const[y,M]of Object.entries(f.emptyWindows)){const O=D.URI.parse(M),j=r.find(G=>this.r.extUri.isEqual(G.location,O));j&&l.set(y,j)}}this.t={profiles:r,workspaces:s,emptyWindows:l}}return this.t}async createTransientProfile(r){const s="Temp",l=new RegExp(`${(0,u.escapeRegExpCharacters)(s)}\\s(\\d+)`);let o=0;for(const y of this.profiles){const M=l.exec(y.name),O=M?parseInt(M[1]):0;o=O>o?O:o}const f=`${s} ${o+1}`;return this.createProfile((0,I.hash)((0,a.generateUuid)()).toString(16),f,{transient:!0},r)}async createNamedProfile(r,s,l){return this.createProfile((0,I.hash)((0,a.generateUuid)()).toString(16),r,s,l)}async createProfile(r,s,l,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const f=await this.v(r,s,l);return o&&await this.setProfileForWorkspace(o,f),f}async v(r,s,l){if(!(0,m.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let o=this.k.get(s);return o||(o=(async()=>{try{const f=this.profiles.find(O=>O.name===s||O.id===r);if(f)return f;const y=L(r,s,(0,C.joinPath)(this.profilesHome,r),l);await this.n.createFolder(y.location);const M=[];return this.h.fire({profile:y,join(O){M.push(O)}}),await w.Promises.settled(M),this.z([y],[],[]),y}finally{this.k.delete(s)}})(),this.k.set(s,o)),o}async updateProfile(r,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(o=>o.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);return l=L(l.id,s.name??l.name,l.location,{shortName:s.shortName??l.shortName,transient:s.transient??l.isTransient,useDefaultFlags:s.useDefaultFlags??l.useDefaultFlags}),this.z([],[],[l]),l}async removeProfile(r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(o=>o.id===r.id);if(!s)throw new Error(`Profile '${r.name}' does not exist`);const l=[];this.i.fire({profile:s,join(o){l.push(o)}});try{await Promise.allSettled(l)}catch(o){this.s.error(o)}for(const o of[...this.u.emptyWindows.keys()])s.id===this.u.emptyWindows.get(o)?.id&&this.u.emptyWindows.delete(o);for(const o of[...this.u.workspaces.keys()])s.id===this.u.workspaces.get(o)?.id&&this.u.workspaces.delete(o);this.F(),this.z([],[s],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(s.location,{recursive:!0})}catch(o){this.s.error(o)}}async setProfileForWorkspace(r,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(o=>o.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);this.D(r,l)}unsetWorkspace(r,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.D(r,void 0,s)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const r=await this.n.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(s=>s.isDirectory&&this.profiles.every(l=>!this.r.extUri.isEqual(l.location,s.resource))).map(s=>this.n.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.l.profiles.filter(s=>!this.y(s));await Promise.allSettled(r.map(s=>this.removeProfile(s)))}getProfileForWorkspace(r){const s=this.w(r);return D.URI.isUri(s)?this.l.workspaces.get(s)??this.u.workspaces.get(s):this.l.emptyWindows.get(s)??this.u.emptyWindows.get(s)}w(r){return(0,b.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,b.isWorkspaceIdentifier)(r)?r.configPath:r.id}y(r){return!!([...this.l.emptyWindows.values()].some(s=>this.r.extUri.isEqual(s.location,r.location))||[...this.l.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,r.location))||[...this.u.emptyWindows.values()].some(s=>this.r.extUri.isEqual(s.location,r.location))||[...this.u.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,r.location)))}z(r,s,l){const o=[...this.profiles,...r],f=[];this.l.profiles=[];for(let y of o)y.isDefault||s.some(M=>y.id===M.id)||(y=l.find(M=>y.id===M.id)??y,y.isTransient?this.l.profiles.push(y):f.push({location:y.location,name:y.name,shortName:y.shortName,useDefaultFlags:y.useDefaultFlags}));this.H(f),this.t=void 0,this.C(r,s,l)}C(r,s,l){this.g.fire({added:r,removed:s,updated:l,all:this.profiles})}D(r,s,l){l=s?.isTransient?!0:l,l||this.D(r,void 0,!0);const o=this.w(r),f=l?this.l:this.u;D.URI.isUri(o)?(f.workspaces.delete(o),s&&f.workspaces.set(o,s)):(f.emptyWindows.delete(o),s&&f.emptyWindows.set(o,s)),l||this.F()}F(){const r={};for(const[l,o]of this.u.workspaces.entries())r[l.toString()]=o.location.toString();const s={};for(const[l,o]of this.u.emptyWindows.entries())s[l.toString()]=o.location.toString();this.J({workspaces:r,emptyWindows:s}),this.t=void 0}G(){return[]}H(r){throw new Error("not implemented")}I(){return{}}J(r){throw new Error("not implemented")}L(){}};t.b="userDataProfiles",t.c="profileAssociations",t=we([_(0,d.IEnvironmentService),_(1,h.IFileService),_(2,p.IUriIdentityService),_(3,v.ILogService)],t),e.UserDataProfilesService=t;class c extends t{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(r){this.a=r}I(){return this.O}J(r){this.O=r}}e.InMemoryUserDataProfilesService=c}),define(ee[77],te([0,1,8,17,2,3,35,7,113,90,16,6,5,40,39,10,13,24]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(c){c.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",c.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class k extends Error{constructor(i,r){super(i),this.code=r}}e.ExtensionsProfileScanningError=k,e.IExtensionsProfileScannerService=(0,v.createDecorator)("IExtensionsProfileScannerService");let E=class extends n.Disposable{constructor(i,r,s,l,o,f){super(),this.h=i,this.i=r,this.j=s,this.k=l,this.l=o,this.m=f,this.a=this.B(new C.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new C.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new C.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new C.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new D.ResourceMap}scanProfileExtensions(i,r){return this.n(i,void 0,r)}async addExtensionsToProfile(i,r){const s=[],l=[];try{return await this.n(r,o=>{const f=[];for(const y of o)i.some(([M])=>(0,d.areSameExtensions)(M.identifier,y.identifier)&&M.manifest.version!==y.version)?s.push(y):f.push(y);for(const[y,M]of i)if(!f.some(O=>(0,d.areSameExtensions)(O.identifier,y.identifier)&&O.version===y.manifest.version)){const O={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:M};l.push(O),f.push(O)}return l.length&&this.a.fire({extensions:l,profileLocation:r}),s.length&&this.c.fire({extensions:s,profileLocation:r}),f}),l.length&&this.b.fire({extensions:l,profileLocation:r}),s.length&&this.f.fire({extensions:s,profileLocation:r}),l}catch(o){throw l.length&&this.b.fire({extensions:l,error:o,profileLocation:r}),s.length&&this.f.fire({extensions:s,error:o,profileLocation:r}),o}}async updateMetadata(i,r){const s=[];return await this.n(r,l=>{const o=[];for(const f of l){const y=i.find(([M])=>(0,d.areSameExtensions)(M.identifier,f.identifier)&&M.manifest.version===f.version);y&&(f.metadata={...f.metadata,...y[1]},s.push(f)),o.push(f)}return o}),s}async removeExtensionFromProfile(i,r){const s=[];this.c.fire({extensions:s,profileLocation:r});try{await this.n(r,l=>{const o=[];for(const f of l)(0,d.areSameExtensions)(f.identifier,i.identifier)?s.push(f):o.push(f);return s.length&&this.c.fire({extensions:s,profileLocation:r}),o}),s.length&&this.f.fire({extensions:s,profileLocation:r})}catch(l){throw s.length&&this.f.fire({extensions:s,error:l,profileLocation:r}),l}}async n(i,r,s){return this.v(i).queue(async()=>{let l=[],o;try{const f=await this.i.readFile(i);o=JSON.parse(f.value.toString())}catch(f){if((0,S.toFileOperationResult)(f)!==1)throw f;if(this.k.extUri.isEqual(i,this.j.defaultProfile.extensionsResource)&&(o=await this.u()),!o&&s?.bailOutWhenFileNotFound)throw new k((0,a.getErrorMessage)(f),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.p(i);let f=!1;for(const y of o){L(y)||this.p(i);let M;if((0,w.isString)(y.location))M=this.s(y.location);else{M=P.URI.revive(y.location);const O=this.r(M);O&&(f=!0,y.location=O)}l.push({identifier:y.identifier,location:M,version:y.version,metadata:y.metadata})}f&&await this.i.writeFile(i,R.VSBuffer.fromString(JSON.stringify(o)))}if(r){l=r(l);const f=l.map(y=>({identifier:y.identifier,version:y.version,location:this.r(y.location)??y.location.toJSON(),metadata:y.metadata}));await this.i.writeFile(i,R.VSBuffer.fromString(JSON.stringify(f)))}return l})}p(i){const r=new k(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:r.code}),r}r(i){return this.k.extUri.isEqualOrParent(i,this.h)?this.k.extUri.relativePath(this.h,i):void 0}s(i){return this.k.extUri.joinPath(this.h,i)}async u(){return this.t||(this.t=(async()=>{const i=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let r;try{r=(await this.i.readFile(i)).value.toString()}catch(l){if((0,S.toFileOperationResult)(l)===1)return;throw l}this.m.info("Migrating extensions from old default profile location",i.toString());let s;try{const l=JSON.parse(r);Array.isArray(l)&&l.every(o=>L(o))?s=l:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.m.error(l)}if(s)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify(s)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",i.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(l){if((0,S.toFileOperationResult)(l)===3)this.m.info("Migration from old default profile location to new location is done by another window",i.toString(),this.j.defaultProfile.extensionsResource.toString());else throw l}try{await this.i.del(i)}catch(l){(0,S.toFileOperationResult)(l)!==1&&this.m.error(l)}return s})()),this.t}v(i){let r=this.g.get(i);return r||(r=new I.Queue,this.g.set(i,r)),r}};E=we([_(1,S.IFileService),_(2,g.IUserDataProfilesService),_(3,p.IUriIdentityService),_(4,u.ITelemetryService),_(5,b.ILogService)],E),e.AbstractExtensionsProfileScannerService=E;function L(c){return(0,w.isObject)(c)&&(0,h.isIExtensionIdentifier)(c.identifier)&&(t(c.location)||(0,w.isString)(c.location))&&c.version&&(0,w.isString)(c.version)}function t(c){return c?(0,w.isString)(c.path)&&(0,w.isString)(c.scheme):!1}}),define(ee[119],te([0,1,25,8,44,17,13,43,141,2,15,9,4,20,193,83,10,7,160,33,113,90,192,16,6,5,19,3,72,77,40,39,190,191]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u,m,k,E,L,t,c,i,r,s,l,o,f,y,M,O,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var G;(function(ge){function V(F,W){if(F===W)return!0;const z=Object.keys(F),X=new Set;for(const ie of Object.keys(W))X.add(ie);if(z.length!==X.size)return!1;for(const ie of z){if(F[ie]!==W[ie])return!1;X.delete(ie)}return X.size===0}ge.equals=V})(G=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let H=class extends h.Disposable{constructor(V,F,W,z,X,ie,se,Q,A,T,U,B){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=F,this.l=W,this.m=z,this.n=X,this.p=ie,this.r=se,this.s=Q,this.t=A,this.u=T,this.v=U,this.w=B,this.g=this.B(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,g.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(re,(0,g.joinPath)(this.m,L.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(re,(0,g.joinPath)(this.m,L.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(ne,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,E.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(V,F,W){const[z,X]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(F)]),ie=W?await this.scanExtensionsUnderDevelopment(V,[...z,...X]):[];return this.F(z,X,ie,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const F=[];F.push(this.G(!!V.useCache,V.language)),F.push(this.H(V.language,!!V.checkControlFile));const[W,z]=await Promise.all(F);return this.D([...W,...z],0,V,!1)}async scanUserExtensions(V){const F=V.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",F);const W=this.v.extUri.isEqual(V.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.J(F,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,W),X=V.useCache&&!z.devMode&&z.excludeObsolete?this.j:this.k;let ie;try{ie=await X.scanExtensions(z)}catch(se){if(se instanceof f.ExtensionsProfileScanningError&&se.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),ie=await X.scanExtensions(z);else throw se}return ie=await this.D(ie,1,V,!0),this.s.trace("Scanned user extensions:",ie.length),ie}async scanExtensionsUnderDevelopment(V,F){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const W=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(z=>z.scheme===S.Schemas.file).map(async z=>{const X=await this.J(z,!1,1,!0,V.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(X)).map(se=>(se.type=F.find(Q=>(0,E.areSameExtensions)(Q.identifier,se.identifier))?.type??se.type,this.k.validate(se,X)))}))).flat();return this.D(W,"development",V,!0)}return[]}async scanExistingExtension(V,F,W){const z=await this.J(V,!1,F,!0,W.language,!0,void 0),X=await this.k.scanExtension(z);return!X||!W.includeInvalid&&!X.isValid?null:X}async scanOneOrMultipleExtensions(V,F,W){const z=await this.J(V,!1,F,!0,W.language,!0,void 0),X=await this.k.scanOneOrMultipleExtensions(z);return this.D(X,F,W,!0)}async scanMetadata(V){const F=(0,g.joinPath)(V,"package.json"),W=(await this.r.readFile(F)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(V,F){const W=(0,g.joinPath)(V,"package.json"),z=(await this.r.readFile(W)).value.toString(),X=JSON.parse(z);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,X.__metadata={...X.__metadata,...F},await this.r.writeFile((0,g.joinPath)(V,"package.json"),C.VSBuffer.fromString(JSON.stringify(X,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof f.ExtensionsProfileScanningError&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw V}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.p.addExtensionsToProfile(V.map(F=>[F,F.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,C.VSBuffer.fromString(JSON.stringify([])))}catch(F){(0,c.toFileOperationResult)(F)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.getErrorMessage)(F))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.s.error(V)}finally{this.z=void 0}})()),this.z}async D(V,F,W,z){return W.includeAllVersions||(V=this.F(F===0?V:void 0,F===1?V:void 0,F==="development"?V:void 0,await this.getTargetPlatform(),z)),W.includeInvalid||(V=V.filter(X=>X.isValid)),V.sort((X,ie)=>{const se=v.basename(X.location.fsPath),Q=v.basename(ie.location.fsPath);return se<Q?-1:se>Q?1:0})}F(V,F,W,z,X){const ie=(Q,A,T)=>{if(Q.isValid&&!A.isValid)return!1;if(Q.isValid===A.isValid){if(X&&p.gt(Q.manifest.version,A.manifest.version))return this.s.debug(`Skipping extension ${A.location.path} with lower version ${A.manifest.version} in favour of ${Q.location.path} with version ${Q.manifest.version}`),!1;if(p.eq(Q.manifest.version,A.manifest.version)){if(Q.type===0)return this.s.debug(`Skipping extension ${A.location.path} in favour of system extension ${Q.location.path} with same version`),!1;if(Q.targetPlatform===z)return this.s.debug(`Skipping extension ${A.location.path} from different target platform ${A.targetPlatform}`),!1}}return T?this.s.warn(`Overwriting user extension ${Q.location.path} with ${A.location.path}.`):this.s.debug(`Overwriting user extension ${Q.location.path} with ${A.location.path}.`),!0},se=new Map;return V?.forEach(Q=>{const A=L.ExtensionIdentifier.toKey(Q.identifier.id),T=se.get(A);(!T||ie(T,Q,!1))&&se.set(A,Q)}),F?.forEach(Q=>{const A=L.ExtensionIdentifier.toKey(Q.identifier.id),T=se.get(A);if(!T&&V&&Q.type===0){this.s.debug(`Skipping obsolete system extension ${Q.location.path}.`);return}(!T||ie(T,Q,!1))&&se.set(A,Q)}),W?.forEach(Q=>{const A=L.ExtensionIdentifier.toKey(Q.identifier.id),T=se.get(A);(!T||ie(T,Q,!0))&&se.set(A,Q),se.set(A,Q)}),[...se.values()]}async G(V,F){this.s.trace("Started scanning system extensions");const W=await this.J(this.systemExtensionsLocation,!1,0,!0,F,!0,void 0),X=await(V&&!W.devMode?this.i:this.k).scanExtensions(W);return this.s.trace("Scanned system extensions:",X.length),X}async H(V,F){const W=this.t.isBuilt?[]:this.u.builtInExtensions;if(!W?.length)return[];this.s.trace("Started scanning dev system extensions");const z=F?await this.I():{},X=[],ie=u.URI.file(v.normalize(v.join(S.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Q of W){const A=z[Q.name]||"marketplace";switch(A){case"disabled":break;case"marketplace":X.push((0,g.joinPath)(ie,Q.name));break;default:X.push(u.URI.file(A));break}}const se=await Promise.all(X.map(async Q=>this.k.scanExtension(await this.J(Q,!1,0,!0,V,!0,void 0))));return this.s.trace("Scanned dev system extensions:",se.length),(0,I.coalesce)(se)}async I(){try{const V=await this.r.readFile(this.l);return JSON.parse(V.value.toString())}catch{return{}}}async J(V,F,W,z,X,ie,se){const Q=await this.f(X??b.language),A=await this.L(V),T=F&&!this.v.extUri.isEqual(V,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,U=T?await this.L(T):void 0;return new K(V,A,T,U,F,se,W,z,ie,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,X,Q)}async L(V){try{const F=await this.r.stat(V);if(typeof F.mtime=="number")return F.mtime}catch{}}};H=we([_(4,y.IUserDataProfilesService),_(5,f.IExtensionsProfileScannerService),_(6,c.IFileService),_(7,r.ILogService),_(8,k.IEnvironmentService),_(9,s.IProductService),_(10,M.IUriIdentityService),_(11,i.IInstantiationService)],H),e.AbstractExtensionsScannerService=H;class K{constructor(V,F,W,z,X,ie,se,Q,A,T,U,B,q,N,$){this.location=V,this.mtime=F,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=z,this.profile=X,this.profileScanOptions=ie,this.type=se,this.excludeObsolete=Q,this.validate=A,this.productVersion=T,this.productDate=U,this.productCommit=B,this.devMode=q,this.language=N,this.translations=$}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,F){return(0,g.isEqual)(V.location,F.location)&&V.mtime===F.mtime&&(0,g.isEqual)(V.applicationExtensionslocation,F.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&V.profile===F.profile&&n.equals(V.profileScanOptions,F.profileScanOptions)&&V.type===F.type&&V.excludeObsolete===F.excludeObsolete&&V.validate===F.validate&&V.productVersion===F.productVersion&&V.productDate===F.productDate&&V.productCommit===F.productCommit&&V.devMode===F.devMode&&V.language===F.language&&G.equals(V.translations,F.translations)}}e.ExtensionScannerInput=K;let ne=class extends h.Disposable{constructor(V,F,W,z,X){super(),this.f=V,this.g=F,this.h=W,this.i=z,this.j=X}async scanExtensions(V){const F=V.profile?await this.l(V):await this.k(V);let W={};if(V.excludeObsolete&&V.type===1)try{const z=(await this.i.readFile(this.f)).value.toString();W=JSON.parse(z)}catch{}return(0,a.isEmptyObject)(W)?F:F.filter(z=>!W[E.ExtensionKey.create(z).toString()])}async k(V){const F=await this.i.resolve(V.location);if(!F.children?.length)return[];const W=await Promise.all(F.children.map(async z=>{if(!z.isDirectory||V.type===1&&(0,g.basename)(z.resource).indexOf(".")===0)return null;const X=new K(z.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(X)}));return(0,I.coalesce)(W).sort((z,X)=>z.location.path<X.location.path?-1:1)}async l(V){let F=await this.m(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){F=F.filter(z=>!z.metadata?.isApplicationScoped);const W=await this.m(V.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,V);F.push(...W)}return F}async m(V,F,W){const z=await this.g.scanProfileExtensions(V,W.profileScanOptions);if(!z.length)return[];const X=await Promise.all(z.map(async ie=>{if(F(ie)){const se=new K(ie.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(se,ie.metadata)}return null}));return(0,I.coalesce)(X)}async scanOneOrMultipleExtensions(V){try{if(await this.i.exists((0,g.joinPath)(V.location,"package.json"))){const F=await this.scanExtension(V);return F?[F]:[]}else return await this.scanExtensions(V)}catch(F){return this.j.error(`Error scanning extensions at ${V.location.path}:`,(0,D.getErrorMessage)(F)),[]}}async scanExtension(V,F){try{let W=await this.scanExtensionManifest(V.location);if(W){W.publisher||(W.publisher=L.UNDEFINED_PUBLISHER),F=F??W.__metadata,delete W.__metadata;const z=(0,E.getGalleryExtensionId)(W.publisher,W.name),X=F?.id?{id:z,uuid:F.id}:{id:z},ie=F?.isSystem?0:V.type,se=ie===0||!!F?.isBuiltin;j.ImplicitActivationEvents.updateManifest(W),W=await this.n(V.location,W,K.createNlsConfiguration(V));const Q={type:ie,identifier:X,manifest:W,location:V.location,isBuiltin:se,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return V.validate?this.validate(Q,V):Q}}catch(W){V.type!==0&&this.j.error(W)}return null}validate(V,F){let W=!0;const z=(0,t.validateExtensionManifest)(F.productVersion,F.productDate,F.location,V.manifest,V.isBuiltin);for(const[X,ie]of z)X===w.default.Error&&(W=!1,this.j.error(this.t(F.location,ie)));return V.isValid=W,V.validations=z,V}async scanExtensionManifest(V){const F=(0,g.joinPath)(V,"package.json");let W;try{W=(await this.i.readFile(F)).value.toString()}catch(X){return(0,c.toFileOperationResult)(X)!==1&&this.j.error(this.t(V,(0,m.localize)(0,null,F.path,X.message))),null}let z;try{z=JSON.parse(W)}catch{const ie=[];(0,P.parse)(W,ie);for(const se of ie)this.j.error(this.t(V,(0,m.localize)(1,null,F.path,se.offset,se.length,(0,d.getParseErrorMessage)(se.error))));return null}return(0,P.getNodeType)(z)!=="object"?(this.j.error(this.t(V,(0,m.localize)(2,null,F.path))),null):z}async n(V,F,W){const z=await this.p(V,F,W);if(z)try{const X=[],ie=await this.r(z.default,X);if(X.length>0)return X.forEach(Q=>{this.j.error(this.t(V,(0,m.localize)(3,null,z.default?.path,(0,d.getParseErrorMessage)(Q.error))))}),F;if((0,P.getNodeType)(z)!=="object")return this.j.error(this.t(V,(0,m.localize)(4,null,z.default?.path))),F;const se=z.values||Object.create(null);return(0,O.localizeManifest)(F,se,ie)}catch{}return F}async p(V,F,W){const z=(0,g.joinPath)(V,"package.nls.json"),X=(A,T)=>{T.forEach(U=>{this.j.error(this.t(V,(0,m.localize)(5,null,A?.path,(0,d.getParseErrorMessage)(U.error))))})},ie=A=>{this.j.error(this.t(V,(0,m.localize)(6,null,A?.path)))},se=`${F.publisher}.${F.name}`,Q=W.translations[se];if(Q)try{const A=u.URI.file(Q),T=(await this.i.readFile(A)).value.toString(),U=[],B=(0,P.parse)(T,U);return U.length>0?(X(A,U),{values:void 0,default:z}):(0,P.getNodeType)(B)!=="object"?(ie(A),{values:void 0,default:z}):{values:B.contents?B.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.i.exists(z))return;let T;try{T=await this.s(V,W)}catch{return}if(!T.localized)return{values:void 0,default:T.original};try{const U=(await this.i.readFile(T.localized)).value.toString(),B=[],q=(0,P.parse)(U,B);return B.length>0?(X(T.localized,B),{values:void 0,default:T.original}):(0,P.getNodeType)(q)!=="object"?(ie(T.localized),{values:void 0,default:T.original}):{values:q,default:T.original}}catch{return{values:void 0,default:T.original}}}}async r(V,F){if(V)try{const W=(await this.i.readFile(V)).value.toString();return(0,P.parse)(W,F)}catch{}}s(V,F){return new Promise((W,z)=>{const X=ie=>{const se=(0,g.joinPath)(V,`package.nls.${ie}.json`);this.i.exists(se).then(Q=>{Q&&W({localized:se,original:(0,g.joinPath)(V,"package.nls.json")});const A=ie.lastIndexOf("-");A===-1?W({localized:(0,g.joinPath)(V,"package.nls.json"),original:null}):(ie=ie.substring(0,A),X(ie))})};if(F.devMode||F.pseudo||!F.language)return W({localized:(0,g.joinPath)(V,"package.nls.json"),original:null});X(F.language)})}t(V,F){return`[${V.path}]: ${F}`}};ne=we([_(1,f.IExtensionsProfileScannerService),_(2,M.IUriIdentityService),_(3,c.IFileService),_(4,r.ILogService)],ne);let re=class extends ne{constructor(V,F,W,z,X,ie){super(F,W,z,X,ie),this.y=V,this.v=this.B(new R.ThrottledDelayer(3e3)),this.w=this.B(new l.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(V){const F=await this.z();if(this.u=V,F&&F.input&&K.equals(F.input,this.u))return this.j.debug("Using cached extensions scan result",V.location.toString()),this.v.trigger(()=>this.D()),F.result.map(z=>(z.location=u.URI.revive(z.location),z));const W=await super.scanExtensions(V);return await this.C({input:V,result:W}),W}async z(){try{const V=await this.i.readFile(this.y),F=JSON.parse(V.value.toString());return{result:F.result,input:(0,o.revive)(F.input)}}catch(V){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,D.getErrorMessage)(V))}return null}async C(V){try{await this.i.writeFile(this.y,C.VSBuffer.fromString(JSON.stringify(V)))}catch(F){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,D.getErrorMessage)(F))}}async D(){if(!this.u)return;const V=await this.z();if(!V)return;const F=V.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!n.equals(W,F))try{await this.i.del(this.y),this.w.fire()}catch(z){this.j.error(z)}}};re=we([_(2,f.IExtensionsProfileScannerService),_(3,M.IUriIdentityService),_(4,c.IFileService),_(5,r.ILogService)],re);function ae(ge,V){const F=(0,E.getExtensionId)(ge.manifest.publisher,ge.manifest.name);return{id:F,identifier:new L.ExtensionIdentifier(F),isBuiltin:ge.type===0,isUserBuiltin:ge.type===1&&ge.isBuiltin,isUnderDevelopment:V,extensionLocation:ge.location,uuid:ge.identifier.uuid,targetPlatform:ge.targetPlatform,...ge.manifest}}e.toExtensionDescription=ae;class fe extends H{constructor(V,F,W,z,X,ie,se,Q,A,T,U,B){super(V,F,(0,g.joinPath)(W,".vscode-oss-dev","extensions","control.json"),(0,g.joinPath)(z,L.MANIFEST_CACHE_FOLDER),X,ie,se,Q,A,T,U,B),this.M=(async()=>{if(b.translationsConfigFile)try{const q=await this.r.readFile(u.URI.file(b.translationsConfigFile));return JSON.parse(q.value.toString())}catch{}return Object.create(null)})()}f(V){return this.M}}e.NativeExtensionsScannerService=fe}),define(ee[264],te([0,1,5,40,39,24,77,16,33,7]),function(x,e,I,R,n,C,D,P,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let S=class extends D.AbstractExtensionsProfileScannerService{constructor(b,g,p,w,a,u){super(h.URI.file(b.extensionsPath),g,p,w,a,u)}};S=we([_(0,d.INativeEnvironmentService),_(1,P.IFileService),_(2,R.IUserDataProfilesService),_(3,n.IUriIdentityService),_(4,C.ITelemetryService),_(5,I.ILogService)],S),e.ExtensionsProfileScannerService=S}),define(ee[265],te([0,1,7,33,77,119,16,6,5,19,39,40]),function(x,e,I,R,n,C,D,P,d,h,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends C.NativeExtensionsScannerService{constructor(p,w,a,u,m,k,E,L){super(I.URI.file(m.builtinExtensionsPath),I.URI.file(m.extensionsPath),m.userHome,I.URI.file(m.userDataPath),p,w,a,u,m,k,E,L)}};b=we([_(0,v.IUserDataProfilesService),_(1,n.IExtensionsProfileScannerService),_(2,D.IFileService),_(3,d.ILogService),_(4,R.INativeEnvironmentService),_(5,h.IProductService),_(6,S.IUriIdentityService),_(7,P.IInstantiationService)],b),e.ExtensionsScannerService=b}),define(ee[266],te([0,1,14,2,15,9,4,60,7,31,42,33,5,40]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let p=class extends R.Disposable{constructor(a,u,m){super(),this.c=a,this.f=m,this.a=P.TernarySearchTree.forPaths(!D.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(a.appRoot),this.addValidFileRoot(a.extensionsPath),this.addValidFileRoot(u.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(a.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:a}=I.session;a.protocol.registerFileProtocol(n.Schemas.vscodeFileResource,(u,m)=>this.i(u,m)),a.protocol.interceptFileProtocol(n.Schemas.file,(u,m)=>this.h(u,m)),this.B((0,R.toDisposable)(()=>{a.protocol.unregisterProtocol(n.Schemas.vscodeFileResource),a.protocol.uninterceptProtocol(n.Schemas.file)}))}addValidFileRoot(a){const u=(0,C.normalize)(a);return this.a.get(u)?R.Disposable.None:(this.a.set(u,!0),(0,R.toDisposable)(()=>this.a.delete(u)))}h(a,u){const m=d.URI.parse(a.url);return this.f.error(`Refused to load resource ${m.fsPath} from ${n.Schemas.file}: protocol (original URL: ${a.url})`),u({error:-3})}i(a,u){const m=this.j(a);let k;return this.c.crossOriginIsolated&&((0,C.basename)(m)==="workbench.html"||(0,C.basename)(m)==="workbench-dev.html"?k=n.COI.CoopAndCoep:k=n.COI.getHeadersFromQuery(a.url)),this.a.findSubstr(m)?u({path:m,headers:k}):this.b.has((0,C.extname)(m).toLowerCase())?u({path:m}):(this.f.error(`${n.Schemas.vscodeFileResource}: Refused to load resource ${m} from ${n.Schemas.vscodeFileResource}: protocol (original URL: ${a.url})`),u({error:-3}))}j(a){const u=d.URI.parse(a.url),m=n.FileAccess.uriToFileUri(u);return(0,C.normalize)(m.fsPath)}createIPCObjectUrl(){let a;const u=d.URI.from({scheme:"vscode",path:(0,h.generateUuid)()}),m=u.toString(),k=async()=>a;return S.validatedIpcMain.handle(m,k),this.f.trace(`IPC Object URL: Registered new channel ${m}.`),{resource:u,update:E=>a=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${m}.`),S.validatedIpcMain.removeHandler(m)}}}};p=we([_(0,v.INativeEnvironmentService),_(1,g.IUserDataProfilesService),_(2,b.ILogService)],p),e.ProtocolMainService=p}),define(ee[267],te([0,1,14,42,8,3,2,15,10,105,28,21,5,65,66,68,45,40,38,64]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let E=class extends D.Disposable{constructor(t,c,i,r,s,l,o,f,y,M){super(),this.g=t,this.h=c,this.i=i,this.j=r,this.k=s,this.l=l,this.m=o,this.n=f,this.p=y,this.r=M,this.a=new n.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new C.Emitter),this.onDidError=C.Event.buffer(this.f.event),this.y=void 0,this.z=void 0,this.s()}s(){R.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(t,c)=>this.t(t,c)),R.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(t,c)=>this.u(t,c)),this.B(this.k.onWillShutdown(()=>this.v()))}async t(t,c){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const i=await this.connect();if(t.sender.isDestroyed())return i.close();t.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[i])}u(t,c){this.l.trace("SharedProcess: onWorkerConnection",c);const i=new D.DisposableStore,r=l=>{!this.G()||(this.l.trace(`SharedProcess: disposing worker (reason: '${l}')`,c),i.dispose(),this.w("vscode:electron-main->shared-process=disposeWorker",c))},s=I.BrowserWindow.fromId(c.reply.windowId);if(!s||s.isDestroyed()||s.webContents.isDestroyed()||!c.reply.channel){r("unavailable");return}i.add(C.Event.filter(this.k.onWillLoadWindow,l=>l.window.win===s)(()=>r("load"))),i.add(C.Event.fromNodeEventEmitter(s,"closed")(()=>r("closed"))),s.webContents.postMessage(c.reply.channel,c.reply.nonce,t.ports)}v(){const t=this.b;!t||(this.w("vscode:electron-main->shared-process=exit"),this.c&&(t.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{t.close()}catch{}this.b=void 0},0))}w(t,...c){if(!this.G()){this.l.warn(`Sending IPC message to channel '${t}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(t,...c)}catch(i){this.l.warn(`Error sending IPC message to channel '${t}' of shared process: ${(0,a.toErrorMessage)(i)}`)}}whenReady(){return this.y||(this.y=new Promise(t=>R.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),t()}))),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D(),this.F(),await new Promise(t=>R.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),t()}))})()),this.z}D(){const t=this.B(this.r.createIPCObjectUrl());this.b=new I.BrowserWindow({show:!1,backgroundColor:this.p.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),t.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:this.j.profiles,userEnv:this.h,args:this.i.args,logLevel:this.l.getLevel(),loggers:this.m.getRegisteredLoggers(),product:g.default,policiesData:this.n.serialize()}),this.b.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}F(){!this.b||(this.c=t=>{this.l.trace("SharedProcess#close prevented"),t.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(t,c)=>this.f.fire({type:2,details:c})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(t,c,i)=>this.f.fire({type:3,details:{reason:i,exitCode:c}})))}async connect(){await this.C;const t=(0,d.assertIsDefined)(this.b);return(0,h.connect)(t)}async toggle(){await this.C,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}G(){const t=this.b;return t?!t.isDestroyed()&&!t.webContents.isDestroyed():!1}};E=we([_(2,S.IEnvironmentMainService),_(3,u.IUserDataProfilesService),_(4,v.ILifecycleMainService),_(5,b.ILogService),_(6,k.ILoggerMainService),_(7,m.IPolicyService),_(8,w.IThemeMainService),_(9,p.IProtocolMainService)],E),e.SharedProcess=E}),define(ee[94],te([0,1,8,3,2,63,10,106,6,40]),function(x,e,I,R,n,C,D,P,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,d.createDecorator)("storageService");var S;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(S=e.WillSaveStateReason||(e.WillSaveStateReason={}));var v;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(v=e.StorageScope||(e.StorageScope={}));var b;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));function g(m){const k=m.get(e.TARGET_KEY);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}e.loadKeyTargets=g;class p extends n.Disposable{constructor(k={flushInterval:p.a}){super(),this.j=k,this.b=this.B(new R.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new R.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new I.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new n.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,I.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,n.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.J()}finally{(0,C.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(k,E){if(E===e.TARGET_KEY){switch(k){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:k})}else this.b.fire({scope:k,key:E,target:this.F(k)[E]})}r(k){this.f.fire({reason:k})}get(k,E,L){return this.L(E)?.get(k,L)}getBoolean(k,E,L){return this.L(E)?.getBoolean(k,L)}getNumber(k,E,L){return this.L(E)?.getNumber(k,L)}store(k,E,L,t){if((0,D.isUndefinedOrNull)(E)){this.remove(k,L);return}this.t(()=>{this.u(k,L,t),this.L(L)?.set(k,E)})}remove(k,E){this.t(()=>{this.u(k,E,void 0),this.L(E)?.delete(k)})}t(k){this.b.pause(),this.c.pause();try{k()}finally{this.b.resume(),this.c.resume()}}keys(k,E){const L=[],t=this.F(k);for(const c of Object.keys(t))t[c]===E&&L.push(c);return L}u(k,E,L){const t=this.F(E);typeof L=="number"?t[k]!==L&&(t[k]=L,this.L(E)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[k]=="number"&&(delete t[k],this.L(E)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(k){switch(k){case-1:return this.D;case 0:return this.z;default:return this.w}}G(k){const E=this.L(k);return E?g(E):Object.create(null)}isNew(k){return this.getBoolean(e.IS_NEW_KEY,k)===!0}async flush(k=S.NONE){this.f.fire({reason:k});const E=this.L(-1),L=this.L(0),t=this.L(1);switch(k){case S.NONE:await I.Promises.settled([E?.whenFlushed()??Promise.resolve(),L?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await I.Promises.settled([E?.flush(0)??Promise.resolve(),L?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const k=this.L(-1)?.items??new Map,E=this.L(0)?.items??new Map,L=this.L(1)?.items??new Map;return u(k,E,L,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(k,E){return this.r(S.NONE),(0,h.isUserDataProfile)(k)?this.N(k,E):this.O(k,E)}H(k,E){return!(k.id===E.id||w(E)&&w(k))}I(k,E,L,t){this.t(()=>{if(t)for(const[c,i]of k)E.set(c,i);else{const c=new Set;for(const[i,r]of k)c.add(i),E.get(i)!==r&&this.n(L,i);for(const[i]of E.items)c.has(i)||this.n(L,i)}})}}e.AbstractStorageService=p,p.a=60*1e3;function w(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=w;class a extends p{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(k=>this.n(1,k))),this.B(this.P.onDidChangeStorage(k=>this.n(0,k))),this.B(this.p.onDidChangeStorage(k=>this.n(-1,k)))}L(k){switch(k){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(k){switch(k){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(k){return!1}}e.InMemoryStorageService=a;async function u(m,k,E,L,t,c){const i=j=>{try{return JSON.parse(j)}catch{return j}},r=new Map,s=new Map;m.forEach((j,G)=>{r.set(G,j),s.set(G,i(j))});const l=new Map,o=new Map;k.forEach((j,G)=>{l.set(G,j),o.set(G,i(j))});const f=new Map,y=new Map;E.forEach((j,G)=>{f.set(G,j),y.set(G,i(j))}),console.group(L!==t?`Storage: Application (path: ${L})`:`Storage: Application & Profile (path: ${L}, default profile)`);const M=[];if(r.forEach((j,G)=>{M.push({key:G,value:j})}),console.table(M),console.groupEnd(),console.log(s),L!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];l.forEach((G,H)=>{j.push({key:H,value:G})}),console.table(j),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${c})`);const O=[];f.forEach((j,G)=>{O.push({key:G,value:j})}),console.table(O),console.groupEnd(),console.log(y)}e.logStorage=u}),define(ee[268],te([0,1,25,8,3,2,9,70,7,23,106,152,5,94,24,29]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class a extends C.Disposable{get storage(){return this.f}constructor(c,i){super(),this.j=c,this.k=i,this.b=this.B(new n.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new n.Emitter),this.onDidCloseStorage=this.c.event,this.f=new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new R.DeferredPromise,this.whenInit=this.h.p,this.i=S.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===S.StorageState.None)try{const c=await this.n();this.f.dispose(),this.f=c,this.B(c.onDidChangeStorage(r=>this.b.fire({key:r}))),await this.m(c);const i=c.getBoolean(g.IS_NEW_KEY);i===void 0?c.set(g.IS_NEW_KEY,!0):i&&c.set(g.IS_NEW_KEY,!1)}catch(c){this.j.error(`[storage main] initialize(): Unable to init storage due to ${c}`)}finally{this.i=S.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===b.LogLevel.Trace?c=>this.j.trace(c):void 0,logError:c=>this.j.error(c)}}m(c){return c.init()}get items(){return this.f.items}get(c,i){return this.f.get(c,i)}set(c,i){return this.f.set(c,i)}delete(c){return this.f.delete(c)}async close(){const c=new P.StopWatch(!1);await this.s(),c.stop(),c.elapsed()>a.a&&await this.r(c),this.c.fire()}async r(c){if(!!this.path)try{const i=(0,I.top)(Array.from(this.f.items.entries()).map(([s,l])=>({key:s,length:l.length})),(s,l)=>l.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),r=(await this.k.stat(d.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${c.elapsed()}ms, DB size: ${r}b, Large Keys: ${i}`)}catch(i){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async s(){this.g&&await this.g,this.i=S.StorageState.Closed,await this.f.close()}}a.a=2e3;class u extends a{get path(){if(!this.v.useInMemoryStorage)return(0,D.join)(this.u.globalStorageHome.fsPath,u.t)}constructor(c,i,r,s){super(r,s),this.u=c,this.v=i}async n(){return new S.Storage(new v.SQLiteStorageDatabase(this.path??v.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:S.StorageHint.STORAGE_IN_MEMORY})}}u.t="state.vscdb";class m extends u{constructor(c,i,r,s){super(c,i,r,s)}}e.ProfileStorageMain=m;class k extends u{constructor(c,i,r,s){super(i.defaultProfile,c,r,s)}async m(c){await super.m(c),this.z(c)}z(c){c.get(p.firstSessionDateStorageKey,void 0)===void 0&&c.set(p.firstSessionDateStorageKey,new Date().toUTCString());const r=c.get(p.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();c.set(p.lastSessionDateStorageKey,typeof r>"u"?null:r),c.set(p.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=k;class E extends a{get path(){if(!this.w.useInMemoryStorage)return(0,D.join)(this.y.workspaceStorageHome.fsPath,this.v.id,E.t)}constructor(c,i,r,s,l){super(r,l),this.v=c,this.w=i,this.y=s}async n(){const{storageFilePath:c,wasCreated:i}=await this.C();return new S.Storage(new v.SQLiteStorageDatabase(c,{logging:this.l()}),{hint:this.w.useInMemoryStorage?S.StorageHint.STORAGE_IN_MEMORY:i?S.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:v.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const c=(0,D.join)(this.y.workspaceStorageHome.fsPath,this.v.id),i=(0,D.join)(c,E.t);return await h.Promises.exists(c)?{storageFilePath:i,wasCreated:!1}:(await h.Promises.mkdir(c,{recursive:!0}),this.D(c),{storageFilePath:i,wasCreated:!0})}async D(c){let i;if((0,w.isSingleFolderWorkspaceIdentifier)(this.v)?i={folder:this.v.uri.toString()}:(0,w.isWorkspaceIdentifier)(this.v)&&(i={workspace:this.v.configPath.toString()}),i)try{const r=(0,D.join)(c,E.u);await h.Promises.exists(r)||await h.Promises.writeFile(r,JSON.stringify(i,void 0,2))}catch(r){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${r}`)}}}e.WorkspaceStorageMain=E,E.t="state.vscdb",E.u="workspace.json";class L extends a{get path(){}async n(){return new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=L}),define(ee[269],te([0,1,3,2,94]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class C extends R.Disposable{constructor(P,d,h){super(),this.b=P,this.c=d,this.f=h;const S=this.B(new R.MutableDisposable);this.a=this.B(new I.Emitter({onWillAddFirstListener:()=>S.value=this.g(),onDidRemoveLastListener:()=>S.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new R.DisposableStore;return P.add(I.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(d,h)=>(d?d.push(h.key):d=[h.key],d),100)(d=>this.h(d))),P.add(I.Event.debounce(this.b.onDidChangeProfileStorage,(d,h)=>{d||(d=new Map);let S=d.get(h.profile.id);return S||d.set(h.profile.id,S={profile:h.profile,keys:[],storage:h.storage}),S.keys.push(h.key),d},100)(d=>this.i(d))),P}h(P){const d=P.includes(n.TARGET_KEY)?[this.c.defaultProfile]:[],h=[];if(P=P.filter(S=>S!==n.TARGET_KEY),P.length){const S=(0,n.loadKeyTargets)(this.b.applicationStorage.storage);h.push({profile:this.c.defaultProfile,changes:P.map(v=>({key:v,scope:0,target:S[v]}))})}this.j(d,h)}i(P){const d=[],h=new Map;for(const[S,v]of P.entries()){v.keys.includes(n.TARGET_KEY)&&d.push(v.profile);const b=v.keys.filter(g=>g!==n.TARGET_KEY);if(b.length){const g=(0,n.loadKeyTargets)(v.storage.storage);h.set(S,{profile:v.profile,changes:b.map(p=>({key:p,scope:0,target:g[p]}))})}}this.j(d,[...h.values()])}j(P,d){(P.length||d.length)&&this.a.fire({valueChanges:d,targetChanges:P})}listen(P,d,h){switch(d){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${d}`)}async call(P,d){throw new Error(`Call not found: ${d}`)}}e.ProfileStorageChangesListenerChannel=C}),define(ee[270],te([0,1,72,7,33,16,5,235,39,40]),function(x,e,I,R,n,C,D,P,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let S=class extends h.UserDataProfilesService{constructor(g,p,w,a){super(p,w,g,a),this.a=p}L(){return this.r.extUri.joinPath(R.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};S=we([_(0,d.IUriIdentityService),_(1,n.INativeEnvironmentService),_(2,C.IFileService),_(3,D.ILogService)],S),e.ServerUserDataProfilesService=S;let v=class pt extends S{constructor(g,p,w,a,u){super(p,w,a,u),this.N=g}G(){return(0,I.revive)(this.N.getItem(pt.b,[]))}I(){return(0,I.revive)(this.N.getItem(pt.c,{}))}L(){return this.r.extUri.joinPath(R.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};v=we([_(0,P.IStateService),_(1,d.IUriIdentityService),_(2,n.INativeEnvironmentService),_(3,C.IFileService),_(4,D.ILogService)],v),e.UserDataProfilesService=v}),define(ee[52],te([0,1,7,33,16,6,5,34,39,40,270]),function(x,e,I,R,n,C,D,P,d,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,C.refineServiceDecorator)(h.IUserDataProfilesService);let v=class at extends S.UserDataProfilesService{constructor(g,p,w,a,u){super(g,p,w,a,u),this.R=g}getAssociatedEmptyWindows(){const g=[];for(const p of this.u.emptyWindows.keys())g.push({id:p});return g}H(g){g.length?this.R.setItem(at.b,g):this.R.removeItem(at.b)}J(g){g.emptyWindows||g.workspaces?this.R.setItem(at.c,g):this.R.removeItem(at.c)}I(){const g="workspaceAndProfileInfo",p=this.R.getItem(g,void 0);if(p){this.R.removeItem(g);const w=p.reduce((a,{workspace:u,profile:m})=>(a[I.URI.revive(u).toString()]=I.URI.revive(m).toString(),a),{});this.R.setItem(at.c,{workspaces:w})}return super.I()}};v=we([_(0,P.IStateMainService),_(1,d.IUriIdentityService),_(2,R.INativeEnvironmentService),_(3,n.IFileService),_(4,D.ILogService)],v),e.UserDataProfilesMainService=v}),define(ee[95],te([0,1,7,49,3,2,33,16,6,21,5,94,268,40,52,39]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,d.createDecorator)("storageMainService");let a=class extends C.Disposable{constructor(k,E,L,t,c,i){super(),this.c=k,this.f=E,this.g=L,this.h=t,this.i=c,this.j=i,this.a=void 0,this.b=this.B(new n.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(k=>{k.window.profile&&this.profileStorage(k.window.profile).init(),k.workspace&&this.workspaceStorage(k.workspace).init()})),this.B(this.h.onWillShutdown(k=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=k.reason,k.join(this.applicationStorage.close());for(const[,E]of this.n)k.join(E.close());for(const[,E]of this.r)k.join(E.close())})),this.B(this.g.onWillCreateProfile(k=>{k.join((async()=>{await this.i.exists(k.profile.globalStorageHome)||await this.i.createFolder(k.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(k=>{const E=this.n.get(k.profile.id);E&&k.join(E.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const k=new b.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,R.once)(k.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),k}profileStorage(k){if((0,v.isProfileUsingDefaultStorage)(k))return this.applicationStorage;let E=this.n.get(k.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${k.name})`),E=this.p(k),this.n.set(k.id,E);const L=this.B(E.onDidChangeStorage(t=>this.b.fire({...t,storage:E,profile:k})));(0,R.once)(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${k.name})`),this.n.delete(k.id),L.dispose()})}return E}p(k){return this.a===2?new b.InMemoryStorageMain(this.c,this.i):new b.ProfileStorageMain(k,this.k(),this.c,this.i)}workspaceStorage(k){let E=this.r.get(k.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${k.id})`),E=this.s(k),this.r.set(k.id,E),(0,R.once)(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${k.id})`),this.r.delete(k.id)})),E}s(k){return this.a===2?new b.InMemoryStorageMain(this.c,this.i):new b.WorkspaceStorageMain(k,this.k(),this.c,this.f,this.i)}isUsed(k){const E=I.URI.file(k);for(const L of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!L.path&&this.j.extUri.isEqualOrParent(I.URI.file(L.path),E))return!0;return!1}};a=we([_(0,S.ILogService),_(1,D.IEnvironmentService),_(2,p.IUserDataProfilesMainService),_(3,h.ILifecycleMainService),_(4,P.IFileService),_(5,w.IUriIdentityService)],a),e.StorageMainService=a,e.IApplicationStorageMainService=(0,d.createDecorator)("applicationStorageMainService");let u=class extends v.AbstractStorageService{constructor(k,E){super(),this.p=k,this.s=E,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(k){if(k===-1)return this.s.applicationStorage.storage}M(k){if(k===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};u=we([_(0,g.IUserDataProfilesService),_(1,e.IStorageMainService)],u),e.ApplicationStorageMainService=u}),define(ee[271],te([0,1,2,21,52,29,8,30]),function(x,e,I,R,n,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let d=class extends I.Disposable{constructor(S,v,b){super(),this.a=v,this.b=b,this.B(S.onWillLoadWindow(g=>{g.reason===2&&this.c(g.window)})),this.B(S.onBeforeCloseWindow(g=>this.c(g))),this.B(new D.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(S){const v=this.f(S),b=this.a.getProfileForWorkspace(v);b&&((0,C.isEmptyWorkspaceIdentifier)(v)||b.isTransient)&&(this.a.unsetWorkspace(v,b.isTransient),b.isTransient&&await this.a.cleanUpTransientProfiles())}f(S){return S.openedWorkspace??(0,C.toWorkspaceIdentifier)(S.backupPath,S.isExtensionDevelopmentHost)}g(){const S=this.a.getAssociatedEmptyWindows();if(S.length===0)return;const v=this.b.getWindows().map(b=>this.f(b));for(const b of S)v.some(g=>g.id===b.id)||this.a.unsetWorkspace(b,!1)}};d=we([_(0,R.ILifecycleMainService),_(1,n.IUserDataProfilesMainService),_(2,P.IWindowsMainService)],d),e.UserDataProfilesHandler=d}),define(ee[120],te([0,1,20,7,29]),function(x,e,I,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function C(d,h,S){for(const b of d){const g=b.openedWorkspace;if((0,n.isWorkspaceIdentifier)(g)){const p=await S(g);if(p){if(p.folders.some(w=>I.extUriBiasedIgnorePathCase.isEqualOrParent(h,w.uri)))return b}else if(I.extUriBiasedIgnorePathCase.isEqualOrParent(h,g.configPath))return b}}const v=d.filter(b=>(0,n.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqualOrParent(h,b.openedWorkspace.uri));if(v.length)return v.sort((b,g)=>-(b.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=C;function D(d,h){for(const S of d)if((0,n.isWorkspaceIdentifier)(S.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(S.openedWorkspace.configPath,h)||(0,n.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(S.openedWorkspace.uri,h))return S}e.findWindowOnWorkspaceOrFolder=D;function P(d,h){const S=v=>h.some(b=>I.extUriBiasedIgnorePathCase.isEqual(R.URI.file(b),R.URI.file(v)));for(const v of d)if(v.config?.extensionDevelopmentPath?.some(b=>S(b)))return v}e.findWindowOnExtensionDevelopmentPath=P}),define(ee[272],te([0,1,14,2,4,20,7,18,21,5,34,30,118,29]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class wt extends R.Disposable{get state(){return this.b}constructor(E,L,t,c,i){super(),this.g=E,this.h=L,this.i=t,this.j=c,this.k=i,this.b=w(this.h.getItem(wt.a)),this.c=void 0,this.f=!1,this.l()}l(){I.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(E=>this.p(E)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(E=>{E.newCount-E.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(E=>this.p(E))}m(){this.f=!0,this.n()}n(){const E=new Set,L={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!L.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(r=>!r.isExtensionDevelopmentHost)),i&&(L.lastActiveWindow=this.r(i),L.lastActiveWindow.uiState.mode===3&&E.add(L.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);t&&(L.lastPluginDevelopmentHostWindow=this.r(t),L.lastPluginDevelopmentHostWindow.uiState.mode===3&&(E.has(L.lastPluginDevelopmentHostWindow.uiState.display)?n.isMacintosh&&!t.win?.isSimpleFullScreen()&&(L.lastPluginDevelopmentHostWindow.uiState.mode=1):E.add(L.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(L.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const r=this.r(i);return r.uiState.mode===3&&(E.has(r.uiState.display)?n.isMacintosh&&r.windowId!==L.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(r.uiState.mode=1):E.add(r.uiState.display)),r}));const c=u(L);this.h.setItem(wt.a,c),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",c)}p(E){if(this.i.quitRequested)return;const L=this.r(E);E.isExtensionDevelopmentHost&&!E.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=L:!E.isExtensionDevelopmentHost&&E.openedWorkspace&&this.b.openedWindows.forEach(t=>{const c=(0,g.isWorkspaceIdentifier)(E.openedWorkspace)&&t.workspace?.id===E.openedWorkspace.id,i=(0,g.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&t.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(t.folderUri,E.openedWorkspace.uri);(c||i)&&(t.uiState=L.uiState)}),this.g.getWindowCount()===1&&(this.c=L)}r(E){return{windowId:E.id,workspace:(0,g.isWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace:void 0,folderUri:(0,g.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace.uri:void 0,backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.serializeWindowState()}}getNewWindowState(E){const L=this.s(E),t=this.k.getValue("window");if(L.mode===3){let c;L.hasDefaultState?c=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):c=!!(this.i.wasRestarted||t?.restoreFullscreen),c||(L.mode=1)}return L}s(E){const L=this.g.getLastActiveWindow();if(!E.extensionTestsPath){if(!!E.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=E.workspace;if((0,g.isWorkspaceIdentifier)(l)){const f=this.state.openedWindows.filter(y=>y.workspace&&y.workspace.id===l.id).map(y=>y.uiState);if(f.length)return f[0]}if((0,g.isSingleFolderWorkspaceIdentifier)(l)){const f=this.state.openedWindows.filter(y=>y.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(y.folderUri,l.uri)).map(y=>y.uiState);if(f.length)return f[0]}else if(E.backupPath){const f=this.state.openedWindows.filter(y=>y.backupPath===E.backupPath).map(y=>y.uiState);if(f.length)return f[0]}const o=this.c||this.state.lastActiveWindow;if(!L&&o)return o.uiState}let t;const c=I.screen.getAllDisplays();if(c.length===1)t=c[0];else{if(n.isMacintosh){const l=I.screen.getCursorScreenPoint();t=I.screen.getDisplayNearestPoint(l)}!t&&L&&(t=I.screen.getDisplayMatching(L.getBounds())),t||(t=I.screen.getPrimaryDisplay()||c[0])}let i=(0,b.defaultWindowState)();i.x=Math.round(t.bounds.x+t.bounds.width/2-i.width/2),i.y=Math.round(t.bounds.y+t.bounds.height/2-i.height/2);const r=this.k.getValue("window");let s=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")i.mode=0,s=!1;else if(r.newWindowDimensions==="fullscreen")i.mode=3,s=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&L){const l=L.serializeWindowState();l.mode===3?i.mode=3:i=l,s=i.mode!==3&&r.newWindowDimensions==="offset"}}return s&&(i=this.t(i)),i.hasDefaultState=!0,i}t(E){if(this.g.getWindows().length===0)return E;E.x=typeof E.x=="number"?E.x:0,E.y=typeof E.y=="number"?E.y:0;const L=this.g.getWindows().map(t=>t.getBounds());for(;L.some(t=>t.x===E.x||t.y===E.y);)E.x+=30,E.y+=30;return E}};p.a="windowsState",p=we([_(0,v.IWindowsMainService),_(1,S.IStateMainService),_(2,d.ILifecycleMainService),_(3,h.ILogService),_(4,P.IConfigurationService)],p),e.WindowsStateHandler=p;function w(k){const E={openedWindows:[]},L=k||{openedWindows:[]};return L.lastActiveWindow&&(E.lastActiveWindow=a(L.lastActiveWindow)),L.lastPluginDevelopmentHostWindow&&(E.lastPluginDevelopmentHostWindow=a(L.lastPluginDevelopmentHostWindow)),Array.isArray(L.openedWindows)&&(E.openedWindows=L.openedWindows.map(t=>a(t))),E}e.restoreWindowsState=w;function a(k){const E={uiState:k.uiState};return k.backupPath&&(E.backupPath=k.backupPath),k.remoteAuthority&&(E.remoteAuthority=k.remoteAuthority),k.folder&&(E.folderUri=D.URI.parse(k.folder)),k.workspaceIdentifier&&(E.workspace={id:k.workspaceIdentifier.id,configPath:D.URI.parse(k.workspaceIdentifier.configURIPath)}),E}function u(k){return{lastActiveWindow:k.lastActiveWindow&&m(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&m(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(E=>m(E))}}e.getWindowsStateStoreData=u;function m(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(ee[96],te([0,1,32,43,125,37,15,9,4,20,7,6,55,29]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function p(y){return y.hasOwnProperty("workspace")}e.isRecentWorkspace=p;function w(y){return y.hasOwnProperty("folderUri")}e.isRecentFolder=w;function a(y){return y.hasOwnProperty("fileUri")}e.isRecentFile=a;function u(y){return m(y)||k(y)}e.isStoredWorkspaceFolder=u;function m(y){const M=y;return typeof M?.path=="string"&&(!M.name||typeof M.name=="string")}function k(y){const M=y;return typeof M?.uri=="string"&&(!M.name||typeof M.name=="string")}function E(y,M,O,j,G){if(y.scheme!==j.scheme)return{name:O,uri:y.toString(!0)};let H=M?void 0:G.relativePath(j,y);if(H!==void 0)H.length===0?H=".":d.isWindows&&(H=L(H));else if(y.scheme===D.Schemas.file)H=y.fsPath,d.isWindows&&(H=L(H));else if(G.isEqualAuthority(y.authority,j.authority))H=y.path;else return{name:O,uri:y.toString(!0)};return{name:O,path:H}}e.getStoredWorkspaceFolder=E;function L(y){return y=(0,C.normalizeDriveLetter)(y),(0,I.isUNC)(y)||(y=(0,I.toSlashes)(y)),y}function t(y,M,O){const j=[],G=new Set,H=O.dirname(M);for(const K of y){let ne;if(m(K))K.path&&(ne=O.resolvePath(H,K.path));else if(k(K))try{ne=S.URI.parse(K.uri),ne.path[0]!==P.posix.sep&&(ne=ne.with({path:P.posix.sep+ne.path}))}catch(re){console.warn(re)}if(ne){const re=O.getComparisonKey(ne);if(!G.has(re)){G.add(re);const ae=K.name||O.basenameOrAuthority(ne);j.push(new g.WorkspaceFolder({uri:ne,name:ae,index:j.length},K))}}}return j}e.toWorkspaceFolders=t;function c(y,M,O,j,G){const H=i(M,y),K=G.dirname(M),ne=G.dirname(j),re=[];for(const V of H.folders){const F=m(V)?G.resolvePath(K,V.path):S.URI.parse(V.uri);let W;O?W=!1:W=!m(V)||(0,P.isAbsolute)(V.path),re.push(E(F,W,V.name,ne,G))}const ae={insertSpaces:!1,tabSize:4,eol:d.isLinux||d.isMacintosh?`
`:`\r
`},fe=n.setProperty(y,["folders"],re,ae);let ge=n.applyEdits(y,fe);return(0,h.isEqualAuthority)(H.remoteAuthority,(0,b.getRemoteAuthority)(j))&&(ge=n.applyEdits(ge,n.removeProperty(ge,["remoteAuthority"],ae))),ge}e.rewriteWorkspaceFileForNewLocation=c;function i(y,M){const O=R.parse(M);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(j=>u(j));else throw new Error(`${y} looks like an invalid workspace file.`);return O}function r(y){return y.workspace&&typeof y.workspace=="object"&&typeof y.workspace.id=="string"&&typeof y.workspace.configPath=="string"}function s(y){return typeof y.folderUri=="string"}function l(y){return typeof y.fileUri=="string"}function o(y,M){const O={workspaces:[],files:[]};if(y){const j=function(H,K){for(let ne=0;ne<H.length;ne++)try{K(H[ne],ne)}catch(re){M.warn(`Error restoring recent entry ${JSON.stringify(H[ne])}: ${re.toString()}. Skip entry.`)}},G=y;Array.isArray(G.entries)&&j(G.entries,H=>{const K=H.label,ne=H.remoteAuthority;r(H)?O.workspaces.push({label:K,remoteAuthority:ne,workspace:{id:H.workspace.id,configPath:S.URI.parse(H.workspace.configPath)}}):s(H)?O.workspaces.push({label:K,remoteAuthority:ne,folderUri:S.URI.parse(H.folderUri)}):l(H)&&O.files.push({label:K,remoteAuthority:ne,fileUri:S.URI.parse(H.fileUri)})})}return O}e.restoreRecentlyOpened=o;function f(y){const M={entries:[]};for(const O of y.workspaces)w(O)?M.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):M.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of y.files)M.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return M}e.toStoreData=f}),define(ee[97],te([0,1,80,15,4,20]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(h){function S(){let v=h.scheme===R.Schemas.file?(0,C.originalFSPath)(h):h.toString();return n.isLinux||(v=v.toLowerCase()),(0,I.createHash)("md5").update(v).digest("hex")}return{id:S(),configPath:h}}e.getWorkspaceIdentifier=D;function P(h,S){function v(){if(h.scheme!==R.Schemas.file)return(0,I.createHash)("md5").update(h.toString()).digest("hex");if(!S)return;let g;return n.isLinux?g=S.ino:n.isMacintosh?g=S.birthtime.getTime():n.isWindows&&(typeof S.birthtimeMs=="number"?g=Math.floor(S.birthtimeMs):g=S.birthtime.getTime()),(0,I.createHash)("md5").update(h.fsPath).update(g?String(g):"").digest("hex")}const b=v();if(typeof b=="string")return{id:b,uri:h}}e.getSingleFolderWorkspaceIdentifier=P;function d(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=d}),define(ee[273],te([0,1,80,32,15,9,4,20,23,182,18,28,34,16,5,181,29,97]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let m=class vt{constructor(E,L,t,c){this.j=E,this.k=L,this.l=t,this.m=c,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.extUriBiasedIgnorePathCase,this.i={isEqual:(i,r)=>(0,R.isEqual)(i,r,!D.isLinux)}}async initialize(){const E=this.m.getItem(vt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(E.emptyWindows),this.d=await this.u((0,h.deserializeWorkspaceInfos)(E)),this.e=await this.v((0,h.deserializeFolderInfos)(E)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==g.HotExitConfiguration.OFF}q(){return this.s()===g.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||g.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(E,L){this.d.some(c=>E.workspace.id===c.workspace.id)||(this.d.push(E),this.C());const t=(0,C.join)(this.c,E.workspace.id);return L?this.t(t,L).then(()=>t):t}async t(E,L){if(await d.Promises.exists(E)&&await this.z(E),await d.Promises.exists(L))try{await d.Promises.rename(L,E)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(E){return this.e.some(L=>this.h.isEqual(E.folderUri,L.folderUri))||(this.e.push(E),this.C()),(0,C.join)(this.c,this.D(E))}registerEmptyWindowBackup(E){return this.g.some(L=>!!L.backupFolder&&this.i.isEqual(L.backupFolder,E.backupFolder))||(this.g.push(E),this.C()),(0,C.join)(this.c,E.backupFolder)}async u(E){if(!Array.isArray(E))return[];const L=new Set,t=[];for(const c of E){const i=c.workspace;if(!(0,a.isWorkspaceIdentifier)(i))return[];if(!L.has(i.id)){L.add(i.id);const r=(0,C.join)(this.c,i.id);await this.B(r)?i.configPath.scheme!==n.Schemas.file||await d.Promises.exists(i.configPath.fsPath)?t.push(c):await this.z(r):await this.x(r)}}return t}async v(E){if(!Array.isArray(E))return[];const L=[],t=new Set;for(const c of E){const i=c.folderUri,r=this.h.getComparisonKey(i);if(!t.has(r)){t.add(r);const s=(0,C.join)(this.c,this.D(c));await this.B(s)?i.scheme!==n.Schemas.file||await d.Promises.exists(i.fsPath)?L.push(c):await this.z(s):await this.x(s)}}return L}async w(E){if(!Array.isArray(E))return[];const L=[],t=new Set;for(const c of E){const i=c.backupFolder;if(typeof i!="string")return[];if(!t.has(i)){t.add(i);const r=(0,C.join)(this.c,i);await this.B(r)?L.push(c):await this.x(r)}}return L}async x(E){try{await d.Promises.rm(E,d.RimRafMode.MOVE)}catch(L){this.l.error(`Backup: Could not delete stale backup: ${L.toString()}`)}}y(){let E=(0,u.createEmptyWorkspaceIdentifier)();for(;this.g.some(L=>!!L.backupFolder&&this.i.isEqual(L.backupFolder,E.id));)E=(0,u.createEmptyWorkspaceIdentifier)();return{backupFolder:E.id}}async z(E){const L=this.y(),t=(0,C.join)(this.c,L.backupFolder);try{await d.Promises.rename(E,t)}catch(c){return this.l.error(`Backup: Could not rename backup folder: ${c.toString()}`),!1}return this.g.push(L),!0}async getDirtyWorkspaces(){const E=[];for(const L of this.d)await this.A(L)&&E.push(L);for(const L of this.e)await this.A(L)&&E.push(L);return E}A(E){let L;return(0,h.isEmptyWindowBackupInfo)(E)?L=(0,C.join)(this.c,E.backupFolder):(0,w.isFolderBackupInfo)(E)?L=(0,C.join)(this.c,this.D(E)):L=(0,C.join)(this.c,E.workspace.id),this.B(L)}async B(E){try{const L=await d.Promises.readdir(E);for(const t of L)try{if((await d.Promises.readdir((0,C.join)(E,t))).length>0)return!0}catch{}}catch{}return!1}C(){const E={workspaces:this.d.map(({workspace:L,remoteAuthority:t})=>{const c={id:L.id,configURIPath:L.configPath.toString()};return t&&(c.remoteAuthority=t),c}),folders:this.e.map(({folderUri:L,remoteAuthority:t})=>{const c={folderUri:L.toString()};return t&&(c.remoteAuthority=t),c}),emptyWindows:this.g.map(({backupFolder:L,remoteAuthority:t})=>{const c={backupFolder:L};return t&&(c.remoteAuthority=t),c})};this.m.setItem(vt.a,E)}D(E){const L=E.folderUri;let t;return L.scheme===n.Schemas.file?t=D.isLinux?L.fsPath:L.fsPath.toLowerCase():t=L.toString().toLowerCase(),(0,I.createHash)("md5").update(t).digest("hex")}};m.a="backupWorkspaces",m=we([_(0,v.IEnvironmentMainService),_(1,S.IConfigurationService),_(2,p.ILogService),_(3,b.IStateMainService)],m),e.BackupMainService=m}),define(ee[53],te([0,1,14,3,43,37,2,15,9,20,10,23,180,62,57,28,6,5,19,52,120,29,96,97]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u,m,k,E,L,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,a.createDecorator)("workspacesManagementMainService");let i=class extends D.Disposable{constructor(s,l,o,f,y,M){super(),this.g=s,this.h=l,this.i=o,this.j=f,this.k=y,this.l=M,this.a=this.B(new R.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new R.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const s=(await v.Promises.readdir(this.c.fsPath)).map(l=>(0,h.joinPath)(this.c,l,L.UNTITLED_WORKSPACE_NAME));for(const l of s){const o=(0,c.getWorkspaceIdentifier)(l),f=await this.resolveLocalWorkspace(l);f?this.f.push({workspace:o,remoteAuthority:f.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(s){s.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${s}).`)}}resolveLocalWorkspace(s){return this.m(s,l=>v.Promises.readFile(l,"utf8"))}m(s,l){if(!!this.n(s)&&s.scheme===P.Schemas.file)try{const o=l(s.fsPath);return o instanceof Promise?o.then(f=>this.p(s,f),f=>{}):this.p(s,o)}catch{return}}n(s){return(0,L.isUntitledWorkspace)(s,this.g)||(0,L.hasWorkspaceFileExtension)(s)}p(s,l){try{const o=this.r(s,l),f=(0,c.getWorkspaceIdentifier)(s);return{id:f.id,configPath:f.configPath,folders:(0,t.toWorkspaceFolders)(o.folders,f.configPath,h.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.h.warn(o.toString())}}r(s,l){const o=(0,n.parse)(l);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(f=>(0,t.isStoredWorkspaceFolder)(f));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(s,l){const{workspace:o,storedWorkspace:f}=this.s(s,l),y=o.configPath.fsPath;return await v.Promises.mkdir((0,d.dirname)(y),{recursive:!0}),await v.Promises.writeFile(y,JSON.stringify(f,null,"	")),this.f.push({workspace:o,remoteAuthority:l}),o}s(s=[],l){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),f=(0,h.joinPath)(this.c,o),y=(0,h.joinPath)(f,L.UNTITLED_WORKSPACE_NAME),M=[];for(const O of s)M.push((0,t.getStoredWorkspaceFolder)(O.uri,!0,O.name,f,h.extUriBiasedIgnorePathCase));return{workspace:(0,c.getWorkspaceIdentifier)(y),storedWorkspace:{folders:M,remoteAuthority:l}}}async getWorkspaceIdentifier(s){return(0,c.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,L.isUntitledWorkspace)(s.configPath,this.g)}async deleteUntitledWorkspace(s){!this.isUntitledWorkspace(s)||(await this.t(s),this.i.isEnabled()&&this.i.unsetWorkspace(s),this.a.fire(s))}async t(s){const l=(0,h.originalFSPath)(s.configPath);try{await v.Promises.rm((0,d.dirname)(l));const o=(0,d.join)(this.g.workspaceStorageHome.fsPath,s.id);await v.Promises.exists(o)&&await v.Promises.writeFile((0,d.join)(o,"obsolete"),""),this.f=this.f.filter(f=>f.workspace.id!==s.id)}catch(o){this.h.warn(`Unable to delete untitled workspace ${l} (${o}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(s,l,o){if(!s||!s.win||!s.isReady||!await this.u(s,l,o))return;const y=await this.v(s,(0,c.getWorkspaceIdentifier)(o));if(!!y)return this.b.fire({window:s,workspace:y.workspace}),y}async u(s,l,o){if(!o)return!0;if((0,L.isWorkspaceIdentifier)(s.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,o))return!1;if((0,E.findWindowOnWorkspaceOrFolder)(l,o)){const f={title:this.l.nameLong,type:"info",buttons:[(0,C.mnemonicButtonLabel)((0,b.localize)(0,null))],message:(0,b.localize)(1,null,(0,h.basename)(o)),detail:(0,b.localize)(2,null),noLink:!0,defaultId:0};return await this.k.showMessageBox(f,(0,S.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),!1}return!0}async v(s,l){if(!s.config)return;s.focus();let o;return s.config.extensionDevelopmentPath||(s.config.backupPath?o=await this.j.registerWorkspaceBackup({workspace:l,remoteAuthority:s.remoteAuthority},s.config.backupPath):o=this.j.registerWorkspaceBackup({workspace:l,remoteAuthority:s.remoteAuthority})),(0,L.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=l,s.config.backupPath=o,{workspace:l,backupPath:o}}};i=we([_(0,w.IEnvironmentMainService),_(1,u.ILogService),_(2,k.IUserDataProfilesMainService),_(3,g.IBackupMainService),_(4,p.IDialogMainService),_(5,m.IProductService)],i),e.WorkspacesManagementMainService=i}),define(ee[121],te([0,1,14,42,22,6,30,29,53,10,5]),function(x,e,I,R,n,C,D,P,d,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,C.createDecorator)(e.ID);let v=class{constructor(g,p,w){this.a=g,this.b=p,this.c=w}async getRemoteDiagnostics(g){const p=this.a.getWindows();return(await Promise.all(p.map(async a=>{const u=a.remoteAuthority;if(!u)return;const m=`vscode:getDiagnosticInfoResponse${a.id}`,k={includeProcesses:g.includeProcesses,folders:g.includeWorkspaceMetadata?await this.f(a):void 0};return new Promise(E=>{a.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:m,args:k}),R.validatedIpcMain.once(m,(L,t)=>{t||E({hostName:u,errorMessage:`Unable to resolve connection to '${u}'.`}),E(t)}),setTimeout(()=>{E({hostName:u,errorMessage:`Connection to '${u}' could not be established`})},5e3)})}))).filter(a=>!!a)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const g=[];for(const p of I.BrowserWindow.getAllWindows()){const w=this.a.getWindowById(p.id);w?g.push(await this.d(w)):g.push(this.e(p))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:g,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async d(g){const p=await this.f(g),w=(0,h.assertIsDefined)(g.win);return this.e(w,p,g.remoteAuthority)}e(g,p=[],w){return{pid:g.webContents.getOSProcessId(),title:g.getTitle(),folderURIs:p,remoteAuthority:w}}async f(g){const p=[],w=g.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(w))p.push(w.uri);else if((0,P.isWorkspaceIdentifier)(w)){const a=await this.b.resolveLocalWorkspace(w.configPath);a&&a.folders.forEach(m=>{p.push(m.uri)})}return p}};v=we([_(0,D.IWindowsMainService),_(1,d.IWorkspacesManagementMainService),_(2,S.ILogService)],v),e.DiagnosticsMainService=v}),define(ee[58],te([0,1,46,14,26,146,54,3,37,2,15,9,4,7,102,84,23,99,170,57,28,6,21,5,19,68,30,29,53,17,229,222,34]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u,m,k,E,L,t,c,i,r,s,l,o,f,y,M,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,L.createDecorator)("nativeHostMainService");let j=class extends h.Disposable{constructor(H,K,ne,re,ae,fe,ge,V,F,W){super(),this.a=H,this.b=K,this.c=ne,this.f=re,this.g=ae,this.h=fe,this.i=ge,this.j=V,this.k=F,this.l=W,this.onDidOpenWindow=P.Event.map(this.b.onDidOpenWindow,z=>z.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.b.onDidTriggerSystemContextMenu,({window:z,x:X,y:ie})=>({windowId:z.id,x:X,y:ie})),({windowId:z})=>!!this.b.getWindowById(z)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-maximize",(z,X)=>X.id),z=>!!this.b.getWindowById(z)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-unmaximize",(z,X)=>X.id),z=>!!this.b.getWindowById(z)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(z,X)=>X.id),z=>!!this.b.getWindowById(z)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),z=>!!z),z=>z.id),P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(z,X)=>X.id),z=>!!this.b.getWindowById(z))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new P.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(z,X,ie)=>ie),z=>!(Array.isArray(z)&&z.length===1&&z[0]==="workArea")),P.Event.fromNodeEventEmitter(R.screen,"display-added"),P.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(K=>({id:K.id,workspace:K.openedWorkspace??(0,l.toWorkspaceIdentifier)(K.backupPath,K.isExtensionDevelopmentHost),title:K.win?.getTitle()??"",filename:K.getRepresentedFilename(),dirty:K.isDocumentEdited()}))}async getWindowCount(H){return this.b.getWindowCount()}async getActiveWindowId(H){const K=R.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(K)return K.id}openWindow(H,K,ne){return Array.isArray(K)?this.n(H,K,ne):this.p(H,K)}async n(H,K,ne=Object.create(null)){K.length>0&&await this.b.open({context:5,contextWindowId:H,urisToOpen:K,cli:this.g.args,forceNewWindow:ne.forceNewWindow,forceReuseWindow:ne.forceReuseWindow,preferNewWindow:ne.preferNewWindow,diffMode:ne.diffMode,mergeMode:ne.mergeMode,addMode:ne.addMode,gotoLineMode:ne.gotoLineMode,noRecentEntry:ne.noRecentEntry,waitMarkerFileURI:ne.waitMarkerFileURI,remoteAuthority:ne.remoteAuthority||void 0,forceProfile:ne.forceProfile,forceTempProfile:ne.forceTempProfile})}async p(H,K){await this.b.openEmptyWindow({context:5,contextWindowId:H},K)}async toggleFullScreen(H){this.w(H)?.toggleFullScreen()}async handleTitleDoubleClick(H){this.w(H)?.handleTitleDoubleClick()}async isMaximized(H){const K=this.w(H);return K?.win?K.win.isMaximized():!1}async maximizeWindow(H){const K=this.w(H);K?.win&&K.win.maximize()}async unmaximizeWindow(H){const K=this.w(H);K?.win&&K.win.unmaximize()}async minimizeWindow(H){const K=this.w(H);K?.win&&K.win.minimize()}async updateWindowControls(H,K){const ne=this.w(H);ne&&ne.updateWindowControls(K)}async focusWindow(H,K){K&&typeof K.windowId=="number"&&(H=K.windowId),this.w(H)?.focus({force:K?.force??!1})}async setMinimumSize(H,K,ne){const re=this.w(H);if(re?.win){const[ae,fe]=re.win.getSize(),[ge,V]=re.win.getMinimumSize(),[F,W]=[K??ge,ne??V],[z,X]=[Math.max(ae,F),Math.max(fe,W)];(ge!==F||V!==W)&&re.win.setMinimumSize(F,W),(ae!==z||fe!==X)&&re.win.setSize(z,X)}}async saveWindowSplash(H,K){this.j.saveWindowSplash(H,K)}async installShellCommand(H){const{source:K,target:ne}=await this.r();try{const{symbolicLink:re}=await a.SymlinkSupport.stat(K);if(re&&!re.dangling){const ae=await(0,p.realpath)(K);if(ne===ae)return}await a.Promises.unlink(K)}catch(re){if(re.code!=="ENOENT")throw re}try{await a.Promises.symlink(ne,K)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:ae}=await this.showMessageBox(H,{title:this.i.nameLong,type:"info",message:(0,m.localize)(0,null,this.i.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,m.localize)(1,null)),(0,d.mnemonicButtonLabel)((0,m.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ae===0)try{const fe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${ne}' '${K}'\\" with administrator privileges"`;await(0,C.promisify)(I.exec)(fe)}catch{throw new Error((0,m.localize)(3,null,K))}}}async uninstallShellCommand(H){const{source:K}=await this.r();try{await a.Promises.unlink(K)}catch(ne){switch(ne.code){case"EACCES":{const{response:re}=await this.showMessageBox(H,{title:this.i.nameLong,type:"info",message:(0,m.localize)(4,null,this.i.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,m.localize)(5,null)),(0,d.mnemonicButtonLabel)((0,m.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const ae=`osascript -e "do shell script \\"rm '${K}'\\" with administrator privileges"`;await(0,C.promisify)(I.exec)(ae)}catch{throw new Error((0,m.localize)(7,null,K))}break}case"ENOENT":break;default:throw ne}}}async r(){const H=(0,v.resolve)(this.g.appRoot,"bin","code"),K=`/usr/local/bin/${this.i.applicationName}`;if(!await a.Promises.exists(H))throw new Error((0,m.localize)(8,null,H));return{source:K,target:H}}async showMessageBox(H,K){return this.c.showMessageBox(K,this.s(H))}async showSaveDialog(H,K){return this.c.showSaveDialog(K,this.s(H))}async showOpenDialog(H,K){return this.c.showOpenDialog(K,this.s(H))}s(H){const K=this.w(H);if(K?.win)return K.win}async pickFileFolderAndOpen(H,K){const ne=await this.c.pickFileFolder(K);ne&&await this.t(await Promise.all(ne.map(async re=>await a.SymlinkSupport.existsDirectory(re)?{folderUri:g.URI.file(re)}:{fileUri:g.URI.file(re)})),K,H)}async pickFolderAndOpen(H,K){const ne=await this.c.pickFolder(K);ne&&await this.t(ne.map(re=>({folderUri:g.URI.file(re)})),K,H)}async pickFileAndOpen(H,K){const ne=await this.c.pickFile(K);ne&&await this.t(ne.map(re=>({fileUri:g.URI.file(re)})),K,H)}async pickWorkspaceAndOpen(H,K){const ne=await this.c.pickWorkspace(K);ne&&await this.t(ne.map(re=>({workspaceUri:g.URI.file(re)})),K,H)}async t(H,K,ne){await this.b.open({context:3,contextWindowId:ne,cli:this.g.args,urisToOpen:H,forceNewWindow:K.forceNewWindow})}async showItemInFolder(H,K){R.shell.showItemInFolder(K)}async setRepresentedFilename(H,K){this.w(H)?.setRepresentedFilename(K)}async setDocumentEdited(H,K){this.w(H)?.setDocumentEdited(K)}async openExternal(H,K){return b.isLinuxSnap?this.u(K):R.shell.openExternal(K),!0}u(H){const K=process.env.GDK_PIXBUF_MODULE_FILE,ne=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,R.shell.openExternal(H),process.env.GDK_PIXBUF_MODULE_FILE=K,process.env.GDK_PIXBUF_MODULEDIR=ne}moveItemToTrash(H,K){return R.shell.trashItem(K)}async isAdmin(){let H;return b.isWindows?H=(await new Promise((K,ne)=>{x(["native-is-elevated"],K,ne)}))():H=process.getuid()===0,H}async writeElevated(H,K,ne,re){const ae=await new Promise((fe,ge)=>{x(["@vscode/sudo-prompt"],fe,ge)});return new Promise((fe,ge)=>{const V=[`"${this.v}"`];re?.unlock&&V.push("--file-chmod"),V.push("--file-write",`"${K.fsPath}"`,`"${ne.fsPath}"`);const F={name:this.i.nameLong.replace("-",""),icns:b.isMacintosh&&this.g.isBuilt?(0,v.join)((0,v.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};ae.exec(V.join(" "),F,(W,z,X)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),X&&this.h.trace(`[sudo-prompt] received stderr: ${X}`),W?ge(W):fe(void 0)})})}get v(){return b.isWindows?this.g.isBuilt?(0,v.join)((0,v.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,v.join)(this.g.appRoot,"scripts","code-cli.bat"):b.isLinux?this.g.isBuilt?(0,v.join)((0,v.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,v.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,v.join)(this.g.appRoot,"bin","code"):(0,v.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,n.totalmem)(),freemem:(0,n.freemem)(),loadavg:(0,n.loadavg)()}}async getOSProperties(){return{arch:(0,n.arch)(),platform:(0,n.platform)(),release:(0,n.release)(),type:(0,n.type)(),cpus:(0,n.cpus)()}}async getOSVirtualMachineHint(){return w.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return b.isWindows&&(0,y.hasWSLFeatureInstalled)()}async killProcess(H,K,ne){process.kill(K,ne)}async readClipboardText(H,K){return R.clipboard.readText(K)}async writeClipboardText(H,K,ne){return R.clipboard.writeText(K,ne)}async readClipboardFindText(H){return R.clipboard.readFindText()}async writeClipboardFindText(H,K){return R.clipboard.writeFindText(K)}async writeClipboardBuffer(H,K,ne,re){return R.clipboard.writeBuffer(K,Buffer.from(ne.buffer),re)}async readClipboardBuffer(H,K){return f.VSBuffer.wrap(R.clipboard.readBuffer(K))}async hasClipboard(H,K,ne){return R.clipboard.has(K,ne)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(H,K){this.w(H)?.updateTouchBar(K)}async notifyReady(H){this.w(H)?.setReady()}async relaunch(H,K){return this.f.relaunch(K)}async reload(H,K){const ne=this.w(H);if(ne){if((0,l.isWorkspaceIdentifier)(ne.openedWorkspace)){const re=ne.openedWorkspace.configPath;if(re.scheme===S.Schemas.file&&(await this.l.resolveLocalWorkspace(re))?.transient)return this.openWindow(ne.id,{forceReuseWindow:!0})}return this.f.reload(ne,K?.disableExtensions!==void 0?{_:[],"disable-extensions":K.disableExtensions}:void 0)}}async closeWindow(H){this.closeWindowById(H,H)}async closeWindowById(H,K){const ne=this.w(K);if(ne?.win)return ne.win.close()}async quit(H){const K=this.b.getLastActiveWindow();K?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&K.win?K.win.close():this.f.quit()}async exit(H,K){await this.f.kill(K)}async resolveProxy(H,K){const re=this.w(H)?.win?.webContents?.session;if(re)return re.resolveProxy(K)}findFreePort(H,K,ne,re,ae=1){return(0,u.findFreePort)(K,ne,re,ae)}async openDevTools(H,K){const ne=this.w(H);ne?.win&&ne.win.webContents.openDevTools(K)}async toggleDevTools(H){const K=this.w(H);K?.win&&K.win.webContents.toggleDevTools()}async sendInputEvent(H,K){const ne=this.w(H);ne?.win&&(K.type==="mouseDown"||K.type==="mouseUp")&&ne.win.webContents.sendInputEvent(K)}async enableSandbox(H,K){K?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(H,K,ne){const re=this.w(H);if(!re||!re.win)throw new Error;return await new M.WindowProfiler(re.win,K,this.h).inspect(ne)}async windowsGetStringRegKey(H,K,ne,re){if(!b.isWindows)return;const ae=await new Promise((fe,ge)=>{x(["@vscode/windows-registry"],fe,ge)});try{return ae.GetStringRegKey(K,ne,re)}catch{return}}w(H){if(typeof H=="number")return this.b.getWindowById(H)}};we([D.memoize],j.prototype,"v",null),j=we([_(1,s.IWindowsMainService),_(2,k.IDialogMainService),_(3,t.ILifecycleMainService),_(4,E.IEnvironmentMainService),_(5,c.ILogService),_(6,i.IProductService),_(7,r.IThemeMainService),_(8,O.IStateMainService),_(9,o.IWorkspacesManagementMainService)],j),e.NativeHostMainService=j}),define(ee[274],te([0,1,14,42,26,37,2,15,4,103,168,87,121,57,28,6,5,58,65,19,66,76,32,10,34]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u,m,k,E,L,t,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,w.createDecorator)("issueMainService");const r="issue.processExplorerWindowState";let s=class kt{constructor(f,y,M,O,j,G,H,K,ne,re){this.g=f,this.h=y,this.i=M,this.j=O,this.k=j,this.l=G,this.m=H,this.n=K,this.o=ne,this.p=re,this.b=null,this.c=null,this.d=null,this.f=null,this.q()}q(){R.validatedIpcMain.on("vscode:issueSystemInfoRequest",async f=>{const[y,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),O=await this.j.getSystemInfo(y,M);this.r(f,"vscode:issueSystemInfoResponse",O)}),R.validatedIpcMain.on("vscode:listProcesses",async f=>{const y=[];try{y.push({name:(0,S.localize)(0,null),rootProcess:await(0,h.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(O=>{(0,v.isRemoteDiagnosticError)(O)?y.push({name:O.hostName,rootProcess:O}):O.processes&&y.push({name:O.hostName,rootProcess:O.processes})})}catch(M){this.i.error(`Listing processes failed: ${M}`)}this.r(f,"vscode:listProcessesResponse",y)}),R.validatedIpcMain.on("vscode:issueReporterClipboard",async f=>{const y={title:this.o.nameLong,message:(0,S.localize)(1,null),type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,S.localize)(2,null)),(0,C.mnemonicButtonLabel)((0,S.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.b){const M=await this.l.showMessageBox(y,this.b);this.r(f,"vscode:issueReporterClipboardResponse",M.response===0)}}),R.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async f=>{const y=await this.v();this.r(f,"vscode:issuePerformanceInfoResponse",y)}),R.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const f={title:this.o.nameLong,message:(0,S.localize)(4,null),type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,C.mnemonicButtonLabel)((0,S.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.b&&(await this.l.showMessageBox(f,this.b)).response===0&&this.b&&(this.b.destroy(),this.b=null)}),R.validatedIpcMain.on("vscode:workbenchCommand",(f,y)=>{const{id:M,from:O,args:j}=y;let G;switch(O){case"issueReporter":G=this.c;break;case"processExplorer":G=this.f;break;default:throw new Error(`Unexpected command source: ${O}`)}G?.webContents.send("vscode:runAction",{id:M,from:O,args:j})}),R.validatedIpcMain.on("vscode:openExternal",(f,y)=>{this.m.openExternal(void 0,y)}),R.validatedIpcMain.on("vscode:closeIssueReporter",f=>{this.b?.close()}),R.validatedIpcMain.on("vscode:closeProcessExplorer",f=>{this.d?.close()}),R.validatedIpcMain.on("vscode:windowsInfoRequest",async f=>{const y=await this.k.getMainDiagnostics();this.r(f,"vscode:windowsInfoResponse",y.windows)})}r(f,y,...M){f.sender.isDestroyed()||f.sender.send(y,...M)}async openReporter(f){if(!this.b&&(this.c=I.BrowserWindow.getFocusedWindow(),this.c)){const y=new D.DisposableStore,M=y.add(this.n.createIPCObjectUrl()),O=this.u(this.c,700,800);this.b=this.t(O,M,{backgroundColor:f.styles.backgroundColor,title:(0,S.localize)(7,null),zoomLevel:f.zoomLevel,alwaysOnTop:!1},"issue-reporter"),M.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:f,disableExtensions:!!this.h.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:m.default}),this.b.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,y.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,y.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(f){if(!this.d&&(this.f=I.BrowserWindow.getFocusedWindow(),this.f)){const y=new D.DisposableStore,M=y.add(this.n.createIPCObjectUrl()),O=this.p.getItem(r,void 0),j=l(O)?O:this.u(this.f,800,500),G=I.screen.getDisplayNearestPoint({x:j.x,y:j.y});j.width/=G.scaleFactor,j.height/=G.scaleFactor,this.d=this.t(j,M,{backgroundColor:f.styles.backgroundColor,title:(0,S.localize)(8,null),zoomLevel:f.zoomLevel,alwaysOnTop:!0},"process-explorer"),M.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:f,product:m.default}),this.d.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,y.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,y.dispose())});const H=()=>{if(!this.d)return;const K=this.d.getSize(),ne=this.d.getPosition();if(!K||!ne)return;const re={width:K[0],height:K[1],x:ne[0],y:ne[1]};this.p.setItem(r,re)};this.d.on("moved",H),this.d.on("resized",H)}this.d&&this.s(this.d)}s(f){f.isMinimized()&&f.restore(),f.focus()}t(f,y,M,O){const j=new I.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:f.width,height:f.height,minWidth:300,minHeight:200,x:f.x,y:f.y,title:M.title,backgroundColor:M.backgroundColor||kt.a,webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${y.resource.toString()}`,`--vscode-window-kind=${O}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,L.zoomLevelToZoomFactor)(M.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:M.alwaysOnTop,experimentalDarkMode:!0});return j.setMenuBarVisibility(!1),j}async getSystemStatus(){const[f,y]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(f,y)}u(f,y,M){let O;const j=I.screen.getAllDisplays();if(j.length===1)O=j[0];else{if(d.isMacintosh){const K=I.screen.getCursorScreenPoint();O=I.screen.getDisplayNearestPoint(K)}!O&&f&&(O=I.screen.getDisplayMatching(f.getBounds())),O||(O=I.screen.getPrimaryDisplay()||j[0])}const G=O.bounds,H={width:y,height:M,x:G.x+G.width/2-y/2,y:G.y+G.height/2-M/2};return G.width>0&&G.height>0&&(H.x<G.x&&(H.x=G.x),H.y<G.y&&(H.y=G.y),H.x>G.x+G.width&&(H.x=G.x),H.y>G.y+G.height&&(H.y=G.y),H.width>G.width&&(H.width=G.width),H.height>G.height&&(H.height=G.height)),H}async v(){try{const[f,y]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(f,y)}catch(f){throw this.i.warn("issueService#getPerformanceInfo ",f.message),f}}async stopTracing(){if(!this.h.args.trace)return;const f=await I.contentTracing.stopRecording(`${(0,t.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({title:this.o.nameLong,type:"info",message:(0,S.localize)(9,null),detail:(0,S.localize)(10,null,f),buttons:[(0,C.mnemonicButtonLabel)((0,S.localize)(11,null))],defaultId:0,noLink:!0},(0,c.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,f)}};s.a="#1E1E1E",s=we([_(1,p.IEnvironmentMainService),_(2,a.ILogService),_(3,v.IDiagnosticsService),_(4,b.IDiagnosticsMainService),_(5,g.IDialogMainService),_(6,u.INativeHostMainService),_(7,E.IProtocolMainService),_(8,k.IProductService),_(9,i.IStateMainService)],s),e.IssueMainService=s;function l(o){return typeof o!="object"||o===null?!1:"x"in o&&"y"in o&&"width"in o&&"height"in o}}),define(ee[275],te([0,1,22,18,28,21,5,58,19,56,24,48,93]),function(x,e,I,R,n,C,D,P,d,h,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let g=class extends b.AbstractUpdateService{constructor(w,a,u,m,k,E,L,t){super(w,a,m,k,E,t),this.e=u,this.t=L}r(w){return(0,b.createUpdateURL)(`linux-${process.arch}`,w,this.k)}s(w){!this.a||(this.d(v.State.CheckingForUpdates(w)),this.i.request({url:this.a},I.CancellationToken.None).then(h.asJson).then(a=>{!a||!a.url||!a.version||!a.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(v.State.Idle(1))):this.d(v.State.AvailableForDownload(a))}).then(void 0,a=>{this.j.error(a),this.e.publicLog2("update:notAvailable",{explicit:!!w});const u=w?a.message||a:void 0;this.d(v.State.Idle(1,u))}))}async n(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.t.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.t.openExternal(void 0,w.update.url),this.d(v.State.Idle(1))}};g=we([_(0,C.ILifecycleMainService),_(1,R.IConfigurationService),_(2,S.ITelemetryService),_(3,n.IEnvironmentMainService),_(4,h.IRequestService),_(5,D.ILogService),_(6,P.INativeHostMainService),_(7,d.IProductService)],g),e.LinuxUpdateService=g}),define(ee[276],te([0,1,46,41,26,8,22,54,9,7,132,23,18,28,16,21,5,58,19,56,24,48,93]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u,m,k,E,L,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function c(l,o=1e3){for(;!l();)await(0,C.timeout)(o)}let i;function r(){return typeof i>"u"&&(i=R.existsSync(d.join(d.dirname(process.execPath),"unins000.exe"))?0:1),i}let s=class extends t.AbstractUpdateService{get cachePath(){const o=d.join((0,n.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return v.Promises.mkdir(o,{recursive:!0}).then(()=>o)}constructor(o,f,y,M,O,j,G,H,K){super(o,f,M,O,j,K),this.t=y,this.u=G,this.v=H}async initialize(){if(this.k.target==="user"&&await this.v.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}r(o){let f="win32";return process.arch!=="ia32"&&(f+=`-${process.arch}`),r()===1?f+="-archive":this.k.target==="user"&&(f+="-user"),(0,t.createUpdateURL)(f,o,this.k)}s(o){!this.a||(this.d(L.State.CheckingForUpdates(o)),this.i.request({url:this.a},D.CancellationToken.None).then(k.asJson).then(f=>{const y=r();return!f||!f.url||!f.version||!f.productVersion?(this.t.publicLog2("update:notAvailable",{explicit:!!o}),this.d(L.State.Idle(y)),Promise.resolve(null)):y===1?(this.d(L.State.AvailableForDownload(f)),Promise.resolve(null)):(this.d(L.State.Downloading(f)),this.A(f.version).then(()=>this.z(f.version).then(M=>v.Promises.exists(M).then(O=>{if(O)return Promise.resolve(M);const j=f.url,G=f.hash,H=`${M}.tmp`;return this.i.request({url:j},D.CancellationToken.None).then(K=>this.u.writeFile(h.URI.file(H),K.stream)).then(G?()=>(0,S.checksum)(H,f.hash):()=>{}).then(()=>v.Promises.rename(H,M)).then(()=>M)})).then(M=>{const O=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:M},O&&f.supportsFastUpdate?this.k.target==="user"?this.o():this.d(L.State.Downloaded(f)):this.d(L.State.Ready(f))})))}).then(void 0,f=>{this.j.error(f),this.t.publicLog2("update:notAvailable",{explicit:!!o});const y=o?f.message||f:void 0;this.d(L.State.Idle(r(),y))}))}async n(o){o.update.url&&this.v.openExternal(void 0,o.update.url),this.d(L.State.Idle(r()))}async z(o){const f=await this.cachePath;return d.join(f,`CodeSetup-${this.k.quality}-${o}.exe`)}async A(o=null){const f=o?j=>!new RegExp(`${this.k.quality}-${o}\\.exe$`).test(j):()=>!0,y=await this.cachePath,O=(await v.Promises.readdir(y)).filter(f).map(async j=>{try{await v.Promises.unlink(d.join(y,j))}catch{}});await Promise.all(O)}async o(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const o=this.state.update;this.d(L.State.Updating(o));const f=await this.cachePath;this.e.updateFilePath=d.join(f,`CodeSetup-${this.k.quality}-${o.version}.flag`),await v.Promises.writeFile(this.e.updateFilePath,"flag"),(0,I.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(L.State.Idle(r()))});const M=`${this.k.win32MutexName}-ready`,O=await new Promise((j,G)=>{x(["windows-mutex"],j,G)});c(()=>O.isActive(M)).then(()=>this.d(L.State.Ready(o)))}q(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?R.unlinkSync(this.e.updateFilePath):(0,I.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}p(){return r()}async _applySpecificUpdate(o){if(this.state.type!=="idle")return;const f=this.g.getValue("update.enableWindowsBackgroundUpdates"),y={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!f};this.d(L.State.Downloading(y)),this.e={packagePath:o},f?this.k.target==="user"?this.o():this.d(L.State.Downloaded(y)):this.d(L.State.Ready(y))}};we([P.memoize],s.prototype,"cachePath",null),s=we([_(0,w.ILifecycleMainService),_(1,b.IConfigurationService),_(2,E.ITelemetryService),_(3,g.IEnvironmentMainService),_(4,k.IRequestService),_(5,a.ILogService),_(6,p.IFileService),_(7,u.INativeHostMainService),_(8,m.IProductService)],s),e.Win32UpdateService=s}),define(ee[277],te([0,1,14,8,22,45,3,37,2,15,9,63,4,7,176,62,18,57,28,61,16,21,5,19,66,240,95,24,131,68,76,30,29,53,118,122,38,34,52,58,242,114,51,92,26,115,64]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u,m,k,E,L,t,c,i,r,s,l,o,f,y,M,O,j,G,H,K,ne,re,ae,fe,ge,V,F,W,z,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ie;(function(Q){Q[Q.NONE=0]="NONE",Q[Q.NAVIGATING=1]="NAVIGATING",Q[Q.READY=2]="READY"})(ie||(ie={}));let se=class ct extends d.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get backupPath(){return this.n?.backupPath}get openedWorkspace(){return this.n?.workspace}get profile(){if(!this.config)return;const A=this.P.profiles.find(T=>T.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&A?A:this.P.getProfileForWorkspace(this.config.workspace??(0,O.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.P.defaultProfile}get remoteAuthority(){return this.n?.remoteAuthority}get config(){return this.n}get isExtensionDevelopmentHost(){return!!this.n?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.n?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.n?.debugId}constructor(A,T,U,B,q,N,$,J,oe,le,be,Le,Te,Ae,pe,ve,Ce,Me,Z,ue,de){super(),this.L=T,this.M=U,this.N=B,this.O=q,this.P=N,this.Q=$,this.R=J,this.S=oe,this.U=le,this.W=be,this.X=Le,this.Y=Te,this.Z=Ae,this.ab=pe,this.bb=ve,this.db=Ce,this.eb=Me,this.fb=Z,this.gb=ue,this.hb=de,this.c=this.B(new D.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new D.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new D.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new D.Emitter),this.onDidClose=this.h.event,this.j=this.B(new D.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.t=void 0,this.u=void 0,this.z=!1,this.C=[],this.D=[],this.F=void 0,this.G=void 0,this.H=this.B(this.eb.createIPCObjectUrl()),this.J=!1,this.ib=0;{const[Pe,Re]=this.tb(A.state);this.r=Pe,this.L.trace("window#ctor: using window state",Pe);const We=this.r.mode===0||this.r.mode===3;typeof ct.b>"u"&&(ct.b=this.gb.getItem("window.experimental.useSandbox",!1));const Fe=this.U.getValue("window");let He=!1;typeof Fe?.experimental?.useSandbox=="boolean"?He=Fe.experimental.useSandbox:this.db.quality==="stable"&&ct.b?He=!0:He=typeof this.db.quality=="string"&&this.db.quality!=="stable";const Ue={width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y,backgroundColor:this.W.getBackgroundColor(),minWidth:y.WindowMinimumSize.WIDTH,minHeight:y.WindowMinimumSize.HEIGHT,show:!We,title:this.db.nameLong,webPreferences:{preload:h.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.H.resource.toString()}`],v8CacheOptions:this.N.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,y.zoomLevelToZoomFactor)(Fe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...He?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};b.isLinux?Ue.icon=(0,S.join)(this.N.appRoot,"resources/linux/code.png"):b.isWindows&&!this.N.isBuilt&&(Ue.icon=(0,S.join)(this.N.appRoot,"resources/win32/code_150x150.png")),b.isMacintosh&&!this.Ab()&&(Ue.fullscreenable=!1),b.isMacintosh&&(Ue.acceptFirstMouse=!0,Fe?.clickThroughInactive===!1&&(Ue.acceptFirstMouse=!1));const qe=b.isMacintosh&&Fe?.nativeTabs===!0;qe&&(Ue.tabbingIdentifier=this.db.nameShort);const Ke=(0,y.getTitleBarStyle)(this.U)==="custom";if(Ke&&(Ue.titleBarStyle="hidden",b.isMacintosh||(Ue.frame=!1),(0,y.useWindowControlsOverlay)(this.U))){const Be=this.W.getWindowSplash()?.colorInfo.titleBarBackground??this.W.getBackgroundColor(),xe=H.Color.fromHex(Be).isDarker()?"#FFFFFF":"#000000";Ue.titleBarOverlay={height:29,color:Be,symbolColor:xe},this.z=!0}if((0,v.mark)("code/willCreateCodeBrowserWindow"),this.l=new I.BrowserWindow(Ue),(0,v.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,b.isMacintosh&&Ke&&this.l.setSheetOffset(22),Ke&&(b.isWindows&&(0,y.useWindowControlsOverlay)(this.U)||b.isMacintosh)){const Be=this.gb.getItem(ct.a);Be&&this.updateWindowControls({height:Be})}b.isWindows&&Ke&&this.l.hookWindowMessage(278,()=>{const[xe,Y]=this.l.getPosition(),ce=I.screen.getCursorScreenPoint(),he=ce.x-xe,me=ce.y-Y;return(()=>!(he>30&&me>=0&&me<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:he,y:me})),0}),(b.isMacintosh||b.isWindows)&&Re&&(!qe||I.BrowserWindow.getAllWindows().length===1)&&[this.r.width,this.r.height,this.r.x,this.r.y].every(Be=>typeof Be=="number")&&this.l.setBounds({width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y}),We&&((0,v.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.r.mode===3&&this.wb(!0),this.l.show(),(0,v.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.N.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.qb(),this.Eb(),this.jb()}setRepresentedFilename(A){b.isMacintosh?this.l.setRepresentedFilename(A):this.v=A}getRepresentedFilename(){return b.isMacintosh?this.l.getRepresentedFilename():this.v}setDocumentEdited(A){b.isMacintosh&&this.l.setDocumentEdited(A),this.w=A}isDocumentEdited(){return b.isMacintosh?this.l.isDocumentEdited():!!this.w}focus(A){b.isMacintosh&&A?.force&&I.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.L.trace(`window#load: window reported ready (id: ${this.k})`),this.ib=2;this.C.length;)this.C.pop()(this);this.f.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.C.push(A)})}get isReady(){return this.ib===2}get whenClosedOrLoaded(){return new Promise(A=>{function T(){U.dispose(),B.dispose(),A()}const U=this.onDidClose(()=>T()),B=this.onWillLoad(()=>T())})}jb(){this.l.on("unresponsive",()=>this.mb(1)),this.l.webContents.on("render-process-gone",(T,U)=>this.mb(2,U)),this.l.webContents.on("did-fail-load",(T,U,B)=>this.mb(3,{reason:B,exitCode:U})),this.l.webContents.on("will-prevent-unload",T=>{T.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.I&&(this.n=this.I,this.I=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",T=>{this.n&&(this.n.maximized=!0),I.app.emit("browser-window-maximize",T,this.l)}),this.l.on("unmaximize",T=>{this.n&&(this.n.maximized=!1),I.app.emit("browser-window-unmaximize",T,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",n.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",n.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.B(this.U.onDidChangeConfiguration(T=>this.qb(T))),this.B(this.X.onDidDeleteUntitledWorkspace(T=>this.pb(T)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(T,U)=>{const B=await this.lb();U({cancel:!1,requestHeaders:Object.assign(T.requestHeaders,B)})})}lb(){return this.kb||(this.kb=(0,r.resolveMarketplaceHeaders)(this.db.version,this.db,this.N,this.U,this.Q,this.R,this.Z)),this.kb}async mb(A,T){switch(A){case 2:this.L.error(`CodeWindow: renderer process gone (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break;case 1:this.L.error("CodeWindow: detected unresponsive");break;case 3:this.L.error(`CodeWindow: failed to load (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break}switch(this.Z.publicLog2("windowerror",{type:A,reason:T?.reason,code:T?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.bb.kill(1);return}if(this.N.args["enable-smoke-test-driver"]){await this.ob(!1,!1),this.bb.quit();return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const U=await this.ab.showMessageBox({title:this.db.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,p.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,p.localize)(1,null)),(0,P.mnemonicButtonLabel)((0,p.localize)(2,null))],message:(0,p.localize)(3,null),detail:(0,p.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this.n?.workspace?(0,p.localize)(5,null):void 0},this.l);if(U.response!==1){const B=U.response===0;await this.ob(B,U.checkboxChecked)}}else if(A===2)if(b.isWindows&&T?.reason==="launch-failed"&&T.exitCode===18&&await this.hb.isAdmin(void 0))await this.nb(T);else{let U;T?U=(0,p.localize)(7,null,T.reason,T.exitCode??"<unknown>"):U=(0,p.localize)(6,null);const B=await this.ab.showMessageBox({title:this.db.nameLong,type:"warning",buttons:[this.n?.workspace?(0,P.mnemonicButtonLabel)((0,p.localize)(8,null)):(0,P.mnemonicButtonLabel)((0,p.localize)(9,null)),(0,P.mnemonicButtonLabel)((0,p.localize)(10,null))],message:U,detail:this.n?.workspace?(0,p.localize)(11,null):(0,p.localize)(12,null),noLink:!0,defaultId:0,checkboxLabel:this.n?.workspace?(0,p.localize)(13,null):void 0},this.l),q=B.response===0;await this.ob(q,B.checkboxChecked)}break}}async nb(A){const T=[],U=(0,V.isInternalTelemetry)(this.db,this.U);if((0,V.supportsTelemetry)(this.db,this.N)){this.db.aiConfig&&this.db.aiConfig.ariaKey&&T.push(new fe.OneDataSystemAppender(U,"monacoworkbench",null,this.db.aiConfig.ariaKey));const{installSourcePath:q}=this.N,N=await(0,z.resolveMachineId)(this.gb),$={appenders:T,sendErrorTelemetry:!1,commonProperties:(0,F.resolveCommonProperties)(this.Q,(0,W.release)(),(0,W.hostname)(),process.arch,this.db.commit,this.db.version,N,U,q),piiPaths:(0,V.getPiiPathsFromEnvironment)(this.N)};await new ge.TelemetryService($,this.U,this.db).publicLog2("windowadminerror",{reason:A.reason,code:A.exitCode})}(await this.ab.showMessageBox({title:this.db.nameLong,type:"error",buttons:[(0,P.mnemonicButtonLabel)((0,p.localize)(14,null)),(0,P.mnemonicButtonLabel)((0,p.localize)(15,null))],message:(0,p.localize)(16,null),detail:(0,p.localize)(17,null,this.db.nameLong),noLink:!0,defaultId:0},this.l)).response===0&&await this.hb.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(T.map(q=>q.flush())),await this.ob(!1,!1)}async ob(A,T){const U=this.n?.workspace;if(T&&U)try{const B=this.S.workspaceStorage(U);await B.init(),B.delete("memento/workbench.parts.editor"),await B.close()}catch(B){this.L.error(B)}if(this.j.fire(),this.l?.destroy(),A&&this.n){let B,q;(0,O.isSingleFolderWorkspaceIdentifier)(U)?B={folderUri:U.uri}:(0,O.isWorkspaceIdentifier)(U)?B={workspaceUri:U.configPath}:q=!0;const[N]=await this.fb.open({context:5,userEnv:this.n.userEnv,cli:{...this.N.args,_:[]},urisToOpen:B?[B]:void 0,forceEmpty:q,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});N.focus()}}pb(A){this.n?.workspace?.id===A.id&&(this.n.workspace=void 0)}qb(A){if(!A||A.affectsConfiguration("window.menuBarVisibility")){const T=this.Bb();T!==this.s&&(this.s=T,this.Cb(T))}if(!A||A.affectsConfiguration("http.proxy")){let T=(this.U.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;T?.endsWith("/")&&(T=T.substr(0,T.length-1));const U=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((T||"").indexOf("@")===-1&&(T!==this.F||U!==this.G)){this.F=T,this.G=U;const B=T||"",q=U?`${U},<local>`:"<local>";this.L.trace(`Setting proxy to '${B}', bypassing '${q}'`),this.l.webContents.session.setProxy({proxyRules:B,proxyBypassRules:q,pacScript:""})}}}addTabbedWindow(A){b.isMacintosh&&A.win&&this.l.addTabbedWindow(A.win)}load(A,T=Object.create(null)){this.L.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!T.isReload||!this.Y.isHotExitEnabled())&&this.setDocumentEdited(!1),T.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.db.nameLong)),this.rb(A,T),this.ib===0?this.n=A:this.I=A,this.ib=1,this.l.loadURL(h.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.N.isBuilt?"":"-dev"}.html`).toString(!0));const U=this.J;this.J=!0,!this.N.isBuilt&&!this.N.extensionTestsLocationURI&&this.B(new R.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:A.workspace,reason:T.isReload?3:U?2:1})}rb(A,T){const U=(this.n??this.I)?.userEnv;if(U){const B=(0,k.isLaunchedFromCli)(U)&&!(0,k.isLaunchedFromCli)(A.userEnv),q=this.isExtensionDevelopmentHost;(B||q)&&(A.userEnv={...U,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),T.disableExtensions!==void 0&&(A["disable-extensions"]=T.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this.l.isMaximized(),A.partsSplash=this.W.getWindowSplash(),(0,v.mark)("code/willOpenNewWindow"),A.perfMarks=(0,v.getMarks)(),this.H.update(A)}async reload(A){const T=Object.assign({},this.n);T.workspace=await this.sb(T),delete T.filesToOpenOrCreate,delete T.filesToDiff,delete T.filesToMerge,delete T.filesToWait,this.isExtensionDevelopmentHost&&A&&(T.verbose=A.verbose,T.debugId=A.debugId,T.extensionEnvironment=A.extensionEnvironment,T["inspect-extensions"]=A["inspect-extensions"],T["inspect-brk-extensions"]=A["inspect-brk-extensions"],T["extensions-dir"]=A["extensions-dir"]),T.accessibilitySupport=I.app.isAccessibilitySupportEnabled(),T.isInitialStartup=!1,T.policiesData=this.O.serialize(),T.continueOn=this.N.continueOn,T.profiles={all:this.P.profiles,profile:this.profile||this.P.defaultProfile},T.logLevel=this.L.getLevel(),T.loggers={window:this.M.getRegisteredLoggers(this.id),global:this.M.getRegisteredLoggers()},this.load(T,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async sb(A){if((0,O.isWorkspaceIdentifier)(A.workspace)){const T=A.workspace.configPath;if(T.scheme===h.Schemas.file&&!await this.Q.exists(T))return}else if((0,O.isSingleFolderWorkspaceIdentifier)(A.workspace)){const T=A.workspace.uri;if(T.scheme===h.Schemas.file&&!await this.Q.exists(T))return}return A.workspace}serializeWindowState(){if(!this.l)return(0,G.defaultWindowState)();if(this.isFullScreen){let U;try{U=I.screen.getDisplayMatching(this.getBounds())}catch{}const B=(0,G.defaultWindowState)();return{mode:3,display:U?U.id:void 0,width:this.r.width||B.width,height:this.r.height||B.height,x:this.r.x||0,y:this.r.y||0}}const A=Object.create(null);let T;if(!b.isMacintosh&&this.l.isMaximized()?T=0:T=1,T===0?A.mode=0:A.mode=1,T===1||T===0){let U;T===1?U=this.getBounds():U=this.l.getNormalBounds(),A.x=U.x,A.y=U.y,A.width=U.width,A.height=U.height}return A}updateWindowControls(A){if(A.height&&this.gb.setItem(ct.a,A.height),b.isWindows&&this.z)this.l.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0});else if(b.isMacintosh&&A.height!==void 0){const T=(A.height-15)/2;this.l.setTrafficLightPosition({x:T,y:T})}}tb(A){(0,v.mark)("code/willRestoreCodeWindowState");let T=!1;if(A)try{const U=I.screen.getAllDisplays();T=U.length>1,A=this.ub(A,U)}catch(U){this.L.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}return(0,v.mark)("code/didRestoreCodeWindowState"),[A||(0,G.defaultWindowState)(),T]}ub(A,T){if(this.L.trace(`window#validateWindowState: validating window state on ${T.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.L.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.L.trace("window#validateWindowState: unexpected negative values");return}if(T.length===1){const q=this.vb(T[0]);if(q){let N=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!q||(A.x<q.x&&(A.x=q.x),A.y<q.y&&(A.y=q.y))};this.L.trace("window#validateWindowState: 1 monitor working area",q),N(),A.width>q.width&&(A.width=q.width),A.height>q.height&&(A.height=q.height),A.x>q.x+q.width-128&&(A.x=q.x+q.width-A.width),A.y>q.y+q.height-128&&(A.y=q.y+q.height-A.height),N()}return A}if(A.display&&A.mode===3){const q=T.find(N=>N.id===A.display);if(q&&typeof q.bounds?.x=="number"&&typeof q.bounds?.y=="number"){this.L.trace("window#validateWindowState: restoring fullscreen to previous display");const N=(0,G.defaultWindowState)(3);return N.x=q.bounds.x,N.y=q.bounds.y,N}}let U,B;try{U=I.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),B=this.vb(U)}catch{}if(U&&B&&A.x+A.width>B.x&&A.y+A.height>B.y&&A.x<B.x+B.width&&A.y<B.y+B.height)return this.L.trace("window#validateWindowState: multi-monitor working area",B),A}vb(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,T]=this.l.getPosition(),[U,B]=this.l.getSize();return{x:A,y:T,width:U,height:B}}toggleFullScreen(){this.wb(!this.isFullScreen)}wb(A){this.Ab()?this.xb(A):this.zb(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",n.CancellationToken.None),this.s&&this.Cb(this.s,!1)}get isFullScreen(){return b.isMacintosh&&typeof this.t=="boolean"?this.t:this.l.isFullScreen()||this.l.isSimpleFullScreen()}xb(A){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.yb(A)}yb(A){b.isMacintosh&&(this.t=A,this.u=new R.DeferredPromise,Promise.race([this.u.p,(0,R.timeout)(1e3)]).finally(()=>this.t=void 0)),this.l.setFullScreen(A)}zb(A){this.l.isFullScreen()&&this.yb(!1),this.l.setSimpleFullScreen(A),this.l.webContents.focus()}Ab(){const A=this.U.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Bb(){let A=(0,y.getMenuBarVisibility)(this.U);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}Cb(A,T=!0){b.isMacintosh||(A==="toggle"&&T&&this.send("vscode:showInfoMessage",(0,p.localize)(18,null)),A==="hidden"?setTimeout(()=>{this.Db(A)}):this.Db(A))}Db(A){const T=this.isFullScreen;switch(A){case"classic":this.l.setMenuBarVisibility(!T),this.l.autoHideMenuBar=T;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(b.isMacintosh)switch(I.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(A,T,...U){this.isReady?this.send(A,...U):this.ready().then(()=>{T.isCancellationRequested||this.send(A,...U)})}send(A,...T){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.L.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this.l.webContents.send(A,...T)}catch(U){this.L.warn(`Error sending IPC message to channel '${A}' of window ${this.k}: ${(0,C.toErrorMessage)(U)}`)}}}updateTouchBar(A){!b.isMacintosh||this.D.forEach((T,U)=>{const B=A[U];T.segments=this.Gb(B)})}Eb(){if(!!b.isMacintosh){for(let A=0;A<10;A++){const T=this.Fb();this.D.push(T)}this.l.setTouchBar(new I.TouchBar({items:this.D}))}}Fb(A=[]){const T=this.Gb(A),U=new I.TouchBar.TouchBarSegmentedControl({segments:T,mode:"buttons",segmentStyle:"automatic",change:B=>{this.sendWhenReady("vscode:runAction",n.CancellationToken.None,{id:U.segments[B].id,from:"touchbar"})}});return U}Gb(A=[]){return A.map(U=>{let B;U.icon&&!o.ThemeIcon.isThemeIcon(U.icon)&&U.icon?.dark?.scheme===h.Schemas.file&&(B=I.nativeImage.createFromPath(g.URI.revive(U.icon.dark).fsPath),B.isEmpty()&&(B=void 0));let q;return typeof U.title=="string"?q=U.title:q=U.title.value,{id:U.id,label:B?void 0:q,icon:B}})}dispose(){super.dispose(),this.M.deregisterLoggers(this.id),this.l=null}};se.a="windowControlHeight",se.b=void 0,se=we([_(1,t.ILogService),_(2,X.ILoggerMainService),_(3,m.IEnvironmentMainService),_(4,K.IPolicyService),_(5,re.IUserDataProfilesMainService),_(6,E.IFileService),_(7,s.IApplicationStorageMainService),_(8,s.IStorageMainService),_(9,a.IConfigurationService),_(10,f.IThemeMainService),_(11,j.IWorkspacesManagementMainService),_(12,w.IBackupMainService),_(13,l.ITelemetryService),_(14,u.IDialogMainService),_(15,L.ILifecycleMainService),_(16,c.IProductService),_(17,i.IProtocolMainService),_(18,M.IWindowsMainService),_(19,ne.IStateMainService),_(20,ae.INativeHostMainService)],se),e.CodeWindow=se}),define(ee[78],te([0,1,14,25,8,3,37,2,15,4,20,7,23,179,6,21,5,95,96,29,53,35]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u,m,k,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,p.createDecorator)("workspacesHistoryMainService");let t=class nt extends P.Disposable{constructor(i,r,s,l){super(),this.f=i,this.g=r,this.h=s,this.j=l,this.c=this.B(new C.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new n.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let r=[],s=[];for(const o of i)if((0,m.isRecentWorkspace)(o))!this.g.isUntitledWorkspace(o.workspace)&&!this.r(r,o.workspace)&&r.push(o);else if((0,m.isRecentFolder)(o))this.s(r,o.folderUri)||r.push(o);else{const f=this.t(s,o.fileUri),y=o.fileUri.scheme===d.Schemas.file&&nt.y.indexOf((0,S.basename)(o.fileUri))>=0;!f&&!y&&(s.push(o),h.isWindows&&o.fileUri.scheme===d.Schemas.file&&I.app.addRecentDocument(o.fileUri.fsPath))}const l=await this.l({workspaces:r,files:s});r=l.workspaces,s=l.files,r.length>nt.a&&(r.length=nt.a),s.length>nt.a&&(s.length=nt.a),await this.n({workspaces:r,files:s}),this.c.fire(),h.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(i){const r=f=>{const y=this.p(f);for(const M of i)if(S.extUriBiasedIgnorePathCase.isEqual(M,y))return!1;return!0},s=await this.getRecentlyOpened(),l=s.workspaces.filter(r),o=s.files.filter(r);(l.length!==s.workspaces.length||o.length!==s.files.length)&&(await this.n({files:o,workspaces:l}),this.c.fire(),h.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),I.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const r=new L.ResourceMap(o=>S.extUriBiasedIgnorePathCase.getComparisonKey(o));if(i?.workspaces)for(const o of i.workspaces)r.set(this.p(o),o);const s=new L.ResourceMap(o=>S.extUriBiasedIgnorePathCase.getComparisonKey(o));if(i?.files)for(const o of i.files)s.set(this.p(o),o);const l=await this.m();for(const o of l.workspaces){const f=r.get(this.p(o));f?f.label=f.label??o.label:r.set(this.p(o),o)}for(const o of l.files){const f=s.get(this.p(o));f?f.label=f.label??o.label:s.set(this.p(o),o)}return{workspaces:[...r.values()],files:[...s.values()]}}async m(){await this.j.whenReady;let i;const r=this.j.get(nt.b,-1);if(typeof r=="string")try{i=JSON.parse(r)}catch(s){this.f.error("Unexpected error parsing opened paths list",s)}return(0,m.restoreRecentlyOpened)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(nt.b,JSON.stringify((0,m.toStoreData)(i)),-1,1)}p(i){return(0,m.isRecentFolder)(i)?i.folderUri:(0,m.isRecentFile)(i)?i.fileUri:i.workspace.configPath}r(i,r){return!!i.find(s=>(0,m.isRecentWorkspace)(s)&&s.workspace.id===r.id)}s(i,r){return!!i.find(s=>(0,m.isRecentFolder)(s)&&S.extUriBiasedIgnorePathCase.isEqual(s.folderUri,r))}t(i,r){return!!i.find(s=>S.extUriBiasedIgnorePathCase.isEqual(s.fileUri,r))}async C(){!h.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!h.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(0,null),description:(0,g.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const r=[];for(const o of I.app.getJumpListSettings().removedItems){const f=o.args;if(f){const y=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(f);y&&r.push(v.URI.parse(y[2]))}}await this.removeRecentlyOpened(r);let s=!1;const l=(0,R.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,nt.w).map(o=>{const f=(0,m.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:y,description:M}=this.F(f,o.label);let O;return v.URI.isUri(f)?O=`--folder-uri "${f.toString()}"`:(s=!0,O=`--file-uri "${f.configPath.toString()}"`),{type:"task",title:y.substr(0,255),description:M.substr(0,255),program:process.execPath,args:O,iconPath:"explorer.exe",iconIndex:0}}));l.length>0&&i.push({type:"custom",name:s?(0,g.localize)(2,null):(0,g.localize)(3,null),items:l})}i.push({type:"recent"});try{const r=I.app.setJumpList(i);r&&r!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${r}`)}catch(r){this.f.warn("updateWindowsJumpList#setJumpList",r)}}F(i,r){if(r)return{title:(0,D.splitName)(r).name,description:r};if(v.URI.isUri(i))return{title:(0,S.basename)(i),description:this.G(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,g.localize)(4,null),description:""};let s=(0,S.basename)(i.configPath);return s.endsWith(k.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-k.WORKSPACE_EXTENSION.length-1)),{title:(0,g.localize)(5,null,s),description:this.G(i.configPath)}}G(i){return i.scheme==="file"?(0,D.normalizeDriveLetter)(i.fsPath):i.toString()}async H(){if(!h.isMacintosh)return;I.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),r=[];let s=0;for(let o=0;o<i.workspaces.length&&s<nt.u;o++){const f=this.p(i.workspaces[o]);if(f.scheme===d.Schemas.file){const y=(0,S.originalFSPath)(f);await b.Promises.exists(y)&&(r.push(y),s++)}}const l=[];for(let o=0;o<i.files.length&&s<nt.v;o++){const f=this.p(i.files[o]);if(f.scheme===d.Schemas.file){const y=(0,S.originalFSPath)(f);if(nt.y.includes((0,S.basename)(f))||r.includes(y))continue;await b.Promises.exists(y)&&(l.push(y),s++)}}l.reverse().forEach(o=>I.app.addRecentDocument(o)),r.reverse().forEach(o=>I.app.addRecentDocument(o))}};t.a=500,t.b="history.recentlyOpenedPathsList",t.u=7,t.v=10,t.w=7,t.y=["COMMIT_EDITMSG","MERGE_MSG"],t=we([_(0,a.ILogService),_(1,E.IWorkspacesManagementMainService),_(2,w.ILifecycleMainService),_(3,u.IApplicationStorageMainService)],t),e.WorkspacesHistoryMainService=t}),define(ee[278],te([0,1,14,8,22,37,4,7,169,18,28,21,5,218,58,19,34,24,48,76,30,78]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u,m,k,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let c=class bt{constructor(s,l,o,f,y,M,O,j,G,H,K){this.n=s,this.o=l,this.p=o,this.q=f,this.r=y,this.s=M,this.t=O,this.u=j,this.v=G,this.w=H,this.x=K,this.m=Object.create(null),this.g=new R.RunOnceScheduler(()=>this.E(),0),this.h=new R.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.isMacintosh||(0,k.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const s=this.t.getItem(bt.a);s&&(s.menus&&(this.k=s.menus),s.keybindings&&(this.l=s.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(M,O,j)=>this.p.openEmptyWindow({context:2,contextWindowId:O?.id}),this.m["workbench.action.newWindow"]=(M,O,j)=>this.p.openEmptyWindow({context:2,contextWindowId:O?.id}),this.m["workbench.action.files.openFileFolder"]=(M,O,j)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(j),telemetryExtraData:{from:t}}),this.m["workbench.action.files.openFolder"]=(M,O,j)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(j),telemetryExtraData:{from:t}}),this.m["workbench.action.openWorkspace"]=(M,O,j)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(j),telemetryExtraData:{from:t}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const s=this.x.twitterUrl;s&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(s,"openTwitterUrl"));const l=this.x.requestFeatureUrl;l&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(l,"openUserVoiceUrl"));const o=this.x.reportIssueUrl;o&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(o,"openReportIssues"));const f=this.x.licenseUrl;f&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.language){const M=f.indexOf("?")>0?"&":"?";this.Z(`${f}${M}lang=${D.language}`,"openLicenseUrl")}else this.Z(f,"openLicenseUrl")});const y=this.x.privacyStatementUrl;y&&f&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(y,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(s=>this.F(s)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const s=this.o.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get C(){if(!D.isMacintosh)return!1;const s=this.o.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,l){this.k=s.menus,this.l=s.keybindings,this.t.setItem(bt.a,s),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(s){!D.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.d=s.newCount===0,this.D())}G(){!D.isMacintosh||(this.f=!I.BrowserWindow.getFocusedWindow(),this.D())}H(){const s=I.Menu.getApplicationMenu();if(s&&this.j.push(s),Object.keys(this.k).length===0){I.Menu.setApplicationMenu(D.isMacintosh?new I.Menu:null);return}const l=new I.Menu;let o;if(D.isMacintosh){const y=new I.Menu;o=new I.MenuItem({label:this.x.nameShort,submenu:y}),this.I(y),l.append(o)}if(D.isMacintosh&&!this.c){this.c=!0;const y=new I.Menu;y.append(new I.MenuItem({label:this.bb(d.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),I.app.dock.setMenu(y)}if(this.K("File")){const y=new I.Menu,M=new I.MenuItem({label:this.bb(d.localize(1,null)),submenu:y});this.M(y,"File"),l.append(M)}if(this.K("Edit")){const y=new I.Menu,M=new I.MenuItem({label:this.bb(d.localize(2,null)),submenu:y});this.M(y,"Edit"),l.append(M)}if(this.K("Selection")){const y=new I.Menu,M=new I.MenuItem({label:this.bb(d.localize(3,null)),submenu:y});this.M(y,"Selection"),l.append(M)}if(this.K("View")){const y=new I.Menu,M=new I.MenuItem({label:this.bb(d.localize(4,null)),submenu:y});this.M(y,"View"),l.append(M)}if(this.K("Go")){const y=new I.Menu,M=new I.MenuItem({label:this.bb(d.localize(5,null)),submenu:y});this.M(y,"Go"),l.append(M)}if(this.K("Run")){const y=new I.Menu,M=new I.MenuItem({label:this.bb(d.localize(6,null)),submenu:y});this.M(y,"Run"),l.append(M)}if(this.K("Terminal")){const y=new I.Menu,M=new I.MenuItem({label:this.bb(d.localize(7,null)),submenu:y});this.M(y,"Terminal"),l.append(M)}let f;if(this.K("Window")){const y=new I.Menu;f=new I.MenuItem({label:this.bb(d.localize(8,null)),submenu:y,role:"window"}),this.S(y)}if(f&&l.append(f),this.K("Help")){const y=new I.Menu,M=new I.MenuItem({label:this.bb(d.localize(9,null)),submenu:y,role:"help"});this.M(y,"Help"),l.append(M)}l.items&&l.items.length>0?I.Menu.setApplicationMenu(l):I.Menu.setApplicationMenu(null),this.h.schedule()}I(s){const l=this.U(d.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),o=this.T();let f;if(this.K("Preferences")){const ne=new I.Menu;this.M(ne,"Preferences"),f=new I.MenuItem({label:this.bb(d.localize(11,null)),submenu:ne})}const y=new I.Menu,M=new I.MenuItem({label:d.localize(12,null),role:"services",submenu:y}),O=new I.MenuItem({label:d.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),j=new I.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),G=new I.MenuItem({label:d.localize(15,null),role:"unhide"}),H=new I.MenuItem(this.Y("workbench.action.quit",{label:d.localize(16,null,this.x.nameLong),click:async(ne,re,ae)=>{const fe=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!I.BrowserWindow.getFocusedWindow()||fe?.isMinimized())&&await this.J(ae)&&this.w.quit(void 0)}})),K=[l];K.push(...o),f&&K.push(i(),f),K.push(i(),M,i(),O,j,G,i(),H),K.forEach(ne=>s.append(ne))}async J(s){if(this.p.getWindowCount()===0)return!0;const l=this.o.getValue("window.confirmBeforeClose");if(l==="always"||l==="keyboardOnly"&&this.Q(s)){const o={title:this.x.nameLong,type:"question",buttons:[(0,C.mnemonicButtonLabel)(d.localize(17,null)),(0,C.mnemonicButtonLabel)(d.localize(18,null))],message:d.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:f}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,o);return f===0}return!0}K(s){if(!D.isMacintosh&&(0,k.getTitleBarStyle)(this.o)==="custom")return!1;switch(s){case"File":case"Help":if(D.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[s];case"Window":if(D.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[s]}}L(s,l){l.forEach(o=>{if((0,g.isMenubarMenuItemSeparator)(o))s.append(i());else if((0,g.isMenubarMenuItemSubmenu)(o)){const f=new I.Menu,y=new I.MenuItem({label:this.bb(o.label),submenu:f});this.L(f,o.submenu.items),s.append(y)}else(0,g.isMenubarMenuItemRecentAction)(o)?s.append(this.O(o)):(0,g.isMenubarMenuItemAction)(o)&&(o.id==="workbench.action.showAboutDialog"&&this.N(s),D.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[o.id]?s.append(new I.MenuItem(this.Y(o.id,{label:this.bb(o.label),click:this.m[o.id]}))):s.append(this.U(o.label,o.id,!1,o.checked)):s.append(this.U(o.label,o.id,o.enabled!==!1,!!o.checked)):s.append(this.U(o.label,o.id,o.enabled!==!1,!!o.checked)))})}M(s,l){this.k&&this.k[l]&&this.L(s,this.k[l].items)}N(s){const l=this.T();l.length&&(l.forEach(o=>s.append(o)),s.append(i()))}O(s){const l=P.URI.revive(s.uri),o=s.id,f=o==="openRecentFile"?{fileUri:l}:o==="openRecentWorkspace"?{workspaceUri:l}:{folderUri:l};return new I.MenuItem(this.Y(o,{label:s.label,click:async(y,M,O)=>{const j=this.P(O);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[f],forceNewWindow:j,gotoLineMode:!1,remoteAuthority:s.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([l])}},!1))}P(s){return!!(s&&(!D.isMacintosh&&(s.ctrlKey||s.shiftKey)||D.isMacintosh&&(s.metaKey||s.altKey)))}Q(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}R(s,l,o){const f={label:this.bb(s),role:o,enabled:!0};return new I.MenuItem(this.X(l,f))}S(s){const l=new I.MenuItem({label:d.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),o=new I.MenuItem({label:d.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),f=new I.MenuItem({label:d.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),y=this.U(d.localize(23,null),"workbench.action.switchWindow"),M=[];this.C&&(M.push(i()),M.push(this.U(d.localize(24,null),"workbench.action.newWindowTab")),M.push(this.R(d.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.R(d.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.R(d.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.R(d.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[l,o,i(),y,...M,i(),f].forEach(O=>s.append(O))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new I.MenuItem({label:this.bb(d.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new I.MenuItem({label:d.localize(30,null),enabled:!1})];case"available for download":return[new I.MenuItem({label:this.bb(d.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new I.MenuItem({label:d.localize(32,null),enabled:!1})];case"downloaded":return[new I.MenuItem({label:this.bb(d.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new I.MenuItem({label:d.localize(34,null),enabled:!1})];case"ready":return[new I.MenuItem({label:this.bb(d.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(s,l,o,f){const y=this.bb(s),M=typeof l=="function"?l:(K,ne,re)=>{const ae=K?K.userSettingsLabel:null;let fe=l;Array.isArray(l)&&(fe=this.P(re)?l[1]:l[0]),ae&&re.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ae}):this.W({type:"commandId",commandId:fe})},O=typeof o=="boolean"?o:this.p.getWindowCount()>0,j=typeof f=="boolean"?f:!1,G={label:y,click:M,enabled:O};j&&(G.type="checkbox",G.checked=j);let H;return typeof l=="string"?H=l:Array.isArray(l)&&(H=l[0]),D.isMacintosh&&(H==="editor.action.clipboardCutAction"?G.role="cut":H==="editor.action.clipboardCopyAction"?G.role="copy":H==="editor.action.clipboardPasteAction"&&(G.role="paste"),H==="undo"?G.click=this.V(M,{inDevTools:K=>K.undo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("undo:")}):H==="redo"?G.click=this.V(M,{inDevTools:K=>K.redo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("redo:")}):H==="editor.action.selectAll"&&(G.click=this.V(M,{inDevTools:K=>K.selectAll(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("selectAll:")}))),new I.MenuItem(this.X(H,G))}V(s,l){return(o,f,y)=>{const M=I.BrowserWindow.getFocusedWindow();if(!M)return l.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return l.inDevTools(M.webContents.devToolsWebContents);s(o,f||M,y)}}W(s){let l=I.BrowserWindow.getFocusedWindow();if(!l){const f=this.p.getLastActiveWindow();f?.isMinimized()&&(l=f.win)}const o=l?this.p.getWindowById(l.id):void 0;if(o){if(this.v.trace("menubar#runActionInRenderer",s),D.isMacintosh&&!this.q.isBuilt&&!o.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const f={id:s.commandId,from:"menu"};o.sendWhenReady("vscode:runAction",n.CancellationToken.None,f)}else{const f={userSettingsLabel:s.userSettingsLabel};o.sendWhenReady("vscode:runKeybinding",n.CancellationToken.None,f)}}else this.v.trace("menubar#runActionInRenderer: no active window found",s)}X(s,l){const o=typeof s=="string"?this.l[s]:void 0;if(o?.label){if(o.isNative!==!1)l.accelerator=o.label,l.userSettingsLabel=o.userSettingsLabel;else if(typeof l.label=="string"){const f=l.label.indexOf("[");f>=0?l.label=`${l.label.substr(0,f)} [${o.label}]`:l.label=`${l.label} [${o.label}]`}}else l.accelerator=void 0;return l}Y(s,l,o=!l.accelerator){o&&(l=this.X(s,l));const f=l.click;return l.click=(y,M,O)=>{this.ab(s),f?.(y,M,O)},l}Z(s,l){this.w.openExternal(void 0,s),this.ab(l)}ab(s){this.r.publicLog2("workbenchActionExecuted",{id:s,from:t})}bb(s){return(0,C.mnemonicMenuLabel)(s,!this.B)}};c.a="lastKnownMenubarData",c=we([_(0,m.IUpdateService),_(1,h.IConfigurationService),_(2,E.IWindowsMainService),_(3,S.IEnvironmentMainService),_(4,u.ITelemetryService),_(5,L.IWorkspacesHistoryMainService),_(6,a.IStateMainService),_(7,v.ILifecycleMainService),_(8,b.ILogService),_(9,p.INativeHostMainService),_(10,w.IProductService)],c),e.Menubar=c;function i(){return new I.MenuItem({type:"separator"})}}),define(ee[279],te([0,1,6,21,5,278]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,I.createDecorator)("menubarMainService");let D=class{constructor(d,h,S){this.b=d,this.c=h,this.d=S,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(C.Menubar)}async updateMenubar(d,h){this.d.trace("menubarService#updateMenubar",d),(await this.a).updateMenu(h,d)}};D=we([_(0,I.IInstantiationService),_(1,R.ILifecycleMainService),_(2,n.ILogService)],D),e.MenubarMainService=D}),define(ee[280],te([0,1,14,23,26,25,22,3,32,49,37,2,15,9,63,4,36,20,10,7,177,62,18,57,28,16,6,21,5,65,19,66,55,34,76,277,120,272,29,97,78,53,68,38,52,64]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u,m,k,E,L,t,c,i,r,s,l,o,f,y,M,O,j,G,H,K,ne,re,ae,fe,ge,V,F,W,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function X(Q){return(0,re.isWorkspaceIdentifier)(Q?.workspace)}function ie(Q){return(0,re.isSingleFolderWorkspaceIdentifier)(Q?.workspace)}let se=class lt extends v.Disposable{constructor(A,T,U,B,q,N,$,J,oe,le,be,Le,Te,Ae,pe,ve,Ce,Me,Z){super(),this.k=A,this.l=T,this.m=U,this.n=B,this.r=q,this.s=N,this.t=$,this.u=J,this.v=oe,this.w=le,this.z=be,this.C=Le,this.D=Te,this.F=Ae,this.G=pe,this.H=ve,this.I=Ce,this.J=Me,this.L=Z,this.b=this.B(new P.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new P.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new P.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new P.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new P.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ne.WindowsStateHandler(this,this.r,this.v,this.m,this.z)),this.M()}M(){this.B(this.D.onDidEnterWorkspace(A=>this.c.fire(A.window))),this.B(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const T=new v.DisposableStore;if(T.add(P.Event.any(A.onDidClose,A.onDidDestroy)(()=>T.dispose())),A.config.extensionDevelopmentPath)for(const U of A.config.extensionDevelopmentPath)T.add(this.J.addValidFileRoot(U));A.config.extensionTestsPath&&T.add(this.J.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,T){const U=this.t.args,B=T?.remoteAuthority||void 0,q=!0,N=T?.forceReuseWindow,$=!N;return this.open({...A,cli:U,forceEmpty:q,forceNewWindow:$,forceReuseWindow:N,remoteAuthority:B})}openExistingWindow(A,T){A.focus(),this.N(T,[A])}async open(A){this.m.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const T=[],U=[],B=[],q=[],N=[];let $,J=0;const oe=await this.U(A);this.m.trace("windowsManager#open pathsToOpen",oe);for(const Ae of oe)ie(Ae)?A.addMode?T.push(Ae):U.push(Ae):X(Ae)?B.push(Ae):Ae.fileUri?($||($={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ae.remoteAuthority}),$.filesToOpenOrCreate.push(Ae)):Ae.backupPath?N.push({backupFolder:(0,g.basename)(Ae.backupPath),remoteAuthority:Ae.remoteAuthority}):J++;A.diffMode&&$&&$.filesToOpenOrCreate.length>=2&&($.filesToDiff=$.filesToOpenOrCreate.slice(0,2),$.filesToOpenOrCreate=[]),A.mergeMode&&$&&$.filesToOpenOrCreate.length===4&&($.filesToMerge=$.filesToOpenOrCreate.slice(0,4),$.filesToOpenOrCreate=[],$.filesToDiff=[]),$&&A.waitMarkerFileURI&&($.filesToWait={paths:(0,C.coalesce)([...$.filesToDiff,$.filesToMerge[3],...$.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(q.push(...this.D.getUntitledWorkspaces()),B.push(...q),N.push(...this.w.getEmptyWindowBackups())):N.length=0;const{windows:le,filesOpenedInWindow:be}=await this.O(A,B,U,N,J,$,T);if(this.m.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${B.length}, foldersToOpen: ${U.length}, emptyToRestore: ${N.length}, emptyToOpen: ${J})`),le.length>1)if(be)be.focus();else{const Ae=this.j.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let pe=!0,ve=!0;if(Ae){const Ce=le.filter(Me=>this.j.state.lastActiveWindow&&Me.backupPath===this.j.state.lastActiveWindow.backupPath);Ce.length&&(Ce[0].focus(),pe=!1,ve=!1)}if(pe)for(let Ce=le.length-1;Ce>=0;Ce--){const Me=le[Ce];if(!(Me.openedWorkspace&&q.some(Z=>Me.openedWorkspace&&Z.workspace.id===Me.openedWorkspace.id)||Me.backupPath&&N.some(Z=>Me.backupPath&&Z.backupFolder===(0,g.basename)(Me.backupPath)))){Me.focus(),ve=!1;break}}ve&&le[le.length-1].focus()}const Le=$&&$.filesToDiff.length>0,Te=$&&$.filesToMerge.length>0;if(!le.some(Ae=>Ae.isExtensionDevelopmentHost)&&!Le&&!Te&&!A.noRecentEntry){const Ae=[];for(const pe of oe)X(pe)&&!pe.transient?Ae.push({label:pe.label,workspace:pe.workspace,remoteAuthority:pe.remoteAuthority}):ie(pe)?Ae.push({label:pe.label,folderUri:pe.workspace.uri,remoteAuthority:pe.remoteAuthority}):pe.fileUri&&Ae.push({label:pe.label,fileUri:pe.fileUri,remoteAuthority:pe.remoteAuthority});this.C.addRecentlyOpened(Ae)}return this.N(A,le),le}N(A,T){const U=A.waitMarkerFileURI;A.context===0&&U&&T.length===1&&T[0]&&(async()=>{await T[0].whenClosedOrLoaded;try{await this.H.del(U)}catch{}})()}async O(A,T,U,B,q,N,$){const J=[];let oe;function le(Ce,Me){J.push(Ce),Me&&(oe=Ce,N=void 0)}let{openFolderInNewWindow:be,openFilesInNewWindow:Le}=this.gb(A);if(!A.initialStartup&&$.length>0){const Ce=$[0].remoteAuthority,Me=this.lb(Ce);Me&&le(this.Q(Me,$.map(Z=>Z.workspace.uri)))}const Te=U.length+T.length+B.length;if(N&&Te===0){const Ce=N.filesToOpenOrCreate[0]||N.filesToDiff[0]||N.filesToMerge[3],Me=this.getWindows().filter(ue=>N&&(0,u.isEqualAuthority)(ue.remoteAuthority,N.remoteAuthority));let Z;Ce?.fileUri&&!Le&&((A.context===4||A.context===0||A.context===1)&&(Z=await(0,K.findWindowOnFile)(Me,Ce.fileUri,async ue=>ue.configPath.scheme===b.Schemas.file?this.D.resolveLocalWorkspace(ue.configPath):void 0)),Z||(Z=this.mb(Me))),Z?(0,re.isWorkspaceIdentifier)(Z.openedWorkspace)?T.push({workspace:Z.openedWorkspace,remoteAuthority:Z.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(Z.openedWorkspace)?U.push({workspace:Z.openedWorkspace,remoteAuthority:Z.remoteAuthority}):le(this.P(A,Z,N),!0):le(await this.hb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const Ae=(0,C.distinct)(T,Ce=>Ce.workspace.id);if(Ae.length>0){const Ce=(0,C.coalesce)(Ae.map(Me=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),Me.workspace.configPath)));if(Ce.length>0){const Me=Ce[0],Z=(0,u.isEqualAuthority)(N?.remoteAuthority,Me.remoteAuthority)?N:void 0;le(this.P(A,Me,Z),!!Z),be=!0}for(const Me of Ae){if(Ce.some(de=>de.openedWorkspace&&de.openedWorkspace.id===Me.workspace.id))continue;const Z=Me.remoteAuthority,ue=(0,u.isEqualAuthority)(N?.remoteAuthority,Z)?N:void 0;le(await this.S(A,Me,be,ue),!!ue),be=!0}}const pe=(0,C.distinct)(U,Ce=>u.extUriBiasedIgnorePathCase.getComparisonKey(Ce.workspace.uri));if(pe.length>0){const Ce=(0,C.coalesce)(pe.map(Me=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),Me.workspace.uri)));if(Ce.length>0){const Me=Ce[0],Z=(0,u.isEqualAuthority)(N?.remoteAuthority,Me.remoteAuthority)?N:void 0;le(this.P(A,Me,Z),!!Z),be=!0}for(const Me of pe){if(Ce.some(de=>(0,re.isSingleFolderWorkspaceIdentifier)(de.openedWorkspace)&&u.extUriBiasedIgnorePathCase.isEqual(de.openedWorkspace.uri,Me.workspace.uri)))continue;const Z=Me.remoteAuthority,ue=(0,u.isEqualAuthority)(N?.remoteAuthority,Z)?N:void 0;le(await this.S(A,Me,be,ue),!!ue),be=!0}}const ve=(0,C.distinct)(B,Ce=>Ce.backupFolder);if(ve.length>0)for(const Ce of ve){const Me=Ce.remoteAuthority,Z=(0,u.isEqualAuthority)(N?.remoteAuthority,Me)?N:void 0;le(await this.R(A,!0,Me,Z,Ce),!!Z),be=!0}if(J.length===0||N){N&&!q&&q++;const Ce=N?N.remoteAuthority:A.remoteAuthority;for(let Me=0;Me<q;Me++)le(await this.R(A,be,Ce,N),!!N),be=!0}return{windows:(0,C.distinct)(J),filesOpenedInWindow:oe}}P(A,T,U){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:U}),T.focus();const B={filesToOpenOrCreate:U?.filesToOpenOrCreate,filesToDiff:U?.filesToDiff,filesToMerge:U?.filesToMerge,filesToWait:U?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return T.sendWhenReady("vscode:openFiles",D.CancellationToken.None,B),T}Q(A,T){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:T}),A.focus();const U={foldersToAdd:T};return A.sendWhenReady("vscode:addFolders",D.CancellationToken.None,U),A}R(A,T,U,B,q){this.m.trace("windowsManager#doOpenEmpty",{restore:!!q,remoteAuthority:U,filesToOpen:B,forceNewWindow:T});let N;return!T&&typeof A.contextWindowId=="number"&&(N=this.getWindowById(A.contextWindowId)),this.hb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:U,forceNewWindow:T,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:B,windowToUse:N,emptyWindowBackupInfo:q,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}S(A,T,U,B,q){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:T,filesToOpen:B}),!U&&!q&&typeof A.contextWindowId=="number"&&(q=this.getWindowById(A.contextWindowId)),this.hb({workspace:T.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:T.remoteAuthority,forceNewWindow:U,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:B,windowToUse:q,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async U(A){let T,U=!1,B=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(T=await this.W(A),U=!0):A.forceEmpty?T=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(T=await this.X(A.cli),T.length===0&&T.push(Object.create(null)),U=!0):(T=await this.Z(),T.length===0&&T.push(Object.create(null)),B=!0),!A.addMode&&U){const q=T.filter(N=>ie(N));if(q.length>1){const N=q[0].remoteAuthority;if(q.every($=>(0,u.isEqualAuthority)($.remoteAuthority,N))){const $=await this.D.createUntitledWorkspace(q.map(J=>({uri:J.workspace.uri})));T.push({workspace:$,remoteAuthority:N}),T=T.filter(J=>!ie(J))}}}if(A.initialStartup&&!B&&this.z.getValue("window")?.restoreWindows==="preserve"){const q=await this.Z();T.unshift(...q.filter(N=>X(N)||ie(N)||N.backupPath))}return T}async W(A){const T={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},U=await Promise.all((0,C.coalesce)(A.urisToOpen||[]).map(async B=>{const q=await this.bb(B,T);if(q)return q.label=B.label,q;const N=this.db(B),$={title:this.I.nameLong,type:"info",buttons:[(0,S.mnemonicButtonLabel)((0,E.localize)(0,null))],defaultId:0,message:N.scheme===b.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:N.scheme===b.Schemas.file?(0,E.localize)(3,null,(0,S.getPathLabel)(N,{os:w.OS,tildify:this.t})):(0,E.localize)(4,null,N.toString(!0)),noLink:!0};this.G.showMessageBox($,(0,m.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow()))}));return(0,C.coalesce)(U)}async X(A){const T=[],U={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},B=A["folder-uri"];if(B){const $=await Promise.all(B.map(J=>{const oe=this.Y(J);if(!!oe)return this.bb({folderUri:oe},U)}));T.push(...(0,C.coalesce)($))}const q=A["file-uri"];if(q){const $=await Promise.all(q.map(J=>{const oe=this.Y(J);if(!!oe)return this.bb((0,re.hasWorkspaceFileExtension)(J)?{workspaceUri:oe}:{fileUri:oe},U)}));T.push(...(0,C.coalesce)($))}const N=await Promise.all(A._.map($=>U.remoteAuthority?this.fb($,U):this.eb($,U)));return T.push(...(0,C.coalesce)(N)),T}Y(A){try{const T=k.URI.parse(A);if(!T.scheme){this.m.error(`Invalid URI input string, scheme missing: ${A}`);return}return T}catch(T){this.m.error(`Invalid URI input string: ${A}, ${T.message}`)}}async Z(){const A=this.ab();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const T=[];A!=="one"&&T.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&T.push(this.j.state.lastActiveWindow);const U=await Promise.all(T.map(async B=>{if(B.workspace){const q=await this.bb({workspaceUri:B.workspace.configPath},{remoteAuthority:B.remoteAuthority,rejectTransientWorkspaces:!0});if(X(q))return q}else if(B.folderUri){const q=await this.bb({folderUri:B.folderUri},{remoteAuthority:B.remoteAuthority});if(ie(q))return q}else if(A!=="folders"&&B.backupPath)return{backupPath:B.backupPath,remoteAuthority:B.remoteAuthority}}));return(0,C.coalesce)(U)}}}ab(){let A;return this.v.wasRestarted?A="all":(A=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async bb(A,T=Object.create(null)){const U=this.db(A);return U.scheme===b.Schemas.file?((0,G.isFileToOpen)(A)&&(T={...T,forceOpenWorkspaceAsFile:!0}),this.eb(U.fsPath,T)):this.cb(A,T)}cb(A,T){let U=this.db(A);const B=(0,O.getRemoteAuthority)(U)||T.remoteAuthority;if(U=(0,u.removeTrailingPathSeparator)((0,u.normalizePath)(U)),(0,G.isFileToOpen)(A)){if(T.gotoLineMode){const{path:q,line:N,column:$}=(0,d.parseLineAndColumnAware)(U.path);return{fileUri:U.with({path:q}),options:{selection:N?{startLineNumber:N,startColumn:$||1}:void 0},remoteAuthority:B}}return{fileUri:U,remoteAuthority:B}}else if((0,G.isWorkspaceToOpen)(A))return{workspace:(0,ae.getWorkspaceIdentifier)(U),remoteAuthority:B};return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(U),remoteAuthority:B}}db(A){return(0,G.isWorkspaceToOpen)(A)?A.workspaceUri:(0,G.isFolderToOpen)(A)?A.folderUri:A.fileUri}async eb(A,T){let U,B;T.gotoLineMode&&({path:A,line:U,column:B}=(0,d.parseLineAndColumnAware)(A)),A=(0,d.sanitizeFilePath)((0,g.normalize)(A),(0,a.cwd)());try{const q=await R.Promises.stat(A);if(q.isFile()){if(!T.forceOpenWorkspaceAsFile){const N=await this.D.resolveLocalWorkspace(k.URI.file(A));if(N)return N.transient&&T.rejectTransientWorkspaces?void 0:{workspace:{id:N.id,configPath:N.configPath},type:r.FileType.File,exists:!0,remoteAuthority:N.remoteAuthority,transient:N.transient}}return{fileUri:k.URI.file(A),type:r.FileType.File,exists:!0,options:{selection:U?{startLineNumber:U,startColumn:B||1}:void 0}}}else{if(q.isDirectory())return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(k.URI.file(A),q),type:r.FileType.Directory,exists:!0};if(!w.isWindows&&A==="/dev/null")return{fileUri:k.URI.file(A),type:r.FileType.File,exists:!0}}}catch{const N=k.URI.file(A);if(this.C.removeRecentlyOpened([N]),T.ignoreFileNotFound)return{fileUri:N,type:r.FileType.File,exists:!1}}}fb(A,T){const U=A.charCodeAt(0),B=T.remoteAuthority;let q,N;T.gotoLineMode&&({path:A,line:q,column:N}=(0,d.parseLineAndColumnAware)(A)),U!==47&&((0,d.isWindowsDriveLetter)(U)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,d.toSlashes)(A)),A=`/${A}`);const $=k.URI.from({scheme:b.Schemas.vscodeRemote,authority:B,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,re.hasWorkspaceFileExtension)(A))return T.forceOpenWorkspaceAsFile?{fileUri:$,options:{selection:q?{startLineNumber:q,startColumn:N||1}:void 0},remoteAuthority:T.remoteAuthority}:{workspace:(0,ae.getWorkspaceIdentifier)($),remoteAuthority:B};if(T.gotoLineMode||g.posix.basename(A).indexOf(".")!==-1)return{fileUri:$,options:{selection:q?{startLineNumber:q,startColumn:N||1}:void 0},remoteAuthority:B}}return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)($),remoteAuthority:B}}gb(A){const T=this.z.getValue("window"),U=T?.openFoldersInNewWindow||"default",B=T?.openFilesInNewWindow||"off";let q=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(U==="on"||U==="off")&&(q=U==="on");let N=!1;return A.forceNewWindow||A.forceReuseWindow?N=!!A.forceNewWindow&&!A.forceReuseWindow:(w.isMacintosh?A.context===1&&(N=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!A.cli.extensionDevelopmentPath&&(B==="on"||B==="off")&&(N=B==="on")),{openFolderInNewWindow:!!q,openFilesInNewWindow:N}}async openExtensionDevelopmentHostWindow(A,T){const U=(0,K.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(U)return this.v.reload(U,T.cli),U.focus(),[U];let B=T.cli["folder-uri"]||[],q=T.cli["file-uri"]||[],N=T.cli._;if(!N.length&&!B.length&&!q.length&&!T.cli.extensionTestsPath){const oe=this.j.state.lastPluginDevelopmentHostWindow,le=oe?.workspace??oe?.folderUri;le&&(k.URI.isUri(le)?le.scheme===b.Schemas.file?N=[le.fsPath]:B=[le.toString()]:le.configPath.scheme===b.Schemas.file?N=[(0,u.originalFSPath)(le.configPath)]:q=[le.configPath.toString()])}let $=T.remoteAuthority;for(const oe of A)if(oe.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const le=k.URI.parse(oe),be=(0,O.getRemoteAuthority)(le);be&&($?(0,u.isEqualAuthority)(be,$)||this.m.error("more than one extension development path authority"):$=be)}N=N.filter(oe=>{const le=k.URI.file(oe);return(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),le)?!1:(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(le),$)}),B=B.filter(oe=>{const le=this.Y(oe);return le&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),le)?!1:le?(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(le),$):!1}),q=q.filter(oe=>{const le=this.Y(oe);return le&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),le)?!1:le?(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(le),$):!1}),T.cli._=N,T.cli["folder-uri"]=B,T.cli["file-uri"]=q;const J={context:T.context,cli:T.cli,forceNewWindow:!0,forceEmpty:!N.length&&!B.length&&!q.length,userEnv:T.userEnv,noRecentEntry:!0,waitMarkerFileURI:T.waitMarkerFileURI,remoteAuthority:$,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile};return this.open(J)}async hb(A){const T=this.z.getValue("window"),U=this.getLastActiveWindow(),B=U?.profile??this.u.defaultProfile;let q;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(q=A.windowToUse||U,q&&q.focus());const N={...this.t.args,...A.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,g.join)(this.t.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.u.profiles,profile:B},homeDir:this.t.userHome.fsPath,tmpDir:this.t.tmpDir.fsPath,userDataDir:this.t.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.l,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.m.getLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.t.logsPath,product:f.default,isInitialStartup:A.initialStartup,perfMarks:(0,p.getMarks)(),os:{release:(0,n.release)(),hostname:(0,n.hostname)()},zoomLevel:typeof T?.zoomLevel=="number"?T.zoomLevel:void 0,autoDetectHighContrast:T?.autoDetectHighContrast??!0,autoDetectColorScheme:T?.autoDetectColorScheme??!1,accessibilitySupport:I.app.accessibilitySupportEnabled,colorScheme:this.L.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn};if(q){const $=q.config;!N.extensionDevelopmentPath&&$?.extensionDevelopmentPath&&(N.extensionDevelopmentPath=$.extensionDevelopmentPath,N.extensionDevelopmentKind=$.extensionDevelopmentKind,N["enable-proposed-api"]=$["enable-proposed-api"],N.verbose=$.verbose,N["inspect-extensions"]=$["inspect-extensions"],N["inspect-brk-extensions"]=$["inspect-brk-extensions"],N.debugId=$.debugId,N.extensionEnvironment=$.extensionEnvironment,N["extensions-dir"]=$["extensions-dir"],N["disable-extensions"]=$["disable-extensions"]),N.loggers=$?.loggers??N.loggers}else{const $=this.j.getNewWindowState(N);(0,p.mark)("code/willCreateCodeWindow");const J=q=this.F.createInstance(H.CodeWindow,{state:$,extensionDevelopmentPath:N.extensionDevelopmentPath,isExtensionTestHost:!!N.extensionTestsPath});(0,p.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(J),lt.a.push(J),this.b.fire(J),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,h.once)(J.onDidSignalReady)(()=>this.c.fire(J)),(0,h.once)(J.onDidClose)(()=>this.kb(J)),(0,h.once)(J.onDidDestroy)(()=>this.f.fire(J)),J.onDidTriggerSystemContextMenu(({x:le,y:be})=>this.h.fire({window:J,x:le,y:be}));const oe=(0,m.assertIsDefined)(J.win?.webContents);oe.removeAllListeners("devtools-reload-page"),oe.on("devtools-reload-page",()=>this.v.reload(J)),this.v.registerWindow(J)}return N.windowId=q.id,q.isReady?this.v.unload(q,4).then(async $=>{$||await this.ib(q,N,A,B)}):await this.ib(q,N,A,B),q}async ib(A,T,U,B){if(T.extensionDevelopmentPath||((0,re.isWorkspaceIdentifier)(T.workspace)?T.backupPath=this.w.registerWorkspaceBackup({workspace:T.workspace,remoteAuthority:T.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(T.workspace)?T.backupPath=this.w.registerFolderBackup({folderUri:T.workspace.uri,remoteAuthority:T.remoteAuthority}):T.backupPath=this.w.registerEmptyWindowBackup({backupFolder:U.emptyWindowBackupInfo?.backupFolder??(0,ae.createEmptyWorkspaceIdentifier)().id,remoteAuthority:T.remoteAuthority})),this.u.isEnabled()){const q=T.workspace??(0,re.toWorkspaceIdentifier)(T.backupPath,!1),N=this.jb(U,q,B),$=N instanceof Promise?await N:N;T.profiles.profile=$,T.extensionDevelopmentPath||await this.u.setProfileForWorkspace(q,$)}A.load(T)}jb(A,T,U){return A.forceProfile?this.u.profiles.find(B=>B.name===A.forceProfile)??this.u.createNamedProfile(A.forceProfile):A.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(T)??U}kb(A){const T=lt.a.indexOf(A);lt.a.splice(T,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=I.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.mb(this.getWindows())}lb(A){return this.mb(this.getWindows().filter(T=>(0,u.isEqualAuthority)(T.remoteAuthority,A)))}mb(A){const T=Math.max.apply(Math,A.map(U=>U.lastFocusTime));return A.find(U=>U.lastFocusTime===T)}sendToFocused(A,...T){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,D.CancellationToken.None,...T)}sendToAll(A,T,U){for(const B of this.getWindows())U&&U.indexOf(B.id)>=0||B.sendWhenReady(A,D.CancellationToken.None,T)}getWindows(){return lt.a}getWindowCount(){return lt.a.length}getWindowById(A){const T=this.getWindows().filter(U=>U.id===A);return(0,C.firstOrDefault)(T)}getWindowByWebContents(A){const T=I.BrowserWindow.fromWebContents(A);if(!!T)return this.getWindowById(T.id)}};se.a=[],se=we([_(2,o.ILogService),_(3,z.ILoggerMainService),_(4,j.IStateMainService),_(5,F.IPolicyService),_(6,i.IEnvironmentMainService),_(7,W.IUserDataProfilesMainService),_(8,l.ILifecycleMainService),_(9,L.IBackupMainService),_(10,t.IConfigurationService),_(11,fe.IWorkspacesHistoryMainService),_(12,ge.IWorkspacesManagementMainService),_(13,s.IInstantiationService),_(14,c.IDialogMainService),_(15,r.IFileService),_(16,y.IProductService),_(17,M.IProtocolMainService),_(18,V.IThemeMainService)],se),e.WindowsMainService=se}),define(ee[281],te([0,1,62,30,78,53]),function(x,e,I,R,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(d,h,S,v){this.a=d,this.b=h,this.c=S,this.d=v,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(d,h){const S=this.b.getWindowById(d);if(S)return this.a.enterWorkspace(S,this.b.getWindows(),h)}createUntitledWorkspace(d,h,S){return this.a.createUntitledWorkspace(h,S)}deleteUntitledWorkspace(d,h){return this.a.deleteUntitledWorkspace(h)}getWorkspaceIdentifier(d,h){return this.a.getWorkspaceIdentifier(h)}getRecentlyOpened(d){return this.c.getRecentlyOpened()}addRecentlyOpened(d,h){return this.c.addRecentlyOpened(h)}removeRecentlyOpened(d,h){return this.c.removeRecentlyOpened(h)}clearRecentlyOpened(d){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};D=we([_(0,C.IWorkspacesManagementMainService),_(1,R.IWindowsMainService),_(2,n.IWorkspacesHistoryMainService),_(3,I.IBackupMainService)],D),e.WorkspacesMainService=D}),define(ee[282],te([0,1,14,42,26,17,45,13,32,49,43,37,2,15,9,4,10,7,31,136,47,150,105,255,153,62,273,18,74,185,87,121,57,108,208,28,61,112,198,221,199,260,109,200,201,16,212,89,73,6,88,274,234,257,21,5,279,58,19,55,267,91,34,263,95,92,24,239,114,51,48,246,247,275,248,276,117,250,251,252,253,261,30,280,262,29,96,78,281,53,256,38,220,52,230,56,77,119,265,271,269,8,115,264,215,64]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u,m,k,E,L,t,c,i,r,s,l,o,f,y,M,O,j,G,H,K,ne,re,ae,fe,ge,V,F,W,z,X,ie,se,Q,A,T,U,B,q,N,$,J,oe,le,be,Le,Te,Ae,pe,ve,Ce,Me,Z,ue,de,Pe,Re,We,Fe,He,Ue,qe,Ke,Be,xe,Y,ce,he,me,ye,Oe,$e,tt,Qe,Ge,et,it,ot,ut,Dt,Ct,Rt,Mt,Lt,At,gt,Ot,Tt,Ft,Ut){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let mt=class extends b.Disposable{constructor(ke,Ie,Se,Ee,De,Ne,Je,Ye,ze,je,Ve){super(),this.c=ke,this.f=Ie,this.g=Se,this.h=Ee,this.i=De,this.j=Ne,this.k=Je,this.l=Ye,this.m=ze,this.n=je,this.p=Ve,this.r(),this.s()}r(){const ke=ze=>ze?.startsWith(`${g.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);I.session.defaultSession.setPermissionRequestHandler((ze,je,Ve,Xe)=>ke(Xe.requestingUrl)?Ve(Ie.has(je)):Ve(!1)),I.session.defaultSession.setPermissionCheckHandler((ze,je,Ve,Xe)=>ke(Xe.requestingUrl)?Ie.has(je):!1);const Se=new Set([g.Schemas.file,g.Schemas.vscodeFileResource,g.Schemas.vscodeRemoteResource,"devtools"]),Ee=ze=>{for(let je=ze;je;je=je.parent)if(je.url.startsWith(`${g.Schemas.vscodeWebview}://`))return!0;return!1},De=ze=>ze.resourceType==="xhr"||Ee(ze.frame),Ne=ze=>{const je=ze.frame;if(!je||!this.a)return!1;const Ve=I.BrowserWindow.getAllWindows();for(const Xe of Ve)if(je.processId===Xe.webContents.mainFrame.processId)return!0;return!1},Je=(ze,je)=>{if(ze.path!=="/index.html")return!0;const Ve=je.frame;if(!Ve||!this.a)return!1;for(const Xe of this.a.getWindows())if(Xe.win&&Ve.processId===Xe.win.webContents.mainFrame.processId)return!0;return!1};I.session.defaultSession.webRequest.onBeforeRequest((ze,je)=>{const Ve=u.URI.parse(ze.url);return Ve.scheme===g.Schemas.vscodeWebview&&!Je(Ve,ze)?(this.h.error("Blocked vscode-webview request",ze.url),je({cancel:!0})):Ve.scheme===g.Schemas.vscodeFileResource&&!Ne(ze)?(this.h.error("Blocked vscode-file request",ze.url),je({cancel:!0})):Ve.path.endsWith(".svg")&&!Se.has(Ve.scheme)?je({cancel:!De(ze)}):je({cancel:!1})}),I.session.defaultSession.webRequest.onHeadersReceived((ze,je)=>{const Ve=ze.responseHeaders,Xe=Ve["content-type"]||Ve["Content-Type"];if(Xe&&Array.isArray(Xe)){const Ze=u.URI.parse(ze.url);if(Ze.path.endsWith(".svg")&&Se.has(Ze.scheme))return Ve["Content-Type"]=["image/svg+xml"],je({cancel:!1,responseHeaders:Ve});if(!Ze.path.endsWith(g.Schemas.vscodeRemoteResource)&&Xe.some(st=>st.toLowerCase().includes("image/svg")))return je({cancel:!De(ze)})}return je({cancel:!1})});const Ye=I.session.defaultSession;typeof Ye.setCodeCachePath=="function"&&this.i.codeCachePath&&Ye.setCodeCachePath((0,p.join)(this.i.codeCachePath,"chrome"))}s(){(0,P.setUnexpectedErrorHandler)(Se=>this.u(Se)),process.on("uncaughtException",Se=>(0,P.onUnexpectedError)(Se)),process.on("unhandledRejection",Se=>(0,P.onUnexpectedError)(Se)),this.j.onWillShutdown(()=>this.dispose()),(0,k.registerContextMenuListener)(),I.app.on("accessibility-support-changed",(Se,Ee)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Ee)}),I.app.on("activate",async(Se,Ee)=>{this.h.trace("app#activate"),Ee||await this.a?.openEmptyWindow({context:1})}),I.app.on("web-contents-created",(Se,Ee)=>{Ee.on("will-navigate",De=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),Ee.setWindowOpenHandler(({url:De})=>(this.b?.openExternal(void 0,De),{action:"deny"}))});let ke=[],Ie;I.app.on("open-file",(Se,Ee)=>{this.h.trace("app#open-file: ",Ee),Se.preventDefault(),ke.push((0,ye.hasWorkspaceFileExtension)(Ee)?{workspaceUri:u.URI.file(Ee)}:{fileUri:u.URI.file(Ee)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:ke,gotoLineMode:!1,preferNewWindow:!0}),ke=[],Ie=void 0},100)}),I.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),R.validatedIpcMain.handle("vscode:fetchShellEnv",Se=>{const Ee=this.a?.getWindowByWebContents(Se.sender);let De,Ne;return Ee?.config?(De=Ee.config,Ne={...process.env,...Ee.config.userEnv}):(De=this.i.args,Ne=process.env),this.M(De,Ne,!1)}),R.validatedIpcMain.handle("vscode:writeNlsFile",(Se,Ee,De)=>{const Ne=this.t([Ee]);if(!Ne||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(Ne,C.VSBuffer.fromString(De))}),R.validatedIpcMain.handle("vscode:readNlsFile",async(Se,...Ee)=>{const De=this.t(Ee);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(De)).value.toString()}),R.validatedIpcMain.on("vscode:toggleDevTools",Se=>Se.sender.toggleDevTools()),R.validatedIpcMain.on("vscode:openDevTools",Se=>Se.sender.openDevTools()),R.validatedIpcMain.on("vscode:reloadWindow",Se=>Se.sender.reload())}t(ke){let Ie;for(const Se of ke)typeof Se=="string"&&(typeof Ie!="string"?Ie=Se:Ie=(0,p.join)(Ie,Se));if(!(typeof Ie!="string"||!(0,p.isAbsolute)(Ie)||!(0,d.isEqualOrParent)(Ie,this.i.cachedLanguagesPath,!w.isLinux)))return u.URI.file(Ie)}u(ke){if(ke){const Ie={message:`[uncaught exception in main]: ${ke.message}`,stack:ke.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.h.error(`[uncaught exception in main]: ${ke}`),ke.stack&&this.h.error(ke.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const ke=this.n.win32AppUserModelId;w.isWindows&&ke&&I.app.setAppUserModelId(ke);try{w.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!I.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&I.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(je){this.h.error(je)}const Ie=new L.Server;this.j.onWillShutdown(je=>{je.reason===2&&Ie.dispose()}),this.h.trace("Resolving machine identifier...");const Se=await(0,Ot.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${Se}`);const{sharedProcess:Ee,sharedProcessReady:De,sharedProcessClient:Ne}=this.D(Se),Je=await this.F(Se,Ee,De);this.B(Je.createInstance(c.ProxyAuthHandler)),this.B(Je.createInstance(Lt.UserDataProfilesHandler)),Je.invokeFunction(je=>this.G(je,Ie,Ne));const Ye=Je.invokeFunction(je=>this.v(je,Ie));this.j.phase=2,await Je.invokeFunction(je=>this.H(je,Ye)),this.j.phase=3,Je.invokeFunction(je=>this.I(je,Ee)),this.B(new gt.RunOnceScheduler(()=>{this.B((0,gt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(ke,Ie){const Se=this.a=ke.get(ce.IWindowsMainService),Ee=ke.get(Ue.IURLService),De=this.b=ke.get(J.INativeHostMainService),Ne=this;Ee.registerHandler({async handleURL(Xe,Ze){return Ne.C(Se,Ee,Xe,Ze)}});const Je=this.B(new me.ActiveWindowManager({onDidOpenWindow:De.onDidOpenWindow,onDidFocusWindow:De.onDidFocusWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),Ye=new E.StaticRouter(Xe=>Je.getActiveClientId().then(Ze=>Xe===Ze)),ze=new qe.URLHandlerRouter(Ye,this.h),je=Ie.getChannel("urlHandler",ze);Ee.registerHandler(new qe.URLHandlerChannelClient(je));const Ve=this.w();return this.B(new Be.ElectronURLListener(Ve?.urls,Ee,Se,this.i,this.n,this.h)),Ve}w(){const ke=this.i.args["open-url"]?this.i.args._urls||[]:[];ke.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",ke);const Ie=global.getOpenUrls()||[];if(Ie.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ie),ke.length+Ie.length===0)return;const Se=[];return{urls:[...ke,...Ie].map(De=>{try{return{uri:u.URI.parse(De),originalUrl:De}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",De);return}}).filter(De=>{if(!De)return!1;if(this.y(De.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",De.uri.toString(!0)),!1;const Ne=this.z(De.uri);return Ne?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",De.uri.toString(!0),Ne),Se.push(Ne),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",De.uri.toString(!0)),!0)}),openables:Se}}y(ke){return!!(ke.authority===g.Schemas.file&&w.isWindows&&I.dialog.showMessageBoxSync({title:this.n.nameLong,type:"question",buttons:[(0,v.mnemonicButtonLabel)((0,i.localize)(0,null)),(0,v.mnemonicButtonLabel)((0,i.localize)(1,null))],defaultId:0,cancelId:1,message:(0,i.localize)(2,null,(0,v.getPathLabel)(ke,{os:w.OS,tildify:this.i}),this.n.nameShort),detail:(0,i.localize)(3,null),noLink:!0})===1)}z(ke){if(!!ke.path){if(ke.authority===g.Schemas.file){const Ie=u.URI.file(ke.fsPath);return(0,ye.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(ke.authority===g.Schemas.vscodeRemote){const Ie=ke.path.indexOf(p.posix.sep,1);if(Ie!==-1){const Se=ke.path.substring(1,Ie),Ee=ke.path.substring(Ie),De=u.URI.from({scheme:g.Schemas.vscodeRemote,authority:Se,path:Ee,query:ke.query,fragment:ke.fragment});return(0,ye.hasWorkspaceFileExtension)(Ee)?{workspaceUri:De}:/:[\d]+$/.test(Ee)?{fileUri:De}:{folderUri:De}}}}}async C(ke,Ie,Se,Ee){if(this.h.trace("app#handleProtocolUrl():",Se.toString(!0),Ee),Se.scheme===this.n.urlProtocol&&Se.path==="workspace"&&(Se=Se.with({authority:"file",path:u.URI.parse(Se.query).path,query:""})),this.y(Se))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",Se.toString(!0)),!0;let De=!1;const Ne=new URLSearchParams(Se.query);Ne.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Se.toString(!0)),Ne.delete("windowId"),Se=Se.with({query:Ne.toString()}),De=!0):w.isMacintosh&&ke.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Se.toString(!0)),De=!0);const Je=Ne.get("continueOn");Je!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Se.toString(!0)),Ne.delete("continueOn"),Se=Se.with({query:Ne.toString()}),this.i.continueOn=Je??void 0);const Ye=this.z(Se);if(Ye){this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Ye,Se.toString(!0));const[ze]=await ke.open({context:5,cli:{...this.i.args},urisToOpen:[Ye],forceNewWindow:De,gotoLineMode:!0});return ze.focus(),!0}if(De){this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Se.toString(!0));const[ze]=await ke.open({context:5,cli:{...this.i.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,le.getRemoteAuthority)(Se)});return await ze.ready(),Ie.open(Se,Ee)}return this.h.trace("app#handleProtocolUrl(): not handled",Se.toString(!0),Ee),!1}D(ke){const Ie=this.B(this.g.createInstance(be.SharedProcess,ke,this.f)),Se=(async()=>{this.h.trace("Main->SharedProcess#connect");const De=await Ie.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new t.Client(De,"main")})(),Ee=(async()=>(await Ie.whenReady(),Se))();return{sharedProcess:Ie,sharedProcessReady:Ee,sharedProcessClient:Se}}async F(ke,Ie,Se){const Ee=new A.ServiceCollection;switch(process.platform){case"win32":Ee.set(de.IUpdateService,new se.SyncDescriptor(He.Win32UpdateService));break;case"linux":w.isLinuxSnap?Ee.set(de.IUpdateService,new se.SyncDescriptor(Fe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ee.set(de.IUpdateService,new se.SyncDescriptor(We.LinuxUpdateService));break;case"darwin":Ee.set(de.IUpdateService,new se.SyncDescriptor(Re.DarwinUpdateService));break}Ee.set(ce.IWindowsMainService,new se.SyncDescriptor(he.WindowsMainService,[ke,this.f],!1));const De=new O.DialogMainService(this.h);Ee.set(O.IDialogMainService,De),Ee.set(B.ILaunchMainService,new se.SyncDescriptor(B.LaunchMainService,void 0,!1)),Ee.set(M.IDiagnosticsMainService,new se.SyncDescriptor(M.DiagnosticsMainService,void 0,!1)),Ee.set(y.IDiagnosticsService,E.ProxyChannel.toService((0,E.getDelayedChannel)(Se.then(Ye=>Ye.getChannel("diagnostics"))))),Ee.set(T.IIssueMainService,new se.SyncDescriptor(T.IssueMainService,[this.f])),Ee.set(j.IEncryptionMainService,new se.SyncDescriptor(G.EncryptionMainService,[ke])),Ee.set(U.IKeyboardLayoutMainService,new se.SyncDescriptor(U.KeyboardLayoutMainService)),Ee.set(J.INativeHostMainService,new se.SyncDescriptor(J.NativeHostMainService,[Ie],!1)),Ee.set(o.ICredentialsMainService,new se.SyncDescriptor(Ge.CredentialsNativeMainService)),Ee.set(xe.IWebviewManagerService,new se.SyncDescriptor(Y.WebviewMainService)),Ee.set($.IMenubarMainService,new se.SyncDescriptor($.MenubarMainService)),Ee.set(re.IExtensionUrlTrustService,new se.SyncDescriptor(ae.ExtensionUrlTrustService)),Ee.set(fe.IExtensionHostStarter,new se.SyncDescriptor(ge.ExtensionHostStarter)),Ee.set(pe.IStorageMainService,new se.SyncDescriptor(pe.StorageMainService)),Ee.set(pe.IApplicationStorageMainService,new se.SyncDescriptor(pe.ApplicationStorageMainService)),w.isWindows?Ee.set(V.IExternalTerminalMainService,new se.SyncDescriptor(F.WindowsExternalTerminalService)):w.isMacintosh?Ee.set(V.IExternalTerminalMainService,new se.SyncDescriptor(F.MacExternalTerminalService)):w.isLinux&&Ee.set(V.IExternalTerminalMainService,new se.SyncDescriptor(F.LinuxExternalTerminalService));const Ne=new s.BackupMainService(this.i,this.k,this.h,this.l);Ee.set(r.IBackupMainService,Ne);const Je=new Qe.WorkspacesManagementMainService(this.i,this.h,this.p,Ne,De,this.n);if(Ee.set(Qe.IWorkspacesManagementMainService,Je),Ee.set(Oe.IWorkspacesService,new se.SyncDescriptor(tt.WorkspacesMainService,void 0,!1)),Ee.set($e.IWorkspacesHistoryMainService,new se.SyncDescriptor($e.WorkspacesHistoryMainService,void 0,!1)),Ee.set(Ue.IURLService,new se.SyncDescriptor(Ke.NativeURLService,void 0,!1)),(0,ue.supportsTelemetry)(this.n,this.i)){const Ye=(0,ue.isInternalTelemetry)(this.n,this.k),ze=(0,E.getDelayedChannel)(Se.then(st=>st.getChannel("telemetryAppender"))),je=new Me.TelemetryAppenderClient(ze),Ve=(0,ve.resolveCommonProperties)(this.m,(0,n.release)(),(0,n.hostname)(),process.arch,this.n.commit,this.n.version,ke,Ye,this.i.installSourcePath),Xe=(0,ue.getPiiPathsFromEnvironment)(this.i),Ze={appenders:[je],commonProperties:Ve,piiPaths:Xe,sendErrorTelemetry:!0};Ee.set(Ce.ITelemetryService,new se.SyncDescriptor(Z.TelemetryService,[Ze],!1))}else Ee.set(Ce.ITelemetryService,ue.NullTelemetryService);return Ee.set(Ct.IExtensionsProfileScannerService,new se.SyncDescriptor(Tt.ExtensionsProfileScannerService,void 0,!0)),Ee.set(Rt.IExtensionsScannerService,new se.SyncDescriptor(Mt.ExtensionsScannerService,void 0,!0)),await gt.Promises.settled([Ne.initialize(),Je.initialize()]),this.g.createChild(Ee)}G(ke,Ie,Se){const Ee=E.ProxyChannel.fromService(ke.get(B.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Ee);const De=E.ProxyChannel.fromService(ke.get(M.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",De);const Ne=new it.PolicyChannel(ke.get(et.IPolicyService));Ie.registerChannel("policy",Ne),Se.then(_e=>_e.registerChannel("policy",Ne));const Je=this.m.getProvider(g.Schemas.file);(0,a.assertType)(Je instanceof ie.DiskFileSystemProvider);const Ye=new X.DiskFileSystemProviderChannel(Je,this.h,this.i);Ie.registerChannel(W.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Ye),Se.then(_e=>_e.registerChannel(W.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Ye));const ze=E.ProxyChannel.fromService(ke.get(ot.IUserDataProfilesMainService));Ie.registerChannel("userDataProfiles",ze),Se.then(_e=>_e.registerChannel("userDataProfiles",ze));const je=new ut.RequestChannel(ke.get(Dt.IRequestService));Se.then(_e=>_e.registerChannel("request",je));const Ve=new Pe.UpdateChannel(ke.get(de.IUpdateService));Ie.registerChannel("update",Ve);const Xe=E.ProxyChannel.fromService(ke.get(T.IIssueMainService));Ie.registerChannel("issue",Xe);const Ze=E.ProxyChannel.fromService(ke.get(j.IEncryptionMainService));Ie.registerChannel("encryption",Ze);const st=E.ProxyChannel.fromService(ke.get(o.ICredentialsMainService));Ie.registerChannel("credentials",st);const rt=E.ProxyChannel.fromService(ke.get(Le.ISignService));Ie.registerChannel("sign",rt);const ht=E.ProxyChannel.fromService(ke.get(U.IKeyboardLayoutMainService));Ie.registerChannel("keyboardLayout",ht),this.b=ke.get(J.INativeHostMainService);const yt=E.ProxyChannel.fromService(this.b);Ie.registerChannel("nativeHost",yt),Se.then(_e=>_e.registerChannel("nativeHost",yt));const Wt=E.ProxyChannel.fromService(ke.get(Oe.IWorkspacesService));Ie.registerChannel("workspaces",Wt);const Nt=E.ProxyChannel.fromService(ke.get($.IMenubarMainService));Ie.registerChannel("menubar",Nt);const jt=E.ProxyChannel.fromService(ke.get(Ue.IURLService));Ie.registerChannel("url",jt);const Bt=E.ProxyChannel.fromService(ke.get(re.IExtensionUrlTrustService));Ie.registerChannel("extensionUrlTrust",Bt);const $t=E.ProxyChannel.fromService(ke.get(xe.IWebviewManagerService));Ie.registerChannel("webview",$t);const St=this.B(new Ae.StorageDatabaseChannel(this.h,ke.get(pe.IStorageMainService)));Ie.registerChannel("storage",St),Se.then(_e=>_e.registerChannel("storage",St));const zt=this.B(new At.ProfileStorageChangesListenerChannel(ke.get(pe.IStorageMainService),ke.get(ot.IUserDataProfilesMainService),this.h));Se.then(_e=>_e.registerChannel("profileStorageListener",zt));const qt=E.ProxyChannel.fromService(ke.get(V.IExternalTerminalMainService));Ie.registerChannel("externalTerminal",qt);const Et=new Ft.LoggerChannel(ke.get(Ut.ILoggerMainService));Ie.registerChannel("logger",Et),Se.then(_e=>_e.registerChannel("logger",Et));const Ht=new f.ElectronExtensionHostDebugBroadcastChannel(ke.get(ce.IWindowsMainService));Ie.registerChannel("extensionhostdebugservice",Ht);const Vt=E.ProxyChannel.fromService(ke.get(fe.IExtensionHostStarter));Ie.registerChannel(fe.ipcExtensionHostStarterChannelName,Vt)}async H(ke,Ie){const Se=this.a=ke.get(ce.IWindowsMainService),Ee=(0,K.isLaunchedFromCli)(process.env)?0:4,De=this.i.args;if(Ie){if(Ie.openables.length>0)return Se.open({context:Ee,cli:De,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const rt of Ie.urls){const ht=new URLSearchParams(rt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),rt.originalUrl=rt.uri.toString(!0),rt.uri=rt.uri.with({query:ht.toString()}),Se.open({context:Ee,cli:De,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ne=global.macOpenFiles,Je=De._.length,Ye=!!De["folder-uri"],ze=!!De["file-uri"],je=De["skip-add-to-recently-opened"]===!0,Ve=De.wait&&De.waitMarkerFilePath?u.URI.file(De.waitMarkerFilePath):void 0,Xe=De.remote||void 0,Ze=De.profile,st=De["profile-temp"];if(!Je&&!Ye&&!ze){if(De["new-window"]||Ze||st)return Se.open({context:Ee,cli:De,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:je,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Xe,forceProfile:Ze,forceTempProfile:st});if(Ne.length)return Se.open({context:1,cli:De,urisToOpen:Ne.map(rt=>(0,ye.hasWorkspaceFileExtension)(rt)?{workspaceUri:u.URI.file(rt)}:{fileUri:u.URI.file(rt)}),noRecentEntry:je,waitMarkerFileURI:Ve,initialStartup:!0})}return Se.open({context:Ee,cli:De,forceNewWindow:De["new-window"]||!Je&&De["unity-launch"],diffMode:De.diff,mergeMode:De.merge,noRecentEntry:je,waitMarkerFileURI:Ve,gotoLineMode:De.goto,initialStartup:!0,remoteAuthority:Xe,forceProfile:Ze,forceTempProfile:st})}I(ke,Ie){const Se=ke.get(Ce.ITelemetryService),Ee=ke.get(de.IUpdateService);this.L(Se,Ie),this.J(),I.protocol.registerHttpProtocol(g.Schemas.vscodeRemoteResource,(De,Ne)=>{Ne({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})}),(Ee instanceof He.Win32UpdateService||Ee instanceof We.LinuxUpdateService||Ee instanceof Re.DarwinUpdateService)&&Ee.initialize(),this.M(this.i.args,process.env,!0),this.N()}async J(){const ke=this.n.win32MutexName;if(w.isWindows&&ke)try{const Ie=await new Promise((Ee,De)=>{x(["windows-mutex"],Ee,De)}),Se=new Ie.Mutex(ke);(0,h.once)(this.j.onWillShutdown)(()=>Se.release())}catch(Ie){this.h.error(Ie)}}L(ke,Ie){let Se=!1;(0,h.once)(this.j.onWillShutdown)(()=>Se=!0),this.B(Ie.onDidError(({type:Ee,details:De})=>{let Ne;switch(Ee){case 1:Ne="SharedProcess: detected unresponsive window";break;case 2:Ne=`SharedProcess: renderer process gone (detail: ${De?.reason??"<unknown>"}, code: ${De?.exitCode??"<unknown>"})`;break;case 3:Ne=`SharedProcess: failed to load (detail: ${De?.reason??"<unknown>"}, code: ${De?.exitCode??"<unknown>"})`;break}(0,P.onUnexpectedError)(new Error(Ne)),ke.publicLog2("sharedprocesserror",{type:Ee,reason:De?.reason,code:De?.exitCode,visible:Ie.isVisible(),shuttingdown:Se})}))}async M(ke,Ie,Se){try{return await(0,ne.getResolvedShellEnv)(this.k,this.h,ke,Ie)}catch(Ee){const De=(0,D.toErrorMessage)(Ee);Se?this.a?.sendToFocused("vscode:showResolveShellEnvError",De):this.h.error(De)}return{}}async N(){try{const Ie=(await this.m.readFile(this.i.argvResource)).value.toString(),Se=JSON.parse((0,S.stripComments)(Ie)),De=(0,ue.getTelemetryLevel)(this.k)>=1;if(Se["enable-crash-reporter"]===void 0){const Ne=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${De},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,m.generateUuid)()}"`,"}"],Je=Ie.substring(0,Ie.length-2).concat(`,
`,Ne.join(`
`));await this.m.writeFile(this.i.argvResource,C.VSBuffer.fromString(Je))}else{const Ne=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${De},`);Ne!==Ie&&await this.m.writeFile(this.i.argvResource,C.VSBuffer.fromString(Ne))}}catch(ke){this.h.error(ke)}}};mt=we([_(2,Q.IInstantiationService),_(3,N.ILogService),_(4,H.IEnvironmentMainService),_(5,q.ILifecycleMainService),_(6,l.IConfigurationService),_(7,Te.IStateMainService),_(8,z.IFileService),_(9,oe.IProductService),_(10,ot.IUserDataProfilesMainService)],mt),e.CodeApplication=mt}),define(ee[283],te([0,1,38,8,290,2,5]),function(x,e,I,R,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let P=class extends I.AbstractPolicyService{constructor(h,S){super(),this.j=h,this.k=S,this.a=new R.Throttler,this.b=this.B(new C.MutableDisposable)}async i(h){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`),await this.a.queue(()=>new Promise((S,v)=>{try{this.b.value=(0,n.createWatcher)(this.k,h,b=>{this.m(b),S()})}catch(b){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",b),v(b)}}))}m(h){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const S in h){const v=h[S];v===void 0?this.g.delete(S):this.g.set(S,v)}this.h.fire(Object.keys(h))}};P=we([_(0,D.ILogService)],P),e.NativePolicyService=P}),define(ee[284],te([0,1,232,8,17,13,2,10,18,33,112,5,231,291]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends D.Disposable{constructor(a,u,m){super(),this.h=a,this.i=u,this.j=m,this.k(),this.B(a.onDidChangeConfiguration(k=>{k.affectsConfiguration("http")&&this.k()}))}k(){const a=this.h.getValue("http");this.a=a?.proxy,this.b=!!a?.proxyStrictSSL,this.f=a?.proxyAuthorization}async request(a,u){this.j.trace("RequestService#request (node) - begin",a.url);const{a:m,b:k}=this;let E;try{E=await(0,S.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(c){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",c))}const L={...process.env,...E},t=a.agent?a.agent:await(0,b.getProxyAgent)(a.url||"",L,{proxyUrl:m,strictSSL:k});a.agent=t,a.strictSSL=k,this.f&&(a.headers={...a.headers||{},"Proxy-Authorization":this.f});try{const c=await this.m(a,u);return this.j.trace("RequestService#request (node) - success",a.url),c}catch(c){throw this.j.trace("RequestService#request (node) - error",a.url,c),c}}async l(a){return((0,I.parse)(a.url).protocol==="https:"?await new Promise((k,E)=>{x(["https"],k,E)}):await new Promise((k,E)=>{x(["http"],k,E)})).request}m(a,u){return R.Promises.withAsyncBody(async(m,k)=>{const E=(0,I.parse)(a.url),L=a.getRawRequest?a.getRawRequest(a):await this.l(a),t={hostname:E.hostname,port:E.port?parseInt(E.port):E.protocol==="https:"?443:80,protocol:E.protocol,path:E.path,method:a.type||"GET",headers:a.headers,agent:a.agent,rejectUnauthorized:(0,P.isBoolean)(a.strictSSL)?a.strictSSL:!0};a.user&&a.password&&(t.auth=a.user+":"+a.password);const c=L(t,i=>{const r=(0,P.isNumber)(a.followRedirects)?a.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)this.m({...a,url:i.headers.location,followRedirects:r-1},u).then(m,k);else{let s=i;!a.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,g.createGunzip)())),m({res:i,stream:(0,n.streamToBufferReadableStream)(s)})}});c.on("error",k),a.timeout&&c.setTimeout(a.timeout),a.isChromiumNetwork&&c.removeHeader("Content-Length"),a.data&&typeof a.data=="string"&&c.write(a.data),c.end(),u.onCancellationRequested(()=>{c.abort(),k(new C.CancellationError)})})}async resolveProxy(a){}};p=we([_(0,d.IConfigurationService),_(1,h.INativeEnvironmentService),_(2,v.ILogService)],p),e.RequestService=p}),define(ee[285],te([0,1,14,284]),function(x,e,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function n(D){return I.net.request}class C extends R.RequestService{request(P,d){return super.request({...P||{},getRawRequest:n,isChromiumNetwork:!0},d)}}e.RequestMainService=C}),define(ee[292],te([0,1,14,41,7,25,8,45,13,32,49,37,15,9,63,4,36,27,23,47,86,282,11,18,225,238,28,61,189,16,210,89,73,206,88,21,213,5,65,19,66,266,116,244,56,285,91,233,34,237,51,68,52,38,283,219,2,39,249,64,214,245]),function(x,e,I,R,n,C,D,P,d,h,S,v,b,g,p,w,a,u,m,k,E,L,t,c,i,r,s,l,o,f,y,M,O,j,G,H,K,ne,re,ae,fe,ge,V,F,W,z,X,ie,se,Q,A,T,U,B,q,N,$,J,oe,le,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Le{main(){try{this.a()}catch(pe){console.error(pe.message),I.app.exit(1)}}async a(){(0,d.setUnexpectedErrorHandler)(Re=>console.error(Re));const[pe,ve,Ce,Me,Z,ue,de,Pe]=this.b();try{try{await this.d(Ce,Pe,Me,Z,de)}catch(Re){throw this.f(Ce,de.nameLong,Re),Re}await pe.invokeFunction(async Re=>{const We=Re.get(ne.ILogService),Fe=Re.get(H.ILifecycleMainService),He=Re.get(f.IFileService),Ue=Re.get(ne.ILoggerService),qe=await this.e(We,Ce,Fe,pe,de,!0);return m.Promises.writeFile(Ce.mainLockfile,String(process.pid)).catch(Ke=>{We.warn(`Error writing main lockfile: ${Ke.stack}`)}),ue.logger=Ue.createLogger(n.URI.file((0,g.join)(Ce.logsPath,"main.log")),{id:"mainLog",name:(0,t.localize)(0,null)}),(0,S.once)(Fe.onWillShutdown)(Ke=>{He.dispose(),Me.dispose(),Ke.join(m.Promises.unlink(Ce.mainLockfile).catch(()=>{}))}),pe.createInstance(L.CodeApplication,qe,ve).startup()})}catch(Re){pe.invokeFunction(this.i,Re)}}b(){const pe=new G.ServiceCollection,ve=new $.DisposableStore;process.once("exit",()=>ve.dispose());const Ce={_serviceBrand:void 0,...re.default};pe.set(ae.IProductService,Ce);const Me=new s.EnvironmentMainService(this.j(),Ce),Z=this.c(Me);pe.set(s.IEnvironmentMainService,Me);const ue=new le.LoggerMainService((0,ne.getLogLevel)(Me));pe.set(le.ILoggerMainService,ue);const de=new K.BufferLogger(ue.getLogLevel()),Pe=ve.add(new be.LogService(de,[new ne.ConsoleMainLogger(ue.getLogLevel())]));pe.set(ne.ILogService,Pe);const Re=new y.FileService(Pe);pe.set(f.IFileService,Re);const We=new M.DiskFileSystemProvider(Pe);Re.registerProvider(b.Schemas.file,We);const Fe=new oe.UriIdentityService(Re);pe.set(J.IUriIdentityService,Fe);const He=new Q.StateMainService(Me,Pe,Re);pe.set(se.IStateMainService,He);const Ue=new U.UserDataProfilesMainService(He,Fe,Me,Re,Pe);pe.set(U.IUserDataProfilesMainService,Ue);const qe=w.isWindows&&Ce.win32RegValueName?ve.add(new q.NativePolicyService(Pe,Ce.win32RegValueName)):Me.policyFile?ve.add(new N.FilePolicyService(Me.policyFile,Re,Pe)):new B.NullPolicyService;pe.set(B.IPolicyService,qe);const Ke=new i.ConfigurationService(Ue.defaultProfile.settingsResource,Re,qe,Pe);return pe.set(c.IConfigurationService,Ke),pe.set(H.ILifecycleMainService,new O.SyncDescriptor(H.LifecycleMainService,void 0,!1)),pe.set(W.IRequestService,new O.SyncDescriptor(z.RequestMainService,void 0,!0)),pe.set(T.IThemeMainService,new O.SyncDescriptor(T.ThemeMainService)),pe.set(X.ISignService,new O.SyncDescriptor(ie.SignService,void 0,!1)),pe.set(V.ITunnelService,new O.SyncDescriptor(F.TunnelService)),pe.set(fe.IProtocolMainService,new ge.ProtocolMainService(Me,Ue,Pe)),[new j.InstantiationService(pe,!0),Z,Me,Ke,He,de,Ce,Ue]}c(pe){const ve={VSCODE_IPC_HOOK:pe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ce=>{const Me=process.env[Ce];typeof Me=="string"&&(ve[Ce]=Me)}),Object.assign(process.env,ve),ve}async d(pe,ve,Ce,Me,Z){await D.Promises.settled([Promise.all([pe.extensionsPath,pe.codeCachePath,pe.logsPath,ve.defaultProfile.globalStorageHome.fsPath,pe.workspaceStorageHome.fsPath,pe.localHistoryHome.fsPath,pe.backupHome].map(ue=>ue?m.Promises.mkdir(ue,{recursive:!0}):void 0)),Me.init(),Ce.initialize()]),ve.init()}async e(pe,ve,Ce,Me,Z,ue){let de;try{(0,p.mark)("code/willStartMainServer"),de=await(0,E.serve)(ve.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),(0,S.once)(Ce.onWillShutdown)(()=>de.dispose())}catch(Pe){if(Pe.code!=="EADDRINUSE")throw this.f(ve,Z.nameLong,Pe),Pe;let Re;try{Re=await(0,E.connect)(ve.mainIPCHandle,"main")}catch(Ue){if(!ue||w.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.g((0,t.localize)(1,null,Z.nameShort),(0,t.localize)(2,null),Z.nameLong),Ue;try{(0,R.unlinkSync)(ve.mainIPCHandle)}catch(qe){throw pe.warn("Could not delete obsolete instance handle",qe),qe}return this.e(pe,ve,Ce,Me,Z,!1)}if(ve.extensionTestsLocationURI&&!ve.debugExtensionHost.break){const Ue=`Running extension tests from the command line is currently only supported if no other instance of ${Z.nameShort} is running.`;throw pe.error(Ue),Re.dispose(),new Error(Ue)}let We;!ve.args.wait&&!ve.args.status&&(We=setTimeout(()=>{this.g((0,t.localize)(3,null,Z.nameShort),(0,t.localize)(4,null),Z.nameLong)},1e4));const Fe=k.ProxyChannel.toService(Re.getChannel("launch"),{disableMarshalling:!0}),He=k.ProxyChannel.toService(Re.getChannel("diagnostics"),{disableMarshalling:!0});if(ve.args.status)return Me.invokeFunction(async()=>{const Ue=new r.DiagnosticsService(A.NullTelemetryService,Z),qe=await He.getMainDiagnostics(),Ke=await He.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ue.getDiagnostics(qe,Ke);throw console.log(Be),new d.ExpectedError});throw w.isWindows&&await this.h(Fe,pe),pe.trace("Sending env to running instance..."),await Fe.start(ve.args,process.env),Re.dispose(),We&&clearTimeout(We),new d.ExpectedError("Sent env to running instance. Terminating...")}if(ve.args.status)throw pe.warn(`Warning: The --status argument can only be used if ${Z.nameShort} is already running. Please run it again after {0} has started.`),new d.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}f(pe,ve,Ce){if(Ce.code==="EACCES"||Ce.code==="EPERM"){const Me=(0,C.coalesce)([pe.userDataPath,pe.extensionsPath,E.XDG_RUNTIME_DIR]).map(Z=>(0,v.getPathLabel)(n.URI.file(Z),{os:w.OS,tildify:pe}));this.g((0,t.localize)(5,null),(0,t.localize)(6,null,(0,P.toErrorMessage)(Ce),Me.join(`
`)),ve)}}g(pe,ve,Ce){I.dialog.showMessageBoxSync({title:Ce,type:"warning",buttons:[(0,v.mnemonicButtonLabel)((0,t.localize)(7,null))],message:pe,detail:ve,defaultId:0,noLink:!0})}async h(pe,ve){if(w.isWindows){const Ce=await pe.getMainProcessId();ve.trace("Sending some foreground love to the running instance:",Ce);try{(await new Promise((Me,Z)=>{x(["windows-foreground-love"],Me,Z)})).allowSetForegroundWindow(Ce)}catch(Me){ve.error(Me)}}}i(pe,ve){const Ce=pe.get(ne.ILogService),Me=pe.get(H.ILifecycleMainService);let Z=0;ve&&(ve.isExpected?ve.message&&Ce.trace(ve.message):(Z=1,ve.stack?Ce.error(ve.stack):Ce.error(`Startup error: ${ve.toString()}`))),Me.kill(Z)}j(){const pe=this.k((0,l.parseMainProcessArgv)(process.argv));if(pe.wait&&!pe.waitMarkerFilePath){const ve=(0,o.createWaitMarkerFileSync)(pe.verbose);ve&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",ve),pe.waitMarkerFilePath=ve)}return pe}k(pe){if(pe["open-url"]&&(pe._urls=pe._,pe._=[]),!pe.remote){const ve=this.l(pe._,pe.goto);pe._=ve}return pe}l(pe,ve){const Ce=(0,a.cwd)(),Me=pe.map(de=>{let Pe=String(de),Re;ve&&(Re=(0,h.parseLineAndColumnAware)(Pe),Pe=Re.path),Pe&&(Pe=this.m(Ce,Pe));const We=(0,h.sanitizeFilePath)(Pe,Ce),Fe=(0,g.basename)(We);return Fe&&!(0,h.isValidBasename)(Fe)?null:ve&&Re?(Re.path=We,this.n(Re)):We}),Z=w.isWindows||w.isMacintosh,ue=(0,C.distinct)(Me,de=>de&&Z?de.toLowerCase():de||"");return(0,C.coalesce)(ue)}m(pe,ve){return w.isWindows&&(ve=(0,u.rtrim)(ve,'"')),ve=(0,u.trim)((0,u.trim)(ve," "),"	"),w.isWindows&&(ve=(0,g.resolve)(pe,ve),ve=(0,u.rtrim)(ve,".")),ve}n(pe){const ve=[pe.path];return typeof pe.line=="number"&&ve.push(String(pe.line)),typeof pe.column=="number"&&ve.push(String(pe.column)),ve.join(":")}}new Le().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f1b09237cd400d92987cf7a9681995e8011ef54c/core/vs/code/electron-main/main.js.map
