/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/platform/environment/common/environment","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/base/common/uuid","vs/base/common/strings","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],_=function(x){for(var e=[],T=0,R=x.length;T<R;T++)e[T]=Q[x[T]];return e};define(Q[49],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function T(k){return(w,g,l)=>{let b=null,m=null;if(typeof l.value=="function"?(b="value",m=l.value):typeof l.get=="function"&&(b="get",m=l.get),!m)throw new Error("not supported");l[b]=k(m,g)}}function R(k,w,g){let l=null,b=null;if(typeof g.value=="function"?(l="value",b=g.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(l="get",b=g.get),!b)throw new Error("not supported");const m=`$memoize$${w}`;g[l]=function(...d){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,d)}),this[m]}}e.memoize=R;function P(k,w,g){return T((l,b)=>{const m=`$debounce$${b}`,d=`$debounce$result$${b}`;return function(...I){this[d]||(this[d]=g?g():void 0),clearTimeout(this[m]),w&&(this[d]=w(this[d],...I),I=[this[d]]),this[m]=setTimeout(()=>{l.apply(this,I),this[d]=g?g():void 0},k)}})}e.debounce=P;function O(k,w,g){return T((l,b)=>{const m=`$throttle$timer$${b}`,d=`$throttle$result$${b}`,I=`$throttle$lastRun$${b}`,v=`$throttle$pending$${b}`;return function(...A){if(this[d]||(this[d]=g?g():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),w&&(this[d]=w(this[d],...A)),this[v])return;const c=this[I]+k;c<=Date.now()?(this[I]=Date.now(),l.apply(this,[this[d]]),this[d]=g?g():void 0):(this[v]=!0,this[m]=setTimeout(()=>{this[v]=!1,this[I]=Date.now(),l.apply(this,[this[d]]),this[d]=g?g():void 0},c-Date.now()))}})}e.throttle=O}),define(Q[70],_([0,1,7]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function R(g,l){if(!g)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=R;function P(g,l="Unreachable"){throw new Error(l)}e.assertNever=P;function O(g){if(!g)throw new T.BugIndicatingError("Assertion Failed")}e.assert=O;function k(g){if(!g()){debugger;g(),(0,T.onUnexpectedError)(new T.BugIndicatingError("Assertion Failed"))}}e.assertFn=k;function w(g,l){let b=0;for(;b<g.length-1;){const m=g[b],d=g[b+1];if(!l(m,d))return!1;b++}return!0}e.checkAdjacentItems=w}),define(Q[50],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var T;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(T=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O=e.ParseOptions||(e.ParseOptions={}));function k(t,s=!1){let i=0;const n=t.length;let r="",o=0,a=16,h=0;function u(ne){let ae=0,ue=0;for(;ae<ne;){const se=t.charCodeAt(i);if(se>=48&&se<=57)ue=ue*16+se-48;else if(se>=65&&se<=70)ue=ue*16+se-65+10;else if(se>=97&&se<=102)ue=ue*16+se-97+10;else break;i++,ae++}return ae<ne&&(ue=-1),ue}function D(ne){i=ne,r="",o=0,a=16,h=0}function F(){const ne=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&l(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&l(t.charCodeAt(i)))for(i++;i<t.length&&l(t.charCodeAt(i));)i++;else return h=3,t.substring(ne,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&l(t.charCodeAt(i))){for(i++;i<t.length&&l(t.charCodeAt(i));)i++;ae=i}else h=3;return t.substring(ne,ae)}function Y(){let ne="",ae=i;for(;;){if(i>=n){ne+=t.substring(ae,i),h=2;break}const ue=t.charCodeAt(i);if(ue===34){ne+=t.substring(ae,i),i++;break}if(ue===92){if(ne+=t.substring(ae,i),i++,i>=n){h=2;break}switch(t.charCodeAt(i++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const ve=u(4);ve>=0?ne+=String.fromCharCode(ve):h=4;break}default:h=5}ae=i;continue}if(ue>=0&&ue<=31)if(g(ue)){ne+=t.substring(ae,i),h=2;break}else h=6;i++}return ne}function Z(){if(r="",h=0,o=i,i>=n)return o=n,a=17;let ne=t.charCodeAt(i);if(w(ne)){do i++,r+=String.fromCharCode(ne),ne=t.charCodeAt(i);while(w(ne));return a=15}if(g(ne))return i++,r+=String.fromCharCode(ne),ne===13&&t.charCodeAt(i)===10&&(i++,r+=`
`),a=14;switch(ne){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,r=Y(),a=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!g(t.charCodeAt(i));)i++;return r=t.substring(ae,i),a=12}if(t.charCodeAt(i+1)===42){i+=2;const ue=n-1;let se=!1;for(;i<ue;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,se=!0;break}i++}return se||(i++,h=1),r=t.substring(ae,i),a=13}return r+=String.fromCharCode(ne),i++,a=16}case 45:if(r+=String.fromCharCode(ne),i++,i===n||!l(t.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=F(),a=11;default:for(;i<n&&te(ne);)i++,ne=t.charCodeAt(i);if(o!==i){switch(r=t.substring(o,i),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(ne),i++,a=16}}function te(ne){if(w(ne)||g(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let ne;do ne=Z();while(ne>=12&&ne<=15);return ne}return{setPosition:D,getPosition:()=>i,scan:s?ie:Z,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>h}}e.createScanner=k;function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function m(t,s){const i=[],n=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function h(u,D,F,Y){o.value=u,o.offset=D,o.length=F,o.type=Y,o.colonOffset=void 0,r=o}try{S(t,{onObjectBegin:(u,D)=>{if(s<=u)throw n;r=void 0,a=s>u,i.push("")},onObjectProperty:(u,D,F)=>{if(s<D||(h(u,D,F,"property"),i[i.length-1]=u,s<=D+F))throw n},onObjectEnd:(u,D)=>{if(s<=u)throw n;r=void 0,i.pop()},onArrayBegin:(u,D)=>{if(s<=u)throw n;r=void 0,i.push(0)},onArrayEnd:(u,D)=>{if(s<=u)throw n;r=void 0,i.pop()},onLiteralValue:(u,D,F)=>{if(s<D||(h(u,D,F,E(u)),s<=D+F))throw n},onSeparator:(u,D,F)=>{if(s<=D)throw n;if(u===":"&&r&&r.type==="property")r.colonOffset=D,a=!1,r=void 0;else if(u===","){const Y=i[i.length-1];typeof Y=="number"?i[i.length-1]=Y+1:(a=!0,i[i.length-1]=""),r=void 0}}})}catch(u){if(u!==n)throw u}return{path:i,previousNode:r,isAtPropertyKey:a,matches:u=>{let D=0;for(let F=0;D<u.length&&F<i.length;F++)if(u[D]===i[F]||u[D]==="*")D++;else if(u[D]!=="**")return!1;return D===u.length}}}e.getLocation=m;function d(t,s=[],i=O.DEFAULT){let n=null,r=[];const o=[];function a(u){Array.isArray(r)?r.push(u):n!==null&&(r[n]=u)}return S(t,{onObjectBegin:()=>{const u={};a(u),o.push(r),r=u,n=null},onObjectProperty:u=>{n=u},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const u=[];a(u),o.push(r),r=u,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:a,onError:(u,D,F)=>{s.push({error:u,offset:D,length:F})}},i),r[0]}e.parse=d;function I(t,s=[],i=O.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(u){n.type==="property"&&(n.length=u-n.offset,n=n.parent)}function o(u){return n.children.push(u),u}S(t,{onObjectBegin:u=>{n=o({type:"object",offset:u,length:-1,parent:n,children:[]})},onObjectProperty:(u,D,F)=>{n=o({type:"property",offset:D,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:u,offset:D,length:F,parent:n})},onObjectEnd:(u,D)=>{n.length=u+D-n.offset,n=n.parent,r(u+D)},onArrayBegin:(u,D)=>{n=o({type:"array",offset:u,length:-1,parent:n,children:[]})},onArrayEnd:(u,D)=>{n.length=u+D-n.offset,n=n.parent,r(u+D)},onLiteralValue:(u,D,F)=>{o({type:E(u),offset:D,length:F,parent:n,value:u}),r(D+F)},onSeparator:(u,D,F)=>{n.type==="property"&&(u===":"?n.colonOffset=D:u===","&&r(D))},onError:(u,D,F)=>{s.push({error:u,offset:D,length:F})}},i);const h=n.children[0];return h&&delete h.parent,h}e.parseTree=I;function v(t,s){if(!t)return;let i=t;for(const n of s)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===n){i=o.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=v;function A(t){if(!t.parent||!t.parent.children)return[];const s=A(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;s.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&s.push(i)}return s}e.getNodePath=A;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const s=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(s[i.children[0].value]=c(n))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=c;function f(t,s,i=!1){return s>=t.offset&&s<t.offset+t.length||i&&s===t.offset+t.length}e.contains=f;function y(t,s,i=!1){if(f(t,s,i)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=s;r++){const o=y(n[r],s,i);if(o)return o}return t}}e.findNodeAtOffset=y;function S(t,s,i=O.DEFAULT){const n=k(t,!1);function r(q){return q?()=>q(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(q){return q?X=>q(X,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=r(s.onObjectBegin),h=o(s.onObjectProperty),u=r(s.onObjectEnd),D=r(s.onArrayBegin),F=r(s.onArrayEnd),Y=o(s.onLiteralValue),Z=o(s.onSeparator),te=r(s.onComment),ie=o(s.onError),ne=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function ue(){for(;;){const q=n.scan();switch(n.getTokenError()){case 4:se(14);break;case 5:se(15);break;case 3:se(13);break;case 1:ne||se(11);break;case 2:se(12);break;case 6:se(16);break}switch(q){case 12:case 13:ne?se(10):te();break;case 16:se(1);break;case 15:case 14:break;default:return q}}}function se(q,X=[],C=[]){if(ie(q),X.length+C.length>0){let N=n.getToken();for(;N!==17;){if(X.indexOf(N)!==-1){ue();break}else if(C.indexOf(N)!==-1)break;N=ue()}}}function ve(q){const X=n.getTokenValue();return q?Y(X):h(X),ue(),!0}function B(){switch(n.getToken()){case 11:{let q=0;try{q=JSON.parse(n.getTokenValue()),typeof q!="number"&&(se(2),q=0)}catch{se(2)}Y(q);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return ue(),!0}function j(){return n.getToken()!==10?(se(3,[],[2,5]),!1):(ve(!1),n.getToken()===6?(Z(":"),ue(),W()||se(4,[],[2,5])):se(5,[],[2,5]),!0)}function M(){a(),ue();let q=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(q||se(4,[],[]),Z(","),ue(),n.getToken()===2&&ae)break}else q&&se(6,[],[]);j()||se(4,[],[2,5]),q=!0}return u(),n.getToken()!==2?se(7,[2],[]):ue(),!0}function $(){D(),ue();let q=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(q||se(4,[],[]),Z(","),ue(),n.getToken()===4&&ae)break}else q&&se(6,[],[]);W()||se(4,[],[4,5]),q=!0}return F(),n.getToken()!==4?se(8,[4],[]):ue(),!0}function W(){switch(n.getToken()){case 3:return $();case 1:return M();case 10:return ve(!0);default:return B()}}return ue(),n.getToken()===17?i.allowEmptyContent?!0:(se(4,[],[]),!1):W()?(n.getToken()!==17&&se(9,[],[]),!0):(se(4,[],[]),!1)}e.visit=S;function p(t,s){const i=k(t),n=[];let r,o=0,a;do switch(a=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:o!==a&&n.push(t.substring(o,a)),s!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,s)),o=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=p;function E(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=E}),define(Q[71],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function T(w,g,l){return Math.min(Math.max(w,g),l)}e.clamp=T;function R(w,g){return(g+w%g)%g}e.rot=R;class P{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=P;class O{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=O;class k{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const l=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=k}),function(){function x(P){const O=[];typeof P=="number"&&O.push("code/timeOrigin",P);function k(g){O.push(g,Date.now())}function w(){const g=[];for(let l=0;l<O.length;l+=2)g.push({name:O[l],startTime:O[l+1]});return g}return{mark:k,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const k of performance.getEntriesByType("mark"))O.push({name:k.name,startTime:Math.round(P+k.startTime)});return O}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function T(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=T(R))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var T=e();for(var R in T)(typeof exports=="object"?exports:x)[R]=T[R]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function T(R){if(e[R])return e[R].exports;var P=e[R]={i:R,l:!1,exports:{}};return x[R].call(P.exports,P,P.exports,T),P.l=!0,P.exports}return T.m=x,T.c=e,T.d=function(R,P,O){T.o(R,P)||Object.defineProperty(R,P,{enumerable:!0,get:O})},T.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},T.t=function(R,P){if(1&P&&(R=T(R)),8&P||4&P&&typeof R=="object"&&R&&R.__esModule)return R;var O=Object.create(null);if(T.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:R}),2&P&&typeof R!="string")for(var k in R)T.d(O,k,function(w){return R[w]}.bind(null,k));return O},T.n=function(R){var P=R&&R.__esModule?function(){return R.default}:function(){return R};return T.d(P,"a",P),P},T.o=function(R,P){return Object.prototype.hasOwnProperty.call(R,P)},T.p="",T(T.s=0)}([function(x,e,T){(function(R){var P;e=x.exports=C,P=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],g=e.src=[],l=0,b=l++;g[b]="0|[1-9]\\d*";var m=l++;g[m]="[0-9]+";var d=l++;g[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=l++;g[I]="("+g[b]+")\\.("+g[b]+")\\.("+g[b]+")";var v=l++;g[v]="("+g[m]+")\\.("+g[m]+")\\.("+g[m]+")";var A=l++;g[A]="(?:"+g[b]+"|"+g[d]+")";var c=l++;g[c]="(?:"+g[m]+"|"+g[d]+")";var f=l++;g[f]="(?:-("+g[A]+"(?:\\."+g[A]+")*))";var y=l++;g[y]="(?:-?("+g[c]+"(?:\\."+g[c]+")*))";var S=l++;g[S]="[0-9A-Za-z-]+";var p=l++;g[p]="(?:\\+("+g[S]+"(?:\\."+g[S]+")*))";var E=l++,t="v?"+g[I]+g[f]+"?"+g[p]+"?";g[E]="^"+t+"$";var s="[v=\\s]*"+g[v]+g[y]+"?"+g[p]+"?",i=l++;g[i]="^"+s+"$";var n=l++;g[n]="((?:<|>)?=?)";var r=l++;g[r]=g[m]+"|x|X|\\*";var o=l++;g[o]=g[b]+"|x|X|\\*";var a=l++;g[a]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[f]+")?"+g[p]+"?)?)?";var h=l++;g[h]="[v=\\s]*("+g[r]+")(?:\\.("+g[r]+")(?:\\.("+g[r]+")(?:"+g[y]+")?"+g[p]+"?)?)?";var u=l++;g[u]="^"+g[n]+"\\s*"+g[a]+"$";var D=l++;g[D]="^"+g[n]+"\\s*"+g[h]+"$";var F=l++;g[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=l++;g[Y]="(?:~>?)";var Z=l++;g[Z]="(\\s*)"+g[Y]+"\\s+",w[Z]=new RegExp(g[Z],"g");var te=l++;g[te]="^"+g[Y]+g[a]+"$";var ie=l++;g[ie]="^"+g[Y]+g[h]+"$";var ne=l++;g[ne]="(?:\\^)";var ae=l++;g[ae]="(\\s*)"+g[ne]+"\\s+",w[ae]=new RegExp(g[ae],"g");var ue=l++;g[ue]="^"+g[ne]+g[a]+"$";var se=l++;g[se]="^"+g[ne]+g[h]+"$";var ve=l++;g[ve]="^"+g[n]+"\\s*("+s+")$|^$";var B=l++;g[B]="^"+g[n]+"\\s*("+t+")$|^$";var j=l++;g[j]="(\\s*)"+g[n]+"\\s*("+s+"|"+g[a]+")",w[j]=new RegExp(g[j],"g");var M=l++;g[M]="^\\s*("+g[a]+")\\s+-\\s+("+g[a]+")\\s*$";var $=l++;g[$]="^\\s*("+g[h]+")\\s+-\\s+("+g[h]+")\\s*$";var W=l++;g[W]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)P(q,g[q]),w[q]||(w[q]=new RegExp(g[q]));function X(z,G){if(z instanceof C)return z;if(typeof z!="string"||z.length>O||!(G?w[i]:w[E]).test(z))return null;try{return new C(z,G)}catch{return null}}function C(z,G){if(z instanceof C){if(z.loose===G)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof C))return new C(z,G);P("SemVer",z,G),this.loose=G;var J=z.trim().match(G?w[i]:w[E]);if(!J)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var pe=+he;if(pe>=0&&pe<k)return pe}return he}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=X,e.valid=function(z,G){var J=X(z,G);return J?J.version:null},e.clean=function(z,G){var J=X(z.trim().replace(/^[=v]+/,""),G);return J?J.version:null},e.SemVer=C,C.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},C.prototype.toString=function(){return this.version},C.prototype.compare=function(z){return P("SemVer.compare",this.version,this.loose,z),z instanceof C||(z=new C(z,this.loose)),this.compareMain(z)||this.comparePre(z)},C.prototype.compareMain=function(z){return z instanceof C||(z=new C(z,this.loose)),L(this.major,z.major)||L(this.minor,z.minor)||L(this.patch,z.patch)},C.prototype.comparePre=function(z){if(z instanceof C||(z=new C(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var G=0;do{var J=this.prerelease[G],he=z.prerelease[G];if(P("prerelease compare",G,J,he),J===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(J===void 0)return-1;if(J!==he)return L(J,he)}while(++G)},C.prototype.inc=function(z,G){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,G,J,he){typeof J=="string"&&(he=J,J=void 0);try{return new C(z,J).inc(G,he).version}catch{return null}},e.diff=function(z,G){if(K(z,G))return null;var J=X(z),he=X(G);if(J.prerelease.length||he.prerelease.length){for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==he[pe])return"pre"+pe;return"prerelease"}for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==he[pe])return pe},e.compareIdentifiers=L;var N=/^[0-9]+$/;function L(z,G){var J=N.test(z),he=N.test(G);return J&&he&&(z=+z,G=+G),J&&!he?-1:he&&!J?1:z<G?-1:z>G?1:0}function U(z,G,J){return new C(z,J).compare(new C(G,J))}function V(z,G,J){return U(z,G,J)>0}function H(z,G,J){return U(z,G,J)<0}function K(z,G,J){return U(z,G,J)===0}function re(z,G,J){return U(z,G,J)!==0}function ce(z,G,J){return U(z,G,J)>=0}function we(z,G,J){return U(z,G,J)<=0}function me(z,G,J,he){var pe;switch(G){case"===":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),pe=z===J;break;case"!==":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),pe=z!==J;break;case"":case"=":case"==":pe=K(z,J,he);break;case"!=":pe=re(z,J,he);break;case">":pe=V(z,J,he);break;case">=":pe=ce(z,J,he);break;case"<":pe=H(z,J,he);break;case"<=":pe=we(z,J,he);break;default:throw new TypeError("Invalid operator: "+G)}return pe}function le(z,G){if(z instanceof le){if(z.loose===G)return z;z=z.value}if(!(this instanceof le))return new le(z,G);P("comparator",z,G),this.loose=G,this.parse(z),this.semver===de?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(z,G){return L(G,z)},e.major=function(z,G){return new C(z,G).major},e.minor=function(z,G){return new C(z,G).minor},e.patch=function(z,G){return new C(z,G).patch},e.compare=U,e.compareLoose=function(z,G){return U(z,G,!0)},e.rcompare=function(z,G,J){return U(G,z,J)},e.sort=function(z,G){return z.sort(function(J,he){return e.compare(J,he,G)})},e.rsort=function(z,G){return z.sort(function(J,he){return e.rcompare(J,he,G)})},e.gt=V,e.lt=H,e.eq=K,e.neq=re,e.gte=ce,e.lte=we,e.cmp=me,e.Comparator=le;var de={};function ge(z,G){if(z instanceof ge)return z.loose===G?z:new ge(z.raw,G);if(z instanceof le)return new ge(z.value,G);if(!(this instanceof ge))return new ge(z,G);if(this.loose=G,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function oe(z){return!z||z.toLowerCase()==="x"||z==="*"}function ye(z,G,J,he,pe,Oe,Pe,Ae,ke,Te,Ue,Re,Le){return((G=oe(J)?"":oe(he)?">="+J+".0.0":oe(pe)?">="+J+"."+he+".0":">="+G)+" "+(Ae=oe(ke)?"":oe(Te)?"<"+(+ke+1)+".0.0":oe(Ue)?"<"+ke+"."+(+Te+1)+".0":Re?"<="+ke+"."+Te+"."+Ue+"-"+Re:"<="+Ae)).trim()}function Se(z,G){for(var J=0;J<z.length;J++)if(!z[J].test(G))return!1;if(G.prerelease.length){for(J=0;J<z.length;J++)if(P(z[J].semver),z[J].semver!==de&&z[J].semver.prerelease.length>0){var he=z[J].semver;if(he.major===G.major&&he.minor===G.minor&&he.patch===G.patch)return!0}return!1}return!0}function Ne(z,G,J){try{G=new ge(G,J)}catch{return!1}return G.test(z)}function Fe(z,G,J,he){var pe,Oe,Pe,Ae,ke;switch(z=new C(z,he),G=new ge(G,he),J){case">":pe=V,Oe=we,Pe=H,Ae=">",ke=">=";break;case"<":pe=H,Oe=ce,Pe=V,Ae="<",ke="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(z,G,he))return!1;for(var Te=0;Te<G.set.length;++Te){var Ue=G.set[Te],Re=null,Le=null;if(Ue.forEach(function(Ce){Ce.semver===de&&(Ce=new le(">=0.0.0")),Re=Re||Ce,Le=Le||Ce,pe(Ce.semver,Re.semver,he)?Re=Ce:Pe(Ce.semver,Le.semver,he)&&(Le=Ce)}),Re.operator===Ae||Re.operator===ke||(!Le.operator||Le.operator===Ae)&&Oe(z,Le.semver)||Le.operator===ke&&Pe(z,Le.semver))return!1}return!0}le.prototype.parse=function(z){var G=this.loose?w[ve]:w[B],J=z.match(G);if(!J)throw new TypeError("Invalid comparator: "+z);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new C(J[2],this.loose):this.semver=de},le.prototype.toString=function(){return this.value},le.prototype.test=function(z){return P("Comparator.test",z,this.loose),this.semver===de||(typeof z=="string"&&(z=new C(z,this.loose)),me(z,this.operator,this.semver,this.loose))},le.prototype.intersects=function(z,G){if(!(z instanceof le))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new ge(z.value,G),Ne(this.value,J,G);if(z.operator==="")return J=new ge(this.value,G),Ne(z.semver,J,G);var he=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Oe=this.semver.version===z.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ae=me(this.semver,"<",z.semver,G)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),ke=me(this.semver,">",z.semver,G)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return he||pe||Oe&&Pe||Ae||ke},e.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(z){var G=this.loose;z=z.trim(),P("range",z,G);var J=G?w[$]:w[M];z=z.replace(J,ye),P("hyphen replace",z),z=z.replace(w[j],"$1$2$3"),P("comparator trim",z,w[j]),z=(z=(z=z.replace(w[Z],"$1~")).replace(w[ae],"$1^")).split(/\s+/).join(" ");var he=G?w[ve]:w[B],pe=z.split(" ").map(function(Oe){return function(Pe,Ae){return P("comp",Pe),Pe=function(ke,Te){return ke.trim().split(/\s+/).map(function(Ue){return function(Re,Le){P("caret",Re,Le);var Ce=Le?w[se]:w[ue];return Re.replace(Ce,function(je,Ee,be,Ie,De){var Me;return P("caret",Re,je,Ee,be,Ie,De),oe(Ee)?Me="":oe(be)?Me=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":oe(Ie)?Me=Ee==="0"?">="+Ee+"."+be+".0 <"+Ee+"."+(+be+1)+".0":">="+Ee+"."+be+".0 <"+(+Ee+1)+".0.0":De?(P("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Me=Ee==="0"?be==="0"?">="+Ee+"."+be+"."+Ie+De+" <"+Ee+"."+be+"."+(+Ie+1):">="+Ee+"."+be+"."+Ie+De+" <"+Ee+"."+(+be+1)+".0":">="+Ee+"."+be+"."+Ie+De+" <"+(+Ee+1)+".0.0"):(P("no pr"),Me=Ee==="0"?be==="0"?">="+Ee+"."+be+"."+Ie+" <"+Ee+"."+be+"."+(+Ie+1):">="+Ee+"."+be+"."+Ie+" <"+Ee+"."+(+be+1)+".0":">="+Ee+"."+be+"."+Ie+" <"+(+Ee+1)+".0.0"),P("caret return",Me),Me})}(Ue,Te)}).join(" ")}(Pe,Ae),P("caret",Pe),Pe=function(ke,Te){return ke.trim().split(/\s+/).map(function(Ue){return function(Re,Le){var Ce=Le?w[ie]:w[te];return Re.replace(Ce,function(je,Ee,be,Ie,De){var Me;return P("tilde",Re,je,Ee,be,Ie,De),oe(Ee)?Me="":oe(be)?Me=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":oe(Ie)?Me=">="+Ee+"."+be+".0 <"+Ee+"."+(+be+1)+".0":De?(P("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Me=">="+Ee+"."+be+"."+Ie+De+" <"+Ee+"."+(+be+1)+".0"):Me=">="+Ee+"."+be+"."+Ie+" <"+Ee+"."+(+be+1)+".0",P("tilde return",Me),Me})}(Ue,Te)}).join(" ")}(Pe,Ae),P("tildes",Pe),Pe=function(ke,Te){return P("replaceXRanges",ke,Te),ke.split(/\s+/).map(function(Ue){return function(Re,Le){Re=Re.trim();var Ce=Le?w[D]:w[u];return Re.replace(Ce,function(je,Ee,be,Ie,De,Me){P("xRange",Re,je,Ee,be,Ie,De,Me);var We=oe(be),ze=We||oe(Ie),Be=ze||oe(De);return Ee==="="&&Be&&(Ee=""),We?je=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Be?(ze&&(Ie=0),Be&&(De=0),Ee===">"?(Ee=">=",ze?(be=+be+1,Ie=0,De=0):Be&&(Ie=+Ie+1,De=0)):Ee==="<="&&(Ee="<",ze?be=+be+1:Ie=+Ie+1),je=Ee+be+"."+Ie+"."+De):ze?je=">="+be+".0.0 <"+(+be+1)+".0.0":Be&&(je=">="+be+"."+Ie+".0 <"+be+"."+(+Ie+1)+".0"),P("xRange return",je),je})}(Ue,Te)}).join(" ")}(Pe,Ae),P("xrange",Pe),Pe=function(ke,Te){return P("replaceStars",ke,Te),ke.trim().replace(w[W],"")}(Pe,Ae),P("stars",Pe),Pe}(Oe,G)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(Oe){return!!Oe.match(he)})),pe=pe.map(function(Oe){return new le(Oe,G)})},ge.prototype.intersects=function(z,G){if(!(z instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(he){return z.set.some(function(pe){return pe.every(function(Oe){return he.intersects(Oe,G)})})})})},e.toComparators=function(z,G){return new ge(z,G).set.map(function(J){return J.map(function(he){return he.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new C(z,this.loose));for(var G=0;G<this.set.length;G++)if(Se(this.set[G],z))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(z,G,J){var he=null,pe=null;try{var Oe=new ge(G,J)}catch{return null}return z.forEach(function(Pe){Oe.test(Pe)&&(he&&pe.compare(Pe)!==-1||(pe=new C(he=Pe,J)))}),he},e.minSatisfying=function(z,G,J){var he=null,pe=null;try{var Oe=new ge(G,J)}catch{return null}return z.forEach(function(Pe){Oe.test(Pe)&&(he&&pe.compare(Pe)!==1||(pe=new C(he=Pe,J)))}),he},e.validRange=function(z,G){try{return new ge(z,G).range||"*"}catch{return null}},e.ltr=function(z,G,J){return Fe(z,G,"<",J)},e.gtr=function(z,G,J){return Fe(z,G,">",J)},e.outside=Fe,e.prerelease=function(z,G){var J=X(z,G);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(z,G,J){return z=new ge(z,J),G=new ge(G,J),z.intersects(G)},e.coerce=function(z){if(z instanceof C)return z;if(typeof z!="string")return null;var G=z.match(w[F]);return G==null?null:X((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,T(1))},function(x,e){var T,R,P=x.exports={};function O(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function w(c){if(T===setTimeout)return setTimeout(c,0);if((T===O||!T)&&setTimeout)return T=setTimeout,setTimeout(c,0);try{return T(c,0)}catch{try{return T.call(null,c,0)}catch{return T.call(this,c,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:O}catch{T=O}try{R=typeof clearTimeout=="function"?clearTimeout:k}catch{R=k}})();var g,l=[],b=!1,m=-1;function d(){b&&g&&(b=!1,g.length?l=g.concat(l):m=-1,l.length&&I())}function I(){if(!b){var c=w(d);b=!0;for(var f=l.length;f;){for(g=l,l=[];++m<f;)g&&g[m].run();m=-1,f=l.length}g=null,b=!1,function(y){if(R===clearTimeout)return clearTimeout(y);if((R===k||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(y);try{R(y)}catch{try{return R.call(null,y)}catch{return R.call(this,y)}}}(c)}}function v(c,f){this.fun=c,this.array=f}function A(){}P.nextTick=function(c){var f=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)f[y-1]=arguments[y];l.push(new v(c,f)),l.length!==1||b||w(I)},v.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=A,P.addListener=A,P.once=A,P.off=A,P.removeListener=A,P.removeAllListeners=A,P.emit=A,P.prependListener=A,P.prependOnceListener=A,P.listeners=function(c){return[]},P.binding=function(c){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(c){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Q[72],_([0,1]),function(x,e){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class R{constructor(w,g,l){this.level=w,this.key=g,this.value=l,this.forward=[]}}const P=void 0;class O{constructor(w,g=2**16){this.comparator=w,this[T]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new R(this.c,P,P)}get size(){return this.f}clear(){this.e=new R(this.c,P,P)}has(w){return Boolean(O.g(this,w,this.comparator))}get(w){return O.g(this,w,this.comparator)?.value}set(w,g){return O.h(this,w,g,this.comparator)&&(this.f+=1),this}delete(w){const g=O.k(this,w,this.comparator);return g&&(this.f-=1),g}forEach(w,g){let l=this.e.forward[0];for(;l;)w.call(g,l.value,l.key,this),l=l.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let w=this.e.forward[0];for(;w;)yield[w.key,w.value],w=w.forward[0]}*keys(){let w=this.e.forward[0];for(;w;)yield w.key,w=w.forward[0]}*values(){let w=this.e.forward[0];for(;w;)yield w.value,w=w.forward[0]}toString(){let w="[SkipList]:",g=this.e.forward[0];for(;g;)w+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return w}static g(w,g,l){let b=w.e;for(let m=w.d-1;m>=0;m--)for(;b.forward[m]&&l(b.forward[m].key,g)<0;)b=b.forward[m];if(b=b.forward[0],b&&l(b.key,g)===0)return b}static h(w,g,l,b){const m=[];let d=w.e;for(let I=w.d-1;I>=0;I--){for(;d.forward[I]&&b(d.forward[I].key,g)<0;)d=d.forward[I];m[I]=d}if(d=d.forward[0],d&&b(d.key,g)===0)return d.value=l,!1;{const I=O.j(w);if(I>w.d){for(let v=w.d;v<I;v++)m[v]=w.e;w.d=I}d=new R(I,g,l);for(let v=0;v<I;v++)d.forward[v]=m[v].forward[v],m[v].forward[v]=d;return!0}}static j(w,g=.5){let l=1;for(;Math.random()<g&&l<w.c;)l+=1;return l}static k(w,g,l){const b=[];let m=w.e;for(let d=w.d-1;d>=0;d--){for(;m.forward[d]&&l(m.forward[d].key,g)<0;)m=m.forward[d];b[d]=m}if(m=m.forward[0],!m||l(m.key,g)!==0)return!1;for(let d=0;d<w.d&&b[d].forward[d]===m;d++)b[d].forward[d]=m.forward[d];for(;w.d>0&&w.e.forward[w.d-1]===P;)w.d-=1;return!0}}e.SkipList=O}),define(Q[43],_([0,1,7,2]),function(x,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function P(p){const E=p;return E?typeof E.read=="function":!1}e.isReadable=P;function O(p){const E=p;return E?[E.on,E.pause,E.resume,E.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=O;function k(p){const E=p;return E?O(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.isReadableBufferedStream=k;function w(p,E){return new g(p,E)}e.newWriteableStream=w;class g{constructor(E,t){this.e=E,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(t=>t(E))}h(E){this.c.error.length===0?(0,T.onUnexpectedError)(E):this.c.error.slice(0).forEach(t=>t(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,t){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(E,t){if(this.a.destroyed)return;let s;switch(E){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const i=s.indexOf(t);i>=0&&s.splice(i,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(p,E){const t=[];let s;for(;(s=p.read())!==null;)t.push(s);return E(t)}e.consumeReadable=l;function b(p,E,t){const s=[];let i;for(;(i=p.read())!==null&&s.length<t;)s.push(i);return i===null&&s.length>0?E(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return p.read()}}}e.peekReadable=b;function m(p,E){return new Promise((t,s)=>{const i=[];d(p,{onData:n=>{E&&i.push(n)},onError:n=>{E?s(n):t(void 0)},onEnd:()=>{t(E?E(i):void 0)}})})}e.consumeStream=m;function d(p,E){let t=!1;return p.on("error",s=>{t||E.onError(s)}),p.on("end",()=>{t||E.onEnd()}),p.on("data",s=>{t||E.onData(s)}),(0,R.toDisposable)(()=>t=!0)}e.listenStream=d;function I(p,E){return new Promise((t,s)=>{const i=new R.DisposableStore,n=[],r=h=>{if(n.push(h),n.length>E)return i.dispose(),p.pause(),t({stream:p,buffer:n,ended:!1})},o=h=>s(h),a=()=>t({stream:p,buffer:n,ended:!0});i.add((0,R.toDisposable)(()=>p.removeListener("error",o))),p.on("error",o),i.add((0,R.toDisposable)(()=>p.removeListener("end",a))),p.on("end",a),i.add((0,R.toDisposable)(()=>p.removeListener("data",r))),p.on("data",r)})}e.peekStream=I;function v(p,E){const t=w(E);return t.end(p),t}e.toStream=v;function A(){const p=w(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=A;function c(p){let E=!1;return{read:()=>E?null:(E=!0,p)}}e.toReadable=c;function f(p,E,t){const s=w(t);return d(p,{onData:i=>s.write(E.data(i)),onError:i=>s.error(E.error?E.error(i):i),onEnd:()=>s.end()}),s}e.transform=f;function y(p,E,t){let s=!1;return{read:()=>{const i=E.read();return s?i:(s=!0,i!==null?t([p,i]):p)}}}e.prefixedReadable=y;function S(p,E,t){let s=!1;const i=w(t);return d(E,{onData:n=>s?i.write(n):(s=!0,i.write(t([p,n]))),onError:n=>i.error(n),onEnd:()=>{s||(s=!0,i.write(p)),i.end()}}),i}e.prefixedStream=S}),define(Q[15],_([0,1,43]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer<"u";let P,O;class k{static alloc(h){return R?new k(Buffer.allocUnsafe(h)):new k(new Uint8Array(h))}static wrap(h){return R&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new k(h)}static fromString(h,u){return!(u?.dontUseNodeBuffer||!1)&&R?new k(Buffer.from(h)):(P||(P=new TextEncoder),new k(P.encode(h)))}static fromByteArray(h){const u=k.alloc(h.length);for(let D=0,F=h.length;D<F;D++)u.buffer[D]=h[D];return u}static concat(h,u){if(typeof u>"u"){u=0;for(let Y=0,Z=h.length;Y<Z;Y++)u+=h[Y].byteLength}const D=k.alloc(u);let F=0;for(let Y=0,Z=h.length;Y<Z;Y++){const te=h[Y];D.set(te,F),F+=te.byteLength}return D}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=k.alloc(this.byteLength);return h.set(this),h}toString(){return R?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(h,u){return new k(this.buffer.subarray(h,u))}set(h,u){if(h instanceof k)this.buffer.set(h.buffer,u);else if(h instanceof Uint8Array)this.buffer.set(h,u);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),u);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),u);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return l(this.buffer,h)}writeUInt32BE(h,u){b(this.buffer,h,u)}readUInt32LE(h){return m(this.buffer,h)}writeUInt32LE(h,u){d(this.buffer,h,u)}readUInt8(h){return I(this.buffer,h)}writeUInt8(h,u){v(this.buffer,h,u)}}e.VSBuffer=k;function w(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0}e.readUInt16LE=w;function g(a,h,u){a[u+0]=h&255,h=h>>>8,a[u+1]=h&255}e.writeUInt16LE=g;function l(a,h){return a[h]*2**24+a[h+1]*2**16+a[h+2]*2**8+a[h+3]}e.readUInt32BE=l;function b(a,h,u){a[u+3]=h,h=h>>>8,a[u+2]=h,h=h>>>8,a[u+1]=h,h=h>>>8,a[u]=h}e.writeUInt32BE=b;function m(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0|a[h+2]<<16>>>0|a[h+3]<<24>>>0}e.readUInt32LE=m;function d(a,h,u){a[u+0]=h&255,h=h>>>8,a[u+1]=h&255,h=h>>>8,a[u+2]=h&255,h=h>>>8,a[u+3]=h&255}e.writeUInt32LE=d;function I(a,h){return a[h]}e.readUInt8=I;function v(a,h,u){a[u]=h}e.writeUInt8=v;function A(a){return T.consumeReadable(a,h=>k.concat(h))}e.readableToBuffer=A;function c(a){return T.toReadable(a)}e.bufferToReadable=c;function f(a){return T.consumeStream(a,h=>k.concat(h))}e.streamToBuffer=f;async function y(a){return a.ended?k.concat(a.buffer):k.concat([...a.buffer,await f(a.stream)])}e.bufferedStreamToBuffer=y;function S(a){return T.toStream(a,h=>k.concat(h))}e.bufferToStream=S;function p(a){return T.transform(a,{data:h=>typeof h=="string"?k.fromString(h):k.wrap(h)},h=>k.concat(h))}e.streamToBufferReadableStream=p;function E(a){return T.newWriteableStream(h=>k.concat(h),a)}e.newWriteableBufferStream=E;function t(a,h){return T.prefixedReadable(a,h,u=>k.concat(u))}e.prefixedBufferReadable=t;function s(a,h){return T.prefixedStream(a,h,u=>k.concat(u))}e.prefixedBufferStream=s;function i(a){let h=0,u=0,D=0;const F=new Uint8Array(Math.floor(a.length/4*3)),Y=te=>{switch(u){case 3:F[D++]=h|te,u=0;break;case 2:F[D++]=h|te>>>2,h=te<<6,u=3;break;case 1:F[D++]=h|te>>>4,h=te<<4,u=2;break;default:h=te<<2,u=1}};for(let te=0;te<a.length;te++){const ie=a.charCodeAt(te);if(ie>=65&&ie<=90)Y(ie-65);else if(ie>=97&&ie<=122)Y(ie-97+26);else if(ie>=48&&ie<=57)Y(ie-48+52);else if(ie===43||ie===45)Y(62);else if(ie===47||ie===95)Y(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${a[te]}`)}}const Z=D;for(;u>0;)Y(0);return k.wrap(F).slice(0,Z)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:a},h=!0,u=!1){const D=u?r:n;let F="";const Y=a.byteLength%3;let Z=0;for(;Z<a.byteLength-Y;Z+=3){const te=a[Z+0],ie=a[Z+1],ne=a[Z+2];F+=D[te>>>2],F+=D[(te<<4|ie>>>4)&63],F+=D[(ie<<2|ne>>>6)&63],F+=D[ne&63]}if(Y===1){const te=a[Z+0];F+=D[te>>>2],F+=D[te<<4&63],h&&(F+="==")}else if(Y===2){const te=a[Z+0],ie=a[Z+1];F+=D[te>>>2],F+=D[(te<<4|ie>>>4)&63],F+=D[ie<<2&63],h&&(F+="=")}return F}e.encodeBase64=o}),define(Q[30],_([0,1,3]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const y=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([S,p])=>{y[S]=p&&typeof p=="object"?R(p):p}),y}e.deepClone=R;function P(f){if(!f||typeof f!="object")return f;const y=[f];for(;y.length>0;){const S=y.shift();Object.freeze(S);for(const p in S)if(O.call(S,p)){const E=S[p];typeof E=="object"&&!Object.isFrozen(E)&&!(0,T.isTypedArray)(E)&&y.push(E)}}return f}e.deepFreeze=P;const O=Object.prototype.hasOwnProperty;function k(f,y){return w(f,y,new Set)}e.cloneAndChange=k;function w(f,y,S){if((0,T.isUndefinedOrNull)(f))return f;const p=y(f);if(typeof p<"u")return p;if(Array.isArray(f)){const E=[];for(const t of f)E.push(w(t,y,S));return E}if((0,T.isObject)(f)){if(S.has(f))throw new Error("Cannot clone recursive data-structure");S.add(f);const E={};for(const t in f)O.call(f,t)&&(E[t]=w(f[t],y,S));return S.delete(f),E}return f}function g(f,y,S=!0){return(0,T.isObject)(f)?((0,T.isObject)(y)&&Object.keys(y).forEach(p=>{p in f?S&&((0,T.isObject)(f[p])&&(0,T.isObject)(y[p])?g(f[p],y[p],S):f[p]=y[p]):f[p]=y[p]}),f):y}e.mixin=g;function l(f,y){if(f===y)return!0;if(f==null||y===null||y===void 0||typeof f!=typeof y||typeof f!="object"||Array.isArray(f)!==Array.isArray(y))return!1;let S,p;if(Array.isArray(f)){if(f.length!==y.length)return!1;for(S=0;S<f.length;S++)if(!l(f[S],y[S]))return!1}else{const E=[];for(p in f)E.push(p);E.sort();const t=[];for(p in y)t.push(p);if(t.sort(),!l(E,t))return!1;for(S=0;S<E.length;S++)if(!l(f[E[S]],y[E[S]]))return!1}return!0}e.equals=l;function b(f){const y=new Set;return JSON.stringify(f,(S,p)=>{if((0,T.isObject)(p)||Array.isArray(p)){if(y.has(p))return"[Circular]";y.add(p)}return p})}e.safeStringify=b;function m(f,y){const S=Object.create(null);return!f||!y||Object.keys(y).forEach(E=>{const t=f[E],s=y[E];l(t,s)||(S[E]=s)}),S}e.distinct=m;function d(f,y){const S=y.toLowerCase(),p=Object.keys(f).find(E=>E.toLowerCase()===S);return p?f[p]:f[y]}e.getCaseInsensitive=d;function I(f,y){const S=Object.create(null);for(const[p,E]of Object.entries(f))y(p,E)&&(S[p]=E);return S}e.filter=I;function v(f){let y=[],S=Object.getPrototypeOf(f);for(;Object.prototype!==S;)y=y.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return y}e.getAllPropertyNames=v;function A(f){const y=[];for(const S of v(f))typeof f[S]=="function"&&y.push(S);return y}e.getAllMethodNames=A;function c(f,y){const S=E=>function(){const t=Array.prototype.slice.call(arguments,0);return y(E,t)},p={};for(const E of f)p[E]=S(E);return p}e.createProxyObject=c}),define(Q[31],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(P){return T.test(P)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(w){for(let g=0;g<w.length;g++)w[g]=Math.floor(Math.random()*256);return w};const O=new Uint8Array(16),k=[];for(let w=0;w<256;w++)k.push(w.toString(16).padStart(2,"0"));return function(){P(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let g=0,l="";return l+=k[O[g++]],l+=k[O[g++]],l+=k[O[g++]],l+=k[O[g++]],l+="-",l+=k[O[g++]],l+=k[O[g++]],l+="-",l+=k[O[g++]],l+=k[O[g++]],l+="-",l+=k[O[g++]],l+=k[O[g++]],l+="-",l+=k[O[g++]],l+=k[O[g++]],l+=k[O[g++]],l+=k[O[g++]],l+=k[O[g++]],l+=k[O[g++]],l}}()}),define(Q[73],_([0,1,33]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(k){const w=k.replace(/\-/g,":").toLowerCase();return!R.has(w)}function O(){const k=(0,T.networkInterfaces)();for(const w in k){const g=k[w];if(g){for(const{mac:l}of g)if(P(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=O}),define(Q[74],_([8,9]),function(x,e){return x.create("vs/base/common/date",e)}),define(Q[75],_([0,1,74]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,P=R*60,O=P*24,k=O*7,w=O*30,g=O*365;function l(m,d,I,v){typeof m!="number"&&(m=m.getTime());const A=Math.round((new Date().getTime()-m)/1e3);if(A<-30)return(0,T.localize)(0,null,l(new Date().getTime()+A*1e3,!1));if(!v&&A<30)return(0,T.localize)(1,null);let c;return A<R?(c=A,d?c===1?I?(0,T.localize)(2,null,c):(0,T.localize)(3,null,c):I?(0,T.localize)(4,null,c):(0,T.localize)(5,null,c):c===1?I?(0,T.localize)(6,null,c):(0,T.localize)(7,null,c):I?(0,T.localize)(8,null,c):(0,T.localize)(9,null,c)):A<P?(c=Math.floor(A/R),d?c===1?I?(0,T.localize)(10,null,c):(0,T.localize)(11,null,c):I?(0,T.localize)(12,null,c):(0,T.localize)(13,null,c):c===1?I?(0,T.localize)(14,null,c):(0,T.localize)(15,null,c):I?(0,T.localize)(16,null,c):(0,T.localize)(17,null,c)):A<O?(c=Math.floor(A/P),d?c===1?I?(0,T.localize)(18,null,c):(0,T.localize)(19,null,c):I?(0,T.localize)(20,null,c):(0,T.localize)(21,null,c):c===1?I?(0,T.localize)(22,null,c):(0,T.localize)(23,null,c):I?(0,T.localize)(24,null,c):(0,T.localize)(25,null,c)):A<k?(c=Math.floor(A/O),d?c===1?(0,T.localize)(26,null,c):(0,T.localize)(27,null,c):c===1?(0,T.localize)(28,null,c):(0,T.localize)(29,null,c)):A<w?(c=Math.floor(A/k),d?c===1?I?(0,T.localize)(30,null,c):(0,T.localize)(31,null,c):I?(0,T.localize)(32,null,c):(0,T.localize)(33,null,c):c===1?I?(0,T.localize)(34,null,c):(0,T.localize)(35,null,c):I?(0,T.localize)(36,null,c):(0,T.localize)(37,null,c)):A<g?(c=Math.floor(A/w),d?c===1?I?(0,T.localize)(38,null,c):(0,T.localize)(39,null,c):I?(0,T.localize)(40,null,c):(0,T.localize)(41,null,c):c===1?I?(0,T.localize)(42,null,c):(0,T.localize)(43,null,c):I?(0,T.localize)(44,null,c):(0,T.localize)(45,null,c)):(c=Math.floor(A/g),d?c===1?I?(0,T.localize)(46,null,c):(0,T.localize)(47,null,c):I?(0,T.localize)(48,null,c):(0,T.localize)(49,null,c):c===1?I?(0,T.localize)(50,null,c):(0,T.localize)(51,null,c):I?(0,T.localize)(52,null,c):(0,T.localize)(53,null,c))}e.fromNow=l;function b(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(Q[76],_([8,9]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(Q[34],_([0,1,19,3,76]),function(x,e,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function O(m,d){return d&&(m.stack||m.stacktrace)?P.localize(0,null,w(m),k(m.stack)||k(m.stacktrace)):w(m)}function k(m){return Array.isArray(m)?m.join(`
`):m}function w(m){return typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?P.localize(1,null,m.message):m.message||P.localize(2,null)}function g(m=null,d=!1){if(!m)return P.localize(3,null);if(Array.isArray(m)){const I=T.coalesce(m),v=g(I[0],d);return I.length>1?P.localize(4,null,v,I.length):v}if(R.isString(m))return m;if(m.detail){const I=m.detail;if(I.error)return O(I.error,d);if(I.exception)return O(I.exception,d)}return m.stack?O(m,d):m.message?m.message:P.localize(5,null)}e.toErrorMessage=g;function l(m){const d=m;return d instanceof Error&&Array.isArray(d.actions)}e.isErrorWithActions=l;function b(m,d){let I;return typeof m=="string"?I=new Error(m):I=m,I.actions=d,I}e.createErrorWithActions=b}),define(Q[77],_([8,9]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(Q[78],_([0,1,77]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function R(P){switch(P){case 1:return(0,T.localize)(0,null);case 2:return(0,T.localize)(1,null);case 3:return(0,T.localize)(2,null);case 4:return(0,T.localize)(3,null);case 5:return(0,T.localize)(4,null);case 6:return(0,T.localize)(5,null);case 7:return(0,T.localize)(6,null);case 8:return(0,T.localize)(7,null);case 9:return(0,T.localize)(8,null);default:return""}}e.getParseErrorMessage=R}),define(Q[51],_([0,1,12]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var P;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(P=e.TerminateResponseCode||(e.TerminateResponseCode={}));function O(w,...g){const l=g.reduce((d,I)=>(d[I]=!0,d),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(w).filter(d=>!l[d]).forEach(d=>{for(let I=0;I<b.length;I++)if(d.search(b[I])!==-1){delete w[d];break}})}e.sanitizeProcessEnvironment=O;function k(w){!w||(delete w.DEBUG,T.isMacintosh&&delete w.DYLD_LIBRARY_PATH,T.isLinux&&delete w.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),define(Q[52],_([0,1,32]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(f){return P(f,0)}e.hash=R;function P(f,y){switch(typeof f){case"object":return f===null?O(349,y):Array.isArray(f)?g(f,y):l(f,y);case"string":return w(f,y);case"boolean":return k(f,y);case"number":return O(f,y);case"undefined":return O(937,y);default:return O(617,y)}}e.doHash=P;function O(f,y){return(y<<5)-y+f|0}e.numberHash=O;function k(f,y){return O(f?433:863,y)}function w(f,y){y=O(149417,y);for(let S=0,p=f.length;S<p;S++)y=O(f.charCodeAt(S),y);return y}e.stringHash=w;function g(f,y){return y=O(104579,y),f.reduce((S,p)=>P(p,S),y)}function l(f,y){return y=O(181387,y),Object.keys(f).sort().reduce((S,p)=>(S=w(p,S),P(f[p],S)),y)}class b{constructor(){this.g=0}get value(){return this.g}hash(y){return this.g=P(y,this.g),this.g}}e.Hasher=b;var m;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(m||(m={}));function d(f,y,S=32){const p=S-y,E=~((1<<p)-1);return(f<<y|(E&f)>>>p)>>>0}function I(f,y=0,S=f.byteLength,p=0){for(let E=0;E<S;E++)f[y+E]=p}function v(f,y,S="0"){for(;f.length<y;)f=S+f;return f}function A(f,y=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(S=>S.toString(16).padStart(2,"0")).join(""):v((f>>>0).toString(16),y/4)}e.toHexString=A;class c{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(y){const S=y.length;if(S===0)return;const p=this.p;let E=this.r,t=this.u,s,i;for(t!==0?(s=t,i=-1,t=0):(s=y.charCodeAt(0),i=0);;){let n=s;if(T.isHighSurrogate(s))if(i+1<S){const r=y.charCodeAt(i+1);T.isLowSurrogate(r)?(i++,n=T.computeCodePoint(s,r)):n=65533}else{t=s;break}else T.isLowSurrogate(s)&&(n=65533);if(E=this.w(p,E,n),i++,i<S)s=y.charCodeAt(i);else break}this.r=E,this.u=t}w(y,S,p){return p<128?y[S++]=p:p<2048?(y[S++]=192|(p&1984)>>>6,y[S++]=128|(p&63)>>>0):p<65536?(y[S++]=224|(p&61440)>>>12,y[S++]=128|(p&4032)>>>6,y[S++]=128|(p&63)>>>0):(y[S++]=240|(p&1835008)>>>18,y[S++]=128|(p&258048)>>>12,y[S++]=128|(p&4032)>>>6,y[S++]=128|(p&63)>>>0),S>=64&&(this.y(),S-=64,this.t+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),S}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),A(this.h)+A(this.l)+A(this.m)+A(this.n)+A(this.o)}x(){this.p[this.r++]=128,I(this.p,this.r),this.r>56&&(this.y(),I(this.p));const y=8*this.t;this.q.setUint32(56,Math.floor(y/4294967296),!1),this.q.setUint32(60,y%4294967296,!1),this.y()}y(){const y=c.g,S=this.q;for(let a=0;a<64;a+=4)y.setUint32(a,S.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)y.setUint32(a,d(y.getUint32(a-12,!1)^y.getUint32(a-32,!1)^y.getUint32(a-56,!1)^y.getUint32(a-64,!1),1),!1);let p=this.h,E=this.l,t=this.m,s=this.n,i=this.o,n,r,o;for(let a=0;a<80;a++)a<20?(n=E&t|~E&s,r=1518500249):a<40?(n=E^t^s,r=1859775393):a<60?(n=E&t|E&s|t&s,r=2400959708):(n=E^t^s,r=3395469782),o=d(p,5)+n+i+r+y.getUint32(a*4,!1)&4294967295,i=s,s=t,t=d(E,30),E=p,p=o;this.h=this.h+p&4294967295,this.l=this.l+E&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+i&4294967295}}e.StringSHA1=c,c.g=new DataView(new ArrayBuffer(320))}),define(Q[53],_([0,1,32]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(R||(R={})),function(P){const O="error",k="warning",w="warn",g="info",l="ignore";function b(d){return d?T.equalsIgnoreCase(O,d)?P.Error:T.equalsIgnoreCase(k,d)||T.equalsIgnoreCase(w,d)?P.Warning:T.equalsIgnoreCase(g,d)?P.Info:P.Ignore:P.Ignore}P.fromValue=b;function m(d){switch(d){case P.Error:return O;case P.Warning:return k;case P.Info:return g;default:return l}}P.toString=m}(R||(R={})),e.default=R}),define(Q[79],_([0,1,11]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(l){const b=l;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=R;function P(l){const b=[];let m;try{const d=JSON.parse(l.arguments),I=d[d.length-1];I&&I.__$stack&&(d.pop(),m=I.__$stack),b.push(...d)}catch{b.push("Unable to log remote console arguments",l.arguments)}return{args:b,stack:m}}e.parse=P;function O(l){if(typeof l!="string")return O(P(l).stack);const b=l;if(b){const m=k(b),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(d&&d.length===4)return{uri:T.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=O;function k(l){if(!l)return l;const b=l.indexOf(`
`);return b===-1?l:l.substring(0,b)}function w(l,b){const{args:m,stack:d}=P(l),I=typeof m[0]=="string"&&m.length===1;let v=k(d);v&&(v=`(${v.trim()})`);let A=[];if(typeof m[0]=="string"?v&&I?A=[`%c[${b}] %c${m[0]} %c${v}`,g("blue"),g(""),g("grey")]:A=[`%c[${b}] %c${m[0]}`,g("blue"),g(""),...m.slice(1)]:A=[`%c[${b}]%`,g("blue"),...m],v&&!I&&A.push(v),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,A)}e.log=w;function g(l){return`color: ${l}`}}),define(Q[44],_([0,1,15,32,11]),function(x,e,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function O(l){return JSON.stringify(l,w)}e.stringify=O;function k(l){let b=JSON.parse(l);return b=g(b),b}e.parse=k;function w(l,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,R.regExpFlags)(b)}:b}function g(l,b=0){if(!l||b>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return P.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof T.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let m=0;m<l.length;++m)l[m]=g(l[m],b+1);else for(const m in l)Object.hasOwnProperty.call(l,m)&&(l[m]=g(l[m],b+1))}return l}e.revive=g}),define(Q[80],_([0,1,33,7,54,31,73]),function(x,e,T,R,P,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(b){return this.a||(this.a=P.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,m=0;const d=(0,T.networkInterfaces)();for(const I in d){const v=d[I];if(v)for(const{mac:A,internal:c}of v)c||(m+=1,this.c(A.toUpperCase())&&(b+=1))}this.b=m>0?b/m:0}return this.b}};let w;async function g(){return w||(w=(async()=>await l()||O.generateUuid())()),w}e.getMachineId=g;async function l(){try{const b=await new Promise((d,I)=>{x(["crypto"],d,I)}),m=(0,k.getMac)();return b.createHash("sha256").update(m,"utf8").digest("hex")}catch(b){R.onUnexpectedError(b);return}}}),define(Q[81],_([0,1,33,14,20]),function(x,e,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const O=/^\d+$/,k=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var g;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(g||(g={}));let l;switch(process.arch){case"ia32":case"x32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class m{constructor(E,t,s){this.exePath=E,this.displayName=t,this.a=s}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:p=!1}={}){return p?l===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function I({useAlternateBitness:p=!1,findPreview:E=!1}={}){const t=d({useAlternateBitness:p});if(!t)return null;const s=R.join(t,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(s))return null;let i=-1,n=null;for(const a of await P.Promises.readdir(s)){let h=-1;if(E){const D=a.indexOf("-");if(D<0)continue;const F=a.substring(0,D);if(!O.test(F)||a.substring(D+1)!=="preview")continue;h=parseInt(F,10)}else{if(!O.test(a))continue;h=parseInt(a,10)}if(h<=i)continue;const u=R.join(s,a,"pwsh.exe");!await P.SymlinkSupport.existsFile(u)||(n=u,i=h)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",o=E?" Preview":"";return new m(n,`PowerShell${o}${r}`,!0)}async function v({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const E=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(E))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=p?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const i of await P.Promises.readdir(E))if(t.test(i)){const n=R.join(E,i,"pwsh.exe");return new m(n,s)}return null}function A(){const p=R.join(T.homedir(),".dotnet","tools","pwsh.exe");return new m(p,".NET Core PowerShell Global Tool")}function c(){const p=R.join(process.env.windir,l===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new m(p,"Windows PowerShell",!0)}async function*f(){let p=await I();p&&(yield p),p=await I({useAlternateBitness:!0}),p&&(yield p),p=await v(),p&&(yield p),p=A(),p&&(yield p),p=await I({findPreview:!0}),p&&(yield p),p=await v({findPreview:!0}),p&&(yield p),p=await I({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=c(),p&&(yield p)}async function*y(){for await(const p of f())await p.exists()&&(yield p)}e.enumeratePowerShellInstallations=y;async function S(){for await(const p of y())return p;return null}e.getFirstAvailablePowerShellInstallation=S}),define(Q[55],_([0,1,14,12,35,51,3,20]),function(x,e,T,R,P,O,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function g(m=P.env){return m.comspec||"cmd.exe"}e.getWindowsShell=g;function l(m){let d=[],I=!1;const v=function(A){if(I){d.push(A);return}(!m.send(A,f=>{if(f&&console.error(f),I=!1,d.length>0){const y=d.slice(0);d=[],y.forEach(S=>v(S))}})||R.isWindows)&&(I=!0)};return{send:v}}e.createQueuedSender=l;var b;(function(m){async function d(I,v,A){if(T.isAbsolute(I))return I;if(v===void 0&&(v=P.cwd()),T.dirname(I)!=="."||(A===void 0&&k.isString(P.env.PATH)&&(A=P.env.PATH.split(T.delimiter)),A===void 0||A.length===0))return T.join(v,I);async function f(y){if(await w.Promises.exists(y)){let S;try{S=await w.Promises.stat(y)}catch(p){p.message.startsWith("EACCES")&&(S=await w.Promises.lstat(y))}return S?!S.isDirectory():!1}return!1}for(const y of A){let S;if(T.isAbsolute(y)?S=T.join(y,I):S=T.join(v,y,I),await f(S))return S;let p=S+".com";if(await f(p)||(p=S+".exe",await f(p)))return p}return T.join(v,I)}m.findExecutable=d})(b=e.win32||(e.win32={}))}),define(Q[82],_([0,1,33,12,81,55]),function(x,e,T,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function k(m,d){return m===1?R.isWindows?b():O.getWindowsShell(d):g(m,d)}e.getSystemShell=k;let w=null;function g(m,d){if(R.isLinux&&m===2||R.isMacintosh&&m===3)return"/bin/bash";if(!w){let I;if(R.isWindows)I="/bin/bash";else{if(I=d.SHELL,!I)try{I=(0,T.userInfo)().shell}catch{}I||(I="sh"),I==="/bin/false"&&(I="/bin/bash")}w=I}return w}let l=null;async function b(){return l||(l=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),l}});var fe=this&&this.__decorate||function(x,e,T,R){var P=arguments.length,O=P<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,T):R,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(x,e,T,R);else for(var w=x.length-1;w>=0;w--)(k=x[w])&&(O=(P<3?k(O):P>3?k(e,T,O):k(e,T))||O);return P>3&&O&&Object.defineProperty(e,T,O),O};define(Q[56],_([0,1,19,5,15,22,49,7,4,2,44,32,3]),function(x,e,T,R,P,O,k,w,g,l,b,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var I;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(I||(I={}));function v(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var A;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(A||(A={}));function c(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(f||(f={}));function y(j){let M=0;for(let $=0;;$+=7){const W=j.read(1);if(M|=(W.buffer[0]&127)<<$,!(W.buffer[0]&128))return M}}const S=i(0);function p(j,M){if(M===0){j.write(S);return}let $=0;for(let q=M;q!==0;q=q>>>7)$++;const W=P.VSBuffer.alloc($);for(let q=0;M!==0;q++)W.buffer[q]=M&127,M=M>>>7,M>0&&(W.buffer[q]|=128);j.write(W)}class E{constructor(M){this.b=M,this.a=0}read(M){const $=this.b.slice(this.a,this.a+M);return this.a+=$.byteLength,$}}e.BufferReader=E;class t{constructor(){this.a=[]}get buffer(){return P.VSBuffer.concat(this.a)}write(M){this.a.push(M)}}e.BufferWriter=t;var s;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(s||(s={}));function i(j){const M=P.VSBuffer.alloc(1);return M.writeUInt8(j,0),M}const n={Undefined:i(s.Undefined),String:i(s.String),Buffer:i(s.Buffer),VSBuffer:i(s.VSBuffer),Array:i(s.Array),Object:i(s.Object),Uint:i(s.Int)},r=typeof Buffer<"u";function o(j,M){if(typeof M>"u")j.write(n.Undefined);else if(typeof M=="string"){const $=P.VSBuffer.fromString(M);j.write(n.String),p(j,$.byteLength),j.write($)}else if(r&&Buffer.isBuffer(M)){const $=P.VSBuffer.wrap(M);j.write(n.Buffer),p(j,$.byteLength),j.write($)}else if(M instanceof P.VSBuffer)j.write(n.VSBuffer),p(j,M.byteLength),j.write(M);else if(Array.isArray(M)){j.write(n.Array),p(j,M.length);for(const $ of M)o(j,$)}else if(typeof M=="number"&&(M|0)===M)j.write(n.Uint),p(j,M);else{const $=P.VSBuffer.fromString(JSON.stringify(M));j.write(n.Object),p(j,$.byteLength),j.write($)}}e.serialize=o;function a(j){switch(j.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return j.read(y(j)).toString();case s.Buffer:return j.read(y(j)).buffer;case s.VSBuffer:return j.read(y(j));case s.Array:{const $=y(j),W=[];for(let q=0;q<$;q++)W.push(a(j));return W}case s.Object:return JSON.parse(j.read(y(j)).toString());case s.Int:return y(j)}}e.deserialize=a;class h{constructor(M,$,W=null,q=1e3){this.h=M,this.j=$,this.k=W,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.q(X)),this.m({type:200})}registerChannel(M,$){this.b.set(M,$),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const $=this.o([M.type]);this.k?.logOutgoing($,0,1,c(M.type));return}case 201:case 202:case 204:case 203:{const $=this.o([M.type,M.id],M.data);this.k?.logOutgoing($,M.id,1,c(M.type),M.data);return}}}o(M,$=void 0){const W=new t;return o(W,M),o(W,$),this.p(W.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const $=new E(M),W=a($),q=a($),X=W[0];switch(X){case 100:return this.k?.logIncoming(M.byteLength,W[1],1,`${v(X)}: ${W[2]}.${W[3]}`,q),this.s({type:X,id:W[1],channelName:W[2],name:W[3],arg:q});case 102:return this.k?.logIncoming(M.byteLength,W[1],1,`${v(X)}: ${W[2]}.${W[3]}`,q),this.t({type:X,id:W[1],channelName:W[2],name:W[3],arg:q});case 101:return this.k?.logIncoming(M.byteLength,W[1],1,`${v(X)}`),this.u({type:X,id:W[1]});case 103:return this.k?.logIncoming(M.byteLength,W[1],1,`${v(X)}`),this.u({type:X,id:W[1]})}}s(M){const $=this.b.get(M.channelName);if(!$){this.v(M);return}const W=new O.CancellationTokenSource;let q;try{q=$.call(this.j,M.name,M.arg,W.token)}catch(N){q=Promise.reject(N)}const X=M.id;q.then(N=>{this.m({id:X,data:N,type:201}),this.d.delete(M.id)},N=>{N instanceof Error?this.m({id:X,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.m({id:X,data:N,type:203}),this.d.delete(M.id)});const C=(0,l.toDisposable)(()=>W.cancel());this.d.set(M.id,C)}t(M){const $=this.b.get(M.channelName);if(!$){this.v(M);return}const W=M.id,X=$.listen(this.j,M.name,M.arg)(C=>this.m({id:W,data:C,type:204}));this.d.set(M.id,X)}u(M){const $=this.d.get(M.id);$&&($.dispose(),this.d.delete(M.id))}v(M){let $=this.g.get(M.channelName);$||($=[],this.g.set(M.channelName,$));const W=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);$.push({request:M,timeoutTimer:W})}w(M){const $=this.g.get(M);if($){for(const W of $)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.s(W.request);break;case 102:this.t(W.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=h;var u;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(M,$=null){this.l=M,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(W=>this.s(W)),this.j=$}getChannel(M){const $=this;return{call(W,q,X){return $.a?Promise.reject(new w.CancellationError):$.m(M,W,q,X)},listen(W,q){return $.a?g.Event.None:$.o(M,W,q)}}}m(M,$,W,q=O.CancellationToken.None){const X=this.g++,N={id:X,type:100,channelName:M,name:$,arg:W};if(q.isCancellationRequested)return Promise.reject(new w.CancellationError);let L;return new Promise((V,H)=>{if(q.isCancellationRequested)return H(new w.CancellationError);const K=()=>{const me=le=>{switch(le.type){case 201:this.f.delete(X),V(le.data);break;case 202:{this.f.delete(X);const de=new Error(le.data.message);de.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,de.name=le.data.name,H(de);break}case 203:this.f.delete(X),H(le.data);break}};this.f.set(X,me),this.p(N)};let re=null;this.b===f.Idle?K():(re=(0,R.createCancelablePromise)(me=>this.u()),re.then(()=>{re=null,K()}));const ce=()=>{re?(re.cancel(),re=null):this.p({id:X,type:101}),H(new w.CancellationError)},we=q.onCancellationRequested(ce);L=(0,l.combinedDisposable)((0,l.toDisposable)(ce),we),this.d.add(L)}).finally(()=>{this.d.delete(L)})}o(M,$,W){const q=this.g++,C={id:q,type:102,channelName:M,name:$,arg:W};let N=null;const L=new g.Emitter({onWillAddFirstListener:()=>{N=(0,R.createCancelablePromise)(V=>this.u()),N.then(()=>{N=null,this.d.add(L),this.p(C)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.d.delete(L),this.p({id:q,type:103}))}}),U=V=>L.fire(V.data);return this.f.set(q,U),L.event}p(M){switch(M.type){case 100:case 102:{const $=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing($,M.id,0,`${v(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const $=this.q([M.type,M.id]);this.j?.logOutgoing($,M.id,0,v(M.type));return}}}q(M,$=void 0){const W=new t;return o(W,M),o(W,$),this.r(W.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const $=new E(M),W=a($),q=a($),X=W[0];switch(X){case 200:return this.j?.logIncoming(M.byteLength,0,0,c(X)),this.t({type:W[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,W[1],0,c(X),q),this.t({type:W[0],id:W[1],data:q})}}t(M){if(M.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.dispose)(this.d.values()),this.d.clear()}}fe([k.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class F{get connections(){const M=[];return this.f.forEach($=>M.push($)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new g.Emitter,this.onDidAddConnection=this.g.event,this.h=new g.Emitter,this.onDidRemoveConnection=this.h.event,M(({protocol:$,onDidClientDisconnect:W})=>{g.Event.once($.onMessage)(X=>{const C=new E(X),N=a(C),L=new h($,N),U=new D($);this.a.forEach((H,K)=>L.registerChannel(K,H));const V={channelServer:L,channelClient:U,ctx:N};this.f.add(V),this.g.fire(V),W(()=>{L.dispose(),U.dispose(),this.f.delete(V),this.h.fire(V)})})})}getChannel(M,$){const W=this;return{call(q,X,C){let N;if((0,d.isFunction)($)){const U=(0,T.getRandomElement)(W.connections.filter($));N=U?Promise.resolve(U):g.Event.toPromise(g.Event.filter(W.onDidAddConnection,$))}else N=$.routeCall(W,q,X);const L=N.then(U=>U.channelClient.getChannel(M));return Z(L).call(q,X,C)},listen(q,X){if((0,d.isFunction)($))return W.j(M,$,q,X);const C=$.routeEvent(W,q,X).then(N=>N.channelClient.getChannel(M));return Z(C).listen(q,X)}}}j(M,$,W,q){const X=this;let C=new l.DisposableStore;const N=new g.Emitter({onWillAddFirstListener:()=>{C=new l.DisposableStore;const L=new g.EventMultiplexer,U=new Map,V=K=>{const ce=K.channelClient.getChannel(M).listen(W,q),we=L.add(ce);U.set(K,we)},H=K=>{const re=U.get(K);!re||(re.dispose(),U.delete(K))};X.connections.filter($).forEach(V),g.Event.filter(X.onDidAddConnection,$)(V,void 0,C),X.onDidRemoveConnection(H,void 0,C),L.event(N.fire,N,C),C.add(L)},onDidRemoveLastListener:()=>{C.dispose()}});return N.event}registerChannel(M,$){this.a.set(M,$),this.f.forEach(W=>{W.channelServer.registerChannel(M,$)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=F;class Y{constructor(M,$,W=null){const q=new t;o(q,$),M.send(q.buffer),this.a=new D(M,W),this.d=new h(M,$,W)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,$){this.d.registerChannel(M,$)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=Y;function Z(j){return{call(M,$,W){return j.then(q=>q.call(M,$,W))},listen(M,$){const W=new g.Relay;return j.then(q=>W.input=q.listen(M,$)),W.event}}}e.getDelayedChannel=Z;function te(j){let M=!1;return{call($,W,q){return M?j.call($,W,q):(0,R.timeout)(0).then(()=>M=!0).then(()=>j.call($,W,q))},listen($,W){if(M)return j.listen($,W);const q=new g.Relay;return(0,R.timeout)(0).then(()=>M=!0).then(()=>q.input=j.listen($,W)),q.event}}}e.getNextTickChannel=te;class ie{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const $ of M.connections)if(await Promise.resolve(this.a($.ctx)))return Promise.resolve($);return await g.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.StaticRouter=ie;var ne;(function(j){function M(X,C){const N=X,L=C&&C.disableMarshalling,U=new Map;for(const V in N)W(V)&&U.set(V,g.Event.buffer(N[V],!0));return new class{listen(V,H,K){const re=U.get(H);if(re)return re;if(q(H)){const ce=N[H];if(typeof ce=="function")return ce.call(N,K)}throw new Error(`Event not found: ${H}`)}call(V,H,K){const re=N[H];if(typeof re=="function"){if(!L&&Array.isArray(K))for(let ce=0;ce<K.length;ce++)K[ce]=(0,b.revive)(K[ce]);return re.apply(N,K)}throw new Error(`Method not found: ${H}`)}}}j.fromService=M;function $(X,C){const N=C&&C.disableMarshalling;return new Proxy({},{get(L,U){if(typeof U=="string")return C?.properties?.has(U)?C.properties.get(U):q(U)?function(V){return X.listen(U,V)}:W(U)?X.listen(U):async function(...V){let H;C&&!(0,d.isUndefinedOrNull)(C.context)?H=[C.context,...V]:H=V;const K=await X.call(U,H);return N?K:(0,b.revive)(K)};throw new Error(`Property not found: ${String(U)}`)}})}j.toService=$;function W(X){return X[0]==="o"&&X[1]==="n"&&m.isUpperAsciiLetter(X.charCodeAt(2))}function q(X){return/^onDynamic/.test(X)&&m.isUpperAsciiLetter(X.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const M=j.toString();if(M!=="[object Object]")return M}return j}function se(j){return Array.isArray(j)?j.map(ue):ue(j)}function ve(j,M,$,W,q,X,C){C=se(C);const N=ae[q],L=N[W%N.length];let U=[`%c[${j}]%c[${String(M).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${L}`];/\($/.test(X)?(U=U.concat(C),U.push(")")):U.push(C),console.log.apply(console,U)}class B{constructor(M,$){this.d=M,this.f=$,this.a=0,this.b=0}logOutgoing(M,$,W,q,X){this.b+=M,ve(this.d,this.b,M,$,W,q,X)}logIncoming(M,$,W,q,X){this.a+=M,ve(this.f,this.a,M,$,W,q,X)}}e.IPCLogger=B}),define(Q[83],_([0,1,57,5,15,22,79,7,4,2,30,55,51,56]),function(x,e,T,R,P,O,k,w,g,l,b,m,d,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class v extends I.ChannelServer{constructor(f){super({send:y=>{try{process.send?.(y.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",y=>P.VSBuffer.wrap(Buffer.from(y,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=v;class A{constructor(f,y){this.i=f,this.j=y,this.c=new Set,this.g=new Map,this.h=new g.Emitter,this.onDidProcessExit=this.h.event;const S=y&&y.timeout?y.timeout:6e4;this.b=new R.Delayer(S),this.d=null,this.f=null}getChannel(f){const y=this;return{call(S,p,E){return y.k(f,S,p,E)},listen(S,p){return y.l(f,S,p)}}}k(f,y,S,p=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(w.canceled());this.b.cancel();const E=this.n(f),t=(0,R.createCancelablePromise)(n=>E.call(y,S,n)),s=p.onCancellationRequested(()=>t.cancel()),i=(0,l.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{s.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,y,S){if(!this.b)return g.Event.None;this.b.cancel();let p;const E=new g.Emitter({onWillAddFirstListener:()=>{p=this.n(f).listen(y,S)(E.fire,E),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return E.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],y=Object.create(null);y.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(y.env={...y.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(y.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,d.removeDangerousEnvVariables)(y.env),this.d=(0,T.fork)(this.i,f,y);const S=new g.Emitter;g.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,k.isRemoteConsoleLog)(r)){(0,k.log)(r,`IPC Library: ${this.j.serverName}`);return}S.fire(P.VSBuffer.wrap(Buffer.from(r,"base64")))});const E=this.j.useQueue?(0,m.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&E.send(r.buffer.toString("base64")),s=S.event,i={send:t,onMessage:s};this.f=new I.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",n),this.c.forEach(a=>(0,l.dispose)(a)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(f){let y=this.g.get(f);return y||(y=this.m.getChannel(f),this.g.set(f,y)),y}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=A}),define(Q[84],_([0,1,5,4,2,3]),function(x,e,T,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k=e.StorageHint||(e.StorageHint={}));function w(m){const d=m;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=w;var g;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class l extends P.Disposable{constructor(d,I=Object.create(null)){super(),this.m=d,this.n=I,this.b=this.B(new R.Emitter),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=new T.ThrottledDelayer(l.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(d=>this.r(d)))}r(d){d.changed?.forEach((I,v)=>this.s(v,I)),d.deleted?.forEach(I=>this.s(I,void 0))}s(d,I){if(this.c===g.Closed)return;let v=!1;(0,O.isUndefinedOrNull)(I)?v=this.f.delete(d):this.f.get(d)!==I&&(this.f.set(d,I),v=!0),v&&this.b.fire(d)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.n.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(d,I){const v=this.f.get(d);return(0,O.isUndefinedOrNull)(v)?I:v}getBoolean(d,I){const v=this.get(d);return(0,O.isUndefinedOrNull)(v)?I:v==="true"}getNumber(d,I){const v=this.get(d);return(0,O.isUndefinedOrNull)(v)?I:parseInt(v,10)}async set(d,I){if(this.c===g.Closed)return;if((0,O.isUndefinedOrNull)(I))return this.delete(d);const v=String(I);if(this.f.get(d)!==v)return this.f.set(d,v),this.j.set(d,v),this.h.delete(d),this.b.fire(d),this.w()}async delete(d){if(!(this.c===g.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire(d),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=g.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(d).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(d){if(!!this.u)return this.w(d)}async w(d){return this.g.trigger(()=>this.v(),d)}async whenFlushed(){if(!!this.u)return new Promise(d=>this.l.push(d))}isInMemory(){return this.n.hint===k.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=l,l.a=100;class b{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((I,v)=>this.a.set(v,I)),d.delete?.forEach(I=>this.a.delete(I))}async close(){}}e.InMemoryStorageDatabase=b}),define(Q[85],_([8,9]),function(x,e){return x.create("vs/base/node/zip",e)}),define(Q[86],_([8,9]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[87],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Q[88],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[89],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Q[90],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Q[91],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Q[92],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Q[93],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Q[94],_([8,9]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[95],_([8,9]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(Q[96],_([8,9]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(Q[97],_([8,9]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[98],_([8,9]),function(x,e){return x.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Q[99],_([8,9]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(Q[100],_([8,9]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(Q[101],_([8,9]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[102],_([8,9]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Q[103],_([8,9]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(Q[104],_([0,1,75,49,16,14,35,18,11]),function(x,e,T,R,P,O,k,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,O.dirname)(P.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,O.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,w.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,w.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const v=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.join)(this.userDataPath,"logs",v)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,O.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,O.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(g.URI.file((0,O.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,w.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,w.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=k.env.VSCODE_PORTABLE;return v?g.URI.file((0,O.join)(v,"argv.json")):(0,w.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,O.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,O.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,O.resolve)(v):(0,O.normalize)((0,O.join)(P.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const v=this.args["extensions-download-dir"];return v?g.URI.file((0,O.resolve)(v)):g.URI.file((0,O.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,O.resolve)(v);const A=k.env.VSCODE_EXTENSIONS;if(A)return A;const c=k.env.VSCODE_PORTABLE;return c?(0,O.join)(c,"extensions"):(0,w.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(A=>/^[^:/?#]+?:\/\//.test(A)?g.URI.parse(A):g.URI.file((0,O.normalize)(A)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?g.URI.parse(v):g.URI.file((0,O.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(v=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(v))}get extensionLogLevel(){const v=[];for(const A of this.args.log||[]){const c=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(A);c&&c[1]&&c[2]&&v.push([c[1],c[2]])}return v.length?v:void 0}get serviceMachineIdResource(){return(0,w.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,O.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const v=k.env.VSCODE_PORTABLE;return v?g.URI.file((0,O.join)(v,"policy.json")):(0,w.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(v){this.args.continueOn=v}get args(){return this.a}constructor(v,A,c){this.a=v,this.b=A,this.c=c,this.editSessionId=this.args.editSessionId}}fe([R.memoize],l.prototype,"appRoot",null),fe([R.memoize],l.prototype,"userHome",null),fe([R.memoize],l.prototype,"userDataPath",null),fe([R.memoize],l.prototype,"appSettingsHome",null),fe([R.memoize],l.prototype,"tmpDir",null),fe([R.memoize],l.prototype,"cacheHome",null),fe([R.memoize],l.prototype,"stateResource",null),fe([R.memoize],l.prototype,"userRoamingDataHome",null),fe([R.memoize],l.prototype,"userDataSyncHome",null),fe([R.memoize],l.prototype,"userDataSyncLogResource",null),fe([R.memoize],l.prototype,"editSessionsLogResource",null),fe([R.memoize],l.prototype,"sync",null),fe([R.memoize],l.prototype,"machineSettingsResource",null),fe([R.memoize],l.prototype,"workspaceStorageHome",null),fe([R.memoize],l.prototype,"localHistoryHome",null),fe([R.memoize],l.prototype,"keyboardLayoutResource",null),fe([R.memoize],l.prototype,"argvResource",null),fe([R.memoize],l.prototype,"isExtensionDevelopment",null),fe([R.memoize],l.prototype,"untitledWorkspacesHome",null),fe([R.memoize],l.prototype,"installSourcePath",null),fe([R.memoize],l.prototype,"builtinExtensionsPath",null),fe([R.memoize],l.prototype,"extensionsPath",null),fe([R.memoize],l.prototype,"extensionDevelopmentLocationURI",null),fe([R.memoize],l.prototype,"extensionDevelopmentKind",null),fe([R.memoize],l.prototype,"extensionTestsLocationURI",null),fe([R.memoize],l.prototype,"debugExtensionHost",null),fe([R.memoize],l.prototype,"logLevel",null),fe([R.memoize],l.prototype,"extensionLogLevel",null),fe([R.memoize],l.prototype,"serviceMachineIdResource",null),fe([R.memoize],l.prototype,"telemetryLogResource",null),fe([R.memoize],l.prototype,"disableWorkspaceTrust",null),fe([R.memoize],l.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=l;function b(I,v){return d(I["inspect-extensions"],I["inspect-brk-extensions"],5870,v,I.debugId,I.extensionEnvironment)}e.parseExtensionHostPort=b;function m(I,v){return d(I["inspect-ptyhost"],I["inspect-brk-ptyhost"],5877,v,I.extensionEnvironment)}e.parsePtyHostPort=m;function d(I,v,A,c,f,y){const p=Number(v||I)||(c?null:A),E=p?Boolean(!!v):!1;let t;if(y)try{t=JSON.parse(y)}catch{}return{port:p,break:E,debugId:f,env:t}}}),function(){"use strict";function x(e,T,R){function P(k,w){const g=O(k,w),l=[g];return e.isAbsolute(g)||l.unshift(R),e.resolve(...l)}function O(k,w){process.env.VSCODE_DEV&&(w="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,w);const b=k["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(m,"AppData","Roaming")}break;case"darwin":l=e.join(T.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,w)}return{getUserDataPath:P}}if(typeof define=="function")define(Q[105],_([157,33,35]),function(e,T,R){return x(e,T,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),T=require("os");module.exports=x(e,T,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[106],_([0,1,33,104,105]),function(x,e,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class O extends R.AbstractNativeEnvironmentService{constructor(w,g){super(w,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,P.getUserDataPath)(w,g.nameShort)},g)}}e.NativeEnvironmentService=O}),define(Q[107],_([0,1,3,90]),function(x,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function P(k,w,g){try{O(k,w,g)}catch(l){console.error(l?.message??l)}return k}e.localizeManifest=P;function O(k,w,g){const l=(b,m,d)=>{const I=b[m];if((0,T.isString)(I)){const v=I,A=v.length;if(A>1&&v[0]==="%"&&v[A-1]==="%"){const c=v.substr(1,A-2);let f=w[c];f===void 0&&g&&(f=g[c]);const y=typeof f=="string"?f:f?.message,S=g?.[c],p=typeof S=="string"?S:S?.message;if(!y){p||console.warn(`[${k.name}]: ${(0,R.localize)(0,null,c)}`);return}if(d&&(m==="title"||m==="category")&&p&&p!==y){const E={value:y,original:p};b[m]=E}else b[m]=y}}else if((0,T.isObject)(I))for(const v in I)I.hasOwnProperty(v)&&(v==="commands"?l(I,v,!0):l(I,v,d));else if(Array.isArray(I))for(let v=0;v<I.length;v++)l(I,v,d)};for(const b in k)k.hasOwnProperty(b)&&l(k,b)}}),define(Q[108],_([0,1,7]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class R{constructor(){this.a=new Map}register(O,k){this.a.set(O,k)}updateManifest(O){if(!(typeof O.main>"u"&&typeof O.browser>"u")&&(O.activationEvents===void 0&&Object.assign(O,{activationEvents:[]}),!(!Array.isArray(O.activationEvents)||!O.contributes)))for(const k in O.contributes){const w=this.a.get(k);if(!w)continue;const g=O.contributes[k],l=Array.isArray(g)?g:[g];try{w(l,O.activationEvents)}catch(b){(0,T.onUnexpectedError)(b)}}}}e.ImplicitActivationEventsImpl=R,e.ImplicitActivationEvents=new R}),define(Q[45],_([0,1,18,53,94,41]),function(x,e,T,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function g(f){return f=f.trim(),f==="*"||k.test(f)}e.isValidVersionStr=g;function l(f){if(!g(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const y=f.match(k);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=l;function b(f){if(!f)return null;const y=f.majorBase,S=f.majorMustEqual,p=f.minorBase;let E=f.minorMustEqual;const t=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&(y===0||(E=!1),s=!1);let i=0;if(f.preRelease){const n=w.exec(f.preRelease);if(n){const[,r,o,a]=n;i=Date.UTC(Number(r),Number(o)-1,Number(a))}}return{majorBase:y,majorMustEqual:S,minorBase:p,minorMustEqual:E,patchBase:t,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:i}}e.normalizeVersion=b;function m(f,y,S){let p;typeof f=="string"?p=b(l(f)):p=f;let E;y instanceof Date?E=y.getTime():typeof y=="string"&&(E=new Date(y).getTime());let t;if(typeof S=="string"?t=b(l(S)):t=S,!p||!t)return!1;const s=p.majorBase,i=p.minorBase,n=p.patchBase;let r=t.majorBase,o=t.minorBase,a=t.patchBase;const h=t.notBefore;let u=t.majorMustEqual,D=t.minorMustEqual,F=t.patchMustEqual;return t.isMinimum?s>r?!0:s<r?!1:i>o?!0:i<o||E&&E<h?!1:n>=a:(s===1&&r===0&&(!u||!D||!F)&&(r=1,o=0,a=0,u=!0,D=!1,F=!1),s<r?!1:s>r?!u:i<o?!1:i>o?!D:n<a?!1:n>a?!F:!(E&&E<h))}e.isValidVersion=m;function d(f,y,S,p,E){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([R.default.Error,P.localize(0,null)]),t;if(typeof p.name!="string")return t.push([R.default.Error,P.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([R.default.Error,P.localize(2,null,"version")]),t;if(!p.engines)return t.push([R.default.Error,P.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([R.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!c(p.extensionDependencies))return t.push([R.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!c(p.activationEvents))return t.push([R.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([R.default.Error,P.localize(7,null,"activationEvents","main")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([R.default.Warning,P.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([R.default.Error,P.localize(9,null,"main")]),t;{const n=(0,T.joinPath)(S,p.main);(0,T.isEqualOrParent)(n,S)||t.push([R.default.Warning,P.localize(10,null,n.path,S.path)])}if(typeof p.activationEvents>"u")return t.push([R.default.Error,P.localize(11,null,"activationEvents","main")]),t}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([R.default.Error,P.localize(12,null,"browser")]),t;{const n=(0,T.joinPath)(S,p.browser);(0,T.isEqualOrParent)(n,S)||t.push([R.default.Warning,P.localize(13,null,n.path,S.path)])}if(typeof p.activationEvents>"u")return t.push([R.default.Error,P.localize(14,null,"activationEvents","browser")]),t}if(!O.valid(p.version))return t.push([R.default.Error,P.localize(15,null)]),t;const s=[];if(!I(f,y,p,E,s))for(const n of s)t.push([R.default.Error,n]);return t}e.validateExtensionManifest=d;function I(f,y,S,p,E){return p||typeof S.main>"u"&&typeof S.browser>"u"?!0:A(f,y,S.engines.vscode,E)}e.isValidExtensionVersion=I;function v(f,y,S){return f==="*"||A(y,S,f)}e.isEngineValid=v;function A(f,y,S,p=[]){const E=b(l(S));if(!E)return p.push(P.localize(16,null,S)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return p.push(P.localize(17,null,S)),!1}else if(!E.majorMustEqual)return p.push(P.localize(18,null,S)),!1;return m(f,y,E)?!0:(p.push(P.localize(19,null,f,S)),!1)}function c(f){if(!Array.isArray(f))return!1;for(let y=0,S=f.length;y<S;y++)if(typeof f[y]!="string")return!1;return!0}}),define(Q[109],_([0,1,15,31]),function(x,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function P(O,k,w){let g=w&&w.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const b=(await k.readFile(O.serviceMachineIdResource)).value.toString();g=(0,R.isUUID)(b)?b:null}catch{g=null}if(!g){g=(0,R.generateUuid)();try{await k.writeFile(O.serviceMachineIdResource,T.VSBuffer.fromString(g))}catch{}}return w?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=P}),define(Q[46],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class T{constructor(P,O=[],k=!1){this.ctor=P,this.staticArguments=O,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=T}),define(Q[110],_([0,1,46]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var P;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(P=e.InstantiationType||(e.InstantiationType={}));function O(w,g,l){g instanceof T.SyncDescriptor||(g=new T.SyncDescriptor(g,[],Boolean(l))),R.push([w,g])}e.registerSingleton=O;function k(){return R}e.getSingletonServiceDescriptors=k}),define(Q[111],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class T{constructor(O,k){this.key=O,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=T;class R{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const k of this.a.values())k.outgoing.size===0&&O.push(k);return O}insertEdge(O,k){const w=this.lookupOrInsertNode(O),g=this.lookupOrInsertNode(k);w.outgoing.set(g.key,g),g.incoming.set(w.key,w)}removeNode(O){const k=this.b(O);this.a.delete(k);for(const w of this.a.values())w.outgoing.delete(k),w.incoming.delete(k)}lookupOrInsertNode(O){const k=this.b(O);let w=this.a.get(k);return w||(w=new T(k,O),this.a.set(k,w)),w}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[k,w]of this.a)O.push(`${k}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,k]of this.a){const w=new Set([O]),g=this.c(k,w);if(g)return g}}c(O,k){for(const[w,g]of O.outgoing){if(k.has(w))return[...k,w].join(" -> ");k.add(w);const l=this.c(g,k);if(l)return l;k.delete(w)}}}e.Graph=R}),define(Q[23],_([0,1,3,11,10]),function(x,e,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function O(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof R.URI)}e.isConfigurationOverrides=O;function k(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=k;var w;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function l(c,f){const y=Object.create(null);for(const S in c)b(y,S,c[S],f);return y}e.toValuesTree=l;function b(c,f,y,S){const p=f.split("."),E=p.pop();let t=c;for(let s=0;s<p.length;s++){const i=p[s];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:S(`Ignoring ${f} as ${p.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[E]=y}catch{S(`Ignoring ${f} as ${p.join(".")} is ${JSON.stringify(t)}`)}else S(`Ignoring ${f} as ${p.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=b;function m(c,f){const y=f.split(".");d(c,y)}e.removeFromValueTree=m;function d(c,f){const y=f.shift();if(f.length===0){delete c[y];return}if(Object.keys(c).indexOf(y)!==-1){const S=c[y];typeof S=="object"&&!Array.isArray(S)&&(d(S,f),Object.keys(S).length===0&&delete c[y])}}function I(c,f,y){function S(t,s){let i=t;for(const n of s){if(typeof i!="object"||i===null)return;i=i[n]}return i}const p=f.split("."),E=S(c,p);return typeof E>"u"?y:E}e.getConfigurationValue=I;function v(c,f,y){Object.keys(f).forEach(S=>{S!=="__proto__"&&(S in c?T.isObject(c[S])&&T.isObject(f[S])?v(c[S],f[S],y):y&&(c[S]=f[S]):c[S]=f[S])})}e.merge=v;function A(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=A}),define(Q[58],_([0,1,10]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,T.createDecorator)("downloadService")}),define(Q[17],_([0,1,10]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,T.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,T.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[24],_([0,1,88,10]),function(x,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough";function P(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function O(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=O;function k(f,y){switch(f){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function w(f,y){return y==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function g(f,y,S){return w(y,S)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===S?!0:l(S).includes(f)}e.isTargetPlatformCompatible=g;function l(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=l;function b(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=b;var m;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(m=e.SortBy||(e.SortBy={}));var d;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(d=e.SortOrder||(e.SortOrder={}));var I;(function(f){f.Install="install",f.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var v;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var A;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(A=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class c extends Error{constructor(y,S){super(y),this.code=S,this.name=S}}e.ExtensionManagementError=c,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,T.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Q[59],_([0,1,10]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,T.createDecorator)("IExtensionSignatureVerificationService");class R{b(){return this.a||(this.a=new Promise((O,k)=>x(["node-vsce-sign"],async w=>O(w),k))),this.a}async verify(O,k){let w;try{w=await this.b()}catch{return!1}return w.verify(O,k)}}e.ExtensionSignatureVerificationService=R}),define(Q[60],_([0,1,15,7,96,13]),function(x,e,T,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(b,m,d,I,v,A){let c;try{await w(b,m,d,I,v,A)}catch(f){c=f}finally{c&&v.errorTransformer&&(c=v.errorTransformer(c)),typeof c<"u"&&d.error(c),d.end()}}e.readFileIntoStream=k;async function w(b,m,d,I,v,A){g(A);const c=await b.open(m,{create:!1});try{g(A);let f=0,y=0,S=v&&typeof v.length=="number"?v.length:void 0,p=T.VSBuffer.alloc(Math.min(v.bufferSize,typeof S=="number"?S:v.bufferSize)),E=v&&typeof v.position=="number"?v.position:0,t=0;do y=await b.read(c,E,p.buffer,t,p.byteLength-t),E+=y,t+=y,f+=y,typeof S=="number"&&(S-=y),t===p.byteLength&&(await d.write(I(p)),p=T.VSBuffer.alloc(Math.min(v.bufferSize,typeof S=="number"?S:v.bufferSize)),t=0);while(y>0&&(typeof S!="number"||S>0)&&g(A)&&l(f,v));if(t>0){let s=t;typeof S=="number"&&(s=Math.min(t,S)),d.write(I(p.slice(0,s)))}}catch(f){throw(0,O.ensureFileSystemProviderError)(f)}finally{await b.close(c)}}function g(b){if(b.isCancellationRequested)throw(0,R.canceled)();return!0}function l(b,m){if(m?.limits){if(typeof m.limits.memory=="number"&&b>m.limits.memory)throw(0,O.createFileSystemProviderError)((0,P.localize)(0,null),O.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof m.limits.size=="number"&&b>m.limits.size)throw(0,O.createFileSystemProviderError)((0,P.localize)(1,null),O.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[112],_([0,1,4,158,2,12,159]),function(x,e,T,R,P,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class w extends P.Disposable{constructor(){super(...arguments),this.a=this.B(new T.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new T.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=T.Event.None,this.c=new Map,this.f=!1}async watch(l){const b=this.i(l),m=b.filter(I=>{const v=this.c.get(I.path);return v?!(0,R.patternsEquals)(v.request.excludes,I.excludes)||!(0,R.patternsEquals)(v.request.includes,I.includes):!0}),d=Array.from(this.c.values()).filter(({request:I})=>!b.find(v=>v.path===I.path&&(0,R.patternsEquals)(v.excludes,I.excludes)&&(0,R.patternsEquals)(v.includes,I.includes))).map(({request:I})=>I.path);m.length&&this.j(`Request to start watching: ${m.map(I=>`${I.path} (excludes: ${I.excludes.length>0?I.excludes:"<none>"}, includes: ${I.includes&&I.includes.length>0?JSON.stringify(I.includes):"<all>"})`).join(",")}`),d.length&&this.j(`Request to stop watching: ${d.join(",")}`);for(const I of d)this.h(I);for(const I of m)this.g(I)}g(l){const b=new k.NodeJSFileWatcherLibrary(l,d=>this.a.fire(d),d=>this.b.fire(d),this.f),m={request:l,instance:b};this.c.set(l.path,m)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const b=this.c.get(l);b&&(this.c.delete(l),b.instance.dispose())}i(l){const b=new Map;for(const m of l){const d=O.isLinux?m.path:m.path.toLowerCase();b.set(d,m)}return Array.from(b.values())}async setVerboseLogging(l){this.f=l;for(const[,b]of this.c)b.instance.setVerboseLogging(l)}j(l){this.f&&this.b.fire({type:"trace",message:this.k(l)})}k(l,b){return b?`[File Watcher (node.js)] ${l} (path: ${b.request.path})`:`[File Watcher (node.js)] ${l}`}}e.NodeJSWatcher=w}),define(Q[113],_([0,1,61,112]),function(x,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class P extends T.AbstractNonRecursiveWatcherClient{constructor(k,w,g){super(k,w,g),this.m()}l(){return new R.NodeJSWatcher}}e.NodeJSWatcherClient=P}),define(Q[114],_([0,1,16,56,83,61]),function(x,e,T,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends O.AbstractUniversalWatcherClient{constructor(g,l,b){super(g,l,b),this.m()}l(g){const l=g.add(new P.Client(T.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(l.onDidProcessExit(({code:b,signal:m})=>this.n(`terminated by itself with code ${b}, signal: ${m}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(Q[62],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class T{constructor(...P){this.a=new Map;for(const[O,k]of P)this.set(O,k)}set(P,O){const k=this.a.get(P);return this.a.set(P,O),k}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.ServiceCollection=T}),define(Q[115],_([0,1,5,7,2,46,111,10,62,160]),function(x,e,T,R,P,O,k,w,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class m extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class d{constructor(c=new g.ServiceCollection,f=!1,y,S=b){this.f=c,this.g=f,this.h=y,this.i=S,this.o=new Set,this.f.set(w.IInstantiationService,this),this._globalGraph=S?y?._globalGraph??new k.Graph(p=>p):void 0}createChild(c){return new d(c,this.g,this,this.i)}invokeFunction(c,...f){const y=v.traceInvocation(this.i,c);let S=!1;try{return c({get:E=>{if(S)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(E,y);if(!t)throw new Error(`[invokeFunction] unknown service '${E}'`);return t}},...f)}finally{S=!0,y.stop()}}createInstance(c,...f){let y,S;return c instanceof O.SyncDescriptor?(y=v.traceCreation(this.i,c.ctor),S=this.j(c.ctor,c.staticArguments.concat(f),y)):(y=v.traceCreation(this.i,c),S=this.j(c,f,y)),y.stop(),S}j(c,f=[],y){const S=w._util.getServiceDependencies(c).sort((t,s)=>t.index-s.index),p=[];for(const t of S){const s=this.m(t.id,y);s||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(s)}const E=S.length>0?S[0].index:f.length;if(f.length!==E){console.trace(`[createInstance] First service dependency of ${c.name} at position ${E+1} conflicts with ${f.length} static arguments`);const t=E-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,E)}return Reflect.construct(c,f.concat(p))}k(c,f){if(this.f.get(c)instanceof O.SyncDescriptor)this.f.set(c,f);else if(this.h)this.h.k(c,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const f=this.f.get(c);return!f&&this.h?this.h.l(c):f}m(c,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const y=this.l(c);return y instanceof O.SyncDescriptor?this.q(c,y,f.branch(c,!0)):(f.branch(c,!1),y)}q(c,f,y){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,f,y)}finally{this.o.delete(c)}}r(c,f,y){const S=new k.Graph(t=>t.id.toString());let p=0;const E=[{id:c,desc:f,_trace:y}];for(;E.length;){const t=E.pop();if(S.lookupOrInsertNode(t),p++>1e3)throw new m(S);for(const s of w._util.getServiceDependencies(t.desc.ctor)){const i=this.l(s.id);if(i||this.u(`[createInstance] ${c} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),i instanceof O.SyncDescriptor){const n={id:s.id,desc:i,_trace:t._trace.branch(s.id,!0)};S.insertEdge(t,n),E.push(n)}}}for(;;){const t=S.roots();if(t.length===0){if(!S.isEmpty())throw new m(S);break}for(const{data:s}of t){if(this.l(s.id)instanceof O.SyncDescriptor){const n=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,n)}S.removeNode(s)}}return this.l(c)}s(c,f,y=[],S,p){if(this.f.get(c)instanceof O.SyncDescriptor)return this.t(c,f,y,S,p);if(this.h)return this.h.s(c,f,y,S,p);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(c,f,y=[],S,p){if(S){const E=new d(void 0,this.g,this,this.i);E.c=String(c);const t=new Map,s=new T.IdleValue(()=>{const i=E.j(f,y,p);for(const[n,r]of t){const o=i[n];if(typeof o=="function")for(const a of r)o.apply(i,a)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let a=t.get(n);return a||(a=new l.LinkedList,t.set(n,a)),(u,D,F)=>{const Y=a.push([u,D,F]);return(0,P.toDisposable)(Y)}}if(n in i)return i[n];const r=s.value;let o=r[n];return typeof o!="function"||(o=o.bind(r),i[n]=o),o},set(i,n,r){return s.value[n]=r,!0},getPrototypeOf(i){return f.prototype}})}else return this.j(f,y,p)}u(c,f){if(f&&console.warn(c),this.g)throw new Error(c)}}e.InstantiationService=d;var I;(function(A){A[A.None=0]="None",A[A.Creation=1]="Creation",A[A.Invocation=2]="Invocation",A[A.Branch=3]="Branch"})(I||(I={}));class v{static traceInvocation(c,f){return c?new v(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(c,f){return c?new v(1,f.name):v.c}constructor(c,f){this.type=c,this.name=f,this.g=Date.now(),this.h=[]}branch(c,f){const y=new v(3,c.toString());return this.h.push([c,f,y]),y}stop(){const c=Date.now()-this.g;v.f+=c;let f=!1;function y(p,E){const t=[],s=new Array(p+1).join("	");for(const[i,n,r]of E.h)if(n&&r){f=!0,t.push(`${s}CREATES -> ${i}`);const o=y(p+1,r);o&&t.push(o)}else t.push(`${s}uses -> ${i}`);return t.join(`
`)}const S=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(c>2||f)&&v.all.add(S.join(`
`))}}e.Trace=v,v.all=new Set,v.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}},v.f=0});var ee=this&&this.__param||function(x,e){return function(T,R){e(T,R,x)}};define(Q[63],_([0,1,22,2,12,98,24,10]),function(x,e,T,R,P,O,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function g(b){return b.tags.find(m=>m.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=g,e.ILanguagePackService=(0,w.createDecorator)("languagePackService");let l=class extends R.Disposable{constructor(m){super(),this.c=m}async getAvailableLanguages(){const m=new T.CancellationTokenSource;setTimeout(()=>m.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},m.token)}catch{return[]}const v=d.firstPage.filter(A=>A.properties.localizedLanguages?.length&&A.tags.some(c=>c.startsWith("lp-"))).map(A=>{const c=A.properties.localizedLanguages?.[0],f=g(A);return{...this.f(f,c,A),extensionId:A.identifier.id,galleryExtension:A}});return v.push(this.f("en","English")),v}f(m,d,I){const v=d??m;let A;if(v!==m&&(A=`(${m})`),m.toLowerCase()===P.language.toLowerCase()&&(A??="",A+=(0,O.localize)(0,null)),I?.installCount){A??="";const c=I.installCount;let f;c>1e6?f=`${Math.floor(c/1e5)/10}M`:c>1e3?f=`${Math.floor(c/1e3)}K`:f=String(c),A+=` $(cloud-download) ${f}`}return{id:m,label:v,description:A}}};l=fe([ee(0,k.IExtensionGalleryService)],l),e.LanguagePackBaseService=l}),define(Q[6],_([0,1,34,4,2,36,12,3,11,10]),function(x,e,T,R,P,O,k,w,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.setLogLevel=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,l.createDecorator)("logService"),e.ILoggerService=(0,l.createDecorator)("loggerService");function b(){return new Date().toISOString()}function m(h){return(0,w.isNumber)(h)}e.isLogLevel=m;var d;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function I(h,u,D){switch(u){case d.Trace:h.trace(D);break;case d.Debug:h.debug(D);break;case d.Info:h.info(D);break;case d.Warning:h.warn(D);break;case d.Error:h.error(D);break;case d.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=I;function v(h){let u="";for(let D=0;D<h.length;D++){let F=h[D];if(typeof F=="object")try{F=JSON.stringify(F)}catch{}u+=(D>0?" ":"")+F}return u}e.format=v;class A extends P.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new R.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(u){this.b!==u&&(this.b=u,this.c.fire(this.b))}getLevel(){return this.b}f(u){return this.b!==d.Off&&this.b<=u}}e.AbstractLogger=A;class c extends A{constructor(u){super(),this.h=u}f(u){return this.h||super.f(u)}trace(u,...D){this.f(d.Trace)&&this.g(d.Trace,v([u,...D]))}debug(u,...D){this.f(d.Debug)&&this.g(d.Debug,v([u,...D]))}info(u,...D){this.f(d.Info)&&this.g(d.Info,v([u,...D]))}warn(u,...D){this.f(d.Warning)&&this.g(d.Warning,v([u,...D]))}error(u,...D){if(this.f(d.Error))if(u instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=u.stack,this.g(d.Error,v(F))}else this.g(d.Error,v([u,...D]))}flush(){}}e.AbstractMessageLogger=c;class f extends A{constructor(u=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(u),this.g=!k.isWindows}trace(u,...D){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,u,...D):console.log(`[main ${b()}]`,u,...D))}debug(u,...D){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,u,...D):console.log(`[main ${b()}]`,u,...D))}info(u,...D){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,u,...D):console.log(`[main ${b()}]`,u,...D))}warn(u,...D){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,u,...D):console.warn(`[main ${b()}]`,u,...D))}error(u,...D){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,u,...D):console.error(`[main ${b()}]`,u,...D))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class y extends A{constructor(u=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(u)}trace(u,...D){this.f(d.Trace)&&console.log("%cTRACE","color: #888",u,...D)}debug(u,...D){this.f(d.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",u,...D)}info(u,...D){this.f(d.Info)&&console.log("%c INFO","color: #33f",u,...D)}warn(u,...D){this.f(d.Warning)&&console.log("%c WARN","color: #993",u,...D)}error(u,...D){this.f(d.Error)&&console.log("%c  ERR","color: #f33",u,...D)}dispose(){}flush(){}}e.ConsoleLogger=y;class S extends A{constructor(u,D=e.DEFAULT_LOG_LEVEL){super(),this.g=u,this.setLevel(D)}trace(u,...D){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(u),...D])}debug(u,...D){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(u),...D])}info(u,...D){this.f(d.Info)&&this.g.log(d.Info,[this.h(u),...D])}warn(u,...D){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(u),...D])}error(u,...D){this.f(d.Error)&&this.g.log(d.Error,[this.h(u),...D])}h(u){return typeof u=="string"?u:(0,T.toErrorMessage)(u,this.f(d.Trace))}dispose(){}flush(){}}e.AdapterLogger=S;class p extends A{constructor(u){super(),this.g=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const D of this.g)D.setLevel(u);super.setLevel(u)}trace(u,...D){for(const F of this.g)F.trace(u,...D)}debug(u,...D){for(const F of this.g)F.debug(u,...D)}info(u,...D){for(const F of this.g)F.info(u,...D)}warn(u,...D){for(const F of this.g)F.warn(u,...D)}error(u,...D){for(const F of this.g)F.error(u,...D)}flush(){for(const u of this.g)u.flush()}dispose(){for(const u of this.g)u.dispose()}}e.MultiplexLogger=p;class E extends P.Disposable{constructor(u,D){if(super(),this.j=u,this.b=new O.ResourceMap,this.c=new O.ResourceMap,this.f=this.B(new R.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new R.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new R.Emitter),this.onDidChangeVisibility=this.h.event,D)for(const F of D)this.c.set(F.resource,F)}getLogger(u){return this.b.get(u)}createLogger(u,D){let F=this.b.get(u);const Y=D?.logLevel==="always"?d.Trace:D?.logLevel;return F||(F=this.k(u,Y??this.getLogLevel(u)??this.j,D),this.b.set(u,F)),this.registerLogger({resource:u,id:D?.id??u.toString(),logLevel:Y,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId}),F}setLogLevel(u,D){if(g.URI.isUri(u)){const F=u,Y=D,Z=this.c.get(F);Z&&Y!==Z.logLevel&&(Z.logLevel=Y===this.j?void 0:Y,this.b.get(F)?.setLevel(Y),this.c.set(Z.resource,Z),this.g.fire([F,Y]))}else{this.j=u;for(const[F,Y]of this.b.entries())this.c.get(F)?.logLevel===void 0&&Y.setLevel(this.j);this.g.fire(this.j)}}setVisibility(u,D){const F=this.c.get(u);F&&D!==!F.hidden&&(F.hidden=!D,this.c.set(F.resource,F),this.h.fire([u,D]))}getLogLevel(u){let D;return u&&(D=this.c.get(u)?.logLevel),D??this.j}registerLogger(u){const D=this.c.get(u.resource);D?D.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this.c.set(u.resource,u),this.f.fire({added:[u],removed:[]}))}deregisterLogger(u){const D=this.c.get(u);if(D){this.c.delete(u);const F=this.b.get(u);F&&(this.b.delete(u),F.dispose()),this.f.fire({added:[],removed:[D]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(u){return this.c.get(u)}dispose(){this.b.forEach(u=>u.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=E;class t{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(u){}getLevel(){return d.Info}trace(u,...D){}debug(u,...D){}info(u,...D){}warn(u,...D){}error(u,...D){}critical(u,...D){}dispose(){}flush(){}}e.NullLogger=t;class s extends t{}e.NullLogService=s;class i extends E{constructor(){super(d.Info)}k(u,D,F){return new t}}e.NullLoggerService=i;function n(h){if(h.verbose)return d.Trace;if(typeof h.logLevel=="string"){const u=o(h.logLevel.toLowerCase());if(u!==void 0)return u}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function r(h){switch(h){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.LogLevelToString=r;function o(h){switch(h){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.parseLogLevel=o;function a(h,u){m(u)?h.setLogLevel(u):h.setLogLevel(u[0],u[1])}e.setLogLevel=a}),define(Q[116],_([0,1,19,5,7,4,2,14,61,6]),function(x,e,T,R,P,O,k,w,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends k.Disposable{constructor(d,I){super(),this.a=d,this.b=I,this.c=this.B(new O.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new O.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new R.ThrottledDelayer(0)),this.s=[],this.t=this.B(new R.ThrottledDelayer(0))}watch(d,I){return I.recursive||this.b?.watcher?.forceUniversal?this.l(d,I):this.u(d,I)}l(d,I){const v={path:this.C(d),excludes:I.excludes,includes:I.includes,recursive:I.recursive},A=(0,T.insert)(this.j,v);return this.m(),(0,k.toDisposable)(()=>{A(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(d=>(0,P.onUnexpectedError)(d))}n(){this.h||(this.h=this.B(this.p(I=>this.c.fire((0,g.toFileChanges)(I)),I=>this.z(I),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const I of this.j)(0,g.isRecursiveWatchRequest)(I)&&(I.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const I of this.j)(0,g.isRecursiveWatchRequest)(I)&&d.includes(I.path)&&(I.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(d,I){const v={path:this.C(d),excludes:I.excludes,includes:I.includes,recursive:!1},A=(0,T.insert)(this.s,v);return this.v(),(0,k.toDisposable)(()=>{A(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(d=>(0,P.onUnexpectedError)(d))}w(){return this.r||(this.r=this.B(this.y(d=>this.c.fire((0,g.toFileChanges)(d)),d=>this.z(d),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.r.watch(this.s)}z(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}C(d){return(0,w.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(Q[117],_([0,1,19,5,15,22,4,52,64,2,54,16,118,18,43,95,13,60,6,7]),function(x,e,T,R,P,O,k,w,g,l,b,m,d,I,v,A,c,f,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let p=class extends l.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new k.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new k.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new k.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new k.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new R.ResourceQueue)}registerProvider(t,s){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${t}`);const i=new l.DisposableStore;return this.h.set(t,s),this.c.fire({added:!0,scheme:t,provider:s}),i.add(s.onDidChangeFile(n=>this.R.fire(new c.FileChangesEvent(n,!this.O(s))))),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:t}))),(0,l.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:s}),this.h.delete(t),(0,l.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const s=[];this.f.fire({scheme:t,join(i){s.push(i)}}),!this.h.has(t)&&await R.Promises.settled(s)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,s){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return g.Iterable.map(this.h,([t,s])=>({scheme:t,capabilities:s.capabilities}))}async j(t){if(!(0,I.isAbsolutePath)(t))throw new c.FileOperationError((0,A.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const s=this.h.get(t.scheme);if(!s){const i=new S.ErrorNoTelemetry;throw i.message=(0,A.localize)(1,null,t.toString()),i}return s}async k(t){const s=await this.j(t);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s)||(0,c.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const s=await this.j(t);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,s){try{return await this.n(t,s)}catch(i){throw(0,c.toFileSystemProviderErrorCode)(i)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,A.localize)(2,null,this.nb(t)),1):(0,c.ensureFileSystemProviderError)(i)}}async n(t,s){const i=await this.j(t),n=this.O(i),r=s?.resolveTo,o=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,h=await i.stat(t);let u;return this.p(i,t,h,void 0,!!a,(D,F)=>(u||(u=b.TernarySearchTree.forUris(()=>!n),u.set(t,!0),r&&u.fill(!0,r)),u.get(D.resource)||u.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&o?F===1:!1))}async p(t,s,i,n,r,o){const{providerExtUri:a}=this.N(t),h={resource:s,name:a.basename(s),isFile:(i.type&c.FileType.File)!==0,isDirectory:(i.type&c.FileType.Directory)!==0,isSymbolicLink:(i.type&c.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&c.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,c.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(h.isDirectory&&o(h,n)){try{const u=await t.readdir(s),D=await R.Promises.settled(u.map(async([F,Y])=>{try{const Z=a.joinPath(s,F),te=r?await t.stat(Z):{type:Y};return await this.p(t,Z,te,u.length,r,o)}catch(Z){return this.b.trace(Z),null}}));h.children=(0,T.coalesce)(D)}catch(u){this.b.trace(u),h.children=[]}return h}return h}async resolveAll(t){return R.Promises.settled(t.map(async s=>{try{return{stat:await this.n(s.resource,s.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const s=await this.j(t),i=await s.stat(t);return this.p(s,t,i,void 0,!0,()=>!1)}async exists(t){const s=await this.j(t);try{return!!await s.stat(t)}catch{return!1}}async canCreateFile(t,s){try{await this.r(t,s)}catch(i){return i}return!0}async r(t,s){if(!s?.overwrite&&await this.exists(t))throw new c.FileOperationError((0,A.localize)(3,null,this.nb(t)),3,s)}async createFile(t,s=P.VSBuffer.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,s);return this.m.fire(new c.FileOperationEvent(t,0,n)),n}async writeFile(t,s,i){const n=this.lb(await this.l(t),t),{providerExtUri:r}=this.N(n);try{await this.s(n,t,i)||await this.P(n,r.dirname(t));let a;if((0,c.hasReadWriteCapability)(n)&&!(s instanceof P.VSBuffer))if((0,v.isReadableStream)(s)){const h=await(0,v.peekStream)(s,3);h.ended?a=P.VSBuffer.concat(h.buffer):a=h}else a=(0,v.peekReadable)(s,h=>P.VSBuffer.concat(h),3);else a=s;!(0,c.hasOpenReadWriteCloseCapability)(n)||(0,c.hasReadWriteCapability)(n)&&a instanceof P.VSBuffer?await this.cb(n,t,i,a):await this.Y(n,t,i,a instanceof P.VSBuffer?(0,P.bufferToReadable)(a):a),this.m.fire(new c.FileOperationEvent(t,4))}catch(o){throw new c.FileOperationError((0,A.localize)(4,null,this.nb(t),(0,c.ensureFileSystemProviderError)(o).toString()),(0,c.toFileOperationResult)(o),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,s,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,A.localize)(5,null,this.nb(s)));let r;try{r=await t.stat(s)}catch{return}if((r.type&c.FileType.Directory)!==0)throw new c.FileOperationError((0,A.localize)(6,null,this.nb(s)),0,i);if(this.mb(s,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==c.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,c.etag)({mtime:i.mtime,size:r.size}))throw new c.FileOperationError((0,A.localize)(7,null),3,i);return r}async readFile(t,s,i){const n=await this.k(t);return s?.atomic?this.t(n,t,s,i):this.u(n,t,s,i)}async t(t,s,i,n){return new Promise((r,o)=>{this.X.queueFor(s,this.N(t).providerExtUri).queue(async()=>{try{const a=await this.u(t,s,i,n);r(a)}catch(a){o(a)}})})}async u(t,s,i,n){const r=await this.v(t,s,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,P.streamToBuffer)(r.value)}}async readFileStream(t,s,i){const n=await this.k(t);return this.v(n,t,s,i)}async v(t,s,i,n){const r=new O.CancellationTokenSource(n),o=this.F(s,i).then(h=>h,h=>{throw r.cancel(),h});let a;try{return typeof i?.etag=="string"&&i.etag!==c.ETAG_DISABLED&&await o,i?.atomic&&(0,c.hasFileAtomicReadCapability)(t)||!((0,c.hasOpenReadWriteCloseCapability)(t)||(0,c.hasFileReadStreamCapability)(t))||(0,c.hasReadWriteCapability)(t)&&i?.preferUnbuffered?a=this.D(t,s,i):(0,c.hasFileReadStreamCapability)(t)?a=this.z(t,s,r.token,i):a=this.C(t,s,r.token,i),{...await o,value:a}}catch(h){throw a&&await(0,v.consumeStream)(a),this.w(h,s,i)}}w(t,s,i){const n=(0,A.localize)(8,null,this.nb(s),(0,c.ensureFileSystemProviderError)(t).toString());return t instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof c.TooLargeFileOperationError?new c.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new c.FileOperationError(n,(0,c.toFileOperationResult)(t),i)}z(t,s,i,n=Object.create(null)){const r=t.readFileStream(s,n,i);return(0,v.transform)(r,{data:o=>o instanceof P.VSBuffer?o:P.VSBuffer.wrap(o),error:o=>this.w(o,s,n)},o=>P.VSBuffer.concat(o))}C(t,s,i,n=Object.create(null)){const r=(0,P.newWriteableBufferStream)();return(0,f.readFileIntoStream)(t,s,r,o=>o,{...n,bufferSize:this.a,errorTransformer:o=>this.w(o,s,n)},i),r}D(t,s,i){const n=(0,v.newWriteableStream)(r=>P.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,c.hasFileAtomicReadCapability)(t)?r=await t.readFile(s,{atomic:!0}):r=await t.readFile(s),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.G(s,r.byteLength,i),n.end(P.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async F(t,s){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new c.FileOperationError((0,A.localize)(9,null,this.nb(t)),0,s);if(typeof s?.etag=="string"&&s.etag!==c.ETAG_DISABLED&&s.etag===i.etag)throw new c.NotModifiedSinceFileOperationError((0,A.localize)(10,null),i,s);return this.G(t,i.size,s),i}G(t,s,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&s>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&s>i.limits.size&&(n=7),typeof n=="number")throw new c.TooLargeFileOperationError((0,A.localize)(11,null,this.nb(t)),n,s,i)}}async canMove(t,s,i){return this.H(t,s,"move",i)}async canCopy(t,s,i){return this.H(t,s,"copy",i)}async H(t,s,i,n){if(t.toString()!==s.toString())try{const r=i==="move"?this.lb(await this.l(t),t):await this.k(t),o=this.lb(await this.l(s),s);await this.M(r,t,o,s,i,n)}catch(r){return r}return!0}async move(t,s,i){const n=this.lb(await this.l(t),t),r=this.lb(await this.l(s),s),o=await this.I(n,t,r,s,"move",!!i),a=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(t,o==="move"?2:3,a)),a}async copy(t,s,i){const n=await this.k(t),r=this.lb(await this.l(s),s),o=await this.I(n,t,r,s,"copy",!!i),a=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(t,o==="copy"?3:2,a)),a}async I(t,s,i,n,r,o){if(s.toString()===n.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:h}=await this.M(t,s,i,n,r,o);if(a&&!h&&o&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),r==="copy"){if(t===i&&(0,c.hasFileFolderCopyCapability)(t))await t.copy(s,n,{overwrite:o});else{const u=await this.resolve(s);u.isDirectory?await this.L(t,u,i,n):await this.J(t,s,i,n)}return r}else return t===i?(await t.rename(s,n,{overwrite:o}),r):(await this.I(t,s,i,n,"copy",o),await this.del(s,{recursive:!0}),"copy")}async J(t,s,i,n){if((0,c.hasOpenReadWriteCloseCapability)(t)&&(0,c.hasOpenReadWriteCloseCapability)(i))return this.eb(t,s,i,n);if((0,c.hasOpenReadWriteCloseCapability)(t)&&(0,c.hasReadWriteCapability)(i))return this.kb(t,s,i,n);if((0,c.hasReadWriteCapability)(t)&&(0,c.hasOpenReadWriteCloseCapability)(i))return this.ib(t,s,i,n);if((0,c.hasReadWriteCapability)(t)&&(0,c.hasReadWriteCapability)(i))return this.gb(t,s,i,n)}async L(t,s,i,n){await i.mkdir(n),Array.isArray(s.children)&&await R.Promises.settled(s.children.map(async r=>{const o=this.N(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),i,o):this.J(t,r.resource,i,o)}))}async M(t,s,i,n,r,o){let a=!1;if(t===i){const{providerExtUri:u,isPathCaseSensitive:D}=this.N(t);if(D||(a=u.isEqual(s,n)),a&&r==="copy")throw new Error((0,A.localize)(12,null,this.nb(s),this.nb(n)));if(!a&&u.isEqualOrParent(n,s))throw new Error((0,A.localize)(13,null,this.nb(s),this.nb(n)))}const h=await this.exists(n);if(h&&!a){if(!o)throw new c.FileOperationError((0,A.localize)(14,null,this.nb(s),this.nb(n)),4);if(t===i){const{providerExtUri:u}=this.N(t);if(u.isEqualOrParent(s,n))throw new Error((0,A.localize)(15,null,this.nb(s),this.nb(n)))}}return{exists:h,isSameResourceWithDifferentPathCase:a}}N(t){const s=this.O(t);return{providerExtUri:s?I.extUri:I.extUriIgnorePathCase,isPathCaseSensitive:s}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const s=this.lb(await this.j(t),t);await this.P(s,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(t,0,i)),i}async P(t,s){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(s,n.dirname(s));)try{if(((await t.stat(s)).type&c.FileType.Directory)===0)throw new Error((0,A.localize)(16,null,this.nb(s)));break}catch(r){if((0,c.toFileSystemProviderErrorCode)(r)!==c.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(s)),s=n.dirname(s)}for(let r=i.length-1;r>=0;r--){s=n.joinPath(s,i[r]);try{await t.mkdir(s)}catch(o){if((0,c.toFileSystemProviderErrorCode)(o)!==c.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,s){try{await this.Q(t,s)}catch(i){return i}return!0}async Q(t,s){const i=this.lb(await this.j(t),t);if(!!s?.useTrash&&!(i.capabilities&4096))throw new Error((0,A.localize)(17,null,this.nb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.mb(t,r);else throw new c.FileOperationError((0,A.localize)(18,null,this.nb(t)),1);if(!!!s?.recursive){const a=await this.resolve(t);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,A.localize)(19,null,this.nb(t)))}return i}async del(t,s){const i=await this.Q(t,s),n=!!s?.useTrash,r=!!s?.recursive;await i.delete(t,{recursive:r,useTrash:n}),this.m.fire(new c.FileOperationEvent(t,1))}async cloneFile(t,s){const i=await this.j(t),n=this.lb(await this.l(s),s);if(i===n&&this.N(i).providerExtUri.isEqual(t,s))return;if(i===n&&(0,c.hasFileCloneCapability)(i))return i.cloneFile(t,s);await this.P(n,this.N(n).providerExtUri.dirname(s));const r=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,c.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(t,s,{overwrite:!0})):r.queue(()=>this.J(i,t,n,s))}watch(t,s={recursive:!1,excludes:[]}){const i=new l.DisposableStore;let n=!1,r=()=>{n=!0};return i.add((0,l.toDisposable)(()=>r())),(async()=>{try{const o=await this.W(t,s);n?(0,l.dispose)(o):r=()=>(0,l.dispose)(o)}catch(o){this.b.error(o)}})(),i}async W(t,s){const i=await this.j(t),n=(0,w.hash)([this.N(i).providerExtUri.getComparisonKey(t),s]);let r=this.U.get(n);return r||(r={count:0,disposable:i.watch(t,s)},this.U.set(n,r)),r.count+=1,(0,l.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,l.dispose)(r.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,l.dispose)(t.disposable);this.U.clear()}async Y(t,s,i,n){return this.X.queueFor(s,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,v.isReadableStream)(n)||(0,v.isReadableBufferedStream)(n)?await this.Z(t,r,n):await this.ab(t,r,n)}catch(o){throw(0,c.ensureFileSystemProviderError)(o)}finally{await t.close(r)}})}async Z(t,s,i){let n=0,r;if((0,v.isReadableBufferedStream)(i)){if(i.buffer.length>0){const o=P.VSBuffer.concat(i.buffer);await this.bb(t,s,o,o.byteLength,n,0),n+=o.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((o,a)=>{(0,v.listenStream)(r,{onData:async h=>{r.pause();try{await this.bb(t,s,h,h.byteLength,n,0)}catch(u){return a(u)}n+=h.byteLength,setTimeout(()=>r.resume())},onError:h=>a(h),onEnd:()=>o()})})}async ab(t,s,i){let n=0,r;for(;(r=i.read())!==null;)await this.bb(t,s,r,r.byteLength,n,0),n+=r.byteLength}async bb(t,s,i,n,r,o){let a=0;for(;a<n;)a+=await t.write(s,r+a,i.buffer,o+a,n-a)}async cb(t,s,i,n){return this.X.queueFor(s,this.N(t).providerExtUri).queue(()=>this.db(t,s,i,n))}async db(t,s,i,n){let r;n instanceof P.VSBuffer?r=n:(0,v.isReadableStream)(n)?r=await(0,P.streamToBuffer)(n):(0,v.isReadableBufferedStream)(n)?r=await(0,P.bufferedStreamToBuffer)(n):r=(0,P.readableToBuffer)(n),await t.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,s,i,n))}async fb(t,s,i,n){let r,o;try{r=await t.open(s,{create:!1}),o=await i.open(n,{create:!0,unlock:!1});const a=P.VSBuffer.alloc(this.a);let h=0,u=0,D=0;do D=await t.read(r,h,a.buffer,u,a.byteLength-u),await this.bb(i,o,a,D,h,u),h+=D,u+=D,u===a.byteLength&&(u=0);while(D>0)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await R.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async gb(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,s,i,n))}async hb(t,s,i,n){return i.writeFile(n,await t.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async ib(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,s,i,n))}async jb(t,s,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const o=await t.readFile(s);await this.bb(i,r,P.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,c.ensureFileSystemProviderError)(o)}finally{await i.close(r)}}async kb(t,s,i,n){const r=await(0,P.streamToBuffer)(this.C(t,s,O.CancellationToken.None));await this.cb(i,n,void 0,r)}lb(t,s){if(t.capabilities&2048)throw new c.FileOperationError((0,A.localize)(20,null,this.nb(s)),6);return t}mb(t,s){if((s.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,A.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===m.Schemas.file?t.fsPath:t.toString(!0)}};p=fe([ee(0,y.ILogService)],p),e.FileService=p}),define(Q[119],_([0,1,120,161,5,36,15,4,162,2,14,12,18,43,20,97,13,60,116,34,114,113]),function(x,e,T,R,P,O,k,w,g,l,b,m,d,I,v,A,c,f,y,S,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(T)}catch(s){console.error(`Error enabling graceful-fs: ${(0,S.toErrorMessage)(s)}`)}})();class t extends y.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=w.Event.None,this.H=new O.ResourceMap(r=>d.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,m.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:r}=await v.SymlinkSupport.stat(this.C(i));return{type:this.G(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await v.Promises.readdir(this.C(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async o=>{try{let a;o.isSymbolicLink()?a=(await this.stat((0,d.joinPath)(i,o.name))).type:a=this.G(o),r.push([o.name,a])}catch(a){this.a.trace(a)}})),r}catch(n){throw this.Y(n)}}G(i,n){let r;return n?.dangling?r=c.FileType.Unknown:i.isFile()?r=c.FileType.File:i.isDirectory()?r=c.FileType.Directory:r=c.FileType.Unknown,n&&(r|=c.FileType.SymbolicLink),r}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const o=new P.Barrier;return this.H.set(i,o),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,l.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===o&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),r=await this.I(i));const o=this.C(i);return await v.Promises.readFile(o)}catch(o){throw this.Y(o)}finally{r?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,r){const o=(0,I.newWriteableStream)(a=>k.VSBuffer.concat(a.map(h=>k.VSBuffer.wrap(h))).buffer);return(0,f.readFileIntoStream)(this,i,o,a=>a.buffer,{...n,bufferSize:256*1024},r),o}async writeFile(i,n,r){let o;try{const a=this.C(i);if(!r.create||!r.overwrite){if(await v.Promises.exists(a)){if(!r.overwrite)throw(0,c.createFileSystemProviderError)((0,A.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,c.createFileSystemProviderError)((0,A.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(o,0,n,0,n.byteLength)}catch(a){throw await this.Z(i,a)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const r=this.C(i);let o;(0,c.isFileOpenForWriteOptions)(n)&&(o=await this.I(i));let a;try{if((0,c.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:u}=await v.SymlinkSupport.stat(r);u.mode&128||await v.Promises.chmod(r,u.mode|128)}catch(u){this.a.trace(u)}let h;if((0,c.isFileOpenForWriteOptions)(n)){if(m.isWindows)try{await v.Promises.truncate(r,0),h="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}h||(h="w")}else h="r";a=await v.Promises.open(r,h)}catch(h){throw o?.dispose(),(0,c.isFileOpenForWriteOptions)(n)?await this.Z(i,h):this.Y(h)}if(this.L.set(a,0),(0,c.isFileOpenForWriteOptions)(n)&&this.N.set(a,i),o){const h=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${r})`),this.M.set(a,o),h&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${r})`),h.dispose())}return a}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await v.Promises.fdatasync(i)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await v.Promises.close(i)}catch(r){throw this.Y(r)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,o,a){const h=this.P(i,n);let u=null;try{u=(await v.Promises.read(i,r,o,a,h)).bytesRead}catch(D){throw this.Y(D)}finally{this.Q(i,h,u)}return u}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,r){const o=this.L.get(i);typeof o=="number"&&(typeof n=="number"||(typeof r=="number"?this.L.set(i,o+r):this.L.delete(i)))}async write(i,n,r,o,a){return(0,P.retry)(()=>this.R(i,n,r,o,a),100,3)}async R(i,n,r,o,a){const h=this.P(i,n);let u=null;try{u=(await v.Promises.write(i,r,o,a,h)).bytesWritten}catch(D){throw await this.Z(this.N.get(i),D)}finally{this.Q(i,h,u)}return u}async mkdir(i){try{await v.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const r=this.C(i);n.recursive?await v.Promises.rm(r,v.RimRafMode.MOVE):await v.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(i,n,r){const o=this.C(i),a=this.C(n);if(o!==a)try{await this.S(i,n,"move",r.overwrite),await v.Promises.move(o,a)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,A.localize)(2,null,(0,b.basename)(o),(0,b.basename)((0,b.dirname)(a)),h.toString()))),this.Y(h)}}async copy(i,n,r){const o=this.C(i),a=this.C(n);if(o!==a)try{await this.S(i,n,"copy",r.overwrite),await v.Promises.copy(o,a,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,A.localize)(3,null,(0,b.basename)(o),(0,b.basename)((0,b.dirname)(a)),h.toString()))),this.Y(h)}}async S(i,n,r,o){const a=this.C(i),h=this.C(n);let u=!1;if(!!(this.capabilities&1024)||(u=(0,g.isEqual)(a,h,!0)),u&&r==="copy")throw(0,c.createFileSystemProviderError)((0,A.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(!u&&await v.Promises.exists(h)){if(!o)throw(0,c.createFileSystemProviderError)((0,A.localize)(5,null),c.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,r){const o=this.C(i),a=this.C(n),h=!!(this.capabilities&1024);if((0,g.isEqual)(o,a,!h))return;const u=new l.DisposableStore;try{const[D,F]=await Promise.all([this.I(i),this.I(n)]);u.add(D),u.add(F),r&&await v.Promises.mkdir((0,b.dirname)(a),{recursive:!0}),await v.Promises.copyFile(o,a)}catch(D){if(D.code==="ENOENT"&&!r)return this.U(i,n,!0);throw this.Y(D)}finally{u.dispose()}}p(i,n,r){return new p.UniversalWatcherClient(o=>i(o),o=>n(o),r)}y(i,n,r){return new E.NodeJSWatcherClient(o=>i(o),o=>n(o),r)}Y(i){if(i instanceof c.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=c.FileSystemProviderErrorCode.NoPermissions;break;default:n=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(i,n)}async Z(i,n){let r=this.Y(n);if(i&&r.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await v.SymlinkSupport.stat(this.C(i));o.mode&128||(r=(0,c.createFileSystemProviderError)(n,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return r}}e.DiskFileSystemProvider=t,t.D=!1,t.O=!0}),define(Q[121],_([0,1,2,6]),function(x,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class P extends T.Disposable{constructor(k,w=[]){super(),this.a=new R.MultiplexLogger([k,...w]),this.B(k.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(k){this.a.setLevel(k)}getLevel(){return this.a.getLevel()}trace(k,...w){this.a.trace(k,...w)}debug(k,...w){this.a.debug(k,...w)}info(k,...w){this.a.info(k,...w)}warn(k,...w){this.a.warn(k,...w)}error(k,...w){this.a.error(k,...w)}flush(){this.a.flush()}}e.LogService=P}),define(Q[122],_([0,1,13,6]),function(x,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var P;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(P||(P={}));async function O(l,b,m,d,I){try{const v=await new Promise((c,f)=>{x(["spdlog"],c,f)});v.setFlushOn(P.Trace);const A=await v.createAsyncRotatingLogger(l,b,m,d);return I?A.clearFormatters():A.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),A}catch(v){console.error(v)}return null}function k(l,b,m){switch(b){case R.LogLevel.Trace:l.trace(m);break;case R.LogLevel.Debug:l.debug(m);break;case R.LogLevel.Info:l.info(m);break;case R.LogLevel.Warning:l.warn(m);break;case R.LogLevel.Error:l.error(m);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function w(l,b){switch(b){case R.LogLevel.Trace:l.setLevel(P.Trace);break;case R.LogLevel.Debug:l.setLevel(P.Debug);break;case R.LogLevel.Info:l.setLevel(P.Info);break;case R.LogLevel.Warning:l.setLevel(P.Warning);break;case R.LogLevel.Error:l.setLevel(P.Error);break;case R.LogLevel.Off:l.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class g extends R.AbstractMessageLogger{constructor(b,m,d,I,v){super(),this.k=[],this.setLevel(v),this.l=this.n(b,m,d,I),this.B(this.onDidChangeLogLevel(A=>{this.m&&w(this.m,A)}))}async n(b,m,d,I){const v=d?6:1,A=30/v*T.ByteSize.MB,c=await O(b,m,A,v,I);if(c){this.m=c,w(this.m,this.getLevel());for(const{level:f,message:y}of this.k)k(this.m,f,y);this.k=[]}}g(b,m){this.m?k(this.m,b,m):this.getLevel()<=b&&this.k.push({level:b,message:m})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=g}),define(Q[38],_([0,1,4,64,2,10]),function(x,e,T,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,O.createDecorator)("policy");class k extends P.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new T.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const b=Object.keys(this.f).length;return this.f={...l,...this.f},b!==Object.keys(this.f).length&&await this.i(l),R.Iterable.reduce(this.g.entries(),(m,[d,I])=>({...m,[d]:I}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(l,[b,m])=>({...l,[b]:{definition:m,value:this.g.get(b)}}),{})}}e.AbstractPolicyService=k;class w{constructor(){this.onDidChange=T.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=w}),define(Q[123],_([0,1,5,4,64,3,13,6,38]),function(x,e,T,R,P,O,k,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(m,d){const I=[];for(const v of new Set(P.Iterable.concat(m.keys(),d.keys())))m.get(v)!==d.get(v)&&I.push(v);return I}let b=class extends g.AbstractPolicyService{constructor(d,I,v){super(),this.j=d,this.k=I,this.l=v,this.c=this.B(new T.ThrottledDelayer(500));const A=R.Event.filter(I.onDidFilesChange,c=>c.affects(d));this.B(I.watch(d)),this.B(A(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const d=new Map;try{const I=await this.k.readFile(this.j),v=JSON.parse(I.value.toString());if(!(0,O.isObject)(v))throw new Error("Policy file isn't a JSON object");for(const A of Object.keys(v))this.f[A]&&d.set(A,v[A])}catch(I){I.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",I)}return d}async p(){const d=await this.n(),I=l(this.g,d);this.g=d,I.length>0&&this.h.fire(I)}};b=fe([ee(1,k.IFileService),ee(2,w.ILogService)],b),e.FilePolicyService=b}),define(Q[28],_([0,1,10]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,T.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Q[37],_([0,1,70,3]),function(x,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.a=new Map}add(k,w){T.ok(R.isString(k)),T.ok(R.isObject(w)),T.ok(!this.a.has(k),"There is already an extension with this id"),this.a.set(k,w)}knows(k){return this.a.has(k)}as(k){return this.a.get(k)||null}}e.Registry=new P}),define(Q[124],_([0,1,4,37]),function(x,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class O{constructor(){this.b=new T.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,l){this.a[P(g)]=l,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const k=new O;R.Registry.add(e.Extensions.JSONContribution,k)}),define(Q[42],_([0,1,19,4,3,86,23,124,37]),function(x,e,T,R,P,O,k,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var l;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(l=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const m=g.Registry.as(w.Extensions.JSONContribution);class d{constructor(){this.h=new Set,this.i=new R.Emitter,this.onDidSchemaChange=this.i.event,this.j=new R.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},m.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const i=new Set;this.n(t,s,i),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const s=new Set;this.o(t,s),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const i=new Set;this.o(s,i),this.n(t,!1,i),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const i=[];for(const{overrides:n,source:r}of t)for(const o in n)if(s.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const a=this.a.get(o),h=a?.valuesSources??new Map;if(r)for(const Y of Object.keys(n[o]))h.set(Y,r);const u={...a?.value||{},...n[o]};this.a.set(o,{source:r,value:u,valuesSources:h});const D=(0,k.getLanguageTagSettingPlainKey)(o),F={type:"object",default:u,description:O.localize(1,null,D),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:u,source:P.isString(r)?void 0:r,defaultValueSource:r};i.push(...A(o)),this.d[o]=F,this.b.properties[o]=F}else{this.a.set(o,{value:n[o],source:r});const a=this.d[o];a&&(this.w(o,a),this.r(o,a))}this.m(i)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:i,source:n}of t)for(const r in i){const o=this.a.get(r),a=P.isString(n)?n:n?.id,h=P.isString(o?.source)?o?.source:o?.source?.id;if(a===h)if(s.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const u=this.d[r];u&&(this.w(r,u),this.r(r,u))}}this.u()}deltaConfiguration(t){let s=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,i){t.forEach(n=>{this.p(n,s,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,s){const i=n=>{if(n.properties)for(const r in n.properties){s.add(r);const o=this.d[r];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>i(r))};for(const n of t){i(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,s=!0,i,n,r=3,o){r=P.isUndefinedOrNull(t.scope)?r:t.scope;const a=t.properties;if(a)for(const u in a){const D=a[u];if(s&&S(u,D)){delete a[u];continue}if(D.source=i,D.defaultDefaultValue=a[u].default,this.w(u,D),e.OVERRIDE_PROPERTY_REGEX.test(u)?D.scope=void 0:(D.scope=P.isUndefinedOrNull(D.scope)?r:D.scope,D.restricted=P.isUndefinedOrNull(D.restricted)?!!n?.includes(u):D.restricted),a[u].hasOwnProperty("included")&&!a[u].included){this.f[u]=a[u],delete a[u];continue}else this.d[u]=a[u],a[u].policy?.name&&this.e.set(a[u].policy.name,u);!a[u].deprecationMessage&&a[u].markdownDeprecationMessage&&(a[u].deprecationMessage=a[u].markdownDeprecationMessage),o.add(u)}const h=t.allOf;if(h)for(const u of h)this.p(u,s,i,n,r,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=i=>{const n=i.properties;if(n)for(const o in n)this.r(o,n[o]);i.allOf?.forEach(s)};s(t)}r(t,s){switch(e.allSettings.properties[t]=s,s.scope){case 1:e.applicationSettings.properties[t]=s;break;case 2:e.machineSettings.properties[t]=s;break;case 6:e.machineOverridableSettings.properties[t]=s;break;case 3:e.windowSettings.properties[t]=s;break;case 4:e.resourceSettings.properties[t]=s;break;case 5:e.resourceSettings.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.allSettings.properties[t],s.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,i={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(s,i),e.allSettings.properties[s]=i,e.applicationSettings.properties[s]=i,e.machineSettings.properties[s]=i,e.machineOverridableSettings.properties[s]=i,e.windowSettings.properties[s]=i,e.resourceSettings.properties[s]=i}}v(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,s){const i=this.a.get(t);let n=i?.value,r=i?.source;P.isUndefined(n)&&(n=s.defaultDefaultValue,r=void 0),P.isUndefined(n)&&(n=f(s.type)),s.default=n,s.defaultValueSource=r}}const I="\\[([^\\]]+)\\]",v=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function A(E){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(E)){let s=v.exec(E);for(;s?.length;){const i=s[1].trim();i&&t.push(i),s=v.exec(E)}}return(0,T.distinct)(t)}e.overrideIdentifiersFromKey=A;function c(E){return E.reduce((t,s)=>`${t}[${s}]`,"")}e.keyFromOverrideIdentifiers=c;function f(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const y=new d;g.Registry.add(e.Extensions.Configuration,y);function S(E,t){return E.trim()?e.OVERRIDE_PROPERTY_REGEX.test(E)?O.localize(7,null,E):y.getConfigurationProperties()[E]!==void 0?O.localize(8,null,E):t.policy?.name&&y.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,E,t.policy?.name,y.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}e.validateProperty=S;function p(){const E=[],t=y.getConfigurationProperties();for(const s of Object.keys(t))E.push([s,t[s].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=p}),define(Q[65],_([0,1,19,4,50,2,36,30,3,11,23,42,37]),function(x,e,T,R,P,O,k,w,g,l,b,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function I(s){return Object.isFrozen(s)?s:w.deepFreeze(s)}class v{constructor(i={},n=[],r=[],o){this.b=i,this.c=n,this.d=r,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof v)return n;const r=new A("");return r.parseRaw(n),r.configurationModel});this.f=i.reduce((n,r)=>r===n?r:n.merge(r),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,b.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const r=this.rawConfiguration.getValue(i),o=n?this.rawConfiguration.getOverrideValue(i,n):void 0,a=n?this.rawConfiguration.override(n).getValue(i):r;return{value:r,override:o,merged:a}}getOverrideValue(i,n){const r=this.i(n);return r?i?(0,b.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return T.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return T.distinct(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=w.deepClone(this.contents),r=w.deepClone(this.overrides),o=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const h of i)if(a.push(...h.raw?.length?h.raw:[h]),!h.isEmpty()){this.h(n,h.contents);for(const u of h.overrides){const[D]=r.filter(F=>T.equals(F.identifiers,u.identifiers));D?(this.h(D.contents,u.contents),D.keys.push(...u.keys),D.keys=T.distinct(D.keys)):r.push(w.deepClone(u))}for(const u of h.keys)o.indexOf(u)===-1&&o.push(u)}return new v(n,o,r,a.every(h=>h instanceof v)?void 0:a)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const o of T.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[o];const h=n[o];h&&(typeof a=="object"&&typeof h=="object"?(a=w.deepClone(a),this.h(a,h)):a=h),r[o]=a}return new v(r,this.keys,this.overrides)}h(i,n){for(const r of Object.keys(n)){if(r in i&&g.isObject(i[r])&&g.isObject(n[r])){this.h(i[r],n[r]);continue}i[r]=w.deepClone(n[r])}}i(i){let n=null,r=null;const o=a=>{a&&(r?this.h(r,a):r=w.deepClone(a))};for(const a of this.overrides)T.equals(a.identifiers,[i])?n=a.contents:a.identifiers.includes(i)&&o(a.contents);return o(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,b.removeFromValueTree)(this.contents,i),m.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>T.equals(r.identifiers,(0,m.overrideIdentifiersFromKey)(i))),1))}j(i,n,r){(0,b.addToValueTree)(this.contents,i,n,o=>console.error(o)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),m.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,m.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,b.toValuesTree)(this.contents[i],o=>console.error(o))})}}e.ConfigurationModel=v;class A{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!g.isUndefinedOrNull(i)){const r=this.g(i);this.parseRaw(r,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:r,keys:o,overrides:a,restricted:h,hasExcludedProperties:u}=this.h(i,n);this.b=new v(r,o,a,u?[i]:void 0),this.c=h||[]}g(i){let n={},r=null,o=[];const a=[],h=[];function u(F){Array.isArray(o)?o.push(F):r!==null&&(o[r]=F)}const D={onObjectBegin:()=>{const F={};u(F),a.push(o),o=F,r=null},onObjectProperty:F=>{r=F},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const F=[];u(F),a.push(o),o=F,r=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:u,onError:(F,Y,Z)=>{h.push({error:F,offset:Y,length:Z})}};if(i)try{P.visit(i,D),n=o[0]||{}}catch(F){console.error(`Error while parsing settings file ${this.f}: ${F}`),this.d=[F]}return n}h(i,n){const r=d.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),o=this.i(i,r,!0,n);i=o.raw;const a=(0,b.toValuesTree)(i,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),h=Object.keys(i),u=this.j(i,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:a,keys:h,overrides:u,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(i,n,r,o){let a=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:a};const h={},u=[];for(const D in i)if(m.OVERRIDE_PROPERTY_REGEX.test(D)&&r){const F=this.i(i[D],n,!1,o);h[D]=F.raw,a=a||F.hasExcludedProperties,u.push(...F.restricted)}else{const F=n[D],Y=F?typeof F.scope<"u"?F.scope:3:void 0;F?.restricted&&u.push(D),(Y===void 0||o.scopes===void 0||o.scopes.includes(Y))&&!(o.skipRestricted&&F?.restricted)?h[D]=i[D]:a=!0}return{raw:h,restricted:u,hasExcludedProperties:a}}j(i,n){const r=[];for(const o of Object.keys(i))if(m.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const h in i[o])a[h]=i[o][h];r.push({identifiers:(0,m.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,b.toValuesTree)(a,n)})}return r}}e.ConfigurationModelParser=A;class c extends O.Disposable{constructor(i,n,r,o){super(),this.f=i,this.g=n,this.h=o,this.c=this.B(new R.Emitter),this.onDidChange=this.c.event,this.a=new A(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(R.Event.any(R.Event.filter(this.h.onDidFilesChange,a=>a.contains(this.f)),R.Event.filter(this.h.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&r.isEqual(a.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new v}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=c;class f{constructor(i,n,r,o,a,h,u,D,F,Y,Z,te,ie){this.a=i,this.b=n,this.c=r,this.overrideIdentifiers=o,this.d=a,this.f=h,this.g=u,this.h=D,this.i=F,this.j=Y,this.k=Z,this.l=te,this.m=ie}get value(){return I(this.c)}n(i,n,r){const o=i.inspect(n,r);return{get value(){return I(o.value)},get override(){return I(o.override)},get merged(){return I(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class y{constructor(i,n,r,o,a=new v,h=new v,u=new k.ResourceMap,D=new v,F=new k.ResourceMap){this.c=i,this.d=n,this.f=r,this.g=o,this.h=a,this.i=h,this.j=u,this.l=D,this.m=F,this.a=null,this.b=new k.ResourceMap,this.n=null}getValue(i,n,r){return this.q(i,n,r).getValue(i)}updateValue(i,n,r={}){let o;r.resource?(o=this.m.get(r.resource),o||(o=new v,this.m.set(r.resource,o))):o=this.l,n===void 0?o.removeValue(i):o.setValue(i,n),r.resource||(this.a=null)}inspect(i,n,r){const o=this.q(i,n,r),a=this.u(n.resource,r),h=n.resource?this.m.get(n.resource)||this.l:this.l,u=new Set;for(const D of o.overrides)for(const F of D.identifiers)o.getOverrideValue(i,F)!==void 0&&u.add(F);return new f(i,n,o.getValue(i),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,a||void 0,h)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:o,updated:a,removed:h}=E(this.c,i);n=[...o,...a,...h]}for(const o of n)for(const a of(0,m.overrideIdentifiersFromKey)(o)){const h=this.c.getKeysForOverrideIdentifier(a),u=i.getKeysForOverrideIdentifier(a),D=[...u.filter(F=>h.indexOf(F)===-1),...h.filter(F=>u.indexOf(F)===-1),...h.filter(F=>!w.equals(this.c.override(a).getValue(F),i.override(a).getValue(F)))];r.push([a,D])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:r,removed:o}=E(this.d,i),a=[...n,...r,...o];return a.length&&this.updatePolicyConfiguration(i),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=E(this.applicationConfiguration,i),h=[...n,...r,...o];return h.length&&this.updateApplicationConfiguration(i),{keys:h,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=E(this.localUserConfiguration,i),h=[...n,...r,...o];return h.length&&this.updateLocalUserConfiguration(i),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=E(this.remoteUserConfiguration,i),h=[...n,...r,...o];return h.length&&this.updateRemoteUserConfiguration(i),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=E(this.workspaceConfiguration,i),h=[...n,...r,...o];return h.length&&this.updateWorkspaceConfiguration(i),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(i,n){const r=this.p.get(i),{added:o,updated:a,removed:h,overrides:u}=E(r,n),D=[...o,...a,...h];return(D.length||!r)&&this.updateFolderConfiguration(i,n),{keys:D,overrides:u}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:o,removed:a,overrides:h}=E(n,void 0);return{keys:[...r,...o,...a],overrides:h}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,r){let o=this.r(n,r);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(o=o.merge(this.d)),o}r({resource:i},n){let r=this.s();if(n&&i){const o=n.getFolder(i);o&&(r=this.t(o.uri)||r);const a=this.m.get(i);a&&(r=r.merge(a))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const r=this.s(),o=this.j.get(i);o?(n=r.merge(o),this.b.set(i,n)):n=r}return n}u(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:r,overrides:o,keys:a}=this.j.get(n);return i.push([n,{contents:r,overrides:o,keys:a}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(r=>i.add(r))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o))),[...n.values()]}static parse(i){const n=this.x(i.defaults),r=this.x(i.policy),o=this.x(i.application),a=this.x(i.user),h=this.x(i.workspace),u=i.folders.reduce((D,F)=>(D.set(l.URI.revive(F[0]),this.x(F[1])),D),new k.ResourceMap);return new y(n,r,o,a,new v,h,u,new v,new k.ResourceMap)}static x(i){return new v(i.contents,i.keys,i.overrides)}}e.Configuration=y;function S(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,n=new Map;for(const o of s)o.keys.forEach(a=>i.add(a)),o.overrides.forEach(([a,h])=>{const u=(0,k.getOrSet)(n,a,new Set);h.forEach(D=>u.add(D))});const r=[];return n.forEach((o,a)=>r.push([a,[...o.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=S;class p{constructor(i,n,r,o){this.change=i,this.f=n,this.g=r,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of i.keys)this.affectedKeys.add(a);for(const[,a]of i.overrides)for(const h of a)this.affectedKeys.add(h);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=y.parse(this.f.data)),this.i}affectsConfiguration(i,n){const r=this.a+i,o=this.d.indexOf(r);if(o<0)return!1;const a=o+r.length;if(a>=this.d.length)return!1;const h=this.d.charCodeAt(a);if(h!==this.b&&h!==this.c)return!1;if(n){const u=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,D=this.g.getValue(i,n,this.h);return!w.equals(u,D)}return!0}}e.ConfigurationChangeEvent=p;function E(s,i){const{added:n,removed:r,updated:o}=t(i?.rawConfiguration,s?.rawConfiguration),a=[],h=s?.getAllOverrideIdentifiers()||[],u=i?.getAllOverrideIdentifiers()||[];if(i){const D=u.filter(F=>!h.includes(F));for(const F of D)a.push([F,i.getKeysForOverrideIdentifier(F)])}if(s){const D=h.filter(F=>!u.includes(F));for(const F of D)a.push([F,s.getKeysForOverrideIdentifier(F)])}if(i&&s){for(const D of h)if(u.includes(D)){const F=t({contents:s.getOverrideValue(void 0,D)||{},keys:s.getKeysForOverrideIdentifier(D)},{contents:i.getOverrideValue(void 0,D)||{},keys:i.getKeysForOverrideIdentifier(D)});a.push([D,[...F.added,...F.removed,...F.updated]])}}return{added:n,removed:r,updated:o,overrides:a}}function t(s,i){const n=s?i?s.keys.filter(a=>i.keys.indexOf(a)===-1):[...s.keys]:[],r=i?s?i.keys.filter(a=>s.keys.indexOf(a)===-1):[...i.keys]:[],o=[];if(s&&i){for(const a of i.keys)if(s.keys.indexOf(a)!==-1){const h=(0,b.getConfigurationValue)(i.contents,a),u=(0,b.getConfigurationValue)(s.contents,a);w.equals(h,u)||o.push(a)}}return{added:n,removed:r,updated:o}}}),define(Q[125],_([0,1,19,4,2,30,3,65,42,6,38,37]),function(x,e,T,R,P,O,k,w,g,l,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class d extends P.Disposable{constructor(){super(...arguments),this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new w.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(m.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:f})=>this.c(Array.from(c),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(c,f){this.h(c,m.Registry.as(g.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:c})}f(){return{}}g(){this.b=new w.ConfigurationModel;const c=m.Registry.as(g.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(c),c)}h(c,f){const y=this.f();for(const S of c){const p=y[S],E=f[S];p!==void 0?this.b.addValue(S,p):E?this.b.addValue(S,E.default):this.b.removeValue(S)}}}e.DefaultConfiguration=d;class I{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new w.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=I;let v=class extends P.Disposable{get configurationModel(){return this.b}constructor(c,f,y){super(),this.c=c,this.f=f,this.g=y,this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new w.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(c=>this.i(c))),this.B(this.c.onDidChangeConfiguration(async({properties:c})=>this.j(await this.h(c),!0))),this.b}async h(c){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",c);const f={},y=[],S=m.Registry.as(g.Extensions.Configuration).getConfigurationProperties();for(const p of c){const E=S[p];if(!E){y.push(p);continue}if(E.policy){if(E.type!=="string"&&E.type!=="number"){this.g.warn(`Policy ${E.policy.name} has unsupported type ${E.type}`);continue}y.push(p),f[E.policy.name]={type:E.type}}}return(0,k.isEmptyObject)(f)||await this.f.updatePolicyDefinitions(f),y}i(c){this.g.trace("PolicyConfiguration#onDidChangePolicies",c);const f=m.Registry.as(g.Extensions.Configuration).getPolicyConfigurations(),y=(0,T.coalesce)(c.map(S=>f.get(S)));this.j(y,!0)}j(c,f){this.g.trace("PolicyConfiguration#update",c);const y=m.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),S=[],p=this.b.isEmpty();for(const E of c){const t=y[E]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(p?s!==void 0:!(0,O.equals)(this.b.getValue(E),s))&&S.push([E,s])}else this.b.getValue(E)!==void 0&&S.push([E,void 0])}if(S.length){this.g.trace("PolicyConfiguration#changed",S);const E=this.b;this.b=new w.ConfigurationModel;for(const t of E.keys)this.b.setValue(t,E.getValue(t));for(const[t,s]of S)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);f&&this.a.fire(this.b)}}};v=fe([ee(1,b.IPolicyService),ee(2,l.ILogService)],v),e.PolicyConfiguration=v}),define(Q[126],_([0,1,5,4,2,18,23,65,125,38]),function(x,e,T,R,P,O,k,w,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends P.Disposable{constructor(d,I,v,A){super(),this.i=d,this.h=this.B(new R.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.DefaultConfiguration),this.c=v instanceof l.NullPolicyService?new g.NullPolicyConfiguration:this.B(new g.PolicyConfiguration(this.b,v,A)),this.f=this.B(new w.UserSettings(this.i,void 0,O.extUriBiasedIgnorePathCase,I)),this.a=new w.Configuration(this.b.configurationModel,this.c.configurationModel,new w.ConfigurationModel,new w.ConfigurationModel),this.g=this.B(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:f})=>this.k(c,f))),this.B(this.c.onDidChangeConfiguration(c=>this.l(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,I,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new w.Configuration(d,I,new w.ConfigurationModel,v)}getConfigurationData(){return this.a.toData()}getValue(d,I){const v=typeof d=="string"?d:void 0,A=(0,k.isConfigurationOverrides)(d)?d:(0,k.isConfigurationOverrides)(I)?I:{};return this.a.getValue(v,A,void 0)}updateValue(d,I,v,A){return Promise.reject(new Error("not supported"))}inspect(d){return this.a.inspect(d,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.j(d)}j(d){const I=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(d);this.m(v,I,2)}k(d,I){const v=this.a.toData(),A=this.a.compareAndUpdateDefaultConfiguration(d,I);this.m(A,v,7)}l(d){const I=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(d);this.m(v,I,7)}m(d,I,v){const A=new w.ConfigurationChangeEvent(d,{data:I},this.a);A.source=v,A.sourceConfig=this.n(v),this.h.fire(A)}n(d){switch(d){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(Q[66],_([0,1,16]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(l){return l.scheme===T.Schemas.vscodeRemote?l.authority:void 0}e.getRemoteAuthority=R;function P(l){if(!l)return;const b=l.indexOf("+");return b<0?l:l.substr(0,b)}e.getRemoteName=P;function O(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.getRemoteServerRootPath=O;function k(l){const{host:b,port:m}=g(l);if(typeof m>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:m}}e.parseAuthorityWithPort=k;function w(l,b){let{host:m,port:d}=g(l);return typeof d>"u"&&(d=b),{host:m,port:d}}e.parseAuthorityWithOptionalPort=w;function g(l){const b=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const m=l.match(/^(\[[0-9a-z:]+\])$/);if(m)return{host:m[1],port:void 0};const d=l.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:l,port:void 0}}}),define(Q[29],_([0,1,32,10,66]),function(x,e,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=O;function k(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(w=e.ExtensionType||(e.ExtensionType={}));var g;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(g=e.TargetPlatform||(e.TargetPlatform={}));class l{constructor(A){this.value=A,this.c=A.toLowerCase()}static equals(A,c){if(typeof A>"u"||A===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof A=="string"||typeof c=="string"){const f=typeof A=="string"?A:A.value,y=typeof c=="string"?c:c.value;return T.equalsIgnoreCase(f,y)}return A.c===c.c}static toKey(A){return typeof A=="string"?A.toLowerCase():A.c}}e.ExtensionIdentifier=l;function b(v){return m(v)}e.isApplicationScopedExtension=b;function m(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function d(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function I(v,A){if(A){const c=`onResolveRemoteAuthority:${(0,P.getRemoteName)(A)}`;return v.activationEvents?.indexOf(c)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[127],_([0,1,2,14,20,29]),function(x,e,T,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends T.Disposable{constructor(g,l){super(),this.b=g,this.a=(0,R.join)(this.b.userDataPath,O.MANIFEST_CACHE_FOLDER,O.USER_MANIFEST_CACHE_FILE),this.B(l.onDidInstallExtensions(b=>this.c(b))),this.B(l.onDidUninstallExtension(b=>this.f(b)))}c(g){g.some(l=>!!l.local)&&this.invalidate()}f(g){g.error||this.invalidate()}invalidate(){P.Promises.rm(this.a,P.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(Q[47],_([0,1,15,99,42,10,37]),function(x,e,T,R,P,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,O.createDecorator)("requestService");function w(A){return A.res.statusCode&&A.res.statusCode>=200&&A.res.statusCode<300||A.res.statusCode===1223}e.isSuccess=w;function g(A){return A.res.statusCode===204}async function l(A){return g(A)?null:(await(0,T.streamToBuffer)(A.stream)).toString()}e.asText=l;async function b(A){if(!w(A))throw new Error("Server returned "+A.res.statusCode);return l(A)}e.asTextOrError=b;async function m(A){if(!w(A))throw new Error("Server returned "+A.res.statusCode);if(g(A))return null;const f=(await(0,T.streamToBuffer)(A.stream)).toString();try{return JSON.parse(f)}catch(y){throw y.message+=`:
`+f,y}}e.asJson=m;function d(A){v(A)}e.updateProxyConfigurationsScope=d;let I;function v(A){const c=k.Registry.as(P.Extensions.Configuration),f=I;I={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:A,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},c.updateConfigurations({add:[I],remove:f?[f]:[]})}v(2)}),define(Q[128],_([0,1,22,16,13,47]),function(x,e,T,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(g,l){this.a=g,this.b=l}async download(g,l,b=T.CancellationToken.None){if(g.scheme===R.Schemas.file||g.scheme===R.Schemas.vscodeRemote){await this.b.copy(g,l);return}const m={type:"GET",url:g.toString(!0)},d=await this.a.request(m,b);if(d.res.statusCode===200)await this.b.writeFile(l,d.stream);else{const I=await(0,O.asTextOrError)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${I}`)}}};k=fe([ee(0,O.IRequestService),ee(1,P.IFileService)],k),e.DownloadService=k}),define(Q[129],_([0,1,130,3]),function(x,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function P(k,w){return k.protocol==="http:"?w.HTTP_PROXY||w.http_proxy||null:k.protocol==="https:"&&(w.HTTPS_PROXY||w.https_proxy||w.HTTP_PROXY||w.http_proxy)||null}async function O(k,w,g={}){const l=(0,T.parse)(k),b=g.proxyUrl||P(l,w);if(!b)return null;const m=(0,T.parse)(b);if(!/^https?:$/.test(m.protocol||""))return null;const d={host:m.hostname||"",port:m.port||(m.protocol==="https"?"443":"80"),auth:m.auth,rejectUnauthorized:(0,R.isBoolean)(g.strictSSL)?g.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((I,v)=>{x(["http-proxy-agent"],I,v)}))(d):new(await new Promise((I,v)=>{x(["https-proxy-agent"],I,v)}))(d)}e.getProxyAgent=O}),define(Q[131],_([0,1,57,14,100,22,34,7,12,31,82,163,5,71]),function(x,e,T,R,P,O,k,w,g,l,b,m,d,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let v;async function A(f,y,S,p){return S["force-disable-user-env"]?(y.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(y.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,m.isLaunchedFromCli)(p)&&!S["force-user-env"]?(y.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,m.isLaunchedFromCli)(p)?y.trace("resolveShellEnv(): running (--force-user-env)"):y.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=d.Promises.withAsyncBody(async(E,t)=>{const s=new O.CancellationTokenSource;let i=1e4;const n=f.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,I.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{s.dispose(!0),t(new Error((0,P.localize)(0,null)))},i);try{E(await c(y,s.token))}catch(o){!(0,w.isCancellationError)(o)&&!s.token.isCancellationRequested?t(new Error((0,P.localize)(1,null,(0,k.toErrorMessage)(o)))):E({})}finally{clearTimeout(r),s.dispose()}})),v)}e.getResolvedShellEnv=A;async function c(f,y){const S=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",S);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",p);const E=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(E+"({.*})"+E),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",s);const i=await(0,b.getSystemShell)(g.OS,s);return f.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(y.isCancellationRequested)return r(new w.CancellationError);const o=(0,R.basename)(i);let a,h;const u=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(a=`& '${process.execPath}' ${u} -p '''${E}'' + JSON.stringify(process.env) + ''${E}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' ${u} -p '"${E}" + JSON.stringify(process.env) + "${E}"'`,o==="tcsh"||o==="csh"?h=["-ic"]:h=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const D=(0,T.spawn)(i,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});y.onCancellationRequested(()=>(D.kill(),r(new w.CancellationError))),D.on("error",Z=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(Z)),r(Z)});const F=[];D.stdout.on("data",Z=>F.push(Z));const Y=[];D.stderr.on("data",Z=>Y.push(Z)),D.on("close",(Z,te)=>{const ie=Buffer.concat(F).toString("utf8");f.trace("getUnixShellEnvironment#raw",ie);const ne=Buffer.concat(Y).toString("utf8");if(ne.trim()&&f.trace("getUnixShellEnvironment#stderr",ne),Z||te)return r(new Error((0,P.localize)(2,null,Z,te)));const ae=t.exec(ie),ue=ae?ae[1]:"{}";try{const se=JSON.parse(ue);S?se.ELECTRON_RUN_AS_NODE=S:delete se.ELECTRON_RUN_AS_NODE,p?se.ELECTRON_NO_ATTACH_CONSOLE=p:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.VSCODE_RESOLVING_ENVIRONMENT,delete se.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",se),n(se)}catch(se){f.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(se)),r(se)}})})}}),define(Q[67],_([0,1,10]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,T.createDecorator)("stateService")}),define(Q[132],_([0,1,5,15,3,17,13,6]),function(x,e,T,R,P,O,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class g{constructor(m,d,I){this.f=m,this.g=d,this.h=I,this.a=Object.create(null),this.b="",this.c=new T.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==1&&this.g.error(m)}}getItem(m,d){const I=this.a[m];return(0,P.isUndefinedOrNull)(I)?d:I}setItem(m,d){this.setItems([{key:m,data:d}])}setItems(m){let d=!1;for(const{key:I,data:v}of m)this.a[I]!==v&&((0,P.isUndefinedOrNull)(v)?(0,P.isUndefined)(this.a[I])||(this.a[I]=void 0,d=!0):(this.a[I]=v,d=!0));d&&this.j()}removeItem(m){(0,P.isUndefined)(this.a[m])||(this.a[m]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.h.writeFile(this.f,R.VSBuffer.fromString(m)),this.b=m}catch(d){this.g.error(d)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=g;let l=class{constructor(m,d,I){this.a=new g(m.stateResource,d,I)}async init(){await this.a.init()}getItem(m,d){return this.a.getItem(m,d)}};l=fe([ee(0,O.IEnvironmentService),ee(1,w.ILogService),ee(2,k.IFileService)],l),e.StateService=l}),define(Q[68],_([0,1,12,35,11,31]),function(x,e,T,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(l){if(T.platform===2&&/^penguin(\.|$)/i.test(l))return"chromebook"}async function w(l,b,m,d,I,v,A,c,f,y){const S=Object.create(null);S["common.machineId"]=A,S.sessionID=(0,O.generateUuid)()+Date.now(),S.commitHash=I,S.version=v,S["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),S["common.platform"]=(0,T.PlatformToString)(T.platform),S["common.nodePlatform"]=R.platform,S["common.nodeArch"]=d,S["common.product"]=y||"desktop",c&&(S["common.msftInternal"]=c);let p=0;const E=Date.now();Object.defineProperties(S,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-E,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),T.isLinuxSnap&&(S["common.snap"]="true");const t=k(m);t&&(S["common.platformDetail"]=t);try{const s=await l.readFile(P.URI.file(f));S["common.source"]=s.value.toString().slice(0,30)}catch{}return S}e.resolveCommonProperties=w;function g(l){const b=R.env.USERDNSDOMAIN;if(!b)return!1;const m=b.toLowerCase();return l.some(d=>m===d)}e.verifyMicrosoftInternalDomain=g}),define(Q[25],_([0,1,10]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,T.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var P;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(P=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Q[39],_([0,1,30,3,4,23,66,68,25]),function(x,e,T,R,P,O,k,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class l{constructor(a){this.value=a}}e.TelemetryTrustedValue=l;class b{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(a,h){return Promise.resolve(void 0)}publicLog2(a,h){return this.publicLog(a,h)}publicLogError(a,h){return Promise.resolve(void 0)}publicLogError2(a,h){return this.publicLogError(a,h)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=b,e.NullTelemetryService=new b;class m{async publicLog(a,h,u){}async publicLogError(a,h,u){}}e.NullEndpointTelemetryService=m,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(o,a){return P.Event.debounce(a.onDidChangeConfiguration,(u,D)=>{const F=u?new Set([...u.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:F}},1e3,!0)(u=>{u.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,O.ConfigurationTargetToString)(u.source),configurationKeys:p(u.affectedKeys)})})}e.configurationTelemetry=d;function I(o,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!o.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=I;function v(o,a){return!(a.isBuilt||a.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=v;function A(o){const a=o.getValue(g.TELEMETRY_SETTING_ID),h=o.getValue(g.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(g.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=A;function c(o){const a={},h={},u={};S(o,u);for(let D in u){D=D.length>150?D.substr(D.length-149):D;const F=u[D];typeof F=="number"?h[D]=F:typeof F=="boolean"?h[D]=F?1:0:typeof F=="string"?(F.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${F.length}`),a[D]=F.substring(0,8191)):typeof F<"u"&&F!==null&&(a[D]=F)}return{properties:a,measurements:h}}e.validateTelemetryData=c;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function y(o){if(!o)return"none";const a=(0,k.getRemoteName)(o);return f.has(a)?a:"other"}e.cleanRemoteAuthority=y;function S(o,a,h=0,u){if(!!o)for(const D of Object.getOwnPropertyNames(o)){const F=o[D],Y=u?u+D:D;Array.isArray(F)?a[Y]=(0,T.safeStringify)(F):F instanceof Date?a[Y]=F.toISOString():(0,R.isObject)(F)?h<2?S(F,a,h+1,Y+"."):a[Y]=(0,T.safeStringify)(F):a[Y]=F}}function p(o){if(!o)return[];const a=[];return E(a,"",o),a}function E(o,a,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(u=>E(o,a?`${a}.${u}`:u,h[u])):o.push(a)}function t(o,a){const h=o.msftInternalDomains||[],u=a.getValue("telemetry.internalTesting");return(0,w.verifyMicrosoftInternalDomain)(h)||u}e.isInternalTelemetry=t;function s(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=s;function i(o,a){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let h=o;const u=[];for(const Z of a)for(;;){const te=Z.exec(o);if(!te)break;u.push([te.index,Z.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,F=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let Y=0;for(h="";;){const Z=F.exec(o);if(!Z)break;const te=u.some(([ie,ne])=>Z.index<ne&&ie<F.lastIndex);!D.test(Z[0])&&!te&&(h+=o.substring(Y,Z.index)+"<REDACTED: user-file-path>",Y=F.lastIndex)}return Y<o.length&&(h+=o.substr(Y)),h}function n(o){if(!o)return o;const a=o.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of h)if(u.regex.test(a))return`<REDACTED: ${u.label}>`;return o}function r(o,a){return(0,T.cloneAndChange)(o,h=>{if(h instanceof l)return h.value;if(typeof h=="string"){let u=h.replaceAll("%20"," ");u=i(u,a);for(const D of a)u=u.replace(D,"");return u=n(u),u}})}e.cleanData=r}),define(Q[26],_([0,1,32,24,29,12,11,7,35,39]),function(x,e,T,R,P,O,k,w,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,T.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=b;const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const r=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,r,o)}static parse(n){const r=m.exec(n);return r&&r[1]&&r[2]?new d({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?b(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=d;const I=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(i){const n=I.exec(i);return n&&n[1]?[c(n[1]),n[2]]:[c(i),void 0]}e.getIdAndVersion=v;function A(i,n){return`${i}.${n}`}e.getExtensionId=A;function c(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=c;function f(i,n){return c(A(i,n))}e.getGalleryExtensionId=f;function y(i,n){const r=[],o=a=>{for(const h of r)if(h.some(u=>b(n(u),n(a))))return h;return null};for(const a of i){const h=o(a);h?h.push(a):r.push([a])}return r}e.groupByExtension=y;function S(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function p(i){return{id:new l.TelemetryTrustedValue(i.identifier.id),name:new l.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function E(i,n){const r=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&r.every(h=>!b(h.identifier,{id:a}))){const h=i.filter(u=>b(u.identifier,{id:a}));h.length===1&&(r.push(h[0]),o.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=E;async function t(i,n){if(!O.isLinux)return!1;let r;try{r=(await i.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,w.getErrorMessage)(a))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function s(i,n){const r=await t(i,n),o=(0,R.getTargetPlatform)(r?"alpine":O.platform,g.arch);return n.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=s}),define(Q[133],_([0,1,22,7,16,18,41,11,89,24,26,29]),function(x,e,T,R,P,O,k,w,g,l,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const d=c=>(0,g.localize)(0,null,c),I=(0,g.localize)(1,null,"ms-dotnettools.csharp");function v(c,f){return f?`${c.publisher}.${c.name}@${c.version}`:`${c.publisher}.${c.name}`}let A=class{constructor(f,y){this.a=f,this.b=y}get d(){}async listExtensions(f,y,S,p=console){let E=await this.a.getInstalled(1,S);const t=m.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(y&&y!==""){if(t.indexOf(y.toLowerCase())<0){p.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}E=E.filter(i=>i.manifest.categories?i.manifest.categories.map(r=>r.toLowerCase()).indexOf(y.toLowerCase())>-1:!1)}else if(y===""){p.log("Possible Categories: "),t.forEach(i=>{p.log(i)});return}this.d&&p.log((0,g.localize)(2,null,this.d)),E=E.sort((i,n)=>i.identifier.id.localeCompare(n.identifier.id));let s;for(const i of E)s!==i.identifier.id&&(s=i.identifier.id,p.log(v(i.manifest,f)))}async installExtensions(f,y,S,p,E=console){const t=[],s=[];f.length&&E.log(this.d?(0,g.localize)(3,null,this.d):(0,g.localize)(4,null));const i=await this.a.getInstalled(1,S.profileLocation),n=(h,u)=>{const D=i.find(F=>(0,b.areSameExtensions)(F.identifier,{id:h}));if(D){if(!p&&(!u||u==="prerelease"&&D.preRelease))return E.log((0,g.localize)(5,null,h,D.manifest.version,h)),!1;if(u&&D.manifest.version===u)return E.log((0,g.localize)(6,null,`${h}@${u}`)),!1}return!0},r=(h,u,D)=>{a.push({id:h,version:u!=="prerelease"?u:void 0,installOptions:{...S,isBuiltin:D,installPreReleaseVersion:u==="prerelease"||S.installPreReleaseVersion}})},o=[],a=[];for(const h of f)if(h instanceof w.URI)o.push(h);else{const[u,D]=(0,b.getIdAndVersion)(h);n(u,D)&&r(u,D,!1)}for(const h of y){const[u,D]=(0,b.getIdAndVersion)(h);n(u,D)&&r(u,D,!0)}if(o.length&&await Promise.all(o.map(async h=>{try{const u=await this.f(h,{...S,isBuiltin:!1},p,E);u&&s.push(u)}catch(u){E.error(u.message||u.stack||u),t.push(h.toString())}})),a.length){const h=await this.g(a);await Promise.all(a.map(async u=>{const D=h.get(u.id.toLowerCase());if(D)try{const F=await this.h(u,D,i,p,E);F&&s.push(F)}catch(F){E.error(F.message||F.stack||F),t.push(u.id)}else E.error(`${d(u.version?`${u.id}@${u.version}`:u.id)}
${I}`),t.push(u.id)}))}if(t.length)throw new Error((0,g.localize)(7,null,t.join(", ")))}async f(f,y,S,p){const E=await this.a.getManifest(f);if(!E)throw new Error("Invalid vsix");if(await this.k(E,S,y.profileLocation,p))try{return await this.a.install(f,y),p.log((0,g.localize)(8,null,(0,O.basename)(f))),E}catch(s){if((0,R.isCancellationError)(s))return p.log((0,g.localize)(9,null,(0,O.basename)(f))),null;throw s}return null}async g(f){const y=new Map,S=f.some(E=>E.installOptions.installPreReleaseVersion),p=await this.b.getExtensions(f.map(E=>({...E,preRelease:S})),T.CancellationToken.None);for(const E of p)y.set(E.identifier.id.toLowerCase(),E);return y}async h({id:f,version:y,installOptions:S},p,E,t,s){const i=await this.b.getManifest(p,T.CancellationToken.None);if(i&&!this.j(i,s))return null;const n=E.find(r=>(0,b.areSameExtensions)(r.identifier,p.identifier));if(n){if(p.version===n.manifest.version)return s.log((0,g.localize)(10,null,y?`${f}@${y}`:f)),null;s.log((0,g.localize)(11,null,f,p.version))}try{S.isBuiltin?s.log(y?(0,g.localize)(12,null,f,y):(0,g.localize)(13,null,f)):s.log(y?(0,g.localize)(14,null,f,y):(0,g.localize)(15,null,f));const r=await this.a.installFromGallery(p,{...S,installGivenVersion:!!y});return s.log((0,g.localize)(16,null,f,r.manifest.version)),i}catch(r){if((0,R.isCancellationError)(r))return s.log((0,g.localize)(17,null,f)),null;throw r}}j(f,y){return!0}async k(f,y,S,p){const E={id:(0,b.getGalleryExtensionId)(f.publisher,f.name)},s=(await this.a.getInstalled(1,S)).find(i=>(0,b.areSameExtensions)(E,i.identifier)&&(0,k.gt)(i.manifest.version,f.version));return s&&!y?(p.log((0,g.localize)(18,null,s.identifier.id,s.manifest.version,f.version)),!1):this.j(f,p)}async uninstallExtensions(f,y,S,p=console){const E=async s=>{if(s instanceof w.URI){const i=await this.a.getManifest(s);return v(i)}return s},t=[];for(const s of f){const i=await E(s),r=(await this.a.getInstalled(void 0,S)).filter(o=>(0,b.areSameExtensions)(o.identifier,{id:i}));if(!r.length)throw new Error(`${this.l(i)}
${I}`);if(r.some(o=>o.type===0)){p.log((0,g.localize)(19,null,i));return}if(!y&&r.some(o=>o.isBuiltin)){p.log((0,g.localize)(20,null,i));return}p.log((0,g.localize)(21,null,i));for(const o of r)await this.a.uninstall(o,{profileLocation:S}),t.push(o);this.d?p.log((0,g.localize)(22,null,i,this.d)):p.log((0,g.localize)(23,null,i))}}async locateExtension(f,y=console){const S=await this.a.getInstalled();f.forEach(p=>{S.forEach(E=>{if(E.identifier.id===p&&E.location.scheme===P.Schemas.file){y.log(E.location.fsPath);return}})})}l(f){return this.d?(0,g.localize)(24,null,f,this.d):(0,g.localize)(25,null,f)}};A=fe([ee(0,l.IExtensionManagementService),ee(1,l.IExtensionGalleryService)],A),e.ExtensionManagementCLI=A}),define(Q[134],_([0,1,5,7,2,16,12,18,41,3,31,20,23,17,24,26,59,13,6,28]),function(x,e,T,R,P,O,k,w,g,l,b,m,d,I,v,A,c,f,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let p=class Ve extends P.Disposable{constructor(t,s,i,n,r,o,a){super(),this.h=s,this.i=i,this.j=n,this.k=r,this.l=o,this.m=a,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.v()}async download(t,s){await this.g;const i=(0,w.joinPath)(this.extensionsDownloadDir,this.w(t));try{await this.t(t,i,r=>this.i.download(t,r,s))}catch(r){throw new v.ExtensionManagementError(r.message,v.ExtensionManagementErrorCode.Download)}let n="Unverified";if(await this.n(t)){const r=await this.r(t);try{await this.l.verify(i.fsPath,r.fsPath)&&(n="Verified"),this.m.info(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`)}catch(o){const a=o.code;if(a==="UnknownError")n="UnknownError",this.m.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`);else throw await this.delete(r),await this.delete(i),new v.ExtensionManagementError(a,v.ExtensionManagementErrorCode.Signature)}}return{location:i,verificationStatus:n}}async n(t){if(!t.isSigned)return!1;const s=this.j.getValue("extensions.verifySignature");return(0,l.isBoolean)(s)?s:this.k.quality!=="stable"}async r(t){await this.g;const s=(0,w.joinPath)(this.extensionsDownloadDir,`${this.w(t)}${Ve.c}`);return await this.t(t,s,i=>this.i.downloadSignatureArchive(t,i)),s}async t(t,s,i){if(await this.h.exists(s))return;if(s.scheme!==O.Schemas.file){await i(s);return}const n=(0,w.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.h.exists(n)||await i(n);try{await this.u(n,s,Date.now()+2*60*1e3)}catch(r){try{await this.h.del(n)}catch{}if(r.code==="ENOTEMPTY")this.m.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.m.info(`Rename failed because of ${(0,R.getErrorMessage)(r)}. Deleted the file from downloaded location`,n.path),r}}async delete(t){await this.g,await this.h.del(t)}async u(t,s,i){try{await m.Promises.rename(t.fsPath,s.fsPath)}catch(n){if(k.isWindows&&n&&n.code==="EPERM"&&Date.now()<i)return this.m.info(`Failed renaming ${t} to ${s} with 'EPERM' error. Trying again...`),this.u(t,s,i);throw n}}async v(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.m.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],i=[],n=[];for(const a of t.children)if(a.name.endsWith(Ve.c))n.push(a.resource);else{const h=A.ExtensionKey.parse(a.name);h&&i.push([h,a])}const r=(0,A.groupByExtension)(i,([a])=>a),o=[];for(const a of r)a.sort((h,u)=>g.rcompare(h[0].version,u[0].version)),s.push(...a.slice(1).map(h=>h[1].resource)),o.push(a[0][1]);o.sort((a,h)=>a.mtime-h.mtime),s.push(...o.slice(0,Math.max(0,o.length-this.f)).map(a=>a.resource)),s.push(...n),await T.Promises.settled(s.map(a=>(this.m.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(t){this.m.error(t)}}w(t){return this.f?A.ExtensionKey.create(t).toString().toLowerCase():(0,b.generateUuid)()}};p.c=".sigzip",p=fe([ee(0,I.INativeEnvironmentService),ee(1,f.IFileService),ee(2,v.IExtensionGalleryService),ee(3,d.IConfigurationService),ee(4,S.IProductService),ee(5,c.IExtensionSignatureVerificationService),ee(6,y.ILogService)],p),e.ExtensionsDownloader=p}),define(Q[135],_([0,1,4,2,36,26,29]),function(x,e,T,R,P,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class w extends R.Disposable{constructor(l,b,m,d,I,v,A){super(),this.f=l,this.g=b,this.h=m,this.i=d,this.j=I,this.k=v,this.l=A,this.a=this.B(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.DisposableMap),this.m().then(null,c=>A.error(c))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(l=>this.p(l.added,l.removed))),this.B(this.i.onAddExtensions(l=>this.r(l))),this.B(this.i.onDidAddExtensions(l=>this.s(l))),this.B(this.i.onRemoveExtensions(l=>this.t(l))),this.B(this.i.onDidRemoveExtensions(l=>this.u(l))),this.B(this.k.onDidFilesChange(l=>this.v(l)))}async p(l,b){try{await Promise.all(b.map(m=>(this.c.deleteAndDispose(m.id),this.z(m.extensionsResource)))),l.length&&await Promise.all(l.map(m=>(this.c.set(m.id,(0,R.combinedDisposable)(this.k.watch(this.j.extUri.dirname(m.extensionsResource)),this.k.watch(m.extensionsResource))),this.y(m.extensionsResource))))}catch(m){throw this.l.error(m),m}}async r(l){for(const b of l.extensions)this.D(this.G(b.identifier,b.version),l.profileLocation)}async s(l){for(const b of l.extensions){const m=this.G(b.identifier,b.version);l.error?this.F(m,l.profileLocation):this.D(m,l.profileLocation)}}async t(l){for(const b of l.extensions)this.F(this.G(b.identifier,b.version),l.profileLocation)}async u(l){let b=!1;for(const m of l.extensions){const d=this.G(m.identifier,m.version);l.error?this.D(d,l.profileLocation):(this.F(d,l.profileLocation),b=b||!this.b.has(d))}b&&await this.C()}v(l){for(const b of this.h.profiles)l.contains(b.extensionsResource,0,1)&&this.w(b.extensionsResource)}async w(l){const b=[],m=[],d=await this.i.scanProfileExtensions(l),I=new Set,v=new Set;for(const[A,c]of this.b)c.has(l)&&v.add(A);for(const A of d){const c=this.G(A.identifier,A.version);I.add(c),v.has(c)||(b.push(A.identifier),this.D(c,l))}for(const A of v)if(!I.has(A)){const c=this.H(A);c&&(m.push(c.identifier),this.F(A,l))}(b.length||m.length)&&this.a.fire({added:b.length?{extensions:b,profileLocation:l}:void 0,removed:m.length?{extensions:m,profileLocation:l}:void 0})}async y(l){const b=await this.i.scanProfileExtensions(l);for(const m of b)this.D(this.G(m.identifier,m.version),l)}async z(l){for(const b of[...this.b.keys()])this.F(b,l);await this.C()}async C(){const b=(await this.f.getAllUserInstalled()).filter(m=>m.installedTimestamp&&!this.b.has(this.G(m.identifier,m.manifest.version)));b.length&&await this.f.markAsUninstalled(...b)}D(l,b){let m=this.b.get(l);m||this.b.set(l,m=new P.ResourceSet(d=>this.j.extUri.getComparisonKey(d))),m.add(b)}F(l,b){const m=this.b.get(l);m&&m.delete(b),m?.size||this.b.delete(l)}G(l,b){return`${k.ExtensionIdentifier.toKey(l.id)}@${b}`}H(l){const[b,m]=(0,O.getIdAndVersion)(l);return m?{identifier:{id:b},version:m}:void 0}}e.ExtensionsWatcher=w}),define(Q[136],_([0,1,109,39]),function(x,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function P(O,k,w,g,l,b,m){const d={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${k.nameShort})`};if((0,R.supportsTelemetry)(k,w)&&(0,R.getTelemetryLevel)(g)===3){const I=await(0,T.getServiceMachineId)(w,l,b),{machineId:v}=await m.getTelemetryInfo();d["X-Market-User-Id"]=I,d["VSCode-SessionId"]=v||I}return d}e.resolveMarketplaceHeaders=P}),define(Q[137],_([0,1,164,19,5,2,16,14,20,17,24,26,6,63,12,11]),function(x,e,T,R,P,O,k,w,g,l,b,m,d,I,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let c=class extends I.LanguagePackBaseService{constructor(p,E,t,s){super(t),this.h=p,this.i=s,this.g=this.B(new f(E,s)),this.h.registerParticipant({postInstall:async i=>this.j(i),postUninstall:async i=>this.k(i)})}async getBuiltInExtensionTranslationsUri(p){const t=(await this.g.getLanguagePacks())[v.Language.value()];if(!t){this.i.warn(`No language pack found for ${v.Language.value()}`);return}const s=t.translations[p];return s?A.URI.file(s):void 0}async getInstalledLanguages(){const p=await this.g.getLanguagePacks(),E=Object.keys(p).map(t=>{const s=p[t];return{...this.f(t,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return E.push(this.f("en","English")),E.sort((t,s)=>t.label.localeCompare(s.label)),E}async j(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",p.identifier.id),await this.update())}async k(p){const E=await this.g.getLanguagePacks();Object.keys(E).some(t=>E[t]&&E[t].extensions.some(s=>(0,m.areSameExtensions)(s.extensionIdentifier,p.identifier)))&&(this.i.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,E]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),t=await this.g.update(E);return!(0,R.equals)(Object.keys(p),Object.keys(t))}};c=fe([ee(0,b.IExtensionManagementService),ee(1,l.INativeEnvironmentService),ee(2,b.IExtensionGalleryService),ee(3,d.ILogService)],c),e.NativeLanguagePackService=c;let f=class extends O.Disposable{constructor(p,E){super(),this.i=E,this.c={},this.f=(0,w.join)(p.userDataPath,"languagepacks.json"),this.g=new P.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(p){return this.m(E=>{Object.keys(E).forEach(t=>delete E[t]),this.j(E,...p)}).then(()=>this.c)}j(p,...E){for(const t of E)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.k(p,t);Object.keys(p).forEach(t=>this.l(p[t]))}k(p,E){const t=E.identifier,s=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const i of s)if(E.location.scheme===k.Schemas.file&&y(i)){let n=p[i.languageId];n||(n={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},p[i.languageId]=n);const r=n.extensions.filter(o=>(0,m.areSameExtensions)(o.extensionIdentifier,t))[0];r?r.version=E.manifest.version:n.extensions.push({extensionIdentifier:t,version:E.manifest.version});for(const o of i.translations)n.translations[o.id]=(0,w.join)(E.location.fsPath,o.path)}}l(p){if(p){const E=(0,T.createHash)("md5");for(const t of p.extensions)E.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);p.hash=E.digest("hex")}}m(p=()=>null){return this.g.queue(()=>{let E=null;return g.Promises.readFile(this.f,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(E=p(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.c=t,this.h=!0;const s=JSON.stringify(this.c);return this.i.debug("Writing language packs",s),g.Promises.writeFile(this.f,s)}).then(()=>E,t=>this.i.error(t))})}};f=fe([ee(0,l.INativeEnvironmentService),ee(1,d.ILogService)],f);function y(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const p of S.translations)if(typeof p.id!="string"||typeof p.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}}),define(Q[138],_([0,1,7,30,39]),function(x,e,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function w(l,b,m){const d=await new Promise((f,y)=>{x(["@microsoft/1ds-core-js"],f,y)}),I=await new Promise((f,y)=>{x(["@microsoft/1ds-post-js"],f,y)}),v=new d.AppInsightsCore,A=new I.PostChannel,c={instrumentationKey:l,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[A]]};if(m){c.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:m};c.extensionConfig[A.identifier]=f}return v.initialize(c,[]),v.addTelemetryInitializer(f=>{b&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),v}class g{constructor(b,m,d,I,v){this.e=b,this.f=m,this.g=d,this.h=v,this.c=O,this.d=k,this.g||(this.g={}),typeof I=="function"?this.a=I():this.a=I,this.b=null}i(b){if(!!this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=w(this.a,this.e,this.h)),this.b.then(m=>{b(m)},m=>{(0,T.onUnexpectedError)(m),console.error(m)})}}log(b,m){if(!this.a)return;m=(0,R.mixin)(m,this.g),m=(0,P.validateTelemetryData)(m);const d=this.f+"/"+b;try{this.i(I=>{I.pluginVersionString=m?.properties.version??"Unknown",I.track({name:d,baseData:{name:d,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=g}),define(Q[139],_([0,1,2,30,12,32,101,23,42,140,28,37,25,39]),function(x,e,T,R,P,O,k,w,g,l,b,m,d,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let v=class{constructor(f,y,S){this.k=y,this.l=S,this.d={},this.i=new T.DisposableStore,this.j=[],this.b=f.appenders,this.c=f.commonProperties||Promise.resolve({}),this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,O.escapeRegExpCharacters)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.escapeRegExpCharacters)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(d.TELEMETRY_SETTING_ID)||p.affectsConfiguration(d.TELEMETRY_OLD_SETTING_ID)||p.affectsConfiguration(d.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(f,y){this.d[f]=y}m(){let f=(0,I.getTelemetryLevel)(this.k);const y=this.l.enabledTelemetryLevels;if(y){this.h=this.sendErrorTelemetry?y.error:!1;const S=y.usage?3:y.error?2:0;f=Math.min(f,S)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const f=await this.c,y=f.sessionID,S=f["common.machineId"],p=f["common.firstSessionDate"],E=f["common.msftInternal"];return{sessionId:y,machineId:S,firstSessionDate:p,msftInternal:E}}dispose(){this.i.dispose()}n(f,y,S){return this.g<y?Promise.resolve(void 0):this.c.then(p=>{S=(0,R.mixin)(S,this.d),S=(0,I.cleanData)(S,this.j),S=(0,R.mixin)(S,p),this.b.forEach(E=>E.log(f,S))},p=>{console.error(p)})}publicLog(f,y){return this.n(f,3,y)}publicLog2(f,y){return this.publicLog(f,y)}publicLogError(f,y){return this.h?this.n(f,2,y):Promise.resolve(void 0)}publicLogError2(f,y){return this.publicLogError(f,y)}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=fe([ee(1,w.IConfigurationService),ee(2,b.IProductService)],v),e.TelemetryService=v;function A(){const c=(0,k.localize)(0,null,l.default.nameLong),f=l.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),y=P.isWeb?"":(0,k.localize)(3,null),S=(0,k.localize)(4,null),p=(0,k.localize)(5,null),E=(0,k.localize)(6,null),t=(0,k.localize)(7,null),s=`
|       | ${S} | ${p} | ${E} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,k.localize)(8,null);return`
${c} ${f} ${y}

&nbsp;

${t}
${s}

&nbsp;

${i}
`}m.Registry.as(g.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(9,null),properties:{[d.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:A(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),m.Registry.as(g.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[d.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,k.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,k.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${d.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[141],_([0,1,165,138]),function(x,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class P extends R.AbstractOneDataSystemAppender{constructor(k,w,g,l){const b={sendPOST:(m,d)=>{const I={method:"POST",headers:{...m.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(m.data)}};try{const v=T.request(m.urlString,I,A=>{A.on("data",function(c){d(A.statusCode??200,A.headers,c.toString())}),A.on("error",function(c){d(0,{})})});v.write(m.data),v.end()}catch{d(0,{})}}};super(k,w,g,l,b)}}e.OneDataSystemAppender=P}),define(Q[142],_([0,1,14,20]),function(x,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function P(O,k){const w=Object.create(null),g=(b,m)=>{const d=JSON.parse(b);w[m]=d};if(k){const b=[],m=await R.Promises.readdir(k);for(const I of m)try{(await R.Promises.stat((0,T.join)(k,I))).isDirectory()&&b.push(I)}catch{}const d=[];for(const I of b)(await R.Promises.readdir((0,T.join)(k,I))).filter(A=>A==="telemetry.json").length===1&&d.push(I);for(const I of d){const v=(await R.Promises.readFile((0,T.join)(k,I,"telemetry.json"))).toString();g(v,I)}}let l=(await R.Promises.readFile((0,T.join)(O,"telemetry-core.json"))).toString();return g(l,"vscode-core"),l=(await R.Promises.readFile((0,T.join)(O,"telemetry-extensions.json"))).toString(),g(l,"vscode-extensions"),JSON.stringify(w,null,4)}e.buildTelemetryMessage=P}),define(Q[143],_([0,1,12,80,25]),function(x,e,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function O(k){let w=k.getItem(P.machineIdKey);return(typeof w!="string"||T.isMacintosh&&w==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(w=await(0,R.getMachineId)()),w}e.resolveMachineId=O}),define(Q[27],_([0,1,10]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(Q[144],_([0,1,27,110,13,18,72,4,2]),function(x,e,T,R,P,O,k,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{constructor(d){this.uri=d,this.time=l._clock++}touch(){return this.time=l._clock++,this}}l._clock=0;let b=class{constructor(d){this.g=d,this.c=new g.DisposableStore,this.f=2**16;const I=new Map,v=A=>{let c=I.get(A.scheme);return c===void 0&&(c=d.hasProvider(A)&&!this.g.hasCapability(A,1024),I.set(A.scheme,c)),c};this.c.add(w.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(A=>{I.delete(A.scheme)})),this.extUri=new O.ExtUri(v),this.d=new k.SkipList((A,c)=>this.extUri.compare(A,c,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,O.normalizePath)(d));const I=this.d.get(d);return I?I.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new l(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((v,A)=>v[1].touch<A[1].touch?1:v[1].touch>A[1].touch?-1:0);l._clock=0,this.d.clear();const I=this.f*.5;for(let v=0;v<I;v++)this.d.set(d[v][0],d[v][1].touch())}};b=fe([ee(0,P.IFileService)],b),e.UriIdentityService=b,(0,R.registerSingleton)(T.IUriIdentityService,b,1)}),define(Q[145],_([0,1,103,14,54,18,11,10,16]),function(x,e,T,R,P,O,k,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,w.createDecorator)("contextService");function l(i){const n=i;return typeof n?.id=="string"&&k.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=l;function b(i){return typeof i?.id=="string"&&!l(i)&&!d(i)}e.isEmptyWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function m(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=m;function d(i){const n=i;return typeof n?.id=="string"&&k.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=d;function I(i){const n=i;if(n?.uri)return{id:n.id,uri:k.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:k.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=I;var v;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function A(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=A;function c(i){const n=i;return!!(n&&typeof n=="object"&&k.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=c;class f{constructor(n,r,o,a,h){this.h=n,this.j=o,this.k=a,this.l=h,this.c=P.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=P.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class y{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,O.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=y;function S(i){return new y({uri:i,index:0,name:(0,O.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(i,n){return O.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function E(i){let n;return k.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=E;function t(i,n){return!p(i,n)&&!E(i)}e.isSavedWorkspace=t;function s(i){return(typeof i=="string"?(0,R.extname)(i):(0,O.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Q[21],_([0,1,52,4,2,18,11,102,17,13,10,6,145,36,27,5,31,32,3]),function(x,e,T,R,P,O,k,w,g,l,b,m,d,I,v,A,c,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function S(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&k.URI.isUri(n.location)&&k.URI.isUri(n.globalStorageHome)&&k.URI.isUri(n.settingsResource)&&k.URI.isUri(n.keybindingsResource)&&k.URI.isUri(n.tasksResource)&&k.URI.isUri(n.snippetsHome)&&k.URI.isUri(n.extensionsResource))}e.isUserDataProfile=S,e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function p(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:k.URI.revive(i.location).with({scheme:n}),globalStorageHome:k.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:k.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:k.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:k.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:k.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:k.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=p;function E(i,n,r,o){return{id:i,name:n,location:r,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,O.joinPath)(r,"globalStorage"),settingsResource:(0,O.joinPath)(r,"settings.json"),keybindingsResource:(0,O.joinPath)(r,"keybindings.json"),tasksResource:(0,O.joinPath)(r,"tasks.json"),snippetsHome:(0,O.joinPath)(r,"snippets"),extensionsResource:(0,O.joinPath)(r,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=E;let t=class extends P.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,r,o,a){super(),this.m=n,this.n=r,this.r=o,this.s=a,this.f=!0,this.g=this.B(new R.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new R.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new R.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new R.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new I.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,O.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)for(const h of this.G()){if(!h.name||!(0,y.isString)(h.name)||!h.location){this.s.warn("Skipping the invalid stored profile",h.location||h.name);continue}n.push(E((0,O.basename)(h.location),h.name,h.location,{shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}))}const r=new I.ResourceMap,o=new Map,a=E((0,T.hash)(this.m.userRoamingDataHome.path).toString(16),(0,w.localize)(0,null),this.m.userRoamingDataHome);if(n.unshift({...a,extensionsResource:this.L()??a.extensionsResource,isDefault:!0}),n.length){const h=this.I();if(h.workspaces)for(const[u,D]of Object.entries(h.workspaces)){const F=k.URI.parse(u),Y=k.URI.parse(D),Z=n.find(te=>this.r.extUri.isEqual(te.location,Y));Z&&r.set(F,Z)}if(h.emptyWindows)for(const[u,D]of Object.entries(h.emptyWindows)){const F=k.URI.parse(D),Y=n.find(Z=>this.r.extUri.isEqual(Z.location,F));Y&&o.set(u,Y)}}this.t={profiles:n,workspaces:r,emptyWindows:o}}return this.t}async createTransientProfile(n){const r="Temp",o=new RegExp(`${(0,f.escapeRegExpCharacters)(r)}\\s(\\d+)`);let a=0;for(const u of this.profiles){const D=o.exec(u.name),F=D?parseInt(D[1]):0;a=F>a?F:a}const h=`${r} ${a+1}`;return this.createProfile((0,T.hash)((0,c.generateUuid)()).toString(16),h,{transient:!0},n)}async createNamedProfile(n,r,o){return this.createProfile((0,T.hash)((0,c.generateUuid)()).toString(16),n,r,o)}async createProfile(n,r,o,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=await this.v(n,r,o);return a&&await this.setProfileForWorkspace(a,h),h}async v(n,r,o){if(!(0,y.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.k.get(r);return a||(a=(async()=>{try{const h=this.profiles.find(F=>F.name===r||F.id===n);if(h)return h;const u=E(n,r,(0,O.joinPath)(this.profilesHome,n),o);await this.n.createFolder(u.location);const D=[];return this.h.fire({profile:u,join(F){D.push(F)}}),await A.Promises.settled(D),this.z([u],[],[]),u}finally{this.k.delete(r)}})(),this.k.set(r,a)),a}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(a=>a.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);return o=E(o.id,r.name??o.name,o.location,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.z([],[],[o]),o}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(a=>a.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const o=[];this.i.fire({profile:r,join(a){o.push(a)}});try{await Promise.allSettled(o)}catch(a){this.s.error(a)}for(const a of[...this.u.emptyWindows.keys()])r.id===this.u.emptyWindows.get(a)?.id&&this.u.emptyWindows.delete(a);for(const a of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(a)?.id&&this.u.workspaces.delete(a);this.F(),this.z([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(a){this.s.error(a)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(a=>a.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.D(n,o)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.D(n,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.r.extUri.isEqual(o.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(r=>!this.y(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.w(n);return k.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindows.get(r)??this.u.emptyWindows.get(r)}w(n){return(0,d.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,d.isWorkspaceIdentifier)(n)?n.configPath:n.id}y(n){return!!([...this.l.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location)))}z(n,r,o){const a=[...this.profiles,...n],h=[];this.l.profiles=[];for(let u of a)u.isDefault||r.some(D=>u.id===D.id)||(u=o.find(D=>u.id===D.id)??u,u.isTransient?this.l.profiles.push(u):h.push({location:u.location,name:u.name,shortName:u.shortName,useDefaultFlags:u.useDefaultFlags}));this.H(h),this.t=void 0,this.C(n,r,o)}C(n,r,o){this.g.fire({added:n,removed:r,updated:o,all:this.profiles})}D(n,r,o){o=r?.isTransient?!0:o,o||this.D(n,void 0,!0);const a=this.w(n),h=o?this.l:this.u;k.URI.isUri(a)?(h.workspaces.delete(a),r&&h.workspaces.set(a,r)):(h.emptyWindows.delete(a),r&&h.emptyWindows.set(a,r)),o||this.F()}F(){const n={};for(const[o,a]of this.u.workspaces.entries())n[o.toString()]=a.location.toString();const r={};for(const[o,a]of this.u.emptyWindows.entries())r[o.toString()]=a.location.toString();this.J({workspaces:n,emptyWindows:r}),this.t=void 0}G(){return[]}H(n){throw new Error("not implemented")}I(){return{}}J(n){throw new Error("not implemented")}L(){}};t.b="userDataProfiles",t.c="profileAssociations",t=fe([ee(0,g.IEnvironmentService),ee(1,l.IFileService),ee(2,v.IUriIdentityService),ee(3,m.ILogService)],t),e.UserDataProfilesService=t;class s extends t{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(n){this.a=n}I(){return this.O}J(n){this.O=n}}e.InMemoryUserDataProfilesService=s}),define(Q[146],_([0,1,19,5,22,7,4,2,12,11,87,24,26,29,6,28,25,21]),function(x,e,T,R,P,O,k,w,g,l,b,m,d,I,v,A,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var y;(function(i){i.Verified="Verified",i.Unverified="Unverified",i.UnknownError="UnknownError"})(y=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let S=class extends w.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,r,o,a,h){super(),this.t=n,this.u=r,this.v=o,this.w=a,this.y=h,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new k.Emitter),this.m=this.B(new k.Emitter),this.n=this.B(new k.Emitter),this.p=this.B(new k.Emitter),this.s=[],this.B((0,w.toDisposable)(()=>{this.j.forEach(({task:u})=>u.cancel()),this.k.forEach(u=>u.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(o=>(0,m.isTargetPlatformCompatible)(o,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{if(!this.t.isEnabled())throw new m.ExtensionManagementError(b.localize(0,null),m.ExtensionManagementErrorCode.Internal);const o=await this.G(n,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(o.manifest,o.extension,r)}catch(o){throw t(this.u,"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(n),error:o}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(o),E(o)}}async uninstall(n,r={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,r)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,r,o){const a={...o,installOnlyNewlyAddedFromExtensionPack:l.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,I.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},h=te=>`${d.ExtensionKey.create(te).toString()}${a.profileLocation?`-${a.profileLocation.toString()}`:""}`;if(!l.URI.isUri(r)){const te=this.j.get(h(r));if(te){this.v.info("Extensions is already requested to install",r.identifier.id);const{local:ie}=await te.task.waitUntilTaskIsFinished();return ie}}const u=[],D=[],F=[],Y=this.Q(n,r,a);l.URI.isUri(r)||this.j.set(h(r),{task:Y,waitingTasks:[]}),this.l.fire({identifier:Y.identifier,source:r,profileLocation:a.profileLocation}),this.v.info("Installing extension:",Y.identifier.id),u.push({task:Y,manifest:n});let Z=!1;try{if(a.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",Y.identifier.id);else try{const ie=await this.F(Y.identifier,n,!!a.installOnlyNewlyAddedFromExtensionPack,!!a.installPreReleaseVersion,a.profileLocation),ne=await this.getInstalled(void 0,a.profileLocation);for(const{gallery:ae,manifest:ue}of(0,T.distinct)(ie,({gallery:se})=>se.identifier.id)){Z=Z||!!ue.extensionDependencies?.some(B=>(0,d.areSameExtensions)({id:B},Y.identifier));const se=h(ae),ve=this.j.get(se);if(ve){if(this.C(Y,ve.task)){const B=ve.task.identifier;this.v.info("Waiting for already requested installing extension",B.id,Y.identifier.id),ve.waitingTasks.push(Y),D.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,j=>j.some(M=>(0,d.areSameExtensions)(M.identifier,B)))).then(j=>{if(this.v.info("Finished waiting for already requested installing extension",B.id,Y.identifier.id),!j.find($=>(0,d.areSameExtensions)($.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!ne.some(({identifier:B})=>(0,d.areSameExtensions)(B,ae.identifier))){const B=this.Q(ue,ae,{...a,donotIncludePackAndDependencies:!0});this.j.set(se,{task:B,waitingTasks:[Y]}),this.l.fire({identifier:B.identifier,source:ae,profileLocation:a.profileLocation}),this.v.info("Installing extension:",B.identifier.id,Y.identifier.id),u.push({task:B,manifest:ue})}}}catch(ie){if(l.URI.isUri(Y.source))(0,T.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",Y.identifier.id,ie.message),(0,T.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",Y.identifier.id,ie.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",Y.identifier.id),ie}const te=u.reduce((ie,{task:ne,manifest:ae})=>(ie.set(ne.identifier.id.toLowerCase(),{task:ne,manifest:ae}),ie),new Map);for(;te.size;){let ie;const ne=[...te.values()].filter(({manifest:ae})=>!ae.extensionDependencies?.some(ue=>te.has(ue.toLowerCase())));ne.length?ie=te.size===1?ne:ne.filter(({task:ae})=>!(ae===Y&&!Z)):(this.v.info("Found extensions with circular dependencies",ne.map(({task:ae})=>ae.identifier.id)),ie=[...te.values()]),await this.D(ie.map(async({task:ae})=>{const ue=new Date().getTime();try{const{local:se}=await ae.run();if(await this.D(this.s.map(ve=>ve.postInstall(se,ae.source,a,P.CancellationToken.None))),!l.URI.isUri(ae.source)){const ve=ae.operation===3,B=ve?void 0:(new Date().getTime()-ae.source.lastUpdated)/1e3;if(t(this.u,ve?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-ue,durationSinceUpdate:B}),g.isWeb&&ae.operation!==3)try{await this.t.reportStatistic(se.manifest.publisher,se.manifest.name,se.manifest.version,"install")}catch{}}F.push({local:se,identifier:ae.identifier,operation:ae.operation,source:ae.source,context:a.context,profileLocation:a.profileLocation,applicationScoped:se.isApplicationScoped})}catch(se){throw l.URI.isUri(ae.source)||t(this.u,ae.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-ue,error:se}),this.v.error("Error while installing the extension:",ae.identifier.id),se}finally{te.delete(ae.identifier.id.toLowerCase())}}))}return D.length&&await this.D(D),F.forEach(({identifier:ie})=>this.v.info("Extension installed successfully:",ie.id)),this.m.fire(F),F.filter(({identifier:ie})=>(0,d.areSameExtensions)(ie,Y.identifier))[0].local}catch(te){if(u.forEach(({task:ie})=>ie.cancel()),F.length)try{const ie=await Promise.allSettled(F.map(({local:ne})=>this.R(ne,{versionOnly:!0,profileLocation:a.profileLocation}).run()));for(let ne=0;ne<ie.length;ne++){const ae=ie[ne],{identifier:ue}=F[ne];ae.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",ue.id):this.v.warn("Rollback: Error while uninstalling extension",ue.id,(0,O.getErrorMessage)(ae.reason))}}catch(ie){this.v.warn("Error while rolling back extensions",(0,O.getErrorMessage)(ie),F.map(({identifier:ne})=>ne.id))}throw this.m.fire(u.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:a.context,profileLocation:a.profileLocation}))),te}finally{for(const{task:te}of u)te.source&&!l.URI.isUri(te.source)&&this.j.delete(h(te.source))}}C(n,r){for(const[,{task:o,waitingTasks:a}]of this.j.entries())if(o===n&&(a.includes(r)||a.some(h=>this.C(h,r)))||o===r&&a[0]&&!this.C(n,a[0]))return!1;return!0}async D(n){const r=[],o=[],a=await Promise.allSettled(n);for(const h of a)h.status==="fulfilled"?r.push(h.value):o.push(h.reason);if(o.length)throw p(o);return r}async F(n,r,o,a,h){if(!this.t.isEnabled())return[];const u=await this.getInstalled(void 0,h),D=[],F=[],Y=async(Z,te)=>{D.push(Z);const ie=te.extensionDependencies||[],ne=[...ie];if(te.extensionPack){const ae=o?u.find(ue=>(0,d.areSameExtensions)(ue.identifier,Z)):void 0;for(const ue of te.extensionPack)ae&&ae.manifest.extensionPack&&ae.manifest.extensionPack.some(se=>(0,d.areSameExtensions)({id:se},{id:ue}))||ne.every(se=>!(0,d.areSameExtensions)({id:se},{id:ue}))&&ne.push(ue)}if(ne.length){const ae=ne.filter(ue=>D.every(se=>!(0,d.areSameExtensions)(se,{id:ue})));if(ae.length){const ue=await this.t.getExtensions(ae.map(se=>({id:se,preRelease:a})),P.CancellationToken.None);for(const se of ue){if(D.find(j=>(0,d.areSameExtensions)(j,se.identifier)))continue;const ve=ie.some(j=>(0,d.areSameExtensions)({id:j},se.identifier));let B;try{B=await this.G(se,!1,a)}catch(j){if(j instanceof m.ExtensionManagementError&&j.code===m.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ve){this.v.info("Skipping the packed extension as it cannot be installed",se.identifier.id);continue}else throw j}F.push({gallery:B.extension,manifest:B.manifest}),await Y(B.extension.identifier,B.manifest)}}}};return await Y(n,r),F}async G(n,r,o){if((await this.getExtensionsControlManifest()).malicious.some(D=>(0,d.areSameExtensions)(n.identifier,D)))throw new m.ExtensionManagementError(b.localize(1,null,n.identifier.id),m.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const D=await this.getTargetPlatform();throw new m.ExtensionManagementError(b.localize(2,null,n.identifier.id,this.w.nameLong,(0,m.TargetPlatformToString)(D)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const h=await this.H(n,r,o);if(h){if(o&&!r&&n.hasPreReleaseVersion&&!h.properties.isPreReleaseVersion)throw new m.ExtensionManagementError(b.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),m.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],P.CancellationToken.None))[0]?new m.ExtensionManagementError(b.localize(4,null,n.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.ExtensionManagementError(b.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),m.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",h.identifier.id);const u=await this.t.getManifest(h,P.CancellationToken.None);if(u===null)throw new m.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(u.version!==h.version)throw new m.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:h,manifest:u}}async H(n,r,o){const a=await this.getTargetPlatform();let h=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==o&&(h=(await this.t.getExtensions([{...n.identifier,preRelease:o}],{targetPlatform:a,compatible:!0},P.CancellationToken.None))[0]||null),!h&&await this.t.isExtensionCompatible(n,o,a)&&(h=n),h||(r?h=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:a,compatible:!0},P.CancellationToken.None))[0]||null:h=await this.t.getCompatibleExtension(n,o,a)),h}async I(n,r){const o={...r,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},a=Z=>`${Z.id.toLowerCase()}${o.versionOnly?`-${n.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,h=this.k.get(a(n.identifier));if(h)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),h.waitUntilTaskIsFinished();const u=Z=>{const te=this.R(Z,o);return this.k.set(a(te.extension.identifier),te),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${Z.identifier.id}@${Z.manifest.version}`),this.n.fire({identifier:Z.identifier,profileLocation:o.profileLocation,applicationScoped:Z.isApplicationScoped}),te},D=(Z,te)=>{te?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,o.profileLocation.toString(),te.message):this.v.error("Failed to uninstall extension:",`${Z.identifier.id}@${Z.manifest.version}`,te.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${Z.identifier.id}@${Z.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${Z.identifier.id}@${Z.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,d.getLocalExtensionTelemetryData)(Z),error:te}),this.p.fire({identifier:Z.identifier,error:te?.code,profileLocation:o.profileLocation,applicationScoped:Z.isApplicationScoped})},F=[],Y=[];try{F.push(u(n));const Z=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const te=this.M(n,Z);for(const ie of te)this.k.has(a(ie.identifier))?this.v.info("Extensions is already requested to uninstall",ie.identifier.id):F.push(u(ie))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(F.map(te=>te.extension),Z,n),await this.D(F.map(async te=>{try{if(await te.run(),await this.D(this.s.map(ie=>ie.postUninstall(te.extension,o,P.CancellationToken.None))),te.extension.identifier.uuid)try{await this.t.reportStatistic(te.extension.manifest.publisher,te.extension.manifest.name,te.extension.manifest.version,"uninstall")}catch{}D(te.extension)}catch(ie){const ne=ie instanceof m.ExtensionManagementError?ie:new m.ExtensionManagementError((0,O.getErrorMessage)(ie),m.ExtensionManagementErrorCode.Internal);throw D(te.extension,ne),ne}finally{Y.push(te)}}))}catch(Z){const te=Z instanceof m.ExtensionManagementError?Z:new m.ExtensionManagementError((0,O.getErrorMessage)(Z),m.ExtensionManagementErrorCode.Internal);for(const ie of F){try{ie.cancel()}catch{}Y.includes(ie)||D(ie.extension,te)}throw te}finally{for(const Z of F)this.k.delete(a(Z.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",Z.extension.identifier.id)}}J(n,r,o){for(const a of n){const h=this.N(a,r);if(h.length){const u=h.filter(D=>!n.some(F=>(0,d.areSameExtensions)(F.identifier,D.identifier)));if(u.length)throw new Error(this.L(a,u,o))}}}L(n,r,o){return o===n?r.length===1?b.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?b.localize(9,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(10,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(11,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(n,r,o=[]){if(o.indexOf(n)!==-1)return[];o.push(n);const a=n.manifest.extensionPack?n.manifest.extensionPack:[];if(a.length){const h=r.filter(D=>!D.isBuiltin&&a.some(F=>(0,d.areSameExtensions)({id:F},D.identifier))),u=[];for(const D of h)u.push(...this.M(D,r,o));return[...h,...u]}return[]}N(n,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(a=>(0,d.areSameExtensions)({id:a},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};S=fe([ee(0,m.IExtensionGalleryService),ee(1,c.ITelemetryService),ee(2,v.ILogService),ee(3,A.IProductService),ee(4,f.IUserDataProfilesService)],S),e.AbstractExtensionManagementService=S;function p(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=p;function E(i){if(i instanceof m.ExtensionManagementError)return i;const n=new m.ExtensionManagementError(i.message,m.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}function t(i,n,{extensionData:r,verificationStatus:o,duration:a,error:h,durationSinceUpdate:u}){let D,F;h&&(h instanceof m.ExtensionManagementError?(D=h.code,h.code===m.ExtensionManagementErrorCode.Signature&&(F=h.message)):D=m.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:o,success:!h,duration:a,errorcode:D,errorcodeDetail:F,durationSinceUpdate:u})}e.reportTelemetry=t;class s{constructor(){this.d=new R.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.createCancelablePromise)(n=>new Promise((r,o)=>{const a=n.onCancellationRequested(()=>{a.dispose(),o(new O.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=s}),define(Q[40],_([0,1,5,15,2,4,36,11,26,29,13,10,6,21,27,3,7,25]),function(x,e,T,R,P,O,k,w,g,l,b,m,d,I,v,A,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var y;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(y=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class S extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=S,e.IExtensionsProfileScannerService=(0,m.createDecorator)("IExtensionsProfileScannerService");let p=class extends P.Disposable{constructor(i,n,r,o,a,h){super(),this.h=i,this.i=n,this.j=r,this.k=o,this.l=a,this.m=h,this.a=this.B(new O.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new O.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new O.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new O.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new k.ResourceMap}scanProfileExtensions(i,n){return this.n(i,void 0,n)}async addExtensionsToProfile(i,n){const r=[],o=[];try{return await this.n(n,a=>{const h=[];for(const u of a)i.some(([D])=>(0,g.areSameExtensions)(D.identifier,u.identifier)&&D.manifest.version!==u.version)?r.push(u):h.push(u);for(const[u,D]of i)if(!h.some(F=>(0,g.areSameExtensions)(F.identifier,u.identifier)&&F.version===u.manifest.version)){const F={identifier:u.identifier,version:u.manifest.version,location:u.location,metadata:D};o.push(F),h.push(F)}return o.length&&this.a.fire({extensions:o,profileLocation:n}),r.length&&this.c.fire({extensions:r,profileLocation:n}),h}),o.length&&this.b.fire({extensions:o,profileLocation:n}),r.length&&this.f.fire({extensions:r,profileLocation:n}),o}catch(a){throw o.length&&this.b.fire({extensions:o,error:a,profileLocation:n}),r.length&&this.f.fire({extensions:r,error:a,profileLocation:n}),a}}async updateMetadata(i,n){const r=[];return await this.n(n,o=>{const a=[];for(const h of o){const u=i.find(([D])=>(0,g.areSameExtensions)(D.identifier,h.identifier)&&D.manifest.version===h.version);u&&(h.metadata={...h.metadata,...u[1]},r.push(h)),a.push(h)}return a}),r}async removeExtensionFromProfile(i,n){const r=[];this.c.fire({extensions:r,profileLocation:n});try{await this.n(n,o=>{const a=[];for(const h of o)(0,g.areSameExtensions)(h.identifier,i.identifier)?r.push(h):a.push(h);return r.length&&this.c.fire({extensions:r,profileLocation:n}),a}),r.length&&this.f.fire({extensions:r,profileLocation:n})}catch(o){throw r.length&&this.f.fire({extensions:r,error:o,profileLocation:n}),o}}async n(i,n,r){return this.v(i).queue(async()=>{let o=[],a;try{const h=await this.i.readFile(i);a=JSON.parse(h.value.toString())}catch(h){if((0,b.toFileOperationResult)(h)!==1)throw h;if(this.k.extUri.isEqual(i,this.j.defaultProfile.extensionsResource)&&(a=await this.u()),!a&&r?.bailOutWhenFileNotFound)throw new S((0,c.getErrorMessage)(h),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.p(i);let h=!1;for(const u of a){E(u)||this.p(i);let D;if((0,A.isString)(u.location))D=this.s(u.location);else{D=w.URI.revive(u.location);const F=this.r(D);F&&(h=!0,u.location=F)}o.push({identifier:u.identifier,location:D,version:u.version,metadata:u.metadata})}h&&await this.i.writeFile(i,R.VSBuffer.fromString(JSON.stringify(a)))}if(n){o=n(o);const h=o.map(u=>({identifier:u.identifier,version:u.version,location:this.r(u.location)??u.location.toJSON(),metadata:u.metadata}));await this.i.writeFile(i,R.VSBuffer.fromString(JSON.stringify(h)))}return o})}p(i){const n=new S(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}r(i){return this.k.extUri.isEqualOrParent(i,this.h)?this.k.extUri.relativePath(this.h,i):void 0}s(i){return this.k.extUri.joinPath(this.h,i)}async u(){return this.t||(this.t=(async()=>{const i=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let n;try{n=(await this.i.readFile(i)).value.toString()}catch(o){if((0,b.toFileOperationResult)(o)===1)return;throw o}this.m.info("Migrating extensions from old default profile location",i.toString());let r;try{const o=JSON.parse(n);Array.isArray(o)&&o.every(a=>E(a))?r=o:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.m.error(o)}if(r)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",i.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(o){if((0,b.toFileOperationResult)(o)===3)this.m.info("Migration from old default profile location to new location is done by another window",i.toString(),this.j.defaultProfile.extensionsResource.toString());else throw o}try{await this.i.del(i)}catch(o){(0,b.toFileOperationResult)(o)!==1&&this.m.error(o)}return r})()),this.t}v(i){let n=this.g.get(i);return n||(n=new T.Queue,this.g.set(i,n)),n}};p=fe([ee(1,b.IFileService),ee(2,I.IUserDataProfilesService),ee(3,v.IUriIdentityService),ee(4,f.ITelemetryService),ee(5,d.ILogService)],p),e.AbstractExtensionsProfileScannerService=p;function E(s){return(0,A.isObject)(s)&&(0,l.isIExtensionIdentifier)(s.identifier)&&(t(s.location)||(0,A.isString)(s.location))&&s.version&&(0,A.isString)(s.version)}function t(s){return s?(0,A.isString)(s.path)&&(0,A.isString)(s.scheme):!1}}),define(Q[48],_([0,1,19,5,30,15,7,50,78,2,16,14,12,18,41,53,3,11,91,17,26,29,45,13,10,6,28,4,44,40,21,27,107,108]),function(x,e,T,R,P,O,k,w,g,l,b,m,d,I,v,A,c,f,y,S,p,E,t,s,i,n,r,o,a,h,u,D,F,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var Z;(function(ve){function B(j,M){if(j===M)return!0;const $=Object.keys(j),W=new Set;for(const q of Object.keys(M))W.add(q);if($.length!==W.size)return!1;for(const q of $){if(j[q]!==M[q])return!1;W.delete(q)}return W.size===0}ve.equals=B})(Z=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let te=class extends l.Disposable{constructor(B,j,M,$,W,q,X,C,N,L,U,V){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=j,this.l=M,this.m=$,this.n=W,this.p=q,this.r=X,this.s=C,this.t=N,this.u=L,this.v=U,this.w=V,this.g=this.B(new o.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,I.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(ae,(0,I.joinPath)(this.m,E.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(ae,(0,I.joinPath)(this.m,E.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(ne,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,p.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(B,j,M){const[$,W]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(j)]),q=M?await this.scanExtensionsUnderDevelopment(B,[...$,...W]):[];return this.F($,W,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const j=[];j.push(this.G(!!B.useCache,B.language)),j.push(this.H(B.language,!!B.checkControlFile));const[M,$]=await Promise.all(j);return this.D([...M,...$],0,B,!1)}async scanUserExtensions(B){const j=B.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",j);const M=this.v.extUri.isEqual(B.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,$=await this.J(j,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,M),W=B.useCache&&!$.devMode&&$.excludeObsolete?this.j:this.k;let q;try{q=await W.scanExtensions($)}catch(X){if(X instanceof h.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),q=await W.scanExtensions($);else throw X}return q=await this.D(q,1,B,!0),this.s.trace("Scanned user extensions:",q.length),q}async scanExtensionsUnderDevelopment(B,j){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const M=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter($=>$.scheme===b.Schemas.file).map(async $=>{const W=await this.J($,!1,1,!0,B.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(W)).map(X=>(X.type=j.find(C=>(0,p.areSameExtensions)(C.identifier,X.identifier))?.type??X.type,this.k.validate(X,W)))}))).flat();return this.D(M,"development",B,!0)}return[]}async scanExistingExtension(B,j,M){const $=await this.J(B,!1,j,!0,M.language,!0,void 0),W=await this.k.scanExtension($);return!W||!M.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(B,j,M){const $=await this.J(B,!1,j,!0,M.language,!0,void 0),W=await this.k.scanOneOrMultipleExtensions($);return this.D(W,j,M,!0)}async scanMetadata(B){const j=(0,I.joinPath)(B,"package.json"),M=(await this.r.readFile(j)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(B,j){const M=(0,I.joinPath)(B,"package.json"),$=(await this.r.readFile(M)).value.toString(),W=JSON.parse($);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0,W.__metadata={...W.__metadata,...j},await this.r.writeFile((0,I.joinPath)(B,"package.json"),O.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof h.ExtensionsProfileScanningError&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw B}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.p.addExtensionsToProfile(B.map(j=>[j,j.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify([])))}catch(j){(0,s.toFileOperationResult)(j)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.getErrorMessage)(j))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.s.error(B)}finally{this.z=void 0}})()),this.z}async D(B,j,M,$){return M.includeAllVersions||(B=this.F(j===0?B:void 0,j===1?B:void 0,j==="development"?B:void 0,await this.getTargetPlatform(),$)),M.includeInvalid||(B=B.filter(W=>W.isValid)),B.sort((W,q)=>{const X=m.basename(W.location.fsPath),C=m.basename(q.location.fsPath);return X<C?-1:X>C?1:0})}F(B,j,M,$,W){const q=(C,N,L)=>{if(C.isValid&&!N.isValid)return!1;if(C.isValid===N.isValid){if(W&&v.gt(C.manifest.version,N.manifest.version))return this.s.debug(`Skipping extension ${N.location.path} with lower version ${N.manifest.version} in favour of ${C.location.path} with version ${C.manifest.version}`),!1;if(v.eq(C.manifest.version,N.manifest.version)){if(C.type===0)return this.s.debug(`Skipping extension ${N.location.path} in favour of system extension ${C.location.path} with same version`),!1;if(C.targetPlatform===$)return this.s.debug(`Skipping extension ${N.location.path} from different target platform ${N.targetPlatform}`),!1}}return L?this.s.warn(`Overwriting user extension ${C.location.path} with ${N.location.path}.`):this.s.debug(`Overwriting user extension ${C.location.path} with ${N.location.path}.`),!0},X=new Map;return B?.forEach(C=>{const N=E.ExtensionIdentifier.toKey(C.identifier.id),L=X.get(N);(!L||q(L,C,!1))&&X.set(N,C)}),j?.forEach(C=>{const N=E.ExtensionIdentifier.toKey(C.identifier.id),L=X.get(N);if(!L&&B&&C.type===0){this.s.debug(`Skipping obsolete system extension ${C.location.path}.`);return}(!L||q(L,C,!1))&&X.set(N,C)}),M?.forEach(C=>{const N=E.ExtensionIdentifier.toKey(C.identifier.id),L=X.get(N);(!L||q(L,C,!0))&&X.set(N,C),X.set(N,C)}),[...X.values()]}async G(B,j){this.s.trace("Started scanning system extensions");const M=await this.J(this.systemExtensionsLocation,!1,0,!0,j,!0,void 0),W=await(B&&!M.devMode?this.i:this.k).scanExtensions(M);return this.s.trace("Scanned system extensions:",W.length),W}async H(B,j){const M=this.t.isBuilt?[]:this.u.builtInExtensions;if(!M?.length)return[];this.s.trace("Started scanning dev system extensions");const $=j?await this.I():{},W=[],q=f.URI.file(m.normalize(m.join(b.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const C of M){const N=$[C.name]||"marketplace";switch(N){case"disabled":break;case"marketplace":W.push((0,I.joinPath)(q,C.name));break;default:W.push(f.URI.file(N));break}}const X=await Promise.all(W.map(async C=>this.k.scanExtension(await this.J(C,!1,0,!0,B,!0,void 0))));return this.s.trace("Scanned dev system extensions:",X.length),(0,T.coalesce)(X)}async I(){try{const B=await this.r.readFile(this.l);return JSON.parse(B.value.toString())}catch{return{}}}async J(B,j,M,$,W,q,X){const C=await this.f(W??d.language),N=await this.L(B),L=j&&!this.v.extUri.isEqual(B,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,U=L?await this.L(L):void 0;return new ie(B,N,L,U,j,X,M,$,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,W,C)}async L(B){try{const j=await this.r.stat(B);if(typeof j.mtime=="number")return j.mtime}catch{}}};te=fe([ee(4,u.IUserDataProfilesService),ee(5,h.IExtensionsProfileScannerService),ee(6,s.IFileService),ee(7,n.ILogService),ee(8,S.IEnvironmentService),ee(9,r.IProductService),ee(10,D.IUriIdentityService),ee(11,i.IInstantiationService)],te),e.AbstractExtensionsScannerService=te;class ie{constructor(B,j,M,$,W,q,X,C,N,L,U,V,H,K,re){this.location=B,this.mtime=j,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=$,this.profile=W,this.profileScanOptions=q,this.type=X,this.excludeObsolete=C,this.validate=N,this.productVersion=L,this.productDate=U,this.productCommit=V,this.devMode=H,this.language=K,this.translations=re}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,j){return(0,I.isEqual)(B.location,j.location)&&B.mtime===j.mtime&&(0,I.isEqual)(B.applicationExtensionslocation,j.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===j.applicationExtensionslocationMtime&&B.profile===j.profile&&P.equals(B.profileScanOptions,j.profileScanOptions)&&B.type===j.type&&B.excludeObsolete===j.excludeObsolete&&B.validate===j.validate&&B.productVersion===j.productVersion&&B.productDate===j.productDate&&B.productCommit===j.productCommit&&B.devMode===j.devMode&&B.language===j.language&&Z.equals(B.translations,j.translations)}}e.ExtensionScannerInput=ie;let ne=class extends l.Disposable{constructor(B,j,M,$,W){super(),this.f=B,this.g=j,this.h=M,this.i=$,this.j=W}async scanExtensions(B){const j=B.profile?await this.l(B):await this.k(B);let M={};if(B.excludeObsolete&&B.type===1)try{const $=(await this.i.readFile(this.f)).value.toString();M=JSON.parse($)}catch{}return(0,c.isEmptyObject)(M)?j:j.filter($=>!M[p.ExtensionKey.create($).toString()])}async k(B){const j=await this.i.resolve(B.location);if(!j.children?.length)return[];const M=await Promise.all(j.children.map(async $=>{if(!$.isDirectory||B.type===1&&(0,I.basename)($.resource).indexOf(".")===0)return null;const W=new ie($.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(W)}));return(0,T.coalesce)(M).sort(($,W)=>$.location.path<W.location.path?-1:1)}async l(B){let j=await this.m(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){j=j.filter($=>!$.metadata?.isApplicationScoped);const M=await this.m(B.applicationExtensionslocation,$=>!!$.metadata?.isApplicationScoped,B);j.push(...M)}return j}async m(B,j,M){const $=await this.g.scanProfileExtensions(B,M.profileScanOptions);if(!$.length)return[];const W=await Promise.all($.map(async q=>{if(j(q)){const X=new ie(q.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(X,q.metadata)}return null}));return(0,T.coalesce)(W)}async scanOneOrMultipleExtensions(B){try{if(await this.i.exists((0,I.joinPath)(B.location,"package.json"))){const j=await this.scanExtension(B);return j?[j]:[]}else return await this.scanExtensions(B)}catch(j){return this.j.error(`Error scanning extensions at ${B.location.path}:`,(0,k.getErrorMessage)(j)),[]}}async scanExtension(B,j){try{let M=await this.scanExtensionManifest(B.location);if(M){M.publisher||(M.publisher=E.UNDEFINED_PUBLISHER),j=j??M.__metadata,delete M.__metadata;const $=(0,p.getGalleryExtensionId)(M.publisher,M.name),W=j?.id?{id:$,uuid:j.id}:{id:$},q=j?.isSystem?0:B.type,X=q===0||!!j?.isBuiltin;Y.ImplicitActivationEvents.updateManifest(M),M=await this.n(B.location,M,ie.createNlsConfiguration(B));const C={type:q,identifier:W,manifest:M,location:B.location,isBuiltin:X,targetPlatform:j?.targetPlatform??"undefined",metadata:j,isValid:!0,validations:[]};return B.validate?this.validate(C,B):C}}catch(M){B.type!==0&&this.j.error(M)}return null}validate(B,j){let M=!0;const $=(0,t.validateExtensionManifest)(j.productVersion,j.productDate,j.location,B.manifest,B.isBuiltin);for(const[W,q]of $)W===A.default.Error&&(M=!1,this.j.error(this.t(j.location,q)));return B.isValid=M,B.validations=$,B}async scanExtensionManifest(B){const j=(0,I.joinPath)(B,"package.json");let M;try{M=(await this.i.readFile(j)).value.toString()}catch(W){return(0,s.toFileOperationResult)(W)!==1&&this.j.error(this.t(B,(0,y.localize)(0,null,j.path,W.message))),null}let $;try{$=JSON.parse(M)}catch{const q=[];(0,w.parse)(M,q);for(const X of q)this.j.error(this.t(B,(0,y.localize)(1,null,j.path,X.offset,X.length,(0,g.getParseErrorMessage)(X.error))));return null}return(0,w.getNodeType)($)!=="object"?(this.j.error(this.t(B,(0,y.localize)(2,null,j.path))),null):$}async n(B,j,M){const $=await this.p(B,j,M);if($)try{const W=[],q=await this.r($.default,W);if(W.length>0)return W.forEach(C=>{this.j.error(this.t(B,(0,y.localize)(3,null,$.default?.path,(0,g.getParseErrorMessage)(C.error))))}),j;if((0,w.getNodeType)($)!=="object")return this.j.error(this.t(B,(0,y.localize)(4,null,$.default?.path))),j;const X=$.values||Object.create(null);return(0,F.localizeManifest)(j,X,q)}catch{}return j}async p(B,j,M){const $=(0,I.joinPath)(B,"package.nls.json"),W=(N,L)=>{L.forEach(U=>{this.j.error(this.t(B,(0,y.localize)(5,null,N?.path,(0,g.getParseErrorMessage)(U.error))))})},q=N=>{this.j.error(this.t(B,(0,y.localize)(6,null,N?.path)))},X=`${j.publisher}.${j.name}`,C=M.translations[X];if(C)try{const N=f.URI.file(C),L=(await this.i.readFile(N)).value.toString(),U=[],V=(0,w.parse)(L,U);return U.length>0?(W(N,U),{values:void 0,default:$}):(0,w.getNodeType)(V)!=="object"?(q(N),{values:void 0,default:$}):{values:V.contents?V.contents.package:void 0,default:$}}catch{return{values:void 0,default:$}}else{if(!await this.i.exists($))return;let L;try{L=await this.s(B,M)}catch{return}if(!L.localized)return{values:void 0,default:L.original};try{const U=(await this.i.readFile(L.localized)).value.toString(),V=[],H=(0,w.parse)(U,V);return V.length>0?(W(L.localized,V),{values:void 0,default:L.original}):(0,w.getNodeType)(H)!=="object"?(q(L.localized),{values:void 0,default:L.original}):{values:H,default:L.original}}catch{return{values:void 0,default:L.original}}}}async r(B,j){if(B)try{const M=(await this.i.readFile(B)).value.toString();return(0,w.parse)(M,j)}catch{}}s(B,j){return new Promise((M,$)=>{const W=q=>{const X=(0,I.joinPath)(B,`package.nls.${q}.json`);this.i.exists(X).then(C=>{C&&M({localized:X,original:(0,I.joinPath)(B,"package.nls.json")});const N=q.lastIndexOf("-");N===-1?M({localized:(0,I.joinPath)(B,"package.nls.json"),original:null}):(q=q.substring(0,N),W(q))})};if(j.devMode||j.pseudo||!j.language)return M({localized:(0,I.joinPath)(B,"package.nls.json"),original:null});W(j.language)})}t(B,j){return`[${B.path}]: ${j}`}};ne=fe([ee(1,h.IExtensionsProfileScannerService),ee(2,D.IUriIdentityService),ee(3,s.IFileService),ee(4,n.ILogService)],ne);let ae=class extends ne{constructor(B,j,M,$,W,q){super(j,M,$,W,q),this.y=B,this.v=this.B(new R.ThrottledDelayer(3e3)),this.w=this.B(new o.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(B){const j=await this.z();if(this.u=B,j&&j.input&&ie.equals(j.input,this.u))return this.j.debug("Using cached extensions scan result",B.location.toString()),this.v.trigger(()=>this.D()),j.result.map($=>($.location=f.URI.revive($.location),$));const M=await super.scanExtensions(B);return await this.C({input:B,result:M}),M}async z(){try{const B=await this.i.readFile(this.y),j=JSON.parse(B.value.toString());return{result:j.result,input:(0,a.revive)(j.input)}}catch(B){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,k.getErrorMessage)(B))}return null}async C(B){try{await this.i.writeFile(this.y,O.VSBuffer.fromString(JSON.stringify(B)))}catch(j){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,k.getErrorMessage)(j))}}async D(){if(!this.u)return;const B=await this.z();if(!B)return;const j=B.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!P.equals(M,j))try{await this.i.del(this.y),this.w.fire()}catch($){this.j.error($)}}};ae=fe([ee(2,h.IExtensionsProfileScannerService),ee(3,D.IUriIdentityService),ee(4,s.IFileService),ee(5,n.ILogService)],ae);function ue(ve,B){const j=(0,p.getExtensionId)(ve.manifest.publisher,ve.manifest.name);return{id:j,identifier:new E.ExtensionIdentifier(j),isBuiltin:ve.type===0,isUserBuiltin:ve.type===1&&ve.isBuiltin,isUnderDevelopment:B,extensionLocation:ve.location,uuid:ve.identifier.uuid,targetPlatform:ve.targetPlatform,...ve.manifest}}e.toExtensionDescription=ue;class se extends te{constructor(B,j,M,$,W,q,X,C,N,L,U,V){super(B,j,(0,I.joinPath)(M,".vscode-oss-dev","extensions","control.json"),(0,I.joinPath)($,E.MANIFEST_CACHE_FOLDER),W,q,X,C,N,L,U,V),this.M=(async()=>{if(d.translationsConfigFile)try{const H=await this.r.readFile(f.URI.file(d.translationsConfigFile));return JSON.parse(H.value.toString())}catch{}return Object.create(null)})()}f(B){return this.M}}e.NativeExtensionsScannerService=se}),define(Q[147],_([0,1,57,5,34,4,2,16,14,20,6,21]),function(x,e,T,R,P,O,k,w,g,l,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends k.Disposable{constructor(v,A){super(),this.b=v,this.f=A,this.a=new R.Limiter(5)}async postUninstall(v){const A=this.g(v,"uninstall");return A&&(this.f.info(v.identifier.id,v.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(A.script,"uninstall",A.args,!0,v).then(()=>this.f.info(v.identifier.id,v.manifest.version,"Finished running post uninstall script"),c=>this.f.error(v.identifier.id,v.manifest.version,`Failed to run post uninstall script: ${c}`)))),l.Promises.rm(this.j(v)).then(void 0,c=>this.f.error("Error while removing extension storage path",c))}g(v,A){const c=`vscode:${A}`;if(v.location.scheme===w.Schemas.file&&v.manifest&&v.manifest.scripts&&typeof v.manifest.scripts[c]=="string"){const f=v.manifest.scripts[c].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(v.identifier.id,v.manifest.version,`${c} should be a node script`),null):{script:(0,g.join)(v.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(v,A,c,f,y){return new Promise((S,p)=>{const E=this.i(v,A,c,y);let t;const s=i=>{t&&(clearTimeout(t),t=null),i?p(i):S(void 0)};E.on("error",i=>{s((0,P.toErrorMessage)(i)||"Unknown")}),E.on("exit",(i,n)=>{s(i?`post-${A} process exited with code ${i}`:void 0)}),f&&(t=setTimeout(()=>{t=null,E.kill(),p("timed out")},5e3))})}i(v,A,c,f){const y={silent:!0,execArgv:void 0},S=(0,T.fork)(v,[`--type=extension-post-${A}`,...c],y);S.stdout.setEncoding("utf8"),S.stderr.setEncoding("utf8");const p=O.Event.fromNodeEventEmitter(S.stdout,"data"),E=O.Event.fromNodeEventEmitter(S.stderr,"data");p(i=>this.f.info(f.identifier.id,f.manifest.version,`post-${A}`,i)),E(i=>this.f.error(f.identifier.id,f.manifest.version,`post-${A}`,i));const t=O.Event.any(O.Event.map(p,i=>({data:`%c${i}`,format:[""]})),O.Event.map(E,i=>({data:`%c${i}`,format:["color: red"]})));return O.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(f.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),S}j(v){return(0,g.join)(this.b.defaultProfile.globalStorageHome.fsPath,v.identifier.id.toLowerCase())}};d=fe([ee(0,m.IUserDataProfilesService),ee(1,b.ILogService)],d),e.ExtensionsLifecycle=d}),define(Q[148],_([0,1,6,21,27,25,40,13,17,11]),function(x,e,T,R,P,O,k,w,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let b=class extends k.AbstractExtensionsProfileScannerService{constructor(d,I,v,A,c,f){super(l.URI.file(d.extensionsPath),I,v,A,c,f)}};b=fe([ee(0,g.INativeEnvironmentService),ee(1,w.IFileService),ee(2,R.IUserDataProfilesService),ee(3,P.IUriIdentityService),ee(4,O.ITelemetryService),ee(5,T.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(Q[149],_([0,1,11,17,40,48,13,10,6,28,27,21]),function(x,e,T,R,P,O,k,w,g,l,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let d=class extends O.NativeExtensionsScannerService{constructor(v,A,c,f,y,S,p,E){super(T.URI.file(y.builtinExtensionsPath),T.URI.file(y.extensionsPath),y.userHome,T.URI.file(y.userDataPath),v,A,c,f,y,S,p,E)}};d=fe([ee(0,m.IUserDataProfilesService),ee(1,P.IExtensionsProfileScannerService),ee(2,k.IFileService),ee(3,g.ILogService),ee(4,R.INativeEnvironmentService),ee(5,l.IProductService),ee(6,b.IUriIdentityService),ee(7,w.IInstantiationService)],d),e.ExtensionsScannerService=d}),define(Q[150],_([0,1,5,4,2,118,3,84,10,21]),function(x,e,T,R,P,O,k,w,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var b;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var m;(function(y){y[y.APPLICATION=-1]="APPLICATION",y[y.PROFILE=0]="PROFILE",y[y.WORKSPACE=1]="WORKSPACE"})(m=e.StorageScope||(e.StorageScope={}));var d;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));function I(y){const S=y.get(e.TARGET_KEY);if(S)try{return JSON.parse(S)}catch{}return Object.create(null)}e.loadKeyTargets=I;class v extends P.Disposable{constructor(S={flushInterval:v.a}){super(),this.j=S,this.b=this.B(new R.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new R.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new T.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new P.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,T.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,P.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.J()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(S,p){if(p===e.TARGET_KEY){switch(S){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:S})}else this.b.fire({scope:S,key:p,target:this.F(S)[p]})}r(S){this.f.fire({reason:S})}get(S,p,E){return this.L(p)?.get(S,E)}getBoolean(S,p,E){return this.L(p)?.getBoolean(S,E)}getNumber(S,p,E){return this.L(p)?.getNumber(S,E)}store(S,p,E,t){if((0,k.isUndefinedOrNull)(p)){this.remove(S,E);return}this.t(()=>{this.u(S,E,t),this.L(E)?.set(S,p)})}remove(S,p){this.t(()=>{this.u(S,p,void 0),this.L(p)?.delete(S)})}t(S){this.b.pause(),this.c.pause();try{S()}finally{this.b.resume(),this.c.resume()}}keys(S,p){const E=[],t=this.F(S);for(const s of Object.keys(t))t[s]===p&&E.push(s);return E}u(S,p,E){const t=this.F(p);typeof E=="number"?t[S]!==E&&(t[S]=E,this.L(p)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[S]=="number"&&(delete t[S],this.L(p)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(S){switch(S){case-1:return this.D;case 0:return this.z;default:return this.w}}G(S){const p=this.L(S);return p?I(p):Object.create(null)}isNew(S){return this.getBoolean(e.IS_NEW_KEY,S)===!0}async flush(S=b.NONE){this.f.fire({reason:S});const p=this.L(-1),E=this.L(0),t=this.L(1);switch(S){case b.NONE:await T.Promises.settled([p?.whenFlushed()??Promise.resolve(),E?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await T.Promises.settled([p?.flush(0)??Promise.resolve(),E?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const S=this.L(-1)?.items??new Map,p=this.L(0)?.items??new Map,E=this.L(1)?.items??new Map;return f(S,p,E,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(S,p){return this.r(b.NONE),(0,l.isUserDataProfile)(S)?this.N(S,p):this.O(S,p)}H(S,p){return!(S.id===p.id||A(p)&&A(S))}I(S,p,E,t){this.t(()=>{if(t)for(const[s,i]of S)p.set(s,i);else{const s=new Set;for(const[i,n]of S)s.add(i),p.get(i)!==n&&this.n(E,i);for(const[i]of p.items)s.has(i)||this.n(E,i)}})}}e.AbstractStorageService=v,v.a=60*1e3;function A(y){return y.isDefault||!!y.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=A;class c extends v{constructor(){super(),this.p=this.B(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(S=>this.n(1,S))),this.B(this.P.onDidChangeStorage(S=>this.n(0,S))),this.B(this.p.onDidChangeStorage(S=>this.n(-1,S)))}L(S){switch(S){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(S){switch(S){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(S){return!1}}e.InMemoryStorageService=c;async function f(y,S,p,E,t,s){const i=Y=>{try{return JSON.parse(Y)}catch{return Y}},n=new Map,r=new Map;y.forEach((Y,Z)=>{n.set(Z,Y),r.set(Z,i(Y))});const o=new Map,a=new Map;S.forEach((Y,Z)=>{o.set(Z,Y),a.set(Z,i(Y))});const h=new Map,u=new Map;p.forEach((Y,Z)=>{h.set(Z,Y),u.set(Z,i(Y))}),console.group(E!==t?`Storage: Application (path: ${E})`:`Storage: Application & Profile (path: ${E}, default profile)`);const D=[];if(n.forEach((Y,Z)=>{D.push({key:Z,value:Y})}),console.table(D),console.groupEnd(),console.log(r),E!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const Y=[];o.forEach((Z,te)=>{Y.push({key:te,value:Z})}),console.table(Y),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${s})`);const F=[];h.forEach((Y,Z)=>{F.push({key:Z,value:Y})}),console.table(F),console.groupEnd(),console.log(u)}e.logStorage=f}),define(Q[151],_([0,1,19,22,7,12,35,3,11,23,17,24,26,45,13,6,28,47,136,150,25]),function(x,e,T,R,P,O,k,w,g,l,b,m,d,I,v,A,c,f,y,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const E=O.isWeb?"web":(0,m.getTargetPlatform)(O.platform,k.arch),t="X-Market-Search-Activity-Id";var s;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function i(...N){return String(N.reduce((L,U)=>L|U,0))}var n;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},h={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class u{constructor(L=h){this.d=L}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(L,U=this.d.pageSize){return new u({...this.d,pageNumber:L,pageSize:U})}withFilter(L,...U){const V=[...this.d.criteria,...U.length?U.map(H=>({filterType:L,value:H})):[{filterType:L}]];return new u({...this.d,criteria:V})}withSortBy(L){return new u({...this.d,sortBy:L})}withSortOrder(L){return new u({...this.d,sortOrder:L})}withFlags(...L){return new u({...this.d,flags:L.reduce((U,V)=>U|V,0)})}withAssetTypes(...L){return new u({...this.d,assetTypes:L})}withSource(L){return new u({...this.d,source:L})}get raw(){const{criteria:L,pageNumber:U,pageSize:V,sortBy:H,sortOrder:K,flags:re,assetTypes:ce}=this.d;return{filters:[{criteria:L,pageNumber:U,pageSize:V,sortBy:H,sortOrder:K}],assetTypes:ce,flags:re}}get searchText(){const L=this.d.criteria.filter(U=>U.filterType===n.SearchText)[0];return L&&L.value?L.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(L=>String(L.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function D(N,L){const U=(N||[]).filter(V=>V.statisticName===L)[0];return U?U.value:0}function F(N){const L="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(V=>V.assetType.indexOf(L)===0).reduce((V,H)=>{const K=te(N,H.assetType);return K&&V.push([H.assetType.substring(L.length),K]),V},[])}function Y(N){if(N.properties){const L=N.properties.filter(H=>H.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=L.filter(H=>U.test(H.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return te(N,r.Repository)}function Z(N){return{uri:`${N.fallbackAssetUri}/${r.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${r.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function te(N,L){return N.files.filter(V=>V.assetType===L)[0]?{uri:`${N.assetUri}/${L}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${L}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function ie(N,L){const U=N.properties?N.properties.filter(H=>H.key===L):[],V=U.length>0&&U[0].value;return V?V.split(",").map(H=>(0,d.adoptToGalleryExtensionId)(H)):[]}function ne(N){const L=N.properties?N.properties.filter(U=>U.key===o.Engine):[];return L.length>0&&L[0].value||""}function ae(N){const L=N.properties?N.properties.filter(U=>U.key===o.PreRelease):[];return L.length>0&&L[0].value==="true"}function ue(N){const L=N.properties?N.properties.filter(V=>V.key===o.LocalizedLanguages):[],U=L.length>0&&L[0].value||"";return U?U.split(","):[]}function se(N){return N.properties?.find(L=>L.key===o.SponsorLink)?.value}function ve(N){return N.indexOf("preview")!==-1}function B(N){return N.targetPlatform?(0,m.toTargetPlatform)(N.targetPlatform):"undefined"}function j(N){const L=(0,T.distinct)(N.versions.map(B)),U=!!N.tags?.includes(m.WEB_EXTENSION_TAG),V=L.indexOf("web");return U?V===-1&&L.push("web"):V!==-1&&L.splice(V,1),L}function M(N,L){const U=(0,m.getFallbackTargetPlarforms)(L);for(let V=0;V<N.length;V++){const H=N[V];if(H.version===N[V-1]?.version){let K=V;const re=B(H);if(re===L)for(;K>0&&N[K-1].version===H.version;)K--;else if(U.includes(re))for(;K>0&&N[K-1].version===H.version&&B(N[K-1])!==L;)K--;K!==V&&(N.splice(V,1),N.splice(K,0,H))}}return N}e.sortExtensionVersions=M;function $(N,L,U){N.telemetryData={index:L,querySource:U,queryActivityId:N.queryContext?.[t]}}function W(N,L,U,V){const H=N.versions[0],K={manifest:te(L,r.Manifest),readme:te(L,r.Details),changelog:te(L,r.Changelog),license:te(L,r.License),repository:Y(L),download:Z(L),icon:te(L,r.Icon),signature:te(L,r.Signature),coreTranslations:F(L)};return{identifier:{id:(0,d.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:L.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,publisherSponsorLink:se(H),description:N.shortDescription||"",installCount:D(N.statistics,"install"),rating:D(N.statistics,"averagerating"),ratingCount:D(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:U,assets:K,properties:{dependencies:ie(L,o.Dependency),extensionPack:ie(L,o.ExtensionPack),engine:ne(L),localizedLanguages:ue(L),targetPlatform:B(L),isPreReleaseVersion:ae(L)},hasPreReleaseVersion:ae(H),hasReleaseVersion:!0,preview:ve(N.flags),isSigned:!!K.signature,queryContext:V}}let q=class{constructor(L,U,V,H,K,re,ce,we){this.k=U,this.l=V,this.n=H,this.o=K,this.q=re,this.u=ce,this.w=we;const me=ce.extensionsGallery,le=me?.servicePPEUrl&&we.getValue("_extensionsGallery.enablePPE");this.d=le?me.servicePPEUrl:me?.serviceUrl,this.g=le?void 0:me?.searchUrl,this.h=me?.controlUrl,this.j=(0,y.resolveMarketplaceHeaders)(ce.version,ce,this.n,this.w,this.q,L,this.o)}x(L=""){return`${this.d}${L}`}isEnabled(){return!!this.d}async getExtensions(L,U,V){const H=R.CancellationToken.isCancellationToken(U)?{}:U,K=R.CancellationToken.isCancellationToken(U)?U:V,re=[],ce=[],we=[],me=[];let le=!0;for(const oe of L){oe.uuid?ce.push(oe.uuid):re.push(oe.id);const ye=!!(oe.version||oe.preRelease);we.push({id:oe.id,uuid:oe.uuid,includePreRelease:ye}),oe.version&&me.push({id:oe.id,uuid:oe.uuid,version:oe.version}),le=le&&!!oe.hasPreRelease&&!ye}if(!ce.length&&!re.length)return[];let de=new u().withPage(1,L.length);ce.length&&(de=de.withFilter(n.ExtensionId,...ce)),re.length&&(de=de.withFilter(n.ExtensionName,...re)),(H.queryAllVersions||le)&&(de=de.withFlags(de.flags,s.IncludeVersions)),H.source&&(de=de.withSource(H.source));const{extensions:ge}=await this.z(de,{targetPlatform:H.targetPlatform??E,includePreRelease:we,versions:me,compatible:!!H.compatible},K);return H.source&&ge.forEach((oe,ye)=>$(oe,ye,H.source)),ge}async getCompatibleExtension(L,U,V){if((0,m.isNotWebExtensionInWebTargetPlatform)(L.allTargetPlatforms,V))return null;if(await this.isExtensionCompatible(L,U,V))return L;const H=new u().withFlags(s.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,L.identifier.uuid),{extensions:K}=await this.z(H,{targetPlatform:V,compatible:!0,includePreRelease:U},R.CancellationToken.None);return K[0]||null}async isExtensionCompatible(L,U,V){if(!(0,m.isTargetPlatformCompatible)(L.properties.targetPlatform,L.allTargetPlatforms,V)||!U&&L.properties.isPreReleaseVersion)return!1;let H=L.properties.engine;if(!H){const K=await this.getManifest(L,R.CancellationToken.None);if(!K)throw new Error("Manifest was not found");H=K.engines.vscode}return(0,I.isEngineValid)(H,this.u.version,this.u.date)}async y(L,U,V,H,K){if(!(0,m.isTargetPlatformCompatible)(B(L),H,K)||U!=="any"&&ae(L)!==(U==="prerelease"))return!1;if(V)try{const re=await this.E(L);if(!(0,I.isEngineValid)(re,this.u.version,this.u.date))return!1}catch(re){return this.l.error(`Error while getting the engine for the version ${L.version}.`,(0,P.getErrorMessage)(re)),!1}return!0}async query(L,U){let V=L.text||"";const H=L.pageSize??50;let K=new u().withPage(1,H);V?(V=V.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,de,ge)=>(K=K.withFilter(n.Category,ge||de),"")),V=V.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,de,ge)=>(K=K.withFilter(n.Tag,ge||de),"")),V=V.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(n.Featured),"")),V=V.trim(),V&&(V=V.length<200?V:V.substring(0,200),K=K.withFilter(n.SearchText,V)),K=K.withSortBy(0)):L.ids?K=K.withFilter(n.ExtensionId,...L.ids):L.names?K=K.withFilter(n.ExtensionName,...L.names):K=K.withSortBy(4),typeof L.sortBy=="number"&&(K=K.withSortBy(L.sortBy)),typeof L.sortOrder=="number"&&(K=K.withSortOrder(L.sortOrder)),L.source&&(K=K.withSource(L.source));const re=async(le,de)=>{const{extensions:ge,total:oe}=await this.z(le,{targetPlatform:E,compatible:!1,includePreRelease:!!L.includePreRelease},de);return ge.forEach((ye,Se)=>$(ye,(le.pageNumber-1)*le.pageSize+Se,L.source)),{extensions:ge,total:oe}},{extensions:ce,total:we}=await re(K,U),me=async(le,de)=>{if(de.isCancellationRequested)throw new P.CancellationError;const{extensions:ge}=await re(K.withPage(le+1),de);return ge};return{firstPage:ce,total:we,pageSize:K.pageSize,getPage:me}}async z(L,U,V){const H=L.flags;!!(L.flags&s.IncludeLatestVersionOnly)&&!!(L.flags&s.IncludeVersions)&&(L=L.withFlags(L.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(L.flags&s.IncludeLatestVersionOnly)&&!(L.flags&s.IncludeVersions)&&(L=L.withFlags(L.flags,s.IncludeLatestVersionOnly)),U.versions?.length&&(L=L.withFlags(L.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),L=L.withFlags(L.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:K,total:re,context:ce}=await this.B(L,V);if(!(L.flags&s.IncludeLatestVersionOnly)){const de=[];for(const ge of K){const oe=await this.A(ge,U,ce);oe&&de.push(oe)}return{extensions:de,total:re}}const me=[],le=new Map;for(let de=0;de<K.length;de++){const ge=K[de],oe={id:(0,d.getGalleryExtensionId)(ge.publisher.publisherName,ge.extensionName),uuid:ge.extensionId},ye=(0,w.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Ne=>(0,d.areSameExtensions)(Ne,oe))?.includePreRelease;if(U.compatible&&(0,m.isNotWebExtensionInWebTargetPlatform)(j(ge),U.targetPlatform))continue;const Se=await this.A(ge,U,ce);!Se||Se.properties.isPreReleaseVersion&&(!ye||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==U.targetPlatform&&Se.hasPreReleaseVersion?le.set(ge.extensionId,de):me.push([de,Se])}if(le.size){const de=new Date().getTime(),ge=new u().withFlags(H&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,le.size).withFilter(n.ExtensionId,...le.keys()),{extensions:oe}=await this.z(ge,U,V);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-de,count:le.size});for(const ye of oe){const Se=le.get(ye.identifier.uuid);me.push([Se,ye])}}return{extensions:me.sort((de,ge)=>de[0]-ge[0]).map(([,de])=>de),total:re}}async A(L,U,V){const H={id:(0,d.getGalleryExtensionId)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},K=U.versions?.find(me=>(0,d.areSameExtensions)(me,H))?.version,re=(0,w.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(me=>(0,d.areSameExtensions)(me,H))?.includePreRelease,ce=j(L),we=M(L.versions,U.targetPlatform);if(U.compatible&&(0,m.isNotWebExtensionInWebTargetPlatform)(ce,U.targetPlatform))return null;for(let me=0;me<we.length;me++){const le=we[me];if(!(K&&le.version!==K)){if(await this.y(le,re?"any":"release",U.compatible,ce,U.targetPlatform))return W(L,le,ce,V);if(K&&le.version===K)return null}}return K||U.compatible?null:W(L,L.versions[0],ce)}async B(L,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");L=L.withFlags(L.flags,s.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(s.Unpublished));const V=await this.j,H=JSON.stringify(L.raw),K={...V,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},re=new Date().getTime();let ce,we,me=0;try{if(ce=await this.k.request({type:"POST",url:this.g&&L.criteria.some(de=>de.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:H,headers:K},U),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:me};const le=await(0,f.asJson)(ce);if(le){const de=le.results[0],ge=de.extensions,oe=de.resultMetadata&&de.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return me=oe&&oe.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:me,context:{[t]:ce.res.headers.activityid}}}return{galleryExtensions:[],total:me}}catch(le){throw we=le,le}finally{this.o.publicLog2("galleryService:query",{...L.telemetryData,requestBodySize:String(H.length),duration:new Date().getTime()-re,success:!!ce&&(0,f.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:we?(0,P.isCancellationError)(we)?"canceled":(0,P.getErrorMessage)(we).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(me)})}}async reportStatistic(L,U,V,H){if(!this.isEnabled())return;const K=O.isWeb?this.x(`/itemName/${L}.${U}/version/${V}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${L}/extensions/${U}/${V}/stats?statType=${H}`),re=O.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",we={...await this.j,Accept:re};try{await this.k.request({type:"POST",url:K,headers:we},R.CancellationToken.None)}catch{}}async download(L,U,V){this.l.trace("ExtensionGalleryService#download",L.identifier.id);const H=(0,d.getGalleryExtensionTelemetryData)(L),K=new Date().getTime(),re=de=>this.o.publicLog("galleryService:downloadVSIX",{...H,duration:de}),ce=V===2?"install":V===3?"update":"",we=ce?{uri:`${L.assets.download.uri}${g.URI.parse(L.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${L.assets.download.fallbackUri}${g.URI.parse(L.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:L.assets.download,me=L.queryContext?.[t]?{[t]:L.queryContext[t]}:void 0,le=await this.D(we,me?{headers:me}:void 0);await this.q.writeFile(U,le.stream),re(new Date().getTime()-K)}async downloadSignatureArchive(L,U){if(!L.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",L.identifier.id);const V=await this.D(L.assets.signature);await this.q.writeFile(U,V.stream)}async getReadme(L,U){if(L.assets.readme){const V=await this.D(L.assets.readme,{},U);return await(0,f.asTextOrError)(V)||""}return""}async getManifest(L,U){if(L.assets.manifest){const V=await this.D(L.assets.manifest,{},U),H=await(0,f.asTextOrError)(V);return H?JSON.parse(H):null}return null}async C(L,U){const V=te(L,r.Manifest);if(!V)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},K=await this.D(V,{headers:H});return await(0,f.asJson)(K)}async getCoreTranslation(L,U){const V=L.assets.coreTranslations.filter(H=>H[0]===U.toUpperCase())[0];if(V){const H=await this.D(V[1]),K=await(0,f.asTextOrError)(H);return K?JSON.parse(K):null}return null}async getChangelog(L,U){if(L.assets.changelog){const V=await this.D(L.assets.changelog,{},U);return await(0,f.asTextOrError)(V)||""}return""}async getAllCompatibleVersions(L,U,V){let H=new u().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);L.identifier.uuid?H=H.withFilter(n.ExtensionId,L.identifier.uuid):H=H.withFilter(n.ExtensionName,L.identifier.id);const{galleryExtensions:K}=await this.B(H,R.CancellationToken.None);if(!K.length)return[];const re=j(K[0]);if((0,m.isNotWebExtensionInWebTargetPlatform)(re,V))return[];const ce=[];await Promise.all(K[0].versions.map(async le=>{try{await this.y(le,U?"any":"release",!0,re,V)&&ce.push(le)}catch{}}));const we=[],me=new Set;for(const le of M(ce,V))me.has(le.version)||(me.add(le.version),we.push({version:le.version,date:le.lastUpdated,isPreReleaseVersion:ae(le)}));return we}async D(L,U={},V=R.CancellationToken.None){const H=await this.j,K={type:"GET"},re={...H,...U.headers||{}};U={...U,...K,headers:re};const ce=L.uri,we=L.fallbackUri,me={...U,url:ce};try{const le=await this.k.request(me,V);if(le.res.statusCode===200)return le;const de=await(0,f.asTextOrError)(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${de}`)}catch(le){if((0,P.isCancellationError)(le))throw le;const de=(0,P.getErrorMessage)(le);this.o.publicLog2("galleryService:cdnFallback",{url:ce,message:de});const ge={...U,url:we};return this.k.request(ge,V)}}async E(L){let U=ne(L);if(!U){const V=await this.C(L,R.CancellationToken.None);if(!V)throw new Error("Manifest was not found");U=V.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const L=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(L.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,f.asJson)(L),V=[],H={};if(U){for(const K of U.malicious)V.push({id:K});if(U.migrateToPreRelease)for(const[K,re]of Object.entries(U.migrateToPreRelease))(!re.engine||(0,I.isEngineValid)(re.engine,this.u.version,this.u.date))&&(H[K.toLowerCase()]={disallowInstall:!0,extension:{id:re.id,displayName:re.displayName,autoMigrate:{storage:!!re.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[K,re]of Object.entries(U.deprecated))re&&(H[K.toLowerCase()]=(0,w.isBoolean)(re)?{}:re)}return{malicious:V,deprecated:H}}};q=fe([ee(1,f.IRequestService),ee(2,A.ILogService),ee(3,b.IEnvironmentService),ee(4,p.ITelemetryService),ee(5,v.IFileService),ee(6,c.IProductService),ee(7,l.IConfigurationService)],q);let X=class extends q{constructor(L,U,V,H,K,re,ce,we){super(L,U,V,H,K,re,ce,we)}};X=fe([ee(0,S.IStorageService),ee(1,f.IRequestService),ee(2,A.ILogService),ee(3,b.IEnvironmentService),ee(4,p.ITelemetryService),ee(5,v.IFileService),ee(6,c.IProductService),ee(7,l.IConfigurationService)],X),e.ExtensionGalleryService=X;let C=class extends q{constructor(L,U,V,H,K,re,ce){super(void 0,L,U,V,H,K,re,ce)}};C=fe([ee(0,f.IRequestService),ee(1,A.ILogService),ee(2,b.IEnvironmentService),ee(3,p.ITelemetryService),ee(4,v.IFileService),ee(5,c.IProductService),ee(6,l.IConfigurationService)],C),e.ExtensionGalleryServiceWithNoStorageService=C}),define(Q[152],_([0,1,44,11,17,13,6,67,27,21]),function(x,e,T,R,P,O,k,w,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let b=class extends l.UserDataProfilesService{constructor(I,v,A,c){super(v,A,I,c),this.a=v}L(){return this.r.extUri.joinPath(R.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};b=fe([ee(0,g.IUriIdentityService),ee(1,P.INativeEnvironmentService),ee(2,O.IFileService),ee(3,k.ILogService)],b),e.ServerUserDataProfilesService=b;let m=class $e extends b{constructor(I,v,A,c,f){super(v,A,c,f),this.N=I}G(){return(0,T.revive)(this.N.getItem($e.b,[]))}I(){return(0,T.revive)(this.N.getItem($e.c,{}))}L(){return this.r.extUri.joinPath(R.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};m=fe([ee(0,w.IStateService),ee(1,g.IUriIdentityService),ee(2,P.INativeEnvironmentService),ee(3,O.IFileService),ee(4,k.ILogService)],m),e.UserDataProfilesService=m}),define(Q[153],_([0,1,38,5,166,2,6]),function(x,e,T,R,P,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let w=class extends T.AbstractPolicyService{constructor(l,b){super(),this.j=l,this.k=b,this.a=new R.Throttler,this.b=this.B(new O.MutableDisposable)}async i(l){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.a.queue(()=>new Promise((b,m)=>{try{this.b.value=(0,P.createWatcher)(this.k,l,d=>{this.m(d),b()})}catch(d){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),m(d)}}))}m(l){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const b in l){const m=l[b];m===void 0?this.g.delete(b):this.g.set(b,m)}this.h.fire(Object.keys(l))}};w=fe([ee(0,k.ILogService)],w),e.NativePolicyService=w}),define(Q[69],_([0,1,120,5,14,3,20,85,167,168]),function(x,e,T,R,P,O,k,w,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class b extends Error{constructor(t,s){let i=s.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=s}}e.ExtractError=b;function m(E){const t=E.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,i)=>s+i,t&61440)}function d(E){if(E instanceof b)return E;let t;return/end of central directory record signature not found/.test(E.message)&&(t="CorruptZip"),new b(t,E)}function I(E,t,s,i,n,r){const o=P.dirname(t),a=P.join(i,o);if(!a.startsWith(i))return Promise.reject(new Error(w.localize(0,null,t)));const h=P.join(i,t);let u;return r.onCancellationRequested(()=>{u?.destroy()}),Promise.resolve(k.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((D,F)=>{if(!r.isCancellationRequested)try{u=(0,T.createWriteStream)(h,{mode:s}),u.once("close",()=>D()),u.once("error",F),E.once("error",F),E.pipe(u)}catch(Y){F(Y)}}))}function v(E,t,s,i){let n=(0,R.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{n.cancel(),E.close()}),new Promise((o,a)=>{const h=new R.Sequencer,u=D=>{D.isCancellationRequested||(r++,E.readEntry())};E.once("error",a),E.once("close",()=>n.then(()=>{i.isCancellationRequested||E.entryCount===r?o():a(new b("Incomplete",new Error(w.localize(1,null,r,E.entryCount))))},a)),E.readEntry(),E.on("entry",D=>{if(i.isCancellationRequested)return;if(!s.sourcePathRegex.test(D.fileName)){u(i);return}const F=D.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(F)){const te=P.join(t,F);n=(0,R.createCancelablePromise)(ie=>k.Promises.mkdir(te,{recursive:!0}).then(()=>u(ie)).then(void 0,a));return}const Y=c(E,D),Z=m(D);n=(0,R.createCancelablePromise)(te=>h.queue(()=>Y.then(ie=>I(ie,F,Z,t,s,te).then(()=>u(te)))).then(null,a))})})}function A(E,t=!1){return new Promise((s,i)=>{(0,g.open)(E,t?{lazyEntries:!0}:void 0,(n,r)=>{n?i(d(n)):s((0,O.assertIsDefined)(r))})})}function c(E,t){return new Promise((s,i)=>{E.openReadStream(t,(n,r)=>{n?i(d(n)):s((0,O.assertIsDefined)(r))})})}function f(E,t){return new Promise((s,i)=>{const n=new l.ZipFile;t.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const r=(0,T.createWriteStream)(E);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>s(E))})}e.zip=f;function y(E,t,s={},i){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=A(E,!0);return s.overwrite&&(r=r.then(o=>k.Promises.rm(t).then(()=>o))),r.then(o=>v(o,t,{sourcePathRegex:n},i))}e.extract=y;function S(E,t){return A(E).then(s=>new Promise((i,n)=>{s.on("entry",r=>{r.fileName===t&&c(s,r).then(o=>i(o),o=>n(o))}),s.once("close",()=>n(new Error(w.localize(2,null,t))))}))}function p(E,t){return S(E,t).then(s=>new Promise((i,n)=>{const r=[];s.once("error",n),s.on("data",o=>r.push(o)),s.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=p}),define(Q[154],_([0,1,69,93]),function(x,e,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function P(O){return(0,T.buffer)(O,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.getManifest=P}),define(Q[155],_([0,1,5,22,34,7,4,2,36,16,14,12,18,41,3,11,31,20,69,92,58,17,146,24,26,40,48,134,147,154,127,135,29,45,13,10,6,28,25,27,21]),function(x,e,T,R,P,O,k,w,g,l,b,m,d,I,v,A,c,f,y,S,p,E,t,s,i,n,r,o,a,h,u,D,F,Y,Z,te,ie,ne,ae,ue,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,te.refineServiceDecorator)(s.IExtensionManagementService);let ve=class extends t.AbstractExtensionManagementService{constructor(C,N,L,U,V,H,K,re,ce,we,me,le){super(C,N,L,we,le),this.Z=V,this.ab=H,this.bb=K,this.cb=ce,this.db=me,this.X=this.B(new k.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new g.ResourceSet;const de=this.B(re.createInstance(a.ExtensionsLifecycle));this.S=this.B(re.createInstance(B,oe=>de.postUninstall(oe))),this.U=this.B(new u.ExtensionsManifestCache(U,this)),this.W=this.B(re.createInstance(o.ExtensionsDownloader));const ge=this.B(new D.ExtensionsWatcher(this,this.Z,le,H,me,ce,L));this.B(ge.onDidChangeExtensionsByAnotherSource(oe=>this.kb(oe))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(C){this.v.trace("ExtensionManagementService#zip",C.identifier.id);const N=await this.jb(C),L=await(0,y.zip)((0,d.joinPath)(this.W.extensionsDownloadDir,(0,c.generateUuid)()).fsPath,N);return A.URI.file(L)}async unzip(C){return this.v.trace("ExtensionManagementService#unzip",C.toString()),(await this.install(C)).identifier}async getManifest(C){const{location:N,cleanup:L}=await this.fb(C),U=b.resolve(N.fsPath);try{return await(0,h.getManifest)(U)}finally{await L()}}getInstalled(C,N){return this.S.scanExtensions(C??null,N)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(C,N={}){this.v.trace("ExtensionManagementService#install",C.toString());const{location:L,cleanup:U}=await this.fb(C);try{const V=await(0,h.getManifest)(b.resolve(L.fsPath));if(V.engines&&V.engines.vscode&&!(0,Y.isEngineValid)(V.engines.vscode,this.w.version,this.w.date))throw new Error(S.localize(0,null,(0,i.getGalleryExtensionId)(V.publisher,V.name),this.w.version));return await this.z(V,L,N)}finally{await U()}}async installFromLocation(C,N){this.v.trace("ExtensionManagementService#installFromLocation",C.toString());const L=await this.S.scanUserExtensionAtLocation(C);if(!L)throw new Error(`Cannot find a valid extension from the location ${C.toString()}`);return await this.ob([L],N),this.v.info("Successfully installed extension",L.identifier.id,N.toString()),L}getMetadata(C,N=this.y.defaultProfile.extensionsResource){return this.S.scanMetadata(C,N)}async updateMetadata(C,N,L=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",C.identifier.id),N.isPreReleaseVersion&&(N.preRelease=!0),N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.pinned=N.pinned||void 0,C=await this.S.updateMetadata(C,N,L),this.U.invalidate(),this.X.fire(C),C}async reinstallFromGallery(C){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",C.identifier.id),!this.t.isEnabled())throw new Error(S.localize(1,null));const N=await this.getTargetPlatform(),[L]=await this.t.getExtensions([{...C.identifier,preRelease:C.preRelease}],{targetPlatform:N,compatible:!0},R.CancellationToken.None);if(!L)throw new Error(S.localize(2,null));await this.S.setUninstalled(C);try{await this.S.removeUninstalledExtension(C)}catch(U){throw new Error(S.localize(3,null,(0,P.toErrorMessage)(U)))}return this.installFromGallery(L)}markAsUninstalled(...C){return this.S.setUninstalled(...C)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(C,N){const{location:L}=await this.W.download(C,N);return L}async fb(C){if(C.scheme===l.Schemas.file)return{location:C,async cleanup(){}};this.v.trace("Downloading extension from",C.toString());const N=(0,d.joinPath)(this.W.extensionsDownloadDir,(0,c.generateUuid)());return await this.bb.download(C,N),this.v.info("Downloaded extension to",N.toString()),{location:N,cleanup:async()=>{try{await this.cb.del(N)}catch(U){this.v.error(U)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(C,N,L){let U;if(A.URI.isUri(N))U=new $(C,N,L,this.t,this.S,this.v);else{const V=i.ExtensionKey.create(N).toString();U=this.Y.get(V),U||(this.Y.set(V,U=new M(C,N,L,this.W,this.S,this.v)),U.waitUntilTaskIsFinished().then(()=>this.Y.delete(V)))}return new W(U,L.profileLocation,this.db,this.y,this.Z,this.ab)}R(C,N){return new q(C,N.profileLocation,this.ab)}async jb(C){const N=async U=>{let V=await f.Promises.readdir(U);V=V.map(re=>b.join(U,re));const H=await Promise.all(V.map(re=>f.Promises.stat(re)));let K=Promise.resolve([]);return H.forEach((re,ce)=>{const we=V[ce];re.isFile()&&(K=K.then(me=>[...me,we])),re.isDirectory()&&(K=K.then(me=>N(we).then(le=>[...me,...le])))}),K};return(await N(C.location.fsPath)).map(U=>({path:`extension/${b.relative(C.location.fsPath,U)}`,localPath:U}))}async kb({added:C,removed:N}){if(N)for(const L of N.extensions)this.v.info("Extensions removed from another source",L.id,N.profileLocation.toString()),this.p.fire({identifier:L,profileLocation:N.profileLocation});if(C){const U=(await this.S.scanExtensions(1,C.profileLocation)).filter(V=>C.extensions.some(H=>(0,i.areSameExtensions)(H,V.identifier)));this.m.fire(U.map(V=>(this.v.info("Extensions added from another source",V.identifier.id,C.profileLocation.toString()),{identifier:V.identifier,local:V,profileLocation:C.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(N=>this.lb.add(N)));const C=await this.cb.resolve(this.Z.userExtensionsLocation);for(const N of C.children??[])N.isDirectory&&this.lb.add(N.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(N=>this.nb(N)))}async nb(C){if(!C.affects(this.Z.userExtensionsLocation,1))return;const N=[];for(const L of C.rawAdded){if(this.lb.has(L)||!this.db.extUri.isEqual(this.db.extUri.dirname(L),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(L,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(L).startsWith(".")||!(await this.cb.stat(L)).isDirectory)continue;const U=await this.S.scanUserExtensionAtLocation(L);U&&U.installedTimestamp===void 0&&(this.lb.add(L),N.push(U))}N.length&&(await this.ob(N,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",N.map(L=>L.identifier.id)))}async ob(C,N){await this.ab.addExtensionsToProfile(C.map(L=>[L,void 0]),N),this.m.fire(C.map(L=>({local:L,identifier:L.identifier,operation:1,profileLocation:N})))}};ve=fe([ee(0,s.IExtensionGalleryService),ee(1,ae.ITelemetryService),ee(2,ie.ILogService),ee(3,E.INativeEnvironmentService),ee(4,r.IExtensionsScannerService),ee(5,n.IExtensionsProfileScannerService),ee(6,p.IDownloadService),ee(7,te.IInstantiationService),ee(8,Z.IFileService),ee(9,ne.IProductService),ee(10,ue.IUriIdentityService),ee(11,se.IUserDataProfilesService)],ve),e.ExtensionManagementService=ve;let B=class extends w.Disposable{constructor(C,N,L,U,V){super(),this.j=C,this.k=N,this.l=L,this.m=U,this.n=V,this.h=this.B(new k.Emitter),this.onExtract=this.h.event,this.c=(0,d.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new T.Queue}async cleanUp(){await this.w()}async scanExtensions(C,N){const L={includeInvalid:!0,profileLocation:N};let U=[];return C===null||C===0?U.push(...await this.l.scanAllExtensions({includeInvalid:!0},L,!1)):C===1&&U.push(...await this.l.scanUserExtensions(L)),U=C!==null?U.filter(V=>V.type===C):U,Promise.all(U.map(V=>this.v(V)))}async scanAllUserExtensions(C){const N=await this.l.scanUserExtensions({includeAllVersions:!C,includeInvalid:!0});return Promise.all(N.map(L=>this.v(L)))}async scanUserExtensionAtLocation(C){try{const N=await this.l.scanExistingExtension(C,1,{includeInvalid:!0});if(N)return await this.v(N)}catch(N){this.n.error(N)}return null}async extractUserExtension(C,N,L,U){const V=C.toString(),H=b.join(this.l.userExtensionsLocation.fsPath,`.${(0,c.generateUuid)()}`),K=b.join(this.l.userExtensionsLocation.fsPath,V);try{await f.Promises.rm(K)}catch{throw new s.ExtensionManagementError(S.localize(4,null,K,C.id),s.ExtensionManagementErrorCode.Delete)}await this.s(C,N,H,U),await this.l.updateMetadata(A.URI.file(H),L);try{this.h.fire(A.URI.file(K)),await this.t(C,H,K,Date.now()+2*60*1e3),this.n.info("Renamed to",K)}catch(re){try{await f.Promises.rm(H)}catch{}if(re.code==="ENOTEMPTY")this.n.info("Rename failed because extension was installed by another source. So ignoring renaming.",C.id);else throw this.n.info(`Rename failed because of ${(0,O.getErrorMessage)(re)}. Deleted from extracted location`,H),re}return this.u(A.URI.file(K),1)}async scanMetadata(C,N){return N?(await this.m.scanProfileExtensions(N)).find(U=>(0,i.areSameExtensions)(U.identifier,C.identifier))?.metadata:this.l.scanMetadata(C.location)}async updateMetadata(C,N,L){return L?await this.m.updateMetadata([[C,N]],L):await this.l.updateMetadata(C.location,N),this.u(C.location,C.type)}getUninstalledExtensions(){return this.p()}async setUninstalled(...C){const N=C.map(L=>i.ExtensionKey.create(L));await this.p(L=>N.forEach(U=>{L[U.toString()]=!0,this.n.info("Marked extension as uninstalled",U.toString())}))}async setInstalled(C){await this.p(U=>delete U[C.toString()]);const L=(await this.scanAllUserExtensions(!0)).find(U=>i.ExtensionKey.create(U).equals(C))||null;return L?this.updateMetadata(L,{installedTimestamp:Date.now()}):null}async removeExtension(C,N){this.n.trace(`Deleting ${N} extension from disk`,C.identifier.id,C.location.fsPath),await f.Promises.rm(C.location.fsPath),this.n.info("Deleted from disk",C.identifier.id,C.location.fsPath)}async removeUninstalledExtension(C){await this.removeExtension(C,"uninstalled"),await this.p(N=>delete N[i.ExtensionKey.create(C).toString()])}async p(C){return this.g.queue(async()=>{let N;try{N=await f.Promises.readFile(this.c,"utf8")}catch(U){if(U.code!=="ENOENT")throw U}let L={};if(N)try{L=JSON.parse(N)}catch{}return C&&(C(L),Object.keys(L).length?await f.Promises.writeFile(this.c,JSON.stringify(L)):await f.Promises.rm(this.c)),L})}async s(C,N,L,U){this.n.trace(`Started extracting the extension from ${N} to ${L}`);try{await f.Promises.rm(L)}catch(V){throw new s.ExtensionManagementError(this.y(V).message,s.ExtensionManagementErrorCode.Delete)}try{await(0,y.extract)(N,L,{sourcePath:"extension",overwrite:!0},U),this.n.info(`Extracted extension to ${L}:`,C.id)}catch(V){try{await f.Promises.rm(L)}catch{}let H=s.ExtensionManagementErrorCode.Extract;throw V instanceof y.ExtractError&&(V.type==="CorruptZip"?H=s.ExtensionManagementErrorCode.CorruptZip:V.type==="Incomplete"&&(H=s.ExtensionManagementErrorCode.IncompleteZip)),new s.ExtensionManagementError(V.message,H)}}async t(C,N,L,U){try{await f.Promises.rename(N,L)}catch(V){if(m.isWindows&&V&&V.code==="EPERM"&&Date.now()<U)return this.n.info(`Failed renaming ${N} to ${L} with 'EPERM' error. Trying again...`,C.id),this.t(C,N,L,U);throw new s.ExtensionManagementError(V.message||S.localize(5,null,N,L),V.code||s.ExtensionManagementErrorCode.Rename)}}async u(C,N){const L=await this.l.scanExistingExtension(C,N,{includeInvalid:!0});if(L)return this.v(L);throw new Error(S.localize(6,null,C.path))}async v(C){const N=await this.k.resolve(C.location);let L,U;return N.children&&(L=N.children.find(({name:V})=>/^readme(\.txt|\.md|)$/i.test(V))?.resource,U=N.children.find(({name:V})=>/^changelog(\.txt|\.md|)$/i.test(V))?.resource),{identifier:C.identifier,type:C.type,isBuiltin:C.isBuiltin||!!C.metadata?.isBuiltin,location:C.location,manifest:C.manifest,targetPlatform:C.targetPlatform,validations:C.validations,isValid:C.isValid,readmeUrl:L,changelogUrl:U,publisherDisplayName:C.metadata?.publisherDisplayName||null,publisherId:C.metadata?.publisherId||null,isApplicationScoped:!!C.metadata?.isApplicationScoped,isMachineScoped:!!C.metadata?.isMachineScoped,isPreReleaseVersion:!!C.metadata?.isPreReleaseVersion,preRelease:!!C.metadata?.preRelease,installedTimestamp:C.metadata?.installedTimestamp,updated:!!C.metadata?.updated,pinned:!!C.metadata?.pinned}}async w(){const C=await this.getUninstalledExtensions(),N=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),L=new Set;for(const H of N)C[i.ExtensionKey.create(H).toString()]||L.add(H.identifier.id.toLowerCase());const U=(0,i.groupByExtension)(N,H=>H.identifier);await T.Promises.settled(U.map(async H=>{const K=H.sort((re,ce)=>I.rcompare(re.manifest.version,ce.manifest.version))[0];L.has(K.identifier.id.toLowerCase())||await this.j(await this.v(K))}));const V=N.filter(H=>H.metadata&&C[i.ExtensionKey.create(H).toString()]);await T.Promises.settled(V.map(H=>this.removeUninstalledExtension(H)))}y(C){const N=Array.isArray(C)?C:[C];return N.length===1?N[0]instanceof Error?N[0]:new Error(N[0]):N.reduce((L,U)=>new Error(`${L.message}${L.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}};B=fe([ee(1,Z.IFileService),ee(2,r.IExtensionsScannerService),ee(3,n.IExtensionsProfileScannerService),ee(4,ie.ILogService)],B),e.ExtensionsScanner=B;class j extends t.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,v.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(C,N,L,U,V){super(),this.identifier=C,this.source=N,this.l=L,this.m=U,this.n=V,this.j="Unverified",this.k=2}async o(C,N){try{const L=await this.p(C.key);if(L)return this.m.updateMetadata(L,C.metadata)}catch{throw m.isMacintosh?new s.ExtensionManagementError(S.localize(7,null),s.ExtensionManagementErrorCode.Internal):new s.ExtensionManagementError(S.localize(8,null),s.ExtensionManagementErrorCode.Internal)}return this.s(C,N)}async p(C){if(!await this.q(C))return null;this.n.trace("Removing the extension from uninstalled list:",C.id);const L=await this.m.setInstalled(C);return this.n.info("Removed the extension from uninstalled list:",C.id),L}async q(C){return!!(await this.m.getUninstalledExtensions())[C.toString()]}async s({zipPath:C,key:N,metadata:L},U){const V=await this.m.extractUserExtension(N,C,L,U);return this.n.info("Extracting completed.",N.id),V}}class M extends j{constructor(C,N,L,U,V,H){super(N.identifier,N,L,V,H),this.t=C,this.u=N,this.v=U}async h(C){const L=(await this.m.scanExtensions(null,this.l.profileLocation)).find(K=>(0,i.areSameExtensions)(K.identifier,this.u.identifier));L&&(this.k=3);const U={id:this.u.identifier.uuid,publisherId:this.u.publisherId,publisherDisplayName:this.u.publisherDisplayName,targetPlatform:this.u.properties.targetPlatform,isApplicationScoped:(0,F.isApplicationScopedExtension)(this.t),isMachineScoped:this.l.isMachineScoped||L?.isMachineScoped,isBuiltin:this.l.isBuiltin||L?.isBuiltin,isSystem:L?.type===0?!0:void 0,updated:!!L,isPreReleaseVersion:this.u.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.u.properties.isPreReleaseVersion||((0,v.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:L?.preRelease)};if(L?.manifest.version===this.u.version)return{local:await this.m.updateMetadata(L,U),metadata:U};const{location:V,verificationStatus:H}=await this.v.download(this.u,this.k);try{return this.j=H,this.x(V.fsPath),{local:await this.o({zipPath:V.fsPath,key:i.ExtensionKey.create(this.u),metadata:U},C),metadata:U}}catch(K){try{await this.v.delete(V)}catch(re){this.n.warn("Error while deleting the downloaded file",V.toString(),(0,O.getErrorMessage)(re))}throw K}}async x(C){try{await(0,h.getManifest)(C)}catch(N){throw new s.ExtensionManagementError((0,t.joinErrors)(N).message,s.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=M;class $ extends j{constructor(C,N,L,U,V,H){super({id:(0,i.getGalleryExtensionId)(C.publisher,C.name)},N,L,V,H),this.t=C,this.u=N,this.v=U}async h(C){const N=new i.ExtensionKey(this.identifier,this.t.version),U=(await this.m.scanExtensions(1,this.l.profileLocation)).find(K=>(0,i.areSameExtensions)(this.identifier,K.identifier)),V=await this.x(this.identifier.id,this.t.version,C);if(V.isApplicationScoped=(0,F.isApplicationScopedExtension)(this.t),V.isMachineScoped=this.l.isMachineScoped||U?.isMachineScoped,V.isBuiltin=this.l.isBuiltin||U?.isBuiltin,V.installedTimestamp=Date.now(),V.pinned=this.l.installGivenVersion?!0:void 0,U)if(this.k=3,N.equals(new i.ExtensionKey(U.identifier,U.manifest.version)))try{await this.m.removeExtension(U,"existing")}catch{throw new Error(S.localize(9,null,this.t.displayName||this.t.name))}else!this.l.profileLocation&&I.gt(U.manifest.version,this.t.version)&&await this.m.setUninstalled(U);else{const K=await this.p(N);if(K)try{await this.m.removeExtension(K,"existing")}catch{throw new Error(S.localize(10,null,this.t.displayName||this.t.name))}}return{local:await this.o({zipPath:b.resolve(this.u.fsPath),key:N,metadata:V},C),metadata:V}}async x(C,N,L){try{let[U]=await this.v.getExtensions([{id:C,version:N}],L);if(U||([U]=await this.v.getExtensions([{id:C}],L)),U)return{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId,isPreReleaseVersion:U.properties.isPreReleaseVersion,preRelease:U.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class W{get operation(){return this.d.operation}get verificationStatus(){return this.d.verificationStatus}constructor(C,N,L,U,V,H){this.d=C,this.g=N,this.h=L,this.j=U,this.k=V,this.l=H,this.identifier=this.d.identifier,this.source=this.d.source,this.c=this.m()}async m(){const C=await this.d.waitUntilTaskIsFinished();return this.h.extUri.isEqual(this.j.defaultProfile.extensionsResource,this.g)&&await this.k.initializeDefaultProfileExtensions(),await this.l.addExtensionsToProfile([[C.local,C.metadata]],this.g),C}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class q extends t.AbstractExtensionTask{constructor(C,N,L){super(),this.extension=C,this.j=N,this.k=L}async h(C){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Q[156],_([0,1,130,5,15,7,2,3,23,17,131,6,129,169]),function(x,e,T,R,P,O,k,w,g,l,b,m,d,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let v=class extends k.Disposable{constructor(c,f,y){super(),this.h=c,this.i=f,this.j=y,this.k(),this.B(c.onDidChangeConfiguration(S=>{S.affectsConfiguration("http")&&this.k()}))}k(){const c=this.h.getValue("http");this.a=c?.proxy,this.b=!!c?.proxyStrictSSL,this.f=c?.proxyAuthorization}async request(c,f){this.j.trace("RequestService#request (node) - begin",c.url);const{a:y,b:S}=this;let p;try{p=await(0,b.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(s){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",s))}const E={...process.env,...p},t=c.agent?c.agent:await(0,d.getProxyAgent)(c.url||"",E,{proxyUrl:y,strictSSL:S});c.agent=t,c.strictSSL=S,this.f&&(c.headers={...c.headers||{},"Proxy-Authorization":this.f});try{const s=await this.m(c,f);return this.j.trace("RequestService#request (node) - success",c.url),s}catch(s){throw this.j.trace("RequestService#request (node) - error",c.url,s),s}}async l(c){return((0,T.parse)(c.url).protocol==="https:"?await new Promise((S,p)=>{x(["https"],S,p)}):await new Promise((S,p)=>{x(["http"],S,p)})).request}m(c,f){return R.Promises.withAsyncBody(async(y,S)=>{const p=(0,T.parse)(c.url),E=c.getRawRequest?c.getRawRequest(c):await this.l(c),t={hostname:p.hostname,port:p.port?parseInt(p.port):p.protocol==="https:"?443:80,protocol:p.protocol,path:p.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,w.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(t.auth=c.user+":"+c.password);const s=E(t,i=>{const n=(0,w.isNumber)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this.m({...c,url:i.headers.location,followRedirects:n-1},f).then(y,S);else{let r=i;!c.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,I.createGunzip)())),y({res:i,stream:(0,P.streamToBufferReadableStream)(r)})}});s.on("error",S),c.timeout&&s.setTimeout(c.timeout),c.isChromiumNetwork&&s.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&s.write(c.data),s.end(),f.onCancellationRequested(()=>{s.abort(),S(new O.CancellationError)})})}async resolveProxy(c){}};v=fe([ee(0,g.IConfigurationService),ee(1,l.INativeEnvironmentService),ee(2,m.ILogService)],v),e.RequestService=v}),define(Q[170],_([0,1,33,5,15,34,7,2,16,14,12,35,11,20,23,126,58,128,17,106,151,24,59,133,40,48,155,149,13,117,119,46,115,62,63,137,6,122,123,38,153,140,28,47,156,67,132,68,25,139,39,141,142,27,144,21,152,143,148,121]),function(x,e,T,R,P,O,k,w,g,l,b,m,d,I,v,A,c,f,y,S,p,E,t,s,i,n,r,o,a,h,u,D,F,Y,Z,te,ie,ne,ae,ue,se,ve,B,j,M,$,W,q,X,C,N,L,U,V,H,K,re,ce,we,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class le extends w.Disposable{constructor(oe){super(),this.b=oe,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[oe,ye]=await this.f();return oe.invokeFunction(async Se=>{const Ne=Se.get(ie.ILogService),Fe=Se.get(a.IFileService),z=Se.get(y.INativeEnvironmentService),G=Se.get(K.IUserDataProfilesService);Ne.info("CLI main",this.b),this.g(Ne),await this.h(z,Fe,G,oe),await Promise.all(ye.map(J=>{(0,R.raceTimeout)(J.flush(),1e3)}))})}async f(){const oe=new Y.ServiceCollection,ye={_serviceBrand:void 0,...ve.default};oe.set(B.IProductService,ye);const Se=new S.NativeEnvironmentService(this.b,ye);oe.set(y.INativeEnvironmentService,Se),await Promise.all([Se.appSettingsHome.fsPath,Se.extensionsPath].map(Re=>Re?I.Promises.mkdir(Re,{recursive:!0}):void 0));const Ne=(0,ie.getLogLevel)(Se),Fe=new ne.SpdLogLogger("cli",(0,l.join)(Se.logsPath,"cli.log"),!0,!1,Ne),z=[];Ne===ie.LogLevel.Trace&&z.push(new ie.ConsoleLogger(Ne));const G=this.B(new me.LogService(Fe,z));oe.set(ie.ILogService,G);const J=this.B(new h.FileService(G));oe.set(a.IFileService,J);const he=this.B(new u.DiskFileSystemProvider(G));J.registerProvider(g.Schemas.file,he);const pe=new W.StateService(Se,G,J);oe.set($.IStateService,pe);const Oe=new H.UriIdentityService(J);oe.set(V.IUriIdentityService,Oe);const Pe=new re.UserDataProfilesService(pe,Oe,Se,J,G);oe.set(K.IUserDataProfilesService,Pe);const Ae=b.isWindows&&ye.win32RegValueName?this.B(new se.NativePolicyService(G,ye.win32RegValueName)):Se.policyFile?this.B(new ae.FilePolicyService(Se.policyFile,J,G)):new ue.NullPolicyService;oe.set(ue.IPolicyService,Ae);const ke=this.B(new A.ConfigurationService(Pe.defaultProfile.settingsResource,J,Ae,G));oe.set(v.IConfigurationService,ke),await Promise.all([pe.init(),ke.initialize()]),Pe.init(),oe.set(V.IUriIdentityService,new H.UriIdentityService(J)),oe.set(j.IRequestService,new D.SyncDescriptor(M.RequestService,void 0,!0)),oe.set(c.IDownloadService,new D.SyncDescriptor(f.DownloadService,void 0,!0)),oe.set(i.IExtensionsProfileScannerService,new D.SyncDescriptor(we.ExtensionsProfileScannerService,void 0,!0)),oe.set(n.IExtensionsScannerService,new D.SyncDescriptor(o.ExtensionsScannerService,void 0,!0)),oe.set(t.IExtensionSignatureVerificationService,new D.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),oe.set(r.INativeServerExtensionManagementService,new D.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),oe.set(E.IExtensionGalleryService,new D.SyncDescriptor(p.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),oe.set(Z.ILanguagePackService,new D.SyncDescriptor(te.NativeLanguagePackService,void 0,!1));const Te=[],Ue=(0,N.isInternalTelemetry)(ye,ke);if((0,N.supportsTelemetry)(ye,Se)){ye.aiConfig&&ye.aiConfig.ariaKey&&Te.push(new L.OneDataSystemAppender(Ue,"monacoworkbench",null,ye.aiConfig.ariaKey));const{installSourcePath:Re}=Se,Le={appenders:Te,sendErrorTelemetry:!1,commonProperties:(async()=>{let Ce;try{Ce=await(0,ce.resolveMachineId)(pe)}catch(je){je.code!=="ENOENT"&&G.error(je)}return(0,q.resolveCommonProperties)(J,(0,T.release)(),(0,T.hostname)(),process.arch,ye.commit,ye.version,Ce,Ue,Re)})(),piiPaths:(0,N.getPiiPathsFromEnvironment)(Se)};oe.set(X.ITelemetryService,new D.SyncDescriptor(C.TelemetryService,[Le],!1))}else oe.set(X.ITelemetryService,N.NullTelemetryService);return[new F.InstantiationService(oe),Te]}g(oe){(0,k.setUnexpectedErrorHandler)(ye=>{const Se=(0,O.toErrorMessage)(ye,!0);!Se||oe.error(`[uncaught exception in CLI]: ${Se}`)}),process.on("uncaughtException",ye=>{(0,k.isSigPipeError)(ye)||(0,k.onUnexpectedError)(ye)}),process.on("unhandledRejection",ye=>(0,k.onUnexpectedError)(ye))}async h(oe,ye,Se,Ne){let Fe;if(oe.args.profile&&(Fe=Se.profiles.find(G=>G.name===oe.args.profile),!Fe))throw new Error(`Profile '${oe.args.profile}' not found.`);const z=(Fe??Se.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(oe,ye,this.b["install-source"]);if(this.b["list-extensions"])return Ne.createInstance(s.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,z);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const G={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:z};return Ne.createInstance(s.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],G,!!this.b.force)}else{if(this.b["uninstall-extension"])return Ne.createInstance(s.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,z);if(this.b["locate-extension"])return Ne.createInstance(s.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,U.buildTelemetryMessage)(oe.appRoot,oe.extensionsPath))}}i(oe){return oe.map(ye=>/\.vsix$/i.test(ye)?d.URI.file((0,l.isAbsolute)(ye)?ye:(0,l.join)((0,m.cwd)(),ye)):ye)}async j(oe,ye,Se){await ye.writeFile(d.URI.file(oe.installSourcePath),P.VSBuffer.fromString(Se.slice(0,30)))}}async function de(ge){const oe=new le(ge);try{await oe.run()}finally{oe.dispose()}}e.main=de})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f1b09237cd400d92987cf7a9681995e8011ef54c/core/vs/code/node/cliProcessMain.js.map
